/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/types","vs/base/common/platform","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/path","vs/base/common/network","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/arrays","vs/base/common/resources","vs/base/node/pfs","vs/platform/environment/common/environment","vs/base/common/objects","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/strings","vs/platform/product/common/productService","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetry","vs/base/common/uuid","vs/platform/policy/common/policy","os","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/stream","child_process","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/request/common/request","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/base/node/processes","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/base/common/map","vs/platform/configuration/common/configurationModels","vs/base/node/zip","vs/base/common/assert","vs/base/common/skipList","vs/base/common/hash","vs/base/common/console","vs/base/common/labels","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/languagePacks/node/languagePacks","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","graceful-fs","crypto","vs/platform/environment/node/argvHelper","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],te=function(B){for(var i=[],C=0,I=B.length;C<I;C++)i[C]=ee[B[C]];return i};define(ee[64],te([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ok=void 0;function C(I,P){if(!I)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}i.ok=C}),define(ee[46],te([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.throttle=i.debounce=i.memoize=i.createDecorator=void 0;function C(T){return(v,a,d)=>{let D=null,L=null;if(typeof d.value=="function"?(D="value",L=d.value):typeof d.get=="function"&&(D="get",L=d.get),!L)throw new Error("not supported");d[D]=T(L,a)}}i.createDecorator=C;function I(T,v,a){let d=null,D=null;if(typeof a.value=="function"?(d="value",D=a.value,D.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof a.get=="function"&&(d="get",D=a.get),!D)throw new Error("not supported");const L=`$memoize$${v}`;a[d]=function(...g){return this.hasOwnProperty(L)||Object.defineProperty(this,L,{configurable:!1,enumerable:!1,writable:!1,value:D.apply(this,g)}),this[L]}}i.memoize=I;function P(T,v,a){return C((d,D)=>{const L=`$debounce$${D}`,g=`$debounce$result$${D}`;return function(...E){this[g]||(this[g]=a?a():void 0),clearTimeout(this[L]),v&&(this[g]=v(this[g],...E),E=[this[g]]),this[L]=setTimeout(()=>{d.apply(this,E),this[g]=a?a():void 0},T)}})}i.debounce=P;function R(T,v,a){return C((d,D)=>{const L=`$throttle$timer$${D}`,g=`$throttle$result$${D}`,E=`$throttle$lastRun$${D}`,b=`$throttle$pending$${D}`;return function(...h){if(this[g]||(this[g]=a?a():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),v&&(this[g]=v(this[g],...h)),this[b])return;const w=this[E]+T;w<=Date.now()?(this[E]=Date.now(),d.apply(this,[this[g]]),this[g]=a?a():void 0):(this[b]=!0,this[L]=setTimeout(()=>{this[b]=!1,this[E]=Date.now(),d.apply(this,[this[g]]),this[g]=a?a():void 0},w-Date.now()))}})}i.throttle=R}),define(ee[47],te([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getNodeType=i.stripComments=i.visit=i.findNodeAtOffset=i.contains=i.getNodeValue=i.getNodePath=i.findNodeAtLocation=i.parseTree=i.parse=i.getLocation=i.createScanner=i.ParseOptions=i.ParseErrorCode=i.SyntaxKind=i.ScanError=void 0;var C;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(C=i.ScanError||(i.ScanError={}));var I;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(I=i.SyntaxKind||(i.SyntaxKind={}));var P;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(P=i.ParseErrorCode||(i.ParseErrorCode={}));var R;(function(e){e.DEFAULT={allowTrailingComma:!0}})(R=i.ParseOptions||(i.ParseOptions={}));function T(e,n=!1){let t=0,r=e.length,o="",u=0,m=16,p=0;function S(M){let x=0,G=0;for(;x<M;){const _=e.charCodeAt(t);if(_>=48&&_<=57)G=G*16+_-48;else if(_>=65&&_<=70)G=G*16+_-65+10;else if(_>=97&&_<=102)G=G*16+_-97+10;else break;t++,x++}return x<M&&(G=-1),G}function A(M){t=M,o="",u=0,m=16,p=0}function V(){const M=t;if(e.charCodeAt(t)===48)t++;else for(t++;t<e.length&&d(e.charCodeAt(t));)t++;if(t<e.length&&e.charCodeAt(t)===46)if(t++,t<e.length&&d(e.charCodeAt(t)))for(t++;t<e.length&&d(e.charCodeAt(t));)t++;else return p=3,e.substring(M,t);let x=t;if(t<e.length&&(e.charCodeAt(t)===69||e.charCodeAt(t)===101))if(t++,(t<e.length&&e.charCodeAt(t)===43||e.charCodeAt(t)===45)&&t++,t<e.length&&d(e.charCodeAt(t))){for(t++;t<e.length&&d(e.charCodeAt(t));)t++;x=t}else p=3;return e.substring(M,x)}function ie(){let M="",x=t;for(;;){if(t>=r){M+=e.substring(x,t),p=2;break}const G=e.charCodeAt(t);if(G===34){M+=e.substring(x,t),t++;break}if(G===92){if(M+=e.substring(x,t),t++,t>=r){p=2;break}switch(e.charCodeAt(t++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const re=S(4);re>=0?M+=String.fromCharCode(re):p=4;break}default:p=5}x=t;continue}if(G>=0&&G<=31)if(a(G)){M+=e.substring(x,t),p=2;break}else p=6;t++}return M}function Y(){if(o="",p=0,u=t,t>=r)return u=r,m=17;let M=e.charCodeAt(t);if(v(M)){do t++,o+=String.fromCharCode(M),M=e.charCodeAt(t);while(v(M));return m=15}if(a(M))return t++,o+=String.fromCharCode(M),M===13&&e.charCodeAt(t)===10&&(t++,o+=`
`),m=14;switch(M){case 123:return t++,m=1;case 125:return t++,m=2;case 91:return t++,m=3;case 93:return t++,m=4;case 58:return t++,m=6;case 44:return t++,m=5;case 34:return t++,o=ie(),m=10;case 47:{const x=t-1;if(e.charCodeAt(t+1)===47){for(t+=2;t<r&&!a(e.charCodeAt(t));)t++;return o=e.substring(x,t),m=12}if(e.charCodeAt(t+1)===42){t+=2;const G=r-1;let _=!1;for(;t<G;){if(e.charCodeAt(t)===42&&e.charCodeAt(t+1)===47){t+=2,_=!0;break}t++}return _||(t++,p=1),o=e.substring(x,t),m=13}return o+=String.fromCharCode(M),t++,m=16}case 45:if(o+=String.fromCharCode(M),t++,t===r||!d(e.charCodeAt(t)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=V(),m=11;default:for(;t<r&&ne(M);)t++,M=e.charCodeAt(t);if(u!==t){switch(o=e.substring(u,t),o){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return o+=String.fromCharCode(M),t++,m=16}}function ne(M){if(v(M)||a(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let M;do M=Y();while(M>=12&&M<=15);return M}return{setPosition:A,getPosition:()=>t,scan:n?oe:Y,getToken:()=>m,getTokenValue:()=>o,getTokenOffset:()=>u,getTokenLength:()=>t-u,getTokenError:()=>p}}i.createScanner=T;function v(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function a(e){return e===10||e===13||e===8232||e===8233}function d(e){return e>=48&&e<=57}var D;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(D||(D={}));function L(e,n){const t=[],r=new Object;let o;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function p(S,A,V,ie){u.value=S,u.offset=A,u.length=V,u.type=ie,u.colonOffset=void 0,o=u}try{y(e,{onObjectBegin:(S,A)=>{if(n<=S)throw r;o=void 0,m=n>S,t.push("")},onObjectProperty:(S,A,V)=>{if(n<A||(p(S,A,V,"property"),t[t.length-1]=S,n<=A+V))throw r},onObjectEnd:(S,A)=>{if(n<=S)throw r;o=void 0,t.pop()},onArrayBegin:(S,A)=>{if(n<=S)throw r;o=void 0,t.push(0)},onArrayEnd:(S,A)=>{if(n<=S)throw r;o=void 0,t.pop()},onLiteralValue:(S,A,V)=>{if(n<A||(p(S,A,V,s(S)),n<=A+V))throw r},onSeparator:(S,A,V)=>{if(n<=A)throw r;if(S===":"&&o&&o.type==="property")o.colonOffset=A,m=!1,o=void 0;else if(S===","){const ie=t[t.length-1];typeof ie=="number"?t[t.length-1]=ie+1:(m=!0,t[t.length-1]=""),o=void 0}}})}catch(S){if(S!==r)throw S}return{path:t,previousNode:o,isAtPropertyKey:m,matches:S=>{let A=0;for(let V=0;A<S.length&&V<t.length;V++)if(S[A]===t[V]||S[A]==="*")A++;else if(S[A]!=="**")return!1;return A===S.length}}}i.getLocation=L;function g(e,n=[],t=R.DEFAULT){let r=null,o=[];const u=[];function m(S){Array.isArray(o)?o.push(S):r!==null&&(o[r]=S)}return y(e,{onObjectBegin:()=>{const S={};m(S),u.push(o),o=S,r=null},onObjectProperty:S=>{r=S},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const S=[];m(S),u.push(o),o=S,r=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:m,onError:(S,A,V)=>{n.push({error:S,offset:A,length:V})}},t),o[0]}i.parse=g;function E(e,n=[],t=R.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(S){r.type==="property"&&(r.length=S-r.offset,r=r.parent)}function u(S){return r.children.push(S),S}y(e,{onObjectBegin:S=>{r=u({type:"object",offset:S,length:-1,parent:r,children:[]})},onObjectProperty:(S,A,V)=>{r=u({type:"property",offset:A,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:S,offset:A,length:V,parent:r})},onObjectEnd:(S,A)=>{r.length=S+A-r.offset,r=r.parent,o(S+A)},onArrayBegin:(S,A)=>{r=u({type:"array",offset:S,length:-1,parent:r,children:[]})},onArrayEnd:(S,A)=>{r.length=S+A-r.offset,r=r.parent,o(S+A)},onLiteralValue:(S,A,V)=>{u({type:s(S),offset:A,length:V,parent:r,value:S}),o(A+V)},onSeparator:(S,A,V)=>{r.type==="property"&&(S===":"?r.colonOffset=A:S===","&&o(A))},onError:(S,A,V)=>{n.push({error:S,offset:A,length:V})}},t);const p=r.children[0];return p&&delete p.parent,p}i.parseTree=E;function b(e,n){if(!e)return;let t=e;for(let r of n)if(typeof r=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let o=!1;for(const u of t.children)if(Array.isArray(u.children)&&u.children[0].value===r){t=u.children[1],o=!0;break}if(!o)return}else{const o=r;if(t.type!=="array"||o<0||!Array.isArray(t.children)||o>=t.children.length)return;t=t.children[o]}return t}i.findNodeAtLocation=b;function h(e){if(!e.parent||!e.parent.children)return[];const n=h(e.parent);if(e.parent.type==="property"){const t=e.parent.children[0].value;n.push(t)}else if(e.parent.type==="array"){const t=e.parent.children.indexOf(e);t!==-1&&n.push(t)}return n}i.getNodePath=h;function w(e){switch(e.type){case"array":return e.children.map(w);case"object":{const n=Object.create(null);for(let t of e.children){const r=t.children[1];r&&(n[t.children[0].value]=w(r))}return n}case"null":case"string":case"number":case"boolean":return e.value;default:return}}i.getNodeValue=w;function l(e,n,t=!1){return n>=e.offset&&n<e.offset+e.length||t&&n===e.offset+e.length}i.contains=l;function f(e,n,t=!1){if(l(e,n,t)){const r=e.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=n;o++){const u=f(r[o],n,t);if(u)return u}return e}}i.findNodeAtOffset=f;function y(e,n,t=R.DEFAULT){const r=T(e,!1);function o(W){return W?()=>W(r.getTokenOffset(),r.getTokenLength()):()=>!0}function u(W){return W?ae=>W(ae,r.getTokenOffset(),r.getTokenLength()):()=>!0}const m=o(n.onObjectBegin),p=u(n.onObjectProperty),S=o(n.onObjectEnd),A=o(n.onArrayBegin),V=o(n.onArrayEnd),ie=u(n.onLiteralValue),Y=u(n.onSeparator),ne=o(n.onComment),oe=u(n.onError),M=t&&t.disallowComments,x=t&&t.allowTrailingComma;function G(){for(;;){const W=r.scan();switch(r.getTokenError()){case 4:_(14);break;case 5:_(15);break;case 3:_(13);break;case 1:M||_(11);break;case 2:_(12);break;case 6:_(16);break}switch(W){case 12:case 13:M?_(10):ne();break;case 16:_(1);break;case 15:case 14:break;default:return W}}}function _(W,ae=[],Z=[]){if(oe(W),ae.length+Z.length>0){let j=r.getToken();for(;j!==17;){if(ae.indexOf(j)!==-1){G();break}else if(Z.indexOf(j)!==-1)break;j=G()}}}function re(W){const ae=r.getTokenValue();return W?ie(ae):p(ae),G(),!0}function k(){switch(r.getToken()){case 11:{let W=0;try{W=JSON.parse(r.getTokenValue()),typeof W!="number"&&(_(2),W=0)}catch{_(2)}ie(W);break}case 7:ie(null);break;case 8:ie(!0);break;case 9:ie(!1);break;default:return!1}return G(),!0}function O(){return r.getToken()!==10?(_(3,[],[2,5]),!1):(re(!1),r.getToken()===6?(Y(":"),G(),$()||_(4,[],[2,5])):_(5,[],[2,5]),!0)}function F(){m(),G();let W=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(W||_(4,[],[]),Y(","),G(),r.getToken()===2&&x)break}else W&&_(6,[],[]);O()||_(4,[],[2,5]),W=!0}return S(),r.getToken()!==2?_(7,[2],[]):G(),!0}function U(){A(),G();let W=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(W||_(4,[],[]),Y(","),G(),r.getToken()===4&&x)break}else W&&_(6,[],[]);$()||_(4,[],[4,5]),W=!0}return V(),r.getToken()!==4?_(8,[4],[]):G(),!0}function $(){switch(r.getToken()){case 3:return U();case 1:return F();case 10:return re(!0);default:return k()}}return G(),r.getToken()===17?t.allowEmptyContent?!0:(_(4,[],[]),!1):$()?(r.getToken()!==17&&_(9,[],[]),!0):(_(4,[],[]),!1)}i.visit=y;function c(e,n){let t=T(e),r=[],o,u=0,m;do switch(m=t.getPosition(),o=t.scan(),o){case 12:case 13:case 17:u!==m&&r.push(e.substring(u,m)),n!==void 0&&r.push(t.getTokenValue().replace(/[^\r\n]/g,n)),u=t.getPosition();break}while(o!==17);return r.join("")}i.stripComments=c;function s(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}i.getNodeType=s}),function(){function B(P){const R=[];typeof P=="number"&&R.push("code/timeOrigin",P);function T(a){R.push(a,Date.now())}function v(){const a=[];for(let d=0;d<R.length;d+=2)a.push({name:R[d],startTime:R[d+1]});return a}return{mark:T,getMarks:v}}function i(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?B():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const T of performance.getEntriesByType("mark"))R.push({name:T.name,startTime:Math.round(P+T.startTime)});return R}};if(typeof process=="object"){const P=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return B(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),B()}function C(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=i()),P.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=C(I))}(),define(ee[48],te([0,1,8]),function(B,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.removeDangerousEnvVariables=i.sanitizeProcessEnvironment=i.TerminateResponseCode=i.Source=void 0;var I;(function(v){v[v.stdout=0]="stdout",v[v.stderr=1]="stderr"})(I=i.Source||(i.Source={}));var P;(function(v){v[v.Success=0]="Success",v[v.Unknown=1]="Unknown",v[v.AccessDenied=2]="AccessDenied",v[v.ProcessNotFound=3]="ProcessNotFound"})(P=i.TerminateResponseCode||(i.TerminateResponseCode={}));function R(v,...a){const d=a.reduce((g,E)=>(g[E]=!0,g),{}),D=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(v).filter(g=>!d[g]).forEach(g=>{for(let E=0;E<D.length;E++)if(g.search(D[E])!==-1){delete v[g];break}})}i.sanitizeProcessEnvironment=R;function T(v){!v||(delete v.DEBUG,C.isMacintosh&&delete v.DYLD_LIBRARY_PATH,C.isLinux&&delete v.LD_PRELOAD)}i.removeDangerousEnvVariables=T}),function(B,i){if(typeof exports=="object"&&typeof module=="object")module.exports=i();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],i);else{var C=i();for(var I in C)(typeof exports=="object"?exports:B)[I]=C[I]}}(typeof self!="undefined"?self:this,function(){return function(B){var i={};function C(I){if(i[I])return i[I].exports;var P=i[I]={i:I,l:!1,exports:{}};return B[I].call(P.exports,P,P.exports,C),P.l=!0,P.exports}return C.m=B,C.c=i,C.d=function(I,P,R){C.o(I,P)||Object.defineProperty(I,P,{enumerable:!0,get:R})},C.r=function(I){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(I,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(I,"__esModule",{value:!0})},C.t=function(I,P){if(1&P&&(I=C(I)),8&P||4&P&&typeof I=="object"&&I&&I.__esModule)return I;var R=Object.create(null);if(C.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:I}),2&P&&typeof I!="string")for(var T in I)C.d(R,T,function(v){return I[v]}.bind(null,T));return R},C.n=function(I){var P=I&&I.__esModule?function(){return I.default}:function(){return I};return C.d(P,"a",P),P},C.o=function(I,P){return Object.prototype.hasOwnProperty.call(I,P)},C.p="",C(C.s=0)}([function(B,i,C){(function(I){var P;i=B.exports=Z,P=typeof I=="object"&&I.env&&I.env.NODE_DEBUG&&/\bsemver\b/i.test(I.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},i.SEMVER_SPEC_VERSION="2.0.0";var R=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,v=i.re=[],a=i.src=[],d=0,D=d++;a[D]="0|[1-9]\\d*";var L=d++;a[L]="[0-9]+";var g=d++;a[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=d++;a[E]="("+a[D]+")\\.("+a[D]+")\\.("+a[D]+")";var b=d++;a[b]="("+a[L]+")\\.("+a[L]+")\\.("+a[L]+")";var h=d++;a[h]="(?:"+a[D]+"|"+a[g]+")";var w=d++;a[w]="(?:"+a[L]+"|"+a[g]+")";var l=d++;a[l]="(?:-("+a[h]+"(?:\\."+a[h]+")*))";var f=d++;a[f]="(?:-?("+a[w]+"(?:\\."+a[w]+")*))";var y=d++;a[y]="[0-9A-Za-z-]+";var c=d++;a[c]="(?:\\+("+a[y]+"(?:\\."+a[y]+")*))";var s=d++,e="v?"+a[E]+a[l]+"?"+a[c]+"?";a[s]="^"+e+"$";var n="[v=\\s]*"+a[b]+a[f]+"?"+a[c]+"?",t=d++;a[t]="^"+n+"$";var r=d++;a[r]="((?:<|>)?=?)";var o=d++;a[o]=a[L]+"|x|X|\\*";var u=d++;a[u]=a[D]+"|x|X|\\*";var m=d++;a[m]="[v=\\s]*("+a[u]+")(?:\\.("+a[u]+")(?:\\.("+a[u]+")(?:"+a[l]+")?"+a[c]+"?)?)?";var p=d++;a[p]="[v=\\s]*("+a[o]+")(?:\\.("+a[o]+")(?:\\.("+a[o]+")(?:"+a[f]+")?"+a[c]+"?)?)?";var S=d++;a[S]="^"+a[r]+"\\s*"+a[m]+"$";var A=d++;a[A]="^"+a[r]+"\\s*"+a[p]+"$";var V=d++;a[V]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var ie=d++;a[ie]="(?:~>?)";var Y=d++;a[Y]="(\\s*)"+a[ie]+"\\s+",v[Y]=new RegExp(a[Y],"g");var ne=d++;a[ne]="^"+a[ie]+a[m]+"$";var oe=d++;a[oe]="^"+a[ie]+a[p]+"$";var M=d++;a[M]="(?:\\^)";var x=d++;a[x]="(\\s*)"+a[M]+"\\s+",v[x]=new RegExp(a[x],"g");var G=d++;a[G]="^"+a[M]+a[m]+"$";var _=d++;a[_]="^"+a[M]+a[p]+"$";var re=d++;a[re]="^"+a[r]+"\\s*("+n+")$|^$";var k=d++;a[k]="^"+a[r]+"\\s*("+e+")$|^$";var O=d++;a[O]="(\\s*)"+a[r]+"\\s*("+n+"|"+a[m]+")",v[O]=new RegExp(a[O],"g");var F=d++;a[F]="^\\s*("+a[m]+")\\s+-\\s+("+a[m]+")\\s*$";var U=d++;a[U]="^\\s*("+a[p]+")\\s+-\\s+("+a[p]+")\\s*$";var $=d++;a[$]="(<|>)?=?\\s*\\*";for(var W=0;W<35;W++)P(W,a[W]),v[W]||(v[W]=new RegExp(a[W]));function ae(z,H){if(z instanceof Z)return z;if(typeof z!="string"||z.length>R||!(H?v[t]:v[s]).test(z))return null;try{return new Z(z,H)}catch{return null}}function Z(z,H){if(z instanceof Z){if(z.loose===H)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof Z))return new Z(z,H);P("SemVer",z,H),this.loose=H;var J=z.trim().match(H?v[t]:v[s]);if(!J)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function(fe){if(/^[0-9]+$/.test(fe)){var pe=+fe;if(pe>=0&&pe<T)return pe}return fe}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}i.parse=ae,i.valid=function(z,H){var J=ae(z,H);return J?J.version:null},i.clean=function(z,H){var J=ae(z.trim().replace(/^[=v]+/,""),H);return J?J.version:null},i.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(z){return P("SemVer.compare",this.version,this.loose,z),z instanceof Z||(z=new Z(z,this.loose)),this.compareMain(z)||this.comparePre(z)},Z.prototype.compareMain=function(z){return z instanceof Z||(z=new Z(z,this.loose)),N(this.major,z.major)||N(this.minor,z.minor)||N(this.patch,z.patch)},Z.prototype.comparePre=function(z){if(z instanceof Z||(z=new Z(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var H=0;do{var J=this.prerelease[H],fe=z.prerelease[H];if(P("prerelease compare",H,J,fe),J===void 0&&fe===void 0)return 0;if(fe===void 0)return 1;if(J===void 0)return-1;if(J!==fe)return N(J,fe)}while(++H)},Z.prototype.inc=function(z,H){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},i.inc=function(z,H,J,fe){typeof J=="string"&&(fe=J,J=void 0);try{return new Z(z,J).inc(H,fe).version}catch{return null}},i.diff=function(z,H){if(K(z,H))return null;var J=ae(z),fe=ae(H);if(J.prerelease.length||fe.prerelease.length){for(var pe in J)if((pe==="major"||pe==="minor"||pe==="patch")&&J[pe]!==fe[pe])return"pre"+pe;return"prerelease"}for(var pe in J)if((pe==="major"||pe==="minor"||pe==="patch")&&J[pe]!==fe[pe])return pe},i.compareIdentifiers=N;var j=/^[0-9]+$/;function N(z,H){var J=j.test(z),fe=j.test(H);return J&&fe&&(z=+z,H=+H),J&&!fe?-1:fe&&!J?1:z<H?-1:z>H?1:0}function q(z,H,J){return new Z(z,J).compare(new Z(H,J))}function X(z,H,J){return q(z,H,J)>0}function Q(z,H,J){return q(z,H,J)<0}function K(z,H,J){return q(z,H,J)===0}function se(z,H,J){return q(z,H,J)!==0}function ue(z,H,J){return q(z,H,J)>=0}function me(z,H,J){return q(z,H,J)<=0}function ge(z,H,J,fe){var pe;switch(H){case"===":typeof z=="object"&&(z=z.version),typeof J=="object"&&(J=J.version),pe=z===J;break;case"!==":typeof z=="object"&&(z=z.version),typeof J=="object"&&(J=J.version),pe=z!==J;break;case"":case"=":case"==":pe=K(z,J,fe);break;case"!=":pe=se(z,J,fe);break;case">":pe=X(z,J,fe);break;case">=":pe=ue(z,J,fe);break;case"<":pe=Q(z,J,fe);break;case"<=":pe=me(z,J,fe);break;default:throw new TypeError("Invalid operator: "+H)}return pe}function le(z,H){if(z instanceof le){if(z.loose===H)return z;z=z.value}if(!(this instanceof le))return new le(z,H);P("comparator",z,H),this.loose=H,this.parse(z),this.semver===he?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}i.rcompareIdentifiers=function(z,H){return N(H,z)},i.major=function(z,H){return new Z(z,H).major},i.minor=function(z,H){return new Z(z,H).minor},i.patch=function(z,H){return new Z(z,H).patch},i.compare=q,i.compareLoose=function(z,H){return q(z,H,!0)},i.rcompare=function(z,H,J){return q(H,z,J)},i.sort=function(z,H){return z.sort(function(J,fe){return i.compare(J,fe,H)})},i.rsort=function(z,H){return z.sort(function(J,fe){return i.rcompare(J,fe,H)})},i.gt=X,i.lt=Q,i.eq=K,i.neq=se,i.gte=ue,i.lte=me,i.cmp=ge,i.Comparator=le;var he={};function ve(z,H){if(z instanceof ve)return z.loose===H?z:new ve(z.raw,H);if(z instanceof le)return new ve(z.value,H);if(!(this instanceof ve))return new ve(z,H);if(this.loose=H,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function Ee(z){return!z||z.toLowerCase()==="x"||z==="*"}function Pe(z,H,J,fe,pe,Re,we,ke,Ce,Oe,Ne,De,Le){return((H=Ee(J)?"":Ee(fe)?">="+J+".0.0":Ee(pe)?">="+J+"."+fe+".0":">="+H)+" "+(ke=Ee(Ce)?"":Ee(Oe)?"<"+(+Ce+1)+".0.0":Ee(Ne)?"<"+Ce+"."+(+Oe+1)+".0":De?"<="+Ce+"."+Oe+"."+Ne+"-"+De:"<="+ke)).trim()}function Me(z,H){for(var J=0;J<z.length;J++)if(!z[J].test(H))return!1;if(H.prerelease.length){for(J=0;J<z.length;J++)if(P(z[J].semver),z[J].semver!==he&&z[J].semver.prerelease.length>0){var fe=z[J].semver;if(fe.major===H.major&&fe.minor===H.minor&&fe.patch===H.patch)return!0}return!1}return!0}function Ue(z,H,J){try{H=new ve(H,J)}catch{return!1}return H.test(z)}function ze(z,H,J,fe){var pe,Re,we,ke,Ce;switch(z=new Z(z,fe),H=new ve(H,fe),J){case">":pe=X,Re=me,we=Q,ke=">",Ce=">=";break;case"<":pe=Q,Re=ue,we=X,ke="<",Ce="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(z,H,fe))return!1;for(var Oe=0;Oe<H.set.length;++Oe){var Ne=H.set[Oe],De=null,Le=null;if(Ne.forEach(function(Ae){Ae.semver===he&&(Ae=new le(">=0.0.0")),De=De||Ae,Le=Le||Ae,pe(Ae.semver,De.semver,fe)?De=Ae:we(Ae.semver,Le.semver,fe)&&(Le=Ae)}),De.operator===ke||De.operator===Ce||(!Le.operator||Le.operator===ke)&&Re(z,Le.semver)||Le.operator===Ce&&we(z,Le.semver))return!1}return!0}le.prototype.parse=function(z){var H=this.loose?v[re]:v[k],J=z.match(H);if(!J)throw new TypeError("Invalid comparator: "+z);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new Z(J[2],this.loose):this.semver=he},le.prototype.toString=function(){return this.value},le.prototype.test=function(z){return P("Comparator.test",z,this.loose),this.semver===he||(typeof z=="string"&&(z=new Z(z,this.loose)),ge(z,this.operator,this.semver,this.loose))},le.prototype.intersects=function(z,H){if(!(z instanceof le))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new ve(z.value,H),Ue(this.value,J,H);if(z.operator==="")return J=new ve(this.value,H),Ue(z.semver,J,H);var fe=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),pe=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),Re=this.semver.version===z.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),ke=ge(this.semver,"<",z.semver,H)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),Ce=ge(this.semver,">",z.semver,H)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return fe||pe||Re&&we||ke||Ce},i.Range=ve,ve.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},ve.prototype.toString=function(){return this.range},ve.prototype.parseRange=function(z){var H=this.loose;z=z.trim(),P("range",z,H);var J=H?v[U]:v[F];z=z.replace(J,Pe),P("hyphen replace",z),z=z.replace(v[O],"$1$2$3"),P("comparator trim",z,v[O]),z=(z=(z=z.replace(v[Y],"$1~")).replace(v[x],"$1^")).split(/\s+/).join(" ");var fe=H?v[re]:v[k],pe=z.split(" ").map(function(Re){return function(we,ke){return P("comp",we),we=function(Ce,Oe){return Ce.trim().split(/\s+/).map(function(Ne){return function(De,Le){P("caret",De,Le);var Ae=Le?v[_]:v[G];return De.replace(Ae,function(Fe,ye,Se,be,Ie){var Te;return P("caret",De,Fe,ye,Se,be,Ie),Ee(ye)?Te="":Ee(Se)?Te=">="+ye+".0.0 <"+(+ye+1)+".0.0":Ee(be)?Te=ye==="0"?">="+ye+"."+Se+".0 <"+ye+"."+(+Se+1)+".0":">="+ye+"."+Se+".0 <"+(+ye+1)+".0.0":Ie?(P("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Te=ye==="0"?Se==="0"?">="+ye+"."+Se+"."+be+Ie+" <"+ye+"."+Se+"."+(+be+1):">="+ye+"."+Se+"."+be+Ie+" <"+ye+"."+(+Se+1)+".0":">="+ye+"."+Se+"."+be+Ie+" <"+(+ye+1)+".0.0"):(P("no pr"),Te=ye==="0"?Se==="0"?">="+ye+"."+Se+"."+be+" <"+ye+"."+Se+"."+(+be+1):">="+ye+"."+Se+"."+be+" <"+ye+"."+(+Se+1)+".0":">="+ye+"."+Se+"."+be+" <"+(+ye+1)+".0.0"),P("caret return",Te),Te})}(Ne,Oe)}).join(" ")}(we,ke),P("caret",we),we=function(Ce,Oe){return Ce.trim().split(/\s+/).map(function(Ne){return function(De,Le){var Ae=Le?v[oe]:v[ne];return De.replace(Ae,function(Fe,ye,Se,be,Ie){var Te;return P("tilde",De,Fe,ye,Se,be,Ie),Ee(ye)?Te="":Ee(Se)?Te=">="+ye+".0.0 <"+(+ye+1)+".0.0":Ee(be)?Te=">="+ye+"."+Se+".0 <"+ye+"."+(+Se+1)+".0":Ie?(P("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Te=">="+ye+"."+Se+"."+be+Ie+" <"+ye+"."+(+Se+1)+".0"):Te=">="+ye+"."+Se+"."+be+" <"+ye+"."+(+Se+1)+".0",P("tilde return",Te),Te})}(Ne,Oe)}).join(" ")}(we,ke),P("tildes",we),we=function(Ce,Oe){return P("replaceXRanges",Ce,Oe),Ce.split(/\s+/).map(function(Ne){return function(De,Le){De=De.trim();var Ae=Le?v[A]:v[S];return De.replace(Ae,function(Fe,ye,Se,be,Ie,Te){P("xRange",De,Fe,ye,Se,be,Ie,Te);var je=Ee(Se),xe=je||Ee(be),Ve=xe||Ee(Ie);return ye==="="&&Ve&&(ye=""),je?Fe=ye===">"||ye==="<"?"<0.0.0":"*":ye&&Ve?(xe&&(be=0),Ve&&(Ie=0),ye===">"?(ye=">=",xe?(Se=+Se+1,be=0,Ie=0):Ve&&(be=+be+1,Ie=0)):ye==="<="&&(ye="<",xe?Se=+Se+1:be=+be+1),Fe=ye+Se+"."+be+"."+Ie):xe?Fe=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ve&&(Fe=">="+Se+"."+be+".0 <"+Se+"."+(+be+1)+".0"),P("xRange return",Fe),Fe})}(Ne,Oe)}).join(" ")}(we,ke),P("xrange",we),we=function(Ce,Oe){return P("replaceStars",Ce,Oe),Ce.trim().replace(v[$],"")}(we,ke),P("stars",we),we}(Re,H)}).join(" ").split(/\s+/);return this.loose&&(pe=pe.filter(function(Re){return!!Re.match(fe)})),pe=pe.map(function(Re){return new le(Re,H)})},ve.prototype.intersects=function(z,H){if(!(z instanceof ve))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function(fe){return z.set.some(function(pe){return pe.every(function(Re){return fe.intersects(Re,H)})})})})},i.toComparators=function(z,H){return new ve(z,H).set.map(function(J){return J.map(function(fe){return fe.value}).join(" ").trim().split(" ")})},ve.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new Z(z,this.loose));for(var H=0;H<this.set.length;H++)if(Me(this.set[H],z))return!0;return!1},i.satisfies=Ue,i.maxSatisfying=function(z,H,J){var fe=null,pe=null;try{var Re=new ve(H,J)}catch{return null}return z.forEach(function(we){Re.test(we)&&(fe&&pe.compare(we)!==-1||(pe=new Z(fe=we,J)))}),fe},i.minSatisfying=function(z,H,J){var fe=null,pe=null;try{var Re=new ve(H,J)}catch{return null}return z.forEach(function(we){Re.test(we)&&(fe&&pe.compare(we)!==1||(pe=new Z(fe=we,J)))}),fe},i.validRange=function(z,H){try{return new ve(z,H).range||"*"}catch{return null}},i.ltr=function(z,H,J){return ze(z,H,"<",J)},i.gtr=function(z,H,J){return ze(z,H,">",J)},i.outside=ze,i.prerelease=function(z,H){var J=ae(z,H);return J&&J.prerelease.length?J.prerelease:null},i.intersects=function(z,H,J){return z=new ve(z,J),H=new ve(H,J),z.intersects(H)},i.coerce=function(z){if(z instanceof Z)return z;if(typeof z!="string")return null;var H=z.match(v[V]);return H==null?null:ae((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,C(1))},function(B,i){var C,I,P=B.exports={};function R(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function v(w){if(C===setTimeout)return setTimeout(w,0);if((C===R||!C)&&setTimeout)return C=setTimeout,setTimeout(w,0);try{return C(w,0)}catch{try{return C.call(null,w,0)}catch{return C.call(this,w,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:R}catch{C=R}try{I=typeof clearTimeout=="function"?clearTimeout:T}catch{I=T}})();var a,d=[],D=!1,L=-1;function g(){D&&a&&(D=!1,a.length?d=a.concat(d):L=-1,d.length&&E())}function E(){if(!D){var w=v(g);D=!0;for(var l=d.length;l;){for(a=d,d=[];++L<l;)a&&a[L].run();L=-1,l=d.length}a=null,D=!1,function(f){if(I===clearTimeout)return clearTimeout(f);if((I===T||!I)&&clearTimeout)return I=clearTimeout,clearTimeout(f);try{I(f)}catch{try{return I.call(null,f)}catch{return I.call(this,f)}}}(w)}}function b(w,l){this.fun=w,this.array=l}function h(){}P.nextTick=function(w){var l=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)l[f-1]=arguments[f];d.push(new b(w,l)),d.length!==1||D||v(E)},b.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=h,P.addListener=h,P.once=h,P.off=h,P.removeListener=h,P.removeAllListeners=h,P.emit=h,P.prependListener=h,P.prependOnceListener=h,P.listeners=function(w){return[]},P.binding=function(w){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(w){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(ee[65],te([0,1]),function(B,i){"use strict";var C;Object.defineProperty(i,"__esModule",{value:!0}),i.SkipList=void 0;class I{constructor(v,a,d){this.level=v,this.key=a,this.value=d,this.forward=[]}}const P=void 0;class R{constructor(v,a=2**16){this.comparator=v,this[C]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(a)|0),this._header=new I(this._maxLevel,P,P)}get size(){return this._size}clear(){this._header=new I(this._maxLevel,P,P)}has(v){return Boolean(R._search(this,v,this.comparator))}get(v){return R._search(this,v,this.comparator)?.value}set(v,a){return R._insert(this,v,a,this.comparator)&&(this._size+=1),this}delete(v){const a=R._delete(this,v,this.comparator);return a&&(this._size-=1),a}forEach(v,a){let d=this._header.forward[0];for(;d;)v.call(a,d.value,d.key,this),d=d.forward[0]}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let v=this._header.forward[0];for(;v;)yield[v.key,v.value],v=v.forward[0]}*keys(){let v=this._header.forward[0];for(;v;)yield v.key,v=v.forward[0]}*values(){let v=this._header.forward[0];for(;v;)yield v.value,v=v.forward[0]}toString(){let v="[SkipList]:",a=this._header.forward[0];for(;a;)v+=`node(${a.key}, ${a.value}, lvl:${a.level})`,a=a.forward[0];return v}static _search(v,a,d){let D=v._header;for(let L=v._level-1;L>=0;L--)for(;D.forward[L]&&d(D.forward[L].key,a)<0;)D=D.forward[L];if(D=D.forward[0],D&&d(D.key,a)===0)return D}static _insert(v,a,d,D){let L=[],g=v._header;for(let E=v._level-1;E>=0;E--){for(;g.forward[E]&&D(g.forward[E].key,a)<0;)g=g.forward[E];L[E]=g}if(g=g.forward[0],g&&D(g.key,a)===0)return g.value=d,!1;{let E=R._randomLevel(v);if(E>v._level){for(let b=v._level;b<E;b++)L[b]=v._header;v._level=E}g=new I(E,a,d);for(let b=0;b<E;b++)g.forward[b]=L[b].forward[b],L[b].forward[b]=g;return!0}}static _randomLevel(v,a=.5){let d=1;for(;Math.random()<a&&d<v._maxLevel;)d+=1;return d}static _delete(v,a,d){let D=[],L=v._header;for(let g=v._level-1;g>=0;g--){for(;L.forward[g]&&d(L.forward[g].key,a)<0;)L=L.forward[g];D[g]=L}if(L=L.forward[0],!L||d(L.key,a)!==0)return!1;for(let g=0;g<v._level&&D[g].forward[g]===L;g++)D[g].forward[g]=L.forward[g];for(;v._level>0&&v._header.forward[v._level-1]===P;)v._level-=1;return!0}}i.SkipList=R}),define(ee[49],te([0,1,3,2]),function(B,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.MutableObservableValue=i.staticObservableValue=void 0;const P=T=>({onDidChange:C.Event.None,value:T});i.staticObservableValue=P;class R extends I.Disposable{constructor(v){super();this._value=v,this.changeEmitter=this._register(new C.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(v){v!==this._value&&(this._value=v,this.changeEmitter.fire(v))}}i.MutableObservableValue=R}),define(ee[40],te([0,1,9,2]),function(B,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.prefixedStream=i.prefixedReadable=i.transform=i.toReadable=i.emptyStream=i.toStream=i.peekStream=i.listenStream=i.consumeStream=i.peekReadable=i.consumeReadable=i.newWriteableStream=i.isReadableBufferedStream=i.isReadableStream=i.isReadable=void 0;function P(c){const s=c;return s?typeof s.read=="function":!1}i.isReadable=P;function R(c){const s=c;return s?[s.on,s.pause,s.resume,s.destroy].every(e=>typeof e=="function"):!1}i.isReadableStream=R;function T(c){const s=c;return s?R(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}i.isReadableBufferedStream=T;function v(c,s){return new a(c,s)}i.newWriteableStream=v;class a{constructor(s,e){this.reducer=s,this.options=e,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(e=>this.pendingWritePromises.push(e))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(e=>e(s))}emitError(s){this.listeners.error.length===0?(0,C.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(e=>e(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,e){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(e),this.resume();break;case"end":this.listeners.end.push(e),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(e),this.state.flowing&&this.flowErrors();break}}removeListener(s,e){if(this.state.destroyed)return;let n;switch(s){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const t=n.indexOf(e);t>=0&&n.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const e=[...this.pendingWritePromises];this.pendingWritePromises.length=0,e.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function d(c,s){const e=[];let n;for(;(n=c.read())!==null;)e.push(n);return s(e)}i.consumeReadable=d;function D(c,s,e){const n=[];let t;for(;(t=c.read())!==null&&n.length<e;)n.push(t);return t===null&&n.length>0?s(n):{read:()=>{if(n.length>0)return n.shift();if(typeof t!="undefined"){const r=t;return t=void 0,r}return c.read()}}}i.peekReadable=D;function L(c,s){return new Promise((e,n)=>{const t=[];g(c,{onData:r=>{s&&t.push(r)},onError:r=>{s?n(r):e(void 0)},onEnd:()=>{e(s?s(t):void 0)}})})}i.consumeStream=L;function g(c,s){let e=!1;return c.on("error",n=>{e||s.onError(n)}),c.on("end",()=>{e||s.onEnd()}),c.on("data",n=>{e||s.onData(n)}),(0,I.toDisposable)(()=>e=!0)}i.listenStream=g;function E(c,s){return new Promise((e,n)=>{const t=new I.DisposableStore,r=[],o=p=>{if(r.push(p),r.length>s)return t.dispose(),c.pause(),e({stream:c,buffer:r,ended:!1})},u=p=>n(p),m=()=>e({stream:c,buffer:r,ended:!0});t.add((0,I.toDisposable)(()=>c.removeListener("error",u))),c.on("error",u),t.add((0,I.toDisposable)(()=>c.removeListener("end",m))),c.on("end",m),t.add((0,I.toDisposable)(()=>c.removeListener("data",o))),c.on("data",o)})}i.peekStream=E;function b(c,s){const e=v(s);return e.end(c),e}i.toStream=b;function h(){const c=v(()=>{throw new Error("not supported")});return c.end(),c}i.emptyStream=h;function w(c){let s=!1;return{read:()=>s?null:(s=!0,c)}}i.toReadable=w;function l(c,s,e){const n=v(e);return g(c,{onData:t=>n.write(s.data(t)),onError:t=>n.error(s.error?s.error(t):t),onEnd:()=>n.end()}),n}i.transform=l;function f(c,s,e){let n=!1;return{read:()=>{const t=s.read();return n?t:(n=!0,t!==null?e([c,t]):c)}}}i.prefixedReadable=f;function y(c,s,e){let n=!1;const t=v(e);return g(s,{onData:r=>n?t.write(r):(n=!0,t.write(e([c,r]))),onError:r=>t.error(r),onEnd:()=>{n||(n=!0,t.write(c)),t.end()}}),t}i.prefixedStream=y}),define(ee[16],te([0,1,40]),function(B,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.encodeBase64=i.decodeBase64=i.prefixedBufferStream=i.prefixedBufferReadable=i.newWriteableBufferStream=i.streamToBufferReadableStream=i.bufferToStream=i.bufferedStreamToBuffer=i.streamToBuffer=i.bufferToReadable=i.readableToBuffer=i.writeUInt8=i.readUInt8=i.writeUInt32LE=i.readUInt32LE=i.writeUInt32BE=i.readUInt32BE=i.writeUInt16LE=i.readUInt16LE=i.VSBuffer=void 0;const I=typeof Buffer!="undefined";let P,R;class T{constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}static alloc(p){return I?new T(Buffer.allocUnsafe(p)):new T(new Uint8Array(p))}static wrap(p){return I&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new T(p)}static fromString(p,S){return!(S?.dontUseNodeBuffer||!1)&&I?new T(Buffer.from(p)):(P||(P=new TextEncoder),new T(P.encode(p)))}static fromByteArray(p){const S=T.alloc(p.length);for(let A=0,V=p.length;A<V;A++)S.buffer[A]=p[A];return S}static concat(p,S){if(typeof S=="undefined"){S=0;for(let ie=0,Y=p.length;ie<Y;ie++)S+=p[ie].byteLength}const A=T.alloc(S);let V=0;for(let ie=0,Y=p.length;ie<Y;ie++){const ne=p[ie];A.set(ne,V),V+=ne.byteLength}return A}clone(){const p=T.alloc(this.byteLength);return p.set(this),p}toString(){return I?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(p,S){return new T(this.buffer.subarray(p,S))}set(p,S){if(p instanceof T)this.buffer.set(p.buffer,S);else if(p instanceof Uint8Array)this.buffer.set(p,S);else if(p instanceof ArrayBuffer)this.buffer.set(new Uint8Array(p),S);else if(ArrayBuffer.isView(p))this.buffer.set(new Uint8Array(p.buffer,p.byteOffset,p.byteLength),S);else throw new Error("Unknown argument 'array'")}readUInt32BE(p){return d(this.buffer,p)}writeUInt32BE(p,S){D(this.buffer,p,S)}readUInt32LE(p){return L(this.buffer,p)}writeUInt32LE(p,S){g(this.buffer,p,S)}readUInt8(p){return E(this.buffer,p)}writeUInt8(p,S){b(this.buffer,p,S)}}i.VSBuffer=T;function v(m,p){return m[p+0]<<0>>>0|m[p+1]<<8>>>0}i.readUInt16LE=v;function a(m,p,S){m[S+0]=p&255,p=p>>>8,m[S+1]=p&255}i.writeUInt16LE=a;function d(m,p){return m[p]*2**24+m[p+1]*2**16+m[p+2]*2**8+m[p+3]}i.readUInt32BE=d;function D(m,p,S){m[S+3]=p,p=p>>>8,m[S+2]=p,p=p>>>8,m[S+1]=p,p=p>>>8,m[S]=p}i.writeUInt32BE=D;function L(m,p){return m[p+0]<<0>>>0|m[p+1]<<8>>>0|m[p+2]<<16>>>0|m[p+3]<<24>>>0}i.readUInt32LE=L;function g(m,p,S){m[S+0]=p&255,p=p>>>8,m[S+1]=p&255,p=p>>>8,m[S+2]=p&255,p=p>>>8,m[S+3]=p&255}i.writeUInt32LE=g;function E(m,p){return m[p]}i.readUInt8=E;function b(m,p,S){m[S]=p}i.writeUInt8=b;function h(m){return C.consumeReadable(m,p=>T.concat(p))}i.readableToBuffer=h;function w(m){return C.toReadable(m)}i.bufferToReadable=w;function l(m){return C.consumeStream(m,p=>T.concat(p))}i.streamToBuffer=l;async function f(m){return m.ended?T.concat(m.buffer):T.concat([...m.buffer,await l(m.stream)])}i.bufferedStreamToBuffer=f;function y(m){return C.toStream(m,p=>T.concat(p))}i.bufferToStream=y;function c(m){return C.transform(m,{data:p=>typeof p=="string"?T.fromString(p):T.wrap(p)},p=>T.concat(p))}i.streamToBufferReadableStream=c;function s(m){return C.newWriteableStream(p=>T.concat(p),m)}i.newWriteableBufferStream=s;function e(m,p){return C.prefixedReadable(m,p,S=>T.concat(S))}i.prefixedBufferReadable=e;function n(m,p){return C.prefixedStream(m,p,S=>T.concat(S))}i.prefixedBufferStream=n;function t(m){let p=0,S=0,A=0;const V=new Uint8Array(Math.floor(m.length/4*3)),ie=ne=>{switch(S){case 3:V[A++]=p|ne,S=0;break;case 2:V[A++]=p|ne>>>2,p=ne<<6,S=3;break;case 1:V[A++]=p|ne>>>4,p=ne<<4,S=2;break;default:p=ne<<2,S=1}};for(let ne=0;ne<m.length;ne++){const oe=m.charCodeAt(ne);if(oe>=65&&oe<=90)ie(oe-65);else if(oe>=97&&oe<=122)ie(oe-97+26);else if(oe>=48&&oe<=57)ie(oe-48+52);else if(oe===43||oe===45)ie(62);else if(oe===47||oe===95)ie(63);else{if(oe===61)break;throw new SyntaxError(`Unexpected base64 character ${m[ne]}`)}}const Y=A;for(;S>0;)ie(0);return T.wrap(V).slice(0,Y)}i.decodeBase64=t;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:m},p=!0,S=!1){const A=S?o:r;let V="";const ie=m.byteLength%3;let Y=0;for(;Y<m.byteLength-ie;Y+=3){const ne=m[Y+0],oe=m[Y+1],M=m[Y+2];V+=A[ne>>>2],V+=A[(ne<<4|oe>>>4)&63],V+=A[(oe<<2|M>>>6)&63],V+=A[M&63]}if(ie===1){const ne=m[Y+0];V+=A[ne>>>2],V+=A[ne<<4&63],p&&(V+="==")}else if(ie===2){const ne=m[Y+0],oe=m[Y+1];V+=A[ne>>>2],V+=A[(ne<<4|oe>>>4)&63],V+=A[oe<<2&63],p&&(V+="=")}return V}i.encodeBase64=u}),define(ee[66],te([0,1,26]),function(B,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.StringSHA1=i.toHexString=i.Hasher=i.stringHash=i.numberHash=i.doHash=i.hash=void 0;function I(l){return P(l,0)}i.hash=I;function P(l,f){switch(typeof l){case"object":return l===null?R(349,f):Array.isArray(l)?a(l,f):d(l,f);case"string":return v(l,f);case"boolean":return T(l,f);case"number":return R(l,f);case"undefined":return R(937,f);default:return R(617,f)}}i.doHash=P;function R(l,f){return(f<<5)-f+l|0}i.numberHash=R;function T(l,f){return R(l?433:863,f)}function v(l,f){f=R(149417,f);for(let y=0,c=l.length;y<c;y++)f=R(l.charCodeAt(y),f);return f}i.stringHash=v;function a(l,f){return f=R(104579,f),l.reduce((y,c)=>P(c,y),f)}function d(l,f){return f=R(181387,f),Object.keys(l).sort().reduce((y,c)=>(y=v(c,y),P(l[c],y)),f)}class D{constructor(){this._value=0}get value(){return this._value}hash(f){return this._value=P(f,this._value),this._value}}i.Hasher=D;var L;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(L||(L={}));function g(l,f,y=32){const c=y-f,s=~((1<<c)-1);return(l<<f|(s&l)>>>c)>>>0}function E(l,f=0,y=l.byteLength,c=0){for(let s=0;s<y;s++)l[f+s]=c}function b(l,f,y="0"){for(;l.length<f;)l=y+l;return l}function h(l,f=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(y=>y.toString(16).padStart(2,"0")).join(""):b((l>>>0).toString(16),f/4)}i.toHexString=h;class w{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(f){const y=f.length;if(y===0)return;const c=this._buff;let s=this._buffLen,e=this._leftoverHighSurrogate,n,t;for(e!==0?(n=e,t=-1,e=0):(n=f.charCodeAt(0),t=0);;){let r=n;if(C.isHighSurrogate(n))if(t+1<y){const o=f.charCodeAt(t+1);C.isLowSurrogate(o)?(t++,r=C.computeCodePoint(n,o)):r=65533}else{e=n;break}else C.isLowSurrogate(n)&&(r=65533);if(s=this._push(c,s,r),t++,t<y)n=f.charCodeAt(t);else break}this._buffLen=s,this._leftoverHighSurrogate=e}_push(f,y,c){return c<128?f[y++]=c:c<2048?(f[y++]=192|(c&1984)>>>6,f[y++]=128|(c&63)>>>0):c<65536?(f[y++]=224|(c&61440)>>>12,f[y++]=128|(c&4032)>>>6,f[y++]=128|(c&63)>>>0):(f[y++]=240|(c&1835008)>>>18,f[y++]=128|(c&258048)>>>12,f[y++]=128|(c&4032)>>>6,f[y++]=128|(c&63)>>>0),y>=64&&(this._step(),y-=64,this._totalLen+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),y}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,E(this._buff,this._buffLen),this._buffLen>56&&(this._step(),E(this._buff));const f=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(f/4294967296),!1),this._buffDV.setUint32(60,f%4294967296,!1),this._step()}_step(){const f=w._bigBlock32,y=this._buffDV;for(let m=0;m<64;m+=4)f.setUint32(m,y.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)f.setUint32(m,g(f.getUint32(m-12,!1)^f.getUint32(m-32,!1)^f.getUint32(m-56,!1)^f.getUint32(m-64,!1),1),!1);let c=this._h0,s=this._h1,e=this._h2,n=this._h3,t=this._h4,r,o,u;for(let m=0;m<80;m++)m<20?(r=s&e|~s&n,o=1518500249):m<40?(r=s^e^n,o=1859775393):m<60?(r=s&e|s&n|e&n,o=2400959708):(r=s^e^n,o=3395469782),u=g(c,5)+r+t+o+f.getUint32(m*4,!1)&4294967295,t=n,n=e,e=g(s,30),s=c,c=u;this._h0=this._h0+c&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+e&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+t&4294967295}}i.StringSHA1=w,w._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ee[50],te([0,1,26]),function(B,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0});var I;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(I||(I={})),function(P){const R="error",T="warning",v="warn",a="info",d="ignore";function D(g){return g?C.equalsIgnoreCase(R,g)?P.Error:C.equalsIgnoreCase(T,g)||C.equalsIgnoreCase(v,g)?P.Warning:C.equalsIgnoreCase(a,g)?P.Info:P.Ignore:P.Ignore}P.fromValue=D;function L(g){switch(g){case P.Error:return R;case P.Warning:return T;case P.Info:return a;default:return d}}P.toString=L}(I||(I={})),i.default=I}),define(ee[21],te([0,1,7]),function(B,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.filter=i.getCaseInsensitive=i.distinct=i.getOrDefault=i.safeStringify=i.equals=i.mixin=i.cloneAndChange=i.deepFreeze=i.deepClone=void 0;function I(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const w=Array.isArray(h)?[]:{};return Object.keys(h).forEach(l=>{h[l]&&typeof h[l]=="object"?w[l]=I(h[l]):w[l]=h[l]}),w}i.deepClone=I;function P(h){if(!h||typeof h!="object")return h;const w=[h];for(;w.length>0;){const l=w.shift();Object.freeze(l);for(const f in l)if(R.call(l,f)){const y=l[f];typeof y=="object"&&!Object.isFrozen(y)&&!(0,C.isTypedArray)(y)&&w.push(y)}}return h}i.deepFreeze=P;const R=Object.prototype.hasOwnProperty;function T(h,w){return v(h,w,new Set)}i.cloneAndChange=T;function v(h,w,l){if((0,C.isUndefinedOrNull)(h))return h;const f=w(h);if(typeof f!="undefined")return f;if((0,C.isArray)(h)){const y=[];for(const c of h)y.push(v(c,w,l));return y}if((0,C.isObject)(h)){if(l.has(h))throw new Error("Cannot clone recursive data-structure");l.add(h);const y={};for(let c in h)R.call(h,c)&&(y[c]=v(h[c],w,l));return l.delete(h),y}return h}function a(h,w,l=!0){return(0,C.isObject)(h)?((0,C.isObject)(w)&&Object.keys(w).forEach(f=>{f in h?l&&((0,C.isObject)(h[f])&&(0,C.isObject)(w[f])?a(h[f],w[f],l):h[f]=w[f]):h[f]=w[f]}),h):w}i.mixin=a;function d(h,w){if(h===w)return!0;if(h==null||w===null||w===void 0||typeof h!=typeof w||typeof h!="object"||Array.isArray(h)!==Array.isArray(w))return!1;let l,f;if(Array.isArray(h)){if(h.length!==w.length)return!1;for(l=0;l<h.length;l++)if(!d(h[l],w[l]))return!1}else{const y=[];for(f in h)y.push(f);y.sort();const c=[];for(f in w)c.push(f);if(c.sort(),!d(y,c))return!1;for(l=0;l<y.length;l++)if(!d(h[y[l]],w[y[l]]))return!1}return!0}i.equals=d;function D(h){const w=new Set;return JSON.stringify(h,(l,f)=>{if((0,C.isObject)(f)||Array.isArray(f)){if(w.has(f))return"[Circular]";w.add(f)}return f})}i.safeStringify=D;function L(h,w,l){const f=w(h);return typeof f=="undefined"?l:f}i.getOrDefault=L;function g(h,w){const l=Object.create(null);return!h||!w||Object.keys(w).forEach(y=>{const c=h[y],s=w[y];d(c,s)||(l[y]=s)}),l}i.distinct=g;function E(h,w){const l=w.toLowerCase(),f=Object.keys(h).find(y=>y.toLowerCase()===l);return f?h[f]:h[w]}i.getCaseInsensitive=E;function b(h,w){const l=Object.create(null);for(const[f,y]of Object.entries(h))w(f,y)&&(l[f]=y);return l}i.filter=b}),define(ee[67],te([0,1,10]),function(B,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.log=i.getFirstFrame=i.parse=i.isRemoteConsoleLog=void 0;function I(d){const D=d;return D&&typeof D.type=="string"&&typeof D.severity=="string"}i.isRemoteConsoleLog=I;function P(d){const D=[];let L;try{const g=JSON.parse(d.arguments),E=g[g.length-1];E&&E.__$stack&&(g.pop(),L=E.__$stack),D.push(...g)}catch{D.push("Unable to log remote console arguments",d.arguments)}return{args:D,stack:L}}i.parse=P;function R(d){if(typeof d!="string")return R(P(d).stack);const D=d;if(D){const L=T(D),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(L||"");if(g&&g.length===4)return{uri:C.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}i.getFirstFrame=R;function T(d){if(!d)return d;const D=d.indexOf(`
`);return D===-1?d:d.substring(0,D)}function v(d,D){const{args:L,stack:g}=P(d),E=typeof L[0]=="string"&&L.length===1;let b=T(g);b&&(b=`(${b.trim()})`);let h=[];if(typeof L[0]=="string"?b&&E?h=[`%c[${D}] %c${L[0]} %c${b}`,a("blue"),a(""),a("grey")]:h=[`%c[${D}] %c${L[0]}`,a("blue"),a(""),...L.slice(1)]:h=[`%c[${D}]%`,a("blue"),...L],b&&!E&&h.push(b),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,h)}i.log=v;function a(d){return`color: ${d}`}}),define(ee[51],te([0,1,16,26,10]),function(B,i,C,I,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.revive=i.parse=i.stringify=void 0;function R(d){return JSON.stringify(d,v)}i.stringify=R;function T(d){let D=JSON.parse(d);return D=a(D),D}i.parse=T;function v(d,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:(0,I.regExpFlags)(D)}:D}function a(d,D=0){if(!d||D>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return P.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 14:return new Date(d.source)}if(d instanceof C.VSBuffer||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let L=0;L<d.length;++L)d[L]=a(d[L],D+1);else for(const L in d)Object.hasOwnProperty.call(d,L)&&(d[L]=a(d[L],D+1))}return d}i.revive=a}),define(ee[68],te([0,1,17,52,14,13,8,18,26,10]),function(B,i,C,I,P,R,T,v,a,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.splitName=i.unmnemonicLabel=i.mnemonicButtonLabel=i.mnemonicMenuLabel=i.template=i.shorten=i.untildify=i.tildify=i.normalizeDriveLetter=i.getBaseLabel=i.getPathLabel=void 0;function D(u,m){const{os:p,tildify:S,relative:A}=m;if(A){const Y=L(u,A,p);if(typeof Y=="string")return Y}let V=u.fsPath;if(p===1&&!T.isWindows?V=V.replace(/\//g,"\\"):p!==1&&T.isWindows&&(V=V.replace(/\\/g,"/")),p!==1&&S?.userHome){let Y=S.userHome.fsPath,ne;u.scheme!==S.userHome.scheme&&u.path.startsWith(R.posix.sep)?ne=S.userHome.with({path:u.path}).fsPath:ne=u.fsPath,V=h(ne,Y,p)}return(p===1?R.win32:R.posix).normalize(E(V,p===1))}i.getPathLabel=D;function L(u,m,p){const S=p===1?R.win32:R.posix,A=p===3?v.extUri:v.extUriIgnorePathCase,V=m.getWorkspace(),ie=(0,C.firstOrDefault)(V.folders);if(!ie)return;u.scheme!==ie.uri.scheme&&u.path.startsWith(R.posix.sep)&&(u=ie.uri.with({path:u.path}));const Y=m.getWorkspaceFolder(u);if(!Y)return;let ne;if(A.isEqual(Y.uri,u)?ne="":ne=A.relativePath(Y.uri,u)??"",ne&&(ne=S.normalize(ne)),V.folders.length>1&&!m.noPrefix){const oe=Y.name?Y.name:A.basenameOrAuthority(Y.uri);ne=ne?`${oe} \u2022 ${ne}`:oe}return ne}function g(u){if(!u)return;typeof u=="string"&&(u=d.URI.file(u));const m=(0,v.basename)(u)||(u.scheme===P.Schemas.file?u.fsPath:u.path);return T.isWindows&&(0,I.isRootOrDriveLetter)(m)?E(m):m}i.getBaseLabel=g;function E(u,m=T.isWindows){return(0,I.hasDriveLetter)(u,m)?u.charAt(0).toUpperCase()+u.slice(1):u}i.normalizeDriveLetter=E;let b=Object.create(null);function h(u,m,p=T.OS){if(p===1||!u||!m)return u;let S=b.original===m?b.normalized:void 0;S||(S=m,T.isWindows&&(S=(0,I.toSlashes)(S)),S=`${(0,a.rtrim)(S,R.posix.sep)}${R.posix.sep}`,b={original:m,normalized:S});let A=u;return T.isWindows&&(A=(0,I.toSlashes)(A)),(p===3?A.startsWith(S):(0,a.startsWithIgnoreCase)(A,S))?`~/${A.substr(S.length)}`:u}i.tildify=h;function w(u,m){return u.replace(/^~($|\/|\\)/,`${m}$1`)}i.untildify=w;const l="\u2026",f="\\\\",y="~";function c(u,m=R.sep){const p=new Array(u.length);let S=!1;for(let A=0;A<u.length;A++){let V=u[A];if(V===""){p[A]=`.${m}`;continue}if(!V){p[A]=V;continue}S=!0;let ie="",Y=V;Y.indexOf(f)===0?(ie=Y.substr(0,Y.indexOf(f)+f.length),Y=Y.substr(Y.indexOf(f)+f.length)):Y.indexOf(m)===0?(ie=Y.substr(0,Y.indexOf(m)+m.length),Y=Y.substr(Y.indexOf(m)+m.length)):Y.indexOf(y)===0&&(ie=Y.substr(0,Y.indexOf(y)+y.length),Y=Y.substr(Y.indexOf(y)+y.length));const ne=Y.split(m);for(let oe=1;S&&oe<=ne.length;oe++)for(let M=ne.length-oe;S&&M>=0;M--){S=!1;let x=ne.slice(M,M+oe).join(m);for(let G=0;!S&&G<u.length;G++)if(G!==A&&u[G]&&u[G].indexOf(x)>-1){const _=M+oe===ne.length,re=M>0&&u[G].indexOf(m)>-1?m+x:x,k=u[G].endsWith(re);S=!_||k}if(!S){let G="";(ne[0].endsWith(":")||ie!=="")&&(M===1&&(M=0,oe++,x=ne[0]+m+x),M>0&&(G=ne[0]+m),G=ie+G),M>0&&(G=G+l+m),G=G+x,M+oe<ne.length&&(G=G+m+l),p[A]=G}}S&&(p[A]=V)}return p}i.shorten=c;var s;(function(u){u[u.TEXT=0]="TEXT",u[u.VARIABLE=1]="VARIABLE",u[u.SEPARATOR=2]="SEPARATOR"})(s||(s={}));function e(u,m=Object.create(null)){const p=[];let S=!1,A="";for(const V of u)if(V==="$"||S&&V==="{")A&&p.push({value:A,type:s.TEXT}),A="",S=!0;else if(V==="}"&&S){const ie=m[A];if(typeof ie=="string")ie.length&&p.push({value:ie,type:s.VARIABLE});else if(ie){const Y=p[p.length-1];(!Y||Y.type!==s.SEPARATOR)&&p.push({value:ie.label,type:s.SEPARATOR})}A="",S=!1}else A+=V;return A&&!S&&p.push({value:A,type:s.TEXT}),p.filter((V,ie)=>{if(V.type===s.SEPARATOR){const Y=p[ie-1],ne=p[ie+1];return[Y,ne].every(oe=>oe&&(oe.type===s.VARIABLE||oe.type===s.TEXT)&&oe.value.length>0)}return!0}).map(V=>V.value).join("")}i.template=e;function n(u,m){return T.isMacintosh||m?u.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):u.replace(/&&|&/g,p=>p==="&"?"&&":"&")}i.mnemonicMenuLabel=n;function t(u,m){return T.isMacintosh||m?u.replace(/\(&&\w\)|&&/g,""):T.isWindows?u.replace(/&&|&/g,p=>p==="&"?"&&":"&"):u.replace(/&&/g,"_")}i.mnemonicButtonLabel=t;function r(u){return u.replace(/&/g,"&&")}i.unmnemonicLabel=r;function o(u){const m=u.indexOf("/")!==-1?R.posix:R.win32,p=m.basename(u),S=m.dirname(u);return p.length?{name:p,parentPath:S}:{name:S,parentPath:""}}i.splitName=o}),define(ee[32],te([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.generateUuid=i.isUUID=void 0;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(P){return C.test(P)}i.isUUID=I,i.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(v){for(let a=0;a<v.length;a++)v[a]=Math.floor(Math.random()*256);return v};const R=new Uint8Array(16),T=[];for(let v=0;v<256;v++)T.push(v.toString(16).padStart(2,"0"));return function(){P(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let a=0,d="";return d+=T[R[a++]],d+=T[R[a++]],d+=T[R[a++]],d+=T[R[a++]],d+="-",d+=T[R[a++]],d+=T[R[a++]],d+="-",d+=T[R[a++]],d+=T[R[a++]],d+="-",d+=T[R[a++]],d+=T[R[a++]],d+="-",d+=T[R[a++]],d+=T[R[a++]],d+=T[R[a++]],d+=T[R[a++]],d+=T[R[a++]],d+=T[R[a++]],d}}()}),define(ee[69],te([0,1,142]),function(B,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LineDecoder=void 0;class I{constructor(R="utf8"){this.stringDecoder=new C.StringDecoder(R),this.remaining=null}write(R){const T=[],v=this.remaining?this.remaining+this.stringDecoder.write(R):this.stringDecoder.write(R);if(v.length<1)return T;let a=0,d,D=a;for(;D<v.length;)if(d=v.charCodeAt(D),d===13||d===10){if(T.push(v.substring(a,D)),D++,D<v.length){const L=d;d=v.charCodeAt(D),(L===13&&d===10||L===10&&d===13)&&D++}a=D}else D++;return this.remaining=a<v.length?v.substr(a):null,T}end(){return this.remaining}}i.LineDecoder=I}),define(ee[70],te([0,1,34,13,19]),function(B,i,C,I,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getFirstAvailablePowerShellInstallation=i.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,T=/^Microsoft.PowerShell_.*/,v=/^Microsoft.PowerShellPreview_.*/;var a;(function(c){c[c.x64=0]="x64",c[c.x86=1]="x86",c[c.ARM=2]="ARM"})(a||(a={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let D;process.env.PROCESSOR_ARCHITEW6432?D=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?D=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?D=1:D=0;class L{constructor(s,e,n){this.exePath=s,this.displayName=e,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await P.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:c=!1}={}){return c?d===0?process.env["ProgramFiles(x86)"]||null:D===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function E({useAlternateBitness:c=!1,findPreview:s=!1}={}){const e=g({useAlternateBitness:c});if(!e)return null;const n=I.join(e,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(n))return null;let t=-1,r=null;for(const m of await P.Promises.readdir(n)){let p=-1;if(s){const A=m.indexOf("-");if(A<0)continue;const V=m.substring(0,A);if(!R.test(V)||m.substring(A+1)!=="preview")continue;p=parseInt(V,10)}else{if(!R.test(m))continue;p=parseInt(m,10)}if(p<=t)continue;const S=I.join(n,m,"pwsh.exe");!await P.SymlinkSupport.existsFile(S)||(r=S,t=p)}if(!r)return null;const o=e.includes("x86")?" (x86)":"",u=s?" Preview":"";return new L(r,`PowerShell${u}${o}`,!0)}async function b({findPreview:c}={}){if(!process.env.LOCALAPPDATA)return null;const s=I.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:e,pwshMsixName:n}=c?{pwshMsixDirRegex:v,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const t of await P.Promises.readdir(s))if(e.test(t)){const r=I.join(s,t,"pwsh.exe");return new L(r,n)}return null}function h(){const c=I.join(C.homedir(),".dotnet","tools","pwsh.exe");return new L(c,".NET Core PowerShell Global Tool")}function w(){const c=I.join(process.env.windir,d===1&&D!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new L(c,"Windows PowerShell",!0)}async function*l(){let c=await E();c&&(yield c),c=await E({useAlternateBitness:!0}),c&&(yield c),c=await b(),c&&(yield c),c=h(),c&&(yield c),c=await E({findPreview:!0}),c&&(yield c),c=await b({findPreview:!0}),c&&(yield c),c=await E({useAlternateBitness:!0,findPreview:!0}),c&&(yield c),c=w(),c&&(yield c)}async function*f(){for await(const c of l())await c.exists()&&(yield c)}i.enumeratePowerShellInstallations=f;async function y(){for await(const c of f())return c;return null}i.getFirstAvailablePowerShellInstallation=y});var de=this&&this.__decorate||function(B,i,C,I){var P=arguments.length,R=P<3?i:I===null?I=Object.getOwnPropertyDescriptor(i,C):I,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(B,i,C,I);else for(var v=B.length-1;v>=0;v--)(T=B[v])&&(R=(P<3?T(R):P>3?T(i,C,R):T(i,C))||R);return P>3&&R&&Object.defineProperty(i,C,R),R};define(ee[53],te([0,1,17,4,16,24,46,9,3,2,51,26,7]),function(B,i,C,I,P,R,T,v,a,d,D,L,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IPCLogger=i.logWithColors=i.ProxyChannel=i.StaticRouter=i.getNextTickChannel=i.getDelayedChannel=i.IPCClient=i.IPCServer=i.ChannelClient=i.RequestInitiator=i.ChannelServer=i.ResponseType=i.RequestType=void 0;var E;(function(k){k[k.Promise=100]="Promise",k[k.PromiseCancel=101]="PromiseCancel",k[k.EventListen=102]="EventListen",k[k.EventDispose=103]="EventDispose"})(E=i.RequestType||(i.RequestType={}));function b(k){switch(k){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(k){k[k.Initialize=200]="Initialize",k[k.PromiseSuccess=201]="PromiseSuccess",k[k.PromiseError=202]="PromiseError",k[k.PromiseErrorObj=203]="PromiseErrorObj",k[k.EventFire=204]="EventFire"})(h=i.ResponseType||(i.ResponseType={}));function w(k){switch(k){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(k){k[k.Uninitialized=0]="Uninitialized",k[k.Idle=1]="Idle"})(l||(l={}));class f{constructor(O){this.buffer=O,this.pos=0}read(O){const F=this.buffer.slice(this.pos,this.pos+O);return this.pos+=F.byteLength,F}}class y{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}var c;(function(k){k[k.Undefined=0]="Undefined",k[k.String=1]="String",k[k.Buffer=2]="Buffer",k[k.VSBuffer=3]="VSBuffer",k[k.Array=4]="Array",k[k.Object=5]="Object"})(c||(c={}));function s(k){const O=P.VSBuffer.alloc(4);return O.writeUInt32BE(k,0),O}function e(k){return k.read(4).readUInt32BE(0)}function n(k){const O=P.VSBuffer.alloc(1);return O.writeUInt8(k,0),O}const t={Undefined:n(c.Undefined),String:n(c.String),Buffer:n(c.Buffer),VSBuffer:n(c.VSBuffer),Array:n(c.Array),Object:n(c.Object)},r=typeof Buffer!="undefined";function o(k,O){if(typeof O=="undefined")k.write(t.Undefined);else if(typeof O=="string"){const F=P.VSBuffer.fromString(O);k.write(t.String),k.write(s(F.byteLength)),k.write(F)}else if(r&&Buffer.isBuffer(O)){const F=P.VSBuffer.wrap(O);k.write(t.Buffer),k.write(s(F.byteLength)),k.write(F)}else if(O instanceof P.VSBuffer)k.write(t.VSBuffer),k.write(s(O.byteLength)),k.write(O);else if(Array.isArray(O)){k.write(t.Array),k.write(s(O.length));for(const F of O)o(k,F)}else{const F=P.VSBuffer.fromString(JSON.stringify(O));k.write(t.Object),k.write(s(F.byteLength)),k.write(F)}}function u(k){switch(k.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return k.read(e(k)).toString();case c.Buffer:return k.read(e(k)).buffer;case c.VSBuffer:return k.read(e(k));case c.Array:{const F=e(k),U=[];for(let $=0;$<F;$++)U.push(u(k));return U}case c.Object:return JSON.parse(k.read(e(k)).toString())}}class m{constructor(O,F,U=null,$=1e3){this.protocol=O,this.ctx=F,this.logger=U,this.timeoutDelay=$,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(W=>this.onRawMessage(W)),this.sendResponse({type:200})}registerChannel(O,F){this.channels.set(O,F),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case 200:{const F=this.send([O.type]);this.logger?.logOutgoing(F,0,1,w(O.type));return}case 201:case 202:case 204:case 203:{const F=this.send([O.type,O.id],O.data);this.logger?.logOutgoing(F,O.id,1,w(O.type),O.data);return}}}send(O,F=void 0){const U=new y;return o(U,O),o(U,F),this.sendBuffer(U.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch{return 0}}onRawMessage(O){const F=new f(O),U=u(F),$=u(F),W=U[0];switch(W){case 100:return this.logger?.logIncoming(O.byteLength,U[1],1,`${b(W)}: ${U[2]}.${U[3]}`,$),this.onPromise({type:W,id:U[1],channelName:U[2],name:U[3],arg:$});case 102:return this.logger?.logIncoming(O.byteLength,U[1],1,`${b(W)}: ${U[2]}.${U[3]}`,$),this.onEventListen({type:W,id:U[1],channelName:U[2],name:U[3],arg:$});case 101:return this.logger?.logIncoming(O.byteLength,U[1],1,`${b(W)}`),this.disposeActiveRequest({type:W,id:U[1]});case 103:return this.logger?.logIncoming(O.byteLength,U[1],1,`${b(W)}`),this.disposeActiveRequest({type:W,id:U[1]})}}onPromise(O){const F=this.channels.get(O.channelName);if(!F){this.collectPendingRequest(O);return}const U=new R.CancellationTokenSource;let $;try{$=F.call(this.ctx,O.name,O.arg,U.token)}catch(Z){$=Promise.reject(Z)}const W=O.id;$.then(Z=>{this.sendResponse({id:W,data:Z,type:201}),this.activeRequests.delete(O.id)},Z=>{Z instanceof Error?this.sendResponse({id:W,data:{message:Z.message,name:Z.name,stack:Z.stack?Z.stack.split?Z.stack.split(`
`):Z.stack:void 0},type:202}):this.sendResponse({id:W,data:Z,type:203}),this.activeRequests.delete(O.id)});const ae=(0,d.toDisposable)(()=>U.cancel());this.activeRequests.set(O.id,ae)}onEventListen(O){const F=this.channels.get(O.channelName);if(!F){this.collectPendingRequest(O);return}const U=O.id,W=F.listen(this.ctx,O.name,O.arg)(ae=>this.sendResponse({id:U,data:ae,type:204}));this.activeRequests.set(O.id,W)}disposeActiveRequest(O){const F=this.activeRequests.get(O.id);F&&(F.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let F=this.pendingRequests.get(O.channelName);F||(F=[],this.pendingRequests.set(O.channelName,F));const U=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);F.push({request:O,timeoutTimer:U})}flushPendingRequests(O){const F=this.pendingRequests.get(O);if(F){for(const U of F)switch(clearTimeout(U.timeoutTimer),U.request.type){case 100:this.onPromise(U.request);break;case 102:this.onEventListen(U.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}i.ChannelServer=m;var p;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(p=i.RequestInitiator||(i.RequestInitiator={}));class S{constructor(O,F=null){this.protocol=O,this.isDisposed=!1,this.state=l.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new a.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(U=>this.onBuffer(U)),this.logger=F}getChannel(O){const F=this;return{call(U,$,W){return F.isDisposed?Promise.reject(v.canceled()):F.requestPromise(O,U,$,W)},listen(U,$){return F.isDisposed?a.Event.None:F.requestEvent(O,U,$)}}}requestPromise(O,F,U,$=R.CancellationToken.None){const W=this.lastRequestId++,Z={id:W,type:100,channelName:O,name:F,arg:U};if($.isCancellationRequested)return Promise.reject(v.canceled());let j;return new Promise((q,X)=>{if($.isCancellationRequested)return X(v.canceled());const Q=()=>{const me=ge=>{switch(ge.type){case 201:this.handlers.delete(W),q(ge.data);break;case 202:{this.handlers.delete(W);const le=new Error(ge.data.message);le.stack=ge.data.stack,le.name=ge.data.name,X(le);break}case 203:this.handlers.delete(W),X(ge.data);break}};this.handlers.set(W,me),this.sendRequest(Z)};let K=null;this.state===l.Idle?Q():(K=(0,I.createCancelablePromise)(me=>this.whenInitialized()),K.then(()=>{K=null,Q()}));const se=()=>{K?(K.cancel(),K=null):this.sendRequest({id:W,type:101}),X(v.canceled())},ue=$.onCancellationRequested(se);j=(0,d.combinedDisposable)((0,d.toDisposable)(se),ue),this.activeRequests.add(j)}).finally(()=>{this.activeRequests.delete(j)})}requestEvent(O,F,U){const $=this.lastRequestId++,ae={id:$,type:102,channelName:O,name:F,arg:U};let Z=null;const j=new a.Emitter({onFirstListenerAdd:()=>{Z=(0,I.createCancelablePromise)(q=>this.whenInitialized()),Z.then(()=>{Z=null,this.activeRequests.add(j),this.sendRequest(ae)})},onLastListenerRemove:()=>{Z?(Z.cancel(),Z=null):(this.activeRequests.delete(j),this.sendRequest({id:$,type:103}))}}),N=q=>j.fire(q.data);return this.handlers.set($,N),j.event}sendRequest(O){switch(O.type){case 100:case 102:{const F=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger&&this.logger.logOutgoing(F,O.id,0,`${b(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const F=this.send([O.type,O.id]);this.logger&&this.logger.logOutgoing(F,O.id,0,b(O.type));return}}}send(O,F=void 0){const U=new y;return o(U,O),o(U,F),this.sendBuffer(U.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch{return 0}}onBuffer(O){const F=new f(O),U=u(F),$=u(F),W=U[0];switch(W){case 200:return this.logger&&this.logger.logIncoming(O.byteLength,0,0,w(W)),this.onResponse({type:U[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(O.byteLength,U[1],0,w(W),$),this.onResponse({type:U[0],id:U[1],data:$})}}onResponse(O){if(O.type===200){this.state=l.Idle,this._onDidInitialize.fire();return}const F=this.handlers.get(O.id);F&&F(O)}get onDidInitializePromise(){return a.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}de([T.memoize],S.prototype,"onDidInitializePromise",null),i.ChannelClient=S;class A{constructor(O){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new a.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new a.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,O(({protocol:F,onDidClientDisconnect:U})=>{a.Event.once(F.onMessage)(W=>{const ae=new f(W),Z=u(ae),j=new m(F,Z),N=new S(F);this.channels.forEach((X,Q)=>j.registerChannel(Q,X));const q={channelServer:j,channelClient:N,ctx:Z};this._connections.add(q),this._onDidAddConnection.fire(q),U(()=>{j.dispose(),N.dispose(),this._connections.delete(q),this._onDidRemoveConnection.fire(q)})})})}get connections(){const O=[];return this._connections.forEach(F=>O.push(F)),O}getChannel(O,F){const U=this;return{call($,W,ae){let Z;if((0,g.isFunction)(F)){let N=(0,C.getRandomElement)(U.connections.filter(F));Z=N?Promise.resolve(N):a.Event.toPromise(a.Event.filter(U.onDidAddConnection,F))}else Z=F.routeCall(U,$,W);const j=Z.then(N=>N.channelClient.getChannel(O));return ie(j).call($,W,ae)},listen($,W){if((0,g.isFunction)(F))return U.getMulticastEvent(O,F,$,W);const ae=F.routeEvent(U,$,W).then(Z=>Z.channelClient.getChannel(O));return ie(ae).listen($,W)}}}getMulticastEvent(O,F,U,$){const W=this;let ae=new d.DisposableStore;const Z=new a.Emitter({onFirstListenerAdd:()=>{ae=new d.DisposableStore;const j=new a.EventMultiplexer,N=new Map,q=Q=>{const se=Q.channelClient.getChannel(O).listen(U,$),ue=j.add(se);N.set(Q,ue)},X=Q=>{const K=N.get(Q);!K||(K.dispose(),N.delete(Q))};W.connections.filter(F).forEach(q),a.Event.filter(W.onDidAddConnection,F)(q,void 0,ae),W.onDidRemoveConnection(X,void 0,ae),j.event(Z.fire,Z,ae),ae.add(j)},onLastListenerRemove:()=>{ae.dispose()}});return Z.event}registerChannel(O,F){this.channels.set(O,F),this._connections.forEach(U=>{U.channelServer.registerChannel(O,F)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}i.IPCServer=A;class V{constructor(O,F,U=null){const $=new y;o($,F),O.send($.buffer),this.channelClient=new S(O,U),this.channelServer=new m(O,F,U)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,F){this.channelServer.registerChannel(O,F)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}i.IPCClient=V;function ie(k){return{call(O,F,U){return k.then($=>$.call(O,F,U))},listen(O,F){const U=new a.Relay;return k.then($=>U.input=$.listen(O,F)),U.event}}}i.getDelayedChannel=ie;function Y(k){let O=!1;return{call(F,U,$){return O?k.call(F,U,$):(0,I.timeout)(0).then(()=>O=!0).then(()=>k.call(F,U,$))},listen(F,U){if(O)return k.listen(F,U);const $=new a.Relay;return(0,I.timeout)(0).then(()=>O=!0).then(()=>$.input=k.listen(F,U)),$.event}}}i.getNextTickChannel=Y;class ne{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const F of O.connections)if(await Promise.resolve(this.fn(F.ctx)))return Promise.resolve(F);return await a.Event.toPromise(O.onDidAddConnection),await this.route(O)}}i.StaticRouter=ne;var oe;(function(k){function O(W,ae){const Z=W,j=ae&&ae.disableMarshalling,N=new Map;for(const q in Z)U(q)&&N.set(q,a.Event.buffer(Z[q],!0));return new class{listen(q,X,Q){const K=N.get(X);if(K)return K;if($(X)){const se=Z[X];if(typeof se=="function")return se.call(Z,Q)}throw new Error(`Event not found: ${X}`)}call(q,X,Q){const K=Z[X];if(typeof K=="function"){if(!j&&Array.isArray(Q))for(let se=0;se<Q.length;se++)Q[se]=(0,D.revive)(Q[se]);return K.apply(Z,Q)}throw new Error(`Method not found: ${X}`)}}}k.fromService=O;function F(W,ae){const Z=ae&&ae.disableMarshalling;return new Proxy({},{get(j,N){if(typeof N=="string")return ae?.properties?.has(N)?ae.properties.get(N):$(N)?function(q){return W.listen(N,q)}:U(N)?W.listen(N):async function(...q){let X;ae&&!(0,g.isUndefinedOrNull)(ae.context)?X=[ae.context,...q]:X=q;const Q=await W.call(N,X);return Z?Q:(0,D.revive)(Q)};throw new Error(`Property not found: ${String(N)}`)}})}k.toService=F;function U(W){return W[0]==="o"&&W[1]==="n"&&L.isUpperAsciiLetter(W.charCodeAt(2))}function $(W){return/^onDynamic/.test(W)&&L.isUpperAsciiLetter(W.charCodeAt(9))}})(oe=i.ProxyChannel||(i.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function x(k){if(Array.isArray(k))return k;if(k&&typeof k=="object"&&typeof k.toString=="function"){let O=k.toString();if(O!=="[object Object]")return O}return k}function G(k){return Array.isArray(k)?k.map(x):x(k)}function _(k,O,F,U,$,W,ae){ae=G(ae);const Z=M[$],j=Z[U%Z.length];let N=[`%c[${k}]%c[${String(O).padStart(7," ")}]%c[len: ${String(F).padStart(5," ")}]%c${String(U).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${j}`];/\($/.test(W)?(N=N.concat(ae),N.push(")")):N.push(ae),console.log.apply(console,N)}i.logWithColors=_;class re{constructor(O,F){this._outgoingPrefix=O,this._incomingPrefix=F,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,F,U,$,W){this._totalOutgoing+=O,_(this._outgoingPrefix,this._totalOutgoing,O,F,U,$,W)}logIncoming(O,F,U,$,W){this._totalIncoming+=O,_(this._incomingPrefix,this._totalIncoming,O,F,U,$,W)}}i.IPCLogger=re}),define(ee[71],te([0,1,4,3,2,7]),function(B,i,C,I,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InMemoryStorageDatabase=i.Storage=i.StorageState=i.isStorageItemsChangeEvent=i.StorageHint=void 0;var T;(function(L){L[L.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=i.StorageHint||(i.StorageHint={}));function v(L){const g=L;return g?.changed instanceof Map||g?.deleted instanceof Set}i.isStorageItemsChangeEvent=v;var a;(function(L){L[L.None=0]="None",L[L.Initialized=1]="Initialized",L[L.Closed=2]="Closed"})(a=i.StorageState||(i.StorageState={}));class d extends P.Disposable{constructor(g,E=Object.create(null)){super();this.database=g,this.options=E,this._onDidChangeStorage=this._register(new I.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=a.None,this.cache=new Map,this.flushDelayer=new C.ThrottledDelayer(d.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){g.changed?.forEach((E,b)=>this.accept(b,E)),g.deleted?.forEach(E=>this.accept(E,void 0))}accept(g,E){if(this.state===a.Closed)return;let b=!1;(0,R.isUndefinedOrNull)(E)?b=this.cache.delete(g):this.cache.get(g)!==E&&(this.cache.set(g,E),b=!0),b&&this._onDidChangeStorage.fire(g)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===a.None&&(this.state=a.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,E){const b=this.cache.get(g);return(0,R.isUndefinedOrNull)(b)?E:b}getBoolean(g,E){const b=this.get(g);return(0,R.isUndefinedOrNull)(b)?E:b==="true"}getNumber(g,E){const b=this.get(g);return(0,R.isUndefinedOrNull)(b)?E:parseInt(b,10)}async set(g,E){if(this.state===a.Closed)return;if((0,R.isUndefinedOrNull)(E))return this.delete(g);const b=String(E);if(this.cache.get(g)!==b)return this.cache.set(g,b),this.pendingInserts.set(g,b),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.doFlush()}async delete(g){if(!(this.state===a.Closed||!this.cache.delete(g)))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=a.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(g){if(!!this.hasPending)return this.doFlush(g)}async doFlush(g){return this.flushDelayer.trigger(()=>this.flushPending(),g)}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}dispose(){this.flushDelayer.dispose(),super.dispose()}}i.Storage=d,d.DEFAULT_FLUSH_DELAY=100;class D{constructor(){this.onDidChangeItemsExternal=I.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert&&g.insert.forEach((E,b)=>this.items.set(b,E)),g.delete&&g.delete.forEach(E=>this.items.delete(E))}async close(){}}i.InMemoryStorageDatabase=D}),define(ee[72],te([5,6]),function(B,i){return B.create("vs/base/common/date",i)}),define(ee[73],te([0,1,72]),function(B,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toLocalISOString=i.fromNow=void 0;const I=60,P=I*60,R=P*24,T=R*7,v=R*30,a=R*365;function d(L,g,E){typeof L!="number"&&(L=L.getTime());const b=Math.round((new Date().getTime()-L)/1e3);if(b<-30)return(0,C.localize)(0,null,d(new Date().getTime()+b*1e3,!1));if(b<30)return(0,C.localize)(1,null);let h;return b<I?(h=b,g?h===1?E?(0,C.localize)(2,null,h):(0,C.localize)(3,null,h):E?(0,C.localize)(4,null,h):(0,C.localize)(5,null,h):h===1?E?(0,C.localize)(6,null,h):(0,C.localize)(7,null,h):E?(0,C.localize)(8,null,h):(0,C.localize)(9,null,h)):b<P?(h=Math.floor(b/I),g?h===1?E?(0,C.localize)(10,null,h):(0,C.localize)(11,null,h):E?(0,C.localize)(12,null,h):(0,C.localize)(13,null,h):h===1?E?(0,C.localize)(14,null,h):(0,C.localize)(15,null,h):E?(0,C.localize)(16,null,h):(0,C.localize)(17,null,h)):b<R?(h=Math.floor(b/P),g?h===1?E?(0,C.localize)(18,null,h):(0,C.localize)(19,null,h):E?(0,C.localize)(20,null,h):(0,C.localize)(21,null,h):h===1?E?(0,C.localize)(22,null,h):(0,C.localize)(23,null,h):E?(0,C.localize)(24,null,h):(0,C.localize)(25,null,h)):b<T?(h=Math.floor(b/R),g?h===1?(0,C.localize)(26,null,h):(0,C.localize)(27,null,h):h===1?(0,C.localize)(28,null,h):(0,C.localize)(29,null,h)):b<v?(h=Math.floor(b/T),g?h===1?E?(0,C.localize)(30,null,h):(0,C.localize)(31,null,h):E?(0,C.localize)(32,null,h):(0,C.localize)(33,null,h):h===1?E?(0,C.localize)(34,null,h):(0,C.localize)(35,null,h):E?(0,C.localize)(36,null,h):(0,C.localize)(37,null,h)):b<a?(h=Math.floor(b/v),g?h===1?E?(0,C.localize)(38,null,h):(0,C.localize)(39,null,h):E?(0,C.localize)(40,null,h):(0,C.localize)(41,null,h):h===1?E?(0,C.localize)(42,null,h):(0,C.localize)(43,null,h):E?(0,C.localize)(44,null,h):(0,C.localize)(45,null,h)):(h=Math.floor(b/a),g?h===1?E?(0,C.localize)(46,null,h):(0,C.localize)(47,null,h):E?(0,C.localize)(48,null,h):(0,C.localize)(49,null,h):h===1?E?(0,C.localize)(50,null,h):(0,C.localize)(51,null,h):E?(0,C.localize)(52,null,h):(0,C.localize)(53,null,h))}i.fromNow=d;function D(L){return L.getFullYear()+"-"+String(L.getMonth()+1).padStart(2,"0")+"-"+String(L.getDate()).padStart(2,"0")+"T"+String(L.getHours()).padStart(2,"0")+":"+String(L.getMinutes()).padStart(2,"0")+":"+String(L.getSeconds()).padStart(2,"0")+"."+(L.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}i.toLocalISOString=D}),define(ee[74],te([5,6]),function(B,i){return B.create("vs/base/common/errorMessage",i)}),define(ee[28],te([0,1,17,7,74]),function(B,i,C,I,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.createErrorWithActions=i.isErrorWithActions=i.toErrorMessage=void 0;function R(L,g){return g&&(L.stack||L.stacktrace)?P.localize(0,null,v(L),T(L.stack)||T(L.stacktrace)):v(L)}function T(L){return Array.isArray(L)?L.join(`
`):L}function v(L){return typeof L.code=="string"&&typeof L.errno=="number"&&typeof L.syscall=="string"?P.localize(1,null,L.message):L.message||P.localize(2,null)}function a(L=null,g=!1){if(!L)return P.localize(3,null);if(Array.isArray(L)){const E=C.coalesce(L),b=a(E[0],g);return E.length>1?P.localize(4,null,b,E.length):b}if(I.isString(L))return L;if(L.detail){const E=L.detail;if(E.error)return R(E.error,g);if(E.exception)return R(E.exception,g)}return L.stack?R(L,g):L.message?L.message:P.localize(5,null)}i.toErrorMessage=a;function d(L){const g=L;return g instanceof Error&&Array.isArray(g.actions)}i.isErrorWithActions=d;function D(L,g){let E;return typeof L=="string"?E=new Error(L):E=L,E.actions=g,E}i.createErrorWithActions=D}),define(ee[75],te([5,6]),function(B,i){return B.create("vs/base/common/jsonErrorMessages",i)}),define(ee[76],te([0,1,75]),function(B,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getParseErrorMessage=void 0;function I(P){switch(P){case 1:return(0,C.localize)(0,null);case 2:return(0,C.localize)(1,null);case 3:return(0,C.localize)(2,null);case 4:return(0,C.localize)(3,null);case 5:return(0,C.localize)(4,null);case 6:return(0,C.localize)(5,null);case 7:return(0,C.localize)(6,null);case 8:return(0,C.localize)(7,null);case 9:return(0,C.localize)(8,null);default:return""}}i.getParseErrorMessage=I}),define(ee[77],te([5,6]),function(B,i){return B.create("vs/base/node/processes",i)}),define(ee[54],te([0,1,41,52,14,21,13,8,29,48,7,69,19,77]),function(B,i,C,I,P,R,T,v,a,d,D,L,g,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.win32=i.createQueuedSender=i.LineProcess=i.AbstractProcess=i.getWindowsShell=i.TerminateResponseCode=i.Source=void 0,Object.defineProperty(i,"Source",{enumerable:!0,get:function(){return d.Source}}),Object.defineProperty(i,"TerminateResponseCode",{enumerable:!0,get:function(){return d.TerminateResponseCode}});function b(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(s,e){if(v.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};e&&(n.cwd=e);const t=C.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],n);return new Promise(r=>{t.once("error",o=>{r({success:!1,error:o})}),t.once("exit",(o,u)=>{r(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?b(n.status):1})}else if(v.isLinux||v.isMacintosh)try{const n=P.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",B).fsPath;return new Promise(t=>{C.execFile(n,[s.pid.toString()],{encoding:"utf8",shell:!0},(r,o,u)=>{t(r?{success:!1,error:r}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function w(s=a.env){return s.comspec||"cmd.exe"}i.getWindowsShell=w;class l{constructor(e,n,t,r){if(n!==void 0&&t!==void 0&&r!==void 0)this.cmd=e,this.args=n,this.shell=t,this.options=r;else{const o=e;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(a.env).forEach(u=>{o[u]=a.env[u]}),Object.keys(this.options.env).forEach(u=>{o[u]=this.options.env[u]}),this.options.env=o}}getSanitizedCommand(){let e=this.cmd.toLowerCase();const n=e.lastIndexOf(T.sep);return n!==-1&&(e=e.substring(n+1)),l.WellKnowCommands[e]?e:"other"}start(e){return v.isWindows&&(this.options&&this.options.cwd&&I.isUNC(this.options.cwd)||!this.options&&I.isUNC(a.cwd()))?Promise.reject(new Error(E.localize(0,null))):this.useExec().then(n=>{let t,r;const o=new Promise((u,m)=>{t=u,r=m});if(n){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=C.exec(u,this.options,(m,p,S)=>{this.childProcess=null;const A=m;A&&A.killed?r({killed:this.terminateRequested,stdout:p.toString(),stderr:S.toString()}):this.handleExec(t,e,m,p,S)})}else{let u=null;const m=p=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(p,t,e,r);const S={terminated:this.terminateRequested};D.isNumber(p)&&(S.cmdCode=p),t(S)};if(this.shell&&v.isWindows){const p=R.deepClone(this.options);p.windowsVerbatimArguments=!0,p.detached=!1;let S=!1,A=!1;const V=[];let ie=this.ensureQuotes(this.cmd);V.push(ie.value),S=ie.quoted,this.args&&this.args.forEach(ne=>{ie=this.ensureQuotes(ne),V.push(ie.value),A=A&&ie.quoted});const Y=["/s","/c"];S?A?Y.push('"'+V.join(" ")+'"'):V.length>1?Y.push('"'+V[0]+'" '+V.slice(1).join(" ")):Y.push('"'+V[0]+'"'):Y.push(V.join(" ")),u=C.spawn(w(),Y,p)}else this.cmd&&(u=C.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(D.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",p=>{this.childProcess=null,r({terminated:this.terminateRequested,error:p})}),u.pid&&(this.childProcess.on("close",m),this.handleSpawn(u,t,e,r,!0)))}return o})}handleClose(e,n,t,r){}ensureQuotes(e){return l.regexp.test(e)?{value:'"'+e+'"',quoted:!0}:{value:e,quoted:e.length>0&&e[0]==='"'&&e[e.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(e=>e.pid,e=>-1):new Promise(e=>{this.pidResolve=e})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(e=>(this.terminateRequested=!0,h(e,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),e=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(e=>{if(!this.shell||!v.isWindows)return e(!1);const n=C.spawn(w(),["/s","/c"]);n.on("error",t=>e(!0)),n.on("exit",t=>e(!1))})}}i.AbstractProcess=l,l.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},l.regexp=/^[^"].* .*[^"]/;class f extends l{constructor(e,n,t,r){super(e,n,t,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(e,n,t,r,o){[r,o].forEach((u,m)=>{const p=new L.LineDecoder;p.write(u).forEach(V=>{n({line:V,source:m===0?0:1})});const A=p.end();A&&n({line:A,source:m===0?0:1})}),e({terminated:this.terminateRequested,error:t})}handleSpawn(e,n,t,r,o){const u=new L.LineDecoder,m=new L.LineDecoder;e.stdout.on("data",p=>{u.write(p).forEach(A=>t({line:A,source:0}))}),e.stderr.on("data",p=>{m.write(p).forEach(A=>t({line:A,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=m}handleClose(e,n,t,r){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&t({line:o,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&t({line:u,source:1})}}i.LineProcess=f;function y(s){let e=[],n=!1;const t=function(r){if(n){e.push(r);return}(!s.send(r,u=>{if(u&&console.error(u),n=!1,e.length>0){const m=e.slice(0);e=[],m.forEach(p=>t(p))}})||v.isWindows)&&(n=!0)};return{send:t}}i.createQueuedSender=y;var c;(function(s){async function e(n,t,r){if(T.isAbsolute(n))return n;if(t===void 0&&(t=a.cwd()),T.dirname(n)!=="."||(r===void 0&&D.isString(a.env.PATH)&&(r=a.env.PATH.split(T.delimiter)),r===void 0||r.length===0))return T.join(t,n);async function u(m){if(await g.Promises.exists(m)){let p;try{p=await g.Promises.stat(m)}catch(S){S.message.startsWith("EACCES")&&(p=await g.Promises.lstat(m))}return p?!p.isDirectory():!1}return!1}for(let m of r){let p;if(T.isAbsolute(m)?p=T.join(m,n):p=T.join(t,m,n),await u(p))return p;let S=p+".com";if(await u(S)||(S=p+".exe",await u(S)))return S}return T.join(t,n)}s.findExecutable=e})(c=i.win32||(i.win32={}))}),define(ee[78],te([0,1,34,8,70,54]),function(B,i,C,I,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSystemShellSync=i.getSystemShell=void 0;async function T(E,b){return E===1?I.isWindows?L():R.getWindowsShell(b):d(E,b)}i.getSystemShell=T;function v(E,b){return E===1?I.isWindows?g(b):R.getWindowsShell(b):d(E,b)}i.getSystemShellSync=v;let a=null;function d(E,b){if(I.isLinux&&E===2||I.isMacintosh&&E===3)return"/bin/bash";if(!a){let h;if(I.isWindows)h="/bin/bash";else{if(h=b.SHELL,!h)try{h=(0,C.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}a=h}return a}let D=null;async function L(){return D||(D=(await(0,P.getFirstAvailablePowerShellInstallation)()).exePath),D}function g(E){if(D)return D;const b=I.isWindows&&parseFloat((0,C.release)())>=10,h=E.hasOwnProperty("PROCESSOR_ARCHITEW6432"),w=`${E.windir}\\${h?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return b?w:R.getWindowsShell(E)}}),define(ee[79],te([0,1,41,4,16,24,67,9,3,2,21,54,48,53]),function(B,i,C,I,P,R,T,v,a,d,D,L,g,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Client=i.Server=void 0;class b extends E.ChannelServer{constructor(l){super({send:f=>{try{process.send&&process.send(f.buffer.toString("base64"))}catch{}},onMessage:a.Event.fromNodeEventEmitter(process,"message",f=>P.VSBuffer.wrap(Buffer.from(f,"base64")))},l);process.once("disconnect",()=>this.dispose())}}i.Server=b;class h{constructor(l,f){this.modulePath=l,this.options=f,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new a.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const y=f&&f.timeout?f.timeout:6e4;this.disposeDelayer=new I.Delayer(y),this.child=null,this._client=null}getChannel(l){const f=this;return{call(y,c,s){return f.requestPromise(l,y,c,s)},listen(y,c){return f.requestEvent(l,y,c)}}}requestPromise(l,f,y,c=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(v.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(l),e=(0,I.createCancelablePromise)(r=>s.call(f,y,r)),n=c.onCancellationRequested(()=>e.cancel()),t=(0,d.toDisposable)(()=>e.cancel());return this.activeRequests.add(t),e.finally(()=>{n.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(l,f,y){if(!this.disposeDelayer)return a.Event.None;this.disposeDelayer.cancel();let c;const s=new a.Emitter({onFirstListenerAdd:()=>{c=this.getCachedChannel(l).listen(f,y)(s.fire,s),this.activeRequests.add(c)},onLastListenerRemove:()=>{this.activeRequests.delete(c),c.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const l=this.options&&this.options.args?this.options.args:[],f=Object.create(null);f.env={...(0,D.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(f.env={...f.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(f.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,g.removeDangerousEnvVariables)(f.env),this.child=(0,C.fork)(this.modulePath,l,f);const y=new a.Emitter;a.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,T.isRemoteConsoleLog)(o)){(0,T.log)(o,`IPC Library: ${this.options.serverName}`);return}y.fire(P.VSBuffer.wrap(Buffer.from(o,"base64")))});const s=this.options.useQueue?(0,L.createQueuedSender)(this.child):this.child,e=o=>this.child&&this.child.connected&&s.send(o.buffer.toString("base64")),n=y.event,t={send:e,onMessage:n};this._client=new E.ChannelClient(t);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,u)=>{process.removeListener("exit",r),this.activeRequests.forEach(m=>(0,d.dispose)(m)),this.activeRequests.clear(),o!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+u),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:u})})}return this._client}getCachedChannel(l){let f=this.channels.get(l);return f||(f=this.client.getChannel(l),this.channels.set(l,f)),f}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}i.Client=h}),define(ee[80],te([5,6]),function(B,i){return B.create("vs/base/node/zip",i)}),define(ee[81],te([5,6]),function(B,i){return B.create("vs/platform/configuration/common/configurationRegistry",i)}),define(ee[82],te([5,6]),function(B,i){return B.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",i)}),define(ee[83],te([5,6]),function(B,i){return B.create("vs/platform/extensionManagement/common/extensionManagement",i)}),define(ee[84],te([5,6]),function(B,i){return B.create("vs/platform/extensionManagement/common/extensionManagementCLIService",i)}),define(ee[85],te([5,6]),function(B,i){return B.create("vs/platform/extensionManagement/common/extensionsScannerService",i)}),define(ee[86],te([5,6]),function(B,i){return B.create("vs/platform/extensionManagement/node/extensionManagementService",i)}),define(ee[87],te([5,6]),function(B,i){return B.create("vs/platform/extensionManagement/node/extensionManagementUtil",i)}),define(ee[88],te([5,6]),function(B,i){return B.create("vs/platform/extensions/common/extensionValidator",i)}),define(ee[89],te([5,6]),function(B,i){return B.create("vs/platform/files/common/fileService",i)}),define(ee[90],te([5,6]),function(B,i){return B.create("vs/platform/files/common/io",i)}),define(ee[91],te([5,6]),function(B,i){return B.create("vs/platform/files/node/diskFileSystemProvider",i)}),define(ee[92],te([5,6]),function(B,i){return B.create("vs/platform/languagePacks/common/languagePacks",i)}),define(ee[93],te([5,6]),function(B,i){return B.create("vs/platform/request/common/request",i)}),define(ee[94],te([5,6]),function(B,i){return B.create("vs/platform/shell/node/shellEnv",i)}),define(ee[95],te([5,6]),function(B,i){return B.create("vs/platform/telemetry/common/telemetryService",i)}),define(ee[96],te([0,1,73,46,14,13,29,18,10]),function(B,i,C,I,P,R,T,v,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.parsePtyHostPort=i.parseSearchPort=i.parseExtensionHostPort=i.AbstractNativeEnvironmentService=void 0;class d{constructor(h,w,l){this._args=h,this.paths=w,this.productService=l}get appRoot(){return(0,R.dirname)(P.FileAccess.asFileUri("",B).fsPath)}get userHome(){return a.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return a.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return a.URI.file(this.paths.tmpDir)}get cacheHome(){return a.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,v.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,v.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return a.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,v.joinPath)(a.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return(0,v.joinPath)(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return(0,v.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,v.joinPath)(this.appSettingsHome,"History")}get keybindingsResource(){return(0,v.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,v.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=T.env.VSCODE_PORTABLE;return h?a.URI.file((0,R.join)(h,"argv.json")):(0,v.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,v.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return a.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,R.resolve)(h):(0,R.normalize)((0,R.join)(P.FileAccess.asFileUri("",B).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?(0,R.resolve)(h):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,R.resolve)(h);const w=T.env.VSCODE_EXTENSIONS;if(w)return w;const l=T.env.VSCODE_PORTABLE;return l?(0,R.join)(l,"extensions"):(0,v.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(w=>/^[^:/?#]+?:\/\//.test(w)?a.URI.parse(w):a.URI.file((0,R.normalize)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?a.URI.parse(h):a.URI.file((0,R.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return D(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,v.joinPath)(a.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return a.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=T.env.VSCODE_PORTABLE;return h?a.URI.file((0,R.join)(h,"policy.json")):(0,v.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}de([I.memoize],d.prototype,"appRoot",null),de([I.memoize],d.prototype,"userHome",null),de([I.memoize],d.prototype,"userDataPath",null),de([I.memoize],d.prototype,"appSettingsHome",null),de([I.memoize],d.prototype,"tmpDir",null),de([I.memoize],d.prototype,"cacheHome",null),de([I.memoize],d.prototype,"userRoamingDataHome",null),de([I.memoize],d.prototype,"settingsResource",null),de([I.memoize],d.prototype,"userDataSyncHome",null),de([I.memoize],d.prototype,"userDataSyncLogResource",null),de([I.memoize],d.prototype,"sync",null),de([I.memoize],d.prototype,"machineSettingsResource",null),de([I.memoize],d.prototype,"globalStorageHome",null),de([I.memoize],d.prototype,"workspaceStorageHome",null),de([I.memoize],d.prototype,"localHistoryHome",null),de([I.memoize],d.prototype,"keybindingsResource",null),de([I.memoize],d.prototype,"keyboardLayoutResource",null),de([I.memoize],d.prototype,"argvResource",null),de([I.memoize],d.prototype,"snippetsHome",null),de([I.memoize],d.prototype,"isExtensionDevelopment",null),de([I.memoize],d.prototype,"untitledWorkspacesHome",null),de([I.memoize],d.prototype,"installSourcePath",null),de([I.memoize],d.prototype,"builtinExtensionsPath",null),de([I.memoize],d.prototype,"extensionsPath",null),de([I.memoize],d.prototype,"extensionDevelopmentLocationURI",null),de([I.memoize],d.prototype,"extensionDevelopmentKind",null),de([I.memoize],d.prototype,"extensionTestsLocationURI",null),de([I.memoize],d.prototype,"debugExtensionHost",null),de([I.memoize],d.prototype,"serviceMachineIdResource",null),de([I.memoize],d.prototype,"telemetryLogResource",null),de([I.memoize],d.prototype,"disableWorkspaceTrust",null),de([I.memoize],d.prototype,"policyFile",null),i.AbstractNativeEnvironmentService=d;function D(b,h){return E(b["inspect-extensions"],b["inspect-brk-extensions"],5870,h,b.debugId,b.extensionEnvironment)}i.parseExtensionHostPort=D;function L(b,h){return E(b["inspect-search"],b["inspect-brk-search"],5876,h,b.extensionEnvironment)}i.parseSearchPort=L;function g(b,h){return E(b["inspect-ptyhost"],b["inspect-brk-ptyhost"],5877,h,b.extensionEnvironment)}i.parsePtyHostPort=g;function E(b,h,w,l,f,y){const s=Number(h||b)||(l?null:w),e=s?Boolean(!!h):!1;let n;if(y)try{n=JSON.parse(y)}catch{}return{port:s,break:e,debugId:f,env:n}}}),function(){"use strict";function B(i,C,I,P){function R(v){const a=T(v),d=[a];return i.isAbsolute(a)||d.unshift(P),i.resolve(...d)}function T(v){const a=process.env.VSCODE_PORTABLE;if(a)return i.join(a,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return i.join(d,I);const D=v["user-data-dir"];if(D)return D;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const L=process.env.USERPROFILE;if(typeof L!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=i.join(L,"AppData","Roaming")}break;case"darwin":d=i.join(C.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||i.join(C.homedir(),".config");break;default:throw new Error("Platform not supported")}return i.join(d,I)}return{getUserDataPath:R}}if(typeof define=="function")define(ee[97],te([0,143,34,14,18,29]),function(i,C,I,P,R,T){const v=R.dirname(P.FileAccess.asFileUri("",i)),a=i.__$__nodeRequire(R.joinPath(v,"package.json").fsPath);return B(C,I,a.name,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const i=require("../../../../../package.json"),C=require("path"),I=require("os");module.exports=B(C,I,i.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[98],te([0,1,34,96,97]),function(B,i,C,I,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeEnvironmentService=void 0;class R extends I.AbstractNativeEnvironmentService{constructor(v,a){super(v,{homeDir:(0,C.homedir)(),tmpDir:(0,C.tmpdir)(),userDataDir:(0,P.getUserDataPath)(v)},a)}}i.NativeEnvironmentService=R}),define(ee[42],te([0,1,18,50,88,35]),function(B,i,C,I,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isEngineValid=i.isValidExtensionVersion=i.validateExtensionManifest=i.isValidVersion=i.normalizeVersion=i.parseVersion=i.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,v=/^-(\d{4})(\d{2})(\d{2})$/;function a(l){return l=l.trim(),l==="*"||T.test(l)}i.isValidVersionStr=a;function d(l){if(!a(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=l.match(T);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}i.parseVersion=d;function D(l){if(!l)return null;let f=l.majorBase,y=l.majorMustEqual,c=l.minorBase,s=l.minorMustEqual,e=l.patchBase,n=l.patchMustEqual;l.hasCaret&&(f===0||(s=!1),n=!1);let t=0;if(l.preRelease){const r=v.exec(l.preRelease);if(r){const[,o,u,m]=r;t=Date.UTC(Number(o),Number(u)-1,Number(m))}}return{majorBase:f,majorMustEqual:y,minorBase:c,minorMustEqual:s,patchBase:e,patchMustEqual:n,isMinimum:l.hasGreaterEquals,notBefore:t}}i.normalizeVersion=D;function L(l,f,y){let c;typeof l=="string"?c=D(d(l)):c=l;let s;f instanceof Date?s=f.getTime():typeof f=="string"&&(s=new Date(f).getTime());let e;if(typeof y=="string"?e=D(d(y)):e=y,!c||!e)return!1;let n=c.majorBase,t=c.minorBase,r=c.patchBase,o=e.majorBase,u=e.minorBase,m=e.patchBase,p=e.notBefore,S=e.majorMustEqual,A=e.minorMustEqual,V=e.patchMustEqual;return e.isMinimum?n>o?!0:n<o?!1:t>u?!0:t<u||s&&s<p?!1:r>=m:(n===1&&o===0&&(!S||!A||!V)&&(o=1,u=0,m=0,S=!0,A=!1,V=!1),n<o?!1:n>o?!S:t<u?!1:t>u?!A:r<m?!1:r>m?!V:!(s&&s<p))}i.isValidVersion=L;function g(l,f,y,c,s){const e=[];if(typeof c.publisher!="undefined"&&typeof c.publisher!="string")return e.push([I.default.Error,P.localize(0,null)]),e;if(typeof c.name!="string")return e.push([I.default.Error,P.localize(1,null,"name")]),e;if(typeof c.version!="string")return e.push([I.default.Error,P.localize(2,null,"version")]),e;if(!c.engines)return e.push([I.default.Error,P.localize(3,null,"engines")]),e;if(typeof c.engines.vscode!="string")return e.push([I.default.Error,P.localize(4,null,"engines.vscode")]),e;if(typeof c.extensionDependencies!="undefined"&&!w(c.extensionDependencies))return e.push([I.default.Error,P.localize(5,null,"extensionDependencies")]),e;if(typeof c.activationEvents!="undefined"){if(!w(c.activationEvents))return e.push([I.default.Error,P.localize(6,null,"activationEvents")]),e;if(typeof c.main=="undefined"&&typeof c.browser=="undefined")return e.push([I.default.Error,P.localize(7,null,"activationEvents","main")]),e}if(typeof c.extensionKind!="undefined"&&typeof c.main=="undefined"&&e.push([I.default.Warning,P.localize(8,null,"extensionKind")]),typeof c.main!="undefined"){if(typeof c.main!="string")return e.push([I.default.Error,P.localize(9,null,"main")]),e;{const r=(0,C.joinPath)(y,c.main);(0,C.isEqualOrParent)(r,y)||e.push([I.default.Warning,P.localize(10,null,r.path,y.path)])}if(typeof c.activationEvents=="undefined")return e.push([I.default.Error,P.localize(11,null,"activationEvents","main")]),e}if(typeof c.browser!="undefined"){if(typeof c.browser!="string")return e.push([I.default.Error,P.localize(12,null,"browser")]),e;{const r=(0,C.joinPath)(y,c.browser);(0,C.isEqualOrParent)(r,y)||e.push([I.default.Warning,P.localize(13,null,r.path,y.path)])}if(typeof c.activationEvents=="undefined")return e.push([I.default.Error,P.localize(14,null,"activationEvents","browser")]),e}if(!R.valid(c.version))return e.push([I.default.Error,P.localize(15,null)]),e;const n=[];if(!E(l,f,c,s,n))for(const r of n)e.push([I.default.Error,r]);return e}i.validateExtensionManifest=g;function E(l,f,y,c,s){return c||typeof y.main=="undefined"&&typeof y.browser=="undefined"?!0:h(l,f,y.engines.vscode,s)}i.isValidExtensionVersion=E;function b(l,f,y){return l==="*"||h(f,y,l)}i.isEngineValid=b;function h(l,f,y,c=[]){let s=D(d(y));if(!s)return c.push(P.localize(16,null,y)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return c.push(P.localize(17,null,y)),!1}else if(!s.majorMustEqual)return c.push(P.localize(18,null,y)),!1;return L(l,f,s)?!0:(c.push(P.localize(19,null,l,y)),!1)}function w(l){if(!Array.isArray(l))return!1;for(let f=0,y=l.length;f<y;f++)if(typeof l[f]!="string")return!1;return!0}}),define(ee[99],te([0,1,16,32]),function(B,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getServiceMachineId=void 0;async function P(R,T,v){let a=v&&v.get("storage.serviceMachineId",0)||null;if(a)return a;try{const D=(await T.readFile(R.serviceMachineIdResource)).value.toString();a=(0,I.isUUID)(D)?D:null}catch{a=null}if(!a){a=(0,I.generateUuid)();try{await T.writeFile(R.serviceMachineIdResource,C.VSBuffer.fromString(a))}catch{}}return v&&v.store("storage.serviceMachineId",a,0,1),a}i.getServiceMachineId=P}),define(ee[43],te([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SyncDescriptor=void 0;class C{constructor(P,R=[],T=!1){this.ctor=P,this.staticArguments=R,this.supportsDelayedInstantiation=T}}i.SyncDescriptor=C}),define(ee[100],te([0,1,43]),function(B,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSingletonServiceDescriptors=i.registerSingleton=void 0;const I=[];function P(T,v,a){v instanceof C.SyncDescriptor||(v=new C.SyncDescriptor(v,[],a)),I.push([T,v])}i.registerSingleton=P;function R(){return I}i.getSingletonServiceDescriptors=R}),define(ee[101],te([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Graph=i.Node=void 0;class C{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}i.Node=C;class I{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(let T of this._nodes.values())T.outgoing.size===0&&R.push(T);return R}insertEdge(R,T){const v=this.lookupOrInsertNode(R),a=this.lookupOrInsertNode(T);v.outgoing.set(this._hashFn(T),a),a.incoming.set(this._hashFn(R),v)}removeNode(R){const T=this._hashFn(R);this._nodes.delete(T);for(let v of this._nodes.values())v.outgoing.delete(T),v.incoming.delete(T)}lookupOrInsertNode(R){const T=this._hashFn(R);let v=this._nodes.get(T);return v||(v=new C(R),this._nodes.set(T,v)),v}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){let R=[];for(let[T,v]of this._nodes)R.push(`${T}, (incoming)[${[...v.incoming.keys()].join(", ")}], (outgoing)[${[...v.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(let[R,T]of this._nodes){const v=new Set([R]),a=this._findCycle(T,v);if(a)return a}}_findCycle(R,T){for(let[v,a]of R.outgoing){if(T.has(v))return[...T,v].join(" -> ");T.add(v);const d=this._findCycle(a,T);if(d)return d;T.delete(v)}}}i.Graph=I}),define(ee[22],te([0,1,7,10,12]),function(B,i,C,I,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getLanguageTagSettingPlainKey=i.getMigratedSettingValue=i.merge=i.getConfigurationValue=i.removeFromValueTree=i.addToValueTree=i.toValuesTree=i.ConfigurationTargetToString=i.ConfigurationTarget=i.isConfigurationUpdateOverrides=i.isConfigurationOverrides=i.IConfigurationService=void 0,i.IConfigurationService=(0,P.createDecorator)("configurationService");function R(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof I.URI)}i.isConfigurationOverrides=R;function T(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||C.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof I.URI)}i.isConfigurationUpdateOverrides=T;var v;(function(l){l[l.USER=1]="USER",l[l.USER_LOCAL=2]="USER_LOCAL",l[l.USER_REMOTE=3]="USER_REMOTE",l[l.WORKSPACE=4]="WORKSPACE",l[l.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",l[l.DEFAULT=6]="DEFAULT",l[l.MEMORY=7]="MEMORY"})(v=i.ConfigurationTarget||(i.ConfigurationTarget={}));function a(l){switch(l){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}i.ConfigurationTargetToString=a;function d(l,f){const y=Object.create(null);for(let c in l)D(y,c,l[c],f);return y}i.toValuesTree=d;function D(l,f,y,c){const s=f.split("."),e=s.pop();let n=l;for(let t=0;t<s.length;t++){let r=s[t],o=n[r];switch(typeof o){case"undefined":o=n[r]=Object.create(null);break;case"object":break;default:c(`Ignoring ${f} as ${s.slice(0,t+1).join(".")} is ${JSON.stringify(o)}`);return}n=o}if(typeof n=="object"&&n!==null)try{n[e]=y}catch{c(`Ignoring ${f} as ${s.join(".")} is ${JSON.stringify(n)}`)}else c(`Ignoring ${f} as ${s.join(".")} is ${JSON.stringify(n)}`)}i.addToValueTree=D;function L(l,f){const y=f.split(".");g(l,y)}i.removeFromValueTree=L;function g(l,f){const y=f.shift();if(f.length===0){delete l[y];return}if(Object.keys(l).indexOf(y)!==-1){const c=l[y];typeof c=="object"&&!Array.isArray(c)&&(g(c,f),Object.keys(c).length===0&&delete l[y])}}function E(l,f,y){function c(n,t){let r=n;for(const o of t){if(typeof r!="object"||r===null)return;r=r[o]}return r}const s=f.split("."),e=c(l,s);return typeof e=="undefined"?y:e}i.getConfigurationValue=E;function b(l,f,y){Object.keys(f).forEach(c=>{c!=="__proto__"&&(c in l?C.isObject(l[c])&&C.isObject(f[c])?b(l[c],f[c],y):y&&(l[c]=f[c]):l[c]=f[c])})}i.merge=b;function h(l,f,y){const c=l.inspect(f),s=l.inspect(y);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:c.defaultValue}i.getMigratedSettingValue=h;function w(l){return l.replace(/[\[\]]/g,"")}i.getLanguageTagSettingPlainKey=w}),define(ee[55],te([0,1,12]),function(B,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IDownloadService=void 0,i.IDownloadService=(0,C.createDecorator)("downloadService")}),define(ee[20],te([0,1,12]),function(B,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.INativeEnvironmentService=i.IEnvironmentService=void 0,i.IEnvironmentService=(0,C.createDecorator)("environmentService"),i.INativeEnvironmentService=(0,C.refineServiceDecorator)(i.IEnvironmentService)}),define(ee[23],te([0,1,83,12]),function(B,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IExtensionManagementCLIService=i.PreferencesLocalizedLabel=i.PreferencesLabel=i.ExtensionsChannelId=i.ExtensionsLocalizedLabel=i.ExtensionsLabel=i.IExtensionTipsService=i.IGlobalExtensionEnablementService=i.ENABLED_EXTENSIONS_STORAGE_PATH=i.DISABLED_EXTENSIONS_STORAGE_PATH=i.IExtensionManagementService=i.ExtensionManagementError=i.ExtensionManagementErrorCode=i.IExtensionGalleryService=i.InstallOperation=i.StatisticType=i.SortOrder=i.SortBy=i.isIExtensionIdentifier=i.getFallbackTargetPlarforms=i.isTargetPlatformCompatible=i.isNotWebExtensionInWebTargetPlatform=i.getTargetPlatform=i.toTargetPlatform=i.TargetPlatformToString=i.WEB_EXTENSION_TAG=i.EXTENSION_IDENTIFIER_REGEX=i.EXTENSION_IDENTIFIER_PATTERN=void 0,i.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",i.EXTENSION_IDENTIFIER_REGEX=new RegExp(i.EXTENSION_IDENTIFIER_PATTERN),i.WEB_EXTENSION_TAG="__web_extension";function P(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}i.TargetPlatformToString=P;function R(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}i.toTargetPlatform=R;function T(l,f){switch(l){case 3:return f==="x64"?"win32-x64":f==="ia32"?"win32-ia32":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}i.getTargetPlatform=T;function v(l,f){return f==="web"&&!l.includes("web")}i.isNotWebExtensionInWebTargetPlatform=v;function a(l,f,y){return v(f,y)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===y?!0:d(y).includes(l)}i.isTargetPlatformCompatible=a;function d(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}i.getFallbackTargetPlarforms=d;function D(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}i.isIExtensionIdentifier=D;var L;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(L=i.SortBy||(i.SortBy={}));var g;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(g=i.SortOrder||(i.SortOrder={}));var E;(function(l){l.Install="install",l.Uninstall="uninstall"})(E=i.StatisticType||(i.StatisticType={}));var b;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(b=i.InstallOperation||(i.InstallOperation={})),i.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService");var h;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal"})(h=i.ExtensionManagementErrorCode||(i.ExtensionManagementErrorCode={}));class w extends Error{constructor(f,y){super(f);this.code=y,this.name=y}}i.ExtensionManagementError=w,i.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),i.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",i.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",i.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),i.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),i.ExtensionsLabel=(0,C.localize)(0,null),i.ExtensionsLocalizedLabel={value:i.ExtensionsLabel,original:"Extensions"},i.ExtensionsChannelId="extensions",i.PreferencesLabel=(0,C.localize)(1,null),i.PreferencesLocalizedLabel={value:i.PreferencesLabel,original:"Preferences"},i.IExtensionManagementCLIService=(0,I.createDecorator)("IExtensionManagementCLIService")}),define(ee[56],te([0,1,16,9,90,15]),function(B,i,C,I,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.readFileIntoStream=void 0;async function T(D,L,g,E,b,h){let w;try{await v(D,L,g,E,b,h)}catch(l){w=l}finally{w&&b.errorTransformer&&(w=b.errorTransformer(w)),typeof w!="undefined"&&g.error(w),g.end()}}i.readFileIntoStream=T;async function v(D,L,g,E,b,h){a(h);const w=await D.open(L,{create:!1});try{a(h);let l=0,f=0,y=b&&typeof b.length=="number"?b.length:void 0,c=C.VSBuffer.alloc(Math.min(b.bufferSize,typeof y=="number"?y:b.bufferSize)),s=b&&typeof b.position=="number"?b.position:0,e=0;do f=await D.read(w,s,c.buffer,e,c.byteLength-e),s+=f,e+=f,l+=f,typeof y=="number"&&(y-=f),e===c.byteLength&&(await g.write(E(c)),c=C.VSBuffer.alloc(Math.min(b.bufferSize,typeof y=="number"?y:b.bufferSize)),e=0);while(f>0&&(typeof y!="number"||y>0)&&a(h)&&d(l,b));if(e>0){let n=e;typeof y=="number"&&(n=Math.min(e,y)),g.write(E(c.slice(0,n)))}}catch(l){throw(0,R.ensureFileSystemProviderError)(l)}finally{await D.close(w)}}function a(D){if(D.isCancellationRequested)throw(0,I.canceled)();return!0}function d(D,L){if(L?.limits){if(typeof L.limits.memory=="number"&&D>L.limits.memory)throw(0,R.createFileSystemProviderError)((0,P.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof L.limits.size=="number"&&D>L.limits.size)throw(0,R.createFileSystemProviderError)((0,P.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[102],te([0,1,3,144,2,8,145]),function(B,i,C,I,P,R,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSWatcher=void 0;class v extends P.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new C.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=C.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(d){const D=this.normalizeRequests(d),L=D.filter(E=>{const b=this.watchers.get(E.path);return b?!(0,I.patternsEquals)(b.request.excludes,E.excludes)||!(0,I.patternsEquals)(b.request.includes,E.includes):!0}),g=Array.from(this.watchers.values()).filter(({request:E})=>!D.find(b=>b.path===E.path&&(0,I.patternsEquals)(b.excludes,E.excludes)&&(0,I.patternsEquals)(b.includes,E.includes))).map(({request:E})=>E.path);L.length&&this.trace(`Request to start watching: ${L.map(E=>`${E.path} (excludes: ${E.excludes.length>0?E.excludes:"<none>"}, includes: ${E.includes&&E.includes.length>0?E.includes:"<all>"})`).join(",")}`),g.length&&this.trace(`Request to stop watching: ${g.join(",")}`);for(const E of g)this.stopWatching(E);for(const E of L)this.startWatching(E)}startWatching(d){const D=new T.NodeJSFileWatcherLibrary(d,g=>this._onDidChangeFile.fire(g),g=>this._onDidLogMessage.fire(g),this.verboseLogging),L={request:d,instance:D};this.watchers.set(d.path,L)}async stop(){for(const[d]of this.watchers)this.stopWatching(d);this.watchers.clear()}stopWatching(d){const D=this.watchers.get(d);D&&(this.watchers.delete(d),D.instance.dispose())}normalizeRequests(d){const D=new Map;for(const L of d){const g=R.isLinux?L.path:L.path.toLowerCase();D.set(g,L)}return Array.from(D.values())}async setVerboseLogging(d){this.verboseLogging=d;for(const[,D]of this.watchers)D.instance.setVerboseLogging(d)}trace(d){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(d)})}toMessage(d,D){return D?`[File Watcher (node.js)] ${d} (path: ${D.request.path})`:`[File Watcher (node.js)] ${d}`}}i.NodeJSWatcher=v}),define(ee[103],te([0,1,57,102]),function(B,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSWatcherClient=void 0;class P extends C.AbstractNonRecursiveWatcherClient{constructor(T,v,a){super(T,v,a);this.init()}createWatcher(){return new I.NodeJSWatcher}}i.NodeJSWatcherClient=P}),define(ee[104],te([0,1,14,53,79,57]),function(B,i,C,I,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UniversalWatcherClient=void 0;class T extends R.AbstractUniversalWatcherClient{constructor(a,d,D){super(a,d,D);this.init()}createWatcher(a){const d=a.add(new P.Client(C.FileAccess.asFileUri("bootstrap-fork",B).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return a.add(d.onDidProcessExit(({code:D,signal:L})=>this.onError(`terminated by itself with code ${D}, signal: ${L}`))),I.ProxyChannel.toService((0,I.getNextTickChannel)(d.getChannel("watcher")))}}i.UniversalWatcherClient=T}),define(ee[58],te([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ServiceCollection=void 0;class C{constructor(...P){this._entries=new Map;for(let[R,T]of P)this.set(R,T)}set(P,R){const T=this._entries.get(P);return this._entries.set(P,R),T}has(P){return this._entries.has(P)}get(P){return this._entries.get(P)}}i.ServiceCollection=C}),define(ee[105],te([0,1,4,9,43,101,12,58]),function(B,i,C,I,P,R,T,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Trace=i.InstantiationService=void 0;const a=!1;class d extends Error{constructor(b){super("cyclic dependency between services");this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class D{constructor(b=new v.ServiceCollection,h=!1,w){this._activeInstantiations=new Set,this._services=b,this._strict=h,this._parent=w,this._services.set(T.IInstantiationService,this)}createChild(b){return new D(b,this._strict,this)}invokeFunction(b,...h){let w=g.traceInvocation(b),l=!1;try{return b({get:y=>{if(l)throw(0,I.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(y,w);if(!c)throw new Error(`[invokeFunction] unknown service '${y}'`);return c}},...h)}finally{l=!0,w.stop()}}createInstance(b,...h){let w,l;return b instanceof P.SyncDescriptor?(w=g.traceCreation(b.ctor),l=this._createInstance(b.ctor,b.staticArguments.concat(h),w)):(w=g.traceCreation(b),l=this._createInstance(b,h,w)),w.stop(),l}_createInstance(b,h=[],w){let l=T._util.getServiceDependencies(b).sort((c,s)=>c.index-s.index),f=[];for(const c of l){let s=this._getOrCreateServiceInstance(c.id,w);s||this._throwIfStrict(`[createInstance] ${b.name} depends on UNKNOWN service ${c.id}.`,!1),f.push(s)}let y=l.length>0?l[0].index:h.length;if(h.length!==y){console.trace(`[createInstance] First service dependency of ${b.name} at position ${y+1} conflicts with ${h.length} static arguments`);let c=y-h.length;c>0?h=h.concat(new Array(c)):h=h.slice(0,y)}return new b(...[...h,...f])}_setServiceInstance(b,h){if(this._services.get(b)instanceof P.SyncDescriptor)this._services.set(b,h);else if(this._parent)this._parent._setServiceInstance(b,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(b){let h=this._services.get(b);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(b):h}_getOrCreateServiceInstance(b,h){let w=this._getServiceInstanceOrDescriptor(b);return w instanceof P.SyncDescriptor?this._safeCreateAndCacheServiceInstance(b,w,h.branch(b,!0)):(h.branch(b,!1),w)}_safeCreateAndCacheServiceInstance(b,h,w){if(this._activeInstantiations.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this._activeInstantiations.add(b);try{return this._createAndCacheServiceInstance(b,h,w)}finally{this._activeInstantiations.delete(b)}}_createAndCacheServiceInstance(b,h,w){const l=new R.Graph(c=>c.id.toString());let f=0;const y=[{id:b,desc:h,_trace:w}];for(;y.length;){const c=y.pop();if(l.lookupOrInsertNode(c),f++>1e3)throw new d(l);for(let s of T._util.getServiceDependencies(c.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(s.id);if(e||this._throwIfStrict(`[createInstance] ${b} depends on ${s.id} which is NOT registered.`,!0),e instanceof P.SyncDescriptor){const n={id:s.id,desc:e,_trace:c._trace.branch(s.id,!0)};l.insertEdge(c,n),y.push(n)}}}for(;;){const c=l.roots();if(c.length===0){if(!l.isEmpty())throw new d(l);break}for(const{data:s}of c){if(this._getServiceInstanceOrDescriptor(s.id)instanceof P.SyncDescriptor){const n=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,n)}l.removeNode(s)}}return this._getServiceInstanceOrDescriptor(b)}_createServiceInstanceWithOwner(b,h,w=[],l,f){if(this._services.get(b)instanceof P.SyncDescriptor)return this._createServiceInstance(h,w,l,f);if(this._parent)return this._parent._createServiceInstanceWithOwner(b,h,w,l,f);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(b,h=[],w,l){if(w){const f=new C.IdleValue(()=>this._createInstance(b,h,l));return new Proxy(Object.create(null),{get(y,c){if(c in y)return y[c];let s=f.value,e=s[c];return typeof e!="function"||(e=e.bind(s),y[c]=e),e},set(y,c,s){return f.value[c]=s,!0}})}else return this._createInstance(b,h,l)}_throwIfStrict(b,h){if(h&&console.warn(h),this._strict)throw new Error(b)}}i.InstantiationService=D;var L;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(L||(L={}));class g{constructor(b,h){this.type=b,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(b){return a?new g(1,b.name||b.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(b){return a?new g(0,b.name):g._None}branch(b,h){let w=new g(2,b.toString());return this._dep.push([b,h,w]),w}stop(){let b=Date.now()-this._start;g._totals+=b;let h=!1;function w(f,y){let c=[],s=new Array(f+1).join("	");for(const[e,n,t]of y._dep)if(n&&t){h=!0,c.push(`${s}CREATES -> ${e}`);let r=w(f+1,t);r&&c.push(r)}else c.push(`${s}uses -> ${e}`);return c.join(`
`)}let l=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(b>2||h)&&console.log(l.join(`
`))}}i.Trace=g,g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0});var ce=this&&this.__param||function(B,i){return function(C,I){i(C,I,B)}};define(ee[59],te([0,1,24,2,8,92,23,12]),function(B,i,C,I,P,R,T,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LanguagePackBaseService=i.ILanguagePackService=void 0,i.ILanguagePackService=(0,v.createDecorator)("languagePackService");let a=class extends I.Disposable{constructor(D){super();this.extensionGalleryService=D}async getAvailableLanguages(){const D=new C.CancellationTokenSource;setTimeout(()=>D.cancel(),1e3);let L;try{L=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},D.token)}catch{return[]}const E=L.firstPage.filter(b=>b.properties.localizedLanguages?.length&&b.tags.some(h=>h.startsWith("lp-"))).map(b=>{const h=b.properties.localizedLanguages?.[0],w=b.tags.find(f=>f.startsWith("lp-")).split("lp-")[1];return{...this.createQuickPickItem({locale:w,label:h}),extensionId:b.identifier.id,galleryExtension:b}});return E.push({...this.createQuickPickItem({locale:"en",label:"English"}),extensionId:"default"}),E}createQuickPickItem(D){const L=D.label??D.locale;let g=D.locale!==D.label?D.locale:void 0;return D.locale.toLowerCase()===P.language.toLowerCase()&&(g||(g=""),g+=(0,R.localize)(0,null)),{id:D.locale,label:L,description:g}}};a=de([ce(0,T.IExtensionGalleryService)],a),i.LanguagePackBaseService=a}),define(ee[11],te([0,1,28,3,2,8,12]),function(B,i,C,I,P,R,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LogLevelToString=i.parseLogLevel=i.getLogLevel=i.NullLogService=i.AbstractLoggerService=i.LogService=i.MultiplexLogService=i.AdapterLogger=i.ConsoleLogger=i.ConsoleMainLogger=i.AbstractMessageLogger=i.AbstractLogger=i.format=i.log=i.DEFAULT_LOG_LEVEL=i.LogLevel=i.ILoggerService=i.ILogService=void 0,i.ILogService=(0,T.createDecorator)("logService"),i.ILoggerService=(0,T.createDecorator)("loggerService");function v(){return new Date().toISOString()}var a;(function(n){n[n.Trace=0]="Trace",n[n.Debug=1]="Debug",n[n.Info=2]="Info",n[n.Warning=3]="Warning",n[n.Error=4]="Error",n[n.Critical=5]="Critical",n[n.Off=6]="Off"})(a=i.LogLevel||(i.LogLevel={})),i.DEFAULT_LOG_LEVEL=a.Info;function d(n,t,r){switch(t){case a.Trace:n.trace(r);break;case a.Debug:n.debug(r);break;case a.Info:n.info(r);break;case a.Warning:n.warn(r);break;case a.Error:n.error(r);break;case a.Critical:n.critical(r);break;default:throw new Error("Invalid log level")}}i.log=d;function D(n){let t="";for(let r=0;r<n.length;r++){let o=n[r];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}t+=(r>0?" ":"")+o}return t}i.format=D;class L extends P.Disposable{constructor(){super(...arguments);this.level=i.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}i.AbstractLogger=L;class g extends L{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(a.Trace)&&this.log(a.Trace,D([t,...r]))}debug(t,...r){this.checkLogLevel(a.Debug)&&this.log(a.Debug,D([t,...r]))}info(t,...r){this.checkLogLevel(a.Info)&&this.log(a.Info,D([t,...r]))}warn(t,...r){this.checkLogLevel(a.Warning)&&this.log(a.Warning,D([t,...r]))}error(t,...r){if(this.checkLogLevel(a.Error))if(t instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=t.stack,this.log(a.Error,D(o))}else this.log(a.Error,D([t,...r]))}critical(t,...r){this.checkLogLevel(a.Critical)&&this.log(a.Critical,D([t,...r]))}flush(){}}i.AbstractMessageLogger=g;class E extends L{constructor(t=i.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!R.isWindows}trace(t,...r){this.getLevel()<=a.Trace&&(this.useColors?console.log(`[90m[main ${v()}][0m`,t,...r):console.log(`[main ${v()}]`,t,...r))}debug(t,...r){this.getLevel()<=a.Debug&&(this.useColors?console.log(`[90m[main ${v()}][0m`,t,...r):console.log(`[main ${v()}]`,t,...r))}info(t,...r){this.getLevel()<=a.Info&&(this.useColors?console.log(`[90m[main ${v()}][0m`,t,...r):console.log(`[main ${v()}]`,t,...r))}warn(t,...r){this.getLevel()<=a.Warning&&(this.useColors?console.warn(`[93m[main ${v()}][0m`,t,...r):console.warn(`[main ${v()}]`,t,...r))}error(t,...r){this.getLevel()<=a.Error&&(this.useColors?console.error(`[91m[main ${v()}][0m`,t,...r):console.error(`[main ${v()}]`,t,...r))}critical(t,...r){this.getLevel()<=a.Critical&&(this.useColors?console.error(`[90m[main ${v()}][0m`,t,...r):console.error(`[main ${v()}]`,t,...r))}dispose(){}flush(){}}i.ConsoleMainLogger=E;class b extends L{constructor(t=i.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=a.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=a.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=a.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=a.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=a.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=a.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}i.ConsoleLogger=b;class h extends L{constructor(t,r=i.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=a.Trace&&this.adapter.log(a.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=a.Debug&&this.adapter.log(a.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=a.Info&&this.adapter.log(a.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=a.Warning&&this.adapter.log(a.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=a.Error&&this.adapter.log(a.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=a.Critical&&this.adapter.log(a.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,C.toErrorMessage)(t,this.getLevel()<=a.Trace)}dispose(){}flush(){}}i.AdapterLogger=h;class w extends L{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const o of this.logServices)o.trace(t,...r)}debug(t,...r){for(const o of this.logServices)o.debug(t,...r)}info(t,...r){for(const o of this.logServices)o.info(t,...r)}warn(t,...r){for(const o of this.logServices)o.warn(t,...r)}error(t,...r){for(const o of this.logServices)o.error(t,...r)}critical(t,...r){for(const o of this.logServices)o.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}i.MultiplexLogService=w;class l extends P.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}i.LogService=l;class f extends P.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(u=>u.setLevel(o))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,r){let o=this.loggers.get(t.toString());return o||(o=this.doCreateLogger(t,r?.always?a.Trace:this.logLevel,r),this.loggers.set(t.toString(),o),r?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}i.AbstractLoggerService=f;class y{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(t){}getLevel(){return a.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}i.NullLogService=y;function c(n){if(n.verbose)return a.Trace;if(typeof n.logLevel=="string"){const t=s(n.logLevel.toLowerCase());if(t!==void 0)return t}return i.DEFAULT_LOG_LEVEL}i.getLogLevel=c;function s(n){switch(n){case"trace":return a.Trace;case"debug":return a.Debug;case"info":return a.Info;case"warn":return a.Warning;case"error":return a.Error;case"critical":return a.Critical;case"off":return a.Off}}i.parseLogLevel=s;function e(n){switch(n){case a.Trace:return"trace";case a.Debug:return"debug";case a.Info:return"info";case a.Warning:return"warn";case a.Error:return"error";case a.Critical:return"critical";case a.Off:return"off"}}i.LogLevelToString=e}),define(ee[106],te([0,1,41,4,28,3,2,14,13,19,20,11]),function(B,i,C,I,P,R,T,v,a,d,D,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsLifecycle=void 0;let g=class extends T.Disposable{constructor(b,h){super();this.environmentService=b,this.logService=h,this.processesLimiter=new I.Limiter(5)}async postUninstall(b){const h=this.parseScript(b,"uninstall");return h&&(this.logService.info(b.identifier.id,b.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(h.script,"uninstall",h.args,!0,b).then(()=>this.logService.info(b.identifier.id,b.manifest.version,"Finished running post uninstall script"),w=>this.logService.error(b.identifier.id,b.manifest.version,`Failed to run post uninstall script: ${w}`)))),d.Promises.rm(this.getExtensionStoragePath(b)).then(void 0,w=>this.logService.error("Error while removing extension storage path",w))}parseScript(b,h){const w=`vscode:${h}`;if(b.location.scheme===v.Schemas.file&&b.manifest&&b.manifest.scripts&&typeof b.manifest.scripts[w]=="string"){const l=b.manifest.scripts[w].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.logService.warn(b.identifier.id,b.manifest.version,`${w} should be a node script`),null):{script:(0,a.join)(b.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}runLifecycleHook(b,h,w,l,f){return new Promise((y,c)=>{const s=this.start(b,h,w,f);let e;const n=t=>{e&&(clearTimeout(e),e=null),t?c(t):y(void 0)};s.on("error",t=>{n((0,P.toErrorMessage)(t)||"Unknown")}),s.on("exit",(t,r)=>{n(t?`post-${h} process exited with code ${t}`:void 0)}),l&&(e=setTimeout(()=>{e=null,s.kill(),c("timed out")},5e3))})}start(b,h,w,l){const f={silent:!0,execArgv:void 0},y=(0,C.fork)(b,[`--type=extension-post-${h}`,...w],f);y.stdout.setEncoding("utf8"),y.stderr.setEncoding("utf8");const c=R.Event.fromNodeEventEmitter(y.stdout,"data"),s=R.Event.fromNodeEventEmitter(y.stderr,"data");c(t=>this.logService.info(l.identifier.id,l.manifest.version,`post-${h}`,t)),s(t=>this.logService.error(l.identifier.id,l.manifest.version,`post-${h}`,t));const e=R.Event.any(R.Event.map(c,t=>({data:`%c${t}`,format:[""]})),R.Event.map(s,t=>({data:`%c${t}`,format:["color: red"]})));return R.Event.debounce(e,(t,r)=>t?{data:t.data+r.data,format:[...t.format,...r.format]}:{data:r.data,format:r.format},100)(t=>{console.group(l.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),y}getExtensionStoragePath(b){return(0,a.join)(this.environmentService.globalStorageHome.fsPath,b.identifier.id.toLowerCase())}};g=de([ce(0,D.IEnvironmentService),ce(1,L.ILogService)],g),i.ExtensionsLifecycle=g}),define(ee[107],te([0,1,17,4,9,3,2,13,57,11]),function(B,i,C,I,P,R,T,v,a,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractDiskFileSystemProvider=void 0;class D extends T.Disposable{constructor(g,E){super();this.logService=g,this.options=E,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new I.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new I.ThrottledDelayer(0))}watch(g,E){return E.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(g,E):this.watchNonRecursive(g,E)}watchUniversal(g,E){const b={path:this.toFilePath(g),excludes:E.excludes,includes:E.includes,recursive:E.recursive},h=(0,C.insert)(this.universalPathsToWatch,b);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{h(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(g=>(0,P.onUnexpectedError)(g))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(E=>this._onDidChangeFile.fire((0,a.toFileChanges)(E)),E=>this.onWatcherLogMessage(E),this.logService.getLevel()===d.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)})));const g=this.options?.watcher?.recursive?.usePolling;if(g===!0)for(const E of this.universalPathsToWatch)(0,a.isRecursiveWatchRequest)(E)&&(E.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const E of this.universalPathsToWatch)(0,a.isRecursiveWatchRequest)(E)&&g.includes(E.path)&&(E.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(g,E){const b={path:this.toFilePath(g),excludes:E.excludes,includes:E.includes,recursive:!1},h=(0,C.insert)(this.nonRecursivePathsToWatch,b);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{h(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(g=>(0,P.onUnexpectedError)(g))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(g=>this._onDidChangeFile.fire((0,a.toFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===d.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(g){g.type==="error"&&this._onDidWatchError.fire(g.message),this.logService[g.type](g.message)}toFilePath(g){return(0,v.normalize)(g.fsPath)}}i.AbstractDiskFileSystemProvider=D}),define(ee[108],te([0,1,17,4,16,24,3,66,60,2,61,14,109,18,40,89,15,56,11]),function(B,i,C,I,P,R,T,v,a,d,D,L,g,E,b,h,w,l,f){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileService=void 0;let y=class extends d.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new I.ResourceQueue)}registerProvider(s,e){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${s}`);const n=new d.DisposableStore;return this.provider.set(s,e),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:e}),n.add(e.onDidChangeFile(t=>this._onDidFilesChange.fire(new w.FileChangesEvent(t,!this.isPathCaseSensitive(e))))),typeof e.onDidWatchError=="function"&&n.add(e.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),n.add(e.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:e,scheme:s}))),(0,d.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:e}),this.provider.delete(s),(0,d.dispose)(n)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const e=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(n){e.push(n)}}),!this.provider.has(s)&&await I.Promises.settled(e)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,e){const n=this.provider.get(s.scheme);return!!(n&&n.capabilities&e)}listCapabilities(){return a.Iterable.map(this.provider,([s,e])=>({scheme:s,capabilities:e.capabilities}))}async withProvider(s){if(!(0,E.isAbsolutePath)(s))throw new w.FileOperationError((0,h.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const e=this.provider.get(s.scheme);if(!e){const n=new Error;throw n.name="ENOPRO",n.message=(0,h.localize)(1,null,s.toString()),n}return e}async withReadProvider(s){const e=await this.withProvider(s);if((0,w.hasOpenReadWriteCloseCapability)(e)||(0,w.hasReadWriteCapability)(e)||(0,w.hasFileReadStreamCapability)(e))return e;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const e=await this.withProvider(s);if((0,w.hasOpenReadWriteCloseCapability)(e)||(0,w.hasReadWriteCapability)(e))return e;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,e){try{return await this.doResolveFile(s,e)}catch(n){throw(0,w.toFileSystemProviderErrorCode)(n)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,h.localize)(2,null,this.resourceForError(s)),1):(0,w.ensureFileSystemProviderError)(n)}}async doResolveFile(s,e){const n=await this.withProvider(s),t=this.isPathCaseSensitive(n),r=e?.resolveTo,o=e?.resolveSingleChildDescendants,u=e?.resolveMetadata,m=await n.stat(s);let p;return this.toFileStat(n,s,m,void 0,!!u,(S,A)=>(p||(p=D.TernarySearchTree.forUris(()=>!t),p.set(s,!0),r&&p.fill(!0,r)),p.get(S.resource)||p.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&o?A===1:!1))}async toFileStat(s,e,n,t,r,o){const{providerExtUri:u}=this.getExtUri(s),m={resource:e,name:u.basename(e),isFile:(n.type&w.FileType.File)!=0,isDirectory:(n.type&w.FileType.Directory)!=0,isSymbolicLink:(n.type&w.FileType.SymbolicLink)!=0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&w.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,w.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(m.isDirectory&&o(m,t)){try{const p=await s.readdir(e),S=await I.Promises.settled(p.map(async([A,V])=>{try{const ie=u.joinPath(e,A),Y=r?await s.stat(ie):{type:V};return await this.toFileStat(s,ie,Y,p.length,r,o)}catch(ie){return this.logService.trace(ie),null}}));m.children=(0,C.coalesce)(S)}catch(p){this.logService.trace(p),m.children=[]}return m}return m}async resolveAll(s){return I.Promises.settled(s.map(async e=>{try{return{stat:await this.doResolveFile(e.resource,e.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async stat(s){const e=await this.withProvider(s),n=await e.stat(s);return this.toFileStat(e,s,n,void 0,!0,()=>!1)}async exists(s){const e=await this.withProvider(s);try{return!!await e.stat(s)}catch{return!1}}async canCreateFile(s,e){try{await this.doValidateCreateFile(s,e)}catch(n){return n}return!0}async doValidateCreateFile(s,e){if(!e?.overwrite&&await this.exists(s))throw new w.FileOperationError((0,h.localize)(3,null,this.resourceForError(s)),3,e)}async createFile(s,e=P.VSBuffer.fromString(""),n){await this.doValidateCreateFile(s,n);const t=await this.writeFile(s,e);return this._onDidRunOperation.fire(new w.FileOperationEvent(s,0,t)),t}async writeFile(s,e,n){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:r}=this.getExtUri(t);try{await this.validateWriteFile(t,s,n)||await this.mkdirp(t,r.dirname(s));let u;if((0,w.hasReadWriteCapability)(t)&&!(e instanceof P.VSBuffer))if((0,b.isReadableStream)(e)){const m=await(0,b.peekStream)(e,3);m.ended?u=P.VSBuffer.concat(m.buffer):u=m}else u=(0,b.peekReadable)(e,m=>P.VSBuffer.concat(m),3);else u=e;!(0,w.hasOpenReadWriteCloseCapability)(t)||(0,w.hasReadWriteCapability)(t)&&u instanceof P.VSBuffer?await this.doWriteUnbuffered(t,s,n,u):await this.doWriteBuffered(t,s,n,u instanceof P.VSBuffer?(0,P.bufferToReadable)(u):u),this._onDidRunOperation.fire(new w.FileOperationEvent(s,4))}catch(o){throw new w.FileOperationError((0,h.localize)(4,null,this.resourceForError(s),(0,w.ensureFileSystemProviderError)(o).toString()),(0,w.toFileOperationResult)(o),n)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,e,n){if(!!n?.unlock&&!(s.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(e)));let r;try{r=await s.stat(e)}catch{return}if((r.type&w.FileType.Directory)!=0)throw new w.FileOperationError((0,h.localize)(6,null,this.resourceForError(e)),0,n);if(this.throwIfFileIsReadonly(e,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==w.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,w.etag)({mtime:n.mtime,size:r.size}))throw new w.FileOperationError((0,h.localize)(7,null),3,n);return r}async readFile(s,e,n){const t=await this.withReadProvider(s);return e?.atomic?this.doReadFileAtomic(t,s,e,n):this.doReadFile(t,s,e,n)}async doReadFileAtomic(s,e,n,t){return new Promise((r,o)=>{this.writeQueue.queueFor(e,this.getExtUri(s).providerExtUri).queue(async()=>{try{const u=await this.doReadFile(s,e,n,t);r(u)}catch(u){o(u)}})})}async doReadFile(s,e,n,t){const r=await this.doReadFileStream(s,e,{...n,preferUnbuffered:!0},t);return{...r,value:await(0,P.streamToBuffer)(r.value)}}async readFileStream(s,e,n){const t=await this.withReadProvider(s);return this.doReadFileStream(t,s,e,n)}async doReadFileStream(s,e,n,t){const r=new R.CancellationTokenSource(t),o=this.validateReadFile(e,n).then(m=>m,m=>{throw r.cancel(),m});let u;try{return typeof n?.etag=="string"&&n.etag!==w.ETAG_DISABLED&&await o,n?.atomic&&(0,w.hasFileAtomicReadCapability)(s)||!((0,w.hasOpenReadWriteCloseCapability)(s)||(0,w.hasFileReadStreamCapability)(s))||(0,w.hasReadWriteCapability)(s)&&n?.preferUnbuffered?u=this.readFileUnbuffered(s,e,n):(0,w.hasFileReadStreamCapability)(s)?u=this.readFileStreamed(s,e,r.token,n):u=this.readFileBuffered(s,e,r.token,n),{...await o,value:u}}catch(m){u&&await(0,b.consumeStream)(u);const p=(0,h.localize)(8,null,this.resourceForError(e),(0,w.ensureFileSystemProviderError)(m).toString());throw m instanceof w.NotModifiedSinceFileOperationError?new w.NotModifiedSinceFileOperationError(p,m.stat,n):new w.FileOperationError(p,(0,w.toFileOperationResult)(m),n)}}readFileStreamed(s,e,n,t=Object.create(null)){const r=s.readFileStream(e,t,n);return(0,b.transform)(r,{data:o=>o instanceof P.VSBuffer?o:P.VSBuffer.wrap(o),error:o=>new w.FileOperationError((0,h.localize)(9,null,this.resourceForError(e),(0,w.ensureFileSystemProviderError)(o).toString()),(0,w.toFileOperationResult)(o),t)},o=>P.VSBuffer.concat(o))}readFileBuffered(s,e,n,t=Object.create(null)){const r=(0,P.newWriteableBufferStream)();return(0,l.readFileIntoStream)(s,e,r,o=>o,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new w.FileOperationError((0,h.localize)(10,null,this.resourceForError(e),(0,w.ensureFileSystemProviderError)(o).toString()),(0,w.toFileOperationResult)(o),t)},n),r}readFileUnbuffered(s,e,n){const t=(0,b.newWriteableStream)(r=>P.VSBuffer.concat(r));return(async()=>{try{let r;n?.atomic&&(0,w.hasFileAtomicReadCapability)(s)?r=await s.readFile(e,{atomic:!0}):r=await s.readFile(e),typeof n?.position=="number"&&(r=r.slice(n.position)),typeof n?.length=="number"&&(r=r.slice(0,n.length)),this.validateReadFileLimits(e,r.byteLength,n),t.end(P.VSBuffer.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async validateReadFile(s,e){const n=await this.resolve(s,{resolveMetadata:!0});if(n.isDirectory)throw new w.FileOperationError((0,h.localize)(11,null,this.resourceForError(s)),0,e);if(typeof e?.etag=="string"&&e.etag!==w.ETAG_DISABLED&&e.etag===n.etag)throw new w.NotModifiedSinceFileOperationError((0,h.localize)(12,null),n,e);return this.validateReadFileLimits(s,n.size,e),n}validateReadFileLimits(s,e,n){if(n?.limits){let t;if(typeof n.limits.memory=="number"&&e>n.limits.memory&&(t=9),typeof n.limits.size=="number"&&e>n.limits.size&&(t=7),typeof t=="number")throw new w.FileOperationError((0,h.localize)(13,null,this.resourceForError(s)),t)}}async canMove(s,e,n){return this.doCanMoveCopy(s,e,"move",n)}async canCopy(s,e,n){return this.doCanMoveCopy(s,e,"copy",n)}async doCanMoveCopy(s,e,n,t){if(s.toString()!==e.toString())try{const r=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e);await this.doValidateMoveCopy(r,s,o,e,n,t)}catch(r){return r}return!0}async move(s,e,n){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e),o=await this.doMoveCopy(t,s,r,e,"move",!!n),u=await this.resolve(e,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(s,o==="move"?2:3,u)),u}async copy(s,e,n){const t=await this.withReadProvider(s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e),o=await this.doMoveCopy(t,s,r,e,"copy",!!n),u=await this.resolve(e,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(s,o==="copy"?3:2,u)),u}async doMoveCopy(s,e,n,t,r,o){if(e.toString()===t.toString())return r;const{exists:u,isSameResourceWithDifferentPathCase:m}=await this.doValidateMoveCopy(s,e,n,t,r,o);if(u&&!m&&o&&await this.del(t,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(t)),r==="copy"){if(s===n&&(0,w.hasFileFolderCopyCapability)(s))await s.copy(e,t,{overwrite:o});else{const p=await this.resolve(e);p.isDirectory?await this.doCopyFolder(s,p,n,t):await this.doCopyFile(s,e,n,t)}return r}else return s===n?(await s.rename(e,t,{overwrite:o}),r):(await this.doMoveCopy(s,e,n,t,"copy",o),await this.del(e,{recursive:!0}),"copy")}async doCopyFile(s,e,n,t){if((0,w.hasOpenReadWriteCloseCapability)(s)&&(0,w.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(s,e,n,t);if((0,w.hasOpenReadWriteCloseCapability)(s)&&(0,w.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(s,e,n,t);if((0,w.hasReadWriteCapability)(s)&&(0,w.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(s,e,n,t);if((0,w.hasReadWriteCapability)(s)&&(0,w.hasReadWriteCapability)(n))return this.doPipeUnbuffered(s,e,n,t)}async doCopyFolder(s,e,n,t){await n.mkdir(t),Array.isArray(e.children)&&await I.Promises.settled(e.children.map(async r=>{const o=this.getExtUri(n).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.doCopyFolder(s,await this.resolve(r.resource),n,o):this.doCopyFile(s,r.resource,n,o)}))}async doValidateMoveCopy(s,e,n,t,r,o){let u=!1;if(s===n){const{providerExtUri:p,isPathCaseSensitive:S}=this.getExtUri(s);if(S||(u=p.isEqual(e,t)),u&&r==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(e),this.resourceForError(t)));if(!u&&p.isEqualOrParent(t,e))throw new Error((0,h.localize)(15,null,this.resourceForError(e),this.resourceForError(t)))}const m=await this.exists(t);if(m&&!u){if(!o)throw new w.FileOperationError((0,h.localize)(16,null,this.resourceForError(e),this.resourceForError(t)),4);if(s===n){const{providerExtUri:p}=this.getExtUri(s);if(p.isEqualOrParent(e,t))throw new Error((0,h.localize)(17,null,this.resourceForError(e),this.resourceForError(t)))}}return{exists:m,isSameResourceWithDifferentPathCase:u}}getExtUri(s){const e=this.isPathCaseSensitive(s);return{providerExtUri:e?E.extUri:E.extUriIgnorePathCase,isPathCaseSensitive:e}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(e,s);const n=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(s,0,n)),n}async mkdirp(s,e){const n=[],{providerExtUri:t}=this.getExtUri(s);for(;!t.isEqual(e,t.dirname(e));)try{if(((await s.stat(e)).type&w.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(e)));break}catch(r){if((0,w.toFileSystemProviderErrorCode)(r)!==w.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(t.basename(e)),e=t.dirname(e)}for(let r=n.length-1;r>=0;r--){e=t.joinPath(e,n[r]);try{await s.mkdir(e)}catch(o){if((0,w.toFileSystemProviderErrorCode)(o)!==w.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,e){try{await this.doValidateDelete(s,e)}catch(n){return n}return!0}async doValidateDelete(s,e){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!e?.useTrash&&!(n.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(s)));let r;try{r=await n.stat(s)}catch{}if(r)this.throwIfFileIsReadonly(s,r);else throw new w.FileOperationError((0,h.localize)(20,null,this.resourceForError(s)),1);if(!!!e?.recursive){const u=await this.resolve(s);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(s)))}return n}async del(s,e){const n=await this.doValidateDelete(s,e),t=!!e?.useTrash,r=!!e?.recursive;await n.delete(s,{recursive:r,useTrash:t}),this._onDidRunOperation.fire(new w.FileOperationEvent(s,1))}async cloneFile(s,e){const n=await this.withProvider(s),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e);if(n===t&&this.getExtUri(n).providerExtUri.isEqual(s,e))return;if(n===t&&(0,w.hasFileCloneCapability)(n))return n.cloneFile(s,e);await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(e));const r=this.writeQueue.queueFor(s,this.getExtUri(n).providerExtUri);return n===t&&(0,w.hasFileFolderCopyCapability)(n)?r.queue(()=>n.copy(s,e,{overwrite:!0})):r.queue(()=>this.doCopyFile(n,s,t,e))}watch(s,e={recursive:!1,excludes:[]}){const n=new d.DisposableStore;let t=!1,r=()=>{t=!0};return n.add((0,d.toDisposable)(()=>r())),(async()=>{try{const o=await this.doWatch(s,e);t?(0,d.dispose)(o):r=()=>(0,d.dispose)(o)}catch(o){this.logService.error(o)}})(),n}async doWatch(s,e){const n=await this.withProvider(s),t=(0,v.hash)([this.getExtUri(n).providerExtUri.getComparisonKey(s),e]);let r=this.activeWatchers.get(t);return r||(r={count:0,disposable:n.watch(s,e)},this.activeWatchers.set(t,r)),r.count+=1,(0,d.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,d.dispose)(r.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,d.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,e,n,t){return this.writeQueue.queueFor(e,this.getExtUri(s).providerExtUri).queue(async()=>{const r=await s.open(e,{create:!0,unlock:n?.unlock??!1});try{(0,b.isReadableStream)(t)||(0,b.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(s,r,t):await this.doWriteReadableBufferedQueued(s,r,t)}catch(o){throw(0,w.ensureFileSystemProviderError)(o)}finally{await s.close(r)}})}async doWriteStreamBufferedQueued(s,e,n){let t=0,r;if((0,b.isReadableBufferedStream)(n)){if(n.buffer.length>0){const o=P.VSBuffer.concat(n.buffer);await this.doWriteBuffer(s,e,o,o.byteLength,t,0),t+=o.byteLength}if(n.ended)return;r=n.stream}else r=n;return new Promise((o,u)=>{(0,b.listenStream)(r,{onData:async m=>{r.pause();try{await this.doWriteBuffer(s,e,m,m.byteLength,t,0)}catch(p){return u(p)}t+=m.byteLength,setTimeout(()=>r.resume())},onError:m=>u(m),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(s,e,n){let t=0,r;for(;(r=n.read())!==null;)await this.doWriteBuffer(s,e,r,r.byteLength,t,0),t+=r.byteLength}async doWriteBuffer(s,e,n,t,r,o){let u=0;for(;u<t;)u+=await s.write(e,r+u,n.buffer,o+u,t-u)}async doWriteUnbuffered(s,e,n,t){return this.writeQueue.queueFor(e,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,e,n,t))}async doWriteUnbufferedQueued(s,e,n,t){let r;t instanceof P.VSBuffer?r=t:(0,b.isReadableStream)(t)?r=await(0,P.streamToBuffer)(t):(0,b.isReadableBufferedStream)(t)?r=await(0,P.bufferedStreamToBuffer)(t):r=(0,P.readableToBuffer)(t),await s.writeFile(e,r.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(s,e,n,t){return this.writeQueue.queueFor(t,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,e,n,t))}async doPipeBufferedQueued(s,e,n,t){let r,o;try{r=await s.open(e,{create:!1}),o=await n.open(t,{create:!0,unlock:!1});const u=P.VSBuffer.alloc(this.BUFFER_SIZE);let m=0,p=0,S=0;do S=await s.read(r,m,u.buffer,p,u.byteLength-p),await this.doWriteBuffer(n,o,u,S,m,p),m+=S,p+=S,p===u.byteLength&&(p=0);while(S>0)}catch(u){throw(0,w.ensureFileSystemProviderError)(u)}finally{await I.Promises.settled([typeof r=="number"?s.close(r):Promise.resolve(),typeof o=="number"?n.close(o):Promise.resolve()])}}async doPipeUnbuffered(s,e,n,t){return this.writeQueue.queueFor(t,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,e,n,t))}async doPipeUnbufferedQueued(s,e,n,t){return n.writeFile(t,await s.readFile(e),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,e,n,t){return this.writeQueue.queueFor(t,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,e,n,t))}async doPipeUnbufferedToBufferedQueued(s,e,n,t){const r=await n.open(t,{create:!0,unlock:!1});try{const o=await s.readFile(e);await this.doWriteBuffer(n,r,P.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,w.ensureFileSystemProviderError)(o)}finally{await n.close(r)}}async doPipeBufferedToUnbuffered(s,e,n,t){const r=await(0,P.streamToBuffer)(this.readFileBuffered(s,e,R.CancellationToken.None));await this.doWriteUnbuffered(n,t,void 0,r)}throwIfFileSystemIsReadonly(s,e){if(s.capabilities&2048)throw new w.FileOperationError((0,h.localize)(22,null,this.resourceForError(e)),6);return s}throwIfFileIsReadonly(s,e){if((e.permissions??0)&w.FilePermission.Readonly)throw new w.FileOperationError((0,h.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===L.Schemas.file?s.fsPath:s.toString(!0)}};y=de([ce(0,f.ILogService)],y),i.FileService=y}),define(ee[110],te([0,1,111,146,4,61,16,3,52,2,13,8,18,40,19,91,15,56,107,28,104,103]),function(B,i,C,I,P,R,T,v,a,d,D,L,g,E,b,h,w,l,f,y,c,s){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DiskFileSystemProvider=void 0,(()=>{try{(0,I.gracefulify)(C)}catch(n){console.error(`Error enabling graceful-fs: ${(0,y.toErrorMessage)(n)}`)}})();class e extends f.AbstractDiskFileSystemProvider{constructor(t,r){super(t,r);this.onDidChangeCapabilities=v.Event.None,this.resourceLocks=new R.ResourceMap(o=>g.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,L.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:r,symbolicLink:o}=await b.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(r,o),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(t){try{const r=await b.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),o=[];return await Promise.all(r.map(async u=>{try{let m;u.isSymbolicLink()?m=(await this.stat((0,g.joinPath)(t,u.name))).type:m=this.toType(u),o.push([u.name,m])}catch(m){this.logService.trace(m)}})),o}catch(r){throw this.toFileSystemProviderError(r)}}toType(t,r){let o;return r?.dangling?o=w.FileType.Unknown:t.isFile()?o=w.FileType.File:t.isDirectory()?o=w.FileType.Directory:o=w.FileType.Unknown,r&&(o|=w.FileType.SymbolicLink),o}async createResourceLock(t){const r=this.toFilePath(t);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let o;for(;o=this.resourceLocks.get(t);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await o.wait();const u=new P.Barrier;return this.resourceLocks.set(t,u),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,d.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.resourceLocks.get(t)===u&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.resourceLocks.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),u.open()})}async readFile(t,r){let o;try{r?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),o=await this.createResourceLock(t));const u=this.toFilePath(t);return await b.Promises.readFile(u)}catch(u){throw this.toFileSystemProviderError(u)}finally{o?.dispose()}}readFileStream(t,r,o){const u=(0,E.newWriteableStream)(m=>T.VSBuffer.concat(m.map(p=>T.VSBuffer.wrap(p))).buffer);return(0,l.readFileIntoStream)(this,t,u,m=>m.buffer,{...r,bufferSize:256*1024},o),u}async writeFile(t,r,o){let u;try{const m=this.toFilePath(t);if(!o.create||!o.overwrite){if(await b.Promises.exists(m)){if(!o.overwrite)throw(0,w.createFileSystemProviderError)((0,h.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,w.createFileSystemProviderError)((0,h.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(t,{create:!0,unlock:o.unlock}),await this.write(u,0,r,0,r.byteLength)}catch(m){throw await this.toFileSystemProviderWriteError(t,m)}finally{typeof u=="number"&&await this.close(u)}}async open(t,r){const o=this.toFilePath(t);let u;(0,w.isFileOpenForWriteOptions)(r)&&(u=await this.createResourceLock(t));let m;try{if((0,w.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:S}=await b.SymlinkSupport.stat(o);S.mode&128||await b.Promises.chmod(o,S.mode|128)}catch(S){this.logService.trace(S)}let p;if((0,w.isFileOpenForWriteOptions)(r)){if(L.isWindows)try{await b.Promises.truncate(o,0),p="r+"}catch(S){S.code!=="ENOENT"&&this.logService.trace(S)}p||(p="w")}else p="r";m=await b.Promises.open(o,p)}catch(p){throw u?.dispose(),(0,w.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(t,p):this.toFileSystemProviderError(p)}if(this.mapHandleToPos.set(m,0),(0,w.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(m,t),u){const p=this.mapHandleToLock.get(m);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${m} (${o})`),this.mapHandleToLock.set(m,u),p&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${m} (${o})`),p.dispose())}return m}async close(t){const r=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&this.canFlush)try{await b.Promises.fdatasync(t)}catch(o){this.canFlush=!1,this.logService.error(o)}return await b.Promises.close(t)}catch(o){throw this.toFileSystemProviderError(o)}finally{r&&(this.mapHandleToLock.get(t)===r&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),r.dispose())}}async read(t,r,o,u,m){const p=this.normalizePos(t,r);let S=null;try{S=(await b.Promises.read(t,o,u,m,p)).bytesRead}catch(A){throw this.toFileSystemProviderError(A)}finally{this.updatePos(t,p,S)}return S}normalizePos(t,r){return r===this.mapHandleToPos.get(t)?null:r}updatePos(t,r,o){const u=this.mapHandleToPos.get(t);typeof u=="number"&&(typeof r=="number"||(typeof o=="number"?this.mapHandleToPos.set(t,u+o):this.mapHandleToPos.delete(t)))}async write(t,r,o,u,m){return(0,P.retry)(()=>this.doWrite(t,r,o,u,m),100,3)}async doWrite(t,r,o,u,m){const p=this.normalizePos(t,r);let S=null;try{S=(await b.Promises.write(t,o,u,m,p)).bytesWritten}catch(A){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),A)}finally{this.updatePos(t,p,S)}return S}async mkdir(t){try{await b.Promises.mkdir(this.toFilePath(t))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(t,r){try{const o=this.toFilePath(t);r.recursive?await b.Promises.rm(o,b.RimRafMode.MOVE):await b.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(t,r,o){const u=this.toFilePath(t),m=this.toFilePath(r);if(u!==m)try{await this.validateTargetDeleted(t,r,"move",o.overwrite),await b.Promises.move(u,m)}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,h.localize)(2,null,(0,D.basename)(u),(0,D.basename)((0,D.dirname)(m)),p.toString()))),this.toFileSystemProviderError(p)}}async copy(t,r,o){const u=this.toFilePath(t),m=this.toFilePath(r);if(u!==m)try{await this.validateTargetDeleted(t,r,"copy",o.overwrite),await b.Promises.copy(u,m,{preserveSymlinks:!0})}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,h.localize)(3,null,(0,D.basename)(u),(0,D.basename)((0,D.dirname)(m)),p.toString()))),this.toFileSystemProviderError(p)}}async validateTargetDeleted(t,r,o,u){const m=this.toFilePath(t),p=this.toFilePath(r);let S=!1;if(!!(this.capabilities&1024)||(S=(0,a.isEqual)(m,p,!0)),S&&o==="copy")throw(0,w.createFileSystemProviderError)((0,h.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(!S&&await b.Promises.exists(p)){if(!u)throw(0,w.createFileSystemProviderError)((0,h.localize)(5,null),w.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(t,r){return this.doCloneFile(t,r,!1)}async doCloneFile(t,r,o){const u=this.toFilePath(t),m=this.toFilePath(r),p=!!(this.capabilities&1024);if((0,a.isEqual)(u,m,!p))return;const S=new d.DisposableStore;try{const[A,V]=await Promise.all([this.createResourceLock(t),this.createResourceLock(r)]);S.add(A),S.add(V),o&&await b.Promises.mkdir((0,D.dirname)(m),{recursive:!0}),await b.Promises.copyFile(u,m)}catch(A){if(A.code==="ENOENT"&&!o)return this.doCloneFile(t,r,!0);throw this.toFileSystemProviderError(A)}finally{S.dispose()}}createUniversalWatcher(t,r,o){return new c.UniversalWatcherClient(u=>t(u),u=>r(u),o)}createNonRecursiveWatcher(t,r,o){return new s.NodeJSWatcherClient(u=>t(u),u=>r(u),o)}toFileSystemProviderError(t){if(t instanceof w.FileSystemProviderError)return t;let r;switch(t.code){case"ENOENT":r=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=w.FileSystemProviderErrorCode.NoPermissions;break;default:r=w.FileSystemProviderErrorCode.Unknown}return(0,w.createFileSystemProviderError)(t,r)}async toFileSystemProviderWriteError(t,r){let o=this.toFileSystemProviderError(r);if(t&&o.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await b.SymlinkSupport.stat(this.toFilePath(t));u.mode&128||(o=(0,w.createFileSystemProviderError)(r,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.logService.trace(u)}return o}}i.DiskFileSystemProvider=e}),define(ee[112],te([0,1,15,11]),function(B,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SpdLogLogger=void 0;async function P(v,a,d,D,L){try{const g=await new Promise((b,h)=>{B(["spdlog"],b,h)});g.setFlushOn(I.LogLevel.Trace);const E=await g.createAsyncRotatingLogger(v,a,d,D);return L&&E.clearFormatters(),E}catch(g){console.error(g)}return null}function R(v,a,d){switch(a){case I.LogLevel.Trace:v.trace(d);break;case I.LogLevel.Debug:v.debug(d);break;case I.LogLevel.Info:v.info(d);break;case I.LogLevel.Warning:v.warn(d);break;case I.LogLevel.Error:v.error(d);break;case I.LogLevel.Critical:v.critical(d);break;default:throw new Error("Invalid log level")}}class T extends I.AbstractMessageLogger{constructor(a,d,D,L,g){super();this.buffer=[],this.setLevel(g),this._loggerCreationPromise=this._createSpdLogLogger(a,d,D,L),this._register(this.onDidChangeLogLevel(E=>{this._logger&&this._logger.setLevel(E)}))}async _createSpdLogLogger(a,d,D,L){const g=D?6:1,E=30/g*C.ByteSize.MB,b=await P(a,d,E,g,L);if(b){this._logger=b,this._logger.setLevel(this.getLevel());for(const{level:h,message:w}of this.buffer)R(this._logger,h,w);this.buffer=[]}}log(a,d){this._logger?R(this._logger,a,d):this.getLevel()<=a&&this.buffer.push({level:a,message:d})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}i.SpdLogLogger=T}),define(ee[33],te([0,1,3,60,2,12]),function(B,i,C,I,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NullPolicyService=i.AbstractPolicyService=i.IPolicyService=void 0,i.IPolicyService=(0,R.createDecorator)("policy");class T extends P.Disposable{constructor(){super(...arguments);this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(d){const D=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...d,...this.policyDefinitions},D!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(d),I.Iterable.reduce(this.policies.entries(),(L,[g,E])=>({...L,[g]:E}),{})}getPolicyValue(d){return this.policies.get(d)}serialize(){return I.Iterable.reduce(Object.entries(this.policyDefinitions),(d,[D,L])=>({...d,[D]:{definition:L,value:this.policies.get(D)}}),{})}}i.AbstractPolicyService=T;class v{constructor(){this.onDidChange=C.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}i.NullPolicyService=v}),define(ee[113],te([0,1,4,3,60,7,15,11,33]),function(B,i,C,I,P,R,T,v,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FilePolicyService=void 0;function d(L,g){const E=[];for(const b of P.Iterable.concat(L.keys(),g.keys()))L.get(b)!==g.get(b)&&E.push(b);return E}let D=class extends a.AbstractPolicyService{constructor(g,E,b){super();this.file=g,this.fileService=E,this.logService=b,this.throttledDelayer=this._register(new C.ThrottledDelayer(500));const h=I.Event.filter(E.onDidFilesChange,w=>w.affects(g));this._register(E.watch(g)),this._register(h(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(g){await this.refresh()}async read(){const g=new Map;try{const E=await this.fileService.readFile(this.file),b=JSON.parse(E.value.toString());if(!(0,R.isObject)(b))throw new Error("Policy file isn't a JSON object");for(const h of Object.keys(b))this.policyDefinitions[h]&&g.set(h,b[h])}catch(E){E.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",E)}return g}async refresh(){const g=await this.read(),E=d(this.policies,g);this.policies=g,E.length>0&&this._onDidChange.fire(E)}};D=de([ce(1,T.IFileService),ce(2,v.ILogService)],D),i.FilePolicyService=D}),define(ee[27],te([0,1,12]),function(B,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.productSchemaId=i.IProductService=void 0,i.IProductService=(0,C.createDecorator)("productService"),i.productSchemaId="vscode://schemas/vscode-product"}),define(ee[30],te([0,1,64,7]),function(B,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Registry=void 0;class P{constructor(){this.data=new Map}add(T,v){C.ok(I.isString(T)),C.ok(I.isObject(v)),C.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,v)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}i.Registry=new P}),define(ee[114],te([0,1,3,30]),function(B,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Extensions=void 0,i.Extensions={JSONContribution:"base.contributions.json"};function P(v){return v.length>0&&v.charAt(v.length-1)==="#"?v.substring(0,v.length-1):v}class R{constructor(){this._onDidChangeSchema=new C.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(a,d){this.schemasById[P(a)]=d,this._onDidChangeSchema.fire(a)}notifySchemaChanged(a){this._onDidChangeSchema.fire(a)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new R;I.Registry.add(i.Extensions.JSONContribution,T)}),define(ee[36],te([0,1,17,3,7,81,22,114,30]),function(B,i,C,I,P,R,T,v,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getScopes=i.validateProperty=i.getDefaultValue=i.keyFromOverrideIdentifiers=i.overrideIdentifiersFromKey=i.OVERRIDE_PROPERTY_REGEX=i.OVERRIDE_PROPERTY_PATTERN=i.configurationDefaultsSchemaId=i.resourceLanguageSettingsSchemaId=i.resourceSettings=i.windowSettings=i.machineOverridableSettings=i.machineSettings=i.applicationSettings=i.allSettings=i.ConfigurationScope=i.Extensions=i.EditPresentationTypes=void 0;var d;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(d=i.EditPresentationTypes||(i.EditPresentationTypes={})),i.Extensions={Configuration:"base.contributions.configuration"};var D;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=i.ConfigurationScope||(i.ConfigurationScope={})),i.allSettings={properties:{},patternProperties:{}},i.applicationSettings={properties:{},patternProperties:{}},i.machineSettings={properties:{},patternProperties:{}},i.machineOverridableSettings={properties:{},patternProperties:{}},i.windowSettings={properties:{},patternProperties:{}},i.resourceSettings={properties:{},patternProperties:{}},i.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",i.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const L=a.Registry.as(v.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},L.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(e,n=!0){this.registerConfigurations([e],n)}registerConfigurations(e,n=!0){const t=this.doRegisterConfigurations(e,n);L.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(e){const n=this.doDeregisterConfigurations(e);L.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:e,remove:n}){const t=[];t.push(...this.doDeregisterConfigurations(n)),t.push(...this.doRegisterConfigurations(e,!1)),L.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,C.distinct)(t)})}registerDefaultConfigurations(e){const n=[],t=[];for(const{overrides:r,source:o}of e)for(const u in r)if(n.push(u),i.OVERRIDE_PROPERTY_REGEX.test(u)){const m=this.configurationDefaultsOverrides.get(u),p=m?.valuesSources??new Map;if(o)for(const ie of Object.keys(r[u]))p.set(ie,o);const S={...m?.value||{},...r[u]};this.configurationDefaultsOverrides.set(u,{source:o,value:S,valuesSources:p});const A=(0,T.getLanguageTagSettingPlainKey)(u),V={type:"object",default:S,description:R.localize(1,null,A),$ref:i.resourceLanguageSettingsSchemaId,defaultDefaultValue:S,source:P.isString(o)?void 0:o,defaultValueSource:o};t.push(...h(u)),this.configurationProperties[u]=V,this.defaultLanguageConfigurationOverridesNode.properties[u]=V}else{this.configurationDefaultsOverrides.set(u,{value:r[u],source:o});const m=this.configurationProperties[u];m&&(this.updatePropertyDefaultValue(u,m),this.updateSchema(u,m))}this.registerOverrideIdentifiers(t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(e){const n=[];for(const{overrides:t,source:r}of e)for(const o in t){const u=this.configurationDefaultsOverrides.get(o),m=P.isString(r)?r:r?.id,p=P.isString(u?.source)?u?.source:u?.source?.id;if(m===p)if(n.push(o),this.configurationDefaultsOverrides.delete(o),i.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const S=this.configurationProperties[o];S&&(this.updatePropertyDefaultValue(o,S),this.updateSchema(o,S))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...e){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(e){for(const n of e)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(e,n){const t=[];return e.forEach(r=>{t.push(...this.validateAndRegisterProperties(r,n,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),t}doDeregisterConfigurations(e){const n=[],t=r=>{if(r.properties)for(const o in r.properties){n.push(o);const u=this.configurationProperties[o];u?.policy?.name&&this.policyConfigurations.delete(u.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,r.properties[o])}r.allOf&&r.allOf.forEach(o=>t(o))};for(const r of e){t(r);const o=this.configurationContributors.indexOf(r);o!==-1&&this.configurationContributors.splice(o,1)}return n}validateAndRegisterProperties(e,n=!0,t,r,o=3){o=P.isUndefinedOrNull(e.scope)?o:e.scope;let u=[],m=e.properties;if(m)for(let S in m){const A=m[S];if(n&&y(S,A)){delete m[S];continue}if(A.source=t,A.defaultDefaultValue=m[S].default,this.updatePropertyDefaultValue(S,A),i.OVERRIDE_PROPERTY_REGEX.test(S)?A.scope=void 0:(A.scope=P.isUndefinedOrNull(A.scope)?o:A.scope,A.restricted=P.isUndefinedOrNull(A.restricted)?!!r?.includes(S):A.restricted),m[S].hasOwnProperty("included")&&!m[S].included){this.excludedConfigurationProperties[S]=m[S],delete m[S];continue}else this.configurationProperties[S]=m[S],m[S].policy?.name&&this.policyConfigurations.set(m[S].policy.name,S);!m[S].deprecationMessage&&m[S].markdownDeprecationMessage&&(m[S].deprecationMessage=m[S].markdownDeprecationMessage),u.push(S)}let p=e.allOf;if(p)for(let S of p)u.push(...this.validateAndRegisterProperties(S,n,t,r,o));return u}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(e){const n=t=>{let r=t.properties;if(r)for(const u in r)this.updateSchema(u,r[u]);let o=t.allOf;o&&o.forEach(n)};n(e)}updateSchema(e,n){switch(i.allSettings.properties[e]=n,n.scope){case 1:i.applicationSettings.properties[e]=n;break;case 2:i.machineSettings.properties[e]=n;break;case 6:i.machineOverridableSettings.properties[e]=n;break;case 3:i.windowSettings.properties[e]=n;break;case 4:i.resourceSettings.properties[e]=n;break;case 5:i.resourceSettings.properties[e]=n,this.resourceLanguageSettingsSchema.properties[e]=n;break}}removeFromSchema(e,n){switch(delete i.allSettings.properties[e],n.scope){case 1:delete i.applicationSettings.properties[e];break;case 2:delete i.machineSettings.properties[e];break;case 6:delete i.machineOverridableSettings.properties[e];break;case 3:delete i.windowSettings.properties[e];break;case 4:case 5:delete i.resourceSettings.properties[e],delete this.resourceLanguageSettingsSchema.properties[e];break}}updateOverridePropertyPatternKey(){for(const e of this.overrideIdentifiers.values()){const n=`[${e}]`,t={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:i.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,t),i.allSettings.properties[n]=t,i.applicationSettings.properties[n]=t,i.machineSettings.properties[n]=t,i.machineOverridableSettings.properties[n]=t,i.windowSettings.properties[n]=t,i.resourceSettings.properties[n]=t}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const e={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:i.resourceLanguageSettingsSchemaId};i.allSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.applicationSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.machineSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.machineOverridableSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.windowSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.resourceSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(e,n){const t=this.configurationDefaultsOverrides.get(e);let r=t?.value,o=t?.source;P.isUndefined(r)&&(r=n.defaultDefaultValue,o=void 0),P.isUndefined(r)&&(r=l(n.type)),n.default=r,n.defaultValueSource=o}}const E="\\[([^\\]]+)\\]",b=new RegExp(E,"g");i.OVERRIDE_PROPERTY_PATTERN=`^(${E})+$`,i.OVERRIDE_PROPERTY_REGEX=new RegExp(i.OVERRIDE_PROPERTY_PATTERN);function h(s){const e=[];if(i.OVERRIDE_PROPERTY_REGEX.test(s)){let n=b.exec(s);for(;n?.length;){const t=n[1].trim();t&&e.push(t),n=b.exec(s)}}return(0,C.distinct)(e)}i.overrideIdentifiersFromKey=h;function w(s){return s.reduce((e,n)=>`${e}[${n}]`,"")}i.keyFromOverrideIdentifiers=w;function l(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}i.getDefaultValue=l;const f=new g;a.Registry.add(i.Extensions.Configuration,f);function y(s,e){return s.trim()?i.OVERRIDE_PROPERTY_REGEX.test(s)?R.localize(7,null,s):f.getConfigurationProperties()[s]!==void 0?R.localize(8,null,s):e.policy?.name&&f.getPolicyConfigurations().get(e.policy?.name)!==void 0?R.localize(9,null,s,e.policy?.name,f.getPolicyConfigurations().get(e.policy?.name)):null:R.localize(6,null)}i.validateProperty=y;function c(){const s=[],e=f.getConfigurationProperties();for(const n of Object.keys(e))s.push([n,e[n].scope]);return s.push(["launch",4]),s.push(["task",4]),s}i.getScopes=c}),define(ee[62],te([0,1,17,3,47,2,61,21,7,10,22,36,30]),function(B,i,C,I,P,R,T,v,a,d,D,L,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AllKeysConfigurationChangeEvent=i.ConfigurationChangeEvent=i.mergeChanges=i.Configuration=i.UserSettings=i.ConfigurationModelParser=i.ConfigurationModel=void 0;class E{constructor(n={},t=[],r=[]){this._contents=n,this._keys=t,this._overrides=r,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(n){return n?(0,D.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,t){const r=this.getContentsForOverrideIdentifer(t);return r?n?(0,D.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const r of this.overrides)r.identifiers.includes(n)&&t.push(...r.keys);return C.distinct(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return C.distinct(n)}override(n){let t=this.overrideConfigurations.get(n);return t||(t=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,t)),t}merge(...n){const t=v.deepClone(this.contents),r=v.deepClone(this.overrides),o=[...this.keys];for(const u of n){this.mergeContents(t,u.contents);for(const m of u.overrides){const[p]=r.filter(S=>C.equals(S.identifiers,m.identifiers));p?(this.mergeContents(p.contents,m.contents),p.keys.push(...m.keys),p.keys=C.distinct(p.keys)):r.push(v.deepClone(m))}for(const m of u.keys)o.indexOf(m)===-1&&o.push(m)}return new E(t,o,r)}freeze(){return this.frozen=!0,this}clone(){return new E(v.deepClone(this.contents),[...this.keys],v.deepClone(this.overrides))}createOverrideConfigurationModel(n){const t=this.getContentsForOverrideIdentifer(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let r={};for(const o of C.distinct([...Object.keys(this.contents),...Object.keys(t)])){let u=this.contents[o],m=t[o];m&&(typeof u=="object"&&typeof m=="object"?(u=v.deepClone(u),this.mergeContents(u,m)):u=m),r[o]=u}return new E(r,this.keys,this.overrides)}mergeContents(n,t){for(const r of Object.keys(t)){if(r in n&&a.isObject(n[r])&&a.isObject(t[r])){this.mergeContents(n[r],t[r]);continue}n[r]=v.deepClone(t[r])}}checkAndFreeze(n){return this.frozen&&!Object.isFrozen(n)?v.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let t=null,r=null;const o=u=>{u&&(r?this.mergeContents(r,u):r=v.deepClone(u))};for(const u of this.overrides)C.equals(u.identifiers,[n])?t=u.contents:u.identifiers.includes(n)&&o(u.contents);return o(t),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,t){this.addKey(n),(0,D.addToValueTree)(this.contents,n,t,r=>{throw new Error(r)})}removeValue(n){this.removeKey(n)&&(0,D.removeFromValueTree)(this.contents,n)}addKey(n){let t=this.keys.length;for(let r=0;r<t;r++)n.indexOf(this.keys[r])===0&&(t=r);this.keys.splice(t,1,n)}removeKey(n){let t=this.keys.indexOf(n);return t!==-1?(this.keys.splice(t,1),!0):!1}}i.ConfigurationModel=E;class b{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,t){if(!a.isUndefinedOrNull(n)){const r=this.doParseContent(n);this.parseRaw(r,t)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,t){this._raw=n;const{contents:r,keys:o,overrides:u,restricted:m}=this.doParseRaw(n,t);this._configurationModel=new E(r,o,u),this._restrictedConfigurations=m||[]}doParseContent(n){let t={},r=null,o=[],u=[],m=[];function p(A){Array.isArray(o)?o.push(A):r!==null&&(o[r]=A)}let S={onObjectBegin:()=>{let A={};p(A),u.push(o),o=A,r=null},onObjectProperty:A=>{r=A},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{let A=[];p(A),u.push(o),o=A,r=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:p,onError:(A,V,ie)=>{m.push({error:A,offset:V,length:ie})}};if(n)try{P.visit(n,S),t=o[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return t}doParseRaw(n,t){const r=g.Registry.as(L.Extensions.Configuration).getConfigurationProperties(),o=this.filter(n,r,!0,t);n=o.raw;const u=(0,D.toValuesTree)(n,S=>console.error(`Conflict in settings file ${this._name}: ${S}`)),m=Object.keys(n),p=this.toOverrides(n,S=>console.error(`Conflict in settings file ${this._name}: ${S}`));return{contents:u,keys:m,overrides:p,restricted:o.restricted}}filter(n,t,r,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:n,restricted:[]};const u={},m=[];for(let p in n)if(L.OVERRIDE_PROPERTY_REGEX.test(p)&&r){const S=this.filter(n[p],t,!1,o);u[p]=S.raw,m.push(...S.restricted)}else{const S=t[p],A=S?typeof S.scope!="undefined"?S.scope:3:void 0;S?.restricted&&m.push(p),(A===void 0||o.scopes===void 0||o.scopes.includes(A))&&(o.skipRestricted&&S?.restricted||(u[p]=n[p]))}return{raw:u,restricted:m}}toOverrides(n,t){const r=[];for(const o of Object.keys(n))if(L.OVERRIDE_PROPERTY_REGEX.test(o)){const u={};for(const m in n[o])u[m]=n[o][m];r.push({identifiers:(0,L.overrideIdentifiersFromKey)(o),keys:Object.keys(u),contents:(0,D.toValuesTree)(u,t)})}return r}}i.ConfigurationModelParser=b;class h extends R.Disposable{constructor(n,t,r,o){super();this.userSettingsResource=n,this.scopes=t,this.fileService=o,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new b(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(I.Event.any(I.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource)),I.Event.filter(this.fileService.onDidRunOperation,u=>(u.isOperation(0)||u.isOperation(3)||u.isOperation(1)||u.isOperation(4))&&r.isEqual(u.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}i.UserSettings=h;class w{constructor(n,t,r,o=new E,u=new E,m=new T.ResourceMap,p=new E,S=new T.ResourceMap,A=!0){this._defaultConfiguration=n,this._policyConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=o,this._workspaceConfiguration=u,this._folderConfigurations=m,this._memoryConfiguration=p,this._memoryConfigurationByResource=S,this._freeze=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(n,t,r){return this.getConsolidatedConfigurationModel(n,t,r).getValue(n)}updateValue(n,t,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=new E,this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,t===void 0?o.removeValue(n):o.setValue(n,t),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,t,r){const o=this.getConsolidatedConfigurationModel(n,t,r),u=this.getFolderConfigurationModelForResource(t.resource,r),m=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,p=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),S=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(n),A=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),V=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),ie=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),Y=r?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,ne=u?t.overrideIdentifier?u.freeze().override(t.overrideIdentifier).getValue(n):u.freeze().getValue(n):void 0,oe=t.overrideIdentifier?m.override(t.overrideIdentifier).getValue(n):m.getValue(n),M=o.getValue(n),x=C.distinct(o.overrides.map(G=>G.identifiers).flat()).filter(G=>o.getOverrideValue(n,G)!==void 0);return{defaultValue:p,policyValue:S,userValue:A,userLocalValue:V,userRemoteValue:ie,workspaceValue:Y,workspaceFolderValue:ne,memoryValue:oe,value:M,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,policy:S!==void 0?{value:S}:void 0,user:A!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userLocal:V!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userRemote:ie!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspace:Y!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspaceFolder:ne!==void 0?{value:u?.freeze().getValue(n),override:t.overrideIdentifier?u?.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,memory:oe!==void 0?{value:m.getValue(n),override:t.overrideIdentifier?m.getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:x.length?x:void 0}}keys(n){const t=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,t){this._folderConfigurations.set(n,t),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,t){const r=[];if(!t){const{added:o,updated:u,removed:m}=c(this._defaultConfiguration,n);t=[...o,...u,...m]}for(const o of t)for(const u of(0,L.overrideIdentifiersFromKey)(o)){const m=this._defaultConfiguration.getKeysForOverrideIdentifier(u),p=n.getKeysForOverrideIdentifier(u),S=[...p.filter(A=>m.indexOf(A)===-1),...m.filter(A=>p.indexOf(A)===-1),...m.filter(A=>!v.equals(this._defaultConfiguration.override(u).getValue(A),n.override(u).getValue(A)))];r.push([u,S])}return this.updateDefaultConfiguration(n),{keys:t,overrides:r}}compareAndUpdatePolicyConfiguration(n){const{added:t,updated:r,removed:o}=c(this._policyConfiguration,n),u=[...t,...r,...o];return u.length&&this.updatePolicyConfiguration(n),{keys:u,overrides:[]}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:r,removed:o,overrides:u}=c(this.localUserConfiguration,n),m=[...t,...r,...o];return m.length&&this.updateLocalUserConfiguration(n),{keys:m,overrides:u}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:r,removed:o,overrides:u}=c(this.remoteUserConfiguration,n);let m=[...t,...r,...o];return m.length&&this.updateRemoteUserConfiguration(n),{keys:m,overrides:u}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:r,removed:o,overrides:u}=c(this.workspaceConfiguration,n);let m=[...t,...r,...o];return m.length&&this.updateWorkspaceConfiguration(n),{keys:m,overrides:u}}compareAndUpdateFolderConfiguration(n,t){const r=this.folderConfigurations.get(n),{added:o,updated:u,removed:m,overrides:p}=c(r,t);let S=[...o,...u,...m];return(S.length||!r)&&this.updateFolderConfiguration(n,t),{keys:S,overrides:p}}compareAndDeleteFolderConfiguration(n){const t=this.folderConfigurations.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:o,removed:u,overrides:m}=c(t,void 0);return{keys:[...r,...o,...u],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,t,r){let o=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier&&(o=o.override(t.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:n},t){let r=this.getWorkspaceConsolidatedConfiguration();if(t&&n){const o=t.getFolder(n);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const u=this._memoryConfigurationByResource.get(n);u&&(r=r.merge(u))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let t=this._foldersConsolidatedConfigurations.get(n);if(!t){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(n);o?(t=r.merge(o),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(n,t)):t=r}return t}getFolderConfigurationModelForResource(n,t){if(t&&n){const r=t.getFolder(n);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,t)=>{const{contents:r,overrides:o,keys:u}=this._folderConfigurations.get(t);return n.push([t,{contents:r,overrides:o,keys:u}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>n.add(t)),this.userConfiguration.freeze().keys.forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(r=>n.add(r))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(r=>n.add(r))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(o=>t.add(o))),[...t.values()]}static parse(n){const t=this.parseConfigurationModel(n.defaults),r=this.parseConfigurationModel(n.policy),o=this.parseConfigurationModel(n.user),u=this.parseConfigurationModel(n.workspace),m=n.folders.reduce((p,S)=>(p.set(d.URI.revive(S[0]),this.parseConfigurationModel(S[1])),p),new T.ResourceMap);return new w(t,r,o,new E,u,m,new E,new T.ResourceMap,!1)}static parseConfigurationModel(n){return new E(n.contents,n.keys,n.overrides).freeze()}}i.Configuration=w;function l(...e){if(e.length===0)return{keys:[],overrides:[]};if(e.length===1)return e[0];const n=new Set,t=new Map;for(const o of e)o.keys.forEach(u=>n.add(u)),o.overrides.forEach(([u,m])=>{const p=(0,T.getOrSet)(t,u,new Set);m.forEach(S=>p.add(S))});const r=[];return t.forEach((o,u)=>r.push([u,[...o.values()]])),{keys:[...n.values()],overrides:r}}i.mergeChanges=l;class f{constructor(n,t,r,o){this.change=n,this.previous=t,this.currentConfiguraiton=r,this.currentWorkspace=o,this._previousConfiguration=void 0;const u=new Set;n.keys.forEach(p=>u.add(p)),n.overrides.forEach(([,p])=>p.forEach(S=>u.add(S))),this.affectedKeys=[...u.values()];const m=new E;this.affectedKeys.forEach(p=>m.setValue(p,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(t){const r=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(n,t,this.currentWorkspace);return!v.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(n,t){let r=(0,D.toValuesTree)({[t]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(n=n[o],!n)return!1;r=r[o]}return!0}}i.ConfigurationChangeEvent=f;class y extends f{constructor(n,t,r,o){super({keys:n.allKeys(),overrides:[]},void 0,n,t);this.source=r,this.sourceConfig=o}}i.AllKeysConfigurationChangeEvent=y;function c(e,n){const{added:t,removed:r,updated:o}=s(n,e),u=[],m=e?.getAllOverrideIdentifiers()||[],p=n?.getAllOverrideIdentifiers()||[];if(n){const S=p.filter(A=>!m.includes(A));for(const A of S)u.push([A,n.getKeysForOverrideIdentifier(A)])}if(e){const S=m.filter(A=>!p.includes(A));for(const A of S)u.push([A,e.getKeysForOverrideIdentifier(A)])}if(n&&e){for(const S of m)if(p.includes(S)){const A=s({contents:e.getOverrideValue(void 0,S)||{},keys:e.getKeysForOverrideIdentifier(S)},{contents:n.getOverrideValue(void 0,S)||{},keys:n.getKeysForOverrideIdentifier(S)});u.push([S,[...A.added,...A.removed,...A.updated]])}}return{added:t,removed:r,updated:o,overrides:u}}function s(e,n){const t=e?n?e.keys.filter(u=>n.keys.indexOf(u)===-1):[...e.keys]:[],r=n?e?n.keys.filter(u=>e.keys.indexOf(u)===-1):[...n.keys]:[],o=[];if(e&&n){for(const u of n.keys)if(e.keys.indexOf(u)!==-1){const m=(0,D.getConfigurationValue)(n.contents,u),p=(0,D.getConfigurationValue)(e.contents,u);v.equals(m,p)||o.push(u)}}return{added:t,removed:r,updated:o}}}),define(ee[115],te([0,1,17,3,2,21,7,22,62,36,11,33,30]),function(B,i,C,I,P,R,T,v,a,d,D,L,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.PolicyConfiguration=i.NullPolicyConfiguration=i.DefaultConfigurationModel=i.DefaultConfiguration=void 0;class E extends P.Disposable{constructor(){super(...arguments);this._onDidChangeConfiguration=this._register(new I.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new b(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(g.Registry.as(d.Extensions.Configuration).onDidUpdateConfiguration(({properties:f,defaultsOverrides:y})=>this.onDidUpdateConfiguration(f,y))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(f,y){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:f})}getConfigurationDefaultOverrides(){return{}}}i.DefaultConfiguration=E;class b extends a.ConfigurationModel{constructor(f={}){const y=g.Registry.as(d.Extensions.Configuration).getConfigurationProperties(),c=Object.keys(y),s=Object.create(null),e=[];for(const n in y){const t=f[n],r=t!==void 0?t:y[n].default;(0,v.addToValueTree)(s,n,r,o=>console.error(`Conflict in default settings: ${o}`))}for(const n of Object.keys(s))d.OVERRIDE_PROPERTY_REGEX.test(n)&&e.push({identifiers:(0,d.overrideIdentifiersFromKey)(n),keys:Object.keys(s[n]),contents:(0,v.toValuesTree)(s[n],t=>console.error(`Conflict in default settings file: ${t}`))});super(s,c,e)}}i.DefaultConfigurationModel=b;class h{constructor(){this.onDidChangeConfiguration=I.Event.None,this.configurationModel=new a.ConfigurationModel}async initialize(){return this.configurationModel}}i.NullPolicyConfiguration=h;let w=class extends P.Disposable{constructor(f,y,c){super();this.defaultConfiguration=f,this.policyService=y,this.logService=c,this._onDidChangeConfiguration=this._register(new I.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new a.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(f=>this.onDidChangePolicies(f))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:f})=>this.update(await this.registerPolicyDefinitions(f),!0))),this._configurationModel}async registerPolicyDefinitions(f){const y={},c=[],s=g.Registry.as(d.Extensions.Configuration).getConfigurationProperties();for(const e of f){const n=s[e];if(!n){c.push(e);continue}if(n.policy){if(n.type!=="string"&&n.type!=="number"){this.logService.warn(`Policy ${n.policy.name} has unsupported type ${n.type}`);continue}c.push(e),y[n.policy.name]={type:n.type}}}return(0,T.isEmptyObject)(y)||await this.policyService.registerPolicyDefinitions(y),c}onDidChangePolicies(f){const y=g.Registry.as(d.Extensions.Configuration).getPolicyConfigurations(),c=(0,C.coalesce)(f.map(s=>y.get(s)));this.update(c,!0)}update(f,y){const c=g.Registry.as(d.Extensions.Configuration).getConfigurationProperties(),s=[],e=this._configurationModel.isEmpty();for(const n of f){const t=c[n]?.policy?.name;if(t){const r=this.policyService.getPolicyValue(t);(e?r!==void 0:!(0,R.equals)(this._configurationModel.getValue(n),r))&&s.push([n,r])}else this._configurationModel.getValue(n)!==void 0&&s.push([n,void 0])}if(s.length){const n=this._configurationModel;this._configurationModel=new a.ConfigurationModel;for(const t of n.keys)this._configurationModel.setValue(t,n.getValue(t));for(const[t,r]of s)r===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,r);y&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};w=de([ce(1,L.IPolicyService),ce(2,D.ILogService)],w),i.PolicyConfiguration=w}),define(ee[116],te([0,1,4,3,2,18,22,62,115,33]),function(B,i,C,I,P,R,T,v,a,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ConfigurationService=void 0;class D extends P.Disposable{constructor(g,E,b,h){super();this.settingsResource=g,this._onDidChangeConfiguration=this._register(new I.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new a.DefaultConfiguration),this.policyConfiguration=b instanceof d.NullPolicyService?new a.NullPolicyConfiguration:this._register(new a.PolicyConfiguration(this.defaultConfiguration,b,h)),this.userConfiguration=this._register(new v.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,E)),this.configuration=new v.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new v.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new C.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:w,properties:l})=>this.onDidDefaultConfigurationChange(w,l))),this._register(this.policyConfiguration.onDidChangeConfiguration(w=>this.onDidPolicyConfigurationChange(w))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[g,E,b]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new v.Configuration(g,E,b)}getConfigurationData(){return this.configuration.toData()}getValue(g,E){const b=typeof g=="string"?g:void 0,h=(0,T.isConfigurationOverrides)(g)?g:(0,T.isConfigurationOverrides)(E)?E:{};return this.configuration.getValue(b,h,void 0)}updateValue(g,E,b,h){return Promise.reject(new Error("not supported"))}inspect(g){return this.configuration.inspect(g,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const g=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(g)}onDidChangeUserConfiguration(g){const E=this.configuration.toData(),b=this.configuration.compareAndUpdateLocalUserConfiguration(g);this.trigger(b,E,1)}onDidDefaultConfigurationChange(g,E){const b=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(g,E);this.trigger(h,b,6)}onDidPolicyConfigurationChange(g){const E=this.configuration.toData(),b=this.configuration.compareAndUpdatePolicyConfiguration(g);this.trigger(b,E,6)}trigger(g,E,b){const h=new v.ConfigurationChangeEvent(g,{data:E},this.configuration);h.source=b,h.sourceConfig=this.getTargetConfiguration(b),this._onDidChangeConfiguration.fire(h)}getTargetConfiguration(g){switch(g){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}i.ConfigurationService=D}),define(ee[117],te([0,1,14]),function(B,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getRemoteServerRootPath=i.getRemoteName=i.getRemoteAuthority=void 0;function I(T){return T.scheme===C.Schemas.vscodeRemote?T.authority:void 0}i.getRemoteAuthority=I;function P(T){if(!T)return;const v=T.indexOf("+");return v<0?T:T.substr(0,v)}i.getRemoteName=P;function R(T){return`/${T.quality??"oss"}-${T.commit??"dev"}`}i.getRemoteServerRootPath=R}),define(ee[37],te([0,1,26,12,117]),function(B,i,C,I,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IBuiltinExtensionsScannerService=i.isResolverExtension=i.isAuthenticationProviderExtension=i.isLanguagePackExtension=i.ExtensionIdentifier=i.TargetPlatform=i.ExtensionType=i.EXTENSION_CATEGORIES=i.isIExtensionIdentifier=i.getWorkspaceSupportTypeMessage=i.ALL_EXTENSION_KINDS=i.UNDEFINED_PUBLISHER=i.BUILTIN_MANIFEST_CACHE_FILE=i.USER_MANIFEST_CACHE_FILE=i.MANIFEST_CACHE_FOLDER=void 0,i.MANIFEST_CACHE_FOLDER="CachedExtensions",i.USER_MANIFEST_CACHE_FILE="user",i.BUILTIN_MANIFEST_CACHE_FILE="builtin",i.UNDEFINED_PUBLISHER="undefined_publisher",i.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}i.getWorkspaceSupportTypeMessage=R;function T(E){return E&&typeof E=="object"&&typeof E.id=="string"&&(!E.uuid||typeof E.uuid=="string")}i.isIExtensionIdentifier=T,i.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var v;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(v=i.ExtensionType||(i.ExtensionType={}));var a;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(a=i.TargetPlatform||(i.TargetPlatform={}));class d{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,h){if(typeof b=="undefined"||b===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof b=="string"||typeof h=="string"){let w=typeof b=="string"?b:b.value,l=typeof h=="string"?h:h.value;return C.equalsIgnoreCase(w,l)}return b._lower===h._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}i.ExtensionIdentifier=d;function D(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}i.isLanguagePackExtension=D;function L(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}i.isAuthenticationProviderExtension=L;function g(E,b){if(b){const h=`onResolveRemoteAuthority:${(0,P.getRemoteName)(b)}`;return E.activationEvents?.indexOf(h)!==-1}return!1}i.isResolverExtension=g,i.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[25],te([0,1,26,23,37,8,10,9,29]),function(B,i,C,I,P,R,T,v,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.computeTargetPlatform=i.isAlpineLinux=i.getExtensionDependencies=i.getMaliciousExtensionsSet=i.BetterMergeId=i.getGalleryExtensionTelemetryData=i.getLocalExtensionTelemetryData=i.groupByExtension=i.getGalleryExtensionId=i.adoptToGalleryExtensionId=i.getExtensionId=i.getIdAndVersion=i.ExtensionKey=i.areSameExtensions=void 0;function d(t,r){return t.uuid&&r.uuid?t.uuid===r.uuid:t.id===r.id?!0:(0,C.compareIgnoreCase)(t.id,r.id)===0}i.areSameExtensions=d;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class L{constructor(r,o,u="undefined"){this.version=o,this.targetPlatform=u,this.id=r.id}static create(r){const o=r.manifest?r.manifest.version:r.version,u=r.manifest?r.targetPlatform:r.properties.targetPlatform;return new L(r.identifier,o,u)}static parse(r){const o=D.exec(r);return o&&o[1]&&o[2]?new L({id:o[1]},o[2],o[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(r){return r instanceof L?d(this,r)&&this.version===r.version&&this.targetPlatform===r.targetPlatform:!1}}i.ExtensionKey=L;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(t){const r=g.exec(t);return r&&r[1]?[h(r[1]),r[2]]:[h(t),void 0]}i.getIdAndVersion=E;function b(t,r){return`${t}.${r}`}i.getExtensionId=b;function h(t){return t.toLocaleLowerCase()}i.adoptToGalleryExtensionId=h;function w(t,r){return h(b(t,r))}i.getGalleryExtensionId=w;function l(t,r){const o=[],u=m=>{for(const p of o)if(p.some(S=>d(r(S),r(m))))return p;return null};for(const m of t){const p=u(m);p?p.push(m):o.push([m])}return o}i.groupByExtension=l;function f(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}i.getLocalExtensionTelemetryData=f;function y(t){return{id:t.identifier.id,name:t.name,galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),...t.telemetryData}}i.getGalleryExtensionTelemetryData=y,i.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function c(t){const r=new Set;if(t.malicious)for(const o of t.malicious)r.add(o.id);return r}i.getMaliciousExtensionsSet=c;function s(t,r){const o=[],u=r.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const m=u.shift();if(m&&o.every(p=>!d(p.identifier,{id:m}))){const p=t.filter(S=>d(S.identifier,{id:m}));p.length===1&&(o.push(p[0]),u.push(...p[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}i.getExtensionDependencies=s;async function e(t,r){if(!R.isLinux)return!1;let o;try{o=(await t.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await t.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(m){r.debug("Error while getting the os-release file.",(0,v.getErrorMessage)(m))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}i.isAlpineLinux=e;async function n(t,r){const o=await e(t,r),u=(0,I.getTargetPlatform)(o?"alpine":R.platform,a.arch);return r.debug("ComputeTargetPlatform:",u),u}i.computeTargetPlatform=n}),define(ee[118],te([0,1,24,9,68,14,35,10,84,23,25,37]),function(B,i,C,I,P,R,T,v,a,d,D,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementCLIService=void 0;const g=w=>(0,a.localize)(0,null,w),E=(0,a.localize)(1,null,"ms-dotnettools.csharp");function b(w,l){return l?`${w.publisher}.${w.name}@${w.version}`:`${w.publisher}.${w.name}`}let h=class{constructor(l,f){this.extensionManagementService=l,this.extensionGalleryService=f}get location(){}async listExtensions(l,f,y=console){let c=await this.extensionManagementService.getInstalled(1);const s=L.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(f&&f!==""){if(s.indexOf(f.toLowerCase())<0){y.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}c=c.filter(n=>n.manifest.categories?n.manifest.categories.map(r=>r.toLowerCase()).indexOf(f.toLowerCase())>-1:!1)}else if(f===""){y.log("Possible Categories: "),s.forEach(n=>{y.log(n)});return}this.location&&y.log((0,a.localize)(2,null,this.location)),c=c.sort((n,t)=>n.identifier.id.localeCompare(t.identifier.id));let e;for(let n of c)e!==n.identifier.id&&(e=n.identifier.id,y.log(b(n.manifest,l)))}async installExtensions(l,f,y,c,s=console){const e=[],n=[];l.length&&s.log(this.location?(0,a.localize)(3,null,this.location):(0,a.localize)(4,null));const t=await this.extensionManagementService.getInstalled(1),r=(p,S)=>{const A=t.find(V=>(0,D.areSameExtensions)(V.identifier,{id:p}));if(A){if(!c&&(!S||S==="prerelease"&&A.preRelease))return s.log((0,a.localize)(5,null,p,A.manifest.version,p)),!1;if(S&&A.manifest.version===S)return s.log((0,a.localize)(6,null,`${p}@${S}`)),!1}return!0},o=(p,S,A)=>{m.push({id:p,version:S!=="prerelease"?S:void 0,installOptions:{...y,isBuiltin:A,installPreReleaseVersion:S==="prerelease"||y.installPreReleaseVersion}})},u=[],m=[];for(const p of l)if(p instanceof v.URI)u.push(p);else{const[S,A]=(0,D.getIdAndVersion)(p);r(S,A)&&o(S,A,!1)}for(const p of f){const[S,A]=(0,D.getIdAndVersion)(p);r(S,A)&&o(S,A,!0)}if(u.length&&await Promise.all(u.map(async p=>{try{const S=await this.installVSIX(p,{...y,isBuiltin:!1},c,s);S&&n.push(S)}catch(S){s.error(S.message||S.stack||S),e.push(p.toString())}})),m.length){const p=await this.getGalleryExtensions(m);await Promise.all(m.map(async S=>{const A=p.get(S.id.toLowerCase());if(A)try{const V=await this.installFromGallery(S,A,t,c,s);V&&n.push(V)}catch(V){s.error(V.message||V.stack||V),e.push(S.id)}else s.error(`${g(S.version?`${S.id}@${S.version}`:S.id)}
${E}`),e.push(S.id)}))}if(e.length)throw new Error((0,a.localize)(7,null,e.join(", ")))}async installVSIX(l,f,y,c){const s=await this.extensionManagementService.getManifest(l);if(!s)throw new Error("Invalid vsix");if(await this.validateVSIX(s,y,c))try{return await this.extensionManagementService.install(l,f),c.log((0,a.localize)(8,null,(0,P.getBaseLabel)(l))),s}catch(n){if((0,I.isCancellationError)(n))return c.log((0,a.localize)(9,null,(0,P.getBaseLabel)(l))),null;throw n}return null}async getGalleryExtensions(l){const f=new Map,y=l.some(s=>s.installOptions.installPreReleaseVersion),c=await this.extensionGalleryService.getExtensions(l.map(s=>({...s,preRelease:y})),C.CancellationToken.None);for(const s of c)f.set(s.identifier.id.toLowerCase(),s);return f}async installFromGallery({id:l,version:f,installOptions:y},c,s,e,n){const t=await this.extensionGalleryService.getManifest(c,C.CancellationToken.None);if(t&&!this.validateExtensionKind(t,n))return null;const r=s.find(o=>(0,D.areSameExtensions)(o.identifier,c.identifier));if(r){if(c.version===r.manifest.version)return n.log((0,a.localize)(10,null,f?`${l}@${f}`:l)),null;n.log((0,a.localize)(11,null,l,c.version))}try{return y.isBuiltin?n.log(f?(0,a.localize)(12,null,l,f):(0,a.localize)(13,null,l)):n.log(f?(0,a.localize)(14,null,l,f):(0,a.localize)(15,null,l)),await this.extensionManagementService.installFromGallery(c,{...y,installGivenVersion:!!f}),n.log((0,a.localize)(16,null,l,c.version)),t}catch(o){if((0,I.isCancellationError)(o))return n.log((0,a.localize)(17,null,l)),null;throw o}}validateExtensionKind(l,f){return!0}async validateVSIX(l,f,y){const c={id:(0,D.getGalleryExtensionId)(l.publisher,l.name)},e=(await this.extensionManagementService.getInstalled(1)).find(n=>(0,D.areSameExtensions)(c,n.identifier)&&(0,T.gt)(n.manifest.version,l.version));return e&&!f?(y.log((0,a.localize)(18,null,e.identifier.id,e.manifest.version,l.version)),!1):this.validateExtensionKind(l,y)}async uninstallExtensions(l,f,y=console){const c=async e=>{if(e instanceof v.URI){const n=await this.extensionManagementService.getManifest(e);return b(n)}return e},s=[];for(const e of l){const n=await c(e),r=(await this.extensionManagementService.getInstalled()).filter(o=>(0,D.areSameExtensions)(o.identifier,{id:n}));if(!r.length)throw new Error(`${this.notInstalled(n)}
${E}`);if(r.some(o=>o.type===0)){y.log((0,a.localize)(19,null,n));return}if(!f&&r.some(o=>o.isBuiltin)){y.log((0,a.localize)(20,null,n));return}y.log((0,a.localize)(21,null,n));for(const o of r)await this.extensionManagementService.uninstall(o),s.push(o);this.location?y.log((0,a.localize)(22,null,n,this.location)):y.log((0,a.localize)(23,null,n))}}async locateExtension(l,f=console){const y=await this.extensionManagementService.getInstalled();l.forEach(c=>{y.forEach(s=>{if(s.identifier.id===c&&s.location.scheme===R.Schemas.file){f.log(s.location.fsPath);return}})})}notInstalled(l){return this.location?(0,a.localize)(24,null,l,this.location):(0,a.localize)(25,null,l)}};h=de([ce(0,d.IExtensionManagementService),ce(1,d.IExtensionGalleryService)],h),i.ExtensionManagementCLIService=h}),define(ee[44],te([0,1,17,4,21,16,9,47,76,2,14,13,8,18,35,50,7,10,85,20,25,37,42,15,12,11,27,3,51]),function(B,i,C,I,P,R,T,v,a,d,D,L,g,E,b,h,w,l,f,y,c,s,e,n,t,r,o,u,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeExtensionsScannerService=i.toExtensionDescription=i.AbstractExtensionsScannerService=i.IExtensionsScannerService=i.Translations=void 0;var p;(function(oe){function M(x,G){if(x===G)return!0;let _=Object.keys(x),re=new Set;for(let k of Object.keys(G))re.add(k);if(_.length!==re.size)return!1;for(let k of _){if(x[k]!==G[k])return!1;re.delete(k)}return re.size===0}oe.equals=M})(p=i.Translations||(i.Translations={})),i.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let S=class extends d.Disposable{constructor(M,x,G,_,re,k,O,F){super();this.systemExtensionsLocation=M,this.userExtensionsLocation=x,this.extensionsControlLocation=G,this.cacheLocation=_,this.fileService=re,this.logService=k,this.environmentService=O,this.productService=F,this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.systemExtensionsCachedScanner=this._register(new ie((0,E.joinPath)(this.cacheLocation,s.BUILTIN_MANIFEST_CACHE_FILE),this.fileService,this.logService)),this.userExtensionsCachedScanner=this._register(new ie((0,E.joinPath)(this.cacheLocation,s.USER_MANIFEST_CACHE_FILE),this.fileService,this.logService)),this.extensionsScanner=this._register(new V(this.fileService,this.logService)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,c.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(M){const[x,G]=await Promise.all([this.scanSystemExtensions(M),this.scanUserExtensions(M)]),_=await this.scanExtensionsUnderDevelopment(M,[...x,...G]);return this.dedupExtensions([...x,...G,..._],await this.getTargetPlatform(),!0)}async scanSystemExtensions(M){const x=[];x.push(this.scanDefaultSystemExtensions(!!M.useCache,M.language)),x.push(this.scanDevSystemExtensions(M.language,!!M.checkControlFile));const[G,_]=await Promise.all(x);return this.applyScanOptions([...G,..._],M,!1)}async scanUserExtensions(M){this.logService.trace("Started scanning user extensions");const x=await this.createExtensionScannerInput(this.userExtensionsLocation,1,!M.includeUninstalled,M.language);let _=await(M.useCache&&!x.devMode&&x.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(x);return _=await this.applyScanOptions(_,M,!0),this.logService.trace("Scanned user extensions:",_.length),_}async scanExtensionsUnderDevelopment(M,x){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const G=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(_=>_.scheme===D.Schemas.file).map(async _=>{const re=await this.createExtensionScannerInput(_,1,!0,M.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(re)).map(O=>(O.type=x.find(F=>(0,c.areSameExtensions)(F.identifier,O.identifier))?.type??O.type,this.extensionsScanner.validate(O,re)))}))).flat();return this.applyScanOptions(G,M,!0)}return[]}async scanExistingExtension(M,x,G){const _=await this.createExtensionScannerInput(M,x,!0,G.language),re=await this.extensionsScanner.scanExtension(_);return!re||!G.includeInvalid&&!re.isValid?null:re}async scanOneOrMultipleExtensions(M,x,G){const _=await this.createExtensionScannerInput(M,x,!0,G.language),re=await this.extensionsScanner.scanOneOrMultipleExtensions(_);return this.applyScanOptions(re,G,!0)}async updateMetadata(M,x){const G=(0,E.joinPath)(M,"package.json"),_=(await this.fileService.readFile(G)).value.toString(),re=JSON.parse(_);x.isMachineScoped=x.isMachineScoped||void 0,x.isBuiltin=x.isBuiltin||void 0,x.installedTimestamp=x.installedTimestamp||void 0,re.__metadata={...re.__metadata,...x},await this.fileService.writeFile((0,E.joinPath)(M,"package.json"),R.VSBuffer.fromString(JSON.stringify(re,null,"	")))}async applyScanOptions(M,x,G){return x.includeAllVersions||(M=this.dedupExtensions(M,await this.getTargetPlatform(),G)),x.includeInvalid||(M=M.filter(_=>_.isValid)),M.sort((_,re)=>{const k=L.basename(_.location.fsPath),O=L.basename(re.location.fsPath);return k<O?-1:k>O?1:0})}dedupExtensions(M,x,G){const _=new Map;for(const re of M){const k=s.ExtensionIdentifier.toKey(re.identifier.id),O=_.get(k);if(O){if(O.isValid&&!re.isValid)continue;if(O.isValid===re.isValid){if(G&&b.gt(O.manifest.version,re.manifest.version)){this.logService.debug(`Skipping extension ${re.location.path} with lower version ${re.manifest.version}.`);continue}if(b.eq(O.manifest.version,re.manifest.version)&&O.targetPlatform===x){this.logService.debug(`Skipping extension ${re.location.path} from different target platform ${re.targetPlatform}`);continue}}O.type===0?this.logService.debug(`Overwriting system extension ${O.location.path} with ${re.location.path}.`):this.logService.warn(`Overwriting user extension ${O.location.path} with ${re.location.path}.`)}_.set(k,re)}return[..._.values()]}async scanDefaultSystemExtensions(M,x){this.logService.trace("Started scanning system extensions");const G=await this.createExtensionScannerInput(this.systemExtensionsLocation,0,!0,x),re=await(M&&!G.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(G);return this.logService.trace("Scanned system extensions:",re.length),re}async scanDevSystemExtensions(M,x){const G=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!G?.length)return[];this.logService.trace("Started scanning dev system extensions");const _=x?await this.getBuiltInExtensionControl():{},re=[],k=l.URI.file(L.normalize(L.join(D.FileAccess.asFileUri("",B).fsPath,"..",".build","builtInExtensions")));for(const F of G){const U=_[F.name]||"marketplace";switch(U){case"disabled":break;case"marketplace":re.push((0,E.joinPath)(k,F.name));break;default:re.push(l.URI.file(U));break}}const O=await Promise.all(re.map(async F=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(F,0,!0,M))));return this.logService.trace("Scanned dev system extensions:",O.length),(0,C.coalesce)(O)}async getBuiltInExtensionControl(){try{const M=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(M.value.toString())}catch{return{}}}async createExtensionScannerInput(M,x,G,_,re=!0){const k=await this.getTranslations(_??g.language);let O;try{const F=await this.fileService.stat(M);typeof F.mtime=="number"&&(O=F.mtime)}catch{}return new A(M,O,x,G,re,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,_,k)}};S=de([ce(4,n.IFileService),ce(5,r.ILogService),ce(6,y.IEnvironmentService),ce(7,o.IProductService)],S),i.AbstractExtensionsScannerService=S;class A{constructor(M,x,G,_,re,k,O,F,U,$,W){this.location=M,this.mtime=x,this.type=G,this.excludeObsolete=_,this.validate=re,this.productVersion=k,this.productDate=O,this.productCommit=F,this.devMode=U,this.language=$,this.translations=W}static createNlsConfiguration(M){return{language:M.language,pseudo:M.language==="pseudo",devMode:M.devMode,translations:M.translations}}static equals(M,x){return(0,E.isEqual)(M.location,x.location)&&M.mtime===x.mtime&&M.type===x.type&&M.excludeObsolete===x.excludeObsolete&&M.validate===x.validate&&M.productVersion===x.productVersion&&M.productDate===x.productDate&&M.productCommit===x.productCommit&&M.devMode===x.devMode&&M.language===x.language&&p.equals(M.translations,x.translations)}}class V extends d.Disposable{constructor(M,x){super();this.fileService=M,this.logService=x}async scanExtensions(M){const x=await this.fileService.resolve(M.location);if(x.children){let G={};if(M.excludeObsolete&&M.type===1)try{const re=(await this.fileService.readFile((0,E.joinPath)(M.location,".obsolete"))).value.toString();G=JSON.parse(re)}catch{}const _=await Promise.all(x.children.map(async re=>{if(!re.isDirectory||M.type===1&&(0,E.basename)(re.resource).indexOf(".")===0)return null;const k=new A(re.resource,M.mtime,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations),O=await this.scanExtension(k);return O&&!G[c.ExtensionKey.create(O).toString()]?O:null}));return(0,C.coalesce)(_)}return[]}async scanOneOrMultipleExtensions(M){try{if(await this.fileService.exists((0,E.joinPath)(M.location,"package.json"))){const x=await this.scanExtension(M);return x?[x]:[]}else return await this.scanExtensions(M)}catch(x){return this.logService.error(`Error scanning extensions at ${M.location.path}:`,(0,T.getErrorMessage)(x)),[]}}async scanExtension(M){try{let x=await this.scanExtensionManifest(M.location);if(x){x.publisher||(x.publisher=s.UNDEFINED_PUBLISHER);const G=x.__metadata;delete x.__metadata;const _=(0,c.getGalleryExtensionId)(x.publisher,x.name),re=G?.id?{id:_,uuid:G.id}:{id:_},k=G?.isSystem?0:M.type,O=k===0||!!G?.isBuiltin;x=await this.translateManifest(M.location,x,A.createNlsConfiguration(M));const F={type:k,identifier:re,manifest:x,location:M.location,isBuiltin:O,targetPlatform:G?.targetPlatform??"undefined",metadata:G,isValid:!0,validations:[]};return M.validate?this.validate(F,M):F}}catch(x){M.type!==0&&this.logService.error(x)}return null}validate(M,x){let G=!0;const _=(0,e.validateExtensionManifest)(x.productVersion,x.productDate,x.location,M.manifest,M.isBuiltin);for(const[re,k]of _)re===h.default.Error&&(G=!1,this.logService.error(this.formatMessage(x.location,k)));return M.isValid=G,M.validations=_,M}async scanExtensionManifest(M){const x=(0,E.joinPath)(M,"package.json");let G;try{G=(await this.fileService.readFile(x)).value.toString()}catch(re){return(0,n.toFileOperationResult)(re)!==1&&this.logService.error(this.formatMessage(M,(0,f.localize)(0,null,x.path,re.message))),null}let _;try{_=JSON.parse(G)}catch{const k=[];(0,v.parse)(G,k);for(const O of k)this.logService.error(this.formatMessage(M,(0,f.localize)(1,null,x.path,O.offset,O.length,(0,a.getParseErrorMessage)(O.error))));return null}return(0,v.getNodeType)(_)!=="object"?(this.logService.error(this.formatMessage(M,(0,f.localize)(2,null,x.path))),null):_}async translateManifest(M,x,G){const _=await this.getLocalizedMessages(M,x,G);if(_)try{const re=[],k=await this.resolveOriginalMessageBundle(_.default,re);if(re.length>0)return re.forEach(F=>{this.logService.error(this.formatMessage(M,(0,f.localize)(3,null,_.default?.path,(0,a.getParseErrorMessage)(F.error))))}),x;if((0,v.getNodeType)(_)!=="object")return this.logService.error(this.formatMessage(M,(0,f.localize)(4,null,_.default?.path))),x;const O=_.values||Object.create(null);this.replaceNLStrings(G.pseudo,x,O,k,M)}catch{}return x}async getLocalizedMessages(M,x,G){const _=(0,E.joinPath)(M,"package.nls.json"),re=(U,$)=>{$.forEach(W=>{this.logService.error(this.formatMessage(M,(0,f.localize)(5,null,U?.path,(0,a.getParseErrorMessage)(W.error))))})},k=U=>{this.logService.error(this.formatMessage(M,(0,f.localize)(6,null,U?.path)))},O=`${x.publisher}.${x.name}`,F=G.translations[O];if(F)try{const U=l.URI.file(F),$=(await this.fileService.readFile(U)).value.toString();let W=[],ae=(0,v.parse)($,W);return W.length>0?(re(U,W),{values:void 0,default:_}):(0,v.getNodeType)(ae)!=="object"?(k(U),{values:void 0,default:_}):{values:ae.contents?ae.contents.package:void 0,default:_}}catch{return{values:void 0,default:_}}else{if(!await this.fileService.exists(_))return;let $;try{$=await this.findMessageBundles(M,G)}catch{return}if(!$.localized)return{values:void 0,default:$.original};try{const W=(await this.fileService.readFile($.localized)).value.toString();let ae=[],Z=(0,v.parse)(W,ae);return ae.length>0?(re($.localized,ae),{values:void 0,default:$.original}):(0,v.getNodeType)(Z)!=="object"?(k($.localized),{values:void 0,default:$.original}):{values:Z,default:$.original}}catch{return{values:void 0,default:$.original}}}}async resolveOriginalMessageBundle(M,x){if(M)try{const G=(await this.fileService.readFile(M)).value.toString();return(0,v.parse)(G,x)}catch{return null}else return null}findMessageBundles(M,x){return new Promise((G,_)=>{const re=k=>{let O=(0,E.joinPath)(M,`package.nls.${k}.json`);this.fileService.exists(O).then(F=>{F&&G({localized:O,original:(0,E.joinPath)(M,"package.nls.json")});let U=k.lastIndexOf("-");U===-1?G({localized:(0,E.joinPath)(M,"package.nls.json"),original:null}):(k=k.substring(0,U),re(k))})};if(x.devMode||x.pseudo||!x.language)return G({localized:(0,E.joinPath)(M,"package.nls.json"),original:null});re(x.language)})}replaceNLStrings(M,x,G,_,re){const k=(O,F,U)=>{const $=O[F];if((0,w.isString)($)){const W=$,ae=W.length;if(ae>1&&W[0]==="%"&&W[ae-1]==="%"){const Z=W.substr(1,ae-2);let j=G[Z];j===void 0&&_&&(j=_[Z]);let N=typeof j=="string"?j:typeof j?.message=="string"?j.message:void 0;N!==void 0?(M&&(N="\uFF3B"+N.replace(/[aouei]/g,"$&$&")+"\uFF3D"),O[F]=U&&(F==="title"||F==="category")&&_?{value:N,original:_[Z]}:N):this.logService.warn(this.formatMessage(re,(0,f.localize)(7,null,Z)))}}else if((0,w.isObject)($))for(let W in $)$.hasOwnProperty(W)&&(W==="commands"?k($,W,!0):k($,W,U));else if((0,w.isArray)($))for(let W=0;W<$.length;W++)k($,W,U)};for(let O in x)x.hasOwnProperty(O)&&k(x,O)}formatMessage(M,x){return`[${M.path}]: ${x}`}}class ie extends V{constructor(M,x,G){super(x,G);this.cacheFile=M,this.cacheValidatorThrottler=this._register(new I.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(M){const x=await this.readExtensionCache();if(this.input=M,x&&x.input&&A.equals(x.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),x.result.map(_=>(_.location=l.URI.revive(_.location),_));const G=await super.scanExtensions(M);return await this.writeExtensionCache({input:M,result:G}),G}async readExtensionCache(){try{const M=await this.fileService.readFile(this.cacheFile),x=JSON.parse(M.value.toString());return{result:x.result,input:(0,m.revive)(x.input)}}catch(M){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(M))}return null}async writeExtensionCache(M){try{await this.fileService.writeFile(this.cacheFile,R.VSBuffer.fromString(JSON.stringify(M)))}catch(x){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(x))}}async validateCache(){if(!this.input)return;const M=await this.readExtensionCache();if(!M)return;const x=M.result,G=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!P.equals(G,x))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(_){this.logService.error(_)}}}function Y(oe,M){const x=(0,c.getExtensionId)(oe.manifest.publisher,oe.manifest.name);return{id:x,identifier:new s.ExtensionIdentifier(x),isBuiltin:oe.type===0,isUserBuiltin:oe.type===1&&oe.isBuiltin,isUnderDevelopment:M,extensionLocation:oe.location,uuid:oe.identifier.uuid,targetPlatform:oe.targetPlatform,...oe.manifest}}i.toExtensionDescription=Y;class ne extends S{constructor(M,x,G,_,re,k,O,F){super(M,x,(0,E.joinPath)(G,".vscode-oss-dev","extensions","control.json"),(0,E.joinPath)(_,s.MANIFEST_CACHE_FOLDER),re,k,O,F);this.translationsPromise=(async()=>{if(g.translationsConfigFile)try{const U=await this.fileService.readFile(l.URI.file(g.translationsConfigFile));return JSON.parse(U.value.toString())}catch{}return Object.create(null)})()}getTranslations(M){return this.translationsPromise}}i.NativeExtensionsScannerService=ne}),define(ee[119],te([0,1,4,9,2,8,18,35,10,32,19,20,23,25,15,11]),function(B,i,C,I,P,R,T,v,a,d,D,L,g,E,b,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsDownloader=void 0;let w=class extends P.Disposable{constructor(f,y,c,s){super();this.fileService=y,this.extensionGalleryService=c,this.logService=s,this.extensionsDownloadDir=a.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,y){await this.cleanUpPromise;const c=this.getName(f),s=(0,T.joinPath)(this.extensionsDownloadDir,c);if(!await this.fileService.exists(s)){const e=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,d.generateUuid)()}`);await this.fileService.exists(e)||await this.extensionGalleryService.download(f,e,y);try{await this.rename(e,s,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(e)}catch{}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,I.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,e.path),n}}return s}async delete(f){await this.cleanUpPromise,await this.fileService.del(f)}async rename(f,y,c){try{await D.Promises.rename(f.fsPath,y.fsPath)}catch(s){if(R.isWindows&&s&&s.code==="EPERM"&&Date.now()<c)return this.logService.info(`Failed renaming ${f} to ${y} with 'EPERM' error. Trying again...`),this.rename(f,y,c);throw s}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const y=[],c=[];for(const n of f.children){const t=E.ExtensionKey.parse(n.name);t&&c.push([t,n])}const s=(0,E.groupByExtension)(c,([n])=>n),e=[];for(const n of s)n.sort((t,r)=>v.rcompare(t[0].version,r[0].version)),y.push(...n.slice(1).map(t=>t[1].resource)),e.push(n[0][1]);e.sort((n,t)=>n.mtime-t.mtime),y.push(...e.slice(0,Math.max(0,e.length-this.cache)).map(n=>n.resource)),await C.Promises.settled(y.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?E.ExtensionKey.create(f).toString().toLowerCase():(0,d.generateUuid)()}};w=de([ce(0,L.INativeEnvironmentService),ce(1,b.IFileService),ce(2,g.IExtensionGalleryService),ce(3,h.ILogService)],w),i.ExtensionsDownloader=w}),define(ee[120],te([0,1,2,13,19,37]),function(B,i,C,I,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsManifestCache=void 0;class T extends C.Disposable{constructor(a,d){super();this.environmentService=a,this.extensionsManifestCache=(0,I.join)(this.environmentService.userDataPath,R.MANIFEST_CACHE_FOLDER,R.USER_MANIFEST_CACHE_FILE),this._register(d.onDidInstallExtensions(D=>this.onDidInstallExtensions(D))),this._register(d.onDidUninstallExtension(D=>this.onDidUnInstallExtension(D)))}onDidInstallExtensions(a){a.some(d=>!!d.local)&&this.invalidate()}onDidUnInstallExtension(a){a.error||this.invalidate()}invalidate(){P.Promises.rm(this.extensionsManifestCache,P.RimRafMode.MOVE).then(()=>{},()=>{})}}i.ExtensionsManifestCache=T}),define(ee[121],te([0,1,10,20,44,15,11,27]),function(B,i,C,I,P,R,T,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsScannerService=void 0;let a=class extends P.NativeExtensionsScannerService{constructor(D,L,g,E){super(C.URI.file(g.builtinExtensionsPath),C.URI.file(g.extensionsPath),g.userHome,C.URI.file(g.userDataPath),D,L,g,E)}};a=de([ce(0,R.IFileService),ce(1,T.ILogService),ce(2,I.INativeEnvironmentService),ce(3,v.IProductService)],a),i.ExtensionsScannerService=a}),define(ee[122],te([0,1,147,17,4,2,14,13,19,20,23,25,11,59]),function(B,i,C,I,P,R,T,v,a,d,D,L,g,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeLanguagePackService=void 0;let b=class extends E.LanguagePackBaseService{constructor(f,y,c,s){super(c);this.extensionManagementService=f,this.logService=s,this.cache=this._register(new h(y,s)),this.extensionManagementService.registerParticipant({postInstall:async e=>this.postInstallExtension(e),postUninstall:async e=>this.postUninstallExtension(e)})}async getInstalledLanguages(){const f=await this.cache.getLanguagePacks(),y=Object.keys(f).map(c=>{const s=f[c];return{...this.createQuickPickItem({locale:c,label:s.label}),extensionId:s.extensions[0].extensionIdentifier.id}});return y.push({...this.createQuickPickItem({locale:"en",label:"English"}),extensionId:"default"}),y}async postInstallExtension(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",f.identifier.id),await this.update())}async postUninstallExtension(f){const y=await this.cache.getLanguagePacks();Object.keys(y).some(c=>y[c]&&y[c].extensions.some(s=>(0,L.areSameExtensions)(s.extensionIdentifier,f.identifier)))&&(this.logService.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,y]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),c=await this.cache.update(y);return!(0,I.equals)(Object.keys(f),Object.keys(c))}};b=de([ce(0,D.IExtensionManagementService),ce(1,d.INativeEnvironmentService),ce(2,D.IExtensionGalleryService),ce(3,g.ILogService)],b),i.NativeLanguagePackService=b;let h=class extends R.Disposable{constructor(f,y){super();this.logService=y,this.languagePacks={},this.languagePacksFilePath=(0,v.join)(f.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new P.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(f){return this.withLanguagePacks(y=>{Object.keys(y).forEach(c=>delete y[c]),this.createLanguagePacksFromExtensions(y,...f)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(f,...y){for(const c of y)c&&c.manifest&&c.manifest.contributes&&c.manifest.contributes.localizations&&c.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(f,c);Object.keys(f).forEach(c=>this.updateHash(f[c]))}createLanguagePacksFromExtension(f,y){const c=y.identifier,s=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const e of s)if(y.location.scheme===T.Schemas.file&&w(e)){let n=f[e.languageId];n||(n={hash:"",extensions:[],translations:{},label:e.localizedLanguageName??e.languageName},f[e.languageId]=n);let t=n.extensions.filter(r=>(0,L.areSameExtensions)(r.extensionIdentifier,c))[0];t?t.version=y.manifest.version:n.extensions.push({extensionIdentifier:c,version:y.manifest.version});for(const r of e.translations)n.translations[r.id]=(0,v.join)(y.location.fsPath,r.path)}}updateHash(f){if(f){const y=(0,C.createHash)("md5");for(const c of f.extensions)y.update(c.extensionIdentifier.uuid||c.extensionIdentifier.id).update(c.version);f.hash=y.digest("hex")}}withLanguagePacks(f=()=>null){return this.languagePacksFileLimiter.queue(()=>{let y=null;return a.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,c=>c.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(c)).then(c=>{try{return JSON.parse(c)}catch{return{}}}).then(c=>(y=f(c),c)).then(c=>{for(const e of Object.keys(c))c[e]||delete c[e];this.languagePacks=c,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),a.Promises.writeFile(this.languagePacksFilePath,s)}).then(()=>y,c=>this.logService.error(c))})}};h=de([ce(0,d.INativeEnvironmentService),ce(1,g.ILogService)],h);function w(l){if(typeof l.languageId!="string"||!Array.isArray(l.translations)||l.translations.length===0)return!1;for(const f of l.translations)if(typeof f.id!="string"||typeof f.path!="string")return!1;return!(l.languageName&&typeof l.languageName!="string"||l.localizedLanguageName&&typeof l.localizedLanguageName!="string")}}),define(ee[45],te([0,1,16,93,36,12,30]),function(B,i,C,I,P,R,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.updateProxyConfigurationsScope=i.asJson=i.asTextOrError=i.asText=i.isSuccess=i.IRequestService=void 0,i.IRequestService=(0,R.createDecorator)("requestService");function v(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}i.isSuccess=v;function a(h){return h.res.statusCode===204}async function d(h){return a(h)?null:(await(0,C.streamToBuffer)(h.stream)).toString()}i.asText=d;async function D(h){if(!v(h))throw new Error("Server returned "+h.res.statusCode);return d(h)}i.asTextOrError=D;async function L(h){if(!v(h))throw new Error("Server returned "+h.res.statusCode);if(a(h))return null;const l=(await(0,C.streamToBuffer)(h.stream)).toString();try{return JSON.parse(l)}catch(f){throw f.message+=`:
`+l,f}}i.asJson=L;function g(h){b(h)}i.updateProxyConfigurationsScope=g;let E;function b(h){const w=T.Registry.as(P.Extensions.Configuration),l=E;E={id:"http",order:15,title:(0,I.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,I.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,I.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,I.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,I.localize)(4,null),(0,I.localize)(5,null),(0,I.localize)(6,null),(0,I.localize)(7,null)],default:"override",description:(0,I.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,I.localize)(9,null),restricted:!0}}},w.updateConfigurations({add:[E],remove:l?[l]:[]})}b(2)}),define(ee[123],te([0,1,24,14,15,45]),function(B,i,C,I,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DownloadService=void 0;let T=class{constructor(a,d){this.requestService=a,this.fileService=d}async download(a,d,D=C.CancellationToken.None){if(a.scheme===I.Schemas.file||a.scheme===I.Schemas.vscodeRemote){await this.fileService.copy(a,d);return}const L={type:"GET",url:a.toString()},g=await this.requestService.request(L,D);if(g.res.statusCode===200)await this.fileService.writeFile(d,g.stream);else{const E=await(0,R.asTextOrError)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${E}`)}}};T=de([ce(0,R.IRequestService),ce(1,P.IFileService)],T),i.DownloadService=T}),define(ee[124],te([0,1,125,7]),function(B,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getProxyAgent=void 0;function P(T,v){return T.protocol==="http:"?v.HTTP_PROXY||v.http_proxy||null:T.protocol==="https:"&&(v.HTTPS_PROXY||v.https_proxy||v.HTTP_PROXY||v.http_proxy)||null}async function R(T,v,a={}){const d=(0,C.parse)(T),D=a.proxyUrl||P(d,v);if(!D)return null;const L=(0,C.parse)(D);if(!/^https?:$/.test(L.protocol||""))return null;const g={host:L.hostname||"",port:L.port||(L.protocol==="https"?"443":"80"),auth:L.auth,rejectUnauthorized:(0,I.isBoolean)(a.strictSSL)?a.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((E,b)=>{B(["http-proxy-agent"],E,b)}))(g):new(await new Promise((E,b)=>{B(["https-proxy-agent"],E,b)}))(g)}i.getProxyAgent=R}),define(ee[126],te([0,1,41,13,94,24,28,9,8,32,78,148,4]),function(B,i,C,I,P,R,T,v,a,d,D,L,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getResolvedShellEnv=void 0;const E=1e4;let b;async function h(l,f,y){return f["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):a.isWindows?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,L.isLaunchedFromCli)(y)&&!f["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,L.isLaunchedFromCli)(y)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),b||(b=g.Promises.withAsyncBody(async(c,s)=>{const e=new R.CancellationTokenSource,n=setTimeout(()=>{e.dispose(!0),s(new Error((0,P.localize)(0,null)))},E);try{c(await w(l,e.token))}catch(t){!(0,v.isCancellationError)(t)&&!e.token.isCancellationRequested?s(new Error((0,P.localize)(1,null,(0,T.toErrorMessage)(t)))):c({})}finally{clearTimeout(n),e.dispose()}})),b)}i.getResolvedShellEnv=h;async function w(l,f){const y=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",y);const c=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",c);const s=(0,d.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(s+"(.*)"+s),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};l.trace("getUnixShellEnvironment#env",n);const t=await(0,D.getSystemShell)(a.OS,n);return l.trace("getUnixShellEnvironment#shell",t),new Promise((r,o)=>{if(f.isCancellationRequested)return o((0,v.canceled)());const u=(0,I.basename)(t);let m,p;const S=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(u)?(m=`& '${process.execPath}' ${S} -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,p=["-Login","-Command"]):(m=`'${process.execPath}' ${S} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,u==="tcsh"?p=["-ic"]:p=["-ilc"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(p),m);const A=(0,C.spawn)(t,[...p,m],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});f.onCancellationRequested(()=>(A.kill(),o((0,v.canceled)()))),A.on("error",Y=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(Y)),o(Y)});const V=[];A.stdout.on("data",Y=>V.push(Y));const ie=[];A.stderr.on("data",Y=>ie.push(Y)),A.on("close",(Y,ne)=>{const oe=Buffer.concat(V).toString("utf8");l.trace("getUnixShellEnvironment#raw",oe);const M=Buffer.concat(ie).toString("utf8");if(M.trim()&&l.trace("getUnixShellEnvironment#stderr",M),Y||ne)return o(new Error((0,P.localize)(2,null,Y,ne)));const x=e.exec(oe),G=x?x[1]:"{}";try{const _=JSON.parse(G);y?_.ELECTRON_RUN_AS_NODE=y:delete _.ELECTRON_RUN_AS_NODE,c?_.ELECTRON_NO_ATTACH_CONSOLE=c:delete _.ELECTRON_NO_ATTACH_CONSOLE,delete _.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",_),r(_)}catch(_){l.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(_)),o(_)}})})}}),define(ee[127],te([0,1,4,3,2,109,7,71,12]),function(B,i,C,I,P,R,T,v,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.logStorage=i.InMemoryStorageService=i.AbstractStorageService=i.StorageTarget=i.StorageScope=i.WillSaveStateReason=i.IStorageService=i.IS_NEW_KEY=void 0,i.IS_NEW_KEY="__$__isNewStorageMarker";const d="__$__targetStorageMarker";i.IStorageService=(0,a.createDecorator)("storageService");var D;(function(w){w[w.NONE=0]="NONE",w[w.SHUTDOWN=1]="SHUTDOWN"})(D=i.WillSaveStateReason||(i.WillSaveStateReason={}));var L;(function(w){w[w.GLOBAL=0]="GLOBAL",w[w.WORKSPACE=1]="WORKSPACE"})(L=i.StorageScope||(i.StorageScope={}));var g;(function(w){w[w.USER=0]="USER",w[w.MACHINE=1]="MACHINE"})(g=i.StorageTarget||(i.StorageTarget={}));class E extends P.Disposable{constructor(l={flushInterval:E.DEFAULT_FLUSH_INTERVAL}){super();this.options=l,this._onDidChangeValue=this._register(new I.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new I.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new I.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new C.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new P.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,C.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,P.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(l,f){f===d?(l===0?this._globalKeyTargets=void 0:l===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:l})):this._onDidChangeValue.fire({scope:l,key:f,target:this.getKeyTargets(l)[f]})}emitWillSaveState(l){this._onWillSaveState.fire({reason:l})}get(l,f,y){return this.getStorage(f)?.get(l,y)}getBoolean(l,f,y){return this.getStorage(f)?.getBoolean(l,y)}getNumber(l,f,y){return this.getStorage(f)?.getNumber(l,y)}store(l,f,y,c){if((0,T.isUndefinedOrNull)(f)){this.remove(l,y);return}this.withPausedEmitters(()=>{this.updateKeyTarget(l,y,c),this.getStorage(y)?.set(l,f)})}remove(l,f){this.withPausedEmitters(()=>{this.updateKeyTarget(l,f,void 0),this.getStorage(f)?.delete(l)})}withPausedEmitters(l){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{l()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(l,f){const y=[],c=this.getKeyTargets(l);for(const s of Object.keys(c))c[s]===f&&y.push(s);return y}updateKeyTarget(l,f,y){const c=this.getKeyTargets(f);typeof y=="number"?c[l]!==y&&(c[l]=y,this.getStorage(f)?.set(d,JSON.stringify(c))):typeof c[l]=="number"&&(delete c[l],this.getStorage(f)?.set(d,JSON.stringify(c)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(l){return l===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(l){const f=this.get(d,l);if(f)try{return JSON.parse(f)}catch{}return Object.create(null)}isNew(l){return this.getBoolean(i.IS_NEW_KEY,l)===!0}async flush(l=D.NONE){this._onWillSaveState.fire({reason:l});const f=this.getStorage(0),y=this.getStorage(1);switch(l){case D.NONE:await C.Promises.settled([f?.whenFlushed()??Promise.resolve(),y?.whenFlushed()??Promise.resolve()]);break;case D.SHUTDOWN:await C.Promises.settled([f?.flush(0)??Promise.resolve(),y?.flush(0)??Promise.resolve()]);break}}async logStorage(){const l=this.getStorage(0)?.items??new Map,f=this.getStorage(1)?.items??new Map;return h(l,f,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}i.AbstractStorageService=E,E.DEFAULT_FLUSH_INTERVAL=60*1e3;class b extends E{constructor(){super();this.globalStorage=this._register(new v.Storage(new v.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new v.Storage(new v.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(l=>this.emitDidChangeValue(1,l))),this._register(this.globalStorage.onDidChangeStorage(l=>this.emitDidChangeValue(0,l)))}getStorage(l){return l===0?this.globalStorage:this.workspaceStorage}getLogDetails(l){return l===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(l){}}i.InMemoryStorageService=b;async function h(w,l,f,y){const c=u=>{try{return JSON.parse(u)}catch{return u}},s=new Map,e=new Map;w.forEach((u,m)=>{s.set(m,u),e.set(m,c(u))});const n=new Map,t=new Map;l.forEach((u,m)=>{n.set(m,u),t.set(m,c(u))}),console.group(`Storage: Global (path: ${f})`);let r=[];s.forEach((u,m)=>{r.push({key:m,value:u})}),console.table(r),console.groupEnd(),console.log(e),console.group(`Storage: Workspace (path: ${y})`);let o=[];n.forEach((u,m)=>{o.push({key:m,value:u})}),console.table(o),console.groupEnd(),console.log(t)}i.logStorage=h}),define(ee[128],te([0,1,8,29,10,32]),function(B,i,C,I,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.verifyMicrosoftInternalDomain=i.resolveCommonProperties=void 0;function T(d){if(C.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function v(d,D,L,g,E,b,h,w,l,f){const y=Object.create(null);y["common.machineId"]=h,y.sessionID=(0,R.generateUuid)()+Date.now(),y.commitHash=E,y.version=b,y["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),y["common.platform"]=(0,C.PlatformToString)(C.platform),y["common.nodePlatform"]=I.platform,y["common.nodeArch"]=g,y["common.product"]=f||"desktop";const c=a(w||[]);c&&(y["common.msftInternal"]=c);let s=0;const e=Date.now();Object.defineProperties(y,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),C.isLinuxSnap&&(y["common.snap"]="true");const n=T(L);n&&(y["common.platformDetail"]=n);try{const t=await d.readFile(P.URI.file(l));y["common.source"]=t.value.toString().slice(0,30)}catch{}return y}i.resolveCommonProperties=v;function a(d){const D=I.env.USERDNSDOMAIN;if(!D)return!1;const L=D.toLowerCase();return d.some(g=>L===g)}i.verifyMicrosoftInternalDomain=a}),define(ee[31],te([0,1,12]),function(B,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryConfiguration=i.TelemetryLevel=i.TELEMETRY_OLD_SETTING_ID=i.TELEMETRY_SETTING_ID=i.TELEMETRY_SECTION_ID=i.machineIdKey=i.lastSessionDateStorageKey=i.firstSessionDateStorageKey=i.currentSessionDateStorageKey=i.ICustomEndpointTelemetryService=i.ITelemetryService=void 0,i.ITelemetryService=(0,C.createDecorator)("telemetryService"),i.ICustomEndpointTelemetryService=(0,C.createDecorator)("customEndpointTelemetryService"),i.currentSessionDateStorageKey="telemetry.currentSessionDate",i.firstSessionDateStorageKey="telemetry.firstSessionDate",i.lastSessionDateStorageKey="telemetry.lastSessionDate",i.machineIdKey="telemetry.machineId",i.TELEMETRY_SECTION_ID="telemetry",i.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",i.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var I;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(I=i.TelemetryLevel||(i.TelemetryLevel={}));var P;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(P=i.TelemetryConfiguration||(i.TelemetryConfiguration={}))}),define(ee[129],te([0,1,17,4,24,9,3,2,8,10,82,23,25,11,27,31]),function(B,i,C,I,P,R,T,v,a,d,D,L,g,E,b,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractExtensionTask=i.reportTelemetry=i.joinErrors=i.AbstractExtensionManagementService=void 0;let w=class extends v.Disposable{constructor(e,n,t,r){super();this.galleryService=e,this.telemetryService=n,this.logService=t,this.productService=r,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new T.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new T.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new T.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,v.toDisposable)(()=>{this.installingExtensions.forEach(o=>o.cancel()),this.uninstallingExtensions.forEach(o=>o.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(e){const n=await this.getTargetPlatform();return e.allTargetPlatforms.some(t=>(0,L.isTargetPlatformCompatible)(t,e.allTargetPlatforms,n))}async installFromGallery(e,n={}){try{if(!this.galleryService.isEnabled())throw new L.ExtensionManagementError(D.localize(0,null),L.ExtensionManagementErrorCode.Internal);const t=await this.checkAndGetCompatibleVersion(e,!!n.installGivenVersion,!!n.installPreReleaseVersion);return await this.installExtension(t.manifest,t.extension,n)}catch(t){throw y(this.telemetryService,"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(e),error:t}),this.logService.error("Failed to install extension.",e.identifier.id),this.logService.error(t),f(t)}}async uninstall(e,n={}){return this.logService.trace("ExtensionManagementService#uninstall",e.identifier.id),this.unininstallExtension(e,n)}async reinstallFromGallery(e){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",e.identifier.id),!this.galleryService.isEnabled())throw new Error(D.localize(1,null));const n=await this.getTargetPlatform(),[t]=await this.galleryService.getExtensions([{...e.identifier,preRelease:e.preRelease}],{targetPlatform:n,compatible:!0},P.CancellationToken.None);if(!t)throw new Error(D.localize(2,null));await this.createUninstallExtensionTask(e,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(t)}getExtensionsControlManifest(){const e=new Date().getTime();return(!this.extensionsControlManifest||e-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=e),this.extensionsControlManifest}registerParticipant(e){this.participants.push(e)}async installExtension(e,n,t){if(!d.URI.isUri(n)){let p=this.installingExtensions.get(g.ExtensionKey.create(n).toString());if(p)return this.logService.info("Extensions is already requested to install",n.identifier.id),p.waitUntilTaskIsFinished();t={...t,installOnlyNewlyAddedFromExtensionPack:!0}}const r=[],o=[],u=this.createInstallExtensionTask(e,n,t);d.URI.isUri(n)||this.installingExtensions.set(g.ExtensionKey.create(n).toString(),u),this._onInstallExtension.fire({identifier:u.identifier,source:n}),this.logService.info("Installing extension:",u.identifier.id),r.push({task:u,manifest:e});let m=!1;try{if(t.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",u.identifier.id);else try{const S=await this.getAllDepsAndPackExtensionsToInstall(u.identifier,e,!!t.installOnlyNewlyAddedFromExtensionPack,!!t.installPreReleaseVersion);for(const{gallery:A,manifest:V}of S){m=m||!!V.extensionDependencies?.some(Y=>(0,g.areSameExtensions)({id:Y},u.identifier));const ie=g.ExtensionKey.create(A).toString();if(this.installingExtensions.has(ie))this.logService.info("Extension is already requested to install",A.identifier.id);else{const Y=this.createInstallExtensionTask(V,A,{...t,donotIncludePackAndDependencies:!0});this.installingExtensions.set(ie,Y),this._onInstallExtension.fire({identifier:Y.identifier,source:A}),this.logService.info("Installing extension:",Y.identifier.id),r.push({task:Y,manifest:V})}}}catch(S){if(d.URI.isUri(u.source))(0,C.isNonEmptyArray)(e.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",u.identifier.id,S.message),(0,C.isNonEmptyArray)(e.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",u.identifier.id,S.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",u.identifier.id),S}const p=r.reduce((S,{task:A,manifest:V})=>(S.set(A.identifier.id.toLowerCase(),{task:A,manifest:V}),S),new Map);for(;p.size;){let S;const A=[...p.values()].filter(({manifest:V})=>!V.extensionDependencies?.some(ie=>p.has(ie.toLowerCase())));A.length?S=p.size===1?A:A.filter(({task:V})=>!(V===u&&!m)):(this.logService.info("Found extensions with circular dependencies",A.map(({task:V})=>V.identifier.id)),S=[...p.values()]),await this.joinAllSettled(S.map(async({task:V})=>{const ie=new Date().getTime();try{const Y=await V.run();if(await this.joinAllSettled(this.participants.map(ne=>ne.postInstall(Y,V.source,t,P.CancellationToken.None))),!d.URI.isUri(V.source)){const ne=V.operation===3;if(y(this.telemetryService,ne?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(V.source),duration:new Date().getTime()-ie,durationSinceUpdate:ne?void 0:new Date().getTime()-V.source.lastUpdated}),a.isWeb&&V.operation!==3)try{await this.galleryService.reportStatistic(Y.manifest.publisher,Y.manifest.name,Y.manifest.version,"install")}catch{}}o.push({local:Y,identifier:V.identifier,operation:V.operation,source:V.source})}catch(Y){throw d.URI.isUri(V.source)||y(this.telemetryService,V.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(V.source),duration:new Date().getTime()-ie,error:Y}),this.logService.error("Error while installing the extension:",V.identifier.id),Y}finally{p.delete(V.identifier.id.toLowerCase())}}))}return o.forEach(({identifier:S})=>this.logService.info("Extension installed successfully:",S.id)),this._onDidInstallExtensions.fire(o),o.filter(({identifier:S})=>(0,g.areSameExtensions)(S,u.identifier))[0].local}catch(p){if(r.forEach(({task:S})=>S.cancel()),o.length)try{const S=await Promise.allSettled(o.map(({local:A})=>this.createUninstallExtensionTask(A,{versionOnly:!0}).run()));for(let A=0;A<S.length;A++){const V=S[A],{identifier:ie}=o[A];V.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",ie.id):this.logService.warn("Rollback: Error while uninstalling extension",ie.id,(0,R.getErrorMessage)(V.reason))}}catch(S){this.logService.warn("Error while rolling back extensions",(0,R.getErrorMessage)(S),o.map(({identifier:A})=>A.id))}throw this._onDidInstallExtensions.fire(r.map(({task:S})=>({identifier:S.identifier,operation:2,source:S.source}))),p}finally{for(const{task:p}of r)if(!d.URI.isUri(p.source)){const S=g.ExtensionKey.create(p.source).toString();this.installingExtensions.delete(S)||this.logService.warn("Installation task is not found in the cache",S)}}}async joinAllSettled(e){const n=[],t=[],r=await Promise.allSettled(e);for(const o of r)o.status==="fulfilled"?n.push(o.value):t.push(o.reason);if(t.length)throw l(t);return n}async getAllDepsAndPackExtensionsToInstall(e,n,t,r){if(!this.galleryService.isEnabled())return[];let o=await this.getInstalled();const u=[e,...o.map(S=>S.identifier)],m=[],p=async(S,A)=>{const V=A.extensionDependencies||[],ie=[...V];if(A.extensionPack){const Y=t?o.find(ne=>(0,g.areSameExtensions)(ne.identifier,S)):void 0;for(const ne of A.extensionPack)Y&&Y.manifest.extensionPack&&Y.manifest.extensionPack.some(oe=>(0,g.areSameExtensions)({id:oe},{id:ne}))||ie.every(oe=>!(0,g.areSameExtensions)({id:oe},{id:ne}))&&ie.push(ne)}if(ie.length){const Y=[...u,...m.map(oe=>oe.gallery.identifier)],ne=ie.filter(oe=>Y.every(M=>!(0,g.areSameExtensions)(M,{id:oe})));if(ne.length){const oe=await this.galleryService.getExtensions(ne.map(M=>({id:M,preRelease:r})),P.CancellationToken.None);for(const M of oe){if(Y.find(_=>(0,g.areSameExtensions)(_,M.identifier)))continue;const x=V.some(_=>(0,g.areSameExtensions)({id:_},M.identifier));let G;try{G=await this.checkAndGetCompatibleVersion(M,!1,r)}catch(_){if(_ instanceof L.ExtensionManagementError&&_.code===L.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!x){this.logService.info("Skipping the packed extension as it cannot be installed",M.identifier.id);continue}else throw _}m.push({gallery:G.extension,manifest:G.manifest}),await p(G.extension.identifier,G.manifest)}}}};return await p(e,n),o=await this.getInstalled(),m.filter(S=>!o.some(A=>(0,g.areSameExtensions)(A.identifier,S.gallery.identifier)))}async checkAndGetCompatibleVersion(e,n,t){const r=await this.getExtensionsControlManifest();if((0,g.getMaliciousExtensionsSet)(r).has(e.identifier.id))throw new L.ExtensionManagementError(D.localize(3,null,e.identifier.id),L.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(e)){const m=await this.getTargetPlatform();throw new L.ExtensionManagementError(D.localize(4,null,e.identifier.id,this.productService.nameLong,(0,L.TargetPlatformToString)(m)),L.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const o=await this.getCompatibleVersion(e,n,t);if(o){if(t&&!n&&e.hasPreReleaseVersion&&!o.properties.isPreReleaseVersion)throw new L.ExtensionManagementError(D.localize(5,null,e.identifier.id,this.productService.nameLong,this.productService.version),L.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!t&&e.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([e.identifier],P.CancellationToken.None))[0]?new L.ExtensionManagementError(D.localize(6,null,e.identifier.id),L.ExtensionManagementErrorCode.ReleaseVersionNotFound):new L.ExtensionManagementError(D.localize(7,null,e.identifier.id,this.productService.nameLong,this.productService.version),L.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",o.identifier.id);const u=await this.galleryService.getManifest(o,P.CancellationToken.None);if(u===null)throw new L.ExtensionManagementError(`Missing manifest for extension ${e.identifier.id}`,L.ExtensionManagementErrorCode.Invalid);if(u.version!==o.version)throw new L.ExtensionManagementError(`Cannot install '${e.identifier.id}' extension because of version mismatch in Marketplace`,L.ExtensionManagementErrorCode.Invalid);return{extension:o,manifest:u}}async getCompatibleVersion(e,n,t){const r=await this.getTargetPlatform();let o=null;return!n&&e.hasPreReleaseVersion&&e.properties.isPreReleaseVersion!==t&&(o=(await this.galleryService.getExtensions([{...e.identifier,preRelease:t}],{targetPlatform:r,compatible:!0},P.CancellationToken.None))[0]||null),!o&&await this.galleryService.isExtensionCompatible(e,t,r)&&(o=e),o||(n?o=(await this.galleryService.getExtensions([{...e.identifier,version:e.version}],{targetPlatform:r,compatible:!0},P.CancellationToken.None))[0]||null:o=await this.galleryService.getCompatibleExtension(e,t,r)),o}async unininstallExtension(e,n){const t=this.uninstallingExtensions.get(e.identifier.id.toLowerCase());if(t)return this.logService.info("Extensions is already requested to uninstall",e.identifier.id),t.waitUntilTaskIsFinished();const r=(p,S)=>{const A=this.createUninstallExtensionTask(p,S);return this.uninstallingExtensions.set(A.extension.identifier.id.toLowerCase(),A),this.logService.info("Uninstalling extension:",p.identifier.id),this._onUninstallExtension.fire(p.identifier),A},o=(p,S)=>{S?this.logService.error("Failed to uninstall extension:",p.identifier.id,S.message):this.logService.info("Successfully uninstalled extension:",p.identifier.id),y(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,g.getLocalExtensionTelemetryData)(p),error:S}),this._onDidUninstallExtension.fire({identifier:p.identifier,error:S?.code})},u=[],m=[];try{u.push(r(e,{}));const p=await this.getInstalled(1);if(n.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",e.identifier.id);else{const S=this.getAllPackExtensionsToUninstall(e,p);for(const A of S)this.uninstallingExtensions.has(A.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",A.identifier.id):u.push(r(A,{}))}n.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",e.identifier.id):this.checkForDependents(u.map(S=>S.extension),p,e),await this.joinAllSettled(u.map(async S=>{try{if(await S.run(),await this.joinAllSettled(this.participants.map(A=>A.postUninstall(S.extension,n,P.CancellationToken.None))),S.extension.identifier.uuid)try{await this.galleryService.reportStatistic(S.extension.manifest.publisher,S.extension.manifest.name,S.extension.manifest.version,"uninstall")}catch{}o(S.extension)}catch(A){const V=A instanceof L.ExtensionManagementError?A:new L.ExtensionManagementError((0,R.getErrorMessage)(A),L.ExtensionManagementErrorCode.Internal);throw o(S.extension,V),V}finally{m.push(S)}}))}catch(p){const S=p instanceof L.ExtensionManagementError?p:new L.ExtensionManagementError((0,R.getErrorMessage)(p),L.ExtensionManagementErrorCode.Internal);for(const A of u){try{A.cancel()}catch{}m.includes(A)||o(A.extension,S)}throw S}finally{for(const p of u)this.uninstallingExtensions.delete(p.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",p.extension.identifier.id)}}checkForDependents(e,n,t){for(const r of e){const o=this.getDependents(r,n);if(o.length){const u=o.filter(m=>!e.some(p=>(0,g.areSameExtensions)(p.identifier,m.identifier)));if(u.length)throw new Error(this.getDependentsErrorMessage(r,u,t))}}}getDependentsErrorMessage(e,n,t){return t===e?n.length===1?D.localize(8,null,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?D.localize(9,null,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):D.localize(10,null,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?D.localize(11,null,t.manifest.displayName||t.manifest.name,e.manifest.displayName||e.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?D.localize(12,null,t.manifest.displayName||t.manifest.name,e.manifest.displayName||e.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):D.localize(13,null,t.manifest.displayName||t.manifest.name,e.manifest.displayName||e.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}getAllPackExtensionsToUninstall(e,n,t=[]){if(t.indexOf(e)!==-1)return[];t.push(e);const r=e.manifest.extensionPack?e.manifest.extensionPack:[];if(r.length){const o=n.filter(m=>!m.isBuiltin&&r.some(p=>(0,g.areSameExtensions)({id:p},m.identifier))),u=[];for(const m of o)u.push(...this.getAllPackExtensionsToUninstall(m,n,t));return[...o,...u]}return[]}getDependents(e,n){return n.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(r=>(0,g.areSameExtensions)({id:r},e.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const e=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",e),e}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};w=de([ce(0,L.IExtensionGalleryService),ce(1,h.ITelemetryService),ce(2,E.ILogService),ce(3,b.IProductService)],w),i.AbstractExtensionManagementService=w;function l(s){const e=Array.isArray(s)?s:[s];return e.length===1?e[0]instanceof Error?e[0]:new Error(e[0]):e.reduce((n,t)=>new Error(`${n.message}${n.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}i.joinErrors=l;function f(s){if(s instanceof L.ExtensionManagementError)return s;const e=new L.ExtensionManagementError(s.message,L.ExtensionManagementErrorCode.Internal);return e.stack=s.stack,e}function y(s,e,{extensionData:n,duration:t,error:r,durationSinceUpdate:o}){const u=r?r instanceof L.ExtensionManagementError?r.code:L.ExtensionManagementErrorCode.Internal:void 0;s.publicLog(e,{...n,success:!r,duration:t,errorcode:u,durationSinceUpdate:o})}i.reportTelemetry=y;class c{constructor(){this.barrier=new I.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,I.createCancelablePromise)(e=>this.doRun(e))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,I.createCancelablePromise)(e=>new Promise((n,t)=>{const r=e.onCancellationRequested(()=>{r.dispose(),t(new R.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}i.AbstractExtensionTask=c}),define(ee[38],te([0,1,21,49,7,22,31]),function(B,i,C,I,P,R,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getPiiPathsFromEnvironment=i.cleanRemoteAuthority=i.validateTelemetryData=i.getTelemetryLevel=i.supportsTelemetry=i.configurationTelemetry=i.NullAppender=i.NullEndpointTelemetryService=i.NullTelemetryService=i.NullTelemetryServiceShape=void 0;class v{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,I.staticObservableValue)(0)}publicLog(c,s){return Promise.resolve(void 0)}publicLog2(c,s){return this.publicLog(c,s)}publicLogError(c,s){return Promise.resolve(void 0)}publicLogError2(c,s){return this.publicLogError(c,s)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}i.NullTelemetryServiceShape=v,i.NullTelemetryService=new v;class a{async publicLog(c,s,e){}async publicLogError(c,s,e){}}i.NullEndpointTelemetryService=a,i.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function d(y,c){return c.onDidChangeConfiguration(s=>{s.source!==6&&y.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(s.source),configurationKeys:w(s.sourceConfig)})})}i.configurationTelemetry=d;function D(y,c){return!(c.disableTelemetry||!y.enableTelemetry||c.extensionTestsLocationURI)}i.supportsTelemetry=D;function L(y){const c=y.getValue(T.TELEMETRY_SETTING_ID),s=y.getValue("telemetry.enableCrashReporter");if(y.getValue(T.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}i.getTelemetryLevel=L;function g(y){const c=Object.create(null),s=Object.create(null),e=Object.create(null);h(y,e);for(let n in e){n=n.length>150?n.substr(n.length-149):n;const t=e[n];typeof t=="number"?s[n]=t:typeof t=="boolean"?s[n]=t?1:0:typeof t=="string"?(t.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${t.length}`),c[n]=t.substring(0,8191)):typeof t!="undefined"&&t!==null&&(c[n]=t)}return{properties:c,measurements:s}}i.validateTelemetryData=g;const E=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function b(y){if(!y)return"none";for(const c of E)if(y.startsWith(`${c}+`))return c;return"other"}i.cleanRemoteAuthority=b;function h(y,c,s=0,e){if(!!y)for(let n of Object.getOwnPropertyNames(y)){const t=y[n],r=e?e+n:n;Array.isArray(t)?c[r]=(0,C.safeStringify)(t):t instanceof Date?c[r]=t.toISOString():(0,P.isObject)(t)?s<2?h(t,c,s+1,r+"."):c[r]=(0,C.safeStringify)(t):c[r]=t}}function w(y){if(!y)return[];const c=[];return l(c,"",y),c}function l(y,c,s){s&&typeof s=="object"&&!Array.isArray(s)?Object.keys(s).forEach(e=>l(y,c?`${c}.${e}`:e,s[e])):y.push(c)}function f(y){return[y.appRoot,y.extensionsPath,y.userHome.fsPath,y.tmpDir.fsPath,y.userDataPath]}i.getPiiPathsFromEnvironment=f}),define(ee[130],te([0,1,99,38]),function(B,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.resolveMarketplaceHeaders=void 0;async function P(R,T,v,a,d,D){const L={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${T.nameShort})`},g=await(0,C.getServiceMachineId)(v,d,D);return(0,I.supportsTelemetry)(T,v)&&(0,I.getTelemetryLevel)(a)===3&&(L["X-Market-User-Id"]=g),L}i.resolveMarketplaceHeaders=P}),define(ee[131],te([0,1,17,24,9,21,8,29,7,10,22,20,23,25,42,15,11,27,45,130,127,31]),function(B,i,C,I,P,R,T,v,a,d,D,L,g,E,b,h,w,l,f,y,c,s){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionGalleryServiceWithNoStorageService=i.ExtensionGalleryService=i.sortExtensionVersions=void 0;const e=T.isWeb?"web":(0,g.getTargetPlatform)(T.platform,v.arch);var n;(function(j){j[j.None=0]="None",j[j.IncludeVersions=1]="IncludeVersions",j[j.IncludeFiles=2]="IncludeFiles",j[j.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",j[j.IncludeSharedAccounts=8]="IncludeSharedAccounts",j[j.IncludeVersionProperties=16]="IncludeVersionProperties",j[j.ExcludeNonValidated=32]="ExcludeNonValidated",j[j.IncludeInstallationTargets=64]="IncludeInstallationTargets",j[j.IncludeAssetUri=128]="IncludeAssetUri",j[j.IncludeStatistics=256]="IncludeStatistics",j[j.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",j[j.Unpublished=4096]="Unpublished",j[j.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function t(...j){return String(j.reduce((N,q)=>N|q,0))}var r;(function(j){j[j.Tag=1]="Tag",j[j.ExtensionId=4]="ExtensionId",j[j.Category=5]="Category",j[j.ExtensionName=7]="ExtensionName",j[j.Target=8]="Target",j[j.Featured=9]="Featured",j[j.SearchText=10]="SearchText",j[j.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},u={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},p={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class S{constructor(N=p){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(N,q=this.state.pageSize){return new S({...this.state,pageNumber:N,pageSize:q})}withFilter(N,...q){const X=[...this.state.criteria,...q.length?q.map(Q=>({filterType:N,value:Q})):[{filterType:N}]];return new S({...this.state,criteria:X})}withSortBy(N){return new S({...this.state,sortBy:N})}withSortOrder(N){return new S({...this.state,sortOrder:N})}withFlags(...N){return new S({...this.state,flags:N.reduce((q,X)=>q|X,0)})}withAssetTypes(...N){return new S({...this.state,assetTypes:N})}withSource(N){return new S({...this.state,source:N})}get raw(){const{criteria:N,pageNumber:q,pageSize:X,sortBy:Q,sortOrder:K,flags:se,assetTypes:ue}=this.state;return{filters:[{criteria:N,pageNumber:q,pageSize:X,sortBy:Q,sortOrder:K}],assetTypes:ue,flags:se}}get searchText(){const N=this.state.criteria.filter(q=>q.filterType===r.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function A(j,N){const q=(j||[]).filter(X=>X.statisticName===N)[0];return q?q.value:0}function V(j){const N="Microsoft.VisualStudio.Code.Translation.";return j.files.filter(X=>X.assetType.indexOf(N)===0).reduce((X,Q)=>{const K=ne(j,Q.assetType);return K&&X.push([Q.assetType.substring(N.length),K]),X},[])}function ie(j){if(j.properties){const N=j.properties.filter(Q=>Q.key===o.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),X=N.filter(Q=>q.test(Q.value))[0];return X?{uri:X.value,fallbackUri:X.value}:null}return ne(j,o.Repository)}function Y(j){return{uri:`${j.fallbackAssetUri}/${o.VSIX}?redirect=true${j.targetPlatform?`&targetPlatform=${j.targetPlatform}`:""}`,fallbackUri:`${j.fallbackAssetUri}/${o.VSIX}${j.targetPlatform?`?targetPlatform=${j.targetPlatform}`:""}`}}function ne(j,N){return j.files.filter(X=>X.assetType===N)[0]?{uri:`${j.assetUri}/${N}${j.targetPlatform?`?targetPlatform=${j.targetPlatform}`:""}`,fallbackUri:`${j.fallbackAssetUri}/${N}${j.targetPlatform?`?targetPlatform=${j.targetPlatform}`:""}`}:null}function oe(j,N){const q=j.properties?j.properties.filter(Q=>Q.key===N):[],X=q.length>0&&q[0].value;return X?X.split(",").map(Q=>(0,E.adoptToGalleryExtensionId)(Q)):[]}function M(j){const N=j.properties?j.properties.filter(q=>q.key===u.Engine):[];return N.length>0&&N[0].value||""}function x(j){const N=j.properties?j.properties.filter(q=>q.key===u.PreRelease):[];return N.length>0&&N[0].value==="true"}function G(j){const N=j.properties?j.properties.filter(X=>X.key===u.LocalizedLanguages):[],q=N.length>0&&N[0].value||"";return q?q.split(","):[]}function _(j){return j.properties?.find(N=>N.key===u.SponsorLink)?.value}function re(j){return j.indexOf("preview")!==-1}function k(j){return j.targetPlatform?(0,g.toTargetPlatform)(j.targetPlatform):"undefined"}function O(j){const N=(0,C.distinct)(j.versions.map(k)),q=!!j.tags?.includes(g.WEB_EXTENSION_TAG),X=N.indexOf("web");return q?X===-1&&N.push("web"):X!==-1&&N.splice(X,1),N}function F(j,N){const q=(0,g.getFallbackTargetPlarforms)(N);for(let X=0;X<j.length;X++){const Q=j[X];if(Q.version===j[X-1]?.version){let K=X;const se=k(Q);if(se===N)for(;K>0&&j[K-1].version===Q.version;)K--;else if(q.includes(se))for(;K>0&&j[K-1].version===Q.version&&k(j[K-1])!==N;)K--;K!==X&&(j.splice(X,1),j.splice(K,0,Q))}}return j}i.sortExtensionVersions=F;function U(j,N,q){j.telemetryData={index:N,querySource:q}}function $(j,N,q){const X=j.versions[0],Q={manifest:ne(N,o.Manifest),readme:ne(N,o.Details),changelog:ne(N,o.Changelog),license:ne(N,o.License),repository:ie(N),download:Y(N),icon:ne(N,o.Icon),coreTranslations:V(N)};return{identifier:{id:(0,E.getGalleryExtensionId)(j.publisher.publisherName,j.extensionName),uuid:j.extensionId},name:j.extensionName,version:N.version,displayName:j.displayName,publisherId:j.publisher.publisherId,publisher:j.publisher.publisherName,publisherDisplayName:j.publisher.displayName,publisherDomain:j.publisher.domain?{link:j.publisher.domain,verified:!!j.publisher.isDomainVerified}:void 0,publisherSponsorLink:_(X),description:j.shortDescription||"",installCount:A(j.statistics,"install"),rating:A(j.statistics,"averagerating"),ratingCount:A(j.statistics,"ratingcount"),categories:j.categories||[],tags:j.tags||[],releaseDate:Date.parse(j.releaseDate),lastUpdated:Date.parse(j.lastUpdated),allTargetPlatforms:q,assets:Q,properties:{dependencies:oe(N,u.Dependency),extensionPack:oe(N,u.ExtensionPack),engine:M(N),localizedLanguages:G(N),targetPlatform:k(N),isPreReleaseVersion:x(N)},hasPreReleaseVersion:x(X),hasReleaseVersion:!0,preview:re(j.flags)}}let W=class{constructor(N,q,X,Q,K,se,ue,me){this.requestService=q,this.logService=X,this.environmentService=Q,this.telemetryService=K,this.fileService=se,this.productService=ue,this.configurationService=me;const ge=ue.extensionsGallery;this.extensionsGalleryUrl=ge&&ge.serviceUrl,this.extensionsControlUrl=ge&&ge.controlUrl,this.commonHeadersPromise=(0,y.resolveMarketplaceHeaders)(ue.version,ue,this.environmentService,this.configurationService,this.fileService,N)}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,q,X){const Q=I.CancellationToken.isCancellationToken(q)?{}:q,K=I.CancellationToken.isCancellationToken(q)?q:X,se=[],ue=[],me=[],ge=[];let le=!0;for(const Ee of N){Ee.uuid?ue.push(Ee.uuid):se.push(Ee.id);const Pe=!!(Ee.version||Ee.preRelease);me.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Pe}),Ee.version&&ge.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),le=le&&!!Ee.hasPreRelease&&!Pe}if(!ue.length&&!se.length)return[];let he=new S().withPage(1,N.length);ue.length&&(he=he.withFilter(r.ExtensionId,...ue)),se.length&&(he=he.withFilter(r.ExtensionName,...se)),(Q.queryAllVersions||le)&&(he=he.withFlags(he.flags,n.IncludeVersions)),Q.source&&(he=he.withSource(Q.source));const{extensions:ve}=await this.queryGalleryExtensions(he,{targetPlatform:Q.targetPlatform??e,includePreRelease:me,versions:ge,compatible:!!Q.compatible},K);return Q.source&&ve.forEach((Ee,Pe)=>U(Ee,Pe,Q.source)),ve}async getCompatibleExtension(N,q,X){if((0,g.isNotWebExtensionInWebTargetPlatform)(N.allTargetPlatforms,X))return null;if(await this.isExtensionCompatible(N,q,X))return N;const Q=new S().withFlags(n.IncludeVersions).withPage(1,1).withFilter(r.ExtensionId,N.identifier.uuid),{extensions:K}=await this.queryGalleryExtensions(Q,{targetPlatform:X,compatible:!0,includePreRelease:q},I.CancellationToken.None);return K[0]||null}async isExtensionCompatible(N,q,X){if(!(0,g.isTargetPlatformCompatible)(N.properties.targetPlatform,N.allTargetPlatforms,X)||!q&&N.properties.isPreReleaseVersion)return!1;let Q=N.properties.engine;if(!Q){const K=await this.getManifest(N,I.CancellationToken.None);if(!K)throw new Error("Manifest was not found");Q=K.engines.vscode}return(0,b.isEngineValid)(Q,this.productService.version,this.productService.date)}async isValidVersion(N,q,X,Q,K){if(!(0,g.isTargetPlatformCompatible)(k(N),Q,K)||q!=="any"&&x(N)!==(q==="prerelease"))return!1;if(X)try{const se=await this.getEngine(N);if(!(0,b.isEngineValid)(se,this.productService.version,this.productService.date))return!1}catch(se){return this.logService.error(`Error while getting the engine for the version ${N.version}.`,(0,P.getErrorMessage)(se)),!1}return!0}async query(N,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let X=N.text||"";const Q=(0,R.getOrDefault)(N,le=>le.pageSize,50);let K=new S().withPage(1,Q);X?(X=X.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,he,ve)=>(K=K.withFilter(r.Category,ve||he),"")),X=X.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,he,ve)=>(K=K.withFilter(r.Tag,ve||he),"")),X=X.replace(/\bfeatured(\s+|\b|$)/g,()=>(K=K.withFilter(r.Featured),"")),X=X.trim(),X&&(X=X.length<200?X:X.substring(0,200),K=K.withFilter(r.SearchText,X)),K=K.withSortBy(0)):N.ids?K=K.withFilter(r.ExtensionId,...N.ids):N.names?K=K.withFilter(r.ExtensionName,...N.names):K=K.withSortBy(4),typeof N.sortBy=="number"&&(K=K.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(K=K.withSortOrder(N.sortOrder)),N.source&&(K=K.withSource(N.source));const se=async(le,he)=>{const{extensions:ve,total:Ee}=await this.queryGalleryExtensions(le,{targetPlatform:e,compatible:!1,includePreRelease:!!N.includePreRelease},he);return ve.forEach((Pe,Me)=>U(Pe,(le.pageNumber-1)*le.pageSize+Me,N.source)),{extensions:ve,total:Ee}},{extensions:ue,total:me}=await se(K,q),ge=async(le,he)=>{if(he.isCancellationRequested)throw new P.CancellationError;const{extensions:ve}=await se(K.withPage(le+1),he);return ve};return{firstPage:ue,total:me,pageSize:K.pageSize,getPage:ge}}async queryGalleryExtensions(N,q,X){const Q=N.flags;!!(N.flags&n.IncludeLatestVersionOnly)&&!!(N.flags&n.IncludeVersions)&&(N=N.withFlags(N.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(N.flags&n.IncludeLatestVersionOnly)&&!(N.flags&n.IncludeVersions)&&(N=N.withFlags(N.flags,n.IncludeLatestVersionOnly)),q.versions?.length&&(N=N.withFlags(N.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),N=N.withFlags(N.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:K,total:se}=await this.queryRawGalleryExtensions(N,X);if(!(N.flags&n.IncludeLatestVersionOnly)){const le=[];for(const he of K){const ve=await this.toGalleryExtensionWithCriteria(he,q);ve&&le.push(ve)}return{extensions:le,total:se}}const me=[],ge=new Map;for(let le=0;le<K.length;le++){const he=K[le],ve={id:(0,E.getGalleryExtensionId)(he.publisher.publisherName,he.extensionName),uuid:he.extensionId},Ee=(0,a.isBoolean)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(Me=>(0,E.areSameExtensions)(Me,ve))?.includePreRelease;if(q.compatible&&(0,g.isNotWebExtensionInWebTargetPlatform)(O(he),q.targetPlatform))continue;const Pe=await this.toGalleryExtensionWithCriteria(he,q);!Pe||Pe.properties.isPreReleaseVersion&&(!Ee||!Pe.hasReleaseVersion)||!Pe.properties.isPreReleaseVersion&&Pe.properties.targetPlatform!==q.targetPlatform&&Pe.hasPreReleaseVersion?ge.set(he.extensionId,le):me.push([le,Pe])}if(ge.size){const le=new Date().getTime(),he=new S().withFlags(Q&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,ge.size).withFilter(r.ExtensionId,...ge.keys()),{extensions:ve}=await this.queryGalleryExtensions(he,q,X);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-le,count:ge.size});for(const Ee of ve){const Pe=ge.get(Ee.identifier.uuid);me.push([Pe,Ee])}}return{extensions:me.sort((le,he)=>le[0]-he[0]).map(([,le])=>le),total:se}}async toGalleryExtensionWithCriteria(N,q){const X={id:(0,E.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},Q=q.versions?.find(me=>(0,E.areSameExtensions)(me,X))?.version,K=(0,a.isBoolean)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(me=>(0,E.areSameExtensions)(me,X))?.includePreRelease,se=O(N),ue=F(N.versions,q.targetPlatform);if(q.compatible&&(0,g.isNotWebExtensionInWebTargetPlatform)(se,q.targetPlatform))return null;for(let me=0;me<ue.length;me++){const ge=ue[me];if(!(Q&&ge.version!==Q)){if(await this.isValidVersion(ge,K?"any":"release",q.compatible,se,q.targetPlatform))return $(N,ge,se);if(Q&&ge.version===Q)return null}}return Q||q.compatible?null:$(N,N.versions[0],se)}async queryRawGalleryExtensions(N,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,n.ExcludeNonValidated).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExcludeWithFlags,t(n.Unpublished));const X=await this.commonHeadersPromise,Q=JSON.stringify(N.raw),K={...X,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Q.length)},se=new Date().getTime();let ue,me,ge=0;try{if(ue=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Q,headers:K},q),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:ge};const le=await(0,f.asJson)(ue);if(le){const he=le.results[0],ve=he.extensions,Ee=he.resultMetadata&&he.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return ge=Ee&&Ee.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:ve,total:ge}}return{galleryExtensions:[],total:ge}}catch(le){throw me=le,le}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(Q.length),duration:new Date().getTime()-se,success:!!ue&&(0,f.isSuccess)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:me?(0,P.isCancellationError)(me)?"canceled":(0,P.getErrorMessage)(me).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ge)})}}async reportStatistic(N,q,X,Q){if(!this.isEnabled())return;const K=T.isWeb?this.api(`/itemName/${N}.${q}/version/${X}/statType/${Q==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${N}/extensions/${q}/${X}/stats?statType=${Q}`),se=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.commonHeadersPromise,Accept:se};try{await this.requestService.request({type:"POST",url:K,headers:me},I.CancellationToken.None)}catch{}}async download(N,q,X){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const Q=(0,E.getGalleryExtensionTelemetryData)(N),K=new Date().getTime(),se=le=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...Q,duration:le}),ue=X===2?"install":X===3?"update":"",me=ue?{uri:`${N.assets.download.uri}${d.URI.parse(N.assets.download.uri).query?"&":"?"}${ue}=true`,fallbackUri:`${N.assets.download.fallbackUri}${d.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${ue}=true`}:N.assets.download,ge=await this.getAsset(me);await this.fileService.writeFile(q,ge.stream),se(new Date().getTime()-K)}async getReadme(N,q){if(N.assets.readme){const X=await this.getAsset(N.assets.readme,{},q);return await(0,f.asTextOrError)(X)||""}return""}async getManifest(N,q){if(N.assets.manifest){const X=await this.getAsset(N.assets.manifest,{},q),Q=await(0,f.asTextOrError)(X);return Q?JSON.parse(Q):null}return null}async getManifestFromRawExtensionVersion(N,q){const X=ne(N,o.Manifest);if(!X)throw new Error("Manifest was not found");const Q={"Accept-Encoding":"gzip"},K=await this.getAsset(X,{headers:Q});return await(0,f.asJson)(K)}async getCoreTranslation(N,q){const X=N.assets.coreTranslations.filter(Q=>Q[0]===q.toUpperCase())[0];if(X){const Q=await this.getAsset(X[1]),K=await(0,f.asTextOrError)(Q);return K?JSON.parse(K):null}return null}async getChangelog(N,q){if(N.assets.changelog){const X=await this.getAsset(N.assets.changelog,{},q);return await(0,f.asTextOrError)(X)||""}return""}async getAllCompatibleVersions(N,q,X){let Q=new S().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);N.identifier.uuid?Q=Q.withFilter(r.ExtensionId,N.identifier.uuid):Q=Q.withFilter(r.ExtensionName,N.identifier.id);const{galleryExtensions:K}=await this.queryRawGalleryExtensions(Q,I.CancellationToken.None);if(!K.length)return[];const se=O(K[0]);if((0,g.isNotWebExtensionInWebTargetPlatform)(se,X))return[];const ue=[];await Promise.all(K[0].versions.map(async le=>{try{await this.isValidVersion(le,q?"any":"release",!0,se,X)&&ue.push(le)}catch{}}));const me=[],ge=new Set;for(const le of F(ue,X))ge.has(le.version)||(ge.add(le.version),me.push({version:le.version,date:le.lastUpdated,isPreReleaseVersion:x(le)}));return me}async getAsset(N,q={},X=I.CancellationToken.None){const Q=await this.commonHeadersPromise,K={type:"GET"},se={...Q,...q.headers||{}};q={...q,...K,headers:se};const ue=N.uri,me=N.fallbackUri,ge={...q,url:ue};try{const le=await this.requestService.request(ge,X);if(le.res.statusCode===200)return le;const he=await(0,f.asTextOrError)(le);throw new Error(`Expected 200, got back ${le.res.statusCode} instead.

${he}`)}catch(le){if((0,P.isCancellationError)(le))throw le;const he=(0,P.getErrorMessage)(le);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ue,message:he});const ve={...q,url:me};return this.requestService.request(ve,X)}}async getEngine(N){let q=M(N);if(!q){const X=await this.getManifestFromRawExtensionVersion(N,I.CancellationToken.None);if(!X)throw new Error("Manifest was not found");q=X.engines.vscode}return q}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},I.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,f.asJson)(N),X=[],Q={};if(q){for(const K of q.malicious)X.push({id:K});if(q.migrateToPreRelease)for(const[K,se]of Object.entries(q.migrateToPreRelease))(!se.engine||(0,b.isEngineValid)(se.engine,this.productService.version,this.productService.date))&&(Q[K.toLowerCase()]={disallowInstall:!0,extension:{id:se.id,displayName:se.displayName,autoMigrate:{storage:!!se.migrateStorage},preRelease:!0}});if(q.deprecated)for(const[K,se]of Object.entries(q.deprecated))se&&(Q[K.toLowerCase()]=(0,a.isBoolean)(se)?{}:se)}return{malicious:X,deprecated:Q}}};W=de([ce(1,f.IRequestService),ce(2,w.ILogService),ce(3,L.IEnvironmentService),ce(4,s.ITelemetryService),ce(5,h.IFileService),ce(6,l.IProductService),ce(7,D.IConfigurationService)],W);let ae=class extends W{constructor(N,q,X,Q,K,se,ue,me){super(N,q,X,Q,K,se,ue,me)}};ae=de([ce(0,c.IStorageService),ce(1,f.IRequestService),ce(2,w.ILogService),ce(3,L.IEnvironmentService),ce(4,s.ITelemetryService),ce(5,h.IFileService),ce(6,l.IProductService),ce(7,D.IConfigurationService)],ae),i.ExtensionGalleryService=ae;let Z=class extends W{constructor(N,q,X,Q,K,se,ue){super(void 0,N,q,X,Q,K,se,ue)}};Z=de([ce(0,f.IRequestService),ce(1,w.ILogService),ce(2,L.IEnvironmentService),ce(3,s.ITelemetryService),ce(4,h.IFileService),ce(5,l.IProductService),ce(6,D.IConfigurationService)],Z),i.ExtensionGalleryServiceWithNoStorageService=Z}),define(ee[132],te([0,1,2,21,49,8,26,95,22,36,133,27,30,31,38]),function(B,i,C,I,P,R,T,v,a,d,D,L,g,E,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryService=void 0;let h=class{constructor(f,y,c){this._configurationService=y,this._productService=c,this._experimentProperties={},this.telemetryLevel=new P.MutableObservableValue(3),this._disposables=new C.DisposableStore,this._cleanupPatterns=[],this._appenders=f.appenders,this._commonProperties=f.commonProperties||Promise.resolve({}),this._piiPaths=f.piiPaths||[],this._sendErrorTelemetry=!!f.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let s of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(s),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(f,y){this._experimentProperties[f]=y}_updateTelemetryLevel(){let f=(0,b.getTelemetryLevel)(this._configurationService);const y=this._productService.enabledTelemetryLevels;if(y){this._sendErrorTelemetry=this.sendErrorTelemetry?y.error:!1;const c=y.usage?3:y.error?2:0;f=Math.min(f,c)}this.telemetryLevel.value=f}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const f=await this._commonProperties;let y=f.sessionID,c=f["common.machineId"],s=f["common.firstSessionDate"],e=f["common.msftInternal"];return{sessionId:y,machineId:c,firstSessionDate:s,msftInternal:e}}dispose(){this._disposables.dispose()}_log(f,y,c,s){return this.telemetryLevel.value<y?Promise.resolve(void 0):this._commonProperties.then(e=>{c=(0,I.mixin)(c,e),c=(0,I.mixin)(c,this._experimentProperties),c=(0,I.cloneAndChange)(c,n=>{if(typeof n=="string")return this._cleanupInfo(n,s)}),this._appenders.forEach(n=>n.log(f,c))},e=>{console.error(e)})}publicLog(f,y,c){return this._log(f,3,y,c)}publicLog2(f,y,c){return this.publicLog(f,y,c)}publicLogError(f,y){return this._sendErrorTelemetry?this._log(f,2,y,!0):Promise.resolve(void 0)}publicLogError2(f,y){return this.publicLogError(f,y)}_anonymizeFilePaths(f){let y=f;const c=[];for(let t of this._cleanupPatterns)for(;;){const r=t.exec(f);if(!r)break;c.push([r.index,t.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,e=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let n=0;for(y="";;){const t=e.exec(f);if(!t)break;!s.test(t[0])&&c.every(([r,o])=>t.index<r||t.index>=o)&&(y+=f.substring(n,t.index)+"<REDACTED: user-file-path>",n=e.lastIndex)}return n<f.length&&(y+=f.substr(n)),y}_removePropertiesWithPossibleUserInfo(f){if(!f)return f;const y=f.toLowerCase(),c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const s of c)if(s.regex.test(y))return`<REDACTED: ${s.label}>`;return f}_cleanupInfo(f,y){let c=f;y&&(c=this._anonymizeFilePaths(c));for(let s of this._cleanupPatterns)c=c.replace(s,"");return c=this._removePropertiesWithPossibleUserInfo(c),c}};h.IDLE_START_EVENT_NAME="UserIdleStart",h.IDLE_STOP_EVENT_NAME="UserIdleStop",h=de([ce(1,a.IConfigurationService),ce(2,L.IProductService)],h),i.TelemetryService=h;function w(){const l=(0,v.localize)(0,null,D.default.nameLong),f=D.default.privacyStatementUrl?(0,v.localize)(2,null,"https://aka.ms/vscode-telemetry",D.default.privacyStatementUrl):(0,v.localize)(1,null,"https://aka.ms/vscode-telemetry"),y=R.isWeb?"":(0,v.localize)(3,null),c=(0,v.localize)(4,null),s=(0,v.localize)(5,null),e=(0,v.localize)(6,null),n=(0,v.localize)(7,null),t=`
|       | ${c} | ${s} | ${e} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,v.localize)(8,null);return`
${l} ${f} ${y}

&nbsp;

${n}
${t}

&nbsp;

${r}
`}g.Registry.as(d.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,v.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,v.localize)(10,null),(0,v.localize)(11,null),(0,v.localize)(12,null),(0,v.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),g.Registry.as(d.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,v.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:D.default.privacyStatementUrl?(0,v.localize)(16,null,D.default.nameLong,D.default.privacyStatementUrl):(0,v.localize)(15,null,D.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,v.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[134],te([0,1,9,21,38]),function(B,i,C,I,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AppInsightsAppender=void 0;async function R(v){const a=await new Promise((D,L)=>{B(["applicationinsights"],D,L)});let d;return a.defaultClient?(d=new a.TelemetryClient(v),d.channel.setUseDiskRetryCaching(!0)):(a.setup(v).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),d=a.defaultClient),v.indexOf("AIF-")===0&&(d.config.endpointUrl="https://mobile.events.data.microsoft.com/collect/v1"),d}class T{constructor(a,d,D){this._eventPrefix=a,this._defaultData=d,this._defaultData||(this._defaultData=Object.create(null)),typeof D=="function"?this._aiClient=D():this._aiClient=D,this._asyncAIClient=null}_withAIClient(a){if(!!this._aiClient){if(typeof this._aiClient!="string"){a(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=R(this._aiClient)),this._asyncAIClient.then(d=>{a(d)},d=>{(0,C.onUnexpectedError)(d),console.error(d)})}}log(a,d){if(!!this._aiClient){d=(0,I.mixin)(d,this._defaultData),d=(0,P.validateTelemetryData)(d);try{this._withAIClient(D=>D.trackEvent({name:this._eventPrefix+"/"+a,properties:d.properties,measurements:d.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(a=>{this._withAIClient(d=>{try{d.flush({callback:()=>{this._aiClient=void 0,a(void 0)}})}catch{}})}):Promise.resolve(void 0)}}i.AppInsightsAppender=T}),define(ee[135],te([0,1,13,19]),function(B,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buildTelemetryMessage=void 0;async function P(R,T){const v=Object.create(null),a=(D,L)=>{const g=JSON.parse(D);v[L]=g};if(T){const D=[],L=await I.Promises.readdir(T);for(const E of L)try{(await I.Promises.stat((0,C.join)(T,E))).isDirectory()&&D.push(E)}catch{}const g=[];for(const E of D)(await I.Promises.readdir((0,C.join)(T,E))).filter(h=>h==="telemetry.json").length===1&&g.push(E);for(const E of g){const b=(await I.Promises.readFile((0,C.join)(T,E,"telemetry.json"))).toString();a(b,E)}}let d=(await I.Promises.readFile((0,C.join)(R,"telemetry-core.json"))).toString();return a(d,"vscode-core"),d=(await I.Promises.readFile((0,C.join)(R,"telemetry-extensions.json"))).toString(),a(d,"vscode-extensions"),JSON.stringify(v,null,4)}i.buildTelemetryMessage=P}),define(ee[39],te([0,1,12]),function(B,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IUriIdentityService=void 0,i.IUriIdentityService=(0,C.createDecorator)("IUriIdentityService")}),define(ee[136],te([0,1,3,2,10,20,25,15,11,39]),function(B,i,C,I,P,R,T,v,a,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsWatcher=void 0;let D=class extends I.Disposable{constructor(g,E,b,h,w){super();this.extensionsManagementService=g,this.logService=h,this.uriIdentityService=w,this._onDidChangeExtensionsByAnotherSource=this._register(new C.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(f=>{this.installedExtensions=f.map(y=>y.identifier),this.startTimestamp=Date.now()}),this._register(g.onInstallExtension(f=>this.onInstallExtension(f))),this._register(g.onDidInstallExtensions(f=>this.onDidInstallExtensions(f))),this._register(g.onDidUninstallExtension(f=>this.onDidUninstallExtension(f)));const l=P.URI.file(b.extensionsPath);this._register(E.watch(l)),this._register(C.Event.filter(E.onDidFilesChange,f=>f.rawChanges.some(y=>this.doesChangeAffects(y,l)))(()=>this.onDidChange()))}doesChangeAffects(g,E){return g.type!==1&&g.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(g.resource),E)?!1:this.uriIdentityService.extUri.isEqual(g.resource,this.uriIdentityService.extUri.joinPath(E,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(g.resource).startsWith(".")}onInstallExtension(g){this.addInstallingExtension(g.identifier)}onDidInstallExtensions(g){for(const E of g)this.removeInstallingExtension(E.identifier),E.local&&this.addInstalledExtension(E.identifier)}onDidUninstallExtension(g){g.error||this.removeInstalledExtension(g.identifier)}addInstallingExtension(g){this.removeInstallingExtension(g),this.installingExtensions.push(g)}removeInstallingExtension(g){this.installingExtensions=this.installingExtensions.filter(E=>!(0,T.areSameExtensions)(E,g))}addInstalledExtension(g){this.installedExtensions&&(this.removeInstalledExtension(g),this.installedExtensions.push(g))}removeInstalledExtension(g){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(E=>!(0,T.areSameExtensions)(E,g)))}async onDidChange(){if(this.installedExtensions){const g=await this.extensionsManagementService.getInstalled(),E=g.filter(h=>[...this.installingExtensions,...this.installedExtensions].some(w=>(0,T.areSameExtensions)(w,h.identifier))?!1:h.installedTimestamp&&h.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",h.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",h.identifier.id),!1)),b=this.installedExtensions.filter(h=>this.installingExtensions.some(w=>(0,T.areSameExtensions)(w,h))?!1:g.every(w=>!(0,T.areSameExtensions)(w.identifier,h))?(this.logService.info("Detected extension removed from another source",h.id),!0):!1);this.installedExtensions=g.map(h=>h.identifier),(E.length||b.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:E,removed:b})}}};D=de([ce(1,v.IFileService),ce(2,R.INativeEnvironmentService),ce(3,a.ILogService),ce(4,d.IUriIdentityService)],D),i.ExtensionsWatcher=D}),define(ee[137],te([0,1,39,100,15,18,65,3,2]),function(B,i,C,I,P,R,T,v,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UriIdentityService=void 0;class d{constructor(g){this.uri=g,this.time=d._clock++}touch(){return this.time=d._clock++,this}}d._clock=0;let D=class{constructor(g){this._fileService=g,this._dispooables=new a.DisposableStore,this._limit=2**16;const E=new Map,b=h=>{let w=E.get(h.scheme);return w===void 0&&(w=g.hasProvider(h)&&!this._fileService.hasCapability(h,1024),E.set(h.scheme,w)),w};this._dispooables.add(v.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(h=>{E.delete(h.scheme)})),this.extUri=new R.ExtUri(b),this._canonicalUris=new T.SkipList((h,w)=>this.extUri.compare(h,w,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(g){this._fileService.hasProvider(g)&&(g=(0,R.normalizePath)(g));let E=this._canonicalUris.get(g);return E?E.touch().uri.with({fragment:g.fragment}):(this._canonicalUris.set(g,new d(g)),this._checkTrim(),g)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const g=[...this._canonicalUris.entries()].sort((b,h)=>b[1].touch<h[1].touch?1:b[1].touch>h[1].touch?-1:0);d._clock=0,this._canonicalUris.clear();const E=this._limit*.5;for(let b=0;b<E;b++)this._canonicalUris.set(g[b][0],g[b][1].touch())}};D=de([ce(0,P.IFileService)],D),i.UriIdentityService=D,(0,I.registerSingleton)(C.IUriIdentityService,D,!0)}),define(ee[138],te([0,1,33,4,149,2]),function(B,i,C,I,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativePolicyService=void 0;class T extends C.AbstractPolicyService{constructor(a){super();this.productName=a,this.throttler=new I.Throttler,this.watcher=this._register(new R.MutableDisposable)}async initializePolicies(a){await this.throttler.queue(()=>new Promise((d,D)=>{try{this.watcher.value=(0,P.createWatcher)(this.productName,a,L=>{for(const g in L){const E=L[g];E===void 0?this.policies.delete(g):this.policies.set(g,E)}this._onDidChange.fire(Object.keys(L)),d()})}catch(L){D(L)}}))}}i.NativePolicyService=T}),define(ee[63],te([0,1,111,4,13,7,19,80,150,151]),function(B,i,C,I,P,R,T,v,a,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buffer=i.extract=i.zip=i.ExtractError=void 0;class D extends Error{constructor(e,n){let t=n.message;switch(e){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t);this.type=e,this.cause=n}}i.ExtractError=D;function L(s){const e=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>e&n).reduce((n,t)=>n+t,e&61440)}function g(s){if(s instanceof D)return s;let e;return/end of central directory record signature not found/.test(s.message)&&(e="CorruptZip"),new D(e,s)}function E(s,e,n,t,r,o){const u=P.dirname(e),m=P.join(t,u);if(!m.startsWith(t))return Promise.reject(new Error(v.localize(0,null,e)));const p=P.join(t,e);let S;return o.onCancellationRequested(()=>{S&&S.destroy()}),Promise.resolve(T.Promises.mkdir(m,{recursive:!0})).then(()=>new Promise((A,V)=>{if(!o.isCancellationRequested)try{S=(0,C.createWriteStream)(p,{mode:n}),S.once("close",()=>A()),S.once("error",V),s.once("error",V),s.pipe(S)}catch(ie){V(ie)}}))}function b(s,e,n,t){let r=(0,I.createCancelablePromise)(()=>Promise.resolve()),o=0;return t.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((u,m)=>{const p=new I.Sequencer,S=A=>{A.isCancellationRequested||(o++,s.readEntry())};s.once("error",m),s.once("close",()=>r.then(()=>{t.isCancellationRequested||s.entryCount===o?u():m(new D("Incomplete",new Error(v.localize(1,null,o,s.entryCount))))},m)),s.readEntry(),s.on("entry",A=>{if(t.isCancellationRequested)return;if(!n.sourcePathRegex.test(A.fileName)){S(t);return}const V=A.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(V)){const ne=P.join(e,V);r=(0,I.createCancelablePromise)(oe=>T.Promises.mkdir(ne,{recursive:!0}).then(()=>S(oe)).then(void 0,m));return}const ie=w(s,A),Y=L(A);r=(0,I.createCancelablePromise)(ne=>p.queue(()=>ie.then(oe=>E(oe,V,Y,e,n,ne).then(()=>S(ne)))).then(null,m))})})}function h(s,e=!1){return new Promise((n,t)=>{(0,a.open)(s,e?{lazyEntries:!0}:void 0,(r,o)=>{r?t(g(r)):n((0,R.assertIsDefined)(o))})})}function w(s,e){return new Promise((n,t)=>{s.openReadStream(e,(r,o)=>{r?t(g(r)):n((0,R.assertIsDefined)(o))})})}function l(s,e){return new Promise((n,t)=>{const r=new d.ZipFile;e.forEach(u=>{u.contents?r.addBuffer(typeof u.contents=="string"?Buffer.from(u.contents,"utf8"):u.contents,u.path):u.localPath&&r.addFile(u.localPath,u.path)}),r.end();const o=(0,C.createWriteStream)(s);r.outputStream.pipe(o),r.outputStream.once("error",t),o.once("error",t),o.once("finish",()=>n(s))})}i.zip=l;function f(s,e,n={},t){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let o=h(s,!0);return n.overwrite&&(o=o.then(u=>T.Promises.rm(e).then(()=>u))),o.then(u=>b(u,e,{sourcePathRegex:r},t))}i.extract=f;function y(s,e){return h(s).then(n=>new Promise((t,r)=>{n.on("entry",o=>{o.fileName===e&&w(n,o).then(u=>t(u),u=>r(u))}),n.once("close",()=>r(new Error(v.localize(2,null,e))))}))}function c(s,e){return y(s,e).then(n=>new Promise((t,r)=>{const o=[];n.once("error",r),n.on("data",u=>o.push(u)),n.on("end",()=>t(Buffer.concat(o)))}))}i.buffer=c}),define(ee[139],te([0,1,63,87]),function(B,i,C,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getManifest=void 0;function P(R){return(0,C.buffer)(R,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,I.localize)(0,null))}})}i.getManifest=P}),define(ee[140],te([0,1,4,28,9,2,14,13,8,18,35,7,10,32,19,63,86,55,20,129,23,25,44,119,106,139,120,136,42,15,12,11,27,31,39]),function(B,i,C,I,P,R,T,v,a,d,D,L,g,E,b,h,w,l,f,y,c,s,e,n,t,r,o,u,m,p,S,A,V,ie,Y){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementService=void 0;let ne=class extends y.AbstractExtensionManagementService{constructor(k,O,F,U,$,W,ae,Z,j){super(k,O,F,Z);this.environmentService=U,this.downloadService=$,this.fileService=ae;const N=this._register(W.createInstance(t.ExtensionsLifecycle));this.extensionsScanner=this._register(W.createInstance(oe,X=>N.postUninstall(X))),this.manifestCache=this._register(new o.ExtensionsManifestCache(U,this)),this.extensionsDownloader=this._register(W.createInstance(n.ExtensionsDownloader));const q=this._register(new u.ExtensionsWatcher(this,ae,U,F,j));this._register(q.onDidChangeExtensionsByAnotherSource(({added:X,removed:Q})=>{X.length&&this._onDidInstallExtensions.fire(X.map(K=>({identifier:K.identifier,operation:1,local:K}))),Q.forEach(K=>this._onDidUninstallExtension.fire({identifier:K}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,s.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(k){this.logService.trace("ExtensionManagementService#zip",k.identifier.id);const O=await this.collectFiles(k),F=await(0,h.zip)((0,d.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)()).fsPath,O);return g.URI.file(F)}async unzip(k){return this.logService.trace("ExtensionManagementService#unzip",k.toString()),(await this.install(k)).identifier}async getManifest(k){const O=await this.downloadVsix(k),F=v.resolve(O.fsPath);return(0,r.getManifest)(F)}getInstalled(k=null){return this.extensionsScanner.scanExtensions(k)}async install(k,O={}){this.logService.trace("ExtensionManagementService#install",k.toString());const F=await this.downloadVsix(k),U=await(0,r.getManifest)(v.resolve(F.fsPath));if(U.engines&&U.engines.vscode&&!(0,m.isEngineValid)(U.engines.vscode,this.productService.version,this.productService.date))throw new Error(w.localize(0,null,(0,s.getGalleryExtensionId)(U.publisher,U.name),this.productService.version));return this.installExtension(U,F,O)}async updateMetadata(k,O){this.logService.trace("ExtensionManagementService#updateMetadata",k.identifier.id);const F={...O};return O.isPreReleaseVersion&&(F.preRelease=!0),k=await this.extensionsScanner.updateMetadata(k,F),this.manifestCache.invalidate(),k}async updateExtensionScope(k,O){return this.logService.trace("ExtensionManagementService#updateExtensionScope",k.identifier.id),k=await this.extensionsScanner.updateMetadata(k,{isMachineScoped:O}),this.manifestCache.invalidate(),k}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(k){if(k.scheme===T.Schemas.file)return k;const O=(0,d.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)());return await this.downloadService.download(k,O),O}createInstallExtensionTask(k,O,F){return g.URI.isUri(O)?new G(k,O,F,this.galleryService,this.extensionsScanner,this.logService):new x(O,F,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(k,O){return new _(k,O,this.extensionsScanner)}async collectFiles(k){const O=async U=>{let $=await b.Promises.readdir(U);$=$.map(Z=>v.join(U,Z));const W=await Promise.all($.map(Z=>b.Promises.stat(Z)));let ae=Promise.resolve([]);return W.forEach((Z,j)=>{const N=$[j];Z.isFile()&&(ae=ae.then(q=>[...q,N])),Z.isDirectory()&&(ae=ae.then(q=>O(N).then(X=>[...q,...X])))}),ae};return(await O(k.location.fsPath)).map(U=>({path:`extension/${v.relative(k.location.fsPath,U)}`,localPath:U}))}};ne=de([ce(0,c.IExtensionGalleryService),ce(1,ie.ITelemetryService),ce(2,A.ILogService),ce(3,f.INativeEnvironmentService),ce(4,l.IDownloadService),ce(5,S.IInstantiationService),ce(6,p.IFileService),ce(7,V.IProductService),ce(8,Y.IUriIdentityService)],ne),i.ExtensionManagementService=ne;let oe=class extends R.Disposable{constructor(k,O,F,U){super();this.beforeRemovingExtension=k,this.fileService=O,this.extensionsScannerService=F,this.logService=U,this.uninstalledPath=(0,d.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new C.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(k){const O={includeInvalid:!0};let F=[];return k===null||k===0?F.push(...await this.extensionsScannerService.scanAllExtensions(O)):k===1&&F.push(...await this.extensionsScannerService.scanUserExtensions(O)),F=k!==null?F.filter(U=>U.type===k):F,Promise.all(F.map(U=>this.toLocalExtension(U)))}async scanUserExtensions(k){const O=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!k,includeInvalid:!0});return Promise.all(O.map(F=>this.toLocalExtension(F)))}async extractUserExtension(k,O,F,U){const $=k.toString(),W=v.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,E.generateUuid)()}`),ae=v.join(this.extensionsScannerService.userExtensionsLocation.fsPath,$);try{await b.Promises.rm(ae)}catch{throw new c.ExtensionManagementError(w.localize(1,null,ae,k.id),c.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(k,O,W,U),await this.extensionsScannerService.updateMetadata(g.URI.file(W),{...F,installedTimestamp:Date.now()});try{await this.rename(k,W,ae,Date.now()+2*60*1e3),this.logService.info("Renamed to",ae)}catch(Z){try{await b.Promises.rm(W)}catch{}if(Z.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",k.id);else throw this.logService.info(`Rename failed because of ${(0,P.getErrorMessage)(Z)}. Deleted from extracted location`,W),Z}return this.scanLocalExtension(g.URI.file(ae),1)}async updateMetadata(k,O){return await this.extensionsScannerService.updateMetadata(k.location,O),this.scanLocalExtension(k.location,k.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...k){const O=k.map(F=>s.ExtensionKey.create(F));await this.withUninstalledExtensions(F=>{O.forEach(U=>F[U.toString()]=!0)})}async setInstalled(k){await this.withUninstalledExtensions(U=>delete U[k.toString()]);const F=(await this.scanUserExtensions(!0)).find(U=>s.ExtensionKey.create(U).equals(k))||null;return F?this.updateMetadata(F,{installedTimestamp:Date.now()}):null}async removeExtension(k,O){this.logService.trace(`Deleting ${O} extension from disk`,k.identifier.id,k.location.fsPath),await b.Promises.rm(k.location.fsPath),this.logService.info("Deleted from disk",k.identifier.id,k.location.fsPath)}async removeUninstalledExtension(k){await this.removeExtension(k,"uninstalled"),await this.withUninstalledExtensions(O=>delete O[s.ExtensionKey.create(k).toString()])}async withUninstalledExtensions(k){return this.uninstalledFileLimiter.queue(async()=>{let O;try{O=await b.Promises.readFile(this.uninstalledPath,"utf8")}catch(U){if(U.code!=="ENOENT")throw U}let F={};if(O)try{F=JSON.parse(O)}catch{}return k&&(k(F),Object.keys(F).length?await b.Promises.writeFile(this.uninstalledPath,JSON.stringify(F)):await b.Promises.rm(this.uninstalledPath)),F})}async extractAtLocation(k,O,F,U){this.logService.trace(`Started extracting the extension from ${O} to ${F}`);try{await b.Promises.rm(F)}catch($){throw new c.ExtensionManagementError(this.joinErrors($).message,c.ExtensionManagementErrorCode.Delete)}try{await(0,h.extract)(O,F,{sourcePath:"extension",overwrite:!0},U),this.logService.info(`Extracted extension to ${F}:`,k.id)}catch($){try{await b.Promises.rm(F)}catch{}let W=c.ExtensionManagementErrorCode.Extract;throw $ instanceof h.ExtractError&&($.type==="CorruptZip"?W=c.ExtensionManagementErrorCode.CorruptZip:$.type==="Incomplete"&&(W=c.ExtensionManagementErrorCode.IncompleteZip)),new c.ExtensionManagementError($.message,W)}}async rename(k,O,F,U){try{await b.Promises.rename(O,F)}catch($){if(a.isWindows&&$&&$.code==="EPERM"&&Date.now()<U)return this.logService.info(`Failed renaming ${O} to ${F} with 'EPERM' error. Trying again...`,k.id),this.rename(k,O,F,U);throw new c.ExtensionManagementError($.message||w.localize(2,null,O,F),$.code||c.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(k,O){const F=await this.extensionsScannerService.scanExistingExtension(k,O,{includeInvalid:!0});if(F)return this.toLocalExtension(F);throw new Error(w.localize(3,null,k.path))}async toLocalExtension(k){const O=await this.fileService.resolve(k.location);let F,U;return O.children&&(F=O.children.find(({name:$})=>/^readme(\.txt|\.md|)$/i.test($))?.resource,U=O.children.find(({name:$})=>/^changelog(\.txt|\.md|)$/i.test($))?.resource),{identifier:k.identifier,type:k.type,isBuiltin:k.isBuiltin||!!k.metadata?.isBuiltin,location:k.location,manifest:k.manifest,targetPlatform:k.targetPlatform,validations:k.validations,isValid:k.isValid,readmeUrl:F,changelogUrl:U,publisherDisplayName:k.metadata?.publisherDisplayName||null,publisherId:k.metadata?.publisherId||null,isMachineScoped:!!k.metadata?.isMachineScoped,isPreReleaseVersion:!!k.metadata?.isPreReleaseVersion,preRelease:!!k.metadata?.preRelease,installedTimestamp:k.metadata?.installedTimestamp,updated:!!k.metadata?.updated}}async removeUninstalledExtensions(){const k=await this.getUninstalledExtensions(),O=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),F=new Set;for(const W of O)k[s.ExtensionKey.create(W).toString()]||F.add(W.identifier.id.toLowerCase());const U=(0,s.groupByExtension)(O,W=>W.identifier);await C.Promises.settled(U.map(async W=>{const ae=W.sort((Z,j)=>D.rcompare(Z.manifest.version,j.manifest.version))[0];F.has(ae.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(ae))}));const $=O.filter(W=>k[s.ExtensionKey.create(W).toString()]);await C.Promises.settled($.map(W=>this.removeUninstalledExtension(W)))}async removeOutdatedExtensions(){const k=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),O=[],F=await this.extensionsScannerService.getTargetPlatform(),U=(0,s.groupByExtension)(k,$=>$.identifier);O.push(...U.map($=>$.sort((W,ae)=>{const Z=D.rcompare(W.manifest.version,ae.manifest.version);return Z!==0?Z:W.targetPlatform===F?-1:1}).slice(1)).flat()),await C.Promises.settled(O.map($=>this.removeExtension($,"outdated")))}joinErrors(k){const O=Array.isArray(k)?k:[k];return O.length===1?O[0]instanceof Error?O[0]:new Error(O[0]):O.reduce((F,U)=>new Error(`${F.message}${F.message?",":""}${U instanceof Error?U.message:U}`),new Error(""))}};oe=de([ce(1,p.IFileService),ce(2,e.IExtensionsScannerService),ce(3,A.ILogService)],oe);class M extends y.AbstractExtensionTask{constructor(k,O,F,U,$){super();this.identifier=k,this.source=O,this.options=F,this.extensionsScanner=U,this.logService=$,this._operation=2}get operation(){return(0,L.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(k,O){try{const F=await this.unsetUninstalledAndGetLocal(k.key);if(F)return k.metadata?this.extensionsScanner.updateMetadata(F,k.metadata):F}catch{throw a.isMacintosh?new c.ExtensionManagementError(w.localize(4,null),c.ExtensionManagementErrorCode.Internal):new c.ExtensionManagementError(w.localize(5,null),c.ExtensionManagementErrorCode.Internal)}return this.extract(k,O)}async unsetUninstalledAndGetLocal(k){if(!await this.isUninstalled(k))return null;this.logService.trace("Removing the extension from uninstalled list:",k.id);const F=await this.extensionsScanner.setInstalled(k);return this.logService.info("Removed the extension from uninstalled list:",k.id),F}async isUninstalled(k){return!!(await this.extensionsScanner.getUninstalledExtensions())[k.toString()]}async extract({zipPath:k,key:O,metadata:F},U){let $=await this.extensionsScanner.extractUserExtension(O,k,F,U);return this.logService.info("Extracting completed.",O.id),$}}class x extends M{constructor(k,O,F,U,$){super(k.identifier,k,O,U,$);this.gallery=k,this.extensionsDownloader=F}async doRun(k){const F=(await this.extensionsScanner.scanExtensions(null)).find($=>(0,s.areSameExtensions)($.identifier,this.gallery.identifier));F&&(this._operation=3);const U=await this.downloadInstallableExtension(this.gallery,this._operation);U.metadata.isMachineScoped=this.options.isMachineScoped||F?.isMachineScoped,U.metadata.isBuiltin=this.options.isBuiltin||F?.isBuiltin,U.metadata.isSystem=F?.type===0?!0:void 0,U.metadata.updated=!!F,U.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,U.metadata.preRelease=this.gallery.properties.isPreReleaseVersion||((0,L.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:F?.preRelease);try{const $=await this.installExtension(U,k);return F&&(F.targetPlatform!==$.targetPlatform||D.neq(F.manifest.version,$.manifest.version))&&await this.extensionsScanner.setUninstalled(F),$}catch($){throw await this.deleteDownloadedVSIX(U.zipPath),$}}async deleteDownloadedVSIX(k){try{await this.extensionsDownloader.delete(g.URI.file(k))}catch(O){this.logService.warn("Error while deleting the downloaded vsix",k.toString(),(0,P.getErrorMessage)(O))}}async downloadInstallableExtension(k,O){const F={id:k.identifier.uuid,publisherId:k.publisherId,publisherDisplayName:k.publisherDisplayName,targetPlatform:k.properties.targetPlatform};let U;try{this.logService.trace("Started downloading extension:",k.identifier.id),U=(await this.extensionsDownloader.downloadExtension(k,O)).fsPath,this.logService.info("Downloaded extension:",k.identifier.id,U)}catch($){throw new c.ExtensionManagementError((0,y.joinErrors)($).message,c.ExtensionManagementErrorCode.Download)}try{return await(0,r.getManifest)(U),{zipPath:U,key:s.ExtensionKey.create(k),metadata:F}}catch($){throw await this.deleteDownloadedVSIX(U),new c.ExtensionManagementError((0,y.joinErrors)($).message,c.ExtensionManagementErrorCode.Invalid)}}}class G extends M{constructor(k,O,F,U,$,W){super({id:(0,s.getGalleryExtensionId)(k.publisher,k.name)},O,F,$,W);this.manifest=k,this.location=O,this.galleryService=U}async doRun(k){const O=new s.ExtensionKey(this.identifier,this.manifest.version),U=(await this.extensionsScanner.scanExtensions(1)).find(W=>(0,s.areSameExtensions)(this.identifier,W.identifier)),$=await this.getMetadata(this.identifier.id,this.manifest.version,k);if($.isMachineScoped=this.options.isMachineScoped||U?.isMachineScoped,$.isBuiltin=this.options.isBuiltin||U?.isBuiltin,U)if(this._operation=3,O.equals(new s.ExtensionKey(U.identifier,U.manifest.version)))try{await this.extensionsScanner.removeExtension(U,"existing")}catch{throw new Error(w.localize(6,null,this.manifest.displayName||this.manifest.name))}else D.gt(U.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(U);else{const W=await this.unsetUninstalledAndGetLocal(O);if(W)try{await this.extensionsScanner.removeExtension(W,"existing")}catch{throw new Error(w.localize(7,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:v.resolve(this.location.fsPath),key:O,metadata:$},k)}async getMetadata(k,O,F){try{let[U]=await this.galleryService.getExtensions([{id:k,version:O}],F);if(U||([U]=await this.galleryService.getExtensions([{id:k}],F)),U)return{id:U.identifier.uuid,publisherDisplayName:U.publisherDisplayName,publisherId:U.publisherId,isPreReleaseVersion:U.properties.isPreReleaseVersion,preRelease:U.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class _ extends y.AbstractExtensionTask{constructor(k,O,F){super();this.extension=k,this.options=O,this.extensionsScanner=F}async doRun(k){const O=[],F=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const U=s.ExtensionKey.create(this.extension);O.push(...F.filter($=>U.equals(s.ExtensionKey.create($))))}else O.push(...F.filter(U=>(0,s.areSameExtensions)(U.identifier,this.extension.identifier)));if(!O.length)throw new Error(w.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...O),this.options.remove)for(const U of O)try{k.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(U)}catch($){throw new Error(w.localize(9,null,(0,I.toErrorMessage)($)))}}}}),define(ee[141],te([0,1,125,4,16,9,2,7,22,20,126,11,124,152]),function(B,i,C,I,P,R,T,v,a,d,D,L,g,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.RequestService=void 0;let b=class extends T.Disposable{constructor(w,l,f){super();this.environmentService=l,this.logService=f,this.configure(w.getValue()),this._register(w.onDidChangeConfiguration(()=>this.configure(w.getValue()),this))}configure(w){this.proxyUrl=w.http&&w.http.proxy,this.strictSSL=!!(w.http&&w.http.proxyStrictSSL),this.authorization=w.http&&w.http.proxyAuthorization}async request(w,l){this.logService.trace("RequestService#request (node) - begin",w.url);const{proxyUrl:f,strictSSL:y}=this;let c;try{c=await(0,D.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(n){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",n))}const s={...process.env,...c},e=w.agent?w.agent:await(0,g.getProxyAgent)(w.url||"",s,{proxyUrl:f,strictSSL:y});w.agent=e,w.strictSSL=y,this.authorization&&(w.headers={...w.headers||{},"Proxy-Authorization":this.authorization});try{const n=await this._request(w,l);return this.logService.trace("RequestService#request (node) - success",w.url),n}catch(n){throw this.logService.trace("RequestService#request (node) - error",w.url,n),n}}async getNodeRequest(w){return((0,C.parse)(w.url).protocol==="https:"?await new Promise((y,c)=>{B(["https"],y,c)}):await new Promise((y,c)=>{B(["http"],y,c)})).request}_request(w,l){return I.Promises.withAsyncBody(async(f,y)=>{let c;const s=(0,C.parse)(w.url),e=w.getRawRequest?w.getRawRequest(w):await this.getNodeRequest(w),n={hostname:s.hostname,port:s.port?parseInt(s.port):s.protocol==="https:"?443:80,protocol:s.protocol,path:s.path,method:w.type||"GET",headers:w.headers,agent:w.agent,rejectUnauthorized:(0,v.isBoolean)(w.strictSSL)?w.strictSSL:!0};w.user&&w.password&&(n.auth=w.user+":"+w.password),c=e(n,t=>{const r=(0,v.isNumber)(w.followRedirects)?w.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&r>0&&t.headers.location)this._request({...w,url:t.headers.location,followRedirects:r-1},l).then(f,y);else{let o=t;t.headers["content-encoding"]==="gzip"&&(o=t.pipe((0,E.createGunzip)())),f({res:t,stream:(0,P.streamToBufferReadableStream)(o)})}}),c.on("error",y),w.timeout&&c.setTimeout(w.timeout),w.data&&typeof w.data=="string"&&c.write(w.data),c.end(),l.onCancellationRequested(()=>{c.abort(),y((0,R.canceled)())})})}async resolveProxy(w){}};b=de([ce(0,a.IConfigurationService),ce(1,d.INativeEnvironmentService),ce(2,L.ILogService)],b),i.RequestService=b}),define(ee[153],te([0,1,34,4,16,28,9,2,14,13,8,29,18,10,19,22,116,55,123,20,98,131,23,118,44,140,121,15,108,110,43,105,58,59,122,11,112,113,33,138,133,27,45,141,128,31,132,38,134,135,39,137]),function(B,i,C,I,P,R,T,v,a,d,D,L,g,E,b,h,w,l,f,y,c,s,e,n,t,r,o,u,m,p,S,A,V,ie,Y,ne,oe,M,x,G,_,re,k,O,F,U,$,W,ae,Z,j,N){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.main=void 0;class q extends v.Disposable{constructor(K){super();this.argv=K,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[K,se]=await this.initServices();return K.invokeFunction(async ue=>{const me=ue.get(ne.ILogService),ge=ue.get(u.IFileService),le=ue.get(y.INativeEnvironmentService),he=ue.get(e.IExtensionManagementCLIService);me.info("CLI main",this.argv),this.registerErrorHandler(me),await this.doRun(le,he,ge),await Promise.all(se.map(ve=>{(0,I.raceTimeout)(ve.flush(),1e3)}))})}async initServices(){const K=new V.ServiceCollection,se={_serviceBrand:void 0,..._.default};K.set(re.IProductService,se);const ue=new c.NativeEnvironmentService(this.argv,se);K.set(y.INativeEnvironmentService,ue),await Promise.all([ue.appSettingsHome.fsPath,ue.extensionsPath].map(Ue=>Ue?b.Promises.mkdir(Ue,{recursive:!0}):void 0));const me=(0,ne.getLogLevel)(ue),ge=[];ge.push(new oe.SpdLogLogger("cli",(0,d.join)(ue.logsPath,"cli.log"),!0,!1,me)),me===ne.LogLevel.Trace&&ge.push(new ne.ConsoleLogger(me));const le=this._register(new ne.MultiplexLogService(ge));K.set(ne.ILogService,le);const he=this._register(new m.FileService(le));K.set(u.IFileService,he);const ve=this._register(new p.DiskFileSystemProvider(le));he.registerProvider(a.Schemas.file,ve);const Ee=D.isWindows&&se.win32RegValueName?this._register(new G.NativePolicyService(se.win32RegValueName)):ue.policyFile?this._register(new M.FilePolicyService(ue.policyFile,he,le)):new x.NullPolicyService;K.set(x.IPolicyService,Ee);const Pe=this._register(new w.ConfigurationService(ue.settingsResource,he,Ee,le));K.set(h.IConfigurationService,Pe),await Pe.initialize(),K.set(j.IUriIdentityService,new N.UriIdentityService(he)),K.set(k.IRequestService,new S.SyncDescriptor(O.RequestService)),K.set(l.IDownloadService,new S.SyncDescriptor(f.DownloadService)),K.set(t.IExtensionsScannerService,new S.SyncDescriptor(o.ExtensionsScannerService)),K.set(e.IExtensionManagementService,new S.SyncDescriptor(r.ExtensionManagementService)),K.set(e.IExtensionGalleryService,new S.SyncDescriptor(s.ExtensionGalleryServiceWithNoStorageService)),K.set(e.IExtensionManagementCLIService,new S.SyncDescriptor(n.ExtensionManagementCLIService)),K.set(ie.ILanguagePackService,new S.SyncDescriptor(Y.NativeLanguagePackService));const Me=[];if((0,W.supportsTelemetry)(se,ue)){se.aiConfig&&se.aiConfig.asimovKey&&Me.push(new ae.AppInsightsAppender("monacoworkbench",null,se.aiConfig.asimovKey));const{installSourcePath:Ue}=ue,ze={appenders:Me,sendErrorTelemetry:!1,commonProperties:(async()=>{let z;try{const H=await b.Promises.readFile((0,g.joinPath)(ue.globalStorageHome,"storage.json").fsPath);z=JSON.parse(H.toString())[U.machineIdKey]}catch(H){H.code!=="ENOENT"&&le.error(H)}return(0,F.resolveCommonProperties)(he,(0,C.release)(),(0,C.hostname)(),process.arch,se.commit,se.version,z,se.msftInternalDomains,Ue)})(),piiPaths:(0,W.getPiiPathsFromEnvironment)(ue)};K.set(U.ITelemetryService,new S.SyncDescriptor($.TelemetryService,[ze]))}else K.set(U.ITelemetryService,W.NullTelemetryService);return[new A.InstantiationService(K),Me]}registerErrorHandler(K){(0,T.setUnexpectedErrorHandler)(se=>{const ue=(0,R.toErrorMessage)(se,!0);!ue||K.error(`[uncaught exception in CLI]: ${ue}`)}),process.on("uncaughtException",se=>(0,T.onUnexpectedError)(se)),process.on("unhandledRejection",se=>(0,T.onUnexpectedError)(se))}async doRun(K,se,ue){if(this.argv["install-source"])return this.setInstallSource(K,ue,this.argv["install-source"]);if(this.argv["list-extensions"])return se.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const me={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"]};return se.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],me,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return se.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return se.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,Z.buildTelemetryMessage)(K.appRoot,K.extensionsPath))}}asExtensionIdOrVSIX(K){return K.map(se=>/\.vsix$/i.test(se)?E.URI.file((0,d.isAbsolute)(se)?se:(0,d.join)((0,L.cwd)(),se)):se)}async setInstallSource(K,se,ue){await se.writeFile(E.URI.file(K.installSourcePath),P.VSBuffer.fromString(ue.slice(0,30)))}}async function X(Q){const K=new q(Q);try{await K.run()}finally{K.dispose()}}i.main=X})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/30d9c6cd9483b2cc586687151bcbcd635f373630/core/vs/code/node/cliProcessMain.js.map
