/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/base/common/errors","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/path","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/platform","vs/base/common/buffer","vs/base/common/map","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/collections","vs/base/common/uuid","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/instantiation/common/serviceCollection","vs/base/common/process","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testItemCollection","vs/editor/common/languages","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/mime","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/base/common/hash","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/textModelDefaults","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/base/common/linkedList","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ie=function(J){for(var e=[],s=0,C=J.length;s<C;s++)e[s]=De[J[s]];return e};define(De[42],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function s(C,p){if(!C)throw new Error(p?`Assertion failed (${p})`:"Assertion Failed")}e.ok=s}),define(De[43],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const s=Object.prototype.hasOwnProperty;function C(O){const w=[];for(let g in O)s.call(O,g)&&w.push(O[g]);return w}e.values=C;function p(O,w){for(let g in O)if(s.call(O,g)&&w({key:g,value:O[g]},function(){delete O[g]})===!1)return}e.forEach=p;function U(O,w){const g=Object.create(null);for(const S of O){const f=w(S);let c=g[f];c||(c=g[f]=[]),c.push(S)}return g}e.groupBy=U;function T(O){const w=Object.create(null);return O&&O.forEach((g,S)=>{w[S]=g}),w}e.fromMap=T;function P(O,w){const g=[],S=[];for(let f of O)w.has(f)||g.push(f);for(let f of w)O.has(f)||S.push(f);return{removed:g,added:S}}e.diffSets=P;function b(O,w){const g=[],S=[];for(let[f,c]of O)w.has(f)||g.push(c);for(let[f,c]of w)O.has(f)||S.push(c);return{removed:g,added:S}}e.diffMaps=b;class A{constructor(){this.map=new Map}add(w,g){let S=this.map.get(w);S||(S=new Set,this.map.set(w,S)),S.add(g)}delete(w,g){const S=this.map.get(w);!S||(S.delete(g),S.size===0&&this.map.delete(w))}forEach(w,g){const S=this.map.get(w);!S||S.forEach(g)}}e.SetMap=A}),define(De[55],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function s(T){return(P,b,A)=>{let O=null,w=null;if(typeof A.value=="function"?(O="value",w=A.value):typeof A.get=="function"&&(O="get",w=A.get),!w)throw new Error("not supported");A[O]=T(w,b)}}e.createDecorator=s;function C(T,P,b){let A=null,O=null;if(typeof b.value=="function"?(A="value",O=b.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(A="get",O=b.get),!O)throw new Error("not supported");const w=`$memoize$${P}`;b[A]=function(...g){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,g)}),this[w]}}e.memoize=C;function p(T,P,b){return s((A,O)=>{const w=`$debounce$${O}`,g=`$debounce$result$${O}`;return function(...S){this[g]||(this[g]=b?b():void 0),clearTimeout(this[w]),P&&(this[g]=P(this[g],...S),S=[this[g]]),this[w]=setTimeout(()=>{A.apply(this,S),this[g]=b?b():void 0},T)}})}e.debounce=p;function U(T,P,b){return s((A,O)=>{const w=`$throttle$timer$${O}`,g=`$throttle$result$${O}`,S=`$throttle$lastRun$${O}`,f=`$throttle$pending$${O}`;return function(...c){if(this[g]||(this[g]=b?b():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),P&&(this[g]=P(this[g],...c)),this[f])return;const h=this[S]+T;h<=Date.now()?(this[S]=Date.now(),A.apply(this,[this[g]]),this[g]=b?b():void 0):(this[f]=!0,this[w]=setTimeout(()=>{this[f]=!1,this[S]=Date.now(),A.apply(this,[this[g]]),this[g]=b?b():void 0},h-Date.now()))}})}e.throttle=U}),define(De[56],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class s{constructor(p){this._prefix=p,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=s,e.defaultGenerator=new s("id#")}),define(De[104],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var s;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(s=e.ScanError||(e.ScanError={}));var C;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(C=e.SyntaxKind||(e.SyntaxKind={}));var p;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(p=e.ParseErrorCode||(e.ParseErrorCode={}));var U;(function(r){r.DEFAULT={allowTrailingComma:!0}})(U=e.ParseOptions||(e.ParseOptions={}));function T(r,d=!1){let i=0,o=r.length,n="",t=0,l=16,v=0;function m(N){let W=0,Z=0;for(;W<N;){const K=r.charCodeAt(i);if(K>=48&&K<=57)Z=Z*16+K-48;else if(K>=65&&K<=70)Z=Z*16+K-65+10;else if(K>=97&&K<=102)Z=Z*16+K-97+10;else break;i++,W++}return W<N&&(Z=-1),Z}function I(N){i=N,n="",t=0,l=16,v=0}function B(){const N=i;if(r.charCodeAt(i)===48)i++;else for(i++;i<r.length&&A(r.charCodeAt(i));)i++;if(i<r.length&&r.charCodeAt(i)===46)if(i++,i<r.length&&A(r.charCodeAt(i)))for(i++;i<r.length&&A(r.charCodeAt(i));)i++;else return v=3,r.substring(N,i);let W=i;if(i<r.length&&(r.charCodeAt(i)===69||r.charCodeAt(i)===101))if(i++,(i<r.length&&r.charCodeAt(i)===43||r.charCodeAt(i)===45)&&i++,i<r.length&&A(r.charCodeAt(i))){for(i++;i<r.length&&A(r.charCodeAt(i));)i++;W=i}else v=3;return r.substring(N,W)}function x(){let N="",W=i;for(;;){if(i>=o){N+=r.substring(W,i),v=2;break}const Z=r.charCodeAt(i);if(Z===34){N+=r.substring(W,i),i++;break}if(Z===92){if(N+=r.substring(W,i),i++,i>=o){v=2;break}switch(r.charCodeAt(i++)){case 34:N+='"';break;case 92:N+="\\";break;case 47:N+="/";break;case 98:N+="\b";break;case 102:N+="\f";break;case 110:N+=`
`;break;case 114:N+="\r";break;case 116:N+="	";break;case 117:{const F=m(4);F>=0?N+=String.fromCharCode(F):v=4;break}default:v=5}W=i;continue}if(Z>=0&&Z<=31)if(b(Z)){N+=r.substring(W,i),v=2;break}else v=6;i++}return N}function R(){if(n="",v=0,t=i,i>=o)return t=o,l=17;let N=r.charCodeAt(i);if(P(N)){do i++,n+=String.fromCharCode(N),N=r.charCodeAt(i);while(P(N));return l=15}if(b(N))return i++,n+=String.fromCharCode(N),N===13&&r.charCodeAt(i)===10&&(i++,n+=`
`),l=14;switch(N){case 123:return i++,l=1;case 125:return i++,l=2;case 91:return i++,l=3;case 93:return i++,l=4;case 58:return i++,l=6;case 44:return i++,l=5;case 34:return i++,n=x(),l=10;case 47:{const W=i-1;if(r.charCodeAt(i+1)===47){for(i+=2;i<o&&!b(r.charCodeAt(i));)i++;return n=r.substring(W,i),l=12}if(r.charCodeAt(i+1)===42){i+=2;const Z=o-1;let K=!1;for(;i<Z;){if(r.charCodeAt(i)===42&&r.charCodeAt(i+1)===47){i+=2,K=!0;break}i++}return K||(i++,v=1),n=r.substring(W,i),l=13}return n+=String.fromCharCode(N),i++,l=16}case 45:if(n+=String.fromCharCode(N),i++,i===o||!A(r.charCodeAt(i)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=B(),l=11;default:for(;i<o&&E(N);)i++,N=r.charCodeAt(i);if(t!==i){switch(n=r.substring(t,i),n){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return n+=String.fromCharCode(N),i++,l=16}}function E(N){if(P(N)||b(N))return!1;switch(N){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let N;do N=R();while(N>=12&&N<=15);return N}return{setPosition:I,getPosition:()=>i,scan:d?M:R,getToken:()=>l,getTokenValue:()=>n,getTokenOffset:()=>t,getTokenLength:()=>i-t,getTokenError:()=>v}}e.createScanner=T;function P(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function b(r){return r===10||r===13||r===8232||r===8233}function A(r){return r>=48&&r<=57}var O;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(O||(O={}));function w(r,d){const i=[],o=new Object;let n;const t={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function v(m,I,B,x){t.value=m,t.offset=I,t.length=B,t.type=x,t.colonOffset=void 0,n=t}try{y(r,{onObjectBegin:(m,I)=>{if(d<=m)throw o;n=void 0,l=d>m,i.push("")},onObjectProperty:(m,I,B)=>{if(d<I||(v(m,I,B,"property"),i[i.length-1]=m,d<=I+B))throw o},onObjectEnd:(m,I)=>{if(d<=m)throw o;n=void 0,i.pop()},onArrayBegin:(m,I)=>{if(d<=m)throw o;n=void 0,i.push(0)},onArrayEnd:(m,I)=>{if(d<=m)throw o;n=void 0,i.pop()},onLiteralValue:(m,I,B)=>{if(d<I||(v(m,I,B,_(m)),d<=I+B))throw o},onSeparator:(m,I,B)=>{if(d<=I)throw o;if(m===":"&&n&&n.type==="property")n.colonOffset=I,l=!1,n=void 0;else if(m===","){const x=i[i.length-1];typeof x=="number"?i[i.length-1]=x+1:(l=!0,i[i.length-1]=""),n=void 0}}})}catch(m){if(m!==o)throw m}return{path:i,previousNode:n,isAtPropertyKey:l,matches:m=>{let I=0;for(let B=0;I<m.length&&B<i.length;B++)if(m[I]===i[B]||m[I]==="*")I++;else if(m[I]!=="**")return!1;return I===m.length}}}e.getLocation=w;function g(r,d=[],i=U.DEFAULT){let o=null,n=[];const t=[];function l(m){Array.isArray(n)?n.push(m):o!==null&&(n[o]=m)}return y(r,{onObjectBegin:()=>{const m={};l(m),t.push(n),n=m,o=null},onObjectProperty:m=>{o=m},onObjectEnd:()=>{n=t.pop()},onArrayBegin:()=>{const m=[];l(m),t.push(n),n=m,o=null},onArrayEnd:()=>{n=t.pop()},onLiteralValue:l,onError:(m,I,B)=>{d.push({error:m,offset:I,length:B})}},i),n[0]}e.parse=g;function S(r,d=[],i=U.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(m){o.type==="property"&&(o.length=m-o.offset,o=o.parent)}function t(m){return o.children.push(m),m}y(r,{onObjectBegin:m=>{o=t({type:"object",offset:m,length:-1,parent:o,children:[]})},onObjectProperty:(m,I,B)=>{o=t({type:"property",offset:I,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:m,offset:I,length:B,parent:o})},onObjectEnd:(m,I)=>{o.length=m+I-o.offset,o=o.parent,n(m+I)},onArrayBegin:(m,I)=>{o=t({type:"array",offset:m,length:-1,parent:o,children:[]})},onArrayEnd:(m,I)=>{o.length=m+I-o.offset,o=o.parent,n(m+I)},onLiteralValue:(m,I,B)=>{t({type:_(m),offset:I,length:B,parent:o,value:m}),n(I+B)},onSeparator:(m,I,B)=>{o.type==="property"&&(m===":"?o.colonOffset=I:m===","&&n(I))},onError:(m,I,B)=>{d.push({error:m,offset:I,length:B})}},i);const v=o.children[0];return v&&delete v.parent,v}e.parseTree=S;function f(r,d){if(!r)return;let i=r;for(let o of d)if(typeof o=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let n=!1;for(const t of i.children)if(Array.isArray(t.children)&&t.children[0].value===o){i=t.children[1],n=!0;break}if(!n)return}else{const n=o;if(i.type!=="array"||n<0||!Array.isArray(i.children)||n>=i.children.length)return;i=i.children[n]}return i}e.findNodeAtLocation=f;function c(r){if(!r.parent||!r.parent.children)return[];const d=c(r.parent);if(r.parent.type==="property"){const i=r.parent.children[0].value;d.push(i)}else if(r.parent.type==="array"){const i=r.parent.children.indexOf(r);i!==-1&&d.push(i)}return d}e.getNodePath=c;function h(r){switch(r.type){case"array":return r.children.map(h);case"object":{const d=Object.create(null);for(let i of r.children){const o=i.children[1];o&&(d[i.children[0].value]=h(o))}return d}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=h;function u(r,d,i=!1){return d>=r.offset&&d<r.offset+r.length||i&&d===r.offset+r.length}e.contains=u;function D(r,d,i=!1){if(u(r,d,i)){const o=r.children;if(Array.isArray(o))for(let n=0;n<o.length&&o[n].offset<=d;n++){const t=D(o[n],d,i);if(t)return t}return r}}e.findNodeAtOffset=D;function y(r,d,i=U.DEFAULT){const o=T(r,!1);function n(Ee){return Ee?()=>Ee(o.getTokenOffset(),o.getTokenLength()):()=>!0}function t(Ee){return Ee?be=>Ee(be,o.getTokenOffset(),o.getTokenLength()):()=>!0}const l=n(d.onObjectBegin),v=t(d.onObjectProperty),m=n(d.onObjectEnd),I=n(d.onArrayBegin),B=n(d.onArrayEnd),x=t(d.onLiteralValue),R=t(d.onSeparator),E=n(d.onComment),M=t(d.onError),N=i&&i.disallowComments,W=i&&i.allowTrailingComma;function Z(){for(;;){const Ee=o.scan();switch(o.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:N||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(Ee){case 12:case 13:N?K(10):E();break;case 16:K(1);break;case 15:case 14:break;default:return Ee}}}function K(Ee,be=[],ee=[]){if(M(Ee),be.length+ee.length>0){let ve=o.getToken();for(;ve!==17;){if(be.indexOf(ve)!==-1){Z();break}else if(ee.indexOf(ve)!==-1)break;ve=Z()}}}function F(Ee){const be=o.getTokenValue();return Ee?x(be):v(be),Z(),!0}function oe(){switch(o.getToken()){case 11:{let Ee=0;try{Ee=JSON.parse(o.getTokenValue()),typeof Ee!="number"&&(K(2),Ee=0)}catch{K(2)}x(Ee);break}case 7:x(null);break;case 8:x(!0);break;case 9:x(!1);break;default:return!1}return Z(),!0}function ce(){return o.getToken()!==10?(K(3,[],[2,5]),!1):(F(!1),o.getToken()===6?(R(":"),Z(),ie()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function ae(){l(),Z();let Ee=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(Ee||K(4,[],[]),R(","),Z(),o.getToken()===2&&W)break}else Ee&&K(6,[],[]);ce()||K(4,[],[2,5]),Ee=!0}return m(),o.getToken()!==2?K(7,[2],[]):Z(),!0}function fe(){I(),Z();let Ee=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(Ee||K(4,[],[]),R(","),Z(),o.getToken()===4&&W)break}else Ee&&K(6,[],[]);ie()||K(4,[],[4,5]),Ee=!0}return B(),o.getToken()!==4?K(8,[4],[]):Z(),!0}function ie(){switch(o.getToken()){case 3:return fe();case 1:return ae();case 10:return F(!0);default:return oe()}}return Z(),o.getToken()===17?i.allowEmptyContent?!0:(K(4,[],[]),!1):ie()?(o.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}e.visit=y;function a(r,d){let i=T(r),o=[],n,t=0,l;do switch(l=i.getPosition(),n=i.scan(),n){case 12:case 13:case 17:t!==l&&o.push(r.substring(t,l)),d!==void 0&&o.push(i.getTokenValue().replace(/[^\r\n]/g,d)),t=i.getPosition();break}while(n!==17);return o.join("")}e.stripComments=a;function _(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=_}),function(J,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(De[105],Ie([0]),e):(J=typeof globalThis!="undefined"?globalThis:J||self,e(J.marked={}))}(this,function(J){"use strict";function e(Te,Se){for(var ke=0;ke<Se.length;ke++){var se=Se[ke];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Te,se.key,se)}}function s(Te,Se,ke){return Se&&e(Te.prototype,Se),ke&&e(Te,ke),Object.defineProperty(Te,"prototype",{writable:!1}),Te}function C(Te,Se){if(!!Te){if(typeof Te=="string")return p(Te,Se);var ke=Object.prototype.toString.call(Te).slice(8,-1);if(ke==="Object"&&Te.constructor&&(ke=Te.constructor.name),ke==="Map"||ke==="Set")return Array.from(Te);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return p(Te,Se)}}function p(Te,Se){(Se==null||Se>Te.length)&&(Se=Te.length);for(var ke=0,se=new Array(Se);ke<Se;ke++)se[ke]=Te[ke];return se}function U(Te,Se){var ke=typeof Symbol!="undefined"&&Te[Symbol.iterator]||Te["@@iterator"];if(ke)return(ke=ke.call(Te)).next.bind(ke);if(Array.isArray(Te)||(ke=C(Te))||Se&&Te&&typeof Te.length=="number"){ke&&(Te=ke);var se=0;return function(){return se>=Te.length?{done:!0}:{done:!1,value:Te[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function T(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}J.defaults=T();function P(Te){J.defaults=Te}var b=/[&<>"']/,A=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,w=/[<>"']|&(?!#?\w+;)/g,g={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},S=function(Se){return g[Se]};function f(Te,Se){if(Se){if(b.test(Te))return Te.replace(A,S)}else if(O.test(Te))return Te.replace(w,S);return Te}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(Te){return Te.replace(c,function(Se,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var u=/(^|[^\[])\^/g;function D(Te,Se){Te=typeof Te=="string"?Te:Te.source,Se=Se||"";var ke={replace:function(le,G){return G=G.source||G,G=G.replace(u,"$1"),Te=Te.replace(le,G),ke},getRegex:function(){return new RegExp(Te,Se)}};return ke}var y=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function _(Te,Se,ke){if(Te){var se;try{se=decodeURIComponent(h(ke)).replace(y,"").toLowerCase()}catch{return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}Se&&!a.test(ke)&&(ke=n(Se,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch{return null}return ke}var r={},d=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(Te,Se){r[" "+Te]||(d.test(Te)?r[" "+Te]=Te+"/":r[" "+Te]=m(Te,"/",!0)),Te=r[" "+Te];var ke=Te.indexOf(":")===-1;return Se.substring(0,2)==="//"?ke?Se:Te.replace(i,"$1")+Se:Se.charAt(0)==="/"?ke?Se:Te.replace(o,"$1")+Se:Te+Se}var t={exec:function(){}};function l(Te){for(var Se=1,ke,se;Se<arguments.length;Se++){ke=arguments[Se];for(se in ke)Object.prototype.hasOwnProperty.call(ke,se)&&(Te[se]=ke[se])}return Te}function v(Te,Se){var ke=Te.replace(/\|/g,function(G,X,k){for(var z=!1,H=X;--H>=0&&k[H]==="\\";)z=!z;return z?"|":" |"}),se=ke.split(/ \|/),le=0;if(se[0].trim()||se.shift(),se.length>0&&!se[se.length-1].trim()&&se.pop(),se.length>Se)se.splice(Se);else for(;se.length<Se;)se.push("");for(;le<se.length;le++)se[le]=se[le].trim().replace(/\\\|/g,"|");return se}function m(Te,Se,ke){var se=Te.length;if(se===0)return"";for(var le=0;le<se;){var G=Te.charAt(se-le-1);if(G===Se&&!ke)le++;else if(G!==Se&&ke)le++;else break}return Te.slice(0,se-le)}function I(Te,Se){if(Te.indexOf(Se[1])===-1)return-1;for(var ke=Te.length,se=0,le=0;le<ke;le++)if(Te[le]==="\\")le++;else if(Te[le]===Se[0])se++;else if(Te[le]===Se[1]&&(se--,se<0))return le;return-1}function B(Te){Te&&Te.sanitize&&!Te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function x(Te,Se){if(Se<1)return"";for(var ke="";Se>1;)Se&1&&(ke+=Te),Se>>=1,Te+=Te;return ke+Te}function R(Te,Se,ke,se){var le=Se.href,G=Se.title?f(Se.title):null,X=Te[1].replace(/\\([\[\]])/g,"$1");if(Te[0].charAt(0)!=="!"){se.state.inLink=!0;var k={type:"link",raw:ke,href:le,title:G,text:X,tokens:se.inlineTokens(X,[])};return se.state.inLink=!1,k}return{type:"image",raw:ke,href:le,title:G,text:f(X)}}function E(Te,Se){var ke=Te.match(/^(\s+)(?:```)/);if(ke===null)return Se;var se=ke[1];return Se.split(`
`).map(function(le){var G=le.match(/^\s+/);if(G===null)return le;var X=G[0];return X.length>=se.length?le.slice(se.length):le}).join(`
`)}var M=function(){function Te(ke){this.options=ke||J.defaults}var Se=Te.prototype;return Se.space=function(se){var le=this.rules.block.newline.exec(se);if(le&&le[0].length>0)return{type:"space",raw:le[0]}},Se.code=function(se){var le=this.rules.block.code.exec(se);if(le){var G=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?G:m(G,`
`)}}},Se.fences=function(se){var le=this.rules.block.fences.exec(se);if(le){var G=le[0],X=E(G,le[3]||"");return{type:"code",raw:G,lang:le[2]?le[2].trim():le[2],text:X}}},Se.heading=function(se){var le=this.rules.block.heading.exec(se);if(le){var G=le[2].trim();if(/#$/.test(G)){var X=m(G,"#");(this.options.pedantic||!X||/ $/.test(X))&&(G=X.trim())}var k={type:"heading",raw:le[0],depth:le[1].length,text:G,tokens:[]};return this.lexer.inline(k.text,k.tokens),k}},Se.hr=function(se){var le=this.rules.block.hr.exec(se);if(le)return{type:"hr",raw:le[0]}},Se.blockquote=function(se){var le=this.rules.block.blockquote.exec(se);if(le){var G=le[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(G,[]),text:G}}},Se.list=function(se){var le=this.rules.block.list.exec(se);if(le){var G,X,k,z,H,V,re,de,Q,pe,ge,Ne,Be=le[1].trim(),Pe=Be.length>1,Ke={type:"list",raw:"",ordered:Pe,start:Pe?+Be.slice(0,-1):"",loose:!1,items:[]};Be=Pe?"\\d{1,9}\\"+Be.slice(-1):"\\"+Be,this.options.pedantic&&(Be=Pe?Be:"[*+-]");for(var q=new RegExp("^( {0,3}"+Be+")((?:[	 ][^\\n]*)?(?:\\n|$))");se&&(Ne=!1,!(!(le=q.exec(se))||this.rules.block.hr.test(se)));){if(G=le[0],se=se.substring(G.length),de=le[2].split(`
`,1)[0],Q=se.split(`
`,1)[0],this.options.pedantic?(z=2,ge=de.trimLeft()):(z=le[2].search(/[^ ]/),z=z>4?1:z,ge=de.slice(z),z+=le[1].length),V=!1,!de&&/^ *$/.test(Q)&&(G+=Q+`
`,se=se.substring(Q.length+1),Ne=!0),!Ne)for(var Y=new RegExp("^ {0,"+Math.min(3,z-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),me=new RegExp("^ {0,"+Math.min(3,z-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)");se&&(pe=se.split(`
`,1)[0],de=pe,this.options.pedantic&&(de=de.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Y.test(de)||me.test(se)));){if(de.search(/[^ ]/)>=z||!de.trim())ge+=`
`+de.slice(z);else if(!V)ge+=`
`+de;else break;!V&&!de.trim()&&(V=!0),G+=pe+`
`,se=se.substring(pe.length+1)}Ke.loose||(re?Ke.loose=!0:/\n *\n *$/.test(G)&&(re=!0)),this.options.gfm&&(X=/^\[[ xX]\] /.exec(ge),X&&(k=X[0]!=="[ ] ",ge=ge.replace(/^\[[ xX]\] +/,""))),Ke.items.push({type:"list_item",raw:G,task:!!X,checked:k,loose:!1,text:ge}),Ke.raw+=G}Ke.items[Ke.items.length-1].raw=G.trimRight(),Ke.items[Ke.items.length-1].text=ge.trimRight(),Ke.raw=Ke.raw.trimRight();var Le=Ke.items.length;for(H=0;H<Le;H++){this.lexer.state.top=!1,Ke.items[H].tokens=this.lexer.blockTokens(Ke.items[H].text,[]);var ze=Ke.items[H].tokens.filter(function(Ze){return Ze.type==="space"}),Ge=ze.every(function(Ze){for(var ot=Ze.raw.split(""),Qe=0,et=U(ot),qe;!(qe=et()).done;){var st=qe.value;if(st===`
`&&(Qe+=1),Qe>1)return!0}return!1});!Ke.loose&&ze.length&&Ge&&(Ke.loose=!0,Ke.items[H].loose=!0)}return Ke}},Se.html=function(se){var le=this.rules.block.html.exec(se);if(le){var G={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};return this.options.sanitize&&(G.type="paragraph",G.text=this.options.sanitizer?this.options.sanitizer(le[0]):f(le[0]),G.tokens=[],this.lexer.inline(G.text,G.tokens)),G}},Se.def=function(se){var le=this.rules.block.def.exec(se);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var G=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:G,raw:le[0],href:le[2],title:le[3]}}},Se.table=function(se){var le=this.rules.block.table.exec(se);if(le){var G={type:"table",header:v(le[1]).map(function(re){return{text:re}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]&&le[3].trim()?le[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(G.header.length===G.align.length){G.raw=le[0];var X=G.align.length,k,z,H,V;for(k=0;k<X;k++)/^ *-+: *$/.test(G.align[k])?G.align[k]="right":/^ *:-+: *$/.test(G.align[k])?G.align[k]="center":/^ *:-+ *$/.test(G.align[k])?G.align[k]="left":G.align[k]=null;for(X=G.rows.length,k=0;k<X;k++)G.rows[k]=v(G.rows[k],G.header.length).map(function(re){return{text:re}});for(X=G.header.length,z=0;z<X;z++)G.header[z].tokens=[],this.lexer.inline(G.header[z].text,G.header[z].tokens);for(X=G.rows.length,z=0;z<X;z++)for(V=G.rows[z],H=0;H<V.length;H++)V[H].tokens=[],this.lexer.inline(V[H].text,V[H].tokens);return G}}},Se.lheading=function(se){var le=this.rules.block.lheading.exec(se);if(le){var G={type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:[]};return this.lexer.inline(G.text,G.tokens),G}},Se.paragraph=function(se){var le=this.rules.block.paragraph.exec(se);if(le){var G={type:"paragraph",raw:le[0],text:le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1],tokens:[]};return this.lexer.inline(G.text,G.tokens),G}},Se.text=function(se){var le=this.rules.block.text.exec(se);if(le){var G={type:"text",raw:le[0],text:le[0],tokens:[]};return this.lexer.inline(G.text,G.tokens),G}},Se.escape=function(se){var le=this.rules.inline.escape.exec(se);if(le)return{type:"escape",raw:le[0],text:f(le[1])}},Se.tag=function(se){var le=this.rules.inline.tag.exec(se);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):f(le[0]):le[0]}},Se.link=function(se){var le=this.rules.inline.link.exec(se);if(le){var G=le[2].trim();if(!this.options.pedantic&&/^</.test(G)){if(!/>$/.test(G))return;var X=m(G.slice(0,-1),"\\");if((G.length-X.length)%2==0)return}else{var k=I(le[2],"()");if(k>-1){var z=le[0].indexOf("!")===0?5:4,H=z+le[1].length+k;le[2]=le[2].substring(0,k),le[0]=le[0].substring(0,H).trim(),le[3]=""}}var V=le[2],re="";if(this.options.pedantic){var de=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(V);de&&(V=de[1],re=de[3])}else re=le[3]?le[3].slice(1,-1):"";return V=V.trim(),/^</.test(V)&&(this.options.pedantic&&!/>$/.test(G)?V=V.slice(1):V=V.slice(1,-1)),R(le,{href:V&&V.replace(this.rules.inline._escapes,"$1"),title:re&&re.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},Se.reflink=function(se,le){var G;if((G=this.rules.inline.reflink.exec(se))||(G=this.rules.inline.nolink.exec(se))){var X=(G[2]||G[1]).replace(/\s+/g," ");if(X=le[X.toLowerCase()],!X||!X.href){var k=G[0].charAt(0);return{type:"text",raw:k,text:k}}return R(G,X,G[0],this.lexer)}},Se.emStrong=function(se,le,G){G===void 0&&(G="");var X=this.rules.inline.emStrong.lDelim.exec(se);if(!!X&&!(X[3]&&G.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var k=X[1]||X[2]||"";if(!k||k&&(G===""||this.rules.inline.punctuation.exec(G))){var z=X[0].length-1,H,V,re=z,de=0,Q=X[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Q.lastIndex=0,le=le.slice(-1*se.length+z);(X=Q.exec(le))!=null;)if(H=X[1]||X[2]||X[3]||X[4]||X[5]||X[6],!!H){if(V=H.length,X[3]||X[4]){re+=V;continue}else if((X[5]||X[6])&&z%3&&!((z+V)%3)){de+=V;continue}if(re-=V,!(re>0)){if(V=Math.min(V,V+re+de),Math.min(z,V)%2){var pe=se.slice(1,z+X.index+V);return{type:"em",raw:se.slice(0,z+X.index+V+1),text:pe,tokens:this.lexer.inlineTokens(pe,[])}}var ge=se.slice(2,z+X.index+V-1);return{type:"strong",raw:se.slice(0,z+X.index+V+1),text:ge,tokens:this.lexer.inlineTokens(ge,[])}}}}}},Se.codespan=function(se){var le=this.rules.inline.code.exec(se);if(le){var G=le[2].replace(/\n/g," "),X=/[^ ]/.test(G),k=/^ /.test(G)&&/ $/.test(G);return X&&k&&(G=G.substring(1,G.length-1)),G=f(G,!0),{type:"codespan",raw:le[0],text:G}}},Se.br=function(se){var le=this.rules.inline.br.exec(se);if(le)return{type:"br",raw:le[0]}},Se.del=function(se){var le=this.rules.inline.del.exec(se);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2],[])}},Se.autolink=function(se,le){var G=this.rules.inline.autolink.exec(se);if(G){var X,k;return G[2]==="@"?(X=f(this.options.mangle?le(G[1]):G[1]),k="mailto:"+X):(X=f(G[1]),k=X),{type:"link",raw:G[0],text:X,href:k,tokens:[{type:"text",raw:X,text:X}]}}},Se.url=function(se,le){var G;if(G=this.rules.inline.url.exec(se)){var X,k;if(G[2]==="@")X=f(this.options.mangle?le(G[0]):G[0]),k="mailto:"+X;else{var z;do z=G[0],G[0]=this.rules.inline._backpedal.exec(G[0])[0];while(z!==G[0]);X=f(G[0]),G[1]==="www."?k="http://"+X:k=X}return{type:"link",raw:G[0],text:X,href:k,tokens:[{type:"text",raw:X,text:X}]}}},Se.inlineText=function(se,le){var G=this.rules.inline.text.exec(se);if(G){var X;return this.lexer.state.inRawBlock?X=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(G[0]):f(G[0]):G[0]:X=f(this.options.smartypants?le(G[0]):G[0]),{type:"text",raw:G[0],text:X}}},Te}(),N={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:t,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};N._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,N._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,N.def=D(N.def).replace("label",N._label).replace("title",N._title).getRegex(),N.bullet=/(?:[*+-]|\d{1,9}[.)])/,N.listItemStart=D(/^( *)(bull) */).replace("bull",N.bullet).getRegex(),N.list=D(N.list).replace(/bull/g,N.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+N.def.source+")").getRegex(),N._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",N._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,N.html=D(N.html,"i").replace("comment",N._comment).replace("tag",N._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),N.paragraph=D(N._paragraph).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.blockquote=D(N.blockquote).replace("paragraph",N.paragraph).getRegex(),N.normal=l({},N),N.gfm=l({},N.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),N.gfm.table=D(N.gfm.table).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.gfm.paragraph=D(N._paragraph).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",N.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.pedantic=l({},N.normal,{html:D(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",N._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:t,paragraph:D(N.normal._paragraph).replace("hr",N.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",N.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var W={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:t,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:t,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};W._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",W.punctuation=D(W.punctuation).replace(/punctuation/g,W._punctuation).getRegex(),W.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,W.escapedEmSt=/\\\*|\\_/g,W._comment=D(N._comment).replace("(?:-->|$)","-->").getRegex(),W.emStrong.lDelim=D(W.emStrong.lDelim).replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimAst=D(W.emStrong.rDelimAst,"g").replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimUnd=D(W.emStrong.rDelimUnd,"g").replace(/punct/g,W._punctuation).getRegex(),W._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,W._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,W._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,W.autolink=D(W.autolink).replace("scheme",W._scheme).replace("email",W._email).getRegex(),W._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,W.tag=D(W.tag).replace("comment",W._comment).replace("attribute",W._attribute).getRegex(),W._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,W._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,W._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,W.link=D(W.link).replace("label",W._label).replace("href",W._href).replace("title",W._title).getRegex(),W.reflink=D(W.reflink).replace("label",W._label).replace("ref",N._label).getRegex(),W.nolink=D(W.nolink).replace("ref",N._label).getRegex(),W.reflinkSearch=D(W.reflinkSearch,"g").replace("reflink",W.reflink).replace("nolink",W.nolink).getRegex(),W.normal=l({},W),W.pedantic=l({},W.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:D(/^!?\[(label)\]\((.*?)\)/).replace("label",W._label).getRegex(),reflink:D(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",W._label).getRegex()}),W.gfm=l({},W.normal,{escape:D(W.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),W.gfm.url=D(W.gfm.url,"i").replace("email",W.gfm._extended_email).getRegex(),W.breaks=l({},W.gfm,{br:D(W.br).replace("{2,}","*").getRegex(),text:D(W.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function Z(Te){return Te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(Te){var Se="",ke,se,le=Te.length;for(ke=0;ke<le;ke++)se=Te.charCodeAt(ke),Math.random()>.5&&(se="x"+se.toString(16)),Se+="&#"+se+";";return Se}var F=function(){function Te(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||J.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:N.normal,inline:W.normal};this.options.pedantic?(se.block=N.pedantic,se.inline=W.pedantic):this.options.gfm&&(se.block=N.gfm,this.options.breaks?se.inline=W.breaks:se.inline=W.gfm),this.tokenizer.rules=se}Te.lex=function(se,le){var G=new Te(le);return G.lex(se)},Te.lexInline=function(se,le){var G=new Te(le);return G.inlineTokens(se)};var Se=Te.prototype;return Se.lex=function(se){se=se.replace(/\r\n|\r/g,`
`),this.blockTokens(se,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},Se.blockTokens=function(se,le){var G=this;le===void 0&&(le=[]),this.options.pedantic?se=se.replace(/\t/g,"    ").replace(/^ +$/gm,""):se=se.replace(/^( *)(\t+)/gm,function(re,de,Q){return de+"    ".repeat(Q.length)});for(var X,k,z,H;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(re){return(X=re.call({lexer:G},se,le))?(se=se.substring(X.raw.length),le.push(X),!0):!1}))){if(X=this.tokenizer.space(se)){se=se.substring(X.raw.length),X.raw.length===1&&le.length>0?le[le.length-1].raw+=`
`:le.push(X);continue}if(X=this.tokenizer.code(se)){se=se.substring(X.raw.length),k=le[le.length-1],k&&(k.type==="paragraph"||k.type==="text")?(k.raw+=`
`+X.raw,k.text+=`
`+X.text,this.inlineQueue[this.inlineQueue.length-1].src=k.text):le.push(X);continue}if(X=this.tokenizer.fences(se)){se=se.substring(X.raw.length),le.push(X);continue}if(X=this.tokenizer.heading(se)){se=se.substring(X.raw.length),le.push(X);continue}if(X=this.tokenizer.hr(se)){se=se.substring(X.raw.length),le.push(X);continue}if(X=this.tokenizer.blockquote(se)){se=se.substring(X.raw.length),le.push(X);continue}if(X=this.tokenizer.list(se)){se=se.substring(X.raw.length),le.push(X);continue}if(X=this.tokenizer.html(se)){se=se.substring(X.raw.length),le.push(X);continue}if(X=this.tokenizer.def(se)){se=se.substring(X.raw.length),k=le[le.length-1],k&&(k.type==="paragraph"||k.type==="text")?(k.raw+=`
`+X.raw,k.text+=`
`+X.raw,this.inlineQueue[this.inlineQueue.length-1].src=k.text):this.tokens.links[X.tag]||(this.tokens.links[X.tag]={href:X.href,title:X.title});continue}if(X=this.tokenizer.table(se)){se=se.substring(X.raw.length),le.push(X);continue}if(X=this.tokenizer.lheading(se)){se=se.substring(X.raw.length),le.push(X);continue}if(z=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var re=1/0,de=se.slice(1),Q=void 0;G.options.extensions.startBlock.forEach(function(pe){Q=pe.call({lexer:this},de),typeof Q=="number"&&Q>=0&&(re=Math.min(re,Q))}),re<1/0&&re>=0&&(z=se.substring(0,re+1))}(),this.state.top&&(X=this.tokenizer.paragraph(z))){k=le[le.length-1],H&&k.type==="paragraph"?(k.raw+=`
`+X.raw,k.text+=`
`+X.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=k.text):le.push(X),H=z.length!==se.length,se=se.substring(X.raw.length);continue}if(X=this.tokenizer.text(se)){se=se.substring(X.raw.length),k=le[le.length-1],k&&k.type==="text"?(k.raw+=`
`+X.raw,k.text+=`
`+X.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=k.text):le.push(X);continue}if(se){var V="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(V);break}else throw new Error(V)}}return this.state.top=!0,le},Se.inline=function(se,le){this.inlineQueue.push({src:se,tokens:le})},Se.inlineTokens=function(se,le){var G=this;le===void 0&&(le=[]);var X,k,z,H=se,V,re,de;if(this.tokens.links){var Q=Object.keys(this.tokens.links);if(Q.length>0)for(;(V=this.tokenizer.rules.inline.reflinkSearch.exec(H))!=null;)Q.includes(V[0].slice(V[0].lastIndexOf("[")+1,-1))&&(H=H.slice(0,V.index)+"["+x("a",V[0].length-2)+"]"+H.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(V=this.tokenizer.rules.inline.blockSkip.exec(H))!=null;)H=H.slice(0,V.index)+"["+x("a",V[0].length-2)+"]"+H.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(V=this.tokenizer.rules.inline.escapedEmSt.exec(H))!=null;)H=H.slice(0,V.index)+"++"+H.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(re||(de=""),re=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ge){return(X=ge.call({lexer:G},se,le))?(se=se.substring(X.raw.length),le.push(X),!0):!1}))){if(X=this.tokenizer.escape(se)){se=se.substring(X.raw.length),le.push(X);continue}if(X=this.tokenizer.tag(se)){se=se.substring(X.raw.length),k=le[le.length-1],k&&X.type==="text"&&k.type==="text"?(k.raw+=X.raw,k.text+=X.text):le.push(X);continue}if(X=this.tokenizer.link(se)){se=se.substring(X.raw.length),le.push(X);continue}if(X=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(X.raw.length),k=le[le.length-1],k&&X.type==="text"&&k.type==="text"?(k.raw+=X.raw,k.text+=X.text):le.push(X);continue}if(X=this.tokenizer.emStrong(se,H,de)){se=se.substring(X.raw.length),le.push(X);continue}if(X=this.tokenizer.codespan(se)){se=se.substring(X.raw.length),le.push(X);continue}if(X=this.tokenizer.br(se)){se=se.substring(X.raw.length),le.push(X);continue}if(X=this.tokenizer.del(se)){se=se.substring(X.raw.length),le.push(X);continue}if(X=this.tokenizer.autolink(se,K)){se=se.substring(X.raw.length),le.push(X);continue}if(!this.state.inLink&&(X=this.tokenizer.url(se,K))){se=se.substring(X.raw.length),le.push(X);continue}if(z=se,this.options.extensions&&this.options.extensions.startInline&&function(){var ge=1/0,Ne=se.slice(1),Be=void 0;G.options.extensions.startInline.forEach(function(Pe){Be=Pe.call({lexer:this},Ne),typeof Be=="number"&&Be>=0&&(ge=Math.min(ge,Be))}),ge<1/0&&ge>=0&&(z=se.substring(0,ge+1))}(),X=this.tokenizer.inlineText(z,Z)){se=se.substring(X.raw.length),X.raw.slice(-1)!=="_"&&(de=X.raw.slice(-1)),re=!0,k=le[le.length-1],k&&k.type==="text"?(k.raw+=X.raw,k.text+=X.text):le.push(X);continue}if(se){var pe="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(pe);break}else throw new Error(pe)}}return le},s(Te,null,[{key:"rules",get:function(){return{block:N,inline:W}}}]),Te}(),oe=function(){function Te(ke){this.options=ke||J.defaults}var Se=Te.prototype;return Se.code=function(se,le,G){var X=(le||"").match(/\S*/)[0];if(this.options.highlight){var k=this.options.highlight(se,X);k!=null&&k!==se&&(G=!0,se=k)}return se=se.replace(/\n$/,"")+`
`,X?'<pre><code class="'+this.options.langPrefix+f(X,!0)+'">'+(G?se:f(se,!0))+`</code></pre>
`:"<pre><code>"+(G?se:f(se,!0))+`</code></pre>
`},Se.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},Se.html=function(se){return se},Se.heading=function(se,le,G,X){if(this.options.headerIds){var k=this.options.headerPrefix+X.slug(G);return"<h"+le+' id="'+k+'">'+se+"</h"+le+`>
`}return"<h"+le+">"+se+"</h"+le+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(se,le,G){var X=le?"ol":"ul",k=le&&G!==1?' start="'+G+'"':"";return"<"+X+k+`>
`+se+"</"+X+`>
`},Se.listitem=function(se){return"<li>"+se+`</li>
`},Se.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(se){return"<p>"+se+`</p>
`},Se.table=function(se,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+le+`</table>
`},Se.tablerow=function(se){return`<tr>
`+se+`</tr>
`},Se.tablecell=function(se,le){var G=le.header?"th":"td",X=le.align?"<"+G+' align="'+le.align+'">':"<"+G+">";return X+se+("</"+G+`>
`)},Se.strong=function(se){return"<strong>"+se+"</strong>"},Se.em=function(se){return"<em>"+se+"</em>"},Se.codespan=function(se){return"<code>"+se+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(se){return"<del>"+se+"</del>"},Se.link=function(se,le,G){if(se=_(this.options.sanitize,this.options.baseUrl,se),se===null)return G;var X='<a href="'+f(se)+'"';return le&&(X+=' title="'+le+'"'),X+=">"+G+"</a>",X},Se.image=function(se,le,G){if(se=_(this.options.sanitize,this.options.baseUrl,se),se===null)return G;var X='<img src="'+se+'" alt="'+G+'"';return le&&(X+=' title="'+le+'"'),X+=this.options.xhtml?"/>":">",X},Se.text=function(se){return se},Te}(),ce=function(){function Te(){}var Se=Te.prototype;return Se.strong=function(se){return se},Se.em=function(se){return se},Se.codespan=function(se){return se},Se.del=function(se){return se},Se.html=function(se){return se},Se.text=function(se){return se},Se.link=function(se,le,G){return""+G},Se.image=function(se,le,G){return""+G},Se.br=function(){return""},Te}(),ae=function(){function Te(){this.seen={}}var Se=Te.prototype;return Se.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(se,le){var G=se,X=0;if(this.seen.hasOwnProperty(G)){X=this.seen[se];do X++,G=se+"-"+X;while(this.seen.hasOwnProperty(G))}return le||(this.seen[se]=X,this.seen[G]=0),G},Se.slug=function(se,le){le===void 0&&(le={});var G=this.serialize(se);return this.getNextSafeSlug(G,le.dryrun)},Te}(),fe=function(){function Te(ke){this.options=ke||J.defaults,this.options.renderer=this.options.renderer||new oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ce,this.slugger=new ae}Te.parse=function(se,le){var G=new Te(le);return G.parse(se)},Te.parseInline=function(se,le){var G=new Te(le);return G.parseInline(se)};var Se=Te.prototype;return Se.parse=function(se,le){le===void 0&&(le=!0);var G="",X,k,z,H,V,re,de,Q,pe,ge,Ne,Be,Pe,Ke,q,Y,me,Le,ze,Ge=se.length;for(X=0;X<Ge;X++){if(ge=se[X],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ge.type]&&(ze=this.options.extensions.renderers[ge.type].call({parser:this},ge),ze!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ge.type))){G+=ze||"";continue}switch(ge.type){case"space":continue;case"hr":{G+=this.renderer.hr();continue}case"heading":{G+=this.renderer.heading(this.parseInline(ge.tokens),ge.depth,h(this.parseInline(ge.tokens,this.textRenderer)),this.slugger);continue}case"code":{G+=this.renderer.code(ge.text,ge.lang,ge.escaped);continue}case"table":{for(Q="",de="",H=ge.header.length,k=0;k<H;k++)de+=this.renderer.tablecell(this.parseInline(ge.header[k].tokens),{header:!0,align:ge.align[k]});for(Q+=this.renderer.tablerow(de),pe="",H=ge.rows.length,k=0;k<H;k++){for(re=ge.rows[k],de="",V=re.length,z=0;z<V;z++)de+=this.renderer.tablecell(this.parseInline(re[z].tokens),{header:!1,align:ge.align[z]});pe+=this.renderer.tablerow(de)}G+=this.renderer.table(Q,pe);continue}case"blockquote":{pe=this.parse(ge.tokens),G+=this.renderer.blockquote(pe);continue}case"list":{for(Ne=ge.ordered,Be=ge.start,Pe=ge.loose,H=ge.items.length,pe="",k=0;k<H;k++)q=ge.items[k],Y=q.checked,me=q.task,Ke="",q.task&&(Le=this.renderer.checkbox(Y),Pe?q.tokens.length>0&&q.tokens[0].type==="paragraph"?(q.tokens[0].text=Le+" "+q.tokens[0].text,q.tokens[0].tokens&&q.tokens[0].tokens.length>0&&q.tokens[0].tokens[0].type==="text"&&(q.tokens[0].tokens[0].text=Le+" "+q.tokens[0].tokens[0].text)):q.tokens.unshift({type:"text",text:Le}):Ke+=Le),Ke+=this.parse(q.tokens,Pe),pe+=this.renderer.listitem(Ke,me,Y);G+=this.renderer.list(pe,Ne,Be);continue}case"html":{G+=this.renderer.html(ge.text);continue}case"paragraph":{G+=this.renderer.paragraph(this.parseInline(ge.tokens));continue}case"text":{for(pe=ge.tokens?this.parseInline(ge.tokens):ge.text;X+1<Ge&&se[X+1].type==="text";)ge=se[++X],pe+=`
`+(ge.tokens?this.parseInline(ge.tokens):ge.text);G+=le?this.renderer.paragraph(pe):pe;continue}default:{var Ze='Token with "'+ge.type+'" type was not found.';if(this.options.silent){console.error(Ze);return}else throw new Error(Ze)}}}return G},Se.parseInline=function(se,le){le=le||this.renderer;var G="",X,k,z,H=se.length;for(X=0;X<H;X++){if(k=se[X],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[k.type]&&(z=this.options.extensions.renderers[k.type].call({parser:this},k),z!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(k.type))){G+=z||"";continue}switch(k.type){case"escape":{G+=le.text(k.text);break}case"html":{G+=le.html(k.text);break}case"link":{G+=le.link(k.href,k.title,this.parseInline(k.tokens,le));break}case"image":{G+=le.image(k.href,k.title,k.text);break}case"strong":{G+=le.strong(this.parseInline(k.tokens,le));break}case"em":{G+=le.em(this.parseInline(k.tokens,le));break}case"codespan":{G+=le.codespan(k.text);break}case"br":{G+=le.br();break}case"del":{G+=le.del(this.parseInline(k.tokens,le));break}case"text":{G+=le.text(k.text);break}default:{var V='Token with "'+k.type+'" type was not found.';if(this.options.silent){console.error(V);return}else throw new Error(V)}}}return G},Te}();function ie(Te,Se,ke){if(typeof Te=="undefined"||Te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");if(typeof Se=="function"&&(ke=Se,Se=null),Se=l({},ie.defaults,Se||{}),B(Se),ke){var se=Se.highlight,le;try{le=F.lex(Te,Se)}catch(z){return ke(z)}var G=function(H){var V;if(!H)try{Se.walkTokens&&ie.walkTokens(le,Se.walkTokens),V=fe.parse(le,Se)}catch(re){H=re}return Se.highlight=se,H?ke(H):ke(null,V)};if(!se||se.length<3||(delete Se.highlight,!le.length))return G();var X=0;ie.walkTokens(le,function(z){z.type==="code"&&(X++,setTimeout(function(){se(z.text,z.lang,function(H,V){if(H)return G(H);V!=null&&V!==z.text&&(z.text=V,z.escaped=!0),X--,X===0&&G()})},0))}),X===0&&G();return}try{var k=F.lex(Te,Se);return Se.walkTokens&&ie.walkTokens(k,Se.walkTokens),fe.parse(k,Se)}catch(z){if(z.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+f(z.message+"",!0)+"</pre>";throw z}}ie.options=ie.setOptions=function(Te){return l(ie.defaults,Te),P(ie.defaults),ie},ie.getDefaults=T,ie.defaults=J.defaults,ie.use=function(){for(var Te=arguments.length,Se=new Array(Te),ke=0;ke<Te;ke++)Se[ke]=arguments[ke];var se=l.apply(void 0,[{}].concat(Se)),le=ie.defaults.extensions||{renderers:{},childTokens:{}},G;Se.forEach(function(X){if(X.extensions&&(G=!0,X.extensions.forEach(function(z){if(!z.name)throw new Error("extension name required");if(z.renderer){var H=le.renderers?le.renderers[z.name]:null;H?le.renderers[z.name]=function(){for(var V=arguments.length,re=new Array(V),de=0;de<V;de++)re[de]=arguments[de];var Q=z.renderer.apply(this,re);return Q===!1&&(Q=H.apply(this,re)),Q}:le.renderers[z.name]=z.renderer}if(z.tokenizer){if(!z.level||z.level!=="block"&&z.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");le[z.level]?le[z.level].unshift(z.tokenizer):le[z.level]=[z.tokenizer],z.start&&(z.level==="block"?le.startBlock?le.startBlock.push(z.start):le.startBlock=[z.start]:z.level==="inline"&&(le.startInline?le.startInline.push(z.start):le.startInline=[z.start]))}z.childTokens&&(le.childTokens[z.name]=z.childTokens)})),X.renderer&&function(){var z=ie.defaults.renderer||new oe,H=function(de){var Q=z[de];z[de]=function(){for(var pe=arguments.length,ge=new Array(pe),Ne=0;Ne<pe;Ne++)ge[Ne]=arguments[Ne];var Be=X.renderer[de].apply(z,ge);return Be===!1&&(Be=Q.apply(z,ge)),Be}};for(var V in X.renderer)H(V);se.renderer=z}(),X.tokenizer&&function(){var z=ie.defaults.tokenizer||new M,H=function(de){var Q=z[de];z[de]=function(){for(var pe=arguments.length,ge=new Array(pe),Ne=0;Ne<pe;Ne++)ge[Ne]=arguments[Ne];var Be=X.tokenizer[de].apply(z,ge);return Be===!1&&(Be=Q.apply(z,ge)),Be}};for(var V in X.tokenizer)H(V);se.tokenizer=z}(),X.walkTokens){var k=ie.defaults.walkTokens;se.walkTokens=function(z){X.walkTokens.call(this,z),k&&k.call(this,z)}}G&&(se.extensions=le),ie.setOptions(se)})},ie.walkTokens=function(Te,Se){for(var ke=function(){var X=le.value;switch(Se.call(ie,X),X.type){case"table":{for(var k=U(X.header),z;!(z=k()).done;){var H=z.value;ie.walkTokens(H.tokens,Se)}for(var V=U(X.rows),re;!(re=V()).done;)for(var de=re.value,Q=U(de),pe;!(pe=Q()).done;){var ge=pe.value;ie.walkTokens(ge.tokens,Se)}break}case"list":{ie.walkTokens(X.items,Se);break}default:ie.defaults.extensions&&ie.defaults.extensions.childTokens&&ie.defaults.extensions.childTokens[X.type]?ie.defaults.extensions.childTokens[X.type].forEach(function(Ne){ie.walkTokens(X[Ne],Se)}):X.tokens&&ie.walkTokens(X.tokens,Se)}},se=U(Te),le;!(le=se()).done;)ke()},ie.parseInline=function(Te,Se){if(typeof Te=="undefined"||Te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");Se=l({},ie.defaults,Se||{}),B(Se);try{var ke=F.lexInline(Te,Se);return Se.walkTokens&&ie.walkTokens(ke,Se.walkTokens),fe.parseInline(ke,Se)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+f(se.message+"",!0)+"</pre>";throw se}},ie.Parser=fe,ie.parser=fe.parse,ie.Renderer=oe,ie.TextRenderer=ce,ie.Lexer=F,ie.lexer=F.lex,ie.Tokenizer=M,ie.Slugger=ae,ie.parse=ie;var Ee=ie.options,be=ie.setOptions,ee=ie.use,ve=ie.walkTokens,Re=ie.parseInline,Fe=ie,We=fe.parse,Xe=F.lex;J.Lexer=F,J.Parser=fe,J.Renderer=oe,J.Slugger=ae,J.TextRenderer=ce,J.Tokenizer=M,J.getDefaults=T,J.lexer=Xe,J.marked=ie,J.options=Ee,J.parse=Fe,J.parseInline=Re,J.parser=We,J.setOptions=be,J.use=ee,J.walkTokens=ve,Object.defineProperty(J,"__esModule",{value:!0})}),define(De[106],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function s(P,b,A){return Math.min(Math.max(P,b),A)}e.clamp=s;function C(P,b){return(b+P%b)%b}e.rot=C;class p{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=p;class U{constructor(){this._n=1,this._val=0}update(b){return this._val=this._val+(b-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=U;class T{constructor(b){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(b),this._values.fill(0,0,b)}update(b){const A=this._values[this._index];return this._values[this._index]=b,this._index=(this._index+1)%this._values.length,this._sum-=A,this._sum+=b,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=T}),function(){function J(p){const U=[];typeof p=="number"&&U.push("code/timeOrigin",p);function T(b){U.push(b,Date.now())}function P(){const b=[];for(let A=0;A<U.length;A+=2)b.push({name:U[A],startTime:U[A+1]});return b}return{mark:T,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(p){performance.mark(p)},getMarks(){let p=performance.timeOrigin;typeof p!="number"&&(p=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const U=[{name:"code/timeOrigin",startTime:Math.round(p)}];for(const T of performance.getEntriesByType("mark"))U.push({name:T.name,startTime:Math.round(p+T.startTime)});return U}};if(typeof process=="object"){const p=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(p)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function s(p){return p.MonacoPerformanceMarks||(p.MonacoPerformanceMarks=e()),p.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return s(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=s(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=s(C))}(),define(De[74],Ie([1,0,19]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var C;(function(w){w.text="text/plain",w.binary="application/octet-stream",w.unknown="application/unknown",w.markdown="text/markdown",w.latex="text/latex",w.uriList="text/uri-list"})(C=e.Mimes||(e.Mimes={}));const p={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},U={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(w){const g=(0,s.extname)(w),S=p[g.toLowerCase()];return S!==void 0?S:P(w)}e.getMediaOrTextMime=T;function P(w){const g=(0,s.extname)(w);return U[g.toLowerCase()]}e.getMediaMime=P;function b(w){for(const g in U)if(U[g]===w)return g}e.getExtensionForMimeType=b;const A=/^(.+)\/(.+?)(;.+)?$/;function O(w,g){const S=A.exec(w);return S?`${S[1].toLowerCase()}/${S[2].toLowerCase()}${S[3]??""}`:g?void 0:w}e.normalizeMimeType=O}),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var s=e();for(var C in s)(typeof exports=="object"?exports:J)[C]=s[C]}}(typeof self!="undefined"?self:this,function(){return function(J){var e={};function s(C){if(e[C])return e[C].exports;var p=e[C]={i:C,l:!1,exports:{}};return J[C].call(p.exports,p,p.exports,s),p.l=!0,p.exports}return s.m=J,s.c=e,s.d=function(C,p,U){s.o(C,p)||Object.defineProperty(C,p,{enumerable:!0,get:U})},s.r=function(C){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},s.t=function(C,p){if(1&p&&(C=s(C)),8&p||4&p&&typeof C=="object"&&C&&C.__esModule)return C;var U=Object.create(null);if(s.r(U),Object.defineProperty(U,"default",{enumerable:!0,value:C}),2&p&&typeof C!="string")for(var T in C)s.d(U,T,function(P){return C[P]}.bind(null,T));return U},s.n=function(C){var p=C&&C.__esModule?function(){return C.default}:function(){return C};return s.d(p,"a",p),p},s.o=function(C,p){return Object.prototype.hasOwnProperty.call(C,p)},s.p="",s(s.s=0)}([function(J,e,s){(function(C){var p;e=J.exports=ee,p=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var Q=Array.prototype.slice.call(arguments,0);Q.unshift("SEMVER"),console.log.apply(console,Q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var U=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],b=e.src=[],A=0,O=A++;b[O]="0|[1-9]\\d*";var w=A++;b[w]="[0-9]+";var g=A++;b[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=A++;b[S]="("+b[O]+")\\.("+b[O]+")\\.("+b[O]+")";var f=A++;b[f]="("+b[w]+")\\.("+b[w]+")\\.("+b[w]+")";var c=A++;b[c]="(?:"+b[O]+"|"+b[g]+")";var h=A++;b[h]="(?:"+b[w]+"|"+b[g]+")";var u=A++;b[u]="(?:-("+b[c]+"(?:\\."+b[c]+")*))";var D=A++;b[D]="(?:-?("+b[h]+"(?:\\."+b[h]+")*))";var y=A++;b[y]="[0-9A-Za-z-]+";var a=A++;b[a]="(?:\\+("+b[y]+"(?:\\."+b[y]+")*))";var _=A++,r="v?"+b[S]+b[u]+"?"+b[a]+"?";b[_]="^"+r+"$";var d="[v=\\s]*"+b[f]+b[D]+"?"+b[a]+"?",i=A++;b[i]="^"+d+"$";var o=A++;b[o]="((?:<|>)?=?)";var n=A++;b[n]=b[w]+"|x|X|\\*";var t=A++;b[t]=b[O]+"|x|X|\\*";var l=A++;b[l]="[v=\\s]*("+b[t]+")(?:\\.("+b[t]+")(?:\\.("+b[t]+")(?:"+b[u]+")?"+b[a]+"?)?)?";var v=A++;b[v]="[v=\\s]*("+b[n]+")(?:\\.("+b[n]+")(?:\\.("+b[n]+")(?:"+b[D]+")?"+b[a]+"?)?)?";var m=A++;b[m]="^"+b[o]+"\\s*"+b[l]+"$";var I=A++;b[I]="^"+b[o]+"\\s*"+b[v]+"$";var B=A++;b[B]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var x=A++;b[x]="(?:~>?)";var R=A++;b[R]="(\\s*)"+b[x]+"\\s+",P[R]=new RegExp(b[R],"g");var E=A++;b[E]="^"+b[x]+b[l]+"$";var M=A++;b[M]="^"+b[x]+b[v]+"$";var N=A++;b[N]="(?:\\^)";var W=A++;b[W]="(\\s*)"+b[N]+"\\s+",P[W]=new RegExp(b[W],"g");var Z=A++;b[Z]="^"+b[N]+b[l]+"$";var K=A++;b[K]="^"+b[N]+b[v]+"$";var F=A++;b[F]="^"+b[o]+"\\s*("+d+")$|^$";var oe=A++;b[oe]="^"+b[o]+"\\s*("+r+")$|^$";var ce=A++;b[ce]="(\\s*)"+b[o]+"\\s*("+d+"|"+b[l]+")",P[ce]=new RegExp(b[ce],"g");var ae=A++;b[ae]="^\\s*("+b[l]+")\\s+-\\s+("+b[l]+")\\s*$";var fe=A++;b[fe]="^\\s*("+b[v]+")\\s+-\\s+("+b[v]+")\\s*$";var ie=A++;b[ie]="(<|>)?=?\\s*\\*";for(var Ee=0;Ee<35;Ee++)p(Ee,b[Ee]),P[Ee]||(P[Ee]=new RegExp(b[Ee]));function be(Q,pe){if(Q instanceof ee)return Q;if(typeof Q!="string"||Q.length>U||!(pe?P[i]:P[_]).test(Q))return null;try{return new ee(Q,pe)}catch{return null}}function ee(Q,pe){if(Q instanceof ee){if(Q.loose===pe)return Q;Q=Q.version}else if(typeof Q!="string")throw new TypeError("Invalid Version: "+Q);if(Q.length>U)throw new TypeError("version is longer than "+U+" characters");if(!(this instanceof ee))return new ee(Q,pe);p("SemVer",Q,pe),this.loose=pe;var ge=Q.trim().match(pe?P[i]:P[_]);if(!ge)throw new TypeError("Invalid Version: "+Q);if(this.raw=Q,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var Be=+Ne;if(Be>=0&&Be<T)return Be}return Ne}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=be,e.valid=function(Q,pe){var ge=be(Q,pe);return ge?ge.version:null},e.clean=function(Q,pe){var ge=be(Q.trim().replace(/^[=v]+/,""),pe);return ge?ge.version:null},e.SemVer=ee,ee.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ee.prototype.toString=function(){return this.version},ee.prototype.compare=function(Q){return p("SemVer.compare",this.version,this.loose,Q),Q instanceof ee||(Q=new ee(Q,this.loose)),this.compareMain(Q)||this.comparePre(Q)},ee.prototype.compareMain=function(Q){return Q instanceof ee||(Q=new ee(Q,this.loose)),Re(this.major,Q.major)||Re(this.minor,Q.minor)||Re(this.patch,Q.patch)},ee.prototype.comparePre=function(Q){if(Q instanceof ee||(Q=new ee(Q,this.loose)),this.prerelease.length&&!Q.prerelease.length)return-1;if(!this.prerelease.length&&Q.prerelease.length)return 1;if(!this.prerelease.length&&!Q.prerelease.length)return 0;var pe=0;do{var ge=this.prerelease[pe],Ne=Q.prerelease[pe];if(p("prerelease compare",pe,ge,Ne),ge===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ne)return Re(ge,Ne)}while(++pe)},ee.prototype.inc=function(Q,pe){switch(Q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",pe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",pe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",pe),this.inc("pre",pe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",pe),this.inc("pre",pe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}pe&&(this.prerelease[0]===pe?isNaN(this.prerelease[1])&&(this.prerelease=[pe,0]):this.prerelease=[pe,0]);break;default:throw new Error("invalid increment argument: "+Q)}return this.format(),this.raw=this.version,this},e.inc=function(Q,pe,ge,Ne){typeof ge=="string"&&(Ne=ge,ge=void 0);try{return new ee(Q,ge).inc(pe,Ne).version}catch{return null}},e.diff=function(Q,pe){if(Te(Q,pe))return null;var ge=be(Q),Ne=be(pe);if(ge.prerelease.length||Ne.prerelease.length){for(var Be in ge)if((Be==="major"||Be==="minor"||Be==="patch")&&ge[Be]!==Ne[Be])return"pre"+Be;return"prerelease"}for(var Be in ge)if((Be==="major"||Be==="minor"||Be==="patch")&&ge[Be]!==Ne[Be])return Be},e.compareIdentifiers=Re;var ve=/^[0-9]+$/;function Re(Q,pe){var ge=ve.test(Q),Ne=ve.test(pe);return ge&&Ne&&(Q=+Q,pe=+pe),ge&&!Ne?-1:Ne&&!ge?1:Q<pe?-1:Q>pe?1:0}function Fe(Q,pe,ge){return new ee(Q,ge).compare(new ee(pe,ge))}function We(Q,pe,ge){return Fe(Q,pe,ge)>0}function Xe(Q,pe,ge){return Fe(Q,pe,ge)<0}function Te(Q,pe,ge){return Fe(Q,pe,ge)===0}function Se(Q,pe,ge){return Fe(Q,pe,ge)!==0}function ke(Q,pe,ge){return Fe(Q,pe,ge)>=0}function se(Q,pe,ge){return Fe(Q,pe,ge)<=0}function le(Q,pe,ge,Ne){var Be;switch(pe){case"===":typeof Q=="object"&&(Q=Q.version),typeof ge=="object"&&(ge=ge.version),Be=Q===ge;break;case"!==":typeof Q=="object"&&(Q=Q.version),typeof ge=="object"&&(ge=ge.version),Be=Q!==ge;break;case"":case"=":case"==":Be=Te(Q,ge,Ne);break;case"!=":Be=Se(Q,ge,Ne);break;case">":Be=We(Q,ge,Ne);break;case">=":Be=ke(Q,ge,Ne);break;case"<":Be=Xe(Q,ge,Ne);break;case"<=":Be=se(Q,ge,Ne);break;default:throw new TypeError("Invalid operator: "+pe)}return Be}function G(Q,pe){if(Q instanceof G){if(Q.loose===pe)return Q;Q=Q.value}if(!(this instanceof G))return new G(Q,pe);p("comparator",Q,pe),this.loose=pe,this.parse(Q),this.semver===X?this.value="":this.value=this.operator+this.semver.version,p("comp",this)}e.rcompareIdentifiers=function(Q,pe){return Re(pe,Q)},e.major=function(Q,pe){return new ee(Q,pe).major},e.minor=function(Q,pe){return new ee(Q,pe).minor},e.patch=function(Q,pe){return new ee(Q,pe).patch},e.compare=Fe,e.compareLoose=function(Q,pe){return Fe(Q,pe,!0)},e.rcompare=function(Q,pe,ge){return Fe(pe,Q,ge)},e.sort=function(Q,pe){return Q.sort(function(ge,Ne){return e.compare(ge,Ne,pe)})},e.rsort=function(Q,pe){return Q.sort(function(ge,Ne){return e.rcompare(ge,Ne,pe)})},e.gt=We,e.lt=Xe,e.eq=Te,e.neq=Se,e.gte=ke,e.lte=se,e.cmp=le,e.Comparator=G;var X={};function k(Q,pe){if(Q instanceof k)return Q.loose===pe?Q:new k(Q.raw,pe);if(Q instanceof G)return new k(Q.value,pe);if(!(this instanceof k))return new k(Q,pe);if(this.loose=pe,this.raw=Q,this.set=Q.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Q);this.format()}function z(Q){return!Q||Q.toLowerCase()==="x"||Q==="*"}function H(Q,pe,ge,Ne,Be,Pe,Ke,q,Y,me,Le,ze,Ge){return((pe=z(ge)?"":z(Ne)?">="+ge+".0.0":z(Be)?">="+ge+"."+Ne+".0":">="+pe)+" "+(q=z(Y)?"":z(me)?"<"+(+Y+1)+".0.0":z(Le)?"<"+Y+"."+(+me+1)+".0":ze?"<="+Y+"."+me+"."+Le+"-"+ze:"<="+q)).trim()}function V(Q,pe){for(var ge=0;ge<Q.length;ge++)if(!Q[ge].test(pe))return!1;if(pe.prerelease.length){for(ge=0;ge<Q.length;ge++)if(p(Q[ge].semver),Q[ge].semver!==X&&Q[ge].semver.prerelease.length>0){var Ne=Q[ge].semver;if(Ne.major===pe.major&&Ne.minor===pe.minor&&Ne.patch===pe.patch)return!0}return!1}return!0}function re(Q,pe,ge){try{pe=new k(pe,ge)}catch{return!1}return pe.test(Q)}function de(Q,pe,ge,Ne){var Be,Pe,Ke,q,Y;switch(Q=new ee(Q,Ne),pe=new k(pe,Ne),ge){case">":Be=We,Pe=se,Ke=Xe,q=">",Y=">=";break;case"<":Be=Xe,Pe=ke,Ke=We,q="<",Y="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(re(Q,pe,Ne))return!1;for(var me=0;me<pe.set.length;++me){var Le=pe.set[me],ze=null,Ge=null;if(Le.forEach(function(Ze){Ze.semver===X&&(Ze=new G(">=0.0.0")),ze=ze||Ze,Ge=Ge||Ze,Be(Ze.semver,ze.semver,Ne)?ze=Ze:Ke(Ze.semver,Ge.semver,Ne)&&(Ge=Ze)}),ze.operator===q||ze.operator===Y||(!Ge.operator||Ge.operator===q)&&Pe(Q,Ge.semver)||Ge.operator===Y&&Ke(Q,Ge.semver))return!1}return!0}G.prototype.parse=function(Q){var pe=this.loose?P[F]:P[oe],ge=Q.match(pe);if(!ge)throw new TypeError("Invalid comparator: "+Q);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new ee(ge[2],this.loose):this.semver=X},G.prototype.toString=function(){return this.value},G.prototype.test=function(Q){return p("Comparator.test",Q,this.loose),this.semver===X||(typeof Q=="string"&&(Q=new ee(Q,this.loose)),le(Q,this.operator,this.semver,this.loose))},G.prototype.intersects=function(Q,pe){if(!(Q instanceof G))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new k(Q.value,pe),re(this.value,ge,pe);if(Q.operator==="")return ge=new k(this.value,pe),re(Q.semver,ge,pe);var Ne=!(this.operator!==">="&&this.operator!==">"||Q.operator!==">="&&Q.operator!==">"),Be=!(this.operator!=="<="&&this.operator!=="<"||Q.operator!=="<="&&Q.operator!=="<"),Pe=this.semver.version===Q.semver.version,Ke=!(this.operator!==">="&&this.operator!=="<="||Q.operator!==">="&&Q.operator!=="<="),q=le(this.semver,"<",Q.semver,pe)&&(this.operator===">="||this.operator===">")&&(Q.operator==="<="||Q.operator==="<"),Y=le(this.semver,">",Q.semver,pe)&&(this.operator==="<="||this.operator==="<")&&(Q.operator===">="||Q.operator===">");return Ne||Be||Pe&&Ke||q||Y},e.Range=k,k.prototype.format=function(){return this.range=this.set.map(function(Q){return Q.join(" ").trim()}).join("||").trim(),this.range},k.prototype.toString=function(){return this.range},k.prototype.parseRange=function(Q){var pe=this.loose;Q=Q.trim(),p("range",Q,pe);var ge=pe?P[fe]:P[ae];Q=Q.replace(ge,H),p("hyphen replace",Q),Q=Q.replace(P[ce],"$1$2$3"),p("comparator trim",Q,P[ce]),Q=(Q=(Q=Q.replace(P[R],"$1~")).replace(P[W],"$1^")).split(/\s+/).join(" ");var Ne=pe?P[F]:P[oe],Be=Q.split(" ").map(function(Pe){return function(Ke,q){return p("comp",Ke),Ke=function(Y,me){return Y.trim().split(/\s+/).map(function(Le){return function(ze,Ge){p("caret",ze,Ge);var Ze=Ge?P[K]:P[Z];return ze.replace(Ze,function(ot,Qe,et,qe,st){var it;return p("caret",ze,ot,Qe,et,qe,st),z(Qe)?it="":z(et)?it=">="+Qe+".0.0 <"+(+Qe+1)+".0.0":z(qe)?it=Qe==="0"?">="+Qe+"."+et+".0 <"+Qe+"."+(+et+1)+".0":">="+Qe+"."+et+".0 <"+(+Qe+1)+".0.0":st?(p("replaceCaret pr",st),st.charAt(0)!=="-"&&(st="-"+st),it=Qe==="0"?et==="0"?">="+Qe+"."+et+"."+qe+st+" <"+Qe+"."+et+"."+(+qe+1):">="+Qe+"."+et+"."+qe+st+" <"+Qe+"."+(+et+1)+".0":">="+Qe+"."+et+"."+qe+st+" <"+(+Qe+1)+".0.0"):(p("no pr"),it=Qe==="0"?et==="0"?">="+Qe+"."+et+"."+qe+" <"+Qe+"."+et+"."+(+qe+1):">="+Qe+"."+et+"."+qe+" <"+Qe+"."+(+et+1)+".0":">="+Qe+"."+et+"."+qe+" <"+(+Qe+1)+".0.0"),p("caret return",it),it})}(Le,me)}).join(" ")}(Ke,q),p("caret",Ke),Ke=function(Y,me){return Y.trim().split(/\s+/).map(function(Le){return function(ze,Ge){var Ze=Ge?P[M]:P[E];return ze.replace(Ze,function(ot,Qe,et,qe,st){var it;return p("tilde",ze,ot,Qe,et,qe,st),z(Qe)?it="":z(et)?it=">="+Qe+".0.0 <"+(+Qe+1)+".0.0":z(qe)?it=">="+Qe+"."+et+".0 <"+Qe+"."+(+et+1)+".0":st?(p("replaceTilde pr",st),st.charAt(0)!=="-"&&(st="-"+st),it=">="+Qe+"."+et+"."+qe+st+" <"+Qe+"."+(+et+1)+".0"):it=">="+Qe+"."+et+"."+qe+" <"+Qe+"."+(+et+1)+".0",p("tilde return",it),it})}(Le,me)}).join(" ")}(Ke,q),p("tildes",Ke),Ke=function(Y,me){return p("replaceXRanges",Y,me),Y.split(/\s+/).map(function(Le){return function(ze,Ge){ze=ze.trim();var Ze=Ge?P[I]:P[m];return ze.replace(Ze,function(ot,Qe,et,qe,st,it){p("xRange",ze,ot,Qe,et,qe,st,it);var lt=z(et),ct=lt||z(qe),Pt=ct||z(st);return Qe==="="&&Pt&&(Qe=""),lt?ot=Qe===">"||Qe==="<"?"<0.0.0":"*":Qe&&Pt?(ct&&(qe=0),Pt&&(st=0),Qe===">"?(Qe=">=",ct?(et=+et+1,qe=0,st=0):Pt&&(qe=+qe+1,st=0)):Qe==="<="&&(Qe="<",ct?et=+et+1:qe=+qe+1),ot=Qe+et+"."+qe+"."+st):ct?ot=">="+et+".0.0 <"+(+et+1)+".0.0":Pt&&(ot=">="+et+"."+qe+".0 <"+et+"."+(+qe+1)+".0"),p("xRange return",ot),ot})}(Le,me)}).join(" ")}(Ke,q),p("xrange",Ke),Ke=function(Y,me){return p("replaceStars",Y,me),Y.trim().replace(P[ie],"")}(Ke,q),p("stars",Ke),Ke}(Pe,pe)}).join(" ").split(/\s+/);return this.loose&&(Be=Be.filter(function(Pe){return!!Pe.match(Ne)})),Be=Be.map(function(Pe){return new G(Pe,pe)})},k.prototype.intersects=function(Q,pe){if(!(Q instanceof k))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ne){return Q.set.some(function(Be){return Be.every(function(Pe){return Ne.intersects(Pe,pe)})})})})},e.toComparators=function(Q,pe){return new k(Q,pe).set.map(function(ge){return ge.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},k.prototype.test=function(Q){if(!Q)return!1;typeof Q=="string"&&(Q=new ee(Q,this.loose));for(var pe=0;pe<this.set.length;pe++)if(V(this.set[pe],Q))return!0;return!1},e.satisfies=re,e.maxSatisfying=function(Q,pe,ge){var Ne=null,Be=null;try{var Pe=new k(pe,ge)}catch{return null}return Q.forEach(function(Ke){Pe.test(Ke)&&(Ne&&Be.compare(Ke)!==-1||(Be=new ee(Ne=Ke,ge)))}),Ne},e.minSatisfying=function(Q,pe,ge){var Ne=null,Be=null;try{var Pe=new k(pe,ge)}catch{return null}return Q.forEach(function(Ke){Pe.test(Ke)&&(Ne&&Be.compare(Ke)!==1||(Be=new ee(Ne=Ke,ge)))}),Ne},e.validRange=function(Q,pe){try{return new k(Q,pe).range||"*"}catch{return null}},e.ltr=function(Q,pe,ge){return de(Q,pe,"<",ge)},e.gtr=function(Q,pe,ge){return de(Q,pe,">",ge)},e.outside=de,e.prerelease=function(Q,pe){var ge=be(Q,pe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(Q,pe,ge){return Q=new k(Q,ge),pe=new k(pe,ge),Q.intersects(pe)},e.coerce=function(Q){if(Q instanceof ee)return Q;if(typeof Q!="string")return null;var pe=Q.match(P[B]);return pe==null?null:be((pe[1]||"0")+"."+(pe[2]||"0")+"."+(pe[3]||"0"))}}).call(this,s(1))},function(J,e){var s,C,p=J.exports={};function U(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function P(h){if(s===setTimeout)return setTimeout(h,0);if((s===U||!s)&&setTimeout)return s=setTimeout,setTimeout(h,0);try{return s(h,0)}catch{try{return s.call(null,h,0)}catch{return s.call(this,h,0)}}}(function(){try{s=typeof setTimeout=="function"?setTimeout:U}catch{s=U}try{C=typeof clearTimeout=="function"?clearTimeout:T}catch{C=T}})();var b,A=[],O=!1,w=-1;function g(){O&&b&&(O=!1,b.length?A=b.concat(A):w=-1,A.length&&S())}function S(){if(!O){var h=P(g);O=!0;for(var u=A.length;u;){for(b=A,A=[];++w<u;)b&&b[w].run();w=-1,u=A.length}b=null,O=!1,function(D){if(C===clearTimeout)return clearTimeout(D);if((C===T||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(D);try{C(D)}catch{try{return C.call(null,D)}catch{return C.call(this,D)}}}(h)}}function f(h,u){this.fun=h,this.array=u}function c(){}p.nextTick=function(h){var u=new Array(arguments.length-1);if(arguments.length>1)for(var D=1;D<arguments.length;D++)u[D-1]=arguments[D];A.push(new f(h,u)),A.length!==1||O||P(S)},f.prototype.run=function(){this.fun.apply(null,this.array)},p.title="browser",p.browser=!0,p.env={},p.argv=[],p.version="",p.versions={},p.on=c,p.addListener=c,p.once=c,p.off=c,p.removeListener=c,p.removeAllListeners=c,p.emit=c,p.prependListener=c,p.prependOnceListener=c,p.listeners=function(h){return[]},p.binding=function(h){throw new Error("process.binding is not supported")},p.cwd=function(){return"/"},p.chdir=function(h){throw new Error("process.chdir is not supported")},p.umask=function(){return 0}}])}),define(De[107],Ie([1,0,11,7]),function(J,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function p(a){const _=a;return _?typeof _.read=="function":!1}e.isReadable=p;function U(a){const _=a;return _?[_.on,_.pause,_.resume,_.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=U;function T(a){const _=a;return _?U(_.stream)&&Array.isArray(_.buffer)&&typeof _.ended=="boolean":!1}e.isReadableBufferedStream=T;function P(a,_){return new b(a,_)}e.newWriteableStream=P;class b{constructor(_,r){this.reducer=_,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(_){if(!this.state.destroyed){if(this.state.flowing)this.emitData(_);else if(this.buffer.data.push(_),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(_){this.state.destroyed||(this.state.flowing?this.emitError(_):this.buffer.error.push(_))}end(_){this.state.destroyed||(typeof _!="undefined"&&this.write(_),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(_){this.listeners.data.slice(0).forEach(r=>r(_))}emitError(_){this.listeners.error.length===0?(0,s.onUnexpectedError)(_):this.listeners.error.slice(0).forEach(r=>r(_))}emitEnd(){this.listeners.end.slice(0).forEach(_=>_())}on(_,r){if(!this.state.destroyed)switch(_){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(_,r){if(this.state.destroyed)return;let d;switch(_){case"data":d=this.listeners.data;break;case"end":d=this.listeners.end;break;case"error":d=this.listeners.error;break}if(d){const i=d.indexOf(r);i>=0&&d.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const _=this.reducer(this.buffer.data);this.emitData(_),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(d=>d())}}flowErrors(){if(this.listeners.error.length>0){for(const _ of this.buffer.error)this.emitError(_);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function A(a,_){const r=[];let d;for(;(d=a.read())!==null;)r.push(d);return _(r)}e.consumeReadable=A;function O(a,_,r){const d=[];let i;for(;(i=a.read())!==null&&d.length<r;)d.push(i);return i===null&&d.length>0?_(d):{read:()=>{if(d.length>0)return d.shift();if(typeof i!="undefined"){const o=i;return i=void 0,o}return a.read()}}}e.peekReadable=O;function w(a,_){return new Promise((r,d)=>{const i=[];g(a,{onData:o=>{_&&i.push(o)},onError:o=>{_?d(o):r(void 0)},onEnd:()=>{r(_?_(i):void 0)}})})}e.consumeStream=w;function g(a,_){let r=!1;return a.on("error",d=>{r||_.onError(d)}),a.on("end",()=>{r||_.onEnd()}),a.on("data",d=>{r||_.onData(d)}),(0,C.toDisposable)(()=>r=!0)}e.listenStream=g;function S(a,_){return new Promise((r,d)=>{const i=new C.DisposableStore,o=[],n=v=>{if(o.push(v),o.length>_)return i.dispose(),a.pause(),r({stream:a,buffer:o,ended:!1})},t=v=>d(v),l=()=>r({stream:a,buffer:o,ended:!0});i.add((0,C.toDisposable)(()=>a.removeListener("error",t))),a.on("error",t),i.add((0,C.toDisposable)(()=>a.removeListener("end",l))),a.on("end",l),i.add((0,C.toDisposable)(()=>a.removeListener("data",n))),a.on("data",n)})}e.peekStream=S;function f(a,_){const r=P(_);return r.end(a),r}e.toStream=f;function c(){const a=P(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=c;function h(a){let _=!1;return{read:()=>_?null:(_=!0,a)}}e.toReadable=h;function u(a,_,r){const d=P(r);return g(a,{onData:i=>d.write(_.data(i)),onError:i=>d.error(_.error?_.error(i):i),onEnd:()=>d.end()}),d}e.transform=u;function D(a,_,r){let d=!1;return{read:()=>{const i=_.read();return d?i:(d=!0,i!==null?r([a,i]):a)}}}e.prefixedReadable=D;function y(a,_,r){let d=!1;const i=P(r);return g(_,{onData:o=>d?i.write(o):(d=!0,i.write(r([a,o]))),onError:o=>i.error(o),onEnd:()=>{d||(d=!0,i.write(a)),i.end()}}),i}e.prefixedStream=y}),define(De[23],Ie([1,0,107]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const C=typeof Buffer!="undefined";let p,U;class T{constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}static alloc(v){return C?new T(Buffer.allocUnsafe(v)):new T(new Uint8Array(v))}static wrap(v){return C&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new T(v)}static fromString(v,m){return!(m?.dontUseNodeBuffer||!1)&&C?new T(Buffer.from(v)):(p||(p=new TextEncoder),new T(p.encode(v)))}static fromByteArray(v){const m=T.alloc(v.length);for(let I=0,B=v.length;I<B;I++)m.buffer[I]=v[I];return m}static concat(v,m){if(typeof m=="undefined"){m=0;for(let x=0,R=v.length;x<R;x++)m+=v[x].byteLength}const I=T.alloc(m);let B=0;for(let x=0,R=v.length;x<R;x++){const E=v[x];I.set(E,B),B+=E.byteLength}return I}clone(){const v=T.alloc(this.byteLength);return v.set(this),v}toString(){return C?this.buffer.toString():(U||(U=new TextDecoder),U.decode(this.buffer))}slice(v,m){return new T(this.buffer.subarray(v,m))}set(v,m){if(v instanceof T)this.buffer.set(v.buffer,m);else if(v instanceof Uint8Array)this.buffer.set(v,m);else if(v instanceof ArrayBuffer)this.buffer.set(new Uint8Array(v),m);else if(ArrayBuffer.isView(v))this.buffer.set(new Uint8Array(v.buffer,v.byteOffset,v.byteLength),m);else throw new Error("Unknown argument 'array'")}readUInt32BE(v){return A(this.buffer,v)}writeUInt32BE(v,m){O(this.buffer,v,m)}readUInt32LE(v){return w(this.buffer,v)}writeUInt32LE(v,m){g(this.buffer,v,m)}readUInt8(v){return S(this.buffer,v)}writeUInt8(v,m){f(this.buffer,v,m)}}e.VSBuffer=T;function P(l,v){return l[v+0]<<0>>>0|l[v+1]<<8>>>0}e.readUInt16LE=P;function b(l,v,m){l[m+0]=v&255,v=v>>>8,l[m+1]=v&255}e.writeUInt16LE=b;function A(l,v){return l[v]*2**24+l[v+1]*2**16+l[v+2]*2**8+l[v+3]}e.readUInt32BE=A;function O(l,v,m){l[m+3]=v,v=v>>>8,l[m+2]=v,v=v>>>8,l[m+1]=v,v=v>>>8,l[m]=v}e.writeUInt32BE=O;function w(l,v){return l[v+0]<<0>>>0|l[v+1]<<8>>>0|l[v+2]<<16>>>0|l[v+3]<<24>>>0}e.readUInt32LE=w;function g(l,v,m){l[m+0]=v&255,v=v>>>8,l[m+1]=v&255,v=v>>>8,l[m+2]=v&255,v=v>>>8,l[m+3]=v&255}e.writeUInt32LE=g;function S(l,v){return l[v]}e.readUInt8=S;function f(l,v,m){l[m]=v}e.writeUInt8=f;function c(l){return s.consumeReadable(l,v=>T.concat(v))}e.readableToBuffer=c;function h(l){return s.toReadable(l)}e.bufferToReadable=h;function u(l){return s.consumeStream(l,v=>T.concat(v))}e.streamToBuffer=u;async function D(l){return l.ended?T.concat(l.buffer):T.concat([...l.buffer,await u(l.stream)])}e.bufferedStreamToBuffer=D;function y(l){return s.toStream(l,v=>T.concat(v))}e.bufferToStream=y;function a(l){return s.transform(l,{data:v=>typeof v=="string"?T.fromString(v):T.wrap(v)},v=>T.concat(v))}e.streamToBufferReadableStream=a;function _(l){return s.newWriteableStream(v=>T.concat(v),l)}e.newWriteableBufferStream=_;function r(l,v){return s.prefixedReadable(l,v,m=>T.concat(m))}e.prefixedBufferReadable=r;function d(l,v){return s.prefixedStream(l,v,m=>T.concat(m))}e.prefixedBufferStream=d;function i(l){let v=0,m=0,I=0;const B=new Uint8Array(Math.floor(l.length/4*3)),x=E=>{switch(m){case 3:B[I++]=v|E,m=0;break;case 2:B[I++]=v|E>>>2,v=E<<6,m=3;break;case 1:B[I++]=v|E>>>4,v=E<<4,m=2;break;default:v=E<<2,m=1}};for(let E=0;E<l.length;E++){const M=l.charCodeAt(E);if(M>=65&&M<=90)x(M-65);else if(M>=97&&M<=122)x(M-97+26);else if(M>=48&&M<=57)x(M-48+52);else if(M===43||M===45)x(62);else if(M===47||M===95)x(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${l[E]}`)}}const R=I;for(;m>0;)x(0);return T.wrap(B).slice(0,R)}e.decodeBase64=i;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function t({buffer:l},v=!0,m=!1){const I=m?n:o;let B="";const x=l.byteLength%3;let R=0;for(;R<l.byteLength-x;R+=3){const E=l[R+0],M=l[R+1],N=l[R+2];B+=I[E>>>2],B+=I[(E<<4|M>>>4)&63],B+=I[(M<<2|N>>>6)&63],B+=I[N&63]}if(x===1){const E=l[R+0];B+=I[E>>>2],B+=I[E<<4&63],v&&(B+="==")}else if(x===2){const E=l[R+0],M=l[R+1];B+=I[E>>>2],B+=I[(E<<4|M>>>4)&63],B+=I[M<<2&63],v&&(B+="=")}return B}e.encodeBase64=t});var Ye=this&&this.__classPrivateFieldSet||function(J,e,s,C,p){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?p.call(J,s):p?p.value=s:e.set(J,s),s},Ae=this&&this.__classPrivateFieldGet||function(J,e,s,C){if(s==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?C:s==="a"?C.call(J):C?C.value:e.get(J)};define(De[24],Ie([1,0,15,10]),function(J,e,s,C){"use strict";var p,U,T,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function b(n,t,l){let v=n.get(t);return v===void 0&&(v=l,n.set(t,v)),v}e.getOrSet=b;function A(n){const t=[];return n.forEach((l,v)=>{t.push(`${v} => ${l}`)}),`Map(${n.size}) {${t.join(", ")}}`}e.mapToString=A;function O(n){const t=[];return n.forEach(l=>{t.push(l)}),`Set(${n.size}) {${t.join(", ")}}`}e.setToString=O;class w{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const l=t.charCodeAt(0),v=this._value.charCodeAt(this._pos);return l-v}value(){return this._value[this._pos]}}e.StringIterator=w;class g{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,C.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,C.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=g;class S{constructor(t=!0,l=!0){this._splitOnBackslash=t,this._caseSensitive=l}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let l=t.length-1;l>=0;l--,this._valueLen--){const v=this._value.charCodeAt(l);if(!(v===47||this._splitOnBackslash&&v===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const l=this._value.charCodeAt(this._to);if(l===47||this._splitOnBackslash&&l===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,C.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,C.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=S;var f;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(f||(f={}));class c{constructor(t,l){this._ignorePathCasing=t,this._ignoreQueryAndFragment=l,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new S(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(t)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,C.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,C.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,C.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,C.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=c;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var u;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(u||(u={}));class D{constructor(t){this._iter=t}static forUris(t=()=>!1,l=()=>!1){return new D(new c(t,l))}static forPaths(t=!1){return new D(new S(void 0,!t))}static forStrings(){return new D(new w)}static forConfigKeys(){return new D(new g)}clear(){this._root=void 0}fill(t,l){if(l){const v=l.slice(0);(0,s.shuffle)(v);for(let m of v)this.set(m,t)}else{const v=t.slice(0);(0,s.shuffle)(v);for(let m of v)this.set(m[0],m[1])}}set(t,l){const v=this._iter.reset(t);let m;this._root||(this._root=new h,this._root.segment=v.value());const I=[];for(m=this._root;;){const x=v.cmp(m.segment);if(x>0)m.left||(m.left=new h,m.left.segment=v.value()),I.push([-1,m]),m=m.left;else if(x<0)m.right||(m.right=new h,m.right.segment=v.value()),I.push([1,m]),m=m.right;else if(v.hasNext())v.next(),m.mid||(m.mid=new h,m.mid.segment=v.value()),I.push([0,m]),m=m.mid;else break}const B=m.value;m.value=l,m.key=t;for(let x=I.length-1;x>=0;x--){const R=I[x][1];R.updateHeight();const E=R.balanceFactor();if(E<-1||E>1){const M=I[x][0],N=I[x+1][0];if(M===1&&N===1)I[x][1]=R.rotateLeft();else if(M===-1&&N===-1)I[x][1]=R.rotateRight();else if(M===1&&N===-1)R.right=I[x+1][1]=I[x+1][1].rotateRight(),I[x][1]=R.rotateLeft();else if(M===-1&&N===1)R.left=I[x+1][1]=I[x+1][1].rotateLeft(),I[x][1]=R.rotateRight();else throw new Error;if(x>0)switch(I[x-1][0]){case-1:I[x-1][1].left=I[x][1];break;case 1:I[x-1][1].right=I[x][1];break;case 0:I[x-1][1].mid=I[x][1];break}else this._root=I[0][1]}}return B}get(t){return this._getNode(t)?.value}_getNode(t){const l=this._iter.reset(t);let v=this._root;for(;v;){const m=l.cmp(v.segment);if(m>0)v=v.left;else if(m<0)v=v.right;else if(l.hasNext())l.next(),v=v.mid;else break}return v}has(t){const l=this._getNode(t);return!(l?.value===void 0&&l?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,l){const v=this._iter.reset(t),m=[];let I=this._root;for(;I;){const B=v.cmp(I.segment);if(B>0)m.push([-1,I]),I=I.left;else if(B<0)m.push([1,I]),I=I.right;else if(v.hasNext())v.next(),m.push([0,I]),I=I.mid;else break}if(!!I){if(l?(I.left=void 0,I.mid=void 0,I.right=void 0,I.height=1):(I.key=void 0,I.value=void 0),!I.mid&&!I.value)if(I.left&&I.right){const B=this._min(I.right),{key:x,value:R,segment:E}=B;this._delete(B.key,!1),I.key=x,I.value=R,I.segment=E}else{const B=I.left??I.right;if(m.length>0){const[x,R]=m[m.length-1];switch(x){case-1:R.left=B;break;case 0:R.mid=B;break;case 1:R.right=B;break}}else this._root=B}for(let B=m.length-1;B>=0;B--){const x=m[B][1];x.updateHeight();const R=x.balanceFactor();if(R>1?(x.right.balanceFactor()>=0||(x.right=x.right.rotateRight()),m[B][1]=x.rotateLeft()):R<-1&&(x.left.balanceFactor()<=0||(x.left=x.left.rotateLeft()),m[B][1]=x.rotateRight()),B>0)switch(m[B-1][0]){case-1:m[B-1][1].left=m[B][1];break;case 1:m[B-1][1].right=m[B][1];break;case 0:m[B-1][1].mid=m[B][1];break}else this._root=m[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const l=this._iter.reset(t);let v=this._root,m;for(;v;){const I=l.cmp(v.segment);if(I>0)v=v.left;else if(I<0)v=v.right;else if(l.hasNext())l.next(),m=v.value||m,v=v.mid;else break}return v&&v.value||m}findSuperstr(t){const l=this._iter.reset(t);let v=this._root;for(;v;){const m=l.cmp(v.segment);if(m>0)v=v.left;else if(m<0)v=v.right;else if(l.hasNext())l.next(),v=v.mid;else return v.mid?this._entries(v.mid):void 0}}forEach(t){for(const[l,v]of this)t(v,l)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=l=>{if(!l)return!0;const v=l.balanceFactor();return v<-1||v>1?!1:t(l.left)&&t(l.right)};return t(this._root)}}e.TernarySearchTree=D;class y{constructor(t,l){this.uri=t,this.value=l}}class a{constructor(t,l){this[p]="ResourceMap",t instanceof a?(this.map=new Map(t.map),this.toKey=l??a.defaultToKey):(this.map=new Map,this.toKey=t??a.defaultToKey)}set(t,l){return this.map.set(this.toKey(t),new y(t,l)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,l){typeof l!="undefined"&&(t=t.bind(l));for(let[v,m]of this.map)t(m.value,m.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(p=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=a,a.defaultToKey=n=>n.toString();class _{constructor(t,l){this[U]="ResourceSet",!t||typeof t=="function"?this._map=new a(t):(this._map=new a(l),t.forEach(this.add,this))}get size(){return this._map.size}add(t){return this._map.set(t,t),this}clear(){this._map.clear()}delete(t){return this._map.delete(t)}forEach(t,l){this._map.forEach((v,m)=>t.call(l,m,m,this))}has(t){return this._map.has(t)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(U=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=_;var r;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(r=e.Touch||(e.Touch={}));class d{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,l=0){const v=this._map.get(t);if(!!v)return l!==0&&this.touch(v,l),v.value}set(t,l,v=0){let m=this._map.get(t);if(m)m.value=l,v!==0&&this.touch(m,v);else{switch(m={key:t,value:l,next:void 0,previous:void 0},v){case 0:this.addItemLast(m);break;case 1:this.addItemFirst(m);break;case 2:this.addItemLast(m);break;default:this.addItemLast(m);break}this._map.set(t,m),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const l=this._map.get(t);if(!!l)return this._map.delete(t),this.removeItem(l),this._size--,l.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,l){const v=this._state;let m=this._head;for(;m;){if(l?t.bind(l)(m.value,m.key,this):t(m.value,m.key,this),this._state!==v)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const t=this,l=this._state;let v=this._head;const m={[Symbol.iterator](){return m},next(){if(t._state!==l)throw new Error("LinkedMap got modified during iteration.");if(v){const I={value:v.key,done:!1};return v=v.next,I}else return{value:void 0,done:!0}}};return m}values(){const t=this,l=this._state;let v=this._head;const m={[Symbol.iterator](){return m},next(){if(t._state!==l)throw new Error("LinkedMap got modified during iteration.");if(v){const I={value:v.value,done:!1};return v=v.next,I}else return{value:void 0,done:!0}}};return m}entries(){const t=this,l=this._state;let v=this._head;const m={[Symbol.iterator](){return m},next(){if(t._state!==l)throw new Error("LinkedMap got modified during iteration.");if(v){const I={value:[v.key,v.value],done:!1};return v=v.next,I}else return{value:void 0,done:!0}}};return m}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let l=this._head,v=this.size;for(;l&&v>t;)this._map.delete(l.key),l=l.next,v--;this._head=l,this._size=v,l&&(l.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const l=t.next,v=t.previous;if(!l||!v)throw new Error("Invalid list");l.previous=v,v.next=l}t.next=void 0,t.previous=void 0,this._state++}touch(t,l){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(t===this._head)return;const v=t.next,m=t.previous;t===this._tail?(m.next=void 0,this._tail=m):(v.previous=m,m.next=v),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(l===2){if(t===this._tail)return;const v=t.next,m=t.previous;t===this._head?(v.previous=void 0,this._head=v):(v.previous=m,m.next=v),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((l,v)=>{t.push([v,l])}),t}fromJSON(t){this.clear();for(const[l,v]of t)this.set(l,v)}}e.LinkedMap=d;class i extends d{constructor(t,l=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,l),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,l=2){return super.get(t,l)}peek(t){return super.get(t,0)}set(t,l){return super.set(t,l,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class o{constructor(t){P.set(this,void 0),Ye(this,P,t,"f")}get size(){return Ae(this,P,"f").size}forEach(t,l){Ae(this,P,"f").forEach(t,l)}get(t){return Ae(this,P,"f").get(t)}has(t){return Ae(this,P,"f").has(t)}entries(){return Ae(this,P,"f").entries()}keys(){return Ae(this,P,"f").keys()}values(){return Ae(this,P,"f").values()}[(P=new WeakMap,Symbol.iterator)](){return Ae(this,P,"f").entries()}}e.ReadonlyMapView=o}),define(De[108],Ie([1,0,24,10]),function(J,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function p(...G){return function(X,k){for(let z=0,H=G.length;z<H;z++){const V=G[z](X,k);if(V)return V}return null}}e.or=p,e.matchesStrictPrefix=U.bind(void 0,!1),e.matchesPrefix=U.bind(void 0,!0);function U(G,X,k){if(!k||k.length<X.length)return null;let z;return G?z=C.startsWithIgnoreCase(k,X):z=k.indexOf(X)===0,z?X.length>0?[{start:0,end:X.length}]:[]:null}function T(G,X){const k=X.toLowerCase().indexOf(G.toLowerCase());return k===-1?null:[{start:k,end:k+G.length}]}e.matchesContiguousSubString=T;function P(G,X){return b(G.toLowerCase(),X.toLowerCase(),0,0)}e.matchesSubString=P;function b(G,X,k,z){if(k===G.length)return[];if(z===X.length)return null;if(G[k]===X[z]){let H=null;return(H=b(G,X,k+1,z+1))?u({start:z,end:z+1},H):null}return b(G,X,k,z+1)}function A(G){return 97<=G&&G<=122}function O(G){return 65<=G&&G<=90}e.isUpper=O;function w(G){return 48<=G&&G<=57}function g(G){return G===32||G===9||G===10||G===13}const S=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(G=>S.add(G.charCodeAt(0)));function f(G){return g(G)||S.has(G)}function c(G,X){return G===X||f(G)&&f(X)}function h(G){return A(G)||O(G)||w(G)}function u(G,X){return X.length===0?X=[G]:G.end===X[0].start?X[0].start=G.start:X.unshift(G),X}function D(G,X){for(let k=X;k<G.length;k++){const z=G.charCodeAt(k);if(O(z)||w(z)||k>0&&!h(G.charCodeAt(k-1)))return k}return G.length}function y(G,X,k,z){if(k===G.length)return[];if(z===X.length)return null;if(G[k]!==X[z].toLowerCase())return null;{let H=null,V=z+1;for(H=y(G,X,k+1,z+1);!H&&(V=D(X,V))<X.length;)H=y(G,X,k+1,V),V++;return H===null?null:u({start:z,end:z+1},H)}}function a(G){let X=0,k=0,z=0,H=0,V=0;for(let ge=0;ge<G.length;ge++)V=G.charCodeAt(ge),O(V)&&X++,A(V)&&k++,h(V)&&z++,w(V)&&H++;const re=X/G.length,de=k/G.length,Q=z/G.length,pe=H/G.length;return{upperPercent:re,lowerPercent:de,alphaPercent:Q,numericPercent:pe}}function _(G){const{upperPercent:X,lowerPercent:k}=G;return k===0&&X>.6}function r(G){const{upperPercent:X,lowerPercent:k,alphaPercent:z,numericPercent:H}=G;return k>.2&&X<.8&&z>.6&&H<.2}function d(G){let X=0,k=0,z=0,H=0;for(let V=0;V<G.length;V++)z=G.charCodeAt(V),O(z)&&X++,A(z)&&k++,g(z)&&H++;return(X===0||k===0)&&H===0?G.length<=30:X<=5}function i(G,X){if(!X||(X=X.trim(),X.length===0)||!d(G)||X.length>60)return null;const k=a(X);if(!r(k)){if(!_(k))return null;X=X.toLowerCase()}let z=null,H=0;for(G=G.toLowerCase();H<X.length&&(z=y(G,X,0,H))===null;)H=D(X,H+1);return z}e.matchesCamelCase=i;function o(G,X,k=!1){if(!X||X.length===0)return null;let z=null,H=0;for(G=G.toLowerCase(),X=X.toLowerCase();H<X.length&&(z=n(G,X,0,H,k))===null;)H=t(X,H+1);return z}e.matchesWords=o;function n(G,X,k,z,H){if(k===G.length)return[];if(z===X.length)return null;if(c(G.charCodeAt(k),X.charCodeAt(z))){let V=null,re=z+1;if(V=n(G,X,k+1,z+1,H),!H)for(;!V&&(re=t(X,re))<X.length;)V=n(G,X,k+1,re,H),re++;return V===null?null:u({start:z,end:z+1},V)}else return null}function t(G,X){for(let k=X;k<G.length;k++)if(f(G.charCodeAt(k))||k>0&&f(G.charCodeAt(k-1)))return k;return G.length}const l=p(e.matchesPrefix,i,T),v=p(e.matchesPrefix,i,P),m=new s.LRUCache(1e4);function I(G,X,k=!1){if(typeof G!="string"||typeof X!="string")return null;let z=m.get(G);z||(z=new RegExp(C.convertSimple2RegExpPattern(G),"i"),m.set(G,z));const H=z.exec(X);return H?[{start:H.index,end:H.index+H[0].length}]:k?v(G,X):l(G,X)}e.matchesFuzzy=I;function B(G,X){const k=We(G,G.toLowerCase(),0,X,X.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return k?R(k):null}e.matchesFuzzy2=B;function x(G,X,k,z,H,V){const re=Math.min(13,G.length);for(;k<re;k++){const de=We(G,X,k,z,H,V,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(de)return de}return[0,V]}e.anyScore=x;function R(G){if(typeof G=="undefined")return[];const X=[],k=G[1];for(let z=G.length-1;z>1;z--){const H=G[z]+k,V=X[X.length-1];V&&V.end===H?V.end=H+1:X.push({start:H,end:H+1})}return X}e.createMatches=R;const E=128;function M(){const G=[],X=[];for(let k=0;k<=E;k++)X[k]=0;for(let k=0;k<=E;k++)G.push(X.slice(0));return G}function N(G){const X=[];for(let k=0;k<=G;k++)X[k]=0;return X}const W=N(2*E),Z=N(2*E),K=M(),F=M(),oe=M(),ce=!1;function ae(G,X,k,z,H){function V(de,Q,pe=" "){for(;de.length<Q;)de=pe+de;return de}let re=` |   |${z.split("").map(de=>V(de,3)).join("|")}
`;for(let de=0;de<=k;de++)de===0?re+=" |":re+=`${X[de-1]}|`,re+=G[de].slice(0,H+1).map(Q=>V(Q.toString(),3)).join("|")+`
`;return re}function fe(G,X,k,z){G=G.substr(X),k=k.substr(z),console.log(ae(F,G,G.length,k,k.length)),console.log(ae(oe,G,G.length,k,k.length)),console.log(ae(K,G,G.length,k,k.length))}function ie(G,X){if(X<0||X>=G.length)return!1;const k=G.codePointAt(X);switch(k){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!C.isEmojiImprecise(k)}}function Ee(G,X){if(X<0||X>=G.length)return!1;switch(G.charCodeAt(X)){case 32:case 9:return!0;default:return!1}}function be(G,X,k){return X[G]!==k[G]}function ee(G,X,k,z,H,V,re=!1){for(;X<k&&H<V;)G[X]===z[H]&&(re&&(W[X]=H),X+=1),H+=1;return X===k}e.isPatternInWord=ee;var ve;(function(G){G[G.Diag=1]="Diag",G[G.Left=2]="Left",G[G.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var Re;(function(G){G.Default=[-100,0];function X(k){return!k||k.length===2&&k[0]===-100&&k[1]===0}G.isDefault=X})(Re=e.FuzzyScore||(e.FuzzyScore={}));class Fe{constructor(X,k){this.firstMatchCanBeWeak=X,this.boostFullMatch=k}}e.FuzzyScoreOptions=Fe,Fe.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function We(G,X,k,z,H,V,re=Fe.default){const de=G.length>E?E:G.length,Q=z.length>E?E:z.length;if(k>=de||V>=Q||de-k>Q-V||!ee(X,k,de,H,V,Q,!0))return;Xe(de,Q,k,V,X,H);let pe=1,ge=1,Ne=k,Be=V;const Pe=[!1];for(pe=1,Ne=k;Ne<de;pe++,Ne++){const Le=W[Ne],ze=Z[Ne],Ge=Ne+1<de?Z[Ne+1]:Q;for(ge=Le-V+1,Be=Le;Be<Ge;ge++,Be++){let Ze=Number.MIN_SAFE_INTEGER,ot=!1;Be<=ze&&(Ze=Te(G,X,Ne,k,z,H,Be,Q,V,K[pe-1][ge-1]===0,Pe));let Qe=0;Ze!==Number.MAX_SAFE_INTEGER&&(ot=!0,Qe=Ze+F[pe-1][ge-1]);const et=Be>Le,qe=et?F[pe][ge-1]+(K[pe][ge-1]>0?-5:0):0,st=Be>Le+1&&K[pe][ge-1]>0,it=st?F[pe][ge-2]+(K[pe][ge-2]>0?-5:0):0;if(st&&(!et||it>=qe)&&(!ot||it>=Qe))F[pe][ge]=it,oe[pe][ge]=3,K[pe][ge]=0;else if(et&&(!ot||qe>=Qe))F[pe][ge]=qe,oe[pe][ge]=2,K[pe][ge]=0;else if(ot)F[pe][ge]=Qe,oe[pe][ge]=1,K[pe][ge]=K[pe-1][ge-1]+1;else throw new Error("not possible")}}if(ce&&fe(G,k,z,V),!Pe[0]&&!re.firstMatchCanBeWeak)return;pe--,ge--;const Ke=[F[pe][ge],V];let q=0,Y=0;for(;pe>=1;){let Le=ge;do{const ze=oe[pe][Le];if(ze===3)Le=Le-2;else if(ze===2)Le=Le-1;else break}while(Le>=1);q>1&&X[k+pe-1]===H[V+ge-1]&&!be(Le+V-1,z,H)&&q+1>K[pe][Le]&&(Le=ge),Le===ge?q++:q=1,Y||(Y=Le),pe--,ge=Le-1,Ke.push(ge)}Q===de&&re.boostFullMatch&&(Ke[0]+=2);const me=Y-de;return Ke[0]-=me,Ke}e.fuzzyScore=We;function Xe(G,X,k,z,H,V){let re=G-1,de=X-1;for(;re>=k&&de>=z;)H[re]===V[de]&&(Z[re]=de,re--),de--}function Te(G,X,k,z,H,V,re,de,Q,pe,ge){if(X[k]!==V[re])return Number.MIN_SAFE_INTEGER;let Ne=1,Be=!1;return re===k-z?Ne=G[k]===H[re]?7:5:be(re,H,V)&&(re===0||!be(re-1,H,V))?(Ne=G[k]===H[re]?7:5,Be=!0):ie(V,re)&&(re===0||!ie(V,re-1))?Ne=5:(ie(V,re-1)||Ee(V,re-1))&&(Ne=5,Be=!0),Ne>1&&k===z&&(ge[0]=!0),Be||(Be=be(re,H,V)||ie(V,re-1)||Ee(V,re-1)),k===z?re>Q&&(Ne-=Be?3:5):pe?Ne+=Be?2:0:Ne+=Be?0:1,re+1===de&&(Ne-=Be?3:5),Ne}function Se(G,X,k,z,H,V,re){return se(G,X,k,z,H,V,!0,re)}e.fuzzyScoreGracefulAggressive=Se;function ke(G,X,k,z,H,V,re){return se(G,X,k,z,H,V,!1,re)}e.fuzzyScoreGraceful=ke;function se(G,X,k,z,H,V,re,de){let Q=We(G,X,k,z,H,V,de);if(Q&&!re)return Q;if(G.length>=3){const pe=Math.min(7,G.length-1);for(let ge=k+1;ge<pe;ge++){const Ne=le(G,ge);if(Ne){const Be=We(Ne,Ne.toLowerCase(),k,z,H,V,de);Be&&(Be[0]-=3,(!Q||Be[0]>Q[0])&&(Q=Be))}}}return Q}function le(G,X){if(X+1>=G.length)return;const k=G[X],z=G[X+1];if(k!==z)return G.slice(0,X)+z+k+G.slice(X+2)}}),define(De[109],Ie([1,0,110,108,10]),function(J,e,s,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const U=new RegExp(`\\$\\(${s.CSSIcon.iconNameExpression}(?:${s.CSSIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(s.CSSIcon.iconNameCharacter),P=new RegExp(`(\\\\)?${U.source}`,"g");function b(h){return h.replace(P,(u,D)=>D?u:`\\${u}`)}e.escapeIcons=b;const A=new RegExp(`\\\\${U.source}`,"g");function O(h){return h.replace(A,u=>`\\${u}`)}e.markdownEscapeEscapedIcons=O;const w=new RegExp(`(\\s)?(\\\\)?${U.source}(\\s)?`,"g");function g(h){return h.indexOf(e.iconStartMarker)===-1?h:h.replace(w,(u,D,y,a)=>y?u:D||a||"")}e.stripIcons=g;function S(h){const u=h.indexOf(e.iconStartMarker);return u===-1?{text:h}:f(h,u)}e.parseLabelWithIcons=S;function f(h,u){const D=[];let y="";function a(l){if(l){y+=l;for(const v of l)D.push(d)}}let _=-1,r="",d=0,i,o,n=u;const t=h.length;for(a(h.substr(0,u));n<t;)i=h[n],o=h[n+1],i===e.iconStartMarker[0]&&o===e.iconStartMarker[1]?(_=n,a(r),r=e.iconStartMarker,n++):i===")"&&_!==-1?(d+=n-_+1,_=-1,r=""):_!==-1?T.test(i)?r+=i:(a(r),_=-1,r=""):a(i),n++;return a(r),{text:y,iconOffsets:D}}function c(h,u,D=!1){const{text:y,iconOffsets:a}=u;if(!a||a.length===0)return(0,C.matchesFuzzy)(h,y,D);const _=(0,p.ltrim)(y," "),r=y.length-_.length,d=(0,C.matchesFuzzy)(h,_,D);if(d)for(const i of d){const o=a[i.start+r]+r;i.start+=o,i.end+=o}return d}e.matchesFuzzyIconAware=c}),define(De[29],Ie([1,0,10]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(p){p[p.Ignore=0]="Ignore",p[p.Info=1]="Info",p[p.Warning=2]="Warning",p[p.Error=3]="Error"})(C||(C={})),function(p){const U="error",T="warning",P="warn",b="info",A="ignore";function O(g){return g?s.equalsIgnoreCase(U,g)?p.Error:s.equalsIgnoreCase(T,g)||s.equalsIgnoreCase(P,g)?p.Warning:s.equalsIgnoreCase(b,g)?p.Info:p.Ignore:p.Ignore}p.fromValue=O;function w(g){switch(g){case p.Error:return U;case p.Warning:return T;case p.Info:return b;default:return A}}p.toString=w}(C||(C={})),e.default=C}),define(De[37],Ie([1,0,19,22,10,9]),function(J,e,s,C,p,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(n){return n===47||n===92}e.isPathSeparator=T;function P(n){return n.replace(/[\\/]/g,s.posix.sep)}e.toSlashes=P;function b(n){return n.indexOf("/")===-1&&(n=P(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=b;function A(n,t=s.posix.sep){if(!n)return"";const l=n.length,v=n.charCodeAt(0);if(T(v)){if(T(n.charCodeAt(1))&&!T(n.charCodeAt(2))){let I=3;const B=I;for(;I<l&&!T(n.charCodeAt(I));I++);if(B!==I&&!T(n.charCodeAt(I+1))){for(I+=1;I<l;I++)if(T(n.charCodeAt(I)))return n.slice(0,I+1).replace(/[\\/]/g,t)}}return t}else if(u(v)&&n.charCodeAt(1)===58)return T(n.charCodeAt(2))?n.slice(0,2)+t:n.slice(0,2);let m=n.indexOf("://");if(m!==-1){for(m+=3;m<l;m++)if(T(n.charCodeAt(m)))return n.slice(0,m+1)}return""}e.getRoot=A;function O(n){if(!C.isWindows||!n||n.length<5)return!1;let t=n.charCodeAt(0);if(t!==92||(t=n.charCodeAt(1),t!==92))return!1;let l=2;const v=l;for(;l<n.length&&(t=n.charCodeAt(l),t!==92);l++);return!(v===l||(t=n.charCodeAt(l+1),isNaN(t)||t===92))}e.isUNC=O;const w=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(n,t=C.isWindows){const l=t?w:g;return!(!n||n.length===0||/^\s+$/.test(n)||(l.lastIndex=0,l.test(n))||t&&S.test(n)||n==="."||n===".."||t&&n[n.length-1]==="."||t&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=f;function c(n,t,l){const v=n===t;return!l||v?v:!n||!t?!1:(0,p.equalsIgnoreCase)(n,t)}e.isEqual=c;function h(n,t,l,v=s.sep){if(n===t)return!0;if(!n||!t||t.length>n.length)return!1;if(l){if(!(0,p.startsWithIgnoreCase)(n,t))return!1;if(t.length===n.length)return!0;let I=t.length;return t.charAt(t.length-1)===v&&I--,n.charAt(I)===v}return t.charAt(t.length-1)!==v&&(t+=v),n.indexOf(t)===0}e.isEqualOrParent=h;function u(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=u;function D(n,t){return C.isWindows&&n.endsWith(":")&&(n+=s.sep),(0,s.isAbsolute)(n)||(n=(0,s.join)(t,n)),n=(0,s.normalize)(n),C.isWindows?(n=(0,p.rtrim)(n,s.sep),n.endsWith(":")&&(n+=s.sep)):(n=(0,p.rtrim)(n,s.sep),n||(n=s.sep)),n}e.sanitizeFilePath=D;function y(n){const t=(0,s.normalize)(n);return C.isWindows?n.length>3?!1:a(t)&&(n.length===2||t.charCodeAt(2)===92):t===s.posix.sep}e.isRootOrDriveLetter=y;function a(n,t=C.isWindows){return t?u(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function _(n){return a(n)?n[0]:void 0}e.getDriveLetter=_;function r(n,t,l){return t.length>n.length?-1:n===t?0:(l&&(n=n.toLowerCase(),t=t.toLowerCase()),n.indexOf(t))}e.indexOfPath=r;function d(n){const t=n.split(":");let l,v,m;for(const I of t){const B=Number(I);(0,U.isNumber)(B)?v===void 0?v=B:m===void 0&&(m=B):l=l?[l,I].join(":"):I}if(!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:v!==void 0?v:void 0,column:m!==void 0?m:v!==void 0?1:void 0}}e.parseLineAndColumnAware=d;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function o(n,t,l=8){let v="";for(let I=0;I<l;I++)v+=i.charAt(Math.floor(Math.random()*i.length));let m;return t?m=`${t}-${v}`:m=v,n?(0,s.join)(n,m):m}e.randomPath=o}),define(De[57],Ie([1,0,23,10,2]),function(J,e,s,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function U(A){return JSON.stringify(A,P)}e.stringify=U;function T(A){let O=JSON.parse(A);return O=b(O),O}e.parse=T;function P(A,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,C.regExpFlags)(O)}:O}function b(A,O=0){if(!A||O>200)return A;if(typeof A=="object"){switch(A.$mid){case 1:return p.URI.revive(A);case 2:return new RegExp(A.source,A.flags);case 14:return new Date(A.source)}if(A instanceof s.VSBuffer||A instanceof Uint8Array)return A;if(Array.isArray(A))for(let w=0;w<A.length;++w)A[w]=b(A[w],O+1);else for(const w in A)Object.hasOwnProperty.call(A,w)&&(A[w]=b(A[w],O+1))}return A}e.revive=b}),define(De[12],Ie([1,0,22,2]),function(J,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var p;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.vscodeUserData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp",P.vsls="vsls"})(p=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class U{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${p.vscodeRemoteResource}`}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}setServerRootPath(b){this._remoteResourcesPath=`${b}/${p.vscodeRemoteResource}`}set(b,A,O){this._hosts[b]=A,this._ports[b]=O}setConnectionToken(b,A){this._connectionTokens[b]=A}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(b){if(this._delegate)return this._delegate(b);const A=b.authority;let O=this._hosts[A];O&&O.indexOf(":")!==-1&&(O=`[${O}]`);const w=this._ports[A],g=this._connectionTokens[A];let S=`path=${encodeURIComponent(b.path)}`;return typeof g=="string"&&(S+=`&${e.connectionTokenQueryName}=${encodeURIComponent(g)}`),C.URI.from({scheme:s.isWeb?this._preferredWebSchema:p.vscodeRemoteResource,authority:`${O}:${w}`,path:this._remoteResourcesPath,query:S})}}e.RemoteAuthorities=new U;class T{asBrowserUri(b,A){const O=this.toUri(b,A);return O.scheme===p.vscodeRemote?e.RemoteAuthorities.rewrite(O):O.scheme===p.file&&(s.isNative||s.isWebWorker&&s.globals.origin===`${p.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?O.with({scheme:p.vscodeFileResource,authority:O.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):O}asFileUri(b,A){const O=this.toUri(b,A);return O.scheme===p.vscodeFileResource?O.with({scheme:p.file,authority:O.authority!==T.FALLBACK_AUTHORITY?O.authority:null,query:null,fragment:null}):O}toUri(b,A){return C.URI.isUri(b)?b:C.URI.parse(A.toUrl(b))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T}),define(De[21],Ie([1,0,37,12,19,22,10,2]),function(J,e,s,C,p,U,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function b(S){return(0,P.uriToFsPath)(S,!0)}e.originalFSPath=b;class A{constructor(f){this._ignorePathCasing=f}compare(f,c,h=!1){return f===c?0:(0,T.compare)(this.getComparisonKey(f,h),this.getComparisonKey(c,h))}isEqual(f,c,h=!1){return f===c?!0:!f||!c?!1:this.getComparisonKey(f,h)===this.getComparisonKey(c,h)}getComparisonKey(f,c=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,c,h=!1){if(f.scheme===c.scheme){if(f.scheme===C.Schemas.file)return s.isEqualOrParent(b(f),b(c),this._ignorePathCasing(f))&&f.query===c.query&&(h||f.fragment===c.fragment);if((0,e.isEqualAuthority)(f.authority,c.authority))return s.isEqualOrParent(f.path,c.path,this._ignorePathCasing(f),"/")&&f.query===c.query&&(h||f.fragment===c.fragment)}return!1}joinPath(f,...c){return P.URI.joinPath(f,...c)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return p.posix.basename(f.path)}extname(f){return p.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let c;return f.scheme===C.Schemas.file?c=P.URI.file(p.dirname(b(f))).path:(c=p.posix.dirname(f.path),f.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),c="/")),f.with({path:c})}normalizePath(f){if(!f.path.length)return f;let c;return f.scheme===C.Schemas.file?c=P.URI.file(p.normalize(b(f))).path:c=p.posix.normalize(f.path),f.with({path:c})}relativePath(f,c){if(f.scheme!==c.scheme||!(0,e.isEqualAuthority)(f.authority,c.authority))return;if(f.scheme===C.Schemas.file){const D=p.relative(b(f),b(c));return U.isWindows?s.toSlashes(D):D}let h=f.path||"/",u=c.path||"/";if(this._ignorePathCasing(f)){let D=0;for(const y=Math.min(h.length,u.length);D<y&&!(h.charCodeAt(D)!==u.charCodeAt(D)&&h.charAt(D).toLowerCase()!==u.charAt(D).toLowerCase());D++);h=u.substr(0,D)+h.substr(D)}return p.posix.relative(h,u)}resolvePath(f,c){if(f.scheme===C.Schemas.file){const h=P.URI.file(p.resolve(b(f),c));return f.with({authority:h.authority,path:h.path})}return c=s.toPosixPath(c),f.with({path:p.posix.resolve(f.path,c)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,c){return f===c||f!==void 0&&c!==void 0&&(0,T.equalsIgnoreCase)(f,c)}hasTrailingPathSeparator(f,c=p.sep){if(f.scheme===C.Schemas.file){const h=b(f);return h.length>s.getRoot(h).length&&h[h.length-1]===c}else{const h=f.path;return h.length>1&&h.charCodeAt(h.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,c=p.sep){return(0,e.hasTrailingPathSeparator)(f,c)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,c=p.sep){let h=!1;if(f.scheme===C.Schemas.file){const u=b(f);h=u!==void 0&&u.length===s.getRoot(u).length&&u[u.length-1]===c}else{c="/";const u=f.path;h=u.length===1&&u.charCodeAt(u.length-1)===47}return!h&&!(0,e.hasTrailingPathSeparator)(f,c)?f.with({path:f.path+"/"}):f}}e.ExtUri=A,e.extUri=new A(()=>!1),e.extUriBiasedIgnorePathCase=new A(S=>S.scheme===C.Schemas.file?!U.isLinux:!0),e.extUriIgnorePathCase=new A(S=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function O(S,f){const c=[];for(let h=0;h<S.length;h++){const u=f(S[h]);S.some((D,y)=>y===h?!1:(0,e.isEqualOrParent)(u,f(D)))||c.push(S[h])}return c}e.distinctParents=O;var w;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function f(c){const h=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(y=>{const[a,_]=y.split(":");a&&_&&h.set(a,_)});const D=c.path.substring(0,c.path.indexOf(";"));return D&&h.set(S.META_DATA_MIME,D),h}S.parseMetaData=f})(w=e.DataUri||(e.DataUri={}));function g(S,f,c){if(f){let h=S.path;return h&&h[0]!==p.posix.sep&&(h=p.posix.sep+h),S.with({scheme:c,authority:f,path:h})}return S.with({scheme:c})}e.toLocalResource=g}),define(De[13],Ie([1,0,20,11,5,7,21,22]),function(J,e,s,C,p,U,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function b(be){return!!be&&typeof be.then=="function"}e.isThenable=b;function A(be){const ee=new s.CancellationTokenSource,ve=be(ee.token),Re=new Promise((Fe,We)=>{const Xe=ee.token.onCancellationRequested(()=>{Xe.dispose(),ee.dispose(),We(new C.CancellationError)});Promise.resolve(ve).then(Te=>{Xe.dispose(),ee.dispose(),Fe(Te)},Te=>{Xe.dispose(),ee.dispose(),We(Te)})});return new class{cancel(){ee.cancel()}then(Fe,We){return Re.then(Fe,We)}catch(Fe){return this.then(void 0,Fe)}finally(Fe){return Re.finally(Fe)}}}e.createCancelablePromise=A;function O(be,ee,ve){return new Promise((Re,Fe)=>{const We=ee.onCancellationRequested(()=>{We.dispose(),Re(ve)});be.then(Re,Fe).finally(()=>We.dispose())})}e.raceCancellation=O;function w(be,ee){return new Promise((ve,Re)=>{const Fe=ee.onCancellationRequested(()=>{Fe.dispose(),Re(new C.CancellationError)});be.then(ve,Re).finally(()=>Fe.dispose())})}e.raceCancellationError=w;async function g(be){let ee=-1;const ve=be.map((Fe,We)=>Fe.then(Xe=>(ee=We,Xe))),Re=await Promise.race(ve);return be.forEach((Fe,We)=>{We!==ee&&Fe.cancel()}),Re}e.raceCancellablePromises=g;function S(be,ee,ve){let Re;const Fe=setTimeout(()=>{Re?.(void 0),ve?.()},ee);return Promise.race([be.finally(()=>clearTimeout(Fe)),new Promise(We=>Re=We)])}e.raceTimeout=S;function f(be){return new Promise((ee,ve)=>{const Re=be();b(Re)?Re.then(ee,ve):ee(Re)})}e.asPromise=f;class c{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(ee){if(this.activePromise){if(this.queuedPromiseFactory=ee,!this.queuedPromise){const ve=()=>{this.queuedPromise=null;const Re=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Re};this.queuedPromise=new Promise(Re=>{this.activePromise.then(ve,ve).then(Re)})}return new Promise((ve,Re)=>{this.queuedPromise.then(ve,Re)})}return this.activePromise=ee(),new Promise((ve,Re)=>{this.activePromise.then(Fe=>{this.activePromise=null,ve(Fe)},Fe=>{this.activePromise=null,Re(Fe)})})}}e.Throttler=c;class h{constructor(){this.current=Promise.resolve(null)}queue(ee){return this.current=this.current.then(()=>ee(),()=>ee())}}e.Sequencer=h;class u{constructor(){this.promiseMap=new Map}queue(ee,ve){const Fe=(this.promiseMap.get(ee)??Promise.resolve()).catch(()=>{}).then(ve).finally(()=>{this.promiseMap.get(ee)===Fe&&this.promiseMap.delete(ee)});return this.promiseMap.set(ee,Fe),Fe}}e.SequencerByKey=u;const D=(be,ee)=>{let ve=!0;const Re=setTimeout(()=>{ve=!1,ee()},be);return{isTriggered:()=>ve,dispose:()=>{clearTimeout(Re),ve=!1}}},y=be=>{let ee=!0;return queueMicrotask(()=>{ee&&(ee=!1,be())}),{isTriggered:()=>ee,dispose:()=>{ee=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class a{constructor(ee){this.defaultDelay=ee,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(ee,ve=this.defaultDelay){this.task=ee,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Fe,We)=>{this.doResolve=Fe,this.doReject=We}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Fe=this.task;return this.task=null,Fe()}}));const Re=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ve===e.MicrotaskDelay?y(Re):D(ve,Re),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new C.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=a;class _{constructor(ee){this.delayer=new a(ee),this.throttler=new c}trigger(ee,ve){return this.delayer.trigger(()=>this.throttler.queue(ee),ve)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=_;class r{constructor(){this._isOpen=!1,this._promise=new Promise((ee,ve)=>{this._completePromise=ee})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class d extends r{constructor(ee){super();this._timeout=setTimeout(()=>this.open(),ee)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function i(be,ee){return ee?new Promise((ve,Re)=>{const Fe=setTimeout(()=>{We.dispose(),ve()},be),We=ee.onCancellationRequested(()=>{clearTimeout(Fe),We.dispose(),Re(new C.CancellationError)})}):A(ve=>i(be,ve))}e.timeout=i;function o(be,ee=0){const ve=setTimeout(be,ee);return(0,U.toDisposable)(()=>clearTimeout(ve))}e.disposableTimeout=o;function n(be){const ee=[];let ve=0;const Re=be.length;function Fe(){return ve<Re?be[ve++]():null}function We(Xe){Xe!=null&&ee.push(Xe);const Te=Fe();return Te?Te.then(We):Promise.resolve(ee)}return Promise.resolve(null).then(We)}e.sequence=n;function t(be,ee=Re=>!!Re,ve=null){let Re=0;const Fe=be.length,We=()=>{if(Re>=Fe)return Promise.resolve(ve);const Xe=be[Re++];return Promise.resolve(Xe()).then(Se=>ee(Se)?Promise.resolve(Se):We())};return We()}e.first=t;function l(be,ee=Re=>!!Re,ve=null){if(be.length===0)return Promise.resolve(ve);let Re=be.length;const Fe=()=>{Re=-1;for(const We of be)We.cancel?.()};return new Promise((We,Xe)=>{for(const Te of be)Te.then(Se=>{--Re>=0&&ee(Se)?(Fe(),We(Se)):Re===0&&We(ve)}).catch(Se=>{--Re>=0&&(Fe(),Xe(Se))})})}e.firstParallel=l;class v{constructor(ee){this._size=0,this.maxDegreeOfParalellism=ee,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new p.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(ee){return this._size++,new Promise((ve,Re)=>{this.outstandingPromises.push({factory:ee,c:ve,e:Re}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const ee=this.outstandingPromises.shift();this.runningPromises++;const ve=ee.factory();ve.then(ee.c,ee.e),ve.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=v;class m extends v{constructor(){super(1)}}e.Queue=m;class I{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const ee=new oe;return this.drainers.add(ee),ee.p}isDrained(){for(const[,ee]of this.queues)if(ee.size>0)return!1;return!0}queueFor(ee,ve=T.extUri){const Re=ve.getComparisonKey(ee);let Fe=this.queues.get(Re);return Fe||(Fe=new m,p.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.queues.delete(Re),this.onDidQueueDrain()}),this.queues.set(Re,Fe)),Fe}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const ee of this.drainers)ee.complete();this.drainers.clear()}dispose(){for(const[,ee]of this.queues)ee.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=I;class B{constructor(ee,ve){this._token=-1,typeof ee=="function"&&typeof ve=="number"&&this.setIfNotSet(ee,ve)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(ee,ve){this.cancel(),this._token=setTimeout(()=>{this._token=-1,ee()},ve)}setIfNotSet(ee,ve){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,ee()},ve))}}e.TimeoutTimer=B;class x{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(ee,ve){this.cancel(),this._token=setInterval(()=>{ee()},ve)}}e.IntervalTimer=x;class R{constructor(ee,ve){this.timeoutToken=-1,this.runner=ee,this.timeout=ve,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(ee=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,ee)}get delay(){return this.timeout}set delay(ee){this.timeout=ee}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class E{constructor(ee,ve){ve%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ve}ms is not a multiple of 1000ms.`),this.runner=ee,this.timeout=ve,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(ee=this.timeout){ee%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(ee/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=E;class M extends R{constructor(ee,ve){super(ee,ve);this.units=[]}work(ee){this.units.push(ee),this.isScheduled()||this.schedule()}doRun(){const ee=this.units;this.units=[],this.runner&&this.runner(ee)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=M;class N extends U.Disposable{constructor(ee,ve){super();this.options=ee,this.handler=ve,this.pendingWork=[],this.throttler=this._register(new U.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(ee){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+ee.length>this.options.maxBufferedWork)return!1}else if(this.pending+ee.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...ee),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=be=>{(0,P.setTimeout0)(()=>{if(ee)return;const ve=Date.now()+15;be(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ve-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0)}}}:e.runWhenIdle=(be,ee)=>{const ve=requestIdleCallback(be,typeof ee=="number"?{timeout:ee}:void 0);let Re=!1;return{dispose(){Re||(Re=!0,cancelIdleCallback(ve))}}}}();class W{constructor(ee){this._didRun=!1,this._executor=()=>{try{this._value=ee()}catch(ve){this._error=ve}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=W;async function Z(be,ee,ve){let Re;for(let Fe=0;Fe<ve;Fe++)try{return await be()}catch(We){Re=We,await i(ee)}throw Re}e.retry=Z;class K{hasPending(ee){return this._pending?typeof ee=="number"?this._pending.taskId===ee:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(ee,ve,Re){return this._pending={taskId:ee,cancel:()=>Re?.(),promise:ve},ve.then(()=>this.donePending(ee),()=>this.donePending(ee)),ve}donePending(ee){this._pending&&ee===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const ee=this._next;this._next=void 0,ee.run().then(ee.promiseResolve,ee.promiseReject)}}setNext(ee){if(this._next)this._next.run=ee;else{let ve,Re;const Fe=new Promise((We,Xe)=>{ve=We,Re=Xe});this._next={run:ee,promise:Fe,promiseResolve:ve,promiseReject:Re}}return this._next.promise}}e.TaskSequentializer=K;class F{constructor(ee,ve=()=>Date.now()){this.interval=ee,this.nowFn=ve,this.lastIncrementTime=0,this.value=0}increment(){const ee=this.nowFn();return ee-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=ee,this.value=0),this.value++,this.value}}e.IntervalCounter=F;class oe{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((ee,ve)=>{this.completeCallback=ee,this.errorCallback=ve})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(ee){return new Promise(ve=>{this.completeCallback(ee),this.resolved=!0,ve()})}error(ee){return new Promise(ve=>{this.errorCallback(ee),this.rejected=!0,ve()})}cancel(){new Promise(ee=>{this.errorCallback(new C.CancellationError),this.rejected=!0,ee()})}}e.DeferredPromise=oe;var ce;(function(be){async function ee(Re){let Fe;const We=await Promise.all(Re.map(Xe=>Xe.then(Te=>Te,Te=>{Fe||(Fe=Te)})));if(typeof Fe!="undefined")throw Fe;return We}be.settled=ee;function ve(Re){return new Promise(async(Fe,We)=>{try{await Re(Fe,We)}catch(Xe){We(Xe)}})}be.withAsyncBody=ve})(ce=e.Promises||(e.Promises={}));var ae;(function(be){be[be.Initial=0]="Initial",be[be.DoneOK=1]="DoneOK",be[be.DoneError=2]="DoneError"})(ae||(ae={}));class fe{constructor(ee){this._state=0,this._results=[],this._error=null,this._onStateChanged=new p.Emitter,queueMicrotask(async()=>{const ve={emitOne:Re=>this.emitOne(Re),emitMany:Re=>this.emitMany(Re),reject:Re=>this.reject(Re)};try{await Promise.resolve(ee(ve)),this.resolve()}catch(Re){this.reject(Re)}finally{ve.emitOne=void 0,ve.emitMany=void 0,ve.reject=void 0}})}static fromArray(ee){return new fe(ve=>{ve.emitMany(ee)})}static fromPromise(ee){return new fe(async ve=>{ve.emitMany(await ee)})}static fromPromises(ee){return new fe(async ve=>{await Promise.all(ee.map(async Re=>ve.emitOne(await Re)))})}static merge(ee){return new fe(async ve=>{await Promise.all(ee.map(async Re=>{for await(const Fe of Re)ve.emitOne(Fe)}))})}[Symbol.asyncIterator](){let ee=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(ee<this._results.length)return{done:!1,value:this._results[ee++]};if(this._state===1)return{done:!0,value:void 0};await p.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(ee,ve){return new fe(async Re=>{for await(const Fe of ee)Re.emitOne(ve(Fe))})}map(ee){return fe.map(this,ee)}static filter(ee,ve){return new fe(async Re=>{for await(const Fe of ee)ve(Fe)&&Re.emitOne(Fe)})}filter(ee){return fe.filter(this,ee)}static coalesce(ee){return fe.filter(ee,ve=>!!ve)}coalesce(){return fe.coalesce(this)}static async toPromise(ee){const ve=[];for await(const Re of ee)ve.push(Re);return ve}toPromise(){return fe.toPromise(this)}emitOne(ee){this._state===0&&(this._results.push(ee),this._onStateChanged.fire())}emitMany(ee){this._state===0&&(this._results=this._results.concat(ee),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(ee){this._state===0&&(this._state=2,this._error=ee,this._onStateChanged.fire())}}e.AsyncIterableObject=fe,fe.EMPTY=fe.fromArray([]);class ie extends fe{constructor(ee,ve){super(ve);this._source=ee}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ie;function Ee(be){const ee=new s.CancellationTokenSource,ve=be(ee.token);return new ie(ee,async Re=>{const Fe=ee.token.onCancellationRequested(()=>{Fe.dispose(),ee.dispose(),Re.reject(new C.CancellationError)});try{for await(const We of ve){if(ee.token.isCancellationRequested)return;Re.emitOne(We)}Fe.dispose(),ee.dispose()}catch(We){Fe.dispose(),ee.dispose(),Re.reject(We)}})}e.createCancelableAsyncIterable=Ee}),define(De[111],Ie([1,0,13,19]),function(J,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const p=new s.IdleValue(()=>{const m=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:m,collatorIsNumeric:m.resolvedOptions().numeric}}),U=new s.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new s.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(m,I,B=!1){const x=m||"",R=I||"",E=p.value.collator.compare(x,R);return p.value.collatorIsNumeric&&E===0&&x!==R?x<R?-1:1:E}e.compareFileNames=P;function b(m,I){const B=U.value.collator;return m=m||"",I=I||"",_(B,m,I)}e.compareFileNamesDefault=b;function A(m,I){const B=U.value.collator;return m=m||"",I=I||"",o(m,I)||_(B,m,I)}e.compareFileNamesUpper=A;function O(m,I){const B=U.value.collator;return m=m||"",I=I||"",i(m,I)||_(B,m,I)}e.compareFileNamesLower=O;function w(m,I){return m=m||"",I=I||"",m===I?0:m<I?-1:1}e.compareFileNamesUnicode=w;function g(m,I,B=!1){B||(m=m&&m.toLowerCase(),I=I&&I.toLowerCase());const[x,R]=y(m),[E,M]=y(I);return x!==E?x<E?-1:1:R===M?0:R<M?-1:1}e.noIntlCompareFileNames=g;function S(m,I){const[B,x]=y(m),[R,E]=y(I);let M=p.value.collator.compare(x,E);if(M===0){if(p.value.collatorIsNumeric&&x!==E)return x<E?-1:1;if(M=p.value.collator.compare(B,R),p.value.collatorIsNumeric&&M===0&&B!==R)return B<R?-1:1}return M}e.compareFileExtensions=S;function f(m,I){m=m||"",I=I||"";const B=a(m),x=a(I),R=U.value.collator,E=T.value.collator;return _(E,B,x)||_(R,m,I)}e.compareFileExtensionsDefault=f;function c(m,I){m=m||"",I=I||"";const B=a(m),x=a(I),R=U.value.collator,E=T.value.collator;return _(E,B,x)||o(m,I)||_(R,m,I)}e.compareFileExtensionsUpper=c;function h(m,I){m=m||"",I=I||"";const B=a(m),x=a(I),R=U.value.collator,E=T.value.collator;return _(E,B,x)||i(m,I)||_(R,m,I)}e.compareFileExtensionsLower=h;function u(m,I){m=m||"",I=I||"";const B=a(m).toLowerCase(),x=a(I).toLowerCase();return B!==x?B<x?-1:1:m!==I?m<I?-1:1:0}e.compareFileExtensionsUnicode=u;const D=/^(.*?)(\.([^.]*))?$/;function y(m,I=!1){const B=m?D.exec(m):[];let x=[B&&B[1]||"",B&&B[3]||""];return I&&(!x[0]&&x[1]||x[0]&&x[0].charAt(0)===".")&&(x=[x[0]+"."+x[1],""]),x}function a(m){const I=m?D.exec(m):[];return I&&I[1]&&I[1].charAt(0)!=="."&&I[3]||""}function _(m,I,B){let x=m.compare(I,B);return x!==0?x:I.length!==B.length?I.length<B.length?-1:1:0}function r(m){const I=m.charAt(0);return I.toLocaleUpperCase()!==I}function d(m){const I=m.charAt(0);return I.toLocaleLowerCase()!==I}function i(m,I){return r(m)&&d(I)?-1:d(m)&&r(I)?1:0}function o(m,I){return d(m)&&r(I)?-1:r(m)&&d(I)?1:0}function n(m,I,B=!1){return B||(m=m&&m.toLowerCase(),I=I&&I.toLowerCase()),m===I?0:m<I?-1:1}function t(m,I,B=!1){const x=m.split(C.sep),R=I.split(C.sep),E=x.length-1,M=R.length-1;let N,W;for(let Z=0;;Z++){if(N=E===Z,W=M===Z,N&&W)return P(x[Z],R[Z],B);if(N)return-1;if(W)return 1;const K=n(x[Z],R[Z],B);if(K!==0)return K}}e.comparePaths=t;function l(m,I,B){const x=m.toLowerCase(),R=I.toLowerCase(),E=v(m,I,B);if(E)return E;const M=x.endsWith(B),N=R.endsWith(B);if(M!==N)return M?-1:1;const W=P(x,R);return W!==0?W:x.localeCompare(R)}e.compareAnything=l;function v(m,I,B){const x=m.toLowerCase(),R=I.toLowerCase(),E=x.startsWith(B),M=R.startsWith(B);if(E!==M)return E?-1:1;if(E&&M){if(x.length<R.length)return-1;if(x.length>R.length)return 1}return 0}e.compareByPrefix=v}),define(De[34],Ie([1,0,15,13,37,24,19,22,10]),function(J,e,s,C,p,U,T,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function A(){return Object.create(null)}e.getEmptyExpression=A,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const O="[/\\\\]",w="[^/\\\\]",g=/\//g;function S(oe,ce){switch(oe){case 0:return"";case 1:return`${w}*?`;default:return`(?:${O}|${w}+${O}${ce?`|${O}${w}+`:""})*?`}}function f(oe,ce){if(!oe)return[];const ae=[];let fe=!1,ie=!1,Ee="";for(const be of oe){switch(be){case ce:if(!fe&&!ie){ae.push(Ee),Ee="";continue}break;case"{":fe=!0;break;case"}":fe=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}Ee+=be}return Ee&&ae.push(Ee),ae}e.splitGlobAware=f;function c(oe){if(!oe)return"";let ce="";const ae=f(oe,e.GLOB_SPLIT);if(ae.every(fe=>fe===e.GLOBSTAR))ce=".*";else{let fe=!1;ae.forEach((ie,Ee)=>{if(ie===e.GLOBSTAR){if(fe)return;ce+=S(2,Ee===ae.length-1)}else{let be=!1,ee="",ve=!1,Re="";for(const Fe of ie){if(Fe!=="}"&&be){ee+=Fe;continue}if(ve&&(Fe!=="]"||!Re)){let We;Fe==="-"?We=Fe:(Fe==="^"||Fe==="!")&&!Re?We="^":Fe===e.GLOB_SPLIT?We="":We=(0,b.escapeRegExpCharacters)(Fe),Re+=We;continue}switch(Fe){case"{":be=!0;continue;case"[":ve=!0;continue;case"}":{ce+=`(?:${f(ee,",").map(Te=>c(Te)).join("|")})`,be=!1,ee="";break}case"]":{ce+="["+Re+"]",ve=!1,Re="";break}case"?":ce+=w;continue;case"*":ce+=S(1);continue;default:ce+=(0,b.escapeRegExpCharacters)(Fe)}}Ee<ae.length-1&&(ae[Ee+1]!==e.GLOBSTAR||Ee+2<ae.length)&&(ce+=O)}fe=ie===e.GLOBSTAR})}return ce}const h=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,D=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,y=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,_=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new U.LRUCache(1e4),d=function(){return!1},i=function(){return null};function o(oe,ce){if(!oe)return i;let ae;typeof oe!="string"?ae=oe.pattern:ae=oe,ae=ae.trim();const fe=`${ae}_${!!ce.trimForExclusions}`;let ie=r.get(fe);if(ie)return n(ie,oe);let Ee;return h.test(ae)?ie=l(ae.substr(4),ae):(Ee=u.exec(t(ae,ce)))?ie=v(Ee[1],ae):(ce.trimForExclusions?y:D).test(ae)?ie=m(ae,ce):(Ee=a.exec(t(ae,ce)))?ie=I(Ee[1].substr(1),ae,!0):(Ee=_.exec(t(ae,ce)))?ie=I(Ee[1],ae,!1):ie=B(ae),r.set(fe,ie),n(ie,oe)}function n(oe,ce){if(typeof ce=="string")return oe;const ae=function(fe,ie){return(0,p.isEqualOrParent)(fe,ce.base,!P.isLinux)?oe(fe.substr(ce.base.length+1),ie):null};return ae.allBasenames=oe.allBasenames,ae.allPaths=oe.allPaths,ae.basenames=oe.basenames,ae.patterns=oe.patterns,ae}function t(oe,ce){return ce.trimForExclusions&&oe.endsWith("/**")?oe.substr(0,oe.length-2):oe}function l(oe,ce){return function(ae,fe){return typeof ae=="string"&&ae.endsWith(oe)?ce:null}}function v(oe,ce){const ae=`/${oe}`,fe=`\\${oe}`,ie=function(be,ee){return typeof be!="string"?null:ee?ee===oe?ce:null:be===oe||be.endsWith(ae)||be.endsWith(fe)?ce:null},Ee=[oe];return ie.basenames=Ee,ie.patterns=[ce],ie.allBasenames=Ee,ie}function m(oe,ce){const ae=K(oe.slice(1,-1).split(",").map(ee=>o(ee,ce)).filter(ee=>ee!==i),oe),fe=ae.length;if(!fe)return i;if(fe===1)return ae[0];const ie=function(ee,ve){for(let Re=0,Fe=ae.length;Re<Fe;Re++)if(ae[Re](ee,ve))return oe;return null},Ee=ae.find(ee=>!!ee.allBasenames);Ee&&(ie.allBasenames=Ee.allBasenames);const be=ae.reduce((ee,ve)=>ve.allPaths?ee.concat(ve.allPaths):ee,[]);return be.length&&(ie.allPaths=be),ie}function I(oe,ce,ae){const fe=T.sep===T.posix.sep,ie=fe?oe:oe.replace(g,T.sep),Ee=T.sep+ie,be=T.posix.sep+oe;let ee;return ae?ee=function(ve,Re){return typeof ve=="string"&&(ve===ie||ve.endsWith(Ee)||!fe&&(ve===oe||ve.endsWith(be)))?ce:null}:ee=function(ve,Re){return typeof ve=="string"&&(ve===ie||!fe&&ve===oe)?ce:null},ee.allPaths=[(ae?"*/":"./")+oe],ee}function B(oe){try{const ce=new RegExp(`^${c(oe)}$`);return function(ae){return ce.lastIndex=0,typeof ae=="string"&&ce.test(ae)?oe:null}}catch{return i}}function x(oe,ce,ae){return!oe||typeof ce!="string"?!1:R(oe)(ce,void 0,ae)}e.match=x;function R(oe,ce={}){if(!oe)return d;if(typeof oe=="string"||E(oe)){const ae=o(oe,ce);if(ae===i)return d;const fe=function(ie,Ee){return!!ae(ie,Ee)};return ae.allBasenames&&(fe.allBasenames=ae.allBasenames),ae.allPaths&&(fe.allPaths=ae.allPaths),fe}return W(oe,ce)}e.parse=R;function E(oe){const ce=oe;return ce?typeof ce.base=="string"&&typeof ce.pattern=="string":!1}e.isRelativePattern=E;function M(oe){return oe.allBasenames||[]}e.getBasenameTerms=M;function N(oe){return oe.allPaths||[]}e.getPathTerms=N;function W(oe,ce){const ae=K(Object.getOwnPropertyNames(oe).map(ee=>Z(ee,oe[ee],ce)).filter(ee=>ee!==i)),fe=ae.length;if(!fe)return i;if(!ae.some(ee=>!!ee.requiresSiblings)){if(fe===1)return ae[0];const ee=function(Fe,We){let Xe;for(let Te=0,Se=ae.length;Te<Se;Te++){const ke=ae[Te](Fe,We);if(typeof ke=="string")return ke;(0,C.isThenable)(ke)&&(Xe||(Xe=[]),Xe.push(ke))}return Xe?(async()=>{for(const Te of Xe){const Se=await Te;if(typeof Se=="string")return Se}return null})():null},ve=ae.find(Fe=>!!Fe.allBasenames);ve&&(ee.allBasenames=ve.allBasenames);const Re=ae.reduce((Fe,We)=>We.allPaths?Fe.concat(We.allPaths):Fe,[]);return Re.length&&(ee.allPaths=Re),ee}const ie=function(ee,ve,Re){let Fe,We;for(let Xe=0,Te=ae.length;Xe<Te;Xe++){const Se=ae[Xe];Se.requiresSiblings&&Re&&(ve||(ve=(0,T.basename)(ee)),Fe||(Fe=ve.substr(0,ve.length-(0,T.extname)(ee).length)));const ke=Se(ee,ve,Fe,Re);if(typeof ke=="string")return ke;(0,C.isThenable)(ke)&&(We||(We=[]),We.push(ke))}return We?(async()=>{for(const Xe of We){const Te=await Xe;if(typeof Te=="string")return Te}return null})():null},Ee=ae.find(ee=>!!ee.allBasenames);Ee&&(ie.allBasenames=Ee.allBasenames);const be=ae.reduce((ee,ve)=>ve.allPaths?ee.concat(ve.allPaths):ee,[]);return be.length&&(ie.allPaths=be),ie}function Z(oe,ce,ae){if(ce===!1)return i;const fe=o(oe,ae);if(fe===i)return i;if(typeof ce=="boolean")return fe;if(ce){const ie=ce.when;if(typeof ie=="string"){const Ee=(be,ee,ve,Re)=>{if(!Re||!fe(be,ee))return null;const Fe=ie.replace("$(basename)",ve),We=Re(Fe);return(0,C.isThenable)(We)?We.then(Xe=>Xe?oe:null):We?oe:null};return Ee.requiresSiblings=!0,Ee}}return fe}function K(oe,ce){const ae=oe.filter(ee=>!!ee.basenames);if(ae.length<2)return oe;const fe=ae.reduce((ee,ve)=>{const Re=ve.basenames;return Re?ee.concat(Re):ee},[]);let ie;if(ce){ie=[];for(let ee=0,ve=fe.length;ee<ve;ee++)ie.push(ce)}else ie=ae.reduce((ee,ve)=>{const Re=ve.patterns;return Re?ee.concat(Re):ee},[]);const Ee=function(ee,ve){if(typeof ee!="string")return null;if(!ve){let Fe;for(Fe=ee.length;Fe>0;Fe--){const We=ee.charCodeAt(Fe-1);if(We===47||We===92)break}ve=ee.substr(Fe)}const Re=fe.indexOf(ve);return Re!==-1?ie[Re]:null};Ee.basenames=fe,Ee.patterns=ie,Ee.allBasenames=fe;const be=oe.filter(ee=>!ee.basenames);return be.push(Ee),be}function F(oe,ce){return(0,s.equals)(oe,ce,(ae,fe)=>typeof ae=="string"&&typeof fe=="string"?ae===fe:typeof ae!="string"&&typeof fe!="string"?ae.base===fe.base&&ae.pattern===fe.pattern:!1)}e.patternsEquals=F}),define(De[75],Ie([1,0,11,109,21,10,2]),function(J,e,s,C,p,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(P=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class b{constructor(h="",u=!1){if(this.value=h,typeof this.value!="string")throw(0,s.illegalArgument)("value");typeof u=="boolean"?(this.isTrusted=u,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=u.isTrusted??void 0,this.supportThemeIcons=u.supportThemeIcons??!1,this.supportHtml=u.supportHtml??!1)}appendText(h,u=0){return this.value+=g(this.supportThemeIcons?(0,C.escapeIcons)(h):h).replace(/([ \t]+)/g,(D,y)=>"&nbsp;".repeat(y.length)).replace(/\>/gm,"\\>").replace(/\n/g,u===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,u){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=u,this.value+="\n```\n",this}appendLink(h,u,D){return this.value+="[",this.value+=this._escape(u,"]"),this.value+="](",this.value+=this._escape(String(h),")"),D&&(this.value+=` "${this._escape(this._escape(D,'"'),")")}"`),this.value+=")",this}_escape(h,u){const D=new RegExp((0,U.escapeRegExpCharacters)(u),"g");return h.replace(D,(y,a)=>h.charAt(a-1)!=="\\"?`\\${y}`:y)}}e.MarkdownString=b;function A(c){return O(c)?!c.value:Array.isArray(c)?c.every(A):!0}e.isEmptyMarkdownString=A;function O(c){return c instanceof b?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.isMarkdownString=O;function w(c,h){return c===h?!0:!c||!h?!1:c.value===h.value&&c.isTrusted===h.isTrusted&&c.supportThemeIcons===h.supportThemeIcons&&c.supportHtml===h.supportHtml&&(c.baseUri===h.baseUri||!!c.baseUri&&!!h.baseUri&&(0,p.isEqual)(T.URI.from(c.baseUri),T.URI.from(h.baseUri)))}e.markdownStringEqual=w;function g(c){return c.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=g;function S(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=S;function f(c){const h=[],u=c.split("|").map(y=>y.trim());c=u[0];const D=u[1];if(D){const y=/height=(\d+)/.exec(D),a=/width=(\d+)/.exec(D),_=y?y[1]:"",r=a?a[1]:"",d=isFinite(parseInt(r)),i=isFinite(parseInt(_));d&&h.push(`width="${r}"`),i&&h.push(`height="${_}"`)}return{href:c,dimensions:h}}e.parseHrefAndDimensions=f}),define(De[76],Ie([1,0,15,37,12,19,22,21,10,2]),function(J,e,s,C,p,U,T,P,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function O(t,l){const{os:v,tildify:m,relative:I}=l;if(I){const R=w(t,I,v);if(typeof R=="string")return R}let B=t.fsPath;if(v===1&&!T.isWindows?B=B.replace(/\//g,"\\"):v!==1&&T.isWindows&&(B=B.replace(/\\/g,"/")),v!==1&&m?.userHome){let R=m.userHome.fsPath,E;t.scheme!==m.userHome.scheme&&t.path.startsWith(U.posix.sep)?E=m.userHome.with({path:t.path}).fsPath:E=t.fsPath,B=c(E,R,v)}return(v===1?U.win32:U.posix).normalize(S(B,v===1))}e.getPathLabel=O;function w(t,l,v){const m=v===1?U.win32:U.posix,I=v===3?P.extUri:P.extUriIgnorePathCase,B=l.getWorkspace(),x=(0,s.firstOrDefault)(B.folders);if(!x)return;t.scheme!==x.uri.scheme&&t.path.startsWith(U.posix.sep)&&(t=x.uri.with({path:t.path}));const R=l.getWorkspaceFolder(t);if(!R)return;let E;if(I.isEqual(R.uri,t)?E="":E=I.relativePath(R.uri,t)??"",E&&(E=m.normalize(E)),B.folders.length>1&&!l.noPrefix){const M=R.name?R.name:I.basenameOrAuthority(R.uri);E=E?`${M} \u2022 ${E}`:M}return E}function g(t){if(!t)return;typeof t=="string"&&(t=A.URI.file(t));const l=(0,P.basename)(t)||(t.scheme===p.Schemas.file?t.fsPath:t.path);return T.isWindows&&(0,C.isRootOrDriveLetter)(l)?S(l):l}e.getBaseLabel=g;function S(t,l=T.isWindows){return(0,C.hasDriveLetter)(t,l)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=S;let f=Object.create(null);function c(t,l,v=T.OS){if(v===1||!t||!l)return t;let m=f.original===l?f.normalized:void 0;m||(m=l,T.isWindows&&(m=(0,C.toSlashes)(m)),m=`${(0,b.rtrim)(m,U.posix.sep)}${U.posix.sep}`,f={original:l,normalized:m});let I=t;return T.isWindows&&(I=(0,C.toSlashes)(I)),(v===3?I.startsWith(m):(0,b.startsWithIgnoreCase)(I,m))?`~/${I.substr(m.length)}`:t}e.tildify=c;function h(t,l){return t.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=h;const u="\u2026",D="\\\\",y="~";function a(t,l=U.sep){const v=new Array(t.length);let m=!1;for(let I=0;I<t.length;I++){let B=t[I];if(B===""){v[I]=`.${l}`;continue}if(!B){v[I]=B;continue}m=!0;let x="",R=B;R.indexOf(D)===0?(x=R.substr(0,R.indexOf(D)+D.length),R=R.substr(R.indexOf(D)+D.length)):R.indexOf(l)===0?(x=R.substr(0,R.indexOf(l)+l.length),R=R.substr(R.indexOf(l)+l.length)):R.indexOf(y)===0&&(x=R.substr(0,R.indexOf(y)+y.length),R=R.substr(R.indexOf(y)+y.length));const E=R.split(l);for(let M=1;m&&M<=E.length;M++)for(let N=E.length-M;m&&N>=0;N--){m=!1;let W=E.slice(N,N+M).join(l);for(let Z=0;!m&&Z<t.length;Z++)if(Z!==I&&t[Z]&&t[Z].indexOf(W)>-1){const K=N+M===E.length,F=N>0&&t[Z].indexOf(l)>-1?l+W:W,oe=t[Z].endsWith(F);m=!K||oe}if(!m){let Z="";(E[0].endsWith(":")||x!=="")&&(N===1&&(N=0,M++,W=E[0]+l+W),N>0&&(Z=E[0]+l),Z=x+Z),N>0&&(Z=Z+u+l),Z=Z+W,N+M<E.length&&(Z=Z+l+u),v[I]=Z}}m&&(v[I]=B)}return v}e.shorten=a;var _;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(_||(_={}));function r(t,l=Object.create(null)){const v=[];let m=!1,I="";for(const B of t)if(B==="$"||m&&B==="{")I&&v.push({value:I,type:_.TEXT}),I="",m=!0;else if(B==="}"&&m){const x=l[I];if(typeof x=="string")x.length&&v.push({value:x,type:_.VARIABLE});else if(x){const R=v[v.length-1];(!R||R.type!==_.SEPARATOR)&&v.push({value:x.label,type:_.SEPARATOR})}I="",m=!1}else I+=B;return I&&!m&&v.push({value:I,type:_.TEXT}),v.filter((B,x)=>{if(B.type===_.SEPARATOR){const R=v[x-1],E=v[x+1];return[R,E].every(M=>M&&(M.type===_.VARIABLE||M.type===_.TEXT)&&M.value.length>0)}return!0}).map(B=>B.value).join("")}e.template=r;function d(t,l){return T.isMacintosh||l?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):t.replace(/&&|&/g,v=>v==="&"?"&&":"&")}e.mnemonicMenuLabel=d;function i(t,l){return T.isMacintosh||l?t.replace(/\(&&\w\)|&&/g,""):T.isWindows?t.replace(/&&|&/g,v=>v==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function o(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=o;function n(t){const l=t.indexOf("/")!==-1?U.posix:U.win32,v=l.basename(t),m=l.dirname(t);return v.length?{name:v,parentPath:m}:{name:m,parentPath:""}}e.splitName=n}),define(De[112],Ie([1,0,2]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function C(O){return O.toJSON()}class p{constructor(w){this._uriTransformer=w}transformIncoming(w){const g=this._uriTransformer.transformIncoming(w);return g===w?w:C(s.URI.from(g))}transformOutgoing(w){const g=this._uriTransformer.transformOutgoing(w);return g===w?w:C(s.URI.from(g))}transformOutgoingURI(w){const g=this._uriTransformer.transformOutgoing(w);return g===w?w:s.URI.from(g)}transformOutgoingScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}}e.URITransformer=p,e.DefaultURITransformer=new class{transformIncoming(O){return O}transformOutgoing(O){return O}transformOutgoingURI(O){return O}transformOutgoingScheme(O){return O}};function U(O,w,g){if(!O||g>200)return null;if(typeof O=="object"){if(O instanceof s.URI)return w.transformOutgoing(O);for(let S in O)if(Object.hasOwnProperty.call(O,S)){const f=U(O[S],w,g+1);f!==null&&(O[S]=f)}}return null}function T(O,w){const g=U(O,w,0);return g===null?O:g}e.transformOutgoingURIs=T;function P(O,w,g,S){if(!O||S>200)return null;if(typeof O=="object"){if(O.$mid===1)return g?s.URI.revive(w.transformIncoming(O)):w.transformIncoming(O);for(let f in O)if(Object.hasOwnProperty.call(O,f)){const c=P(O[f],w,g,S+1);c!==null&&(O[f]=c)}}return null}function b(O,w){const g=P(O,w,!1,0);return g===null?O:g}e.transformIncomingURIs=b;function A(O,w){const g=P(O,w,!0,0);return g===null?O:g}e.transformAndReviveIncomingURIs=A}),define(De[44],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const s=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(p){return s.test(p)}e.isUUID=C,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let p;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?p=crypto.getRandomValues.bind(crypto):p=function(P){for(let b=0;b<P.length;b++)P[b]=Math.floor(Math.random()*256);return P};const U=new Uint8Array(16),T=[];for(let P=0;P<256;P++)T.push(P.toString(16).padStart(2,"0"));return function(){p(U),U[6]=U[6]&15|64,U[8]=U[8]&63|128;let b=0,A="";return A+=T[U[b++]],A+=T[U[b++]],A+=T[U[b++]],A+=T[U[b++]],A+="-",A+=T[U[b++]],A+=T[U[b++]],A+="-",A+=T[U[b++]],A+=T[U[b++]],A+="-",A+=T[U[b++]],A+=T[U[b++]],A+="-",A+=T[U[b++]],A+=T[U[b++]],A+=T[U[b++]],A+=T[U[b++]],A+=T[U[b++]],A+=T[U[b++]],A}}()}),define(De[113],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[114],Ie([1,0,34,19]),function(J,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function p(U,T,P,b,A,O){if(Array.isArray(U)){let w=0;for(const g of U){const S=p(g,T,P,b,A,O);if(S===10)return S;S>w&&(w=S)}return w}else{if(typeof U=="string")return b?U==="*"?5:U===P?10:0:0;if(U){const{language:w,pattern:g,scheme:S,hasAccessToAllModels:f,notebookType:c}=U;if(!b&&!f)return 0;c&&A&&(T=A);let h=0;if(S)if(S===T.scheme)h=10;else if(S==="*")h=5;else return 0;if(w)if(w===P)h=10;else if(w==="*")h=Math.max(h,5);else return 0;if(c)if(c===O)h=10;else if(c==="*"&&O!==void 0)h=Math.max(h,5);else return 0;if(g){let u;if(typeof g=="string"?u=g:u={...g,base:(0,C.normalize)(g.base)},u===T.fsPath||(0,s.match)(u,T.fsPath))h=10;else return 0}return h}else return 0}}e.score=p}),define(De[115],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var s;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(s=e.IndentAction||(e.IndentAction={}));class C{constructor(P){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=P.open,this.close=P.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(P.notIn))for(let b=0,A=P.notIn.length;b<A;b++)switch(P.notIn[b]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(P){switch(P){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(P,b){if(P.getTokenCount()===0)return!0;const A=P.findTokenIndexAtOffset(b-2),O=P.getStandardTokenType(A);return this.isOK(O)}_findNeutralCharacterInRange(P,b){for(let A=P;A<=b;A++){const O=String.fromCharCode(A);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=C;class p{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const b of P)U(this.autoClosingPairsOpenByStart,b.open.charAt(0),b),U(this.autoClosingPairsOpenByEnd,b.open.charAt(b.open.length-1),b),U(this.autoClosingPairsCloseByStart,b.close.charAt(0),b),U(this.autoClosingPairsCloseByEnd,b.close.charAt(b.close.length-1),b),b.close.length===1&&b.open.length===1&&U(this.autoClosingPairsCloseSingleChar,b.close,b)}}e.AutoClosingPairs=p;function U(T,P,b){T.has(P)?T.get(P).push(b):T.set(P,[b])}}),define(De[77],Ie([1,0,23,22]),function(J,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var p;(function(w){w[w.Full=1]="Full",w[w.Delta=2]="Delta"})(p||(p={}));function U(w){for(let g=0,S=w.length;g<S;g+=4){const f=w[g+0],c=w[g+1],h=w[g+2],u=w[g+3];w[g+0]=u,w[g+1]=h,w[g+2]=c,w[g+3]=f}}function T(w){const g=new Uint8Array(w.buffer,w.byteOffset,w.length*4);return C.isLittleEndian()||U(g),s.VSBuffer.wrap(g)}function P(w){const g=w.buffer;if(C.isLittleEndian()||U(g),g.byteOffset%4==0)return new Uint32Array(g.buffer,g.byteOffset,g.length/4);{const S=new Uint8Array(g.byteLength);return S.set(g),new Uint32Array(S.buffer,S.byteOffset,S.length/4)}}function b(w){const g=new Uint32Array(A(w));let S=0;if(g[S++]=w.id,w.type==="full")g[S++]=1,g[S++]=w.data.length,g.set(w.data,S),S+=w.data.length;else{g[S++]=2,g[S++]=w.deltas.length;for(const f of w.deltas)g[S++]=f.start,g[S++]=f.deleteCount,f.data?(g[S++]=f.data.length,g.set(f.data,S),S+=f.data.length):g[S++]=0}return T(g)}e.encodeSemanticTokensDto=b;function A(w){let g=0;if(g+=1+1,w.type==="full")g+=1+w.data.length;else{g+=1,g+=(1+1+1)*w.deltas.length;for(const S of w.deltas)S.data&&(g+=S.data.length)}return g}function O(w){const g=P(w);let S=0;const f=g[S++];if(g[S++]===1){const D=g[S++],y=g.subarray(S,S+D);return S+=D,{id:f,type:"full",data:y}}const h=g[S++],u=[];for(let D=0;D<h;D++){const y=g[S++],a=g[S++],_=g[S++];let r;_>0&&(r=g.subarray(S,S+_),S+=_),u[D]={start:y,deleteCount:a,data:r}}return{id:f,type:"delta",deltas:u}}e.decodeSemanticTokensDto=O}),define(De[116],Ie([17,18]),function(J,e){return J.create("vs/base/common/date",e)}),define(De[117],Ie([1,0,116]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const C=60,p=C*60,U=p*24,T=U*7,P=U*30,b=U*365;function A(w,g,S){typeof w!="number"&&(w=w.getTime());const f=Math.round((new Date().getTime()-w)/1e3);if(f<-30)return(0,s.localize)(0,null,A(new Date().getTime()+f*1e3,!1));if(f<30)return(0,s.localize)(1,null);let c;return f<C?(c=f,g?c===1?S?(0,s.localize)(2,null,c):(0,s.localize)(3,null,c):S?(0,s.localize)(4,null,c):(0,s.localize)(5,null,c):c===1?S?(0,s.localize)(6,null,c):(0,s.localize)(7,null,c):S?(0,s.localize)(8,null,c):(0,s.localize)(9,null,c)):f<p?(c=Math.floor(f/C),g?c===1?S?(0,s.localize)(10,null,c):(0,s.localize)(11,null,c):S?(0,s.localize)(12,null,c):(0,s.localize)(13,null,c):c===1?S?(0,s.localize)(14,null,c):(0,s.localize)(15,null,c):S?(0,s.localize)(16,null,c):(0,s.localize)(17,null,c)):f<U?(c=Math.floor(f/p),g?c===1?S?(0,s.localize)(18,null,c):(0,s.localize)(19,null,c):S?(0,s.localize)(20,null,c):(0,s.localize)(21,null,c):c===1?S?(0,s.localize)(22,null,c):(0,s.localize)(23,null,c):S?(0,s.localize)(24,null,c):(0,s.localize)(25,null,c)):f<T?(c=Math.floor(f/U),g?c===1?(0,s.localize)(26,null,c):(0,s.localize)(27,null,c):c===1?(0,s.localize)(28,null,c):(0,s.localize)(29,null,c)):f<P?(c=Math.floor(f/T),g?c===1?S?(0,s.localize)(30,null,c):(0,s.localize)(31,null,c):S?(0,s.localize)(32,null,c):(0,s.localize)(33,null,c):c===1?S?(0,s.localize)(34,null,c):(0,s.localize)(35,null,c):S?(0,s.localize)(36,null,c):(0,s.localize)(37,null,c)):f<b?(c=Math.floor(f/P),g?c===1?S?(0,s.localize)(38,null,c):(0,s.localize)(39,null,c):S?(0,s.localize)(40,null,c):(0,s.localize)(41,null,c):c===1?S?(0,s.localize)(42,null,c):(0,s.localize)(43,null,c):S?(0,s.localize)(44,null,c):(0,s.localize)(45,null,c)):(c=Math.floor(f/b),g?c===1?S?(0,s.localize)(46,null,c):(0,s.localize)(47,null,c):S?(0,s.localize)(48,null,c):(0,s.localize)(49,null,c):c===1?S?(0,s.localize)(50,null,c):(0,s.localize)(51,null,c):S?(0,s.localize)(52,null,c):(0,s.localize)(53,null,c))}e.fromNow=A;function O(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(De[118],Ie([17,18]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(De[45],Ie([1,0,15,9,118]),function(J,e,s,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function U(w,g){return g&&(w.stack||w.stacktrace)?p.localize(0,null,P(w),T(w.stack)||T(w.stacktrace)):P(w)}function T(w){return Array.isArray(w)?w.join(`
`):w}function P(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?p.localize(1,null,w.message):w.message||p.localize(2,null)}function b(w=null,g=!1){if(!w)return p.localize(3,null);if(Array.isArray(w)){const S=s.coalesce(w),f=b(S[0],g);return S.length>1?p.localize(4,null,f,S.length):f}if(C.isString(w))return w;if(w.detail){const S=w.detail;if(S.error)return U(S.error,g);if(S.exception)return U(S.exception,g)}return w.stack?U(w,g):w.message?w.message:p.localize(5,null)}e.toErrorMessage=b;function A(w){const g=w;return g instanceof Error&&Array.isArray(g.actions)}e.isErrorWithActions=A;function O(w,g){let S;return typeof w=="string"?S=new Error(w):S=w,S.actions=g,S}e.createErrorWithActions=O}),define(De[119],Ie([17,18]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(De[120],Ie([1,0,119,22,121,15,27,113]),function(J,e,s,C,p,U,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var b;(function(q){q[q.None=0]="None",q[q.Keep=1]="Keep",q[q.Brackets=2]="Brackets",q[q.Advanced=3]="Advanced",q[q.Full=4]="Full"})(b=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class A{constructor(Y){this._values=Y}hasChanged(Y){return this._values[Y]}}e.ConfigurationChangedEvent=A;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class w{constructor(Y,me,Le,ze){this.id=Y,this.name=me,this.defaultValue=Le,this.schema=ze}applyUpdate(Y,me){return S(Y,me)}compute(Y,me,Le){return Le}}class g{constructor(Y,me){this.newValue=Y,this.didChange=me}}e.ApplyUpdateResult=g;function S(q,Y){if(typeof q!="object"||typeof Y!="object"||!q||!Y)return new g(Y,q!==Y);if(Array.isArray(q)||Array.isArray(Y)){const Le=Array.isArray(q)&&Array.isArray(Y)&&U.equals(q,Y);return new g(Y,Le)}let me=!1;for(const Le in Y)if(Y.hasOwnProperty(Le)){const ze=S(q[Le],Y[Le]);ze.didChange&&(q[Le]=ze.newValue,me=!0)}return new g(q,me)}class f{constructor(Y){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0}applyUpdate(Y,me){return S(Y,me)}validate(Y){return this.defaultValue}}class c{constructor(Y,me,Le,ze){this.id=Y,this.name=me,this.defaultValue=Le,this.schema=ze}applyUpdate(Y,me){return S(Y,me)}validate(Y){return typeof Y=="undefined"?this.defaultValue:Y}compute(Y,me,Le){return Le}}function h(q,Y){return typeof q=="undefined"?Y:q==="false"?!1:Boolean(q)}e.boolean=h;class u extends c{constructor(Y,me,Le,ze=void 0){typeof ze!="undefined"&&(ze.type="boolean",ze.default=Le);super(Y,me,Le,ze)}validate(Y){return h(Y,this.defaultValue)}}function D(q,Y,me,Le){if(typeof q=="undefined")return Y;let ze=parseInt(q,10);return isNaN(ze)?Y:(ze=Math.max(me,ze),ze=Math.min(Le,ze),ze|0)}e.clampedInt=D;class y extends c{constructor(Y,me,Le,ze,Ge,Ze=void 0){typeof Ze!="undefined"&&(Ze.type="integer",Ze.default=Le,Ze.minimum=ze,Ze.maximum=Ge);super(Y,me,Le,Ze);this.minimum=ze,this.maximum=Ge}static clampedInt(Y,me,Le,ze){return D(Y,me,Le,ze)}validate(Y){return y.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}class a extends c{constructor(Y,me,Le,ze,Ge){typeof Ge!="undefined"&&(Ge.type="number",Ge.default=Le);super(Y,me,Le,Ge);this.validationFn=ze}static clamp(Y,me,Le){return Y<me?me:Y>Le?Le:Y}static float(Y,me){if(typeof Y=="number")return Y;if(typeof Y=="undefined")return me;const Le=parseFloat(Y);return isNaN(Le)?me:Le}validate(Y){return this.validationFn(a.float(Y,this.defaultValue))}}class _ extends c{static string(Y,me){return typeof Y!="string"?me:Y}constructor(Y,me,Le,ze=void 0){typeof ze!="undefined"&&(ze.type="string",ze.default=Le);super(Y,me,Le,ze)}validate(Y){return _.string(Y,this.defaultValue)}}function r(q,Y,me){return typeof q!="string"||me.indexOf(q)===-1?Y:q}e.stringSet=r;class d extends c{constructor(Y,me,Le,ze,Ge=void 0){typeof Ge!="undefined"&&(Ge.type="string",Ge.enum=ze,Ge.default=Le);super(Y,me,Le,Ge);this._allowedValues=ze}validate(Y){return r(Y,this.defaultValue,this._allowedValues)}}class i extends w{constructor(Y,me,Le,ze,Ge,Ze,ot=void 0){typeof ot!="undefined"&&(ot.type="string",ot.enum=Ge,ot.default=ze);super(Y,me,Le,ot);this._allowedValues=Ge,this._convert=Ze}validate(Y){return typeof Y!="string"?this.defaultValue:this._allowedValues.indexOf(Y)===-1?this.defaultValue:this._convert(Y)}}function o(q){switch(q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class n extends w{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[s.localize(0,null),s.localize(1,null),s.localize(2,null)],default:"auto",description:s.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,me,Le){return Le===0?Y.accessibilitySupport:Le}}class t extends w{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:s.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:s.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{insertSpace:h(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:h(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var l;(function(q){q[q.Hidden=0]="Hidden",q[q.Blink=1]="Blink",q[q.Smooth=2]="Smooth",q[q.Phase=3]="Phase",q[q.Expand=4]="Expand",q[q.Solid=5]="Solid"})(l=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function v(q){switch(q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var m;(function(q){q[q.Line=1]="Line",q[q.Block=2]="Block",q[q.Underline=3]="Underline",q[q.LineThin=4]="LineThin",q[q.BlockOutline=5]="BlockOutline",q[q.UnderlineThin=6]="UnderlineThin"})(m=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function I(q){switch(q){case m.Line:return"line";case m.Block:return"block";case m.Underline:return"underline";case m.LineThin:return"line-thin";case m.BlockOutline:return"block-outline";case m.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=I;function B(q){switch(q){case"line":return m.Line;case"block":return m.Block;case"underline":return m.Underline;case"line-thin":return m.LineThin;case"block-outline":return m.BlockOutline;case"underline-thin":return m.UnderlineThin}}class x extends f{constructor(){super(129)}compute(Y,me,Le){const ze=["monaco-editor"];return me.get(34)&&ze.push(me.get(34)),Y.extraEditorClassName&&ze.push(Y.extraEditorClassName),me.get(67)==="default"?ze.push("mouse-default"):me.get(67)==="copy"&&ze.push("mouse-copy"),me.get(101)&&ze.push("showUnused"),me.get(127)&&ze.push("showDeprecated"),ze.join(" ")}}class R extends u{constructor(){super(33,"emptySelectionClipboard",!0,{description:s.localize(6,null)})}compute(Y,me,Le){return Le&&Y.emptySelectionClipboard}}class E extends w{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:s.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[s.localize(8,null),s.localize(9,null),s.localize(10,null)],description:s.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[s.localize(12,null),s.localize(13,null),s.localize(14,null)],description:s.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:s.localize(16,null),included:C.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:s.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:s.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{cursorMoveOnType:h(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":r(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":r(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:h(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:h(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:h(me.loop,this.defaultValue.loop)}}}class M extends w{constructor(){super(46,"fontLigatures",M.OFF,{anyOf:[{type:"boolean",description:s.localize(19,null)},{type:"string",description:s.localize(20,null)}],description:s.localize(21,null),default:!1})}validate(Y){return typeof Y=="undefined"?this.defaultValue:typeof Y=="string"?Y==="false"?M.OFF:Y==="true"?M.ON:Y:Boolean(Y)?M.ON:M.OFF}}e.EditorFontLigatures=M,M.OFF='"liga" off, "calt" off',M.ON='"liga" on, "calt" on';class N extends f{constructor(){super(45)}compute(Y,me,Le){return Y.fontInfo}}class W extends c{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:s.localize(22,null)})}validate(Y){const me=a.float(Y,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(me,6,100)}compute(Y,me,Le){return Y.fontInfo.fontSize}}class Z extends w{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Z.MINIMUM_VALUE,maximum:Z.MAXIMUM_VALUE,errorMessage:s.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Z.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:s.localize(24,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(y.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,Z.MINIMUM_VALUE,Z.MAXIMUM_VALUE))}}Z.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],Z.MINIMUM_VALUE=1,Z.MAXIMUM_VALUE=1e3;class K extends w{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[s.localize(25,null),s.localize(26,null),s.localize(27,null)]},Le=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:s.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:s.localize(29,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:s.localize(30,null),...me},"editor.gotoLocation.multipleDeclarations":{description:s.localize(31,null),...me},"editor.gotoLocation.multipleImplementations":{description:s.localize(32,null),...me},"editor.gotoLocation.multipleReferences":{description:s.localize(33,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:Le,description:s.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:Le,description:s.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:Le,description:s.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:Le,description:s.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:Le,description:s.localize(38,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{multiple:r(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??r(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??r(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??r(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??r(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??r(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:_.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:_.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:_.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:_.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:_.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class F extends w{constructor(){const Y={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:s.localize(39,null)},"editor.hover.delay":{type:"number",default:Y.delay,minimum:0,maximum:1e4,description:s.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:s.localize(41,null)},"editor.hover.above":{type:"boolean",default:Y.above,description:s.localize(42,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:h(me.enabled,this.defaultValue.enabled),delay:y.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:h(me.sticky,this.defaultValue.sticky),above:h(me.above,this.defaultValue.above)}}}var oe;(function(q){q[q.None=0]="None",q[q.Text=1]="Text",q[q.Blocks=2]="Blocks"})(oe=e.RenderMinimap||(e.RenderMinimap={}));class ce extends f{constructor(){super(132)}compute(Y,me,Le){return ce.computeLayout(me,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio})}static computeContainedMinimapLineCount(Y){const me=Y.height/Y.lineHeight,Le=Y.scrollBeyondLastLine?me-1:0,ze=(Y.viewLineCount+Le)/(Y.pixelRatio*Y.height),Ge=Math.floor(Y.viewLineCount/ze);return{typicalViewportLineCount:me,extraLinesBeyondLastLine:Le,desiredRatio:ze,minimapLineCount:Ge}}static _computeMinimapLayout(Y,me){const Le=Y.outerWidth,ze=Y.outerHeight,Ge=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ge*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const Ze=me.stableMinimapLayoutInput,ot=Ze&&Y.outerHeight===Ze.outerHeight&&Y.lineHeight===Ze.lineHeight&&Y.typicalHalfwidthCharacterWidth===Ze.typicalHalfwidthCharacterWidth&&Y.pixelRatio===Ze.pixelRatio&&Y.scrollBeyondLastLine===Ze.scrollBeyondLastLine&&Y.minimap.enabled===Ze.minimap.enabled&&Y.minimap.side===Ze.minimap.side&&Y.minimap.size===Ze.minimap.size&&Y.minimap.showSlider===Ze.minimap.showSlider&&Y.minimap.renderCharacters===Ze.minimap.renderCharacters&&Y.minimap.maxColumn===Ze.minimap.maxColumn&&Y.minimap.scale===Ze.minimap.scale&&Y.verticalScrollbarWidth===Ze.verticalScrollbarWidth&&Y.isViewportWrapping===Ze.isViewportWrapping,Qe=Y.lineHeight,et=Y.typicalHalfwidthCharacterWidth,qe=Y.scrollBeyondLastLine,st=Y.minimap.renderCharacters;let it=Ge>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const lt=Y.minimap.maxColumn,ct=Y.minimap.size,Pt=Y.minimap.side,zt=Y.verticalScrollbarWidth,It=Y.viewLineCount,mt=Y.remainingWidth,Ft=Y.isViewportWrapping,$t=st?2:3;let Dt=Math.floor(Ge*ze);const He=Dt/Ge;let At=!1,Lt=!1,Nt=$t*it,pt=it/Ge,yt=1;if(ct==="fill"||ct==="fit"){const{typicalViewportLineCount:ye,extraLinesBeyondLastLine:Me,desiredRatio:Je,minimapLineCount:Ve}=ce.computeContainedMinimapLineCount({viewLineCount:It,scrollBeyondLastLine:qe,height:ze,lineHeight:Qe,pixelRatio:Ge});if(It/Ve>1)At=!0,Lt=!0,it=1,Nt=1,pt=it/Ge;else{let ht=!1,Et=it+1;if(ct==="fit"){const ft=Math.ceil((It+Me)*Nt);Ft&&ot&&mt<=me.stableFitRemainingWidth?(ht=!0,Et=me.stableFitMaxMinimapScale):ht=ft>Dt}if(ct==="fill"||ht){At=!0;const ft=it;Nt=Math.min(Qe*Ge,Math.max(1,Math.floor(1/Je))),Ft&&ot&&mt<=me.stableFitRemainingWidth&&(Et=me.stableFitMaxMinimapScale),it=Math.min(Et,Math.max(1,Math.floor(Nt/$t))),it>ft&&(yt=Math.min(2,it/ft)),pt=it/Ge/yt,Dt=Math.ceil(Math.max(ye,It+Me)*Nt),Ft?(me.stableMinimapLayoutInput=Y,me.stableFitRemainingWidth=mt,me.stableFitMaxMinimapScale=it):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const Tt=Math.floor(lt*pt),wt=Math.min(Tt,Math.max(0,Math.floor((mt-zt-2)*pt/(et+pt)))+e.MINIMAP_GUTTER_WIDTH);let we=Math.floor(Ge*wt);const Ce=we/Ge;we=Math.floor(we*yt);const ue=st?1:2,j=Pt==="left"?0:Le-wt-zt;return{renderMinimap:ue,minimapLeft:j,minimapWidth:wt,minimapHeightIsEditorHeight:At,minimapIsSampling:Lt,minimapScale:it,minimapLineHeight:Nt,minimapCanvasInnerWidth:we,minimapCanvasInnerHeight:Dt,minimapCanvasOuterWidth:Ce,minimapCanvasOuterHeight:He}}static computeLayout(Y,me){const Le=me.outerWidth|0,ze=me.outerHeight|0,Ge=me.lineHeight|0,Ze=me.lineNumbersDigitCount|0,ot=me.typicalHalfwidthCharacterWidth,Qe=me.maxDigitWidth,et=me.pixelRatio,qe=me.viewLineCount,st=Y.get(124),it=st==="inherit"?Y.get(123):st,lt=it==="inherit"?Y.get(119):it,ct=Y.get(122),Pt=Y.get(2),zt=me.isDominatedByLongLines,It=Y.get(51),mt=Y.get(61).renderType!==0,Ft=Y.get(62),$t=Y.get(95),Dt=Y.get(66),He=Y.get(93),At=He.verticalScrollbarSize,Lt=He.verticalHasArrows,Nt=He.arrowSize,pt=He.horizontalScrollbarSize,yt=Y.get(59),Tt=Y.get(38);let wt;if(typeof yt=="string"&&/^\d+(\.\d+)?ch$/.test(yt)){const vt=parseFloat(yt.substr(0,yt.length-2));wt=y.clampedInt(vt*ot,0,0,1e3)}else wt=y.clampedInt(yt,0,0,1e3);Tt&&(wt+=16);let we=0;if(mt){const vt=Math.max(Ze,Ft);we=Math.round(vt*Qe)}let Ce=0;It&&(Ce=Ge);let ue=0,j=ue+Ce,ye=j+we,Me=ye+wt;const Je=Le-Ce-we-wt;let Ve=!1,ut=!1,ht=-1;Pt!==2&&(it==="inherit"&&zt?(Ve=!0,ut=!0):lt==="on"||lt==="bounded"?ut=!0:lt==="wordWrapColumn"&&(ht=ct));const Et=ce._computeMinimapLayout({outerWidth:Le,outerHeight:ze,lineHeight:Ge,typicalHalfwidthCharacterWidth:ot,pixelRatio:et,scrollBeyondLastLine:$t,minimap:Dt,verticalScrollbarWidth:At,viewLineCount:qe,remainingWidth:Je,isViewportWrapping:ut},me.memory||new O);Et.renderMinimap!==0&&Et.minimapLeft===0&&(ue+=Et.minimapWidth,j+=Et.minimapWidth,ye+=Et.minimapWidth,Me+=Et.minimapWidth);const ft=Je-Et.minimapWidth,Ct=Math.max(1,Math.floor((ft-At-2)/ot)),Rt=Lt?Nt:0;return ut&&(ht=Math.max(1,Ct),lt==="bounded"&&(ht=Math.min(ht,ct))),{width:Le,height:ze,glyphMarginLeft:ue,glyphMarginWidth:Ce,lineNumbersLeft:j,lineNumbersWidth:we,decorationsLeft:ye,decorationsWidth:wt,contentLeft:Me,contentWidth:ft,minimap:Et,viewportColumn:Ct,isWordWrapMinified:Ve,isViewportWrapping:ut,wrappingColumn:ht,verticalScrollbarWidth:At,horizontalScrollbarHeight:pt,overviewRuler:{top:Rt,width:At,height:ze-2*Rt,right:0}}}}e.EditorLayoutInfoComputer=ce;class ae extends w{constructor(){const Y={enabled:!0};super(58,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"boolean",default:Y.enabled,description:s.localize(43,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:h(Y.enabled,this.defaultValue.enabled)}}}class fe extends w{constructor(){const Y={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(128,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"string",default:Y.enabled,description:s.localize(44,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[s.localize(45,null),s.localize(46,null),s.localize(47,null),s.localize(48,null)]},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:s.localize(49,null)},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,markdownDescription:s.localize(50,null)},"editor.inlayHints.padding":{type:"boolean",default:Y.padding,description:s.localize(51,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return typeof me.enabled=="boolean"&&(me.enabled=me.enabled?"on":"off"),{enabled:r(me.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:y.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:_.string(me.fontFamily,this.defaultValue.fontFamily),padding:h(me.padding,this.defaultValue.padding)}}}class ie extends a{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>a.clamp(Y,0,150),{markdownDescription:s.localize(52,null)})}compute(Y,me,Le){return Y.fontInfo.lineHeight}}class Ee extends w{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:s.localize(53,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[s.localize(54,null),s.localize(55,null),s.localize(56,null)],default:Y.size,description:s.localize(57,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:s.localize(58,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:s.localize(59,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:s.localize(60,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:s.localize(61,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:s.localize(62,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:h(me.enabled,this.defaultValue.enabled),size:r(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(me.side,this.defaultValue.side,["right","left"]),showSlider:r(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:h(me.renderCharacters,this.defaultValue.renderCharacters),scale:y.clampedInt(me.scale,1,1,3),maxColumn:y.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function be(q){return q==="ctrlCmd"?C.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ee extends w{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(63,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(64,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{top:y.clampedInt(me.top,0,0,1e3),bottom:y.clampedInt(me.bottom,0,0,1e3)}}}class ve extends w{constructor(){const Y={enabled:!0,cycle:!1};super(77,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:s.localize(65,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:s.localize(66,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:h(me.enabled,this.defaultValue.enabled),cycle:h(me.cycle,this.defaultValue.cycle)}}}class Re extends f{constructor(){super(130)}compute(Y,me,Le){return Y.pixelRatio}}class Fe extends w{constructor(){const Y={other:"on",comments:"off",strings:"off"},me=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[s.localize(67,null),s.localize(68,null),s.localize(69,null)]}];super(80,"quickSuggestions",Y,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:me,default:Y.strings,description:s.localize(70,null)},comments:{anyOf:me,default:Y.comments,description:s.localize(71,null)},other:{anyOf:me,default:Y.other,description:s.localize(72,null)}},default:Y,markdownDescription:s.localize(73,null)});this.defaultValue=Y}validate(Y){if(typeof Y=="boolean"){const et=Y?"on":"off";return{comments:et,strings:et,other:et}}if(!Y||typeof Y!="object")return this.defaultValue;const{other:me,comments:Le,strings:ze}=Y,Ge=["on","inline","off"];let Ze,ot,Qe;return typeof me=="boolean"?Ze=me?"on":"off":Ze=r(me,this.defaultValue.other,Ge),typeof Le=="boolean"?ot=Le?"on":"off":ot=r(Le,this.defaultValue.comments,Ge),typeof ze=="boolean"?Qe=ze?"on":"off":Qe=r(ze,this.defaultValue.strings,Ge),{other:Ze,comments:ot,strings:Qe}}}var We;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative",q[q.Interval=3]="Interval",q[q.Custom=4]="Custom"})(We=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Xe extends w{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[s.localize(74,null),s.localize(75,null),s.localize(76,null),s.localize(77,null)],default:"on",description:s.localize(78,null)})}validate(Y){let me=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof Y!="undefined"&&(typeof Y=="function"?(me=4,Le=Y):Y==="interval"?me=3:Y==="relative"?me=2:Y==="on"?me=1:me=0),{renderType:me,renderFn:Le}}}function Te(q){const Y=q.get(88);return Y==="editable"?q.get(82):Y!=="on"}e.filterValidationDecorations=Te;class Se extends w{constructor(){const Y=[],me={type:"number",description:s.localize(79,null)};super(92,"rulers",Y,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:s.localize(80,null),format:"color-hex"}}}]},default:Y,description:s.localize(81,null)})}validate(Y){if(Array.isArray(Y)){const me=[];for(let Le of Y)if(typeof Le=="number")me.push({column:y.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const ze=Le;me.push({column:y.clampedInt(ze.column,0,0,1e4),color:ze.color})}return me.sort((Le,ze)=>Le.column-ze.column),me}return this.defaultValue}}function ke(q,Y){if(typeof q!="string")return Y;switch(q){case"hidden":return 2;case"visible":return 3;default:return 1}}class se extends w{constructor(){const Y={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(82,null),s.localize(83,null),s.localize(84,null)],default:"auto",description:s.localize(85,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(86,null),s.localize(87,null),s.localize(88,null)],default:"auto",description:s.localize(89,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:s.localize(90,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:s.localize(91,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:s.localize(92,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y,Le=y.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=y.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:y.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ke(me.vertical,this.defaultValue.vertical),horizontal:ke(me.horizontal,this.defaultValue.horizontal),useShadows:h(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:h(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:h(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:h(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:h(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:y.clampedInt(me.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:y.clampedInt(me.verticalSliderSize,ze,0,1e3),scrollByPage:h(me.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class le extends w{constructor(){const Y={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(114,"unicodeHighlight",Y,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.nonBasicASCII,description:s.localize(93,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Y.invisibleCharacters,description:s.localize(94,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Y.ambiguousCharacters,description:s.localize(95,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeComments,description:s.localize(96,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeStrings,description:s.localize(97,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Y.allowedCharacters,description:s.localize(98,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Y.allowedLocales,description:s.localize(99,null)}})}applyUpdate(Y,me){let Le=!1;me.allowedCharacters&&(T.equals(Y.allowedCharacters,me.allowedCharacters)||(Y={...Y,allowedCharacters:me.allowedCharacters},Le=!0)),me.allowedLocales&&(T.equals(Y.allowedLocales,me.allowedLocales)||(Y={...Y,allowedLocales:me.allowedLocales},Le=!0));const ze=super.applyUpdate(Y,me);return Le?new g(ze.newValue,!0):ze}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{nonBasicASCII:z(me.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:h(me.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:h(me.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:z(me.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:z(me.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Y.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Y.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Y,me){if(typeof Y!="object"||!Y)return me;const Le={};for(const[ze,Ge]of Object.entries(Y))Ge===!0&&(Le[ze]=!0);return Le}}class G extends w{constructor(){const Y={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:s.localize(100,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:h(me.enabled,this.defaultValue.enabled),mode:r(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class X extends w{constructor(){const Y={enabled:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,markdownDescription:s.localize(101,null)},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Y.independentColorPoolPerBracketType,description:s.localize(102,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:h(me.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:h(me.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class k extends w{constructor(){const Y={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Y,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(103,null),s.localize(104,null),s.localize(105,null)],default:Y.bracketPairs,description:s.localize(106,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(107,null),s.localize(108,null),s.localize(109,null)],default:Y.bracketPairsHorizontal,description:s.localize(110,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Y.highlightActiveBracketPair,description:s.localize(111,null)},"editor.guides.indentation":{type:"boolean",default:Y.indentation,description:s.localize(112,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[s.localize(113,null),s.localize(114,null),s.localize(115,null)],default:Y.highlightActiveIndentation,description:s.localize(116,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{bracketPairs:z(me.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:z(me.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:h(me.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:h(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:z(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function z(q,Y,me){const Le=me.indexOf(q);return Le===-1?Y:me[Le]}class H extends w{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(107,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[s.localize(117,null),s.localize(118,null)],default:Y.insertMode,description:s.localize(119,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:s.localize(120,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:s.localize(121,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:s.localize(122,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:s.localize(123,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:s.localize(124,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:s.localize(125,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:s.localize(126,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:s.localize(127,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:s.localize(128,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:s.localize(129,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:s.localize(130,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:s.localize(131,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:s.localize(132,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:s.localize(133,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:s.localize(134,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:s.localize(135,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:s.localize(136,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:s.localize(137,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:s.localize(138,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:s.localize(139,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:s.localize(140,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:s.localize(141,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:s.localize(142,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:s.localize(143,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:s.localize(144,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:s.localize(145,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:s.localize(146,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:s.localize(147,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:s.localize(148,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:s.localize(149,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:s.localize(150,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:s.localize(151,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:s.localize(152,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:s.localize(153,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:s.localize(154,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:s.localize(155,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:s.localize(156,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:s.localize(157,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:s.localize(158,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{insertMode:r(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:h(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:h(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:h(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:h(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:h(me.showIcons,this.defaultValue.showIcons),showStatusBar:h(me.showStatusBar,this.defaultValue.showStatusBar),preview:h(me.preview,this.defaultValue.preview),previewMode:r(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:h(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:h(me.showMethods,this.defaultValue.showMethods),showFunctions:h(me.showFunctions,this.defaultValue.showFunctions),showConstructors:h(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:h(me.showDeprecated,this.defaultValue.showDeprecated),showFields:h(me.showFields,this.defaultValue.showFields),showVariables:h(me.showVariables,this.defaultValue.showVariables),showClasses:h(me.showClasses,this.defaultValue.showClasses),showStructs:h(me.showStructs,this.defaultValue.showStructs),showInterfaces:h(me.showInterfaces,this.defaultValue.showInterfaces),showModules:h(me.showModules,this.defaultValue.showModules),showProperties:h(me.showProperties,this.defaultValue.showProperties),showEvents:h(me.showEvents,this.defaultValue.showEvents),showOperators:h(me.showOperators,this.defaultValue.showOperators),showUnits:h(me.showUnits,this.defaultValue.showUnits),showValues:h(me.showValues,this.defaultValue.showValues),showConstants:h(me.showConstants,this.defaultValue.showConstants),showEnums:h(me.showEnums,this.defaultValue.showEnums),showEnumMembers:h(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:h(me.showKeywords,this.defaultValue.showKeywords),showWords:h(me.showWords,this.defaultValue.showWords),showColors:h(me.showColors,this.defaultValue.showColors),showFiles:h(me.showFiles,this.defaultValue.showFiles),showReferences:h(me.showReferences,this.defaultValue.showReferences),showFolders:h(me.showFolders,this.defaultValue.showFolders),showTypeParameters:h(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:h(me.showSnippets,this.defaultValue.showSnippets),showUsers:h(me.showUsers,this.defaultValue.showUsers),showIssues:h(me.showIssues,this.defaultValue.showIssues)}}}class V extends w{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:s.localize(159,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:h(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class re extends f{constructor(){super(131)}compute(Y,me,Le){return me.get(82)?!0:Y.tabFocusMode}}var de;(function(q){q[q.None=0]="None",q[q.Same=1]="Same",q[q.Indent=2]="Indent",q[q.DeepIndent=3]="DeepIndent"})(de=e.WrappingIndent||(e.WrappingIndent={}));function Q(q){switch(q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class pe extends f{constructor(){super(133)}compute(Y,me,Le){const ze=me.get(132);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}const ge="Consolas, 'Courier New', monospace",Ne="Menlo, Monaco, 'Courier New', monospace",Be="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.isMacintosh?Ne:C.isLinux?Be:ge,fontWeight:"normal",fontSize:C.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Pe(q){return e.editorOptionsRegistry[q.id]=q,q}var Ke;(function(q){q[q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",q[q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",q[q.accessibilitySupport=2]="accessibilitySupport",q[q.accessibilityPageSize=3]="accessibilityPageSize",q[q.ariaLabel=4]="ariaLabel",q[q.autoClosingBrackets=5]="autoClosingBrackets",q[q.autoClosingDelete=6]="autoClosingDelete",q[q.autoClosingOvertype=7]="autoClosingOvertype",q[q.autoClosingQuotes=8]="autoClosingQuotes",q[q.autoIndent=9]="autoIndent",q[q.automaticLayout=10]="automaticLayout",q[q.autoSurround=11]="autoSurround",q[q.bracketPairColorization=12]="bracketPairColorization",q[q.guides=13]="guides",q[q.codeLens=14]="codeLens",q[q.codeLensFontFamily=15]="codeLensFontFamily",q[q.codeLensFontSize=16]="codeLensFontSize",q[q.colorDecorators=17]="colorDecorators",q[q.columnSelection=18]="columnSelection",q[q.comments=19]="comments",q[q.contextmenu=20]="contextmenu",q[q.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",q[q.cursorBlinking=22]="cursorBlinking",q[q.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",q[q.cursorStyle=24]="cursorStyle",q[q.cursorSurroundingLines=25]="cursorSurroundingLines",q[q.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",q[q.cursorWidth=27]="cursorWidth",q[q.disableLayerHinting=28]="disableLayerHinting",q[q.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",q[q.domReadOnly=30]="domReadOnly",q[q.dragAndDrop=31]="dragAndDrop",q[q.enableDropIntoEditor=32]="enableDropIntoEditor",q[q.emptySelectionClipboard=33]="emptySelectionClipboard",q[q.extraEditorClassName=34]="extraEditorClassName",q[q.fastScrollSensitivity=35]="fastScrollSensitivity",q[q.find=36]="find",q[q.fixedOverflowWidgets=37]="fixedOverflowWidgets",q[q.folding=38]="folding",q[q.foldingStrategy=39]="foldingStrategy",q[q.foldingHighlight=40]="foldingHighlight",q[q.foldingImportsByDefault=41]="foldingImportsByDefault",q[q.foldingMaximumRegions=42]="foldingMaximumRegions",q[q.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",q[q.fontFamily=44]="fontFamily",q[q.fontInfo=45]="fontInfo",q[q.fontLigatures=46]="fontLigatures",q[q.fontSize=47]="fontSize",q[q.fontWeight=48]="fontWeight",q[q.formatOnPaste=49]="formatOnPaste",q[q.formatOnType=50]="formatOnType",q[q.glyphMargin=51]="glyphMargin",q[q.gotoLocation=52]="gotoLocation",q[q.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",q[q.hover=54]="hover",q[q.inDiffEditor=55]="inDiffEditor",q[q.inlineSuggest=56]="inlineSuggest",q[q.letterSpacing=57]="letterSpacing",q[q.lightbulb=58]="lightbulb",q[q.lineDecorationsWidth=59]="lineDecorationsWidth",q[q.lineHeight=60]="lineHeight",q[q.lineNumbers=61]="lineNumbers",q[q.lineNumbersMinChars=62]="lineNumbersMinChars",q[q.linkedEditing=63]="linkedEditing",q[q.links=64]="links",q[q.matchBrackets=65]="matchBrackets",q[q.minimap=66]="minimap",q[q.mouseStyle=67]="mouseStyle",q[q.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",q[q.mouseWheelZoom=69]="mouseWheelZoom",q[q.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",q[q.multiCursorModifier=71]="multiCursorModifier",q[q.multiCursorPaste=72]="multiCursorPaste",q[q.occurrencesHighlight=73]="occurrencesHighlight",q[q.overviewRulerBorder=74]="overviewRulerBorder",q[q.overviewRulerLanes=75]="overviewRulerLanes",q[q.padding=76]="padding",q[q.parameterHints=77]="parameterHints",q[q.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",q[q.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",q[q.quickSuggestions=80]="quickSuggestions",q[q.quickSuggestionsDelay=81]="quickSuggestionsDelay",q[q.readOnly=82]="readOnly",q[q.renameOnType=83]="renameOnType",q[q.renderControlCharacters=84]="renderControlCharacters",q[q.renderFinalNewline=85]="renderFinalNewline",q[q.renderLineHighlight=86]="renderLineHighlight",q[q.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",q[q.renderValidationDecorations=88]="renderValidationDecorations",q[q.renderWhitespace=89]="renderWhitespace",q[q.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",q[q.roundedSelection=91]="roundedSelection",q[q.rulers=92]="rulers",q[q.scrollbar=93]="scrollbar",q[q.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",q[q.scrollBeyondLastLine=95]="scrollBeyondLastLine",q[q.scrollPredominantAxis=96]="scrollPredominantAxis",q[q.selectionClipboard=97]="selectionClipboard",q[q.selectionHighlight=98]="selectionHighlight",q[q.selectOnLineNumbers=99]="selectOnLineNumbers",q[q.showFoldingControls=100]="showFoldingControls",q[q.showUnused=101]="showUnused",q[q.snippetSuggestions=102]="snippetSuggestions",q[q.smartSelect=103]="smartSelect",q[q.smoothScrolling=104]="smoothScrolling",q[q.stickyTabStops=105]="stickyTabStops",q[q.stopRenderingLineAfter=106]="stopRenderingLineAfter",q[q.suggest=107]="suggest",q[q.suggestFontSize=108]="suggestFontSize",q[q.suggestLineHeight=109]="suggestLineHeight",q[q.suggestOnTriggerCharacters=110]="suggestOnTriggerCharacters",q[q.suggestSelection=111]="suggestSelection",q[q.tabCompletion=112]="tabCompletion",q[q.tabIndex=113]="tabIndex",q[q.unicodeHighlighting=114]="unicodeHighlighting",q[q.unusualLineTerminators=115]="unusualLineTerminators",q[q.useShadowDOM=116]="useShadowDOM",q[q.useTabStops=117]="useTabStops",q[q.wordSeparators=118]="wordSeparators",q[q.wordWrap=119]="wordWrap",q[q.wordWrapBreakAfterCharacters=120]="wordWrapBreakAfterCharacters",q[q.wordWrapBreakBeforeCharacters=121]="wordWrapBreakBeforeCharacters",q[q.wordWrapColumn=122]="wordWrapColumn",q[q.wordWrapOverride1=123]="wordWrapOverride1",q[q.wordWrapOverride2=124]="wordWrapOverride2",q[q.wrappingIndent=125]="wrappingIndent",q[q.wrappingStrategy=126]="wrappingStrategy",q[q.showDeprecated=127]="showDeprecated",q[q.inlayHints=128]="inlayHints",q[q.editorClassName=129]="editorClassName",q[q.pixelRatio=130]="pixelRatio",q[q.tabFocusMode=131]="tabFocusMode",q[q.layoutInfo=132]="layoutInfo",q[q.wrappingInfo=133]="wrappingInfo"})(Ke=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Pe(new u(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:s.localize(160,null)})),acceptSuggestionOnEnter:Pe(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",s.localize(161,null),""],markdownDescription:s.localize(162,null)})),accessibilitySupport:Pe(new n),accessibilityPageSize:Pe(new y(3,"accessibilityPageSize",10,1,1073741824,{description:s.localize(163,null)})),ariaLabel:Pe(new _(4,"ariaLabel",s.localize(164,null))),autoClosingBrackets:Pe(new d(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(165,null),s.localize(166,null),""],description:s.localize(167,null)})),autoClosingDelete:Pe(new d(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",s.localize(168,null),""],description:s.localize(169,null)})),autoClosingOvertype:Pe(new d(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",s.localize(170,null),""],description:s.localize(171,null)})),autoClosingQuotes:Pe(new d(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(172,null),s.localize(173,null),""],description:s.localize(174,null)})),autoIndent:Pe(new i(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],o,{enumDescriptions:[s.localize(175,null),s.localize(176,null),s.localize(177,null),s.localize(178,null),s.localize(179,null)],description:s.localize(180,null)})),automaticLayout:Pe(new u(10,"automaticLayout",!1)),autoSurround:Pe(new d(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[s.localize(181,null),s.localize(182,null),s.localize(183,null),""],description:s.localize(184,null)})),bracketPairColorization:Pe(new X),bracketPairGuides:Pe(new k),stickyTabStops:Pe(new u(105,"stickyTabStops",!1,{description:s.localize(185,null)})),codeLens:Pe(new u(14,"codeLens",!0,{description:s.localize(186,null)})),codeLensFontFamily:Pe(new _(15,"codeLensFontFamily","",{description:s.localize(187,null)})),codeLensFontSize:Pe(new y(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:s.localize(188,null)})),colorDecorators:Pe(new u(17,"colorDecorators",!0,{description:s.localize(189,null)})),columnSelection:Pe(new u(18,"columnSelection",!1,{description:s.localize(190,null)})),comments:Pe(new t),contextmenu:Pe(new u(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Pe(new u(21,"copyWithSyntaxHighlighting",!0,{description:s.localize(191,null)})),cursorBlinking:Pe(new i(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],v,{description:s.localize(192,null)})),cursorSmoothCaretAnimation:Pe(new u(23,"cursorSmoothCaretAnimation",!1,{description:s.localize(193,null)})),cursorStyle:Pe(new i(24,"cursorStyle",m.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],B,{description:s.localize(194,null)})),cursorSurroundingLines:Pe(new y(25,"cursorSurroundingLines",0,0,1073741824,{description:s.localize(195,null)})),cursorSurroundingLinesStyle:Pe(new d(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[s.localize(196,null),s.localize(197,null)],description:s.localize(198,null)})),cursorWidth:Pe(new y(27,"cursorWidth",0,0,1073741824,{markdownDescription:s.localize(199,null)})),disableLayerHinting:Pe(new u(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Pe(new u(29,"disableMonospaceOptimizations",!1)),domReadOnly:Pe(new u(30,"domReadOnly",!1)),dragAndDrop:Pe(new u(31,"dragAndDrop",!0,{description:s.localize(200,null)})),emptySelectionClipboard:Pe(new R),enableDropIntoEditor:Pe(new u(32,"enableDropIntoEditor",!0)),extraEditorClassName:Pe(new _(34,"extraEditorClassName","")),fastScrollSensitivity:Pe(new a(35,"fastScrollSensitivity",5,q=>q<=0?5:q,{markdownDescription:s.localize(201,null)})),find:Pe(new E),fixedOverflowWidgets:Pe(new u(37,"fixedOverflowWidgets",!1)),folding:Pe(new u(38,"folding",!0,{description:s.localize(202,null)})),foldingStrategy:Pe(new d(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[s.localize(203,null),s.localize(204,null)],description:s.localize(205,null)})),foldingHighlight:Pe(new u(40,"foldingHighlight",!0,{description:s.localize(206,null)})),foldingImportsByDefault:Pe(new u(41,"foldingImportsByDefault",!1,{description:s.localize(207,null)})),foldingMaximumRegions:Pe(new y(42,"foldingMaximumRegions",5e3,10,65e3,{description:s.localize(208,null)})),unfoldOnClickAfterEndOfLine:Pe(new u(43,"unfoldOnClickAfterEndOfLine",!1,{description:s.localize(209,null)})),fontFamily:Pe(new _(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:s.localize(210,null)})),fontInfo:Pe(new N),fontLigatures2:Pe(new M),fontSize:Pe(new W),fontWeight:Pe(new Z),formatOnPaste:Pe(new u(49,"formatOnPaste",!1,{description:s.localize(211,null)})),formatOnType:Pe(new u(50,"formatOnType",!1,{description:s.localize(212,null)})),glyphMargin:Pe(new u(51,"glyphMargin",!0,{description:s.localize(213,null)})),gotoLocation:Pe(new K),hideCursorInOverviewRuler:Pe(new u(53,"hideCursorInOverviewRuler",!1,{description:s.localize(214,null)})),hover:Pe(new F),inDiffEditor:Pe(new u(55,"inDiffEditor",!1)),letterSpacing:Pe(new a(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,q=>a.clamp(q,-5,20),{description:s.localize(215,null)})),lightbulb:Pe(new ae),lineDecorationsWidth:Pe(new c(59,"lineDecorationsWidth",10)),lineHeight:Pe(new ie),lineNumbers:Pe(new Xe),lineNumbersMinChars:Pe(new y(62,"lineNumbersMinChars",5,1,300)),linkedEditing:Pe(new u(63,"linkedEditing",!1,{description:s.localize(216,null)})),links:Pe(new u(64,"links",!0,{description:s.localize(217,null)})),matchBrackets:Pe(new d(65,"matchBrackets","always",["always","near","never"],{description:s.localize(218,null)})),minimap:Pe(new Ee),mouseStyle:Pe(new d(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Pe(new a(68,"mouseWheelScrollSensitivity",1,q=>q===0?1:q,{markdownDescription:s.localize(219,null)})),mouseWheelZoom:Pe(new u(69,"mouseWheelZoom",!1,{markdownDescription:s.localize(220,null)})),multiCursorMergeOverlapping:Pe(new u(70,"multiCursorMergeOverlapping",!0,{description:s.localize(221,null)})),multiCursorModifier:Pe(new i(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],be,{markdownEnumDescriptions:[s.localize(222,null),s.localize(223,null)],markdownDescription:s.localize(224,null)})),multiCursorPaste:Pe(new d(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[s.localize(225,null),s.localize(226,null)],markdownDescription:s.localize(227,null)})),occurrencesHighlight:Pe(new u(73,"occurrencesHighlight",!0,{description:s.localize(228,null)})),overviewRulerBorder:Pe(new u(74,"overviewRulerBorder",!0,{description:s.localize(229,null)})),overviewRulerLanes:Pe(new y(75,"overviewRulerLanes",3,0,3)),padding:Pe(new ee),parameterHints:Pe(new ve),peekWidgetDefaultFocus:Pe(new d(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[s.localize(230,null),s.localize(231,null)],description:s.localize(232,null)})),definitionLinkOpensInPeek:Pe(new u(79,"definitionLinkOpensInPeek",!1,{description:s.localize(233,null)})),quickSuggestions:Pe(new Fe),quickSuggestionsDelay:Pe(new y(81,"quickSuggestionsDelay",10,0,1073741824,{description:s.localize(234,null)})),readOnly:Pe(new u(82,"readOnly",!1)),renameOnType:Pe(new u(83,"renameOnType",!1,{description:s.localize(235,null),markdownDeprecationMessage:s.localize(236,null)})),renderControlCharacters:Pe(new u(84,"renderControlCharacters",!0,{description:s.localize(237,null),restricted:!0})),renderFinalNewline:Pe(new u(85,"renderFinalNewline",!0,{description:s.localize(238,null)})),renderLineHighlight:Pe(new d(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",s.localize(239,null)],description:s.localize(240,null)})),renderLineHighlightOnlyWhenFocus:Pe(new u(87,"renderLineHighlightOnlyWhenFocus",!1,{description:s.localize(241,null)})),renderValidationDecorations:Pe(new d(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Pe(new d(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",s.localize(242,null),s.localize(243,null),s.localize(244,null),""],description:s.localize(245,null)})),revealHorizontalRightPadding:Pe(new y(90,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Pe(new u(91,"roundedSelection",!0,{description:s.localize(246,null)})),rulers:Pe(new Se),scrollbar:Pe(new se),scrollBeyondLastColumn:Pe(new y(94,"scrollBeyondLastColumn",5,0,1073741824,{description:s.localize(247,null)})),scrollBeyondLastLine:Pe(new u(95,"scrollBeyondLastLine",!0,{description:s.localize(248,null)})),scrollPredominantAxis:Pe(new u(96,"scrollPredominantAxis",!0,{description:s.localize(249,null)})),selectionClipboard:Pe(new u(97,"selectionClipboard",!0,{description:s.localize(250,null),included:C.isLinux})),selectionHighlight:Pe(new u(98,"selectionHighlight",!0,{description:s.localize(251,null)})),selectOnLineNumbers:Pe(new u(99,"selectOnLineNumbers",!0)),showFoldingControls:Pe(new d(100,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[s.localize(252,null),s.localize(253,null)],description:s.localize(254,null)})),showUnused:Pe(new u(101,"showUnused",!0,{description:s.localize(255,null)})),showDeprecated:Pe(new u(127,"showDeprecated",!0,{description:s.localize(256,null)})),inlayHints:Pe(new fe),snippetSuggestions:Pe(new d(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[s.localize(257,null),s.localize(258,null),s.localize(259,null),s.localize(260,null)],description:s.localize(261,null)})),smartSelect:Pe(new V),smoothScrolling:Pe(new u(104,"smoothScrolling",!1,{description:s.localize(262,null)})),stopRenderingLineAfter:Pe(new y(106,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Pe(new H),inlineSuggest:Pe(new G),suggestFontSize:Pe(new y(108,"suggestFontSize",0,0,1e3,{markdownDescription:s.localize(263,null)})),suggestLineHeight:Pe(new y(109,"suggestLineHeight",0,0,1e3,{markdownDescription:s.localize(264,null)})),suggestOnTriggerCharacters:Pe(new u(110,"suggestOnTriggerCharacters",!0,{description:s.localize(265,null)})),suggestSelection:Pe(new d(111,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[s.localize(266,null),s.localize(267,null),s.localize(268,null)],description:s.localize(269,null)})),tabCompletion:Pe(new d(112,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[s.localize(270,null),s.localize(271,null),s.localize(272,null)],description:s.localize(273,null)})),tabIndex:Pe(new y(113,"tabIndex",0,-1,1073741824)),unicodeHighlight:Pe(new le),unusualLineTerminators:Pe(new d(115,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[s.localize(274,null),s.localize(275,null),s.localize(276,null)],description:s.localize(277,null)})),useShadowDOM:Pe(new u(116,"useShadowDOM",!0)),useTabStops:Pe(new u(117,"useTabStops",!0,{description:s.localize(278,null)})),wordSeparators:Pe(new _(118,"wordSeparators",p.USUAL_WORD_SEPARATORS,{description:s.localize(279,null)})),wordWrap:Pe(new d(119,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[s.localize(280,null),s.localize(281,null),s.localize(282,null),s.localize(283,null)],description:s.localize(284,null)})),wordWrapBreakAfterCharacters:Pe(new _(120,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Pe(new _(121,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Pe(new y(122,"wordWrapColumn",80,1,1073741824,{markdownDescription:s.localize(285,null)})),wordWrapOverride1:Pe(new d(123,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Pe(new d(124,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Pe(new i(125,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Q,{enumDescriptions:[s.localize(286,null),s.localize(287,null),s.localize(288,null),s.localize(289,null)],description:s.localize(290,null)})),wrappingStrategy:Pe(new d(126,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[s.localize(291,null),s.localize(292,null)],description:s.localize(293,null)})),editorClassName:Pe(new x),pixelRatio:Pe(new Re),tabFocusMode:Pe(new re),layoutInfo:Pe(new ce),wrappingInfo:Pe(new pe)}}),define(De[122],Ie([17,18]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[123],Ie([17,18]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[124],Ie([17,18]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[125],Ie([17,18]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(De[126],Ie([17,18]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(De[127],Ie([17,18]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(De[128],Ie([17,18]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[129],Ie([17,18]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[130],Ie([17,18]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(De[131],Ie([17,18]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[132],Ie([17,18]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[133],Ie([17,18]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[134],Ie([17,18]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[135],Ie([17,18]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(De[136],Ie([17,18]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[137],Ie([17,18]),function(J,e){return J.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[138],Ie([17,18]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[139],Ie([17,18]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[140],Ie([17,18]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[141],Ie([17,18]),function(J,e){return J.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[142],Ie([17,18]),function(J,e){return J.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[143],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var s;(function(P){P[P.ACTIVATE=1]="ACTIVATE",P[P.RESTORE=2]="RESTORE",P[P.PRESERVE=3]="PRESERVE"})(s=e.EditorActivation||(e.EditorActivation={}));var C;(function(P){P[P.PICK=0]="PICK",P[P.DISABLED=1]="DISABLED",P[P.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(C=e.EditorResolution||(e.EditorResolution={}));var p;(function(P){P[P.API=0]="API",P[P.USER=1]="USER"})(p=e.EditorOpenSource||(e.EditorOpenSource={}));var U;(function(P){P[P.Center=0]="Center",P[P.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",P[P.NearTop=2]="NearTop",P[P.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(U=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var T;(function(P){P.PROGRAMMATIC="api",P.NAVIGATION="code.navigation",P.JUMP="code.jump"})(T=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(De[144],Ie([1,0,21,29,124,236]),function(J,e,s,C,p,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function b(u){return u=u.trim(),u==="*"||T.test(u)}e.isValidVersionStr=b;function A(u){if(!b(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let D=u.match(T);return D?{hasCaret:D[1]==="^",hasGreaterEquals:D[1]===">=",majorBase:D[2]==="x"?0:parseInt(D[2],10),majorMustEqual:D[2]!=="x",minorBase:D[4]==="x"?0:parseInt(D[4],10),minorMustEqual:D[4]!=="x",patchBase:D[6]==="x"?0:parseInt(D[6],10),patchMustEqual:D[6]!=="x",preRelease:D[8]||null}:null}e.parseVersion=A;function O(u){if(!u)return null;let D=u.majorBase,y=u.majorMustEqual,a=u.minorBase,_=u.minorMustEqual,r=u.patchBase,d=u.patchMustEqual;u.hasCaret&&(D===0||(_=!1),d=!1);let i=0;if(u.preRelease){const o=P.exec(u.preRelease);if(o){const[,n,t,l]=o;i=Date.UTC(Number(n),Number(t)-1,Number(l))}}return{majorBase:D,majorMustEqual:y,minorBase:a,minorMustEqual:_,patchBase:r,patchMustEqual:d,isMinimum:u.hasGreaterEquals,notBefore:i}}e.normalizeVersion=O;function w(u,D,y){let a;typeof u=="string"?a=O(A(u)):a=u;let _;D instanceof Date?_=D.getTime():typeof D=="string"&&(_=new Date(D).getTime());let r;if(typeof y=="string"?r=O(A(y)):r=y,!a||!r)return!1;let d=a.majorBase,i=a.minorBase,o=a.patchBase,n=r.majorBase,t=r.minorBase,l=r.patchBase,v=r.notBefore,m=r.majorMustEqual,I=r.minorMustEqual,B=r.patchMustEqual;return r.isMinimum?d>n?!0:d<n?!1:i>t?!0:i<t||_&&_<v?!1:o>=l:(d===1&&n===0&&(!m||!I||!B)&&(n=1,t=0,l=0,m=!0,I=!1,B=!1),d<n?!1:d>n?!m:i<t?!1:i>t?!I:o<l?!1:o>l?!B:!(_&&_<v))}e.isValidVersion=w;function g(u,D,y,a,_){const r=[];if(typeof a.publisher!="undefined"&&typeof a.publisher!="string")return r.push([C.default.Error,p.localize(0,null)]),r;if(typeof a.name!="string")return r.push([C.default.Error,p.localize(1,null,"name")]),r;if(typeof a.version!="string")return r.push([C.default.Error,p.localize(2,null,"version")]),r;if(!a.engines)return r.push([C.default.Error,p.localize(3,null,"engines")]),r;if(typeof a.engines.vscode!="string")return r.push([C.default.Error,p.localize(4,null,"engines.vscode")]),r;if(typeof a.extensionDependencies!="undefined"&&!h(a.extensionDependencies))return r.push([C.default.Error,p.localize(5,null,"extensionDependencies")]),r;if(typeof a.activationEvents!="undefined"){if(!h(a.activationEvents))return r.push([C.default.Error,p.localize(6,null,"activationEvents")]),r;if(typeof a.main=="undefined"&&typeof a.browser=="undefined")return r.push([C.default.Error,p.localize(7,null,"activationEvents","main")]),r}if(typeof a.extensionKind!="undefined"&&typeof a.main=="undefined"&&r.push([C.default.Warning,p.localize(8,null,"extensionKind")]),typeof a.main!="undefined"){if(typeof a.main!="string")return r.push([C.default.Error,p.localize(9,null,"main")]),r;{const o=(0,s.joinPath)(y,a.main);(0,s.isEqualOrParent)(o,y)||r.push([C.default.Warning,p.localize(10,null,o.path,y.path)])}if(typeof a.activationEvents=="undefined")return r.push([C.default.Error,p.localize(11,null,"activationEvents","main")]),r}if(typeof a.browser!="undefined"){if(typeof a.browser!="string")return r.push([C.default.Error,p.localize(12,null,"browser")]),r;{const o=(0,s.joinPath)(y,a.browser);(0,s.isEqualOrParent)(o,y)||r.push([C.default.Warning,p.localize(13,null,o.path,y.path)])}if(typeof a.activationEvents=="undefined")return r.push([C.default.Error,p.localize(14,null,"activationEvents","browser")]),r}if(!U.valid(a.version))return r.push([C.default.Error,p.localize(15,null)]),r;const d=[];if(!S(u,D,a,_,d))for(const o of d)r.push([C.default.Error,o]);return r}e.validateExtensionManifest=g;function S(u,D,y,a,_){return a||typeof y.main=="undefined"&&typeof y.browser=="undefined"?!0:c(u,D,y.engines.vscode,_)}e.isValidExtensionVersion=S;function f(u,D,y){return u==="*"||c(D,y,u)}e.isEngineValid=f;function c(u,D,y,a=[]){let _=O(A(y));if(!_)return a.push(p.localize(16,null,y)),!1;if(_.majorBase===0){if(!_.majorMustEqual||!_.minorMustEqual)return a.push(p.localize(17,null,y)),!1}else if(!_.majorMustEqual)return a.push(p.localize(18,null,y)),!1;return w(u,D,_)?!0:(a.push(p.localize(19,null,u,y)),!1)}function h(u){if(!Array.isArray(u))return!1;for(let D=0,y=u.length;D<y;D++)if(typeof u[D]!="string")return!1;return!0}}),define(De[78],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class s{constructor(p,U=[],T=!1){this.ctor=p,this.staticArguments=U,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=s}),define(De[58],Ie([1,0,78]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const C=[];function p(T,P,b){P instanceof s.SyncDescriptor||(P=new s.SyncDescriptor(P,[],b)),C.push([T,P])}e.registerSingleton=p;function U(){return C}e.getSingletonServiceDescriptors=U}),define(De[145],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class s{constructor(U){this.incoming=new Map,this.outgoing=new Map,this.data=U}}e.Node=s;class C{constructor(U){this._hashFn=U,this._nodes=new Map}roots(){const U=[];for(let T of this._nodes.values())T.outgoing.size===0&&U.push(T);return U}insertEdge(U,T){const P=this.lookupOrInsertNode(U),b=this.lookupOrInsertNode(T);P.outgoing.set(this._hashFn(T),b),b.incoming.set(this._hashFn(U),P)}removeNode(U){const T=this._hashFn(U);this._nodes.delete(T);for(let P of this._nodes.values())P.outgoing.delete(T),P.incoming.delete(T)}lookupOrInsertNode(U){const T=this._hashFn(U);let P=this._nodes.get(T);return P||(P=new s(U),this._nodes.set(T,P)),P}lookup(U){return this._nodes.get(this._hashFn(U))}isEmpty(){return this._nodes.size===0}toString(){let U=[];for(let[T,P]of this._nodes)U.push(`${T}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return U.join(`
`)}findCycleSlow(){for(let[U,T]of this._nodes){const P=new Set([U]),b=this._findCycle(T,P);if(b)return b}}_findCycle(U,T){for(let[P,b]of U.outgoing){if(T.has(P))return[...T,P].join(" -> ");T.add(P);const A=this._findCycle(b,T);if(A)return A;T.delete(P)}}}e.Graph=C}),define(De[3],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var s;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function P(b){return b[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=P})(s=e._util||(e._util={})),e.IInstantiationService=p("instantiationService");function C(T,P,b){P[s.DI_TARGET]===P?P[s.DI_DEPENDENCIES].push({id:T,index:b}):(P[s.DI_DEPENDENCIES]=[{id:T,index:b}],P[s.DI_TARGET]=P)}function p(T){if(s.serviceIds.has(T))return s.serviceIds.get(T);const P=function(b,A,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(P,b,O)};return P.toString=()=>T,s.serviceIds.set(T,P),P}e.createDecorator=p;function U(T){return T}e.refineServiceDecorator=U}),define(De[59],Ie([1,0,9,2,3]),function(J,e,s,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,p.createDecorator)("configurationService");function U(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof C.URI)}e.isConfigurationOverrides=U;function T(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||s.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof C.URI)}e.isConfigurationUpdateOverrides=T;var P;(function(u){u[u.USER=1]="USER",u[u.USER_LOCAL=2]="USER_LOCAL",u[u.USER_REMOTE=3]="USER_REMOTE",u[u.WORKSPACE=4]="WORKSPACE",u[u.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",u[u.DEFAULT=6]="DEFAULT",u[u.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function b(u){switch(u){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=b;function A(u,D){const y=Object.create(null);for(let a in u)O(y,a,u[a],D);return y}e.toValuesTree=A;function O(u,D,y,a){const _=D.split("."),r=_.pop();let d=u;for(let i=0;i<_.length;i++){let o=_[i],n=d[o];switch(typeof n){case"undefined":n=d[o]=Object.create(null);break;case"object":break;default:a(`Ignoring ${D} as ${_.slice(0,i+1).join(".")} is ${JSON.stringify(n)}`);return}d=n}if(typeof d=="object"&&d!==null)try{d[r]=y}catch{a(`Ignoring ${D} as ${_.join(".")} is ${JSON.stringify(d)}`)}else a(`Ignoring ${D} as ${_.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=O;function w(u,D){const y=D.split(".");g(u,y)}e.removeFromValueTree=w;function g(u,D){const y=D.shift();if(D.length===0){delete u[y];return}if(Object.keys(u).indexOf(y)!==-1){const a=u[y];typeof a=="object"&&!Array.isArray(a)&&(g(a,D),Object.keys(a).length===0&&delete u[y])}}function S(u,D,y){function a(d,i){let o=d;for(const n of i){if(typeof o!="object"||o===null)return;o=o[n]}return o}const _=D.split("."),r=a(u,_);return typeof r=="undefined"?y:r}e.getConfigurationValue=S;function f(u,D,y){Object.keys(D).forEach(a=>{a!=="__proto__"&&(a in u?s.isObject(u[a])&&s.isObject(D[a])?f(u[a],D[a],y):y&&(u[a]=D[a]):u[a]=D[a])})}e.merge=f;function c(u,D,y){const a=u.inspect(D),_=u.inspect(y);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof _.userValue!="undefined"||typeof _.workspaceValue!="undefined"||typeof _.workspaceFolderValue!="undefined"?_.value:a.defaultValue}e.getMigratedSettingValue=c;function h(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=h}),define(De[38],Ie([1,0,22,10,3]),function(J,e,s,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const U=new Map;U.set("false",!1),U.set("true",!0),U.set("isMac",s.isMacintosh),U.set("isLinux",s.isLinux),U.set("isWindows",s.isWindows),U.set("isWeb",s.isWeb),U.set("isMacNative",s.isMacintosh&&!s.isWeb),U.set("isEdge",s.isEdge),U.set("isFirefox",s.isFirefox),U.set("isChrome",s.isChrome),U.set("isSafari",s.isSafari);const T=Object.prototype.hasOwnProperty;var P;(function(R){R[R.False=0]="False",R[R.True=1]="True",R[R.Defined=2]="Defined",R[R.Not=3]="Not",R[R.Equals=4]="Equals",R[R.NotEquals=5]="NotEquals",R[R.And=6]="And",R[R.Regex=7]="Regex",R[R.NotRegex=8]="NotRegex",R[R.Or=9]="Or",R[R.In=10]="In",R[R.NotIn=11]="NotIn",R[R.Greater=12]="Greater",R[R.GreaterEquals=13]="GreaterEquals",R[R.Smaller=14]="Smaller",R[R.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return w.INSTANCE}static true(){return g.INSTANCE}static has(E){return S.create(E)}static equals(E,M){return f.create(E,M)}static notEquals(E,M){return u.create(E,M)}static regex(E,M){return i.create(E,M)}static in(E,M){return c.create(E,M)}static not(E){return D.create(E)}static and(...E){return t.create(E,null)}static or(...E){return l.create(E,null,!0)}static greater(E,M){return a.create(E,M)}static greaterEquals(E,M){return _.create(E,M)}static smaller(E,M){return r.create(E,M)}static smallerEquals(E,M){return d.create(E,M)}static deserialize(E,M=!1){if(!!E)return this._deserializeOrExpression(E,M)}static _deserializeOrExpression(E,M){let N=E.split("||");return l.create(N.map(W=>this._deserializeAndExpression(W,M)),null,!0)}static _deserializeAndExpression(E,M){let N=E.split("&&");return t.create(N.map(W=>this._deserializeOne(W,M)),null)}static _deserializeOne(E,M){if(E=E.trim(),E.indexOf("!=")>=0){let N=E.split("!=");return u.create(N[0].trim(),this._deserializeValue(N[1],M))}if(E.indexOf("==")>=0){let N=E.split("==");return f.create(N[0].trim(),this._deserializeValue(N[1],M))}if(E.indexOf("=~")>=0){let N=E.split("=~");return i.create(N[0].trim(),this._deserializeRegexValue(N[1],M))}if(E.indexOf(" in ")>=0){let N=E.split(" in ");return c.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(E)){const N=E.split(">=");return _.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(E)){const N=E.split(">");return a.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(E)){const N=E.split("<=");return d.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(E)){const N=E.split("<");return r.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(E)?D.create(E.substr(1).trim()):S.create(E)}static _deserializeValue(E,M){if(E=E.trim(),E==="true")return!0;if(E==="false")return!1;let N=/^'([^']*)'$/.exec(E);return N?N[1].trim():E}static _deserializeRegexValue(E,M){if((0,C.isFalsyOrWhitespace)(E)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=E.indexOf("/"),W=E.lastIndexOf("/");if(N===W||N<0){if(M)throw new Error(`bad regexp-value '${E}', missing /-enclosure`);return console.warn(`bad regexp-value '${E}', missing /-enclosure`),null}let Z=E.slice(N+1,W),K=E[W+1]==="i"?"i":"";try{return new RegExp(Z,K)}catch(F){if(M)throw new Error(`bad regexp-value '${E}', parse error: ${F}`);return console.warn(`bad regexp-value '${E}', parse error: ${F}`),null}}}e.ContextKeyExpr=b;function A(R,E){const M=R?R.substituteConstants():void 0,N=E?E.substituteConstants():void 0;return!M&&!N?!0:!M||!N?!1:M.equals(N)}e.expressionsAreEqualWithConstantSubstitution=A;function O(R,E){return R.cmp(E)}class w{constructor(){this.type=0}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!1}serialize(){return"false"}keys(){return[]}map(E){return this}negate(){return g.INSTANCE}}e.ContextKeyFalseExpr=w,w.INSTANCE=new w;class g{constructor(){this.type=1}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!0}serialize(){return"true"}keys(){return[]}map(E){return this}negate(){return w.INSTANCE}}e.ContextKeyTrueExpr=g,g.INSTANCE=new g;class S{constructor(E,M){this.key=E,this.negated=M,this.type=2}static create(E,M=null){const N=U.get(E);return typeof N=="boolean"?N?g.INSTANCE:w.INSTANCE:new S(E,M)}cmp(E){return E.type!==this.type?this.type-E.type:m(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=U.get(this.key);return typeof E=="boolean"?E?g.INSTANCE:w.INSTANCE:this}evaluate(E){return!!E.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(E){return E.mapDefined(this.key)}negate(){return this.negated||(this.negated=D.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=S;class f{constructor(E,M,N){this.key=E,this.value=M,this.negated=N,this.type=4}static create(E,M,N=null){if(typeof M=="boolean")return M?S.create(E,N):D.create(E,N);const W=U.get(E);return typeof W=="boolean"?M===(W?"true":"false")?g.INSTANCE:w.INSTANCE:new f(E,M,N)}cmp(E){return E.type!==this.type?this.type-E.type:I(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){const E=U.get(this.key);if(typeof E=="boolean"){const M=E?"true":"false";return this.value===M?g.INSTANCE:w.INSTANCE}return this}evaluate(E){return E.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(E){return E.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=f;class c{constructor(E,M){this.key=E,this.valueKey=M,this.type=10,this.negated=null}static create(E,M){return new c(E,M)}cmp(E){return E.type!==this.type?this.type-E.type:I(this.key,this.valueKey,E.key,E.valueKey)}equals(E){return E.type===this.type?this.key===E.key&&this.valueKey===E.valueKey:!1}substituteConstants(){return this}evaluate(E){const M=E.getValue(this.valueKey),N=E.getValue(this.key);return Array.isArray(M)?M.includes(N):typeof N=="string"&&typeof M=="object"&&M!==null?T.call(M,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(E){return E.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=h.create(this)),this.negated}}e.ContextKeyInExpr=c;class h{constructor(E){this._actual=E,this.type=11}static create(E){return new h(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}substituteConstants(){return this}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new h(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotInExpr=h;class u{constructor(E,M,N){this.key=E,this.value=M,this.negated=N,this.type=5}static create(E,M,N=null){if(typeof M=="boolean")return M?D.create(E,N):S.create(E,N);const W=U.get(E);return typeof W=="boolean"?M===(W?"true":"false")?w.INSTANCE:g.INSTANCE:new u(E,M,N)}cmp(E){return E.type!==this.type?this.type-E.type:I(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){const E=U.get(this.key);if(typeof E=="boolean"){const M=E?"true":"false";return this.value===M?w.INSTANCE:g.INSTANCE}return this}evaluate(E){return E.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(E){return E.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=u;class D{constructor(E,M){this.key=E,this.negated=M,this.type=3}static create(E,M=null){const N=U.get(E);return typeof N=="boolean"?N?w.INSTANCE:g.INSTANCE:new D(E,M)}cmp(E){return E.type!==this.type?this.type-E.type:m(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=U.get(this.key);return typeof E=="boolean"?E?w.INSTANCE:g.INSTANCE:this}evaluate(E){return!E.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(E){return E.mapNot(this.key)}negate(){return this.negated||(this.negated=S.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=D;function y(R,E){if(typeof R=="string"){const M=parseFloat(R);isNaN(M)||(R=M)}return typeof R=="string"||typeof R=="number"?E(R):w.INSTANCE}class a{constructor(E,M,N){this.key=E,this.value=M,this.negated=N,this.type=12}static create(E,M,N=null){return y(M,W=>new a(E,W,N))}cmp(E){return E.type!==this.type?this.type-E.type:I(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=a;class _{constructor(E,M,N){this.key=E,this.value=M,this.negated=N,this.type=13}static create(E,M,N=null){return y(M,W=>new _(E,W,N))}cmp(E){return E.type!==this.type?this.type-E.type:I(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=_;class r{constructor(E,M,N){this.key=E,this.value=M,this.negated=N,this.type=14}static create(E,M,N=null){return y(M,W=>new r(E,W,N))}cmp(E){return E.type!==this.type?this.type-E.type:I(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=_.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=r;class d{constructor(E,M,N){this.key=E,this.value=M,this.negated=N,this.type=15}static create(E,M,N=null){return y(M,W=>new d(E,W,N))}cmp(E){return E.type!==this.type?this.type-E.type:I(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=d;class i{constructor(E,M){this.key=E,this.regexp=M,this.type=7,this.negated=null}static create(E,M){return new i(E,M)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.key<E.key)return-1;if(this.key>E.key)return 1;const M=this.regexp?this.regexp.source:"",N=E.regexp?E.regexp.source:"";return M<N?-1:M>N?1:0}equals(E){if(E.type===this.type){const M=this.regexp?this.regexp.source:"",N=E.regexp?E.regexp.source:"";return this.key===E.key&&M===N}return!1}substituteConstants(){return this}evaluate(E){let M=E.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const E=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${E}`}keys(){return[this.key]}map(E){return E.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=o.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class o{constructor(E){this._actual=E,this.type=8}static create(E){return new o(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}substituteConstants(){return this}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new o(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;function n(R){let E=null;for(let M=0,N=R.length;M<N;M++){const W=R[M].substituteConstants();if(R[M]!==W&&E===null){E=[];for(let Z=0;Z<M;Z++)E[Z]=R[Z]}E!==null&&(E[M]=W)}return E===null?R:E}class t{constructor(E,M){this.expr=E,this.negated=M,this.type=6}static create(E,M){return t._normalizeArr(E,M)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let M=0,N=this.expr.length;M<N;M++){const W=O(this.expr[M],E.expr[M]);if(W!==0)return W}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let M=0,N=this.expr.length;M<N;M++)if(!this.expr[M].equals(E.expr[M]))return!1;return!0}return!1}substituteConstants(){const E=n(this.expr);return E===this.expr?this:t.create(E,this.negated)}evaluate(E){for(let M=0,N=this.expr.length;M<N;M++)if(!this.expr[M].evaluate(E))return!1;return!0}static _normalizeArr(E,M){const N=[];let W=!1;for(const Z of E)if(!!Z){if(Z.type===1){W=!0;continue}if(Z.type===0)return w.INSTANCE;if(Z.type===6){N.push(...Z.expr);continue}N.push(Z)}if(N.length===0&&W)return g.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(O);for(let Z=1;Z<N.length;Z++)N[Z-1].equals(N[Z])&&(N.splice(Z,1),Z--);if(N.length===1)return N[0];for(;N.length>1;){const Z=N[N.length-1];if(Z.type!==9)break;N.pop();const K=N.pop(),F=N.length===0,oe=l.create(Z.expr.map(ce=>t.create([ce,K],null)),null,F);oe&&(N.push(oe),N.sort(O))}return N.length===1?N[0]:new t(N,M)}}serialize(){return this.expr.map(E=>E.serialize()).join(" && ")}keys(){const E=[];for(let M of this.expr)E.push(...M.keys());return E}map(E){return new t(this.expr.map(M=>M.map(E)),null)}negate(){if(!this.negated){const E=[];for(let M of this.expr)E.push(M.negate());this.negated=l.create(E,this,!0)}return this.negated}}class l{constructor(E,M){this.expr=E,this.negated=M,this.type=9}static create(E,M,N){return l._normalizeArr(E,M,N)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let M=0,N=this.expr.length;M<N;M++){const W=O(this.expr[M],E.expr[M]);if(W!==0)return W}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let M=0,N=this.expr.length;M<N;M++)if(!this.expr[M].equals(E.expr[M]))return!1;return!0}return!1}substituteConstants(){const E=n(this.expr);return E===this.expr?this:l.create(E,this.negated,!1)}evaluate(E){for(let M=0,N=this.expr.length;M<N;M++)if(this.expr[M].evaluate(E))return!0;return!1}static _normalizeArr(E,M,N){let W=[],Z=!1;if(E){for(let K=0,F=E.length;K<F;K++){const oe=E[K];if(!!oe){if(oe.type===0){Z=!0;continue}if(oe.type===1)return g.INSTANCE;if(oe.type===9){W=W.concat(oe.expr);continue}W.push(oe)}}if(W.length===0&&Z)return w.INSTANCE;W.sort(O)}if(W.length!==0){if(W.length===1)return W[0];for(let K=1;K<W.length;K++)W[K-1].equals(W[K])&&(W.splice(K,1),K--);if(W.length===1)return W[0];if(N){for(let K=0;K<W.length;K++)for(let F=K+1;F<W.length;F++)B(W[K],W[F])&&(W.splice(F,1),F--);if(W.length===1)return W[0]}return new l(W,M)}}serialize(){return this.expr.map(E=>E.serialize()).join(" || ")}keys(){const E=[];for(let M of this.expr)E.push(...M.keys());return E}map(E){return new l(this.expr.map(M=>M.map(E)),null)}negate(){if(!this.negated){let E=[];for(let M of this.expr)E.push(M.negate());for(;E.length>1;){const M=E.shift(),N=E.shift(),W=[];for(const K of x(M))for(const F of x(N))W.push(t.create([K,F],null));const Z=E.length===0;E.unshift(l.create(W,null,Z))}this.negated=E[0]}return this.negated}}class v extends S{constructor(E,M,N){super(E,null);this._defaultValue=M,typeof N=="object"?v._info.push({...N,key:E}):N!==!0&&v._info.push({key:E,description:N,type:M!=null?typeof M:void 0})}static all(){return v._info.values()}bindTo(E){return E.createKey(this.key,this._defaultValue)}getValue(E){return E.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(E){return f.create(this.key,E)}notEqualsTo(E){return u.create(this.key,E)}}e.RawContextKey=v,v._info=[],e.IContextKeyService=(0,p.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m(R,E){return R<E?-1:R>E?1:0}function I(R,E,M,N){return R<M?-1:R>M?1:E<N?-1:E>N?1:0}function B(R,E){if(E.type===6&&R.type!==9&&R.type!==6){for(const W of E.expr)if(R.equals(W))return!0}const M=R.negate(),N=x(M).concat(x(E));N.sort(O);for(let W=0;W<N.length;W++){const K=N[W].negate();for(let F=W+1;F<N.length;F++){const oe=N[F];if(K.equals(oe))return!0}}return!1}e.implies=B;function x(R){return R.type===9?R.expr:[R]}}),define(De[146],Ie([1,0,3]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,s.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,s.refineServiceDecorator)(e.IEnvironmentService)}),define(De[79],Ie([1,0,123,3]),function(J,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function p(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=p;function U(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=U;function T(u,D){switch(u){case 3:return D==="x64"?"win32-x64":D==="ia32"?"win32-ia32":D==="arm64"?"win32-arm64":"unknown";case 2:return D==="x64"?"linux-x64":D==="arm64"?"linux-arm64":D==="arm"?"linux-armhf":"unknown";case"alpine":return D==="x64"?"alpine-x64":D==="arm64"?"alpine-arm64":"unknown";case 1:return D==="x64"?"darwin-x64":D==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function P(u,D){return D==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function b(u,D,y){return P(D,y)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===y?!0:A(y).includes(u)}e.isTargetPlatformCompatible=b;function A(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=A;function O(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=O;var w;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var g;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(g=e.SortOrder||(e.SortOrder={}));var S;(function(u){u.Install="install",u.Uninstall="uninstall"})(S=e.StatisticType||(e.StatisticType={}));var f;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService");var c;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal"})(c=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class h extends Error{constructor(D,y){super(D);this.code=y,this.name=y}}e.ExtensionManagementError=h,e.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,s.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,s.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,C.createDecorator)("IExtensionManagementCLIService")}),define(De[39],Ie([1,0,11,24,19,10,9,2,125,3]),function(J,e,s,C,p,U,T,P,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,A.createDecorator)("fileService");function O(F){return F.create===!0}e.isFileOpenForWriteOptions=O;var w;(function(F){F[F.Unknown=0]="Unknown",F[F.File=1]="File",F[F.Directory=2]="Directory",F[F.SymbolicLink=64]="SymbolicLink"})(w=e.FileType||(e.FileType={}));var g;(function(F){F[F.Readonly=1]="Readonly"})(g=e.FilePermission||(e.FilePermission={}));var S;(function(F){F[F.FileReadWrite=2]="FileReadWrite",F[F.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",F[F.FileReadStream=16]="FileReadStream",F[F.FileFolderCopy=8]="FileFolderCopy",F[F.PathCaseSensitive=1024]="PathCaseSensitive",F[F.Readonly=2048]="Readonly",F[F.Trash=4096]="Trash",F[F.FileWriteUnlock=8192]="FileWriteUnlock",F[F.FileAtomicRead=16384]="FileAtomicRead",F[F.FileClone=32768]="FileClone"})(S=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(F){return!!(F.capabilities&2)}e.hasReadWriteCapability=f;function c(F){return!!(F.capabilities&8)}e.hasFileFolderCopyCapability=c;function h(F){return!!(F.capabilities&32768)}e.hasFileCloneCapability=h;function u(F){return!!(F.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function D(F){return!!(F.capabilities&16)}e.hasFileReadStreamCapability=D;function y(F){return f(F)?!!(F.capabilities&16384):!1}e.hasFileAtomicReadCapability=y;var a;(function(F){F.FileExists="EntryExists",F.FileNotFound="EntryNotFound",F.FileNotADirectory="EntryNotADirectory",F.FileIsADirectory="EntryIsADirectory",F.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",F.FileTooLarge="EntryTooLarge",F.FileWriteLocked="EntryWriteLocked",F.NoPermissions="NoPermissions",F.Unavailable="Unavailable",F.Unknown="Unknown"})(a=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class _ extends Error{constructor(oe,ce){super(oe);this.code=ce}}e.FileSystemProviderError=_;function r(F,oe){const ce=new _(F.toString(),oe);return i(ce,oe),ce}e.createFileSystemProviderError=r;function d(F){return F||r((0,b.localize)(0,null),a.Unknown)}e.ensureFileSystemProviderError=d;function i(F,oe){return F.name=oe?`${oe} (FileSystemError)`:"FileSystemError",F}e.markAsFileSystemProviderError=i;function o(F){if(!F)return a.Unknown;if(F instanceof _)return F.code;const oe=/^(.+) \(FileSystemError\)$/.exec(F.name);if(!oe)return a.Unknown;switch(oe[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileExceedsMemoryLimit:return a.FileExceedsMemoryLimit;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}e.toFileSystemProviderErrorCode=o;function n(F){if(F instanceof B)return F.fileOperationResult;switch(o(F)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 10;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileExceedsMemoryLimit:return 9;case a.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var t;(function(F){F[F.CREATE=0]="CREATE",F[F.DELETE=1]="DELETE",F[F.MOVE=2]="MOVE",F[F.COPY=3]="COPY",F[F.WRITE=4]="WRITE"})(t=e.FileOperation||(e.FileOperation={}));class l{constructor(oe,ce,ae){this.resource=oe,this.operation=ce,this.target=ae}isOperation(oe){return this.operation===oe}}e.FileOperationEvent=l;var v;(function(F){F[F.UPDATED=0]="UPDATED",F[F.ADDED=1]="ADDED",F[F.DELETED=2]="DELETED"})(v=e.FileChangeType||(e.FileChangeType={}));class m{constructor(oe,ce){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=oe;const ae=new Map;for(const fe of oe){const ie=ae.get(fe.type);switch(ie?ie.push([fe.resource,fe]):ae.set(fe.type,[[fe.resource,fe]]),fe.type){case 1:this.rawAdded.push(fe.resource);break;case 0:this.rawUpdated.push(fe.resource);break;case 2:this.rawDeleted.push(fe.resource);break}}for(const[fe,ie]of ae)switch(fe){case 1:this.added=C.TernarySearchTree.forUris(()=>ce),this.added.fill(ie);break;case 0:this.updated=C.TernarySearchTree.forUris(()=>ce),this.updated.fill(ie);break;case 2:this.deleted=C.TernarySearchTree.forUris(()=>ce),this.deleted.fill(ie);break}}contains(oe,...ce){return this.doContains(oe,{includeChildren:!1},...ce)}affects(oe,...ce){return this.doContains(oe,{includeChildren:!0},...ce)}doContains(oe,ce,...ae){if(!oe)return!1;const fe=ae.length>0;return!!((!fe||ae.includes(1))&&(this.added?.get(oe)||ce.includeChildren&&this.added?.findSuperstr(oe))||(!fe||ae.includes(0))&&(this.updated?.get(oe)||ce.includeChildren&&this.updated?.findSuperstr(oe))||(!fe||ae.includes(2))&&(this.deleted?.findSubstr(oe)||ce.includeChildren&&this.deleted?.findSuperstr(oe)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=m;function I(F,oe,ce){return!F||!oe||F===oe||oe.length>F.length?!1:(oe.charAt(oe.length-1)!==p.sep&&(oe+=p.sep),ce?(0,U.startsWithIgnoreCase)(F,oe):F.indexOf(oe)===0)}e.isParent=I;class B extends s.ErrorNoTelemetry{constructor(oe,ce,ae){super(oe);this.fileOperationResult=ce,this.options=ae}}e.FileOperationError=B;class x extends B{constructor(oe,ce,ae){super(oe,2,ae);this.stat=ce}}e.NotModifiedSinceFileOperationError=x;var R;(function(F){F[F.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",F[F.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",F[F.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",F[F.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",F[F.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",F[F.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",F[F.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",F[F.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",F[F.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",F[F.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",F[F.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",F[F.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(R=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var E;(function(F){F[F.FILE=0]="FILE",F[F.FOLDER=1]="FOLDER",F[F.ROOT_FOLDER=2]="ROOT_FOLDER"})(E=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function M(F){if(!(typeof F.size!="number"||typeof F.mtime!="number"))return F.mtime.toString(29)+F.size.toString(31)}e.etag=M;async function N(F,oe){if(!oe.hasProvider(P.URI.from({scheme:F.scheme})))return new Promise(ce=>{const ae=oe.onDidChangeFileSystemProviderRegistrations(fe=>{fe.scheme===F.scheme&&fe.added&&(ae.dispose(),ce())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class W{static formatSize(oe){return(0,T.isNumber)(oe)||(oe=0),oe<W.KB?(0,b.localize)(1,null,oe.toFixed(0)):oe<W.MB?(0,b.localize)(2,null,(oe/W.KB).toFixed(2)):oe<W.GB?(0,b.localize)(3,null,(oe/W.MB).toFixed(2)):oe<W.TB?(0,b.localize)(4,null,(oe/W.GB).toFixed(2)):(0,b.localize)(5,null,(oe/W.TB).toFixed(2))}}e.ByteSize=W,W.KB=1024,W.MB=W.KB*W.KB,W.GB=W.MB*W.KB,W.TB=W.GB*W.KB;var Z;(function(F){F[F.IA32=0]="IA32",F[F.OTHER=1]="OTHER"})(Z=e.Arch||(e.Arch={}));function K(F){return{maxFileSize:F===0?300*W.MB:16*W.GB,maxHeapSize:F===0?700*W.MB:2*700*W.MB}}e.getPlatformLimits=K}),define(De[60],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class s{constructor(...p){this._entries=new Map;for(let[U,T]of p)this.set(U,T)}set(p,U){const T=this._entries.get(p);return this._entries.set(p,U),T}has(p){return this._entries.has(p)}get(p){return this._entries.get(p)}}e.ServiceCollection=s}),define(De[147],Ie([1,0,13,11,78,145,3,60]),function(J,e,s,C,p,U,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class A extends Error{constructor(f){super("cyclic dependency between services");this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class O{constructor(f=new P.ServiceCollection,c=!1,h){this._activeInstantiations=new Set,this._services=f,this._strict=c,this._parent=h,this._services.set(T.IInstantiationService,this)}createChild(f){return new O(f,this._strict,this)}invokeFunction(f,...c){let h=g.traceInvocation(f),u=!1;try{return f({get:y=>{if(u)throw(0,C.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(y,h);if(!a)throw new Error(`[invokeFunction] unknown service '${y}'`);return a}},...c)}finally{u=!0,h.stop()}}createInstance(f,...c){let h,u;return f instanceof p.SyncDescriptor?(h=g.traceCreation(f.ctor),u=this._createInstance(f.ctor,f.staticArguments.concat(c),h)):(h=g.traceCreation(f),u=this._createInstance(f,c,h)),h.stop(),u}_createInstance(f,c=[],h){let u=T._util.getServiceDependencies(f).sort((a,_)=>a.index-_.index),D=[];for(const a of u){let _=this._getOrCreateServiceInstance(a.id,h);_||this._throwIfStrict(`[createInstance] ${f.name} depends on UNKNOWN service ${a.id}.`,!1),D.push(_)}let y=u.length>0?u[0].index:c.length;if(c.length!==y){console.trace(`[createInstance] First service dependency of ${f.name} at position ${y+1} conflicts with ${c.length} static arguments`);let a=y-c.length;a>0?c=c.concat(new Array(a)):c=c.slice(0,y)}return new f(...[...c,...D])}_setServiceInstance(f,c){if(this._services.get(f)instanceof p.SyncDescriptor)this._services.set(f,c);else if(this._parent)this._parent._setServiceInstance(f,c);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){let c=this._services.get(f);return!c&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):c}_getOrCreateServiceInstance(f,c){let h=this._getServiceInstanceOrDescriptor(f);return h instanceof p.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,h,c.branch(f,!0)):(c.branch(f,!1),h)}_safeCreateAndCacheServiceInstance(f,c,h){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,c,h)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,c,h){const u=new U.Graph(a=>a.id.toString());let D=0;const y=[{id:f,desc:c,_trace:h}];for(;y.length;){const a=y.pop();if(u.lookupOrInsertNode(a),D++>1e3)throw new A(u);for(let _ of T._util.getServiceDependencies(a.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(_.id);if(r||this._throwIfStrict(`[createInstance] ${f} depends on ${_.id} which is NOT registered.`,!0),r instanceof p.SyncDescriptor){const d={id:_.id,desc:r,_trace:a._trace.branch(_.id,!0)};u.insertEdge(a,d),y.push(d)}}}for(;;){const a=u.roots();if(a.length===0){if(!u.isEmpty())throw new A(u);break}for(const{data:_}of a){if(this._getServiceInstanceOrDescriptor(_.id)instanceof p.SyncDescriptor){const d=this._createServiceInstanceWithOwner(_.id,_.desc.ctor,_.desc.staticArguments,_.desc.supportsDelayedInstantiation,_._trace);this._setServiceInstance(_.id,d)}u.removeNode(_)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,c,h=[],u,D){if(this._services.get(f)instanceof p.SyncDescriptor)return this._createServiceInstance(c,h,u,D);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,c,h,u,D);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}_createServiceInstance(f,c=[],h,u){if(h){const D=new s.IdleValue(()=>this._createInstance(f,c,u));return new Proxy(Object.create(null),{get(y,a){if(a in y)return y[a];let _=D.value,r=_[a];return typeof r!="function"||(r=r.bind(_),y[a]=r),r},set(y,a,_){return D.value[a]=_,!0}})}else return this._createInstance(f,c,u)}_throwIfStrict(f,c){if(c&&console.warn(c),this._strict)throw new Error(f)}}e.InstantiationService=O;var w;(function(S){S[S.Creation=0]="Creation",S[S.Invocation=1]="Invocation",S[S.Branch=2]="Branch"})(w||(w={}));class g{constructor(f,c){this.type=f,this.name=c,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return b?new g(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(f){return b?new g(0,f.name):g._None}branch(f,c){let h=new g(2,f.toString());return this._dep.push([f,c,h]),h}stop(){let f=Date.now()-this._start;g._totals+=f;let c=!1;function h(D,y){let a=[],_=new Array(D+1).join("	");for(const[r,d,i]of y._dep)if(d&&i){c=!0,a.push(`${_}CREATES -> ${r}`);let o=h(D+1,i);o&&a.push(o)}else a.push(`${_}uses -> ${r}`);return a.join(`
`)}let u=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(f>2||c)&&console.log(u.join(`
`))}}e.Trace=g,g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(De[14],Ie([1,0,45,5,7,22,3]),function(J,e,s,C,p,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function P(){return new Date().toISOString()}var b;(function(d){d[d.Trace=0]="Trace",d[d.Debug=1]="Debug",d[d.Info=2]="Info",d[d.Warning=3]="Warning",d[d.Error=4]="Error",d[d.Critical=5]="Critical",d[d.Off=6]="Off"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function A(d,i,o){switch(i){case b.Trace:d.trace(o);break;case b.Debug:d.debug(o);break;case b.Info:d.info(o);break;case b.Warning:d.warn(o);break;case b.Error:d.error(o);break;case b.Critical:d.critical(o);break;default:throw new Error("Invalid log level")}}e.log=A;function O(d){let i="";for(let o=0;o<d.length;o++){let n=d[o];if(typeof n=="object")try{n=JSON.stringify(n)}catch{}i+=(o>0?" ":"")+n}return i}e.format=O;class w extends p.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new C.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class g extends w{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...o){this.checkLogLevel(b.Trace)&&this.log(b.Trace,O([i,...o]))}debug(i,...o){this.checkLogLevel(b.Debug)&&this.log(b.Debug,O([i,...o]))}info(i,...o){this.checkLogLevel(b.Info)&&this.log(b.Info,O([i,...o]))}warn(i,...o){this.checkLogLevel(b.Warning)&&this.log(b.Warning,O([i,...o]))}error(i,...o){if(this.checkLogLevel(b.Error))if(i instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=i.stack,this.log(b.Error,O(n))}else this.log(b.Error,O([i,...o]))}critical(i,...o){this.checkLogLevel(b.Critical)&&this.log(b.Critical,O([i,...o]))}flush(){}}e.AbstractMessageLogger=g;class S extends w{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!U.isWindows}trace(i,...o){this.getLevel()<=b.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...o):console.log(`[main ${P()}]`,i,...o))}debug(i,...o){this.getLevel()<=b.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...o):console.log(`[main ${P()}]`,i,...o))}info(i,...o){this.getLevel()<=b.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...o):console.log(`[main ${P()}]`,i,...o))}warn(i,...o){this.getLevel()<=b.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,i,...o):console.warn(`[main ${P()}]`,i,...o))}error(i,...o){this.getLevel()<=b.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,i,...o):console.error(`[main ${P()}]`,i,...o))}critical(i,...o){this.getLevel()<=b.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,i,...o):console.error(`[main ${P()}]`,i,...o))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class f extends w{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...o){this.getLevel()<=b.Trace&&console.log("%cTRACE","color: #888",i,...o)}debug(i,...o){this.getLevel()<=b.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...o)}info(i,...o){this.getLevel()<=b.Info&&console.log("%c INFO","color: #33f",i,...o)}warn(i,...o){this.getLevel()<=b.Warning&&console.log("%c WARN","color: #993",i,...o)}error(i,...o){this.getLevel()<=b.Error&&console.log("%c  ERR","color: #f33",i,...o)}critical(i,...o){this.getLevel()<=b.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...o)}dispose(){}flush(){}}e.ConsoleLogger=f;class c extends w{constructor(i,o=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(o)}trace(i,...o){this.getLevel()<=b.Trace&&this.adapter.log(b.Trace,[this.extractMessage(i),...o])}debug(i,...o){this.getLevel()<=b.Debug&&this.adapter.log(b.Debug,[this.extractMessage(i),...o])}info(i,...o){this.getLevel()<=b.Info&&this.adapter.log(b.Info,[this.extractMessage(i),...o])}warn(i,...o){this.getLevel()<=b.Warning&&this.adapter.log(b.Warning,[this.extractMessage(i),...o])}error(i,...o){this.getLevel()<=b.Error&&this.adapter.log(b.Error,[this.extractMessage(i),...o])}critical(i,...o){this.getLevel()<=b.Critical&&this.adapter.log(b.Critical,[this.extractMessage(i),...o])}extractMessage(i){return typeof i=="string"?i:(0,s.toErrorMessage)(i,this.getLevel()<=b.Trace)}dispose(){}flush(){}}e.AdapterLogger=c;class h extends w{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const o of this.logServices)o.setLevel(i);super.setLevel(i)}trace(i,...o){for(const n of this.logServices)n.trace(i,...o)}debug(i,...o){for(const n of this.logServices)n.debug(i,...o)}info(i,...o){for(const n of this.logServices)n.info(i,...o)}warn(i,...o){for(const n of this.logServices)n.warn(i,...o)}error(i,...o){for(const n of this.logServices)n.error(i,...o)}critical(i,...o){for(const n of this.logServices)n.critical(i,...o)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=h;class u extends p.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...o){this.logger.trace(i,...o)}debug(i,...o){this.logger.debug(i,...o)}info(i,...o){this.logger.info(i,...o)}warn(i,...o){this.logger.warn(i,...o)}error(i,...o){this.logger.error(i,...o)}critical(i,...o){this.logger.critical(i,...o)}flush(){this.logger.flush()}}e.LogService=u;class D extends p.Disposable{constructor(i,o){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(o(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(t=>t.setLevel(n))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,o){let n=this.loggers.get(i.toString());return n||(n=this.doCreateLogger(i,o?.always?b.Trace:this.logLevel,o),this.loggers.set(i.toString(),n),o?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=D;class y{constructor(){this.onDidChangeLogLevel=new C.Emitter().event}setLevel(i){}getLevel(){return b.Info}trace(i,...o){}debug(i,...o){}info(i,...o){}warn(i,...o){}error(i,...o){}critical(i,...o){}dispose(){}flush(){}}e.NullLogService=y;function a(d){if(d.verbose)return b.Trace;if(typeof d.logLevel=="string"){const i=_(d.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function _(d){switch(d){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Critical;case"off":return b.Off}}e.parseLogLevel=_;function r(d){switch(d){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Critical:return"critical";case b.Off:return"off"}}e.LogLevelToString=r}),define(De[80],Ie([1,0,29,126,3]),function(J,e,s,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var U;(function(b){b[b.Unnecessary=1]="Unnecessary",b[b.Deprecated=2]="Deprecated"})(U=e.MarkerTag||(e.MarkerTag={}));var T;(function(b){b[b.Hint=1]="Hint",b[b.Info=2]="Info",b[b.Warning=4]="Warning",b[b.Error=8]="Error"})(T=e.MarkerSeverity||(e.MarkerSeverity={})),function(b){function A(f,c){return c-f}b.compare=A;const O=Object.create(null);O[b.Error]=(0,C.localize)(0,null),O[b.Warning]=(0,C.localize)(1,null),O[b.Info]=(0,C.localize)(2,null);function w(f){return O[f]||""}b.toString=w;function g(f){switch(f){case s.default.Error:return b.Error;case s.default.Warning:return b.Warning;case s.default.Info:return b.Info;case s.default.Ignore:return b.Hint}}b.fromSeverity=g;function S(f){switch(f){case b.Error:return s.default.Error;case b.Warning:return s.default.Warning;case b.Info:return s.default.Info;case b.Hint:return s.default.Ignore}}b.toSeverity=S}(T=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(b){const A="";function O(g){return w(g,!0)}b.makeKey=O;function w(g,S){let f=[A];return g.source?f.push(g.source.replace("\xA6","\\\xA6")):f.push(A),g.code?typeof g.code=="string"?f.push(g.code.replace("\xA6","\\\xA6")):f.push(g.code.value.replace("\xA6","\\\xA6")):f.push(A),g.severity!==void 0&&g.severity!==null?f.push(T.toString(g.severity)):f.push(A),g.message&&S?f.push(g.message.replace("\xA6","\\\xA6")):f.push(A),g.startLineNumber!==void 0&&g.startLineNumber!==null?f.push(g.startLineNumber.toString()):f.push(A),g.startColumn!==void 0&&g.startColumn!==null?f.push(g.startColumn.toString()):f.push(A),g.endLineNumber!==void 0&&g.endLineNumber!==null?f.push(g.endLineNumber.toString()):f.push(A),g.endColumn!==void 0&&g.endColumn!==null?f.push(g.endColumn.toString()):f.push(A),f.push(A),f.join("\xA6")}b.makeKeyOptionalMessage=w})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,p.createDecorator)("markerService")}),define(De[148],Ie([1,0,5,29,3]),function(J,e,s,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=C.default,e.INotificationService=(0,p.createDecorator)("notificationService");var U;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.GLOBAL=1]="GLOBAL"})(U=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var T;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(T=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new b,this.onDidClose=s.Event.None,this.onDidChangeVisibility=s.Event.None}updateSeverity(O){}updateMessage(O){}updateActions(O){}close(){}}e.NoOpNotification=P;class b{infinite(){}done(){}total(O){}worked(O){}}e.NoOpProgress=b}),define(De[81],Ie([1,0,7,10,2,3]),function(J,e,s,C,p,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,U.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return s.Disposable.None},registerValidator(){return s.Disposable.None},registerExternalUriResolver(){return s.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return s.Disposable.None},async open(){return!1},async resolveExternalUri(O){return{resolved:O,dispose(){}}}});function T(O,w){return p.URI.isUri(O)?(0,C.equalsIgnoreCase)(O.scheme,w):(0,C.startsWithIgnoreCase)(O,w+":")}e.matchesScheme=T;function P(O,...w){return w.some(g=>T(O,g))}e.matchesSomeScheme=P;function b(O,w){return O.with({fragment:`${w.startLineNumber},${w.startColumn}${w.endLineNumber?`-${w.endLineNumber}${w.endColumn?`,${w.endColumn}`:""}`:""}`})}e.withSelection=b;function A(O){let w;const g=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(O.fragment);return g&&(w={startLineNumber:parseInt(g[1]),startColumn:g[2]?parseInt(g[2]):1,endLineNumber:g[4]?parseInt(g[4]):void 0,endColumn:g[4]?g[5]?parseInt(g[5]):1:void 0},O=O.with({fragment:""})),{selection:w,uri:O}}e.extractSelection=A}),define(De[149],Ie([1,0,3]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,s.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var $e=this&&this.__decorate||function(J,e,s,C){var p=arguments.length,U=p<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,s):C,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")U=Reflect.decorate(J,e,s,C);else for(var P=J.length-1;P>=0;P--)(T=J[P])&&(U=(p<3?T(U):p>3?T(e,s,U):T(e,s))||U);return p>3&&U&&Object.defineProperty(e,s,U),U},xe=this&&this.__param||function(J,e){return function(s,C){e(s,C,J)}};define(De[150],Ie([1,0,13,20,7,3]),function(J,e,s,C,p,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,U.createDecorator)("progressService");var T;(function(O){O[O.Explorer=1]="Explorer",O[O.Scm=3]="Scm",O[O.Extensions=5]="Extensions",O[O.Window=10]="Window",O[O.Notification=15]="Notification",O[O.Dialog=20]="Dialog"})(T=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(w){this.callback=w}get value(){return this._value}report(w){this._value=w,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let b=class extends p.Disposable{constructor(w,g){super();this.deferred=new s.DeferredPromise,g.withProgress(w,S=>(this.reporter=S,this.lastStep&&S.report(this.lastStep),this.deferred.p)),this._register((0,p.toDisposable)(()=>this.deferred.complete()))}report(w){this.reporter?this.reporter.report(w):this.lastStep=w}};b=$e([xe(1,e.IProgressService)],b),e.UnmanagedProgress=b;class A extends p.Disposable{constructor(w){super();this.progressIndicator=w,this.currentOperationId=0,this.currentOperationDisposables=this._register(new p.DisposableStore)}start(w){this.stop();const g=++this.currentOperationId,S=new C.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{g===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},w),this.currentOperationDisposables.add((0,p.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,p.toDisposable)(()=>S.cancel())),this.currentOperationDisposables.add((0,p.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:g,token:S.token,stop:()=>this.doStop(g),isCurrent:()=>this.currentOperationId===g}}stop(){this.doStop(this.currentOperationId)}doStop(w){this.currentOperationId===w&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=A,e.IEditorProgressService=(0,U.createDecorator)("editorProgressService")}),define(De[30],Ie([1,0,42,9]),function(J,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class p{constructor(){this.data=new Map}add(T,P){s.ok(C.isString(T)),s.ok(C.isObject(P)),s.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,P)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new p}),define(De[82],Ie([1,0,5,30]),function(J,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function p(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class U{constructor(){this._onDidChangeSchema=new s.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(b,A){this.schemasById[p(b)]=A,this._onDidChangeSchema.fire(b)}notifySchemaChanged(b){this._onDidChangeSchema.fire(b)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new U;C.Registry.add(e.Extensions.JSONContribution,T)}),define(De[83],Ie([1,0,15,5,9,122,59,82,30]),function(J,e,s,C,p,U,T,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var A;(function(_){_.Multiline="multilineText",_.Singleline="singlelineText"})(A=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(_){_[_.APPLICATION=1]="APPLICATION",_[_.MACHINE=2]="MACHINE",_[_.WINDOW=3]="WINDOW",_[_.RESOURCE=4]="RESOURCE",_[_.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",_[_.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=b.Registry.as(P.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new C.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new C.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:U.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(r,d=!0){this.registerConfigurations([r],d)}registerConfigurations(r,d=!0){const i=this.doRegisterConfigurations(r,d);w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(r){const d=this.doDeregisterConfigurations(r);w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d})}updateConfigurations({add:r,remove:d}){const i=[];i.push(...this.doDeregisterConfigurations(d)),i.push(...this.doRegisterConfigurations(r,!1)),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,s.distinct)(i)})}registerDefaultConfigurations(r){const d=[],i=[];for(const{overrides:o,source:n}of r)for(const t in o)if(d.push(t),e.OVERRIDE_PROPERTY_REGEX.test(t)){const l=this.configurationDefaultsOverrides.get(t),v=l?.valuesSources??new Map;if(n)for(const x of Object.keys(o[t]))v.set(x,n);const m={...l?.value||{},...o[t]};this.configurationDefaultsOverrides.set(t,{source:n,value:m,valuesSources:v});const I=(0,T.getLanguageTagSettingPlainKey)(t),B={type:"object",default:m,description:U.localize(1,null,I),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:m,source:p.isString(n)?void 0:n,defaultValueSource:n};i.push(...c(t)),this.configurationProperties[t]=B,this.defaultLanguageConfigurationOverridesNode.properties[t]=B}else{this.configurationDefaultsOverrides.set(t,{value:o[t],source:n});const l=this.configurationProperties[t];l&&(this.updatePropertyDefaultValue(t,l),this.updateSchema(t,l))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}deregisterDefaultConfigurations(r){const d=[];for(const{overrides:i,source:o}of r)for(const n in i){const t=this.configurationDefaultsOverrides.get(n),l=p.isString(o)?o:o?.id,v=p.isString(t?.source)?t?.source:t?.source?.id;if(l===v)if(d.push(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const m=this.configurationProperties[n];m&&(this.updatePropertyDefaultValue(n,m),this.updateSchema(n,m))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...r){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(r){for(const d of r)this.overrideIdentifiers.add(d);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(r,d){const i=[];return r.forEach(o=>{i.push(...this.validateAndRegisterProperties(o,d,o.extensionInfo,o.restrictedProperties)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),i}doDeregisterConfigurations(r){const d=[],i=o=>{if(o.properties)for(const n in o.properties){d.push(n);const t=this.configurationProperties[n];t?.policy?.name&&this.policyConfigurations.delete(t.policy.name),delete this.configurationProperties[n],this.removeFromSchema(n,o.properties[n])}o.allOf&&o.allOf.forEach(n=>i(n))};for(const o of r){i(o);const n=this.configurationContributors.indexOf(o);n!==-1&&this.configurationContributors.splice(n,1)}return d}validateAndRegisterProperties(r,d=!0,i,o,n=3){n=p.isUndefinedOrNull(r.scope)?n:r.scope;let t=[],l=r.properties;if(l)for(let m in l){const I=l[m];if(d&&y(m,I)){delete l[m];continue}if(I.source=i,I.defaultDefaultValue=l[m].default,this.updatePropertyDefaultValue(m,I),e.OVERRIDE_PROPERTY_REGEX.test(m)?I.scope=void 0:(I.scope=p.isUndefinedOrNull(I.scope)?n:I.scope,I.restricted=p.isUndefinedOrNull(I.restricted)?!!o?.includes(m):I.restricted),l[m].hasOwnProperty("included")&&!l[m].included){this.excludedConfigurationProperties[m]=l[m],delete l[m];continue}else this.configurationProperties[m]=l[m],l[m].policy?.name&&this.policyConfigurations.set(l[m].policy.name,m);!l[m].deprecationMessage&&l[m].markdownDeprecationMessage&&(l[m].deprecationMessage=l[m].markdownDeprecationMessage),t.push(m)}let v=r.allOf;if(v)for(let m of v)t.push(...this.validateAndRegisterProperties(m,d,i,o,n));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(r){const d=i=>{let o=i.properties;if(o)for(const t in o)this.updateSchema(t,o[t]);let n=i.allOf;n&&n.forEach(d)};d(r)}updateSchema(r,d){switch(e.allSettings.properties[r]=d,d.scope){case 1:e.applicationSettings.properties[r]=d;break;case 2:e.machineSettings.properties[r]=d;break;case 6:e.machineOverridableSettings.properties[r]=d;break;case 3:e.windowSettings.properties[r]=d;break;case 4:e.resourceSettings.properties[r]=d;break;case 5:e.resourceSettings.properties[r]=d,this.resourceLanguageSettingsSchema.properties[r]=d;break}}removeFromSchema(r,d){switch(delete e.allSettings.properties[r],d.scope){case 1:delete e.applicationSettings.properties[r];break;case 2:delete e.machineSettings.properties[r];break;case 6:delete e.machineOverridableSettings.properties[r];break;case 3:delete e.windowSettings.properties[r];break;case 4:case 5:delete e.resourceSettings.properties[r],delete this.resourceLanguageSettingsSchema.properties[r];break}}updateOverridePropertyPatternKey(){for(const r of this.overrideIdentifiers.values()){const d=`[${r}]`,i={type:"object",description:U.localize(2,null),errorMessage:U.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(d,i),e.allSettings.properties[d]=i,e.applicationSettings.properties[d]=i,e.machineSettings.properties[d]=i,e.machineOverridableSettings.properties[d]=i,e.windowSettings.properties[d]=i,e.resourceSettings.properties[d]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const r={type:"object",description:U.localize(4,null),errorMessage:U.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(r,d){const i=this.configurationDefaultsOverrides.get(r);let o=i?.value,n=i?.source;p.isUndefined(o)&&(o=d.defaultDefaultValue,n=void 0),p.isUndefined(o)&&(o=u(d.type)),d.default=o,d.defaultValueSource=n}}const S="\\[([^\\]]+)\\]",f=new RegExp(S,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${S})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function c(_){const r=[];if(e.OVERRIDE_PROPERTY_REGEX.test(_)){let d=f.exec(_);for(;d?.length;){const i=d[1].trim();i&&r.push(i),d=f.exec(_)}}return(0,s.distinct)(r)}e.overrideIdentifiersFromKey=c;function h(_){return _.reduce((r,d)=>`${r}[${d}]`,"")}e.keyFromOverrideIdentifiers=h;function u(_){switch(Array.isArray(_)?_[0]:_){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const D=new g;b.Registry.add(e.Extensions.Configuration,D);function y(_,r){return _.trim()?e.OVERRIDE_PROPERTY_REGEX.test(_)?U.localize(7,null,_):D.getConfigurationProperties()[_]!==void 0?U.localize(8,null,_):r.policy?.name&&D.getPolicyConfigurations().get(r.policy?.name)!==void 0?U.localize(9,null,_,r.policy?.name,D.getPolicyConfigurations().get(r.policy?.name)):null:U.localize(6,null)}e.validateProperty=y;function a(){const _=[],r=D.getConfigurationProperties();for(const d of Object.keys(r))_.push([d,r[d].scope]);return _.push(["launch",4]),_.push(["task",4]),_}e.getScopes=a}),define(De[151],Ie([1,0,15,5,104,7,24,27,9,2,59,83,30]),function(J,e,s,C,p,U,T,P,b,A,O,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class S{constructor(d={},i=[],o=[]){this._contents=d,this._keys=i,this._overrides=o,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(d){return d?(0,O.getConfigurationValue)(this.contents,d):this.contents}getOverrideValue(d,i){const o=this.getContentsForOverrideIdentifer(i);return o?d?(0,O.getConfigurationValue)(o,d):o:void 0}getKeysForOverrideIdentifier(d){const i=[];for(const o of this.overrides)o.identifiers.includes(d)&&i.push(...o.keys);return s.distinct(i)}getAllOverrideIdentifiers(){const d=[];for(const i of this.overrides)d.push(...i.identifiers);return s.distinct(d)}override(d){let i=this.overrideConfigurations.get(d);return i||(i=this.createOverrideConfigurationModel(d),this.overrideConfigurations.set(d,i)),i}merge(...d){const i=P.deepClone(this.contents),o=P.deepClone(this.overrides),n=[...this.keys];for(const t of d){this.mergeContents(i,t.contents);for(const l of t.overrides){const[v]=o.filter(m=>s.equals(m.identifiers,l.identifiers));v?(this.mergeContents(v.contents,l.contents),v.keys.push(...l.keys),v.keys=s.distinct(v.keys)):o.push(P.deepClone(l))}for(const l of t.keys)n.indexOf(l)===-1&&n.push(l)}return new S(i,n,o)}freeze(){return this.frozen=!0,this}clone(){return new S(P.deepClone(this.contents),[...this.keys],P.deepClone(this.overrides))}createOverrideConfigurationModel(d){const i=this.getContentsForOverrideIdentifer(d);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let o={};for(const n of s.distinct([...Object.keys(this.contents),...Object.keys(i)])){let t=this.contents[n],l=i[n];l&&(typeof t=="object"&&typeof l=="object"?(t=P.deepClone(t),this.mergeContents(t,l)):t=l),o[n]=t}return new S(o,this.keys,this.overrides)}mergeContents(d,i){for(const o of Object.keys(i)){if(o in d&&b.isObject(d[o])&&b.isObject(i[o])){this.mergeContents(d[o],i[o]);continue}d[o]=P.deepClone(i[o])}}checkAndFreeze(d){return this.frozen&&!Object.isFrozen(d)?P.deepFreeze(d):d}getContentsForOverrideIdentifer(d){let i=null,o=null;const n=t=>{t&&(o?this.mergeContents(o,t):o=P.deepClone(t))};for(const t of this.overrides)s.equals(t.identifiers,[d])?i=t.contents:t.identifiers.includes(d)&&n(t.contents);return n(i),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(d,i){this.addKey(d),(0,O.addToValueTree)(this.contents,d,i,o=>{throw new Error(o)})}removeValue(d){this.removeKey(d)&&(0,O.removeFromValueTree)(this.contents,d)}addKey(d){let i=this.keys.length;for(let o=0;o<i;o++)d.indexOf(this.keys[o])===0&&(i=o);this.keys.splice(i,1,d)}removeKey(d){let i=this.keys.indexOf(d);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=S;class f{constructor(d){this._name=d,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(d,i){if(!b.isUndefinedOrNull(d)){const o=this.doParseContent(d);this.parseRaw(o,i)}}reparse(d){this._raw&&this.parseRaw(this._raw,d)}parseRaw(d,i){this._raw=d;const{contents:o,keys:n,overrides:t,restricted:l}=this.doParseRaw(d,i);this._configurationModel=new S(o,n,t),this._restrictedConfigurations=l||[]}doParseContent(d){let i={},o=null,n=[],t=[],l=[];function v(I){Array.isArray(n)?n.push(I):o!==null&&(n[o]=I)}let m={onObjectBegin:()=>{let I={};v(I),t.push(n),n=I,o=null},onObjectProperty:I=>{o=I},onObjectEnd:()=>{n=t.pop()},onArrayBegin:()=>{let I=[];v(I),t.push(n),n=I,o=null},onArrayEnd:()=>{n=t.pop()},onLiteralValue:v,onError:(I,B,x)=>{l.push({error:I,offset:B,length:x})}};if(d)try{p.visit(d,m),i=n[0]||{}}catch(I){console.error(`Error while parsing settings file ${this._name}: ${I}`),this._parseErrors=[I]}return i}doParseRaw(d,i){const o=g.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),n=this.filter(d,o,!0,i);d=n.raw;const t=(0,O.toValuesTree)(d,m=>console.error(`Conflict in settings file ${this._name}: ${m}`)),l=Object.keys(d),v=this.toOverrides(d,m=>console.error(`Conflict in settings file ${this._name}: ${m}`));return{contents:t,keys:l,overrides:v,restricted:n.restricted}}filter(d,i,o,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:d,restricted:[]};const t={},l=[];for(let v in d)if(w.OVERRIDE_PROPERTY_REGEX.test(v)&&o){const m=this.filter(d[v],i,!1,n);t[v]=m.raw,l.push(...m.restricted)}else{const m=i[v],I=m?typeof m.scope!="undefined"?m.scope:3:void 0;m?.restricted&&l.push(v),(I===void 0||n.scopes===void 0||n.scopes.includes(I))&&(n.skipRestricted&&m?.restricted||(t[v]=d[v]))}return{raw:t,restricted:l}}toOverrides(d,i){const o=[];for(const n of Object.keys(d))if(w.OVERRIDE_PROPERTY_REGEX.test(n)){const t={};for(const l in d[n])t[l]=d[n][l];o.push({identifiers:(0,w.overrideIdentifiersFromKey)(n),keys:Object.keys(t),contents:(0,O.toValuesTree)(t,i)})}return o}}e.ConfigurationModelParser=f;class c extends U.Disposable{constructor(d,i,o,n){super();this.userSettingsResource=d,this.scopes=i,this.fileService=n,this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(C.Event.any(C.Event.filter(this.fileService.onDidFilesChange,t=>t.contains(this.userSettingsResource)),C.Event.filter(this.fileService.onDidRunOperation,t=>(t.isOperation(0)||t.isOperation(3)||t.isOperation(1)||t.isOperation(4))&&o.isEqual(t.resource,d)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const d=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(d.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new S}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=c;class h{constructor(d,i,o,n=new S,t=new S,l=new T.ResourceMap,v=new S,m=new T.ResourceMap,I=!0){this._defaultConfiguration=d,this._policyConfiguration=i,this._localUserConfiguration=o,this._remoteUserConfiguration=n,this._workspaceConfiguration=t,this._folderConfigurations=l,this._memoryConfiguration=v,this._memoryConfigurationByResource=m,this._freeze=I,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(d,i,o){return this.getConsolidatedConfigurationModel(d,i,o).getValue(d)}updateValue(d,i,o={}){let n;o.resource?(n=this._memoryConfigurationByResource.get(o.resource),n||(n=new S,this._memoryConfigurationByResource.set(o.resource,n))):n=this._memoryConfiguration,i===void 0?n.removeValue(d):n.setValue(d,i),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(d,i,o){const n=this.getConsolidatedConfigurationModel(d,i,o),t=this.getFolderConfigurationModelForResource(i.resource,o),l=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,v=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(d):this._defaultConfiguration.freeze().getValue(d),m=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(d),I=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(d):this.userConfiguration.freeze().getValue(d),B=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(d):this.localUserConfiguration.freeze().getValue(d),x=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(d):this.remoteUserConfiguration.freeze().getValue(d),R=o?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(d):this._workspaceConfiguration.freeze().getValue(d):void 0,E=t?i.overrideIdentifier?t.freeze().override(i.overrideIdentifier).getValue(d):t.freeze().getValue(d):void 0,M=i.overrideIdentifier?l.override(i.overrideIdentifier).getValue(d):l.getValue(d),N=n.getValue(d),W=s.distinct(n.overrides.map(Z=>Z.identifiers).flat()).filter(Z=>n.getOverrideValue(d,Z)!==void 0);return{defaultValue:v,policyValue:m,userValue:I,userLocalValue:B,userRemoteValue:x,workspaceValue:R,workspaceFolderValue:E,memoryValue:M,value:N,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(d),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(d,i.overrideIdentifier):void 0}:void 0,policy:m!==void 0?{value:m}:void 0,user:I!==void 0?{value:this.userConfiguration.freeze().getValue(d),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(d,i.overrideIdentifier):void 0}:void 0,userLocal:B!==void 0?{value:this.localUserConfiguration.freeze().getValue(d),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(d,i.overrideIdentifier):void 0}:void 0,userRemote:x!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(d),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(d,i.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(d),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(d,i.overrideIdentifier):void 0}:void 0,workspaceFolder:E!==void 0?{value:t?.freeze().getValue(d),override:i.overrideIdentifier?t?.freeze().getOverrideValue(d,i.overrideIdentifier):void 0}:void 0,memory:M!==void 0?{value:l.getValue(d),override:i.overrideIdentifier?l.getOverrideValue(d,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:W.length?W:void 0}}keys(d){const i=this.getFolderConfigurationModelForResource(void 0,d);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(d){this._defaultConfiguration=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(d){this._policyConfiguration=d}updateLocalUserConfiguration(d){this._localUserConfiguration=d,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(d){this._remoteUserConfiguration=d,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(d){this._workspaceConfiguration=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(d,i){this._folderConfigurations.set(d,i),this._foldersConsolidatedConfigurations.delete(d)}deleteFolderConfiguration(d){this.folderConfigurations.delete(d),this._foldersConsolidatedConfigurations.delete(d)}compareAndUpdateDefaultConfiguration(d,i){const o=[];if(!i){const{added:n,updated:t,removed:l}=a(this._defaultConfiguration,d);i=[...n,...t,...l]}for(const n of i)for(const t of(0,w.overrideIdentifiersFromKey)(n)){const l=this._defaultConfiguration.getKeysForOverrideIdentifier(t),v=d.getKeysForOverrideIdentifier(t),m=[...v.filter(I=>l.indexOf(I)===-1),...l.filter(I=>v.indexOf(I)===-1),...l.filter(I=>!P.equals(this._defaultConfiguration.override(t).getValue(I),d.override(t).getValue(I)))];o.push([t,m])}return this.updateDefaultConfiguration(d),{keys:i,overrides:o}}compareAndUpdatePolicyConfiguration(d){const{added:i,updated:o,removed:n}=a(this._policyConfiguration,d),t=[...i,...o,...n];return t.length&&this.updatePolicyConfiguration(d),{keys:t,overrides:[]}}compareAndUpdateLocalUserConfiguration(d){const{added:i,updated:o,removed:n,overrides:t}=a(this.localUserConfiguration,d),l=[...i,...o,...n];return l.length&&this.updateLocalUserConfiguration(d),{keys:l,overrides:t}}compareAndUpdateRemoteUserConfiguration(d){const{added:i,updated:o,removed:n,overrides:t}=a(this.remoteUserConfiguration,d);let l=[...i,...o,...n];return l.length&&this.updateRemoteUserConfiguration(d),{keys:l,overrides:t}}compareAndUpdateWorkspaceConfiguration(d){const{added:i,updated:o,removed:n,overrides:t}=a(this.workspaceConfiguration,d);let l=[...i,...o,...n];return l.length&&this.updateWorkspaceConfiguration(d),{keys:l,overrides:t}}compareAndUpdateFolderConfiguration(d,i){const o=this.folderConfigurations.get(d),{added:n,updated:t,removed:l,overrides:v}=a(o,i);let m=[...n,...t,...l];return(m.length||!o)&&this.updateFolderConfiguration(d,i),{keys:m,overrides:v}}compareAndDeleteFolderConfiguration(d){const i=this.folderConfigurations.get(d);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(d);const{added:o,updated:n,removed:t,overrides:l}=a(i,void 0);return{keys:[...o,...n,...t],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(d,i,o){let n=this.getConsolidatedConfigurationModelForResource(i,o);return i.overrideIdentifier&&(n=n.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(d)!==void 0&&(n=n.merge(this._policyConfiguration)),n}getConsolidatedConfigurationModelForResource({resource:d},i){let o=this.getWorkspaceConsolidatedConfiguration();if(i&&d){const n=i.getFolder(d);n&&(o=this.getFolderConsolidatedConfiguration(n.uri)||o);const t=this._memoryConfigurationByResource.get(d);t&&(o=o.merge(t))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(d){let i=this._foldersConsolidatedConfigurations.get(d);if(!i){const o=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(d);n?(i=o.merge(n),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(d,i)):i=o}return i}getFolderConfigurationModelForResource(d,i){if(i&&d){const o=i.getFolder(d);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((d,i)=>{const{contents:o,overrides:n,keys:t}=this._folderConfigurations.get(i);return d.push([i,{contents:o,overrides:n,keys:t}]),d},[])}}allKeys(){const d=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>d.add(i)),this.userConfiguration.freeze().keys.forEach(i=>d.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>d.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(o=>d.add(o))),[...d.values()]}allOverrideIdentifiers(){const d=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>d.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>d.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>d.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(o=>d.add(o))),[...d.values()]}getAllKeysForOverrideIdentifier(d){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(d).forEach(o=>i.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(d).forEach(o=>i.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(d).forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(d).forEach(n=>i.add(n))),[...i.values()]}static parse(d){const i=this.parseConfigurationModel(d.defaults),o=this.parseConfigurationModel(d.policy),n=this.parseConfigurationModel(d.user),t=this.parseConfigurationModel(d.workspace),l=d.folders.reduce((v,m)=>(v.set(A.URI.revive(m[0]),this.parseConfigurationModel(m[1])),v),new T.ResourceMap);return new h(i,o,n,new S,t,l,new S,new T.ResourceMap,!1)}static parseConfigurationModel(d){return new S(d.contents,d.keys,d.overrides).freeze()}}e.Configuration=h;function u(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const d=new Set,i=new Map;for(const n of r)n.keys.forEach(t=>d.add(t)),n.overrides.forEach(([t,l])=>{const v=(0,T.getOrSet)(i,t,new Set);l.forEach(m=>v.add(m))});const o=[];return i.forEach((n,t)=>o.push([t,[...n.values()]])),{keys:[...d.values()],overrides:o}}e.mergeChanges=u;class D{constructor(d,i,o,n){this.change=d,this.previous=i,this.currentConfiguraiton=o,this.currentWorkspace=n,this._previousConfiguration=void 0;const t=new Set;d.keys.forEach(v=>t.add(v)),d.overrides.forEach(([,v])=>v.forEach(m=>t.add(m))),this.affectedKeys=[...t.values()];const l=new S;this.affectedKeys.forEach(v=>l.setValue(v,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=h.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(d,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,d)){if(i){const o=this.previousConfiguration?this.previousConfiguration.getValue(d,i,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(d,i,this.currentWorkspace);return!P.equals(o,n)}return!0}return!1}doesAffectedKeysTreeContains(d,i){let o=(0,O.toValuesTree)({[i]:!0},()=>{}),n;for(;typeof o=="object"&&(n=Object.keys(o)[0]);){if(d=d[n],!d)return!1;o=o[n]}return!0}}e.ConfigurationChangeEvent=D;class y extends D{constructor(d,i,o,n){super({keys:d.allKeys(),overrides:[]},void 0,d,i);this.source=o,this.sourceConfig=n}}e.AllKeysConfigurationChangeEvent=y;function a(r,d){const{added:i,removed:o,updated:n}=_(d,r),t=[],l=r?.getAllOverrideIdentifiers()||[],v=d?.getAllOverrideIdentifiers()||[];if(d){const m=v.filter(I=>!l.includes(I));for(const I of m)t.push([I,d.getKeysForOverrideIdentifier(I)])}if(r){const m=l.filter(I=>!v.includes(I));for(const I of m)t.push([I,r.getKeysForOverrideIdentifier(I)])}if(d&&r){for(const m of l)if(v.includes(m)){const I=_({contents:r.getOverrideValue(void 0,m)||{},keys:r.getKeysForOverrideIdentifier(m)},{contents:d.getOverrideValue(void 0,m)||{},keys:d.getKeysForOverrideIdentifier(m)});t.push([m,[...I.added,...I.removed,...I.updated]])}}return{added:i,removed:o,updated:n,overrides:t}}function _(r,d){const i=r?d?r.keys.filter(t=>d.keys.indexOf(t)===-1):[...r.keys]:[],o=d?r?d.keys.filter(t=>r.keys.indexOf(t)===-1):[...d.keys]:[],n=[];if(r&&d){for(const t of d.keys)if(r.keys.indexOf(t)!==-1){const l=(0,O.getConfigurationValue)(d.contents,t),v=(0,O.getConfigurationValue)(r.contents,t);P.equals(l,v)||n.push(t)}}return{added:i,removed:o,updated:n}}}),define(De[84],Ie([1,0,11,3]),function(J,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,C.createDecorator)("remoteAuthorityResolverService");var p;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(p=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class U extends s.ErrorNoTelemetry{constructor(P,b=p.Unknown,A){super(P);this._message=P,this._code=b,this._detail=A,this.isHandled=b===p.NotAvailable&&A===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,U.prototype)}static isTemporarilyNotAvailable(P){return P instanceof U&&P._code===p.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof U&&P._code===p.NoResolverFound}static isHandled(P){return P instanceof U&&P.isHandled}}e.RemoteAuthorityResolverError=U}),define(De[85],Ie([1,0,12]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function C(T){return T.scheme===s.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=C;function p(T){if(!T)return;const P=T.indexOf("+");return P<0?T:T.substr(0,P)}e.getRemoteName=p;function U(T){return`/${T.quality??"oss"}-${T.commit??"dev"}`}e.getRemoteServerRootPath=U}),define(De[25],Ie([1,0,10,3,85]),function(J,e,s,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function U(S){if(typeof S=="object"&&S!==null&&S.supported!==!0)return S.description}e.getWorkspaceSupportTypeMessage=U;function T(S){return S&&typeof S=="object"&&typeof S.id=="string"&&(!S.uuid||typeof S.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(S){S[S.System=0]="System",S[S.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var b;(function(S){S.WIN32_X64="win32-x64",S.WIN32_IA32="win32-ia32",S.WIN32_ARM64="win32-arm64",S.LINUX_X64="linux-x64",S.LINUX_ARM64="linux-arm64",S.LINUX_ARMHF="linux-armhf",S.ALPINE_X64="alpine-x64",S.ALPINE_ARM64="alpine-arm64",S.DARWIN_X64="darwin-x64",S.DARWIN_ARM64="darwin-arm64",S.WEB="web",S.UNIVERSAL="universal",S.UNKNOWN="unknown",S.UNDEFINED="undefined"})(b=e.TargetPlatform||(e.TargetPlatform={}));class A{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,c){if(typeof f=="undefined"||f===null)return typeof c=="undefined"||c===null;if(typeof c=="undefined"||c===null)return!1;if(typeof f=="string"||typeof c=="string"){let h=typeof f=="string"?f:f.value,u=typeof c=="string"?c:c.value;return s.equalsIgnoreCase(h,u)}return f._lower===c._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.ExtensionIdentifier=A;function O(S){return S.contributes&&S.contributes.localizations?S.contributes.localizations.length>0:!1}e.isLanguagePackExtension=O;function w(S){return S.contributes&&S.contributes.authentication?S.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=w;function g(S,f){if(f){const c=`onResolveRemoteAuthority:${(0,p.getRemoteName)(f)}`;return S.activationEvents?.indexOf(c)!==-1}return!1}e.isResolverExtension=g,e.IBuiltinExtensionsScannerService=(0,C.createDecorator)("IBuiltinExtensionsScannerService")}),define(De[152],Ie([1,0,10,79,25,22,2,11,61]),function(J,e,s,C,p,U,T,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function A(i,o){return i.uuid&&o.uuid?i.uuid===o.uuid:i.id===o.id?!0:(0,s.compareIgnoreCase)(i.id,o.id)===0}e.areSameExtensions=A;const O=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{constructor(o,n,t="undefined"){this.version=n,this.targetPlatform=t,this.id=o.id}static create(o){const n=o.manifest?o.manifest.version:o.version,t=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new w(o.identifier,n,t)}static parse(o){const n=O.exec(o);return n&&n[1]&&n[2]?new w({id:n[1]},n[2],n[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof w?A(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.ExtensionKey=w;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(i){const o=g.exec(i);return o&&o[1]?[c(o[1]),o[2]]:[c(i),void 0]}e.getIdAndVersion=S;function f(i,o){return`${i}.${o}`}e.getExtensionId=f;function c(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=c;function h(i,o){return c(f(i,o))}e.getGalleryExtensionId=h;function u(i,o){const n=[],t=l=>{for(const v of n)if(v.some(m=>A(o(m),o(l))))return v;return null};for(const l of i){const v=t(l);v?v.push(l):n.push([l])}return n}e.groupByExtension=u;function D(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=D;function y(i){return{id:i.identifier.id,name:i.name,galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),...i.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new p.ExtensionIdentifier("pprice.better-merge");function a(i){const o=new Set;if(i.malicious)for(const n of i.malicious)o.add(n.id);return o}e.getMaliciousExtensionsSet=a;function _(i,o){const n=[],t=o.manifest.extensionDependencies?.slice(0)??[];for(;t.length;){const l=t.shift();if(l&&n.every(v=>!A(v.identifier,{id:l}))){const v=i.filter(m=>A(m.identifier,{id:l}));v.length===1&&(n.push(v[0]),t.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=_;async function r(i,o){if(!U.isLinux)return!1;let n;try{n=(await i.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await i.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){o.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(l))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=r;async function d(i,o){const n=await r(i,o),t=(0,C.getTargetPlatform)(n?"alpine":U.platform,b.arch);return o.debug("ComputeTargetPlatform:",t),t}e.computeTargetPlatform=d}),define(De[153],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class s{constructor(p){this._callback=p,this._terminalBufferMap=new Map}dispose(){for(const p of this._terminalBufferMap.values())p.dispose()}startBuffering(p,U,T=5){let P;return P=U(b=>{const A=typeof b=="string"?b:b.data;let O=this._terminalBufferMap.get(p);if(O){O.data.push(A);return}const w=setTimeout(()=>this.flushBuffer(p),T);O={data:[A],timeoutId:w,dispose:()=>{clearTimeout(w),this.flushBuffer(p),P.dispose()}},this._terminalBufferMap.set(p,O)}),P}stopBuffering(p){const U=this._terminalBufferMap.get(p);U&&U.dispose()}flushBuffer(p){const U=this._terminalBufferMap.get(p);U&&(this._terminalBufferMap.delete(p),this._callback(p,U.data.join("")))}}e.TerminalDataBufferer=s}),define(De[154],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var s;(function(U){U.DARK="dark",U.LIGHT="light",U.HIGH_CONTRAST_DARK="hcDark",U.HIGH_CONTRAST_LIGHT="hcLight"})(s=e.ColorScheme||(e.ColorScheme={}));function C(U){return U===s.HIGH_CONTRAST_DARK||U===s.HIGH_CONTRAST_LIGHT}e.isHighContrast=C;function p(U){return U===s.DARK||U===s.HIGH_CONTRAST_DARK}e.isDark=p}),define(De[62],Ie([1,0,110,5,7,3,30,154]),function(J,e,s,C,p,U,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,U.createDecorator)("themeService");var b;(function(h){function u(D){return D&&typeof D=="object"&&typeof D.id=="string"}h.isThemeColor=u})(b=e.ThemeColor||(e.ThemeColor={}));function A(h){return{id:h}}e.themeColorFromId=A;var O;(function(h){function u(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color=="undefined"||b.isThemeColor(o.color))}h.isThemeIcon=u;const D=new RegExp(`^\\$\\((${s.CSSIcon.iconNameExpression}(?:${s.CSSIcon.iconModifierExpression})?)\\)$`);function y(o){const n=D.exec(o);if(!n)return;let[,t]=n;return{id:t}}h.fromString=y;function a(o){return{id:o}}h.fromId=a;function _(o,n){let t=o.id;const l=t.lastIndexOf("~");return l!==-1&&(t=t.substring(0,l)),n&&(t=`${t}~${n}`),{id:t}}h.modify=_;function r(o){const n=o.id.lastIndexOf("~");if(n!==-1)return o.id.substring(n+1)}h.getModifier=r;function d(o,n){return o.id===n.id&&o.color?.id===n.color?.id}h.isEqual=d;function i(o,n){return{id:o.id,color:n?A(n):void 0}}h.asThemeIcon=i,h.asClassNameArray=s.CSSIcon.asClassNameArray,h.asClassName=s.CSSIcon.asClassName,h.asCSSSelector=s.CSSIcon.asCSSSelector})(O=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=s.Codicon.file,e.FolderThemeIcon=s.Codicon.folder;function w(h){switch(h){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case P.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=w,e.Extensions={ThemingContribution:"base.contributions.theming"};class g{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new C.Emitter}onColorThemeChange(u){return this.themingParticipants.push(u),this.onThemingParticipantAddedEmitter.fire(u),(0,p.toDisposable)(()=>{const D=this.themingParticipants.indexOf(u);this.themingParticipants.splice(D,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let S=new g;T.Registry.add(e.Extensions.ThemingContribution,S);function f(h){return S.onColorThemeChange(h)}e.registerThemingParticipant=f;class c extends p.Disposable{constructor(u){super();this.themeService=u,this.theme=u.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(D=>this.onThemeChange(D)))}onThemeChange(u){this.theme=u,this.updateStyles()}updateStyles(){}getColor(u,D){let y=this.theme.getColor(u);return y&&D&&(y=D(y,this.theme)),y?y.toString():null}}e.Themable=c}),define(De[155],Ie([1,0,5,22,3,14]),function(J,e,s,C,p,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,p.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,p.createDecorator)("sharedTunnelsService");var T;(function(f){f.Http="http",f.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var b;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(b=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function A(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!c)return{address:c[1],port:+c[2]}}e.extractLocalHostUriMetaDataForPortMapping=A,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function O(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=O,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=w;function g(f,c){return c?c!==1&&f<1024:!C.isWindows&&f<1024}e.isPortPrivileged=g;let S=class{constructor(c){this.logService=c,this._onTunnelOpened=new s.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new s.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new s.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(c){return this._tunnelProvider=c,c?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this._canElevate=c.elevation,this._privacyOptions=c.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const c=[],h=Array.from(this._tunnels.values());for(let u of h){const D=Array.from(u.values());for(let y of D){const a=await y.value;a&&c.push(a)}}return c}async dispose(){for(const c of this._tunnels.values()){for(const{value:h}of c.values())await h.then(u=>u?.dispose());c.clear()}this._tunnels.clear()}openTunnel(c,h,u,D,y=!1,a,_){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${u} on local port ${D}.`),!c)return;if(h||(h="localhost"),this._tunnelProvider&&this._factoryInProgress.has(u)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.retainOrCreateTunnel(c,h,u,D,y,a,_);return r?r.then(d=>{if(!d){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(h,u);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(d);return(d.tunnelRemoteHost!==h||d.tunnelRemotePort!==u)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const h=this._tunnels.get(c.tunnelRemoteHost);if(h){const u=h.get(c.tunnelRemotePort);u&&(u.refcount--,await this.tryDisposeTunnel(c.tunnelRemoteHost,c.tunnelRemotePort,u))}}}}async tryDisposeTunnel(c,h,u){if(u.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${h}.`);const D=u.value.then(async y=>{y&&(await y.dispose(!0),this._onTunnelClosed.fire({host:y.tunnelRemoteHost,port:y.tunnelRemotePort}))});return this._tunnels.has(c)&&this._tunnels.get(c).delete(h),D}}async closeTunnel(c,h){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${h} `);const u=this._tunnels.get(c);if(u&&u.has(h)){const D=u.get(h);D.refcount=0,await this.tryDisposeTunnel(c,h,D)}}addTunnelToMap(c,h,u){this._tunnels.has(c)||this._tunnels.set(c,new Map),this._tunnels.get(c).set(h,{refcount:1,value:u})}async removeEmptyTunnelFromMap(c,h){const u=this._tunnels.get(c);u&&(await u.get(h)||u.delete(h),u.size===0&&this._tunnels.delete(c))}getTunnelFromMap(c,h){let u=[c];O(c)?(u.push(...e.LOCALHOST_ADDRESSES),u.push(...e.ALL_INTERFACES_ADDRESSES)):w(c)&&u.push(...e.ALL_INTERFACES_ADDRESSES);const D=u.map(y=>this._tunnels.get(y));for(const y of D){const a=y?.get(h);if(a)return a}}canTunnel(c){return!!A(c)}createWithProvider(c,h,u,D,y,a,_){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${u} on local port ${D}.`);const r=u;this._factoryInProgress.add(r);const i={elevationRequired:y?g(D===void 0?u:D):!1},o={remoteAddress:{host:h,port:u},localAddressPort:D,privacy:a,public:a?a!==P.Private:void 0,protocol:_},n=c.forwardPort(o,i);return n?(this.addTunnelToMap(h,u,n),n.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(r)})):this._factoryInProgress.delete(r),n}};S=$e([xe(0,U.ILogService)],S),e.AbstractTunnelService=S}),define(De[156],Ie([1,0,12]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function C(b){return b.scheme!==s.Schemas.file&&b.scheme!==s.Schemas.vscodeRemote}e.isVirtualResource=C;function p(b){if(b.folders.length)return b.folders.every(A=>C(A.uri))?b.folders[0].uri:void 0;if(b.configuration&&C(b.configuration))return b.configuration}e.getVirtualWorkspaceLocation=p;function U(b){return p(b)?.scheme}e.getVirtualWorkspaceScheme=U;function T(b){return p(b)?.authority}e.getVirtualWorkspaceAuthority=T;function P(b){return p(b)!==void 0}e.isVirtualWorkspace=P}),define(De[46],Ie([1,0,127,19,24,21,2,3,12]),function(J,e,s,C,p,U,T,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function A(i){const o=i;return typeof o?.id=="string"&&T.URI.isUri(o.uri)}e.isSingleFolderWorkspaceIdentifier=A;function O(i){if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=O;function w(i){const o=i;return typeof o?.id=="string"&&T.URI.isUri(o.configPath)}e.isWorkspaceIdentifier=w;function g(i){const o=i;if(o?.uri)return{id:o.id,uri:T.URI.revive(o.uri)};const n=i;if(n?.configPath)return{id:n.id,configPath:T.URI.revive(n.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=g;var S;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(S=e.WorkbenchState||(e.WorkbenchState={}));function f(i){const o=i;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.isWorkspace=f;function c(i){const o=i;return!!(o&&typeof o=="object"&&T.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.isWorkspaceFolder=c;class h{constructor(o,n,t,l,v){this._id=o,this._transient=t,this._configuration=l,this._ignorePathCasing=v,this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=n}update(o){this._id=o.id,this._configuration=o.configuration,this._transient=o.transient,this._ignorePathCasing=o._ignorePathCasing,this.folders=o.folders}get folders(){return this._folders}set folders(o){this._folders=o,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(o){this._configuration=o}getFolder(o){return o&&this._foldersMap.findSubstr(o)||null}updateFoldersMap(){this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const o of this.folders)this._foldersMap.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class u{constructor(o,n){this.raw=n,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,U.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=u;function D(i){return new u({uri:i,index:0,name:(0,U.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=D,e.WORKSPACE_EXTENSION="code-workspace";const y=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,s.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function a(i,o){return U.extUriBiasedIgnorePathCase.isEqualOrParent(i,o.untitledWorkspacesHome)}e.isUntitledWorkspace=a;function _(i){let o;return T.URI.isUri(i)?o=i:o=i.configuration,o?.scheme===b.Schemas.tmp}e.isTemporaryWorkspace=_;function r(i,o){return!a(i,o)&&!_(i)}e.isSavedWorkspace=r;function d(i){return(typeof i=="string"?(0,C.extname)(i):(0,U.extname)(i))===y}e.hasWorkspaceFileExtension=d}),define(De[63],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class s{constructor(p){this.id=p,this._data=new Map,this._idPool=1}add(p){const U=this._idPool++;return this._data.set(U,p),this.logDebugInfo(),U}get(p,U){return this._data.has(p)?this._data.get(p)[U]:void 0}delete(p){this._data.delete(p),this.logDebugInfo()}logDebugInfo(){!s.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=s,s.enableDebugLogging=!1}),define(De[35],Ie([1,0,12,21,3]),function(J,e,s,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class U{constructor(){this._systemSchemes=new Set(Object.keys(s.Schemas)),this._providerInfo=new Map,this.extUri=new C.ExtUri(P=>{const b=this._providerInfo.get(P.scheme);return!(b===void 0||b&1024)})}$acceptProviderInfos(P,b){b===null?this._providerInfo.delete(P.scheme):this._providerInfo.set(P.scheme,b)}isFreeScheme(P){return!this._providerInfo.has(P)&&!this._systemSchemes.has(P)}getCapabilities(P){return this._providerInfo.get(P)}}e.ExtHostFileSystemInfo=U,e.IExtHostFileSystemInfo=(0,p.createDecorator)("IExtHostFileSystemInfo")}),define(De[28],Ie([1,0,3]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,s.createDecorator)("IExtHostInitDataService")}),define(De[157],Ie([1,0,13]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class C{constructor(T,P,b){this._deferredPromises=new Map,this._id=T,this._shared=P,this._storage=b,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(A=>(this._value=A,this)),this._storageListener=this._storage.onDidChangeStorage(A=>{A.shared===this._shared&&A.key===this._id&&(this._value=A.value)}),this._scheduler=new s.RunOnceScheduler(()=>{const A=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const O of A.values())O.complete()}catch(O){for(const w of A.values())w.error(O)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this._init}get(T,P){let b=this._value[T];return typeof b=="undefined"&&(b=P),b}update(T,P){this._value[T]=P;let b=this._deferredPromises.get(T);if(b!==void 0)return b.p;const A=new s.DeferredPromise;return this._deferredPromises.set(T,A),this._scheduler.isScheduled()||this._scheduler.schedule(),A.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=C;class p extends C{constructor(T,P){super(T.identifier.value,!0,P);this._extension=T}setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}}e.ExtensionGlobalMemento=p}),define(De[158],Ie([1,0,5,2]),function(J,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class p{constructor(T){this._notebooksAndEditors=T,this._onDidSaveNotebookDocument=new s.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new s.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(T,P,b,A){const w=this._notebooksAndEditors.getNotebookDocument(C.URI.revive(T)).acceptModelChanged(P.value,b,A);this._onDidChangeNotebookDocument.fire(w)}$acceptDirtyStateChanged(T,P){this._notebooksAndEditors.getNotebookDocument(C.URI.revive(T)).acceptDirty(P)}$acceptModelSaved(T){const P=this._notebooksAndEditors.getNotebookDocument(C.URI.revive(T));this._onDidSaveNotebookDocument.fire(P.apiNotebook)}}e.ExtHostNotebookDocuments=p}),define(De[16],Ie([1,0,3]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,s.createDecorator)("IExtHostRpcService");class C{constructor(U){this.getProxy=U.getProxy.bind(U),this.set=U.set.bind(U),this.dispose=U.dispose.bind(U),this.assertRegistered=U.assertRegistered.bind(U),this.drain=U.drain.bind(U)}}e.ExtHostRpcService=C});var Ye=this&&this.__classPrivateFieldSet||function(J,e,s,C,p){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?p.call(J,s):p?p.value=s:e.set(J,s),s},Ae=this&&this.__classPrivateFieldGet||function(J,e,s,C){if(s==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?C:s==="a"?C.call(J):C?C.value:e.get(J)};define(De[159],Ie([1,0,25,5]),function(J,e,s,C){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class U{constructor(P,b){p.set(this,void 0),this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this._id=s.ExtensionIdentifier.toKey(P.identifier),Ye(this,p,b,"f"),Ae(this,p,"f").onDidChangePassword(A=>{A.extensionId===this._id&&this._onDidChange.fire({key:A.key})})}get(P){return Ae(this,p,"f").get(this._id,P)}store(P,b){return Ae(this,p,"f").store(this._id,P,b)}delete(P){return Ae(this,p,"f").delete(this._id,P)}}e.ExtensionSecrets=U,p=new WeakMap}),define(De[86],Ie([1,0,3,5]),function(J,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class p{constructor(){this._onDidChangeTelemetryEnabled=new C.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new C.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(T,P){this._level=T,this._productConfig=P||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(T){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=T,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=p,e.IExtHostTelemetry=(0,s.createDecorator)("IExtHostTelemetry")}),define(De[64],Ie([1,0,3,155,5,16]),function(J,e,s,C,p,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var T;(function(b){function A(w){return{remoteAddress:w.remoteAddress,localAddress:w.localAddress,public:!!w.public,privacy:w.privacy??(w.public?C.TunnelPrivacyId.Public:C.TunnelPrivacyId.Private),protocol:w.protocol}}b.fromApiTunnel=A;function O(w){return{remoteAddress:{host:w.tunnelRemoteHost,port:w.tunnelRemotePort},localAddress:w.localAddress,public:w.privacy!==C.TunnelPrivacyId.ConstantPrivate&&w.privacy!==C.TunnelPrivacyId.ConstantPrivate,privacy:w.privacy,protocol:w.protocol}}b.fromServiceTunnel=O})(T=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,s.createDecorator)("IExtHostTunnelService");let P=class{constructor(A){this.onDidChangeTunnels=new p.Emitter().event}async $applyCandidateFilter(A){return A}async openTunnel(A,O){}async getTunnels(){return[]}async setTunnelFactory(A){return{dispose:()=>{}}}registerPortsAttributesProvider(A,O){return{dispose:()=>{}}}async $providePortAttributes(A,O,w,g,S){return[]}async $forwardPort(A,O){}async $closeTunnel(A){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};P=$e([xe(0,U.IExtHostRpcService)],P),e.ExtHostTunnelService=P});var Ye=this&&this.__classPrivateFieldSet||function(J,e,s,C,p){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?p.call(J,s):p?p.value=s:e.set(J,s),s},Ae=this&&this.__classPrivateFieldGet||function(J,e,s,C){if(s==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?C:s==="a"?C.call(J):C?C.value:e.get(J)};define(De[6],Ie([1,0,15,11,75,24,74,10,9,2,44,39,84]),function(J,e,s,C,p,U,T,P,b,A,O,w,g){"use strict";var S,f,c,h,u,D,y,a,_,r,d,i,o,n,t,l,v,m,I,B,x,R;Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function E($){function L(){return Reflect.construct($,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor($,"name")),Object.setPrototypeOf(L,$),Object.setPrototypeOf(L.prototype,$.prototype),L}let M=D=class{constructor(L){S.set(this,void 0),Ye(this,S,L,"f")}static from(...L){let te=L;return new D(function(){if(te){for(const _e of te)_e&&typeof _e.dispose=="function"&&_e.dispose();te=void 0}})}dispose(){typeof Ae(this,S,"f")=="function"&&(Ae(this,S,"f").call(this),Ye(this,S,void 0,"f"))}};S=new WeakMap,M=D=$e([E],M),e.Disposable=M;let N=y=class{constructor(L,te){if(L<0)throw(0,C.illegalArgument)("line must be non-negative");if(te<0)throw(0,C.illegalArgument)("character must be non-negative");this._line=L,this._character=te}static Min(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let _e=1;_e<L.length;_e++){const je=L[_e];je.isBefore(te)&&(te=je)}return te}static Max(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let _e=1;_e<L.length;_e++){const je=L[_e];je.isAfter(te)&&(te=je)}return te}static isPosition(L){if(!L)return!1;if(L instanceof y)return!0;let{line:te,character:_e}=L;return typeof te=="number"&&typeof _e=="number"}static of(L){if(L instanceof y)return L;if(this.isPosition(L))return new y(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,te=0){if(L===null||te===null)throw(0,C.illegalArgument)();let _e;return typeof L=="undefined"?_e=0:typeof L=="number"?_e=L:(_e=typeof L.lineDelta=="number"?L.lineDelta:0,te=typeof L.characterDelta=="number"?L.characterDelta:0),_e===0&&te===0?this:new y(this.line+_e,this.character+te)}with(L,te=this.character){if(L===null||te===null)throw(0,C.illegalArgument)();let _e;return typeof L=="undefined"?_e=this.line:typeof L=="number"?_e=L:(_e=typeof L.line=="number"?L.line:this.line,te=typeof L.character=="number"?L.character:this.character),_e===this.line&&te===this.character?this:new y(_e,te)}toJSON(){return{line:this.line,character:this.character}}};N=y=$e([E],N),e.Position=N;let W=a=class{constructor(L,te,_e,je){let tt,rt;if(typeof L=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof je=="number"?(tt=new N(L,te),rt=new N(_e,je)):N.isPosition(L)&&N.isPosition(te)&&(tt=N.of(L),rt=N.of(te)),!tt||!rt)throw new Error("Invalid arguments");tt.isBefore(rt)?(this._start=tt,this._end=rt):(this._start=rt,this._end=tt)}static isRange(L){return L instanceof a?!0:L?N.isPosition(L.start)&&N.isPosition(L.end):!1}static of(L){if(L instanceof a)return L;if(this.isRange(L))return new a(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(L){return a.isRange(L)?this.contains(L.start)&&this.contains(L.end):N.isPosition(L)?!(N.of(L).isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const te=N.Max(L.start,this._start),_e=N.Min(L.end,this._end);if(!te.isAfter(_e))return new a(te,_e)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const te=N.Min(L.start,this._start),_e=N.Max(L.end,this.end);return new a(te,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,te=this.end){if(L===null||te===null)throw(0,C.illegalArgument)();let _e;return L?N.isPosition(L)?_e=L:(_e=L.start||this.start,te=L.end||this.end):_e=this.start,_e.isEqual(this._start)&&te.isEqual(this.end)?this:new a(_e,te)}toJSON(){return[this.start,this.end]}};W=a=$e([E],W),e.Range=W;let Z=_=class extends W{constructor(L,te,_e,je){let tt,rt;if(typeof L=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof je=="number"?(tt=new N(L,te),rt=new N(_e,je)):N.isPosition(L)&&N.isPosition(te)&&(tt=N.of(L),rt=N.of(te)),!tt||!rt)throw new Error("Invalid arguments");super(tt,rt);this._anchor=tt,this._active=rt}static isSelection(L){return L instanceof _?!0:L?W.isRange(L)&&N.isPosition(L.anchor)&&N.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};Z=_=$e([E],Z),e.Selection=Z;class K{constructor(L,te,_e){if(typeof L!="string"||L.length===0)throw(0,C.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,C.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,C.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(te),this.connectionToken=_e}}e.ResolvedAuthority=K;class F extends Error{constructor(L,te=g.RemoteAuthorityResolverErrorCode.Unknown,_e){super(L);this._message=L,this._code=te,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,F.prototype)}static NotAvailable(L,te){return new F(L,g.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(L){return new F(L,g.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=F;var oe;(function($){$[$.LF=1]="LF",$[$.CRLF=2]="CRLF"})(oe=e.EndOfLine||(e.EndOfLine={}));var ce;(function($){$[$.Replace=1]="Replace",$[$.Append=2]="Append",$[$.Prepend=3]="Prepend"})(ce=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ae=r=class{constructor(L,te){this._range=L,this._newText=te}static isTextEdit(L){return L instanceof r?!0:L?W.isRange(L)&&typeof L.newText=="string":!1}static replace(L,te){return new r(L,te)}static insert(L,te){return r.replace(new W(L,L),te)}static delete(L){return r.replace(L,"")}static setEndOfLine(L){const te=new r(new W(new N(0,0),new N(0,0)),"");return te.newEol=L,te}get range(){return this._range}set range(L){if(L&&!W.isRange(L))throw(0,C.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,C.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,C.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ae=r=$e([E],ae),e.TextEdit=ae;let fe=d=class{constructor(L,te){this.range=L,this.newCells=te}static isNotebookCellEdit(L){return L instanceof d?!0:L?Mt.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,te){return new d(L,te)}static insertCells(L,te){return new d(new Mt(L,L),te)}static deleteCells(L){return new d(L,[])}static updateCellMetadata(L,te){const _e=new d(new Mt(L,L),[]);return _e.newCellMetadata=te,_e}static updateNotebookMetadata(L){const te=new d(new Mt(0,0),[]);return te.newNotebookMetadata=L,te}};fe=d=$e([E],fe),e.NotebookEdit=fe;class ie{constructor(L,te){this.range=L,this.snippet=te}}e.SnippetTextEdit=ie;var Ee;(function($){$[$.File=1]="File",$[$.Text=2]="Text",$[$.Cell=3]="Cell",$[$.CellReplace=5]="CellReplace"})(Ee=e.FileEditType||(e.FileEditType={}));let be=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,te,_e,je){this._edits.push({_type:1,from:L,to:te,options:_e,metadata:je})}createFile(L,te,_e){this._edits.push({_type:1,from:void 0,to:L,options:te,metadata:_e})}deleteFile(L,te,_e){this._edits.push({_type:1,from:L,to:void 0,options:te,metadata:_e})}replaceNotebookMetadata(L,te,_e){this._edits.push({_type:3,metadata:_e,uri:L,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(L,te,_e,je,tt){let rt,at,St=[],Ot;if(Mt.isNotebookRange(te)&&qt.isNotebookCellDataArray(_e)&&!qt.isNotebookCellDataArray(je)?(rt=te.start,at=te.end,St=_e,Ot=je):typeof te=="number"&&typeof _e=="number"&&qt.isNotebookCellDataArray(je)&&(rt=te,at=_e,St=je,Ot=tt),rt===void 0||at===void 0)throw new Error("Invalid arguments");(rt!==at||St.length>0)&&this._edits.push({_type:5,uri:L,index:rt,count:at-rt,cells:St,metadata:Ot})}replaceNotebookCellMetadata(L,te,_e,je){this._edits.push({_type:3,metadata:je,uri:L,edit:{editType:8,index:te,metadata:_e}})}replace(L,te,_e,je){this._edits.push({_type:2,uri:L,edit:new ae(te,_e),metadata:je})}insert(L,te,_e,je){this.replace(L,new W(te,te),_e,je)}delete(L,te,_e){this.replace(L,te,"",_e)}has(L){return this._edits.some(te=>te._type===2&&te.uri.toString()===L.toString())}set(L,te){if(te)for(const _e of te)_e&&(fe.isNotebookCellEdit(_e)?_e.newCellMetadata?this.replaceNotebookCellMetadata(L,_e.range.start,_e.newCellMetadata):_e.newNotebookMetadata?this.replaceNotebookMetadata(L,_e.newNotebookMetadata):this.replaceNotebookCells(L,_e.range,_e.newCells):this._edits.push({_type:2,uri:L,edit:_e}));else{for(let _e=0;_e<this._edits.length;_e++){const je=this._edits[_e];je._type===2&&je.uri.toString()===L.toString()&&(this._edits[_e]=void 0)}(0,s.coalesceInPlace)(this._edits)}}get(L){const te=[];for(let _e of this._edits)_e._type===2&&_e.uri.toString()===L.toString()&&te.push(_e.edit);return te}entries(){const L=new U.ResourceMap;for(let te of this._edits)if(te._type===2){let _e=L.get(te.uri);_e||(_e=[te.uri,[]],L.set(te.uri,_e)),_e[1].push(te.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};be=$e([E],be),e.WorkspaceEdit=be;let ee=i=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof i?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=i._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,te=this._tabstop++){if(typeof L=="function"){const _e=new i;_e._tabstop=this._tabstop,L(_e),this._tabstop=_e._tabstop,L=_e.value}else L=i._escape(L);return this.value+="${",this.value+=te,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,te=this._tabstop++){const _e=L.map(je=>je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(L,te){if(typeof te=="function"){const _e=new i;_e._tabstop=this._tabstop,te(_e),this._tabstop=_e._tabstop,te=_e.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,te&&(this.value+=":",this.value+=te),this.value+="}",this}};ee=i=$e([E],ee),e.SnippetString=ee;var ve;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(ve=e.DiagnosticTag||(e.DiagnosticTag={}));var Re;(function($){$[$.Hint=3]="Hint",$[$.Information=2]="Information",$[$.Warning=1]="Warning",$[$.Error=0]="Error"})(Re=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Fe=o=class{constructor(L,te){if(this.uri=L,te)if(W.isRange(te))this.range=W.of(te);else if(N.isPosition(te))this.range=new W(te,te);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof o?!0:L?W.isRange(L.range)&&A.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Fe=o=$e([E],Fe),e.Location=Fe;let We=class{constructor(L,te){this.location=L,this.message=te}static is(L){return L?typeof L.message=="string"&&L.location&&W.isRange(L.location.range)&&A.URI.isUri(L.location.uri):!1}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.location.range.isEqual(te.location.range)&&L.location.uri.toString()===te.location.uri.toString()}};We=$e([E],We),e.DiagnosticRelatedInformation=We;let Xe=class{constructor(L,te,_e=Re.Error){if(!W.isRange(L))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=L,this.message=te,this.severity=_e}toJSON(){return{severity:Re[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.severity===te.severity&&L.code===te.code&&L.severity===te.severity&&L.source===te.source&&L.range.isEqual(te.range)&&(0,s.equals)(L.tags,te.tags)&&(0,s.equals)(L.relatedInformation,te.relatedInformation,We.isEqual)}};Xe=$e([E],Xe),e.Diagnostic=Xe;let Te=class{constructor(L,te){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=te}};Te=$e([E],Te),e.Hover=Te;var Se;(function($){$[$.Text=0]="Text",$[$.Read=1]="Read",$[$.Write=2]="Write"})(Se=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ke=class{constructor(L,te=Se.Text){this.range=L,this.kind=te}toJSON(){return{range:this.range,kind:Se[this.kind]}}};ke=$e([E],ke),e.DocumentHighlight=ke;var se;(function($){$[$.File=0]="File",$[$.Module=1]="Module",$[$.Namespace=2]="Namespace",$[$.Package=3]="Package",$[$.Class=4]="Class",$[$.Method=5]="Method",$[$.Property=6]="Property",$[$.Field=7]="Field",$[$.Constructor=8]="Constructor",$[$.Enum=9]="Enum",$[$.Interface=10]="Interface",$[$.Function=11]="Function",$[$.Variable=12]="Variable",$[$.Constant=13]="Constant",$[$.String=14]="String",$[$.Number=15]="Number",$[$.Boolean=16]="Boolean",$[$.Array=17]="Array",$[$.Object=18]="Object",$[$.Key=19]="Key",$[$.Null=20]="Null",$[$.EnumMember=21]="EnumMember",$[$.Struct=22]="Struct",$[$.Event=23]="Event",$[$.Operator=24]="Operator",$[$.TypeParameter=25]="TypeParameter"})(se=e.SymbolKind||(e.SymbolKind={}));var le;(function($){$[$.Deprecated=1]="Deprecated"})(le=e.SymbolTag||(e.SymbolTag={}));let G=n=class{constructor(L,te,_e,je,tt){this.name=L,this.kind=te,this.containerName=tt,typeof _e=="string"&&(this.containerName=_e),je instanceof Fe?this.location=je:_e instanceof W&&(this.location=new Fe(je,_e)),n.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:se[this.kind],location:this.location,containerName:this.containerName}}};G=n=$e([E],G),e.SymbolInformation=G;let X=t=class{constructor(L,te,_e,je,tt){this.name=L,this.detail=te,this.kind=_e,this.range=je,this.selectionRange=tt,this.children=[],t.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(t.validate)}};X=t=$e([E],X),e.DocumentSymbol=X;var k;(function($){$[$.Invoke=1]="Invoke",$[$.Automatic=2]="Automatic"})(k=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let z=class{constructor(L,te){this.title=L,this.kind=te}};z=$e([E],z),e.CodeAction=z;let H=l=class{constructor(L){this.value=L}append(L){return new l(this.value?this.value+l.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+l.sep)}};H.sep=".",H=l=$e([E],H),e.CodeActionKind=H,H.Empty=new H(""),H.QuickFix=H.Empty.append("quickfix"),H.Refactor=H.Empty.append("refactor"),H.RefactorExtract=H.Refactor.append("extract"),H.RefactorInline=H.Refactor.append("inline"),H.RefactorRewrite=H.Refactor.append("rewrite"),H.Source=H.Empty.append("source"),H.SourceOrganizeImports=H.Source.append("organizeImports"),H.SourceFixAll=H.Source.append("fixAll");let V=class{constructor(L,te){if(this.range=L,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};V=$e([E],V),e.SelectionRange=V;class re{constructor(L,te,_e,je,tt,rt){this.kind=L,this.name=te,this.detail=_e,this.uri=je,this.range=tt,this.selectionRange=rt}}e.CallHierarchyItem=re;class de{constructor(L,te){this.fromRanges=te,this.from=L}}e.CallHierarchyIncomingCall=de;class Q{constructor(L,te){this.fromRanges=te,this.to=L}}e.CallHierarchyOutgoingCall=Q;var pe;(function($){$[$.Information=0]="Information",$[$.Warning=1]="Warning",$[$.Error=2]="Error"})(pe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let ge=class{constructor(L,te){this.range=L,this.command=te}get isResolved(){return!!this.command}};ge=$e([E],ge),e.CodeLens=ge;let Ne=v=class{constructor(L,te=!1){f.set(this,void 0),Ye(this,f,new p.MarkdownString(L,{supportThemeIcons:te}),"f")}static isMarkdownString(L){return L instanceof v?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return Ae(this,f,"f").value}set value(L){Ae(this,f,"f").value=L}get isTrusted(){return Ae(this,f,"f").isTrusted}set isTrusted(L){Ae(this,f,"f").isTrusted=L}get supportThemeIcons(){return Ae(this,f,"f").supportThemeIcons}set supportThemeIcons(L){Ae(this,f,"f").supportThemeIcons=L}get supportHtml(){return Ae(this,f,"f").supportHtml}set supportHtml(L){Ae(this,f,"f").supportHtml=L}get baseUri(){return Ae(this,f,"f").baseUri}set baseUri(L){Ae(this,f,"f").baseUri=L}appendText(L){return Ae(this,f,"f").appendText(L),this}appendMarkdown(L){return Ae(this,f,"f").appendMarkdown(L),this}appendCodeblock(L,te){return Ae(this,f,"f").appendCodeblock(te??"",L),this}};f=new WeakMap,Ne=v=$e([E],Ne),e.MarkdownString=Ne;let Be=class{constructor(L,te){this.label=L,this.documentation=te}};Be=$e([E],Be),e.ParameterInformation=Be;let Pe=class{constructor(L,te){this.label=L,this.documentation=te,this.parameters=[]}};Pe=$e([E],Pe),e.SignatureInformation=Pe;let Ke=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ke=$e([E],Ke),e.SignatureHelp=Ke;var q;(function($){$[$.Invoke=1]="Invoke",$[$.TriggerCharacter=2]="TriggerCharacter",$[$.ContentChange=3]="ContentChange"})(q=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Y;(function($){$[$.Type=1]="Type",$[$.Parameter=2]="Parameter"})(Y=e.InlayHintKind||(e.InlayHintKind={}));let me=class{constructor(L){this.value=L}};me=$e([E],me),e.InlayHintLabelPart=me;let Le=class{constructor(L,te,_e){this.position=L,this.label=te,this.kind=_e}};Le=$e([E],Le),e.InlayHint=Le;var ze;(function($){$[$.Invoke=0]="Invoke",$[$.TriggerCharacter=1]="TriggerCharacter",$[$.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ge;(function($){$[$.Text=0]="Text",$[$.Method=1]="Method",$[$.Function=2]="Function",$[$.Constructor=3]="Constructor",$[$.Field=4]="Field",$[$.Variable=5]="Variable",$[$.Class=6]="Class",$[$.Interface=7]="Interface",$[$.Module=8]="Module",$[$.Property=9]="Property",$[$.Unit=10]="Unit",$[$.Value=11]="Value",$[$.Enum=12]="Enum",$[$.Keyword=13]="Keyword",$[$.Snippet=14]="Snippet",$[$.Color=15]="Color",$[$.File=16]="File",$[$.Reference=17]="Reference",$[$.Folder=18]="Folder",$[$.EnumMember=19]="EnumMember",$[$.Constant=20]="Constant",$[$.Struct=21]="Struct",$[$.Event=22]="Event",$[$.Operator=23]="Operator",$[$.TypeParameter=24]="TypeParameter",$[$.User=25]="User",$[$.Issue=26]="Issue"})(Ge=e.CompletionItemKind||(e.CompletionItemKind={}));var Ze;(function($){$[$.Deprecated=1]="Deprecated"})(Ze=e.CompletionItemTag||(e.CompletionItemTag={}));let ot=class{constructor(L,te){this.label=L,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&Ge[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ot=$e([E],ot),e.CompletionItem=ot;let Qe=class{constructor(L=[],te=!1){this.items=L,this.isIncomplete=te}};Qe=$e([E],Qe),e.CompletionList=Qe;let et=class{constructor(L,te,_e){this.insertText=L,this.range=te,this.command=_e}};et=$e([E],et),e.InlineSuggestion=et;let qe=class{constructor(L){this.commands=void 0,this.items=L}};qe=$e([E],qe),e.InlineSuggestionList=qe;let st=class{constructor(L,te,_e){this.insertText=L,this.range=te,this.command=_e}};st=$e([E],st),e.InlineSuggestionNew=st;let it=class{constructor(L,te){this.items=L,this.commands=te}};it=$e([E],it),e.InlineSuggestionsNew=it;var lt;(function($){$[$.Active=-1]="Active",$[$.Beside=-2]="Beside",$[$.One=1]="One",$[$.Two=2]="Two",$[$.Three=3]="Three",$[$.Four=4]="Four",$[$.Five=5]="Five",$[$.Six=6]="Six",$[$.Seven=7]="Seven",$[$.Eight=8]="Eight",$[$.Nine=9]="Nine"})(lt=e.ViewColumn||(e.ViewColumn={}));var ct;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(ct=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Pt;(function($){$[$.Off=0]="Off",$[$.On=1]="On",$[$.Relative=2]="Relative"})(Pt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var zt;(function($){$[$.Manual=1]="Manual",$[$.AfterDelay=2]="AfterDelay",$[$.FocusOut=3]="FocusOut"})(zt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var It;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(It=e.TextEditorRevealType||(e.TextEditorRevealType={}));var mt;(function($){$[$.Keyboard=1]="Keyboard",$[$.Mouse=2]="Mouse",$[$.Command=3]="Command"})(mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ft;(function($){$[$.Undo=1]="Undo",$[$.Redo=2]="Redo"})(Ft=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var $t;(function($){$[$.OpenOpen=0]="OpenOpen",$[$.ClosedClosed=1]="ClosedClosed",$[$.OpenClosed=2]="OpenClosed",$[$.ClosedOpen=3]="ClosedOpen"})($t=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function($){function L(te){switch(te){case"keyboard":return $.Keyboard;case"mouse":return $.Mouse;case"api":return $.Command}}$.fromValue=L}(mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Dt=class{constructor(L,te){if(te&&!A.URI.isUri(te))throw(0,C.illegalArgument)("target");if(!W.isRange(L)||L.isEmpty)throw(0,C.illegalArgument)("range");this.range=L,this.target=te}};Dt=$e([E],Dt),e.DocumentLink=Dt;let He=class{constructor(L,te,_e,je){this.red=L,this.green=te,this.blue=_e,this.alpha=je}};He=$e([E],He),e.Color=He;let At=class{constructor(L,te){if(te&&!(te instanceof He))throw(0,C.illegalArgument)("color");if(!W.isRange(L)||L.isEmpty)throw(0,C.illegalArgument)("range");this.range=L,this.color=te}};At=$e([E],At),e.ColorInformation=At;let Lt=class{constructor(L){if(!L||typeof L!="string")throw(0,C.illegalArgument)("label");this.label=L}};Lt=$e([E],Lt),e.ColorPresentation=Lt;var Nt;(function($){$[$.RGB=0]="RGB",$[$.HEX=1]="HEX",$[$.HSL=2]="HSL"})(Nt=e.ColorFormat||(e.ColorFormat={}));var pt;(function($){$[$.Error=0]="Error",$[$.Warning=1]="Warning",$[$.Information=2]="Information"})(pt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class yt{constructor(L,te,_e){if(this.startIndex=L,this.length=te,this.tooltip=_e,typeof L!="number"||L<0)throw(0,C.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,C.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,C.illegalArgument)("tooltip")}}e.TerminalLink=yt;var Tt;(function($){$[$.Panel=1]="Panel",$[$.Editor=2]="Editor"})(Tt=e.TerminalLocation||(e.TerminalLocation={}));class wt{constructor(L){if(this.options=L,typeof L!="object")throw(0,C.illegalArgument)("options")}}e.TerminalProfile=wt;var we;(function($){$[$.Always=1]="Always",$[$.Silent=2]="Silent",$[$.Never=3]="Never"})(we=e.TaskRevealKind||(e.TaskRevealKind={}));var Ce;(function($){$[$.Shared=1]="Shared",$[$.Dedicated=2]="Dedicated",$[$.New=3]="New"})(Ce=e.TaskPanelKind||(e.TaskPanelKind={}));let ue=m=class{constructor(L,te){if(this.label=te,typeof L!="string"||typeof te!="string")throw(0,C.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return m.Clean;case"build":return m.Build;case"rebuild":return m.Rebuild;case"test":return m.Test;default:return}}get id(){return this._id}};ue.Clean=new m("clean","Clean"),ue.Build=new m("build","Build"),ue.Rebuild=new m("rebuild","Rebuild"),ue.Test=new m("test","Test"),ue=m=$e([E],ue),e.TaskGroup=ue;function j($){let L="";for(let te=0;te<$.length;te++)L+=$[te].replace(/,/g,",,")+",";return L}let ye=class{constructor(L,te,_e){if(typeof L!="string")throw(0,C.illegalArgument)("process");this._args=[],this._process=L,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=_e):this._options=te)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,C.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let te of this._args)L.push(te);return j(L)}};ye=$e([E],ye),e.ProcessExecution=ye;let Me=class{constructor(L,te,_e){if(this._args=[],Array.isArray(te)){if(!L)throw(0,C.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,C.illegalArgument)("command");this._command=L,this._args=te,this._options=_e}else{if(typeof L!="string")throw(0,C.illegalArgument)("commandLine");this._commandLine=L,this._options=te}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,C.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,C.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)L.push(typeof te=="string"?te:te.value);return j(L)}};Me=$e([E],Me),e.ShellExecution=Me;var Je;(function($){$[$.Escape=1]="Escape",$[$.Strong=2]="Strong",$[$.Weak=3]="Weak"})(Je=e.ShellQuoting||(e.ShellQuoting={}));var Ve;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace"})(Ve=e.TaskScope||(e.TaskScope={}));class ut{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,O.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=ut;let ht=I=class{constructor(L,te,_e,je,tt,rt){this.__deprecated=!1,this._definition=this.definition=L;let at;typeof te=="string"?(this._name=this.name=te,this._source=this.source=_e,this.execution=je,at=tt,this.__deprecated=!0):te===Ve.Global||te===Ve.Workspace?(this.target=te,this._name=this.name=_e,this._source=this.source=je,this.execution=tt,at=rt):(this.target=te,this._name=this.name=_e,this._source=this.source=je,this.execution=tt,at=rt),typeof at=="string"?(this._problemMatchers=[at],this._hasDefinedMatchers=!0):Array.isArray(at)?(this._problemMatchers=at,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ye?this._definition={type:I.ProcessType,id:this._execution.computeId()}:this._execution instanceof Me?this._definition={type:I.ShellType,id:this._execution.computeId()}:this._execution instanceof ut?this._definition={type:I.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:I.EmptyType,id:(0,O.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,C.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,C.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const te=this._definition.type;(I.EmptyType===te||I.ProcessType===te||I.ShellType===te||I.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,C.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};ht.ExtensionCallbackType="customExecution",ht.ProcessType="process",ht.ShellType="shell",ht.EmptyType="$empty",ht=I=$e([E],ht),e.Task=ht;var Et;(function($){$[$.SourceControl=1]="SourceControl",$[$.Window=10]="Window",$[$.Notification=15]="Notification"})(Et=e.ProgressLocation||(e.ProgressLocation={}));let ft=class{constructor(L,te=Ct.None){this.collapsibleState=te,A.URI.isUri(L)?this.resourceUri=L:this.label=L}};ft=$e([E],ft),e.TreeItem=ft;var Ct;(function($){$[$.None=0]="None",$[$.Collapsed=1]="Collapsed",$[$.Expanded=2]="Expanded"})(Ct=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Rt=class{constructor(L){this.value=L}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}};Rt=$e([E],Rt),e.DataTransferItem=Rt;let vt=class{constructor(L){c.set(this,new Map);for(const[te,_e]of L??[]){const je=Ae(this,c,"f").get(te);je?je.push(_e):Ae(this,c,"f").set(te,[_e])}}get(L){return Ae(this,c,"f").get(L)?.[0]}set(L,te){Ae(this,c,"f").set(L,[te])}forEach(L){for(const[te,_e]of Ae(this,c,"f"))_e.forEach(je=>L(je,te))}};c=new WeakMap,vt=$e([E],vt),e.DataTransfer=vt;let Wt=class{constructor(L,te){this.id=L,this.color=te}};Wt=$e([E],Wt),e.ThemeIcon=Wt,Wt.File=new Wt("file"),Wt.Folder=new Wt("folder");let Jt=class{constructor(L){this.id=L}};Jt=$e([E],Jt),e.ThemeColor=Jt;var vi;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace",$[$.WorkspaceFolder=3]="WorkspaceFolder"})(vi=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ui=class{constructor(L,te){if(typeof L!="string"&&(!L||!A.URI.isUri(L)&&!A.URI.isUri(L.uri)))throw(0,C.illegalArgument)("base");if(typeof te!="string")throw(0,C.illegalArgument)("pattern");typeof L=="string"?this.baseUri=A.URI.file(L):A.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=te}get base(){return this._base}set base(L){this._base=L,this._baseUri=A.URI.file(L)}get baseUri(){return this._baseUri}set baseUri(L){this._baseUri=L,this._base=L.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ui=$e([E],ui),e.RelativePattern=ui;let _t=class{constructor(L,te,_e,je){this.enabled=typeof L=="boolean"?L:!0,typeof te=="string"&&(this.condition=te),typeof _e=="string"&&(this.hitCondition=_e),typeof je=="string"&&(this.logMessage=je)}get id(){return this._id||(this._id=(0,O.generateUuid)()),this._id}};_t=$e([E],_t),e.Breakpoint=_t;let ri=class extends _t{constructor(L,te,_e,je,tt){super(te,_e,je,tt);if(L===null)throw(0,C.illegalArgument)("location");this.location=L}};ri=$e([E],ri),e.SourceBreakpoint=ri;let di=class extends _t{constructor(L,te,_e,je,tt){super(te,_e,je,tt);this.functionName=L}};di=$e([E],di),e.FunctionBreakpoint=di;let Xt=class extends _t{constructor(L,te,_e,je,tt,rt,at){super(je,tt,rt,at);if(!te)throw(0,C.illegalArgument)("dataId");this.label=L,this.dataId=te,this.canPersist=_e}};Xt=$e([E],Xt),e.DataBreakpoint=Xt;let Qt=class{constructor(L,te,_e){this.command=L,this.args=te||[],this.options=_e}};Qt=$e([E],Qt),e.DebugAdapterExecutable=Qt;let dt=class{constructor(L,te){this.port=L,this.host=te}};dt=$e([E],dt),e.DebugAdapterServer=dt;let hi=class{constructor(L){this.path=L}};hi=$e([E],hi),e.DebugAdapterNamedPipeServer=hi;let xt=class{constructor(L){this.implementation=L}};xt=$e([E],xt),e.DebugAdapterInlineImplementation=xt;let jt=class{constructor(L,te){this.range=L,this.expression=te}};jt=$e([E],jt),e.EvaluatableExpression=jt;var Ei;(function($){$[$.Invoke=0]="Invoke",$[$.Automatic=1]="Automatic"})(Ei=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var Di;(function($){$[$.Invoke=0]="Invoke",$[$.Automatic=1]="Automatic"})(Di=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let si=class{constructor(L,te){this.range=L,this.text=te}};si=$e([E],si),e.InlineValueText=si;let fi=class{constructor(L,te,_e=!0){this.range=L,this.variableName=te,this.caseSensitiveLookup=_e}};fi=$e([E],fi),e.InlineValueVariableLookup=fi;let oi=class{constructor(L,te){this.range=L,this.expression=te}};oi=$e([E],oi),e.InlineValueEvaluatableExpression=oi;let Yt=class{constructor(L,te){this.frameId=L,this.stoppedLocation=te}};Yt=$e([E],Yt),e.InlineValueContext=Yt;var Ci;(function($){$[$.Changed=1]="Changed",$[$.Created=2]="Created",$[$.Deleted=3]="Deleted"})(Ci=e.FileChangeType||(e.FileChangeType={}));let Zt=B=class extends Error{constructor(L,te=w.FileSystemProviderErrorCode.Unknown,_e){super(A.URI.isUri(L)?L.toString(!0):L);this.code=_e?.name??"Unknown",(0,w.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,B.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(L){return new B(L,w.FileSystemProviderErrorCode.FileExists,B.FileExists)}static FileNotFound(L){return new B(L,w.FileSystemProviderErrorCode.FileNotFound,B.FileNotFound)}static FileNotADirectory(L){return new B(L,w.FileSystemProviderErrorCode.FileNotADirectory,B.FileNotADirectory)}static FileIsADirectory(L){return new B(L,w.FileSystemProviderErrorCode.FileIsADirectory,B.FileIsADirectory)}static NoPermissions(L){return new B(L,w.FileSystemProviderErrorCode.NoPermissions,B.NoPermissions)}static Unavailable(L){return new B(L,w.FileSystemProviderErrorCode.Unavailable,B.Unavailable)}};Zt=B=$e([E],Zt),e.FileSystemError=Zt;let ei=class{constructor(L,te,_e){this.start=L,this.end=te,this.kind=_e}};ei=$e([E],ei),e.FoldingRange=ei;var Ii;(function($){$[$.Comment=1]="Comment",$[$.Imports=2]="Imports",$[$.Region=3]="Region"})(Ii=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ti;(function($){$[$.Collapsed=0]="Collapsed",$[$.Expanded=1]="Expanded"})(Ti=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var ti;(function($){$[$.Editing=0]="Editing",$[$.Preview=1]="Preview"})(ti=e.CommentMode||(e.CommentMode={}));var ki;(function($){$[$.Unresolved=0]="Unresolved",$[$.Resolved=1]="Resolved"})(ki=e.CommentThreadState||(e.CommentThreadState={}));class Pi{constructor(L,te=[]){this.tokenTypes=L,this.tokenModifiers=te}}e.SemanticTokensLegend=Pi;function Ai($){return typeof $=="undefined"||(0,b.isStringArray)($)}class mi{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let te=0,_e=L.tokenTypes.length;te<_e;te++)this._tokenTypeStrToInt.set(L.tokenTypes[te],te);for(let te=0,_e=L.tokenModifiers.length;te<_e;te++)this._tokenModifierStrToInt.set(L.tokenModifiers[te],te)}}push(L,te,_e,je,tt){if(typeof L=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof je=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(L,te,_e,je,tt);if(W.isRange(L)&&typeof te=="string"&&Ai(_e))return this._push(L,te,_e);throw(0,C.illegalArgument)()}_push(L,te,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const je=L.start.line,tt=L.start.character,rt=L.end.character-L.start.character,at=this._tokenTypeStrToInt.get(te);let St=0;if(_e)for(const Ot of _e){if(!this._tokenModifierStrToInt.has(Ot))throw new Error("`tokenModifier` is not in the provided legend");const Ht=this._tokenModifierStrToInt.get(Ot);St|=1<<Ht>>>0}this._pushEncoded(je,tt,rt,at,St)}_pushEncoded(L,te,_e,je,tt){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let Ot=0,Ht=0;for(let Vt=0;Vt<St;Vt++){let Kt=this._data[5*Vt],gi=this._data[5*Vt+1];Kt===0?(Kt=Ot,gi+=Ht):Kt+=Ot,this._data[5*Vt]=Kt,this._data[5*Vt+1]=gi,Ot=Kt,Ht=gi}}let rt=L,at=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(rt-=this._prevLine,rt===0&&(at-=this._prevChar)),this._data[this._dataLen++]=rt,this._data[this._dataLen++]=at,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=je,this._data[this._dataLen++]=tt,this._prevLine=L,this._prevChar=te}static _sortAndDeltaEncode(L){let te=[];const _e=L.length/5|0;for(let at=0;at<_e;at++)te[at]=at;te.sort((at,St)=>{const Ot=L[5*at],Ht=L[5*St];if(Ot===Ht){const Vt=L[5*at+1],Kt=L[5*St+1];return Vt-Kt}return Ot-Ht});const je=new Uint32Array(L.length);let tt=0,rt=0;for(let at=0;at<_e;at++){const St=5*te[at],Ot=L[St+0],Ht=L[St+1],Vt=L[St+2],Kt=L[St+3],gi=L[St+4],Gi=Ot-tt,mn=Gi===0?Ht-rt:Ht,pi=5*at;je[pi+0]=Gi,je[pi+1]=mn,je[pi+2]=Vt,je[pi+3]=Kt,je[pi+4]=gi,tt=Ot,rt=Ht}return je}build(L){return this._dataIsSortedAndDeltaEncoded?new ii(new Uint32Array(this._data),L):new ii(mi._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=mi;class ii{constructor(L,te){this.resultId=te,this.data=L}}e.SemanticTokens=ii;class bi{constructor(L,te,_e){this.start=L,this.deleteCount=te,this.data=_e}}e.SemanticTokensEdit=bi;class wi{constructor(L,te){this.resultId=te,this.edits=L}}e.SemanticTokensEdits=wi;var Ue;(function($){$[$.Separate=0]="Separate",$[$.MergeWithParent=1]="MergeWithParent"})(Ue=e.DebugConsoleMode||(e.DebugConsoleMode={}));let Ut=class{constructor(){}};Ut.Back={iconPath:new Wt("arrow-left")},Ut=$e([E],Ut),e.QuickInputButtons=Ut;var _i;(function($){$[$.Separator=-1]="Separator",$[$.Default=0]="Default"})(_i=e.QuickPickItemKind||(e.QuickPickItemKind={}));var gt;(function($){$[$.Info=1]="Info",$[$.Warning=2]="Warning",$[$.Error=3]="Error"})(gt=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Ri;(function($){$[$.UI=1]="UI",$[$.Workspace=2]="Workspace"})(Ri=e.ExtensionKind||(e.ExtensionKind={}));class Oi{constructor(L,te,_e){this.badge=L,this.tooltip=te,this.color=_e}static validate(L){if(L.badge){let te=(0,P.nextCharLength)(L.badge,0);if(te<L.badge.length&&(te+=(0,P.nextCharLength)(L.badge,te)),L.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Oi;let ai=class{constructor(L){this.kind=L}};ai=$e([E],ai),e.ColorTheme=ai;var Fi;(function($){$[$.Light=1]="Light",$[$.Dark=2]="Dark",$[$.HighContrast=3]="HighContrast",$[$.HighContrastLight=4]="HighContrastLight"})(Fi=e.ColorThemeKind||(e.ColorThemeKind={}));class Mt{constructor(L,te){if(L<0)throw(0,C.illegalArgument)("start must be positive");if(te<0)throw(0,C.illegalArgument)("end must be positive");L<=te?(this._start=L,this._end=te):(this._start=te,this._end=L)}static isNotebookRange(L){return L instanceof Mt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let te=this._start,_e=this._end;return L.start!==void 0&&(te=L.start),L.end!==void 0&&(_e=L.end),te===this._start&&_e===this._end?this:new Mt(te,_e)}}e.NotebookRange=Mt;class qt{constructor(L,te,_e,je,tt,rt,at){this.kind=L,this.value=te,this.languageId=_e,this.mime=je,this.outputs=tt??[],this.metadata=rt,this.executionSummary=at,qt.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(te=>qt.isNotebookCellData(te))}static isNotebookCellData(L){return!0}}e.NotebookCellData=qt;class Ni{constructor(L){this.cells=L}}e.NotebookData=Ni;class Bt{constructor(L,te){this.data=L,this.mime=te;const _e=(0,T.normalizeMimeType)(te,!0);if(!_e)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(L){return L instanceof Bt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const te={name:L.name,message:L.message,stack:L.stack};return Bt.json(te,"application/vnd.code.notebook.error")}static stdout(L){return Bt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Bt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,te="application/octet-stream"){return new Bt(L,te)}static text(L,te=T.Mimes.text){const _e=Ae(Bt,h,"f",u).encode(String(L));return new Bt(_e,te)}static json(L,te="text/x-json"){const _e=JSON.stringify(L,void 0,"	");return Bt.text(_e,te)}}e.NotebookCellOutputItem=Bt,h=Bt,u={value:new TextEncoder};class ni{constructor(L,te,_e){this.items=ni.ensureUniqueMimeTypes(L,!0),typeof te=="string"?(this.id=te,this.metadata=_e):(this.id=(0,O.generateUuid)(),this.metadata=te??_e)}static isNotebookCellOutput(L){return L instanceof ni?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&(0,b.isArray)(L.items)}static ensureUniqueMimeTypes(L,te=!1){const _e=new Set,je=new Set;for(let tt=0;tt<L.length;tt++){const rt=L[tt],at=(0,T.normalizeMimeType)(rt.mime);if(!_e.has(at)){_e.add(at);continue}je.add(tt),te&&console.warn(`DUPLICATED mime type '${rt.mime}' will be dropped`)}return je.size===0?L:L.filter((tt,rt)=>!je.has(rt))}}e.NotebookCellOutput=ni;var Mi;(function($){$[$.Markup=1]="Markup",$[$.Code=2]="Code"})(Mi=e.NotebookCellKind||(e.NotebookCellKind={}));var Li;(function($){$[$.Idle=1]="Idle",$[$.Pending=2]="Pending",$[$.Executing=3]="Executing"})(Li=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ui;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(Ui=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Bi;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(Bi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class zi{constructor(L,te){this.text=L,this.alignment=te}}e.NotebookCellStatusBarItem=zi;var ne;(function($){$[$.Default=1]="Default",$[$.Preferred=2]="Preferred"})(ne=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class he{constructor(L,te=[]){this.uri=L,this.provides=(0,s.asArray)(te)}}e.NotebookRendererScript=he;let Oe=class{constructor(L,te){this.label=L,this.timestamp=te}};Oe=$e([E],Oe),e.TimelineItem=Oe;var nt;(function($){$[$.Production=1]="Production",$[$.Development=2]="Development",$[$.Test=3]="Test"})(nt=e.ExtensionMode||(e.ExtensionMode={}));var bt;(function($){$[$.Node=1]="Node",$[$.Webworker=2]="Webworker"})(bt=e.ExtensionRuntime||(e.ExtensionRuntime={}));var kt;(function($){$[$.Other=0]="Other",$[$.Comment=1]="Comment",$[$.String=2]="String",$[$.RegEx=3]="RegEx"})(kt=e.StandardTokenType||(e.StandardTokenType={}));class Ji{constructor(L,te){this.ranges=L,this.wordPattern=te}}e.LinkedEditingRanges=Ji;class Zi{constructor(L,te){this._port=L,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Zi;var en;(function($){$[$.Queued=1]="Queued",$[$.Running=2]="Running",$[$.Passed=3]="Passed",$[$.Failed=4]="Failed",$[$.Skipped=5]="Skipped",$[$.Errored=6]="Errored"})(en=e.TestResultState||(e.TestResultState={}));var tn;(function($){$[$.Run=1]="Run",$[$.Debug=2]="Debug",$[$.Coverage=3]="Coverage"})(tn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let $i=class{constructor(L=void 0,te=void 0,_e=void 0){this.include=L,this.exclude=te,this.profile=_e}};$i=$e([E],$i),e.TestRunRequest=$i;let Wi=x=class{constructor(L){this.message=L}static diff(L,te,_e){const je=new x(L);return je.expectedOutput=te,je.actualOutput=_e,je}};Wi=x=$e([E],Wi),e.TestMessage=Wi;let xi=class{constructor(L){this.id=L}};xi=$e([E],xi),e.TestTag=xi;let li=class{constructor(L,te){this.covered=L,this.total=te}};li=$e([E],li),e.CoveredCount=li;let Hi=R=class{constructor(L,te,_e,je){this.uri=L,this.statementCoverage=te,this.branchCoverage=_e,this.functionCoverage=je}static fromDetails(L,te){const _e=new li(0,0),je=new li(0,0),tt=new li(0,0);for(const at of te)if("branches"in at){_e.total+=1,_e.covered+=at.executionCount>0?1:0;for(const St of at.branches)je.total+=1,je.covered+=St.executionCount>0?1:0}else tt.total+=1,tt.covered+=at.executionCount>0?1:0;const rt=new R(L,_e,je.total>0?je:void 0,tt.total>0?tt:void 0);return rt.detailedCoverage=te,rt}};Hi=R=$e([E],Hi),e.FileCoverage=Hi;let Vi=class{constructor(L,te,_e=[]){this.executionCount=L,this.location=te,this.branches=_e}};Vi=$e([E],Vi),e.StatementCoverage=Vi;let ji=class{constructor(L,te){this.executionCount=L,this.location=te}};ji=$e([E],ji),e.BranchCoverage=ji;let qi=class{constructor(L,te){this.executionCount=L,this.location=te}};qi=$e([E],qi),e.FunctionCoverage=qi;var nn;(function($){$[$.None=0]="None",$[$.Option=1]="Option",$[$.Default=2]="Default",$[$.Preferred=3]="Preferred"})(nn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var rn;(function($){$[$.Untrusted=0]="Untrusted",$[$.Trusted=1]="Trusted",$[$.Unspecified=2]="Unspecified"})(rn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var sn;(function($){$[$.Notify=1]="Notify",$[$.OpenBrowser=2]="OpenBrowser",$[$.OpenPreview=3]="OpenPreview",$[$.Silent=4]="Silent",$[$.Ignore=5]="Ignore",$[$.OpenBrowserOnce=6]="OpenBrowserOnce"})(sn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class on{constructor(L,te,_e,je,tt,rt){this.kind=L,this.name=te,this.detail=_e,this.uri=je,this.range=tt,this.selectionRange=rt}}e.TypeHierarchyItem=on;class an{constructor(L){this.uri=L}}e.TextTabInput=an;class ln{constructor(L,te){this.original=L,this.modified=te}}e.TextDiffTabInput=ln;class cn{constructor(L,te){this.uri=L,this.viewType=te}}e.CustomEditorTabInput=cn;class un{constructor(L){this.viewType=L}}e.WebviewEditorTabInput=un;class dn{constructor(L,te){this.uri=L,this.notebookType=te}}e.NotebookEditorTabInput=dn;class hn{constructor(L,te,_e){this.original=L,this.modified=te,this.notebookType=_e}}e.NotebookDiffEditorTabInput=hn;class fn{constructor(){}}e.TerminalEditorTabInput=fn}),define(De[87],Ie([1,0,42,12,10,237,121,6,15]),function(J,e,s,C,p,U,T,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const A=new Map;function O(f,c){c?A.set(f,c):A.delete(f)}e.setWordDefinitionFor=O;function w(f){return A.get(f)}e.getWordDefinitionFor=w;class g extends U.MirrorTextModel{constructor(c,h,u,D,y,a,_,r){super(h,u,D,y);this._proxy=c,this._languageId=a,this._isDirty=_,this.notebook=r,this._isDisposed=!1}dispose(){(0,s.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(c){return(0,b.equals)(this._lines,c)}get document(){if(!this._document){const c=this;this._document={get uri(){return c._uri},get fileName(){return c._uri.fsPath},get isUntitled(){return c._uri.scheme===C.Schemas.untitled},get languageId(){return c._languageId},get version(){return c._versionId},get isClosed(){return c._isDisposed},get isDirty(){return c._isDirty},save(){return c._save()},getText(h){return h?c._getTextInRange(h):c.getText()},get eol(){return c._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return c._lines.length},lineAt(h){return c._lineAt(h)},offsetAt(h){return c._offsetAt(h)},positionAt(h){return c._positionAt(h)},validateRange(h){return c._validateRange(h)},validatePosition(h){return c._validatePosition(h)},getWordRangeAtPosition(h,u){return c._getWordRangeAtPosition(h,u)}}}return Object.freeze(this._document)}_acceptLanguageId(c){(0,s.ok)(!this._isDisposed),this._languageId=c}_acceptIsDirty(c){(0,s.ok)(!this._isDisposed),this._isDirty=c}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(c){const h=this._validateRange(c);if(h.isEmpty)return"";if(h.isSingleLine)return this._lines[h.start.line].substring(h.start.character,h.end.character);const u=this._eol,D=h.start.line,y=h.end.line,a=[];a.push(this._lines[D].substring(h.start.character));for(let _=D+1;_<y;_++)a.push(this._lines[_]);return a.push(this._lines[y].substring(0,h.end.character)),a.join(u)}_lineAt(c){let h;if(c instanceof P.Position?h=c.line:typeof c=="number"&&(h=c),typeof h!="number"||h<0||h>=this._lines.length||Math.floor(h)!==h)throw new Error("Illegal value for `line`");return new S(h,this._lines[h],h===this._lines.length-1)}_offsetAt(c){return c=this._validatePosition(c),this._ensureLineStarts(),this._lineStarts.getPrefixSum(c.line-1)+c.character}_positionAt(c){c=Math.floor(c),c=Math.max(0,c),this._ensureLineStarts();const h=this._lineStarts.getIndexOf(c),u=this._lines[h.index].length;return new P.Position(h.index,Math.min(h.remainder,u))}_validateRange(c){if(!(c instanceof P.Range))throw new Error("Invalid argument");const h=this._validatePosition(c.start),u=this._validatePosition(c.end);return h===c.start&&u===c.end?c:new P.Range(h.line,h.character,u.line,u.character)}_validatePosition(c){if(!(c instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return c.with(0,0);let{line:h,character:u}=c,D=!1;if(h<0)h=0,u=0,D=!0;else if(h>=this._lines.length)h=this._lines.length-1,u=this._lines[h].length,D=!0;else{const y=this._lines[h].length;u<0?(u=0,D=!0):u>y&&(u=y,D=!0)}return D?new P.Position(h,u):c}_getWordRangeAtPosition(c,h){const u=this._validatePosition(c);if(!h)h=w(this._languageId);else if((0,p.regExpLeadsToEndlessLoop)(h))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${h.source}' because it matches the empty string.`);const D=(0,T.getWordAtText)(u.character+1,(0,T.ensureValidWordDefinition)(h),this._lines[u.line],0);if(D)return new P.Range(u.line,D.startColumn-1,u.line,D.endColumn-1)}}e.ExtHostDocumentData=g;class S{constructor(c,h,u){this._line=c,this._text=h,this._isLastLine=u}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=S}),define(De[160],Ie([1,0,6,16,5]),function(J,e,s,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let U=class{constructor(P){this._actual=new s.ColorTheme(s.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new p.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let b;switch(P){case"light":b=s.ColorThemeKind.Light;break;case"hcDark":b=s.ColorThemeKind.HighContrast;break;case"hcLight":b=s.ColorThemeKind.HighContrastLight;break;default:b=s.ColorThemeKind.Dark}this._actual=new s.ColorTheme(b),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};U=$e([xe(0,C.IExtHostRpcService)],U),e.ExtHostTheming=U}),define(De[65],Ie([1,0,3]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,s.createDecorator)("IURITransformerService");class C{constructor(U){U?(this.transformIncoming=U.transformIncoming.bind(U),this.transformOutgoing=U.transformOutgoing.bind(U),this.transformOutgoingURI=U.transformOutgoingURI.bind(U),this.transformOutgoingScheme=U.transformOutgoingScheme.bind(U)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.URITransformerService=C}),define(De[161],Ie([1,0,23]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class C{constructor(){this.buffers=[]}add(b){let A=this.buffers.indexOf(b);return A<0&&(A=this.buffers.length,this.buffers.push(b)),A}}function p(P,b){if(b.serializeBuffersForPostMessage){const A=new C,O=(S,f)=>{if(f instanceof ArrayBuffer){const c=A.add(f);return{$$vscode_array_buffer_reference$$:!0,index:c}}else if(ArrayBuffer.isView(f)){const c=U(f);if(c){const h=A.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:h,view:{type:c,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},w=JSON.stringify(P,O),g=A.buffers.map(S=>{const f=new Uint8Array(S);return s.VSBuffer.wrap(f)});return{message:w,buffers:g}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=p;function U(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(P,b){const A=b.map(g=>{const S=new ArrayBuffer(g.byteLength);return new Uint8Array(S).set(g.buffer),S}),O=b.length?(g,S)=>{if(S&&typeof S=="object"&&S.$$vscode_array_buffer_reference$$){const f=S,{index:c}=f,h=A[c];if(f.view)switch(f.view.type){case 1:return new Int8Array(h,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(h,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(h,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(h,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(h,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(h,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(h,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(h,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(h,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(h,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(h,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return h}return S}:void 0;return{message:JSON.parse(P,O),arrayBuffers:A}}e.deserializeWebviewMessage=T}),define(De[162],Ie([1,0,135,9,2,7,3,30,39,15,12]),function(J,e,s,C,p,U,T,P,b,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,s.localize)(0,null),providerDisplayName:(0,s.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var w;(function(K){K[K.PROGRAMMATIC=1]="PROGRAMMATIC",K[K.USER=2]="USER",K[K.EDIT=3]="EDIT",K[K.NAVIGATION=4]="NAVIGATION",K[K.JUMP=5]="JUMP"})(w=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var g;(function(K){K[K.IDENTICAL=1]="IDENTICAL",K[K.SIMILAR=2]="SIMILAR",K[K.DIFFERENT=3]="DIFFERENT"})(g=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function S(K){const F=K;return!!F&&typeof F.getSelection=="function"&&!!F.onDidChangeSelection}e.isEditorPaneWithSelection=S;function f(K,F,oe){for(const ce of oe.visibleEditorPanes)if(ce.group.id===F&&K.matches(ce.input))return ce.getViewState()}e.findViewStateForEditor=f;function c(K){if(i(K))return!1;const F=K;return p.URI.isUri(F?.resource)}e.isResourceEditorInput=c;function h(K){if(i(K))return!1;const F=K;return F?.original!==void 0&&F.modified!==void 0}e.isResourceDiffEditorInput=h;function u(K){if(i(K)||h(K))return!1;const F=K;return F?.primary!==void 0&&F.secondary!==void 0}e.isResourceSideBySideEditorInput=u;function D(K){if(i(K))return!1;const F=K;return F?F.resource===void 0||F.resource.scheme===O.Schemas.untitled||F.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=D;var y;(function(K){K[K.SHORT=0]="SHORT",K[K.MEDIUM=1]="MEDIUM",K[K.LONG=2]="LONG"})(y=e.Verbosity||(e.Verbosity={}));var a;(function(K){K[K.EXPLICIT=1]="EXPLICIT",K[K.AUTO=2]="AUTO",K[K.FOCUS_CHANGE=3]="FOCUS_CHANGE",K[K.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a=e.SaveReason||(e.SaveReason={}));class _{constructor(){this.mapIdToSaveSource=new Map}registerSource(F,oe){let ce=this.mapIdToSaveSource.get(F);return ce||(ce={source:F,label:oe},this.mapIdToSaveSource.set(F,ce)),ce.source}getSourceLabel(F){return this.mapIdToSaveSource.get(F)?.label??F}}e.SaveSourceRegistry=new _;var r;(function(K){K[K.None=0]="None",K[K.Readonly=2]="Readonly",K[K.Untitled=4]="Untitled",K[K.Singleton=8]="Singleton",K[K.RequiresTrust=16]="RequiresTrust",K[K.CanSplitInGroup=32]="CanSplitInGroup",K[K.ForceDescription=64]="ForceDescription",K[K.CanDropIntoEditor=128]="CanDropIntoEditor"})(r=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class d extends U.Disposable{}e.AbstractEditorInput=d;function i(K){return K instanceof d}e.isEditorInput=i;function o(K){const F=K;return p.URI.isUri(F?.preferredResource)}function n(K){const F=K;return i(F?.primary)&&i(F?.secondary)}e.isSideBySideEditorInput=n;function t(K){const F=K;return i(F?.modified)&&i(F?.original)}e.isDiffEditorInput=t;function l(K){return i(K?.editor)}e.isEditorInputWithOptions=l;function v(K){const F=K;return l(K)&&F?.group!==void 0}e.isEditorInputWithOptionsAndGroup=v;function m(K){const F=K;return typeof F?.groupId=="number"&&i(F.editor)}e.isEditorIdentifier=m;var I;(function(K){K[K.UNKNOWN=0]="UNKNOWN",K[K.REPLACE=1]="REPLACE",K[K.MOVE=2]="MOVE",K[K.UNPIN=3]="UNPIN"})(I=e.EditorCloseContext||(e.EditorCloseContext={}));var B;(function(K){K[K.GROUP_ACTIVE=0]="GROUP_ACTIVE",K[K.GROUP_INDEX=1]="GROUP_INDEX",K[K.GROUP_LOCKED=2]="GROUP_LOCKED",K[K.EDITOR_OPEN=3]="EDITOR_OPEN",K[K.EDITOR_CLOSE=4]="EDITOR_CLOSE",K[K.EDITOR_MOVE=5]="EDITOR_MOVE",K[K.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",K[K.EDITOR_LABEL=7]="EDITOR_LABEL",K[K.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",K[K.EDITOR_PIN=9]="EDITOR_PIN",K[K.EDITOR_STICKY=10]="EDITOR_STICKY",K[K.EDITOR_DIRTY=11]="EDITOR_DIRTY",K[K.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(B=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var x;(function(K){K[K.PRIMARY=1]="PRIMARY",K[K.SECONDARY=2]="SECONDARY",K[K.BOTH=3]="BOTH",K[K.ANY=4]="ANY"})(x=e.SideBySideEditor||(e.SideBySideEditor={}));class R{getOriginalUri(F,oe){if(!F)return;if(oe?.supportSideBySide){const{primary:ae,secondary:fe}=this.getSideEditors(F);if(ae&&fe){if(oe?.supportSideBySide===x.BOTH)return{primary:this.getOriginalUri(ae,{filterByScheme:oe.filterByScheme}),secondary:this.getOriginalUri(fe,{filterByScheme:oe.filterByScheme})};if(oe?.supportSideBySide===x.ANY)return this.getOriginalUri(ae,{filterByScheme:oe.filterByScheme})??this.getOriginalUri(fe,{filterByScheme:oe.filterByScheme});F=oe.supportSideBySide===x.PRIMARY?ae:fe}}if(h(F)||u(F))return;const ce=o(F)?F.preferredResource:F.resource;return!ce||!oe||!oe.filterByScheme?ce:this.filterUri(ce,oe.filterByScheme)}getSideEditors(F){return n(F)||u(F)?{primary:F.primary,secondary:F.secondary}:t(F)||h(F)?{primary:F.modified,secondary:F.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(F,oe){if(!F)return;if(oe?.supportSideBySide){const{primary:ae,secondary:fe}=this.getSideEditors(F);if(ae&&fe){if(oe?.supportSideBySide===x.BOTH)return{primary:this.getCanonicalUri(ae,{filterByScheme:oe.filterByScheme}),secondary:this.getCanonicalUri(fe,{filterByScheme:oe.filterByScheme})};if(oe?.supportSideBySide===x.ANY)return this.getCanonicalUri(ae,{filterByScheme:oe.filterByScheme})??this.getCanonicalUri(fe,{filterByScheme:oe.filterByScheme});F=oe.supportSideBySide===x.PRIMARY?ae:fe}}if(h(F)||u(F))return;const ce=F.resource;return!ce||!oe||!oe.filterByScheme?ce:this.filterUri(ce,oe.filterByScheme)}filterUri(F,oe){if(Array.isArray(oe)){if(oe.some(ce=>F.scheme===ce))return F}else if(oe===F.scheme)return F}}e.EditorResourceAccessor=new R;var E;(function(K){K[K.LEFT=0]="LEFT",K[K.RIGHT=1]="RIGHT"})(E=e.CloseDirection||(e.CloseDirection={}));class M{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(F){const oe=this.instantiationService=F.get(T.IInstantiationService);for(const[ce,ae]of this.editorSerializerConstructors)this.createEditorSerializer(ce,ae,oe);this.editorSerializerConstructors.clear()}createEditorSerializer(F,oe,ce){const ae=ce.createInstance(oe);this.editorSerializerInstances.set(F,ae)}registerFileEditorFactory(F){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=F}getFileEditorFactory(){return(0,C.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(F,oe){if(this.editorSerializerConstructors.has(F)||this.editorSerializerInstances.has(F))throw new Error(`A editor serializer with type ID '${F}' was already registered.`);return this.instantiationService?this.createEditorSerializer(F,oe,this.instantiationService):this.editorSerializerConstructors.set(F,oe),(0,U.toDisposable)(()=>{this.editorSerializerConstructors.delete(F),this.editorSerializerInstances.delete(F)})}getEditorSerializer(F){return this.editorSerializerInstances.get(typeof F=="string"?F:F.typeId)}}P.Registry.add(e.EditorExtensions.EditorFactory,new M);async function N(K,F){if(!K||!K.length)return[];const oe=await Promise.all(K.map(async ce=>{const ae=p.URI.revive(ce.fileUri);if(!ae||!await F.canHandleResource(ae))return;let ie=ce.exists,Ee=ce.type;if(typeof ie!="boolean"||typeof Ee!="number")try{Ee=(await F.stat(ae)).isDirectory?b.FileType.Directory:b.FileType.Unknown,ie=!0}catch{ie=!1}if(!ie&&ce.openOnlyIfExists||Ee===b.FileType.Directory)return;const be={...ce.options,pinned:!0};let ee;return ie?ee={resource:ae,options:be}:ee={resource:ae,options:be,forceUntitled:!0},ee}));return(0,A.coalesce)(oe)}e.pathsToEditors=N;var W;(function(K){K[K.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",K[K.SEQUENTIAL=1]="SEQUENTIAL"})(W=e.EditorsOrder||(e.EditorsOrder={}));function Z(K){const F=K;if(!F)return!1;const oe=F;if(oe.modified)return Z(oe.modified);const ce=F;return!!(ce.contributionsState&&ce.viewState&&Array.isArray(ce.cursorState))}e.isTextEditorViewState=Z}),define(De[66],Ie([1,0,12,2]),function(J,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function p(P,b){return P.scheme===s.Schemas.http||P.scheme===s.Schemas.https?P:(b&&b.authority&&b.isRemote&&P.scheme===s.Schemas.file&&(P=C.URI.from({scheme:s.Schemas.vscodeRemote,authority:b.authority,path:P.path})),C.URI.from({scheme:s.Schemas.https,authority:`${P.scheme}+${U(P.authority)}.${e.webviewRootResourceAuthority}`,path:P.path,fragment:P.fragment,query:P.query}))}e.asWebviewUri=p;function U(P){return P.replace(/./g,b=>{const A=b.charCodeAt(0);return A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57?b:"-"+A.toString(16).padStart(4,"0")})}function T(P){return P.replace(/-([0-9a-f]{4})/g,(b,A)=>String.fromCharCode(parseInt(A,16)))}e.decodeAuthority=T}),define(De[163],Ie([1,0,5,7,66]),function(J,e,s,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class U{constructor(P,b,A){this._proxy=P,this._editors=b,this._remoteInfo=A,this._handlePool=0,this._disposables=new C.DisposableStore,this._insets=new Map,this._disposables.add(b.onDidChangeVisibleTextEditors(()=>{const O=b.getVisibleTextEditors();for(const w of this._insets.values())O.indexOf(w.editor)<0&&w.inset.dispose()}))}dispose(){this._insets.forEach(P=>P.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(P,b,A,O,w){let g;for(const y of this._editors.getVisibleTextEditors(!0))if(y.value===P){g=y;break}if(!g)throw new Error("not a visible editor");const S=this,f=this._handlePool++,c=new s.Emitter,h=new s.Emitter,u=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(y){return(0,p.asWebviewUri)(y,S._remoteInfo)}get cspSource(){return p.webviewGenericCspSource}set options(y){this._options=y,S._proxy.$setOptions(f,y)}get options(){return this._options}set html(y){this._html=y,S._proxy.$setHtml(f,y)}get html(){return this._html}get onDidReceiveMessage(){return c.event}postMessage(y){return S._proxy.$postMessage(f,y)}},D=new class{constructor(){this.editor=P,this.line=b,this.height=A,this.webview=u,this.onDidDispose=h.event}dispose(){S._insets.has(f)&&(S._insets.delete(f),S._proxy.$disposeEditorInset(f),h.fire(),h.dispose(),c.dispose())}};return this._proxy.$createEditorInset(f,g.id,g.value.document.uri,b+1,A,O||{},w.identifier,w.extensionLocation),this._insets.set(f,{editor:P,inset:D,onDidReceiveMessage:c}),D}$onDidDispose(P){const b=this._insets.get(P);b&&b.inset.dispose()}$onDidReceiveMessage(P,b){const A=this._insets.get(P);A&&A.onDidReceiveMessage.fire(b)}}e.ExtHostEditorInsets=U}),define(De[164],Ie([1,0,5,13,136]),function(J,e,s,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class U{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new s.Emitter,this._onExit=new s.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,b,A,O){const w={command:P};if(b&&Object.keys(b).length>0&&(w.arguments=b),this.internalSend("request",w),typeof O=="number"){const g=setTimeout(()=>{clearTimeout(g);const S=this.pendingRequests.get(w.seq);if(S){this.pendingRequests.delete(w.seq);const f={type:"response",seq:0,request_seq:w.seq,success:!1,command:P,message:(0,p.localize)(0,null,O,P)};S(f)}},O)}return A&&this.pendingRequests.set(w.seq,A),w.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,b){return P.type!=="event"||b.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,C.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback&&this.eventCallback(P);break;case"request":this.requestCallback&&this.requestCallback(P);break;case"response":{const b=P,A=this.pendingRequests.get(b.request_seq);A&&(this.pendingRequests.delete(b.request_seq),A(b));break}}}}internalSend(P,b){b.type=P,b.seq=this.sequence++,this.sendMessage(b)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((b,A)=>P.set(A,b)),await(0,C.timeout)(500),P.forEach((b,A)=>{b({type:"response",seq:0,request_seq:A,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(A)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=U}),define(De[165],Ie([1,0,137,38,3]),function(J,e,s,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerUiMessage=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new C.RawContextKey("debugType",void 0,{type:"string",description:s.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new C.RawContextKey("debugConfigurationType",void 0,{type:"string",description:s.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new C.RawContextKey("debugState","inactive",{type:"string",description:s.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new C.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:s.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new C.RawContextKey("inDebugMode",!1,{type:"boolean",description:s.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new C.RawContextKey("inDebugRepl",!1,{type:"boolean",description:s.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new C.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:s.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new C.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:s.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new C.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:s.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new C.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:s.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new C.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:s.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new C.RawContextKey("variablesFocused",!0,{type:"boolean",description:s.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new C.RawContextKey("expressionSelected",!1,{type:"boolean",description:s.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new C.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:s.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new C.RawContextKey("callStackItemType",void 0,{type:"string",description:s.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new C.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:s.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new C.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:s.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new C.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:s.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new C.RawContextKey("watchItemType",void 0,{type:"string",description:s.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new C.RawContextKey("canViewMemory",void 0,{type:"boolean",description:s.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new C.RawContextKey("breakpointItemType",void 0,{type:"string",description:s.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new C.RawContextKey("breakpointAccessType",void 0,{type:"string",description:s.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new C.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:s.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new C.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:s.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new C.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:s.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new C.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:s.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new C.RawContextKey("stepBackSupported",!1,{type:"boolean",description:s.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new C.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:s.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new C.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:s.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new C.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:s.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new C.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:s.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new C.RawContextKey("breakpointsExist",!1,{type:"boolean",description:s.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new C.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:s.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new C.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:s.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new C.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:s.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new C.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:s.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new C.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:s.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new C.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:s.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new C.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:s.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new C.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:s.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new C.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:s.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new C.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:s.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new C.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:s.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new C.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:s.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new C.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:s.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new C.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:s.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new C.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:s.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new C.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:s.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new C.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:s.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new C.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:s.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new C.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:s.localize(50,null)});const U=g=>s.localize(51,null,g);e.debuggerDisabledMessage=U,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:s.localize(52,null)};var T;(function(g){g[g.Inactive=0]="Inactive",g[g.Initializing=1]="Initializing",g[g.Stopped=2]="Stopped",g[g.Running=3]="Running"})(T=e.State||(e.State={}));function P(g){switch(g){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=P;var b;(function(g){g[g.Valid=0]="Valid",g[g.Unreadable=1]="Unreadable",g[g.Error=2]="Error"})(b=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var A;(function(g){g[g.Initial=1]="Initial",g[g.Dynamic=2]="Dynamic"})(A=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var O;(function(g){g.UnverifiedBreakpoints="unverifiedBreakpoints"})(O=e.DebuggerUiMessage||(e.DebuggerUiMessage={})),e.IDebugService=(0,p.createDecorator)(e.DEBUG_SERVICE_ID);var w;(function(g){g[g.CONDITION=0]="CONDITION",g[g.HIT_COUNT=1]="HIT_COUNT",g[g.LOG_MESSAGE=2]="LOG_MESSAGE"})(w=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(De[166],Ie([1,0,10,2,19,27,12]),function(J,e,s,C,p,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function b(i,o,n){return i.replace(P,function(t,l){return o&&l.length>0&&l[0]!=="_"?t:n&&n.hasOwnProperty(l)?n[l]:t})}e.formatPII=b;function A(i){const o={};for(const n of Object.keys(i))n.startsWith("!")||(o[n]=i[n]);return o}e.filterExceptionsFromTelemetry=A;function O(i){return i.configuration.request==="attach"&&!w(i)&&(!i.parentSession||O(i.parentSession))}e.isSessionAttach=O;function w(i){let o=i.configuration.type;if(!!o)return o==="vslsShare"&&(o=i.configuration.adapterProxy.configuration.type),(0,s.equalsIgnoreCase)(o,"extensionhost")||(0,s.equalsIgnoreCase)(o,"pwa-extensionhost")?i:i.parentSession?w(i.parentSession):void 0}e.getExtensionHostDebugSession=w;function g(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=g;function S(i,o,n){let t,l=0;const v=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let m=null;for(;m=v.exec(i);){const I=m.index+1,B=I+m[0].length;if(I<=o&&B>=n){t=m[0],l=I;break}}if(t){const I=/\w+/g;let B=null;for(;(B=I.exec(t))&&!(B.index+1+l+B[0].length>=n););B&&(t=t.substring(0,I.lastIndex))}return t?{start:l,end:l+t.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=S;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function c(i){return!!(i&&i.match(f))}e.isUri=c;function h(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(c(i.path))return C.URI.parse(i.path);if((0,p.isAbsolute)(i.path))return C.URI.file(i.path)}return i.path}function u(i){if(typeof i.path=="object"){const o=C.URI.revive(i.path);if(o)return o.scheme===T.Schemas.file?o.fsPath:o.toString()}return i.path}function D(i,o){const n=o?h:u,t=(0,U.deepClone)(i);return a(t,(l,v)=>{l&&v&&(v.path=n(v))}),t}e.convertToDAPaths=D;function y(i,o){const n=o?h:u,t=(0,U.deepClone)(i);return a(t,(l,v)=>{!l&&v&&(v.path=n(v))}),t}e.convertToVSCPaths=y;function a(i,o){switch(i.type){case"event":{const n=i;switch(n.event){case"output":o(!1,n.body.source);break;case"loadedSource":o(!1,n.body.source);break;case"breakpoint":o(!1,n.body.breakpoint.source);break;default:break}break}case"request":{const n=i;switch(n.command){case"setBreakpoints":o(!0,n.arguments.source);break;case"breakpointLocations":o(!0,n.arguments.source);break;case"source":o(!0,n.arguments.source);break;case"gotoTargets":o(!0,n.arguments.source);break;case"launchVSCode":n.arguments.args.forEach(t=>o(!1,t));break;default:break}break}case"response":{const n=i;if(n.success&&n.body)switch(n.command){case"stackTrace":n.body.stackFrames.forEach(t=>o(!1,t.source));break;case"loadedSources":n.body.sources.forEach(t=>o(!1,t));break;case"scopes":n.body.scopes.forEach(t=>o(!1,t.source));break;case"setFunctionBreakpoints":n.body.breakpoints.forEach(t=>o(!1,t.source));break;case"setBreakpoints":n.body.breakpoints.forEach(t=>o(!1,t.source));break;case"disassemble":{const t=n;t.body&&t.body.instructions.forEach(l=>o(!1,l.location))}break;default:break}break}}}function _(i){return i.filter(o=>!o.presentation?.hidden).sort((o,n)=>o.presentation?n.presentation?o.presentation.group?n.presentation.group?o.presentation.group!==n.presentation.group?o.presentation.group.localeCompare(n.presentation.group):r(o.presentation.order,n.presentation.order):-1:n.presentation.group?1:r(o.presentation.order,n.presentation.order):-1:n.presentation?1:0)}e.getVisibleAndSorted=_;function r(i,o){return typeof i!="number"?typeof o!="number"?0:1:typeof o!="number"?-1:i-o}async function d(i,o){const n=i.getValue("debug.saveBeforeStart",{overrideIdentifier:o.activeTextEditorLanguageId});if(n!=="none"&&(await o.saveAll(),n==="allEditorsInActiveGroup")){const t=o.activeEditorPane;t&&t.input.resource?.scheme===T.Schemas.untitled&&await o.save({editor:t.input,groupId:t.group.id})}await i.reloadConfiguration()}e.saveAllBeforeDebugStart=d}),define(De[88],Ie([1,0,34,167,74,12,19,22,38]),function(J,e,s,C,p,U,T,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var A;(function(n){n[n.Markup=1]="Markup",n[n.Code=2]="Code"})(A=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",p.Mimes.latex,p.Mimes.markdown,"image/png","image/jpeg",p.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[p.Mimes.latex,p.Mimes.markdown,"application/json",p.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var O;(function(n){n[n.Running=1]="Running",n[n.Idle=2]="Idle"})(O=e.NotebookRunState||(e.NotebookRunState={}));var w;(function(n){n[n.Unconfirmed=1]="Unconfirmed",n[n.Pending=2]="Pending",n[n.Executing=3]="Executing"})(w=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var g;(function(n){n[n.WithHardKernelDependency=0]="WithHardKernelDependency",n[n.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",n[n.Pure=2]="Pure",n[n.Never=3]="Never"})(g=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var S;(function(n){n.Always="always",n.Never="never",n.Optional="optional"})(S=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(n){n[n.ModelChange=1]="ModelChange",n[n.Move=2]="Move",n[n.ChangeCellLanguage=5]="ChangeCellLanguage",n[n.Initialize=6]="Initialize",n[n.ChangeCellMetadata=7]="ChangeCellMetadata",n[n.Output=8]="Output",n[n.OutputItem=9]="OutputItem",n[n.ChangeCellContent=10]="ChangeCellContent",n[n.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",n[n.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",n[n.ChangeCellMime=13]="ChangeCellMime",n[n.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var c;(function(n){n[n.Handle=0]="Handle",n[n.Index=1]="Index"})(c=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(n){n[n.Replace=1]="Replace",n[n.Output=2]="Output",n[n.Metadata=3]="Metadata",n[n.CellLanguage=4]="CellLanguage",n[n.DocumentMetadata=5]="DocumentMetadata",n[n.Move=6]="Move",n[n.OutputItems=7]="OutputItems",n[n.PartialMetadata=8]="PartialMetadata",n[n.PartialInternalMetadata=9]="PartialInternalMetadata"})(h=e.CellEditType||(e.CellEditType={}));var u;(function(n){n.scheme=U.Schemas.vscodeNotebookCell;const t=/^ch(\d{7,})/;function l(R,E){return R.with({scheme:n.scheme,fragment:`ch${E.toString().padStart(7,"0")}${R.scheme!==U.Schemas.file?R.scheme:""}`})}n.generate=l;function v(R){if(R.scheme!==n.scheme)return;const E=t.exec(R.fragment);return E?{handle:Number(E[1]),notebook:R.with({scheme:R.fragment.substring(E[0].length)||U.Schemas.file,fragment:null})}:void 0}n.parse=v;function m(R,E){return R.with({scheme:U.Schemas.vscodeNotebookCellOutput,fragment:`op${E??""},${R.scheme!==U.Schemas.file?R.scheme:""}`})}n.generateCellOutputUri=m;function I(R){if(R.scheme!==U.Schemas.vscodeNotebookCellOutput)return;const E=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(R.fragment);if(!E)return;const M=E[1]&&E[1]!==""?E[1]:void 0,N=E[2];return{outputId:M,notebook:R.with({scheme:N||U.Schemas.file,fragment:null})}}n.parseCellOutputUri=I;function B(R,E,M){return R.with({scheme:M,fragment:`ch${E.toString().padStart(7,"0")}${R.scheme!==U.Schemas.file?R.scheme:""}`})}n.generateCellUri=B;function x(R,E){if(R.scheme!==E)return;const M=t.exec(R.fragment);return M?{handle:Number(M[1]),notebook:R.with({scheme:R.fragment.substring(M[0].length)||U.Schemas.file,fragment:null})}:void 0}n.parseCellUri=x})(u=e.CellUri||(e.CellUri={}));const D=n=>P.isWindows?n.replace(/\//g,"\\"):n;class y{constructor(t=[],l=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=l,this.order=[...new Set(t)].map(v=>({pattern:v,matches:s.parse(D(v))}))}sort(t){const l=new Map(C.Iterable.map(t,m=>[m,D(m)]));let v=[];for(const{matches:m}of this.order)for(const[I,B]of l)if(m(B)){v.push(I),l.delete(I);break}return l.size&&(v=v.concat([...l.keys()].sort((m,I)=>this.defaultOrder.indexOf(m)-this.defaultOrder.indexOf(I)))),v}prioritize(t,l){const v=this.findIndex(t);if(v===-1){this.order.unshift({pattern:t,matches:s.parse(D(t))});return}const m=new Set(l.map(B=>this.findIndex(B,v)));m.delete(-1);const I=Array.from(m).sort();this.order.splice(v+1,0,...I.map(B=>this.order[B]));for(let B=I.length-1;B>=0;B--)this.order.splice(I[B],1)}toArray(){return this.order.map(t=>t.pattern)}findIndex(t,l=this.order.length){const v=D(t);for(let m=0;m<l;m++)if(this.order[m].matches(v))return m;return-1}}e.MimeTypeDisplayOrder=y;function a(n,t,l,v=(m,I)=>m===I){const m=[];function I(R,E,M){if(E===0&&M.length===0)return;const N=m[m.length-1];N&&N.start+N.deleteCount===R?(N.deleteCount+=E,N.toInsert.push(...M)):m.push({start:R,deleteCount:E,toInsert:M})}let B=0,x=0;for(;;){if(B===n.length){I(B,0,t.slice(x));break}if(x===t.length){I(B,n.length-B,[]);break}const R=n[B],E=t[x];if(v(R,E)){B+=1,x+=1;continue}l(E)?(I(B,1,[]),B+=1):(I(B,0,[E]),x+=1)}return m}e.diff=a,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new b.RawContextKey("notebookEditorCursorAtBoundary","none");var _;(function(n){n.default="default",n.option="option"})(_=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(n){const t=n;return!!((typeof t.include=="string"||s.isRelativePattern(t.include))&&(typeof t.exclude=="string"||s.isRelativePattern(t.exclude)))}e.isDocumentExcludePattern=r;function d(n,t,l){if(Array.isArray(n.viewType)&&n.viewType.indexOf(t)>=0||n.viewType===t)return!0;if(n.filenamePattern){const v=r(n.filenamePattern)?n.filenamePattern.include:n.filenamePattern,m=r(n.filenamePattern)?n.filenamePattern.exclude:void 0;if(s.match(v,(0,T.basename)(l.fsPath).toLowerCase()))return!(m&&s.match(m,(0,T.basename)(l.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=d,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",interactiveWindowAlwaysScrollOnNewCell:"interactiveWindow.alwaysScrollOnNewCell"};var i;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class o{static create(t){return`${o._prefix}${t}`}static parse(t){if(t.startsWith(o._prefix))return t.substring(o._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=o,o._prefix="notebook/"}),define(De[168],Ie([1,0,3]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var C;(function(p){p[p.Output=1]="Output",p[p.OutputItems=2]="OutputItems",p[p.ExecutionState=3]="ExecutionState"})(C=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,s.createDecorator)("INotebookExecutionService")}),define(De[169],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function s(p){return[...p.entries()]}e.serializeEnvironmentVariableCollection=s;function C(p){return new Map(p)}e.deserializeEnvironmentVariableCollection=C}),define(De[47],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var s;(function(U){U.Delimiter="\0"})(s=e.TestIdPathParts||(e.TestIdPathParts={}));var C;(function(U){U[U.IsSame=0]="IsSame",U[U.Disconnected=1]="Disconnected",U[U.IsChild=2]="IsChild",U[U.IsParent=3]="IsParent"})(C=e.TestPosition||(e.TestPosition={}));class p{constructor(T,P=T.length){if(this.path=T,this.viewEnd=P,T.length===0||P<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(T,P,b=T.parent){if(T.id===P)return new p([P]);let A=[T.id];for(let O=b;O&&O.id!==P;O=O.parent)A.push(O.id);return A.push(P),new p(A.reverse())}static isRoot(T){return!T.includes("\0")}static root(T){const P=T.indexOf("\0");return P===-1?T:T.slice(0,P)}static fromString(T){return new p(T.split("\0"))}static join(T,P){return new p([...T.path,P])}static joinToString(T,P){return T.toString()+"\0"+P}static compare(T,P){return T===P?0:P.startsWith(T+"\0")?2:T.startsWith(P+"\0")?3:1}get parentId(){return this.viewEnd>1?new p(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let T=1;T<=this.viewEnd;T++)yield new p(this.path,T)}compare(T){if(typeof T=="string")return p.compare(this.toString(),T);for(let P=0;P<T.viewEnd&&P<this.viewEnd;P++)if(T.path[P]!==this.path[P])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=p}),define(De[48],Ie([1,0,2,49]),function(J,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var p;(function(n){n[n.Unset=0]="Unset",n[n.Queued=1]="Queued",n[n.Running=2]="Running",n[n.Passed=3]="Passed",n[n.Failed=4]="Failed",n[n.Skipped=5]="Skipped",n[n.Errored=6]="Errored"})(p=e.TestResultState||(e.TestResultState={}));var U;(function(n){n[n.Run=2]="Run",n[n.Debug=4]="Debug",n[n.Coverage=8]="Coverage",n[n.HasNonDefaultProfile=16]="HasNonDefaultProfile",n[n.HasConfigurable=32]="HasConfigurable"})(U=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var T;(function(n){n.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),n.deserialize=t=>({range:C.Range.lift(t.range),uri:s.URI.revive(t.uri)})})(T=e.IRichLocation||(e.IRichLocation={}));var P;(function(n){n[n.Error=0]="Error",n[n.Output=1]="Output"})(P=e.TestMessageType||(e.TestMessageType={}));var b;(function(n){n.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&T.serialize(t.location)}),n.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&T.deserialize(t.location)})})(b=e.ITestErrorMessage||(e.ITestErrorMessage={}));var A;(function(n){n.serialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&T.serialize(t.location)}),n.deserialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&T.deserialize(t.location)})})(A=e.ITestOutputMessage||(e.ITestOutputMessage={}));var O;(function(n){n.serialize=t=>t.type===0?b.serialize(t):A.serialize(t),n.deserialize=t=>t.type===0?b.deserialize(t):A.deserialize(t)})(O=e.ITestMessage||(e.ITestMessage={}));var w;(function(n){n.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(O.serialize)}),n.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(O.deserialize)})})(w=e.ITestTaskState||(e.ITestTaskState={}));const g="\0",S=(n,t)=>n+g+t;e.namespaceTestTag=S;const f=n=>{const t=n.indexOf(g);return{ctrlId:n.slice(0,t),tagId:n.slice(t+1)}};e.denamespaceTestTag=f;var c;(function(n){n.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),n.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?s.URI.revive(t.uri):void 0,range:t.range?C.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(c=e.ITestItem||(e.ITestItem={}));var h;(function(n){n[n.NotExpandable=0]="NotExpandable",n[n.Expandable=1]="Expandable",n[n.BusyExpanding=2]="BusyExpanding",n[n.Expanded=3]="Expanded"})(h=e.TestItemExpandState||(e.TestItemExpandState={}));var u;(function(n){n.serialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:c.serialize(t.item)}),n.deserialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:c.deserialize(t.item)})})(u=e.InternalTestItem||(e.InternalTestItem={}));var D;(function(n){n.serialize=t=>{let l;return t.item&&(l={},t.item.label!==void 0&&(l.label=t.item.label),t.item.tags!==void 0&&(l.tags=t.item.tags),t.item.busy!==void 0&&(l.busy=t.item.busy),t.item.uri!==void 0&&(l.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(l.range=t.item.range?.toJSON()),t.item.description!==void 0&&(l.description=t.item.description),t.item.error!==void 0&&(l.error=t.item.error),t.item.sortText!==void 0&&(l.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:l}},n.deserialize=t=>{let l;return t.item&&(l={},t.item.label!==void 0&&(l.label=t.item.label),t.item.tags!==void 0&&(l.tags=t.item.tags),t.item.busy!==void 0&&(l.busy=t.item.busy),t.item.range!==void 0&&(l.range=t.item.range?C.Range.lift(t.item.range):null),t.item.description!==void 0&&(l.description=t.item.description),t.item.error!==void 0&&(l.error=t.item.error),t.item.sortText!==void 0&&(l.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:l}}})(D=e.ITestItemUpdate||(e.ITestItemUpdate={}));const y=(n,t)=>{t.expand!==void 0&&(n.expand=t.expand),t.item!==void 0&&(n.item=n.item?Object.assign(n.item,t.item):t.item)};e.applyTestItemUpdate=y;var a;(function(n){n.serialize=(t,l)=>({...u.serialize(t),children:l,ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(w.serialize)})})(a=e.TestResultItem||(e.TestResultItem={}));var _;(function(n){n[n.Function=0]="Function",n[n.Statement=1]="Statement"})(_=e.DetailType||(e.DetailType={}));var r;(function(n){n[n.Add=0]="Add",n[n.Update=1]="Update",n[n.Remove=2]="Remove",n[n.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",n[n.Retire=4]="Retire",n[n.AddTag=5]="AddTag",n[n.RemoveTag=6]="RemoveTag"})(r=e.TestDiffOpType||(e.TestDiffOpType={}));var d;(function(n){n.deserialize=t=>t.op===0?{op:t.op,item:u.deserialize(t.item)}:t.op===1?{op:t.op,item:D.deserialize(t.item)}:t,n.serialize=t=>t.op===0?{op:t.op,item:u.serialize(t.item)}:t.op===1?{op:t.op,item:D.serialize(t.item)}:t})(d=e.TestsDiffOp||(e.TestsDiffOp={}));class i{add(t){}update(t){}remove(t,l){}complete(){}}e.IncrementalChangeCollector=i;class o{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(t){const l=this.createChangeCollector();for(const v of t)switch(v.op){case 0:{const m=u.deserialize(v.item);if(m.parent){if(this.items.has(m.parent)){const I=this.items.get(m.parent);I.children.add(m.item.extId);const B=this.createItem(m,I);this.items.set(m.item.extId,B),l.add(B)}}else{const I=this.createItem(m);this.roots.add(I),this.items.set(m.item.extId,I),l.add(I)}m.expand===2&&this.busyControllerCount++;break}case 1:{const m=D.deserialize(v.item),I=this.items.get(m.extId);if(!I)break;m.expand!==void 0&&(I.expand===2&&this.busyControllerCount--,m.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(I,m),l.update(I);break}case 2:{const m=this.items.get(v.itemId);if(!m)break;m.parent?this.items.get(m.parent).children.delete(m.item.extId):this.roots.delete(m);const I=[[v.itemId]];for(;I.length;)for(const B of I.pop()){const x=this.items.get(B);x&&(I.push(x.children),this.items.delete(B),l.remove(x,x!==m),x.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(v.itemId);break;case 3:this.updatePendingRoots(v.amount);break;case 5:this._tags.set(v.tag.id,v.tag);break;case 6:this._tags.delete(v.id);break}l.complete()}retireTest(t){}updatePendingRoots(t){this.pendingRootCount+=t}createChangeCollector(){return new i}}e.AbstractIncrementalTestCollection=o}),define(De[67],Ie([1,0,13,5,7,9,48,47]),function(J,e,s,C,p,U,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var b;(function(u){u[u.Upsert=0]="Upsert",u[u.SetTags=1]="SetTags",u[u.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",u[u.RemoveChild=3]="RemoveChild",u[u.SetProp=4]="SetProp",u[u.Bulk=5]="Bulk"})(b=e.TestItemEventOp||(e.TestItemEventOp={}));const A=(u,D)=>u===D,O={range:(u,D)=>u===D?!0:!u||!D?!1:u.equalsRange(D),busy:A,label:A,description:A,error:A,tags:(u,D)=>!(u.length!==D.length||u.some(y=>!D.includes(y)))},w=(u,D)=>{let y;for(const[a,_]of Object.entries(O))_(u[a],D[a])||(y?y[a]=D[a]:y={[a]:D[a]});return y};class g extends p.Disposable{constructor(D){super();this.options=D,this.debounceSendDiff=this._register(new s.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new C.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}get root(){return this.options.root}set resolveHandler(D){this._resolveHandler=D;for(const y of this.tree.values())this.updateExpandability(y)}collectDiff(){const D=this.diff;return this.diff=[],D}pushDiff(D){const y=this.diff[this.diff.length-1];if(y&&D.op===1){if(y.op===1&&y.item.extId===D.item.extId){(0,T.applyTestItemUpdate)(y.item,D.item);return}if(y.op===0&&y.item.item.extId===D.item.extId){(0,T.applyTestItemUpdate)(y.item,D.item);return}}this.diff.push(D),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(D,y){const a=this.tree.get(D);if(!!a){if((a.expandLevels===void 0||y>a.expandLevels)&&(a.expandLevels=y),a.expand===1){const _=this.resolveChildren(a);return _.isOpen()?this.expandChildren(a,y-1):_.wait().then(()=>this.expandChildren(a,y-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.expandChildren(a,y-1)):this.expandChildren(a,y-1)}}dispose(){for(const D of this.tree.values())this.options.getApiFor(D.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(D,y){switch(y.op){case 3:this.removeItem(P.TestId.joinToString(D.fullId,y.id));break;case 0:this.upsertItem(y.item,D);break;case 5:for(const a of y.ops)this.onTestItemEvent(D,a);break;case 1:this.diffTagRefs(y.new,y.old,D.fullId.toString());break;case 2:this.updateExpandability(D);break;case 4:this.pushDiff({op:1,item:{extId:D.fullId.toString(),item:y.update}});break;default:(0,U.assertNever)(y)}}upsertItem(D,y){const a=P.TestId.fromExtHostTestItem(D,this.root.id,y?.actual),_=this.options.getApiFor(D);_.parent&&_.parent!==y?.actual&&this.options.getChildren(_.parent).delete(D.id);let r=this.tree.get(a.toString());if(!r){r={fullId:a,actual:D,parent:y?a.parentId:null,expandLevels:y?.expandLevels?y.expandLevels-1:void 0,expand:0},D.tags.forEach(this.incrementTagRefs,this),this.tree.set(r.fullId.toString(),r),this.setItemParent(D,y),this.pushDiff({op:0,item:{parent:r.parent&&r.parent.toString(),controllerId:this.options.controllerId,expand:r.expand,item:this.options.toITestItem(D)}}),this.connectItemAndChildren(D,r,y);return}if(r.actual===D){this.connectItem(D,r,y);return}const d=this.options.getChildren(r.actual),i=r.actual,o=w(this.options.toITestItem(i),this.options.toITestItem(D));this.options.getApiFor(i).listener=void 0,r.actual=D,r.expand=0,o&&(o.hasOwnProperty("tags")&&(this.diffTagRefs(D.tags,i.tags,a.toString()),delete o.tags),this.onTestItemEvent(r,{op:4,update:o})),this.connectItemAndChildren(D,r,y);for(const n of d)this.options.getChildren(D).get(n.id)||this.removeItem(P.TestId.joinToString(a,n.id))}diffTagRefs(D,y,a){const _=new Set(y.map(r=>r.id));for(const r of D)_.delete(r.id)||this.incrementTagRefs(r);this.pushDiff({op:1,item:{extId:a,item:{tags:D.map(r=>(0,T.namespaceTestTag)(this.options.controllerId,r.id))}}}),_.forEach(this.decrementTagRefs,this)}incrementTagRefs(D){const y=this.tags.get(D.id);y?y.refCount++:(this.tags.set(D.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,T.namespaceTestTag)(this.options.controllerId,D.id)}}))}decrementTagRefs(D){const y=this.tags.get(D);y&&!--y.refCount&&(this.tags.delete(D),this.pushDiff({op:6,id:(0,T.namespaceTestTag)(this.options.controllerId,D)}))}setItemParent(D,y){this.options.getApiFor(D).parent=y&&y.actual!==this.root?y.actual:void 0}connectItem(D,y,a){this.setItemParent(D,a);const _=this.options.getApiFor(D);_.parent=a?.actual,_.listener=r=>this.onTestItemEvent(y,r),this.updateExpandability(y)}connectItemAndChildren(D,y,a){this.connectItem(D,y,a);for(const _ of this.options.getChildren(D))this.upsertItem(_,y)}updateExpandability(D){let y;this._resolveHandler?D.resolveBarrier?y=D.resolveBarrier.isOpen()?3:2:y=D.actual.canResolveChildren?1:0:y=0,y!==D.expand&&(D.expand=y,this.pushDiff({op:1,item:{extId:D.fullId.toString(),expand:y}}),y===1&&D.expandLevels!==void 0&&this.resolveChildren(D))}expandChildren(D,y){if(y<0)return;const a=[];for(const _ of this.options.getChildren(D.actual)){const r=this.expand(P.TestId.joinToString(D.fullId,_.id),y);(0,s.isThenable)(r)&&a.push(r)}if(a.length)return Promise.all(a).then(()=>{})}resolveChildren(D){if(D.resolveBarrier)return D.resolveBarrier;if(!this._resolveHandler){const r=new s.Barrier;return r.open(),r}D.expand=2,this.pushExpandStateUpdate(D);const y=D.resolveBarrier=new s.Barrier,a=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,r)};let _;try{_=this._resolveHandler(D.actual===this.root?void 0:D.actual)}catch(r){a(r)}return(0,s.isThenable)(_)?_.catch(a).then(()=>{y.open(),this.updateExpandability(D)}):(y.open(),this.updateExpandability(D)),D.resolveBarrier}pushExpandStateUpdate(D){this.pushDiff({op:1,item:{extId:D.fullId.toString(),expand:D.expand}})}removeItem(D){const y=this.tree.get(D);if(!y)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:D});const a=[y];for(;a.length;){const _=a.pop();if(!!_){this.options.getApiFor(_.actual).listener=void 0;for(const r of _.actual.tags)this.decrementTagRefs(r.id);this.tree.delete(_.fullId.toString());for(const r of this.options.getChildren(_.actual))a.push(this.tree.get(P.TestId.joinToString(_.fullId,r.id)))}}}flushDiff(){const D=this.collectDiff();D.length&&this.diffOpEmitter.fire(D)}}e.TestItemCollection=g;class S extends Error{constructor(D){super(`Attempted to insert a duplicate test item ID ${D}`)}}e.DuplicateTestItemError=S;class f extends Error{constructor(D){super(`TestItem with ID "${D}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class c extends Error{constructor(D,y,a){super(`TestItem with ID "${D}" is from controller "${y}" and cannot be added as a child of an item from controller "${a}".`)}}e.MixedTestItemController=c;const h=(u,D,y)=>{let a=new Map;return{get size(){return a.size},forEach(_,r){for(const d of a.values())_.call(r,d,this)},replace(_){const r=new Map,d=new Set(a.keys()),i={op:5,ops:[]};for(const o of _){if(!(o instanceof y))throw new f(o.id);const n=D(o).controllerId;if(n!==u.controllerId)throw new c(o.id,n,u.controllerId);if(r.has(o.id))throw new S(o.id);r.set(o.id,o),d.delete(o.id),i.ops.push({op:0,item:o})}for(const o of d.keys())i.ops.push({op:3,id:o});u.listener?.(i),a=r},add(_){if(!(_ instanceof y))throw new f(_.id);a.set(_.id,_),u.listener?.({op:0,item:_})},delete(_){a.delete(_)&&u.listener?.({op:3,id:_})},get(_){return a.get(_)},toJSON(){return Array.from(a.values())},[Symbol.iterator](){return a.values()}}};e.createTestItemChildren=h}),define(De[89],Ie([1,0,67]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const C=new WeakMap,p=(T,P)=>{const b={controllerId:P};return C.set(T,b),b};e.createPrivateApiFor=p;const U=T=>{const P=C.get(T);if(!P)throw new s.InvalidTestItemError(T?.id||"<unknown>");return P};e.getPrivateApiFor=U}),define(De[170],Ie([1,0,19,61,9,27,22,76,140,10]),function(J,e,s,C,p,U,T,P,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class O{constructor(g,S,f,c){this._contributedVariables=new Map,this._context=g,this._labelService=S,this._userHomePromise=f,c&&(this._envVariablesPromise=c.then(h=>this.prepareEnv(h)))}prepareEnv(g){if(T.isWindows){const S=Object.create(null);return Object.keys(g).forEach(f=>{S[f.toLowerCase()]=g[f]}),S}return g}resolveWithEnvironment(g,S,f){return this.recursiveResolve({env:this.prepareEnv(g),userHome:void 0},S?S.uri:void 0,f)}async resolveAsync(g,S){const f={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(f,g?g.uri:void 0,S)}async resolveAnyBase(g,S,f,c){const h=U.deepClone(S);T.isWindows&&h.windows?Object.keys(h.windows).forEach(D=>h[D]=h.windows[D]):T.isMacintosh&&h.osx?Object.keys(h.osx).forEach(D=>h[D]=h.osx[D]):T.isLinux&&h.linux&&Object.keys(h.linux).forEach(D=>h[D]=h.linux[D]),delete h.windows,delete h.osx,delete h.linux;const u={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(u,g?g.uri:void 0,h,f,c)}async resolveAnyAsync(g,S,f){return this.resolveAnyBase(g,S,f)}async resolveAnyMap(g,S,f){const c=new Map;return{newConfig:await this.resolveAnyBase(g,S,f,c),resolvedVariables:c}}resolveWithInteractionReplace(g,S,f,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(g,S,f,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(g,S){if(this._contributedVariables.has(g))throw new Error("Variable "+g+" is contributed twice.");this._contributedVariables.set(g,S)}async recursiveResolve(g,S,f,c,h){if(p.isString(f))return this.resolveString(g,S,f,c,h);if(p.isArray(f))return Promise.all(f.map(u=>this.recursiveResolve(g,S,u,c,h)));if(p.isObject(f)){let u=Object.create(null);const D=await Promise.all(Object.keys(f).map(async y=>[await this.resolveString(g,S,y,c,h),await this.recursiveResolve(g,S,f[y],c,h)]));for(const[y,a]of D)u[y]=a;return u}return f}resolveString(g,S,f,c,h){return(0,A.replaceAsync)(f,O.VARIABLE_REGEXP,async(u,D)=>{if(D.includes(O.VARIABLE_LHS))return u;let y=await this.evaluateSingleVariable(g,u,D,S,c);return h&&h.set(D,y),y!==u&&p.isString(y)&&y.match(O.VARIABLE_REGEXP)&&(y=await this.resolveString(g,S,y,c,h)),y})}fsPath(g){return this._labelService?this._labelService.getUriLabel(g,{noPrefix:!0}):g.fsPath}async evaluateSingleVariable(g,S,f,c,h){let u;const D=f.split(":");D.length>1&&(f=D[0],u=D[1]);const y=()=>{const r=this._context.getFilePath();if(r)return r;throw new Error((0,b.localize)(0,null,S))},a=()=>{const r=y();if(this._context.getWorkspaceFolderPathForFile){const d=this._context.getWorkspaceFolderPathForFile();if(d)return d}throw new Error((0,b.localize)(1,null,S,s.basename(r)))},_=()=>{if(u){const r=this._context.getFolderUri(u);if(r)return r;throw new Error((0,b.localize)(2,null,S,u))}if(c)return c;throw this._context.getWorkspaceFolderCount()>1?new Error((0,b.localize)(3,null,S)):new Error((0,b.localize)(4,null,S))};switch(f){case"env":if(u){if(g.env){const r=g.env[T.isWindows?u.toLowerCase():u];if(p.isString(r))return r}return""}throw new Error((0,b.localize)(5,null,S));case"config":if(u){const r=this._context.getConfigurationValue(c,u);if(p.isUndefinedOrNull(r))throw new Error((0,b.localize)(6,null,S,u));if(p.isObject(r))throw new Error((0,b.localize)(7,null,S,u));return r}throw new Error((0,b.localize)(8,null,S));case"command":return this.resolveFromMap(S,u,h,"command");case"input":return this.resolveFromMap(S,u,h,"input");case"extensionInstallFolder":if(u){const r=await this._context.getExtension(u);if(!r)throw new Error((0,b.localize)(9,null,S,u));return this.fsPath(r.extensionLocation)}throw new Error((0,b.localize)(10,null,S));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(_()));case"cwd":return c||u?(0,P.normalizeDriveLetter)(this.fsPath(_())):C.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return s.basename(this.fsPath(_()));case"userHome":{if(g.userHome)return g.userHome;throw new Error((0,b.localize)(11,null,S))}case"lineNumber":{const r=this._context.getLineNumber();if(r)return r;throw new Error((0,b.localize)(12,null,S))}case"selectedText":{const r=this._context.getSelectedText();if(r)return r;throw new Error((0,b.localize)(13,null,S))}case"file":return y();case"fileWorkspaceFolder":return a();case"relativeFile":return c||u?s.relative(this.fsPath(_()),y()):y();case"relativeFileDirname":{const r=s.dirname(y());if(c||u){const d=s.relative(this.fsPath(_()),r);return d.length===0?".":d}return r}case"fileDirname":return s.dirname(y());case"fileExtname":return s.extname(y());case"fileBasename":return s.basename(y());case"fileBasenameNoExtension":{const r=s.basename(y());return r.slice(0,r.length-s.extname(r).length)}case"fileDirnameBasename":return s.basename(s.dirname(y()));case"execPath":{const r=this._context.getExecPath();return r||S}case"execInstallFolder":{const r=this._context.getAppRoot();return r||S}case"pathSeparator":return s.sep;default:try{const r=u?`${f}:${u}`:f;return this.resolveFromMap(S,r,h,void 0)}catch{return S}}}}resolveFromMap(g,S,f,c){if(S&&f){const h=c===void 0?f[S]:f[c+":"+S];if(typeof h=="string")return h;throw new Error((0,b.localize)(14,null,g))}return g}}e.AbstractVariableResolverService=O,O.VARIABLE_LHS="${",O.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(De[90],Ie([1,0,3,162]),function(J,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,s.createDecorator)("editorGroupsService");var p;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(p=e.GroupDirection||(e.GroupDirection={}));var U;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(U=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var P;(function(f){f[f.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(P=e.GroupsArrangement||(e.GroupsArrangement={}));var b;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(b=e.MergeGroupMode||(e.MergeGroupMode={}));function A(f){const c=f;return(0,C.isEditorInput)(c?.editor)&&(0,C.isEditorInput)(c?.replacement)}e.isEditorReplacement=A;var O;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O=e.GroupsOrder||(e.GroupsOrder={}));var w;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(w=e.OpenEditorContext||(e.OpenEditorContext={}));function g(f){const c=f;return!!c&&typeof c.id=="number"&&Array.isArray(c.editors)}e.isEditorGroup=g;function S(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=S}),define(De[171],Ie([1,0,3,90]),function(J,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,s.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function p(U){const T=U;return typeof U=="number"||(0,C.isEditorGroup)(T)}e.isPreferredGroup=p}),define(De[8],Ie([1,0,15,23,75,24,105,57,27,9,2,49,68,143,80,89,88,47,48,171,6,172]),function(J,e,s,C,p,U,T,P,b,A,O,w,g,S,f,c,h,u,D,y,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.SnippetTextEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(we){function Ce(j){const{selectionStartLineNumber:ye,selectionStartColumn:Me,positionLineNumber:Je,positionColumn:Ve}=j,ut=new a.Position(ye-1,Me-1),ht=new a.Position(Je-1,Ve-1);return new a.Selection(ut,ht)}we.to=Ce;function ue(j){const{anchor:ye,active:Me}=j;return{selectionStartLineNumber:ye.line+1,selectionStartColumn:ye.character+1,positionLineNumber:Me.line+1,positionColumn:Me.character+1}}we.from=ue})(r=e.Selection||(e.Selection={}));var d;(function(we){function Ce(j){if(!j)return;const{start:ye,end:Me}=j;return{startLineNumber:ye.line+1,startColumn:ye.character+1,endLineNumber:Me.line+1,endColumn:Me.character+1}}we.from=Ce;function ue(j){if(!j)return;const{startLineNumber:ye,startColumn:Me,endLineNumber:Je,endColumn:Ve}=j;return new a.Range(ye-1,Me-1,Je-1,Ve-1)}we.to=ue})(d=e.Range||(e.Range={}));var i;(function(we){function Ce(ue){switch(ue){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 3:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}we.to=Ce})(i=e.TokenType||(e.TokenType={}));var o;(function(we){function Ce(j){return new a.Position(j.lineNumber-1,j.column-1)}we.to=Ce;function ue(j){return{lineNumber:j.line+1,column:j.character+1}}we.from=ue})(o=e.Position||(e.Position={}));var n;(function(we){function Ce(ye,Me){return(0,s.coalesce)((0,s.asArray)(ye).map(Je=>ue(Je,Me)))}we.from=Ce;function ue(ye,Me){if(typeof ye=="string")return{$serialized:!0,language:ye};if(ye)return{$serialized:!0,language:ye.language,scheme:j(ye.scheme,Me),pattern:Ge.from(ye.pattern)??void 0,exclusive:ye.exclusive,notebookType:ye.notebookType}}function j(ye,Me){return Me&&typeof ye=="string"?Me.transformOutgoingScheme(ye):ye}})(n=e.DocumentSelector||(e.DocumentSelector={}));var t;(function(we){function Ce(j){switch(j){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}we.from=Ce;function ue(j){switch(j){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}we.to=ue})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var l;(function(we){function Ce(j){let ye;return j.code&&((0,A.isString)(j.code)||(0,A.isNumber)(j.code)?ye=String(j.code):ye={value:String(j.code.value),target:j.code.target}),{...d.from(j.range),message:j.message,source:j.source,code:ye,severity:m.from(j.severity),relatedInformation:j.relatedInformation&&j.relatedInformation.map(v.from),tags:Array.isArray(j.tags)?(0,s.coalesce)(j.tags.map(t.from)):void 0}}we.from=Ce;function ue(j){const ye=new a.Diagnostic(d.to(j),j.message,m.to(j.severity));return ye.source=j.source,ye.code=(0,A.isString)(j.code)?j.code:j.code?.value,ye.relatedInformation=j.relatedInformation&&j.relatedInformation.map(v.to),ye.tags=j.tags&&(0,s.coalesce)(j.tags.map(t.to)),ye}we.to=ue})(l=e.Diagnostic||(e.Diagnostic={}));var v;(function(we){function Ce(j){return{...d.from(j.location.range),message:j.message,resource:j.location.uri}}we.from=Ce;function ue(j){return new a.DiagnosticRelatedInformation(new a.Location(j.resource,d.to(j)),j.message)}we.to=ue})(v=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var m;(function(we){function Ce(j){switch(j){case a.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}we.from=Ce;function ue(j){switch(j){case f.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}we.to=ue})(m=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var I;(function(we){function Ce(j){return typeof j=="number"&&j>=a.ViewColumn.One?j-1:j===a.ViewColumn.Beside?y.SIDE_GROUP:y.ACTIVE_GROUP}we.from=Ce;function ue(j){if(typeof j=="number"&&j>=0)return j+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=ue})(I=e.ViewColumn||(e.ViewColumn={}));function B(we){return typeof we.range!="undefined"}function x(we){return we.length===0?!0:!!B(we[0])}e.isDecorationOptionsArr=x;var R;(function(we){function Ce(Ve){return Ve.map(we.from)}we.fromMany=Ce;function ue(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function j(Ve){let ut;if(ue(Ve)){const{language:Ct,value:Rt}=Ve;ut={value:"```"+Ct+`
`+Rt+"\n```\n"}}else a.MarkdownString.isMarkdownString(Ve)?ut={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?ut={value:Ve}:ut={value:""};const ht=Object.create(null);ut.uris=ht;const Et=Ct=>{try{let Rt=O.URI.parse(Ct,!0);Rt=Rt.with({query:ye(Rt.query,ht)}),ht[Ct]=Rt}catch{}return""},ft=new T.marked.Renderer;return ft.link=Et,ft.image=Ct=>typeof Ct=="string"?Et(p.parseHrefAndDimensions(Ct).href):"",(0,T.marked)(ut.value,{renderer:ft}),ut}we.from=j;function ye(Ve,ut){if(!Ve)return Ve;let ht;try{ht=(0,P.parse)(Ve)}catch{}if(!ht)return Ve;let Et=!1;return ht=(0,b.cloneAndChange)(ht,ft=>{if(O.URI.isUri(ft)){const Ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[Ct]=ft,Et=!0,Ct}else return}),Et?JSON.stringify(ht):Ve}function Me(Ve){const ut=new a.MarkdownString(Ve.value,Ve.supportThemeIcons);return ut.isTrusted=Ve.isTrusted,ut.supportHtml=Ve.supportHtml,ut.baseUri=Ve.baseUri?O.URI.from(Ve.baseUri):void 0,ut}we.to=Me;function Je(Ve){if(!!Ve)return typeof Ve=="string"?Ve:we.from(Ve)}we.fromStrict=Je})(R=e.MarkdownString||(e.MarkdownString={}));function E(we){return x(we)?we.map(Ce=>({range:d.from(Ce.range),hoverMessage:Array.isArray(Ce.hoverMessage)?R.fromMany(Ce.hoverMessage):Ce.hoverMessage?R.from(Ce.hoverMessage):void 0,renderOptions:Ce.renderOptions})):we.map(Ce=>({range:d.from(Ce)}))}e.fromRangeOrRangeWithMessage=E;function M(we){return typeof we=="undefined"?we:typeof we=="string"?O.URI.file(we):we}e.pathOrURIToURI=M;var N;(function(we){function Ce(ue){return typeof ue=="undefined"?ue:{contentText:ue.contentText,contentIconPath:ue.contentIconPath?M(ue.contentIconPath):void 0,border:ue.border,borderColor:ue.borderColor,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,color:ue.color,backgroundColor:ue.backgroundColor,margin:ue.margin,width:ue.width,height:ue.height}}we.from=Ce})(N=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var W;(function(we){function Ce(ue){return typeof ue=="undefined"?ue:{backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?M(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?N.from(ue.before):void 0,after:ue.after?N.from(ue.after):void 0}}we.from=Ce})(W=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var Z;(function(we){function Ce(ue){if(typeof ue=="undefined")return ue;switch(ue){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}we.from=Ce})(Z=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var K;(function(we){function Ce(ue){return{isWholeLine:ue.isWholeLine,rangeBehavior:ue.rangeBehavior?Z.from(ue.rangeBehavior):void 0,overviewRulerLane:ue.overviewRulerLane,light:ue.light?W.from(ue.light):void 0,dark:ue.dark?W.from(ue.dark):void 0,backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?M(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?N.from(ue.before):void 0,after:ue.after?N.from(ue.after):void 0}}we.from=Ce})(K=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var F;(function(we){function Ce(j){return{text:j.newText,eol:j.newEol&&q.from(j.newEol),range:d.from(j.range)}}we.from=Ce;function ue(j){const ye=new a.TextEdit(d.to(j.range),j.text);return ye.newEol=typeof j.eol=="undefined"?void 0:q.to(j.eol),ye}we.to=ue})(F=e.TextEdit||(e.TextEdit={}));var oe;(function(we){function Ce(ue){return{range:d.from(ue.range),snippet:ue.snippet.value}}we.from=Ce})(oe=e.SnippetTextEdit||(e.SnippetTextEdit={}));var ce;(function(we){function Ce(j,ye){const Me={edits:[]};if(j instanceof a.WorkspaceEdit){const Je=new U.ResourceSet;for(const Ve of j._allEntries())Ve._type===1&&O.URI.isUri(Ve.to)&&Ve.from===void 0&&Je.add(Ve.to);for(const Ve of j._allEntries())Ve._type===1?Me.edits.push({_type:1,oldUri:Ve.from,newUri:Ve.to,options:Ve.options,metadata:Ve.metadata}):Ve._type===2?Me.edits.push({_type:2,resource:Ve.uri,edit:F.from(Ve.edit),modelVersionId:Je.has(Ve.uri)?void 0:ye?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?Me.edits.push({_type:3,metadata:Ve.metadata,resource:Ve.uri,edit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:ye?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&Me.edits.push({_type:3,metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:ye?.getNotebookDocumentVersion(Ve.uri),edit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(it.from)}})}return Me}we.from=Ce;function ue(j){const ye=new a.WorkspaceEdit;for(const Me of j.edits)Me.edit?ye.replace(O.URI.revive(Me.resource),d.to(Me.edit.range),Me.edit.text):ye.renameFile(O.URI.revive(Me.oldUri),O.URI.revive(Me.newUri),Me.options);return ye}we.to=ue})(ce=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ae;(function(we){const Ce=Object.create(null);Ce[a.SymbolKind.File]=0,Ce[a.SymbolKind.Module]=1,Ce[a.SymbolKind.Namespace]=2,Ce[a.SymbolKind.Package]=3,Ce[a.SymbolKind.Class]=4,Ce[a.SymbolKind.Method]=5,Ce[a.SymbolKind.Property]=6,Ce[a.SymbolKind.Field]=7,Ce[a.SymbolKind.Constructor]=8,Ce[a.SymbolKind.Enum]=9,Ce[a.SymbolKind.Interface]=10,Ce[a.SymbolKind.Function]=11,Ce[a.SymbolKind.Variable]=12,Ce[a.SymbolKind.Constant]=13,Ce[a.SymbolKind.String]=14,Ce[a.SymbolKind.Number]=15,Ce[a.SymbolKind.Boolean]=16,Ce[a.SymbolKind.Array]=17,Ce[a.SymbolKind.Object]=18,Ce[a.SymbolKind.Key]=19,Ce[a.SymbolKind.Null]=20,Ce[a.SymbolKind.EnumMember]=21,Ce[a.SymbolKind.Struct]=22,Ce[a.SymbolKind.Event]=23,Ce[a.SymbolKind.Operator]=24,Ce[a.SymbolKind.TypeParameter]=25;function ue(ye){return typeof Ce[ye]=="number"?Ce[ye]:6}we.from=ue;function j(ye){for(const Me in Ce)if(Ce[Me]===ye)return Number(Me);return a.SymbolKind.Property}we.to=j})(ae=e.SymbolKind||(e.SymbolKind={}));var fe;(function(we){function Ce(j){switch(j){case a.SymbolTag.Deprecated:return 1}}we.from=Ce;function ue(j){switch(j){case 1:return a.SymbolTag.Deprecated}}we.to=ue})(fe=e.SymbolTag||(e.SymbolTag={}));var ie;(function(we){function Ce(j){return{name:j.name,kind:ae.from(j.kind),tags:j.tags&&j.tags.map(fe.from),containerName:j.containerName,location:Re.from(j.location)}}we.from=Ce;function ue(j){const ye=new a.SymbolInformation(j.name,ae.to(j.kind),j.containerName,Re.to(j.location));return ye.tags=j.tags&&j.tags.map(fe.to),ye}we.to=ue})(ie=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Ee;(function(we){function Ce(j){const ye={name:j.name||"!!MISSING: name!!",detail:j.detail,range:d.from(j.range),selectionRange:d.from(j.selectionRange),kind:ae.from(j.kind),tags:j.tags?.map(fe.from)??[]};return j.children&&(ye.children=j.children.map(Ce)),ye}we.from=Ce;function ue(j){const ye=new a.DocumentSymbol(j.name,j.detail,ae.to(j.kind),d.to(j.range),d.to(j.selectionRange));return(0,s.isNonEmptyArray)(j.tags)&&(ye.tags=j.tags.map(fe.to)),j.children&&(ye.children=j.children.map(ue)),ye}we.to=ue})(Ee=e.DocumentSymbol||(e.DocumentSymbol={}));var be;(function(we){function Ce(j){const ye=new a.CallHierarchyItem(ae.to(j.kind),j.name,j.detail||"",O.URI.revive(j.uri),d.to(j.range),d.to(j.selectionRange));return ye._sessionId=j._sessionId,ye._itemId=j._itemId,ye}we.to=Ce;function ue(j,ye,Me){if(ye=ye??j._sessionId,Me=Me??j._itemId,ye===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:ye,_itemId:Me,name:j.name,detail:j.detail,kind:ae.from(j.kind),uri:j.uri,range:d.from(j.range),selectionRange:d.from(j.selectionRange),tags:j.tags?.map(fe.from)}}we.from=ue})(be=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ee;(function(we){function Ce(ue){return new a.CallHierarchyIncomingCall(be.to(ue.from),ue.fromRanges.map(j=>d.to(j)))}we.to=Ce})(ee=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ve;(function(we){function Ce(ue){return new a.CallHierarchyOutgoingCall(be.to(ue.to),ue.fromRanges.map(j=>d.to(j)))}we.to=Ce})(ve=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Re;(function(we){function Ce(j){return{range:j.range&&d.from(j.range),uri:j.uri}}we.from=Ce;function ue(j){return new a.Location(O.URI.revive(j.uri),d.to(j.range))}we.to=ue})(Re=e.location||(e.location={}));var Fe;(function(we){function Ce(j){const ye=j,Me=j;return{originSelectionRange:ye.originSelectionRange?d.from(ye.originSelectionRange):void 0,uri:ye.targetUri?ye.targetUri:Me.uri,range:d.from(ye.targetRange?ye.targetRange:Me.range),targetSelectionRange:ye.targetSelectionRange?d.from(ye.targetSelectionRange):void 0}}we.from=Ce;function ue(j){return{targetUri:O.URI.revive(j.uri),targetRange:d.to(j.range),targetSelectionRange:j.targetSelectionRange?d.to(j.targetSelectionRange):void 0,originSelectionRange:j.originSelectionRange?d.to(j.originSelectionRange):void 0}}we.to=ue})(Fe=e.DefinitionLink||(e.DefinitionLink={}));var We;(function(we){function Ce(j){return{range:d.from(j.range),contents:R.fromMany(j.contents)}}we.from=Ce;function ue(j){return new a.Hover(j.contents.map(R.to),d.to(j.range))}we.to=ue})(We=e.Hover||(e.Hover={}));var Xe;(function(we){function Ce(j){return{range:d.from(j.range),expression:j.expression}}we.from=Ce;function ue(j){return new a.EvaluatableExpression(d.to(j.range),j.expression)}we.to=ue})(Xe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Te;(function(we){function Ce(j){if(j instanceof a.InlineValueText)return{type:"text",range:d.from(j.range),text:j.text};if(j instanceof a.InlineValueVariableLookup)return{type:"variable",range:d.from(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};if(j instanceof a.InlineValueEvaluatableExpression)return{type:"expression",range:d.from(j.range),expression:j.expression};throw new Error("Unknown 'InlineValue' type")}we.from=Ce;function ue(j){switch(j.type){case"text":return{range:d.to(j.range),text:j.text};case"variable":return{range:d.to(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};case"expression":return{range:d.to(j.range),expression:j.expression}}}we.to=ue})(Te=e.InlineValue||(e.InlineValue={}));var Se;(function(we){function Ce(j){return{frameId:j.frameId,stoppedLocation:d.from(j.stoppedLocation)}}we.from=Ce;function ue(j){return new a.InlineValueContext(j.frameId,d.to(j.stoppedLocation))}we.to=ue})(Se=e.InlineValueContext||(e.InlineValueContext={}));var ke;(function(we){function Ce(j){return{range:d.from(j.range),kind:j.kind}}we.from=Ce;function ue(j){return new a.DocumentHighlight(d.to(j.range),j.kind)}we.to=ue})(ke=e.DocumentHighlight||(e.DocumentHighlight={}));var se;(function(we){function Ce(ue){switch(ue){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}we.to=Ce})(se=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var le;(function(we){function Ce(ue){return{triggerKind:se.to(ue.triggerKind),triggerCharacter:ue.triggerCharacter}}we.to=Ce})(le=e.CompletionContext||(e.CompletionContext={}));var G;(function(we){function Ce(j){switch(j){case a.CompletionItemTag.Deprecated:return 1}}we.from=Ce;function ue(j){switch(j){case 1:return a.CompletionItemTag.Deprecated}}we.to=ue})(G=e.CompletionItemTag||(e.CompletionItemTag={}));var X;(function(we){const Ce=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function ue(Me){return Ce.get(Me)??9}we.from=ue;const j=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function ye(Me){return j.get(Me)??a.CompletionItemKind.Property}we.to=ye})(X=e.CompletionItemKind||(e.CompletionItemKind={}));var k;(function(we){function Ce(ue,j){const ye=new a.CompletionItem(ue.label);return ye.insertText=ue.insertText,ye.kind=X.to(ue.kind),ye.tags=ue.tags?.map(G.to),ye.detail=ue.detail,ye.documentation=p.isMarkdownString(ue.documentation)?R.to(ue.documentation):ue.documentation,ye.sortText=ue.sortText,ye.filterText=ue.filterText,ye.preselect=ue.preselect,ye.commitCharacters=ue.commitCharacters,w.Range.isIRange(ue.range)?ye.range=d.to(ue.range):typeof ue.range=="object"&&(ye.range={inserting:d.to(ue.range.insert),replacing:d.to(ue.range.replace)}),ye.keepWhitespace=typeof ue.insertTextRules=="undefined"?!1:Boolean(ue.insertTextRules&1),typeof ue.insertTextRules!="undefined"&&ue.insertTextRules&4?ye.insertText=new a.SnippetString(ue.insertText):(ye.insertText=ue.insertText,ye.textEdit=ye.range instanceof a.Range?new a.TextEdit(ye.range,ye.insertText):void 0),ue.additionalTextEdits&&ue.additionalTextEdits.length>0&&(ye.additionalTextEdits=ue.additionalTextEdits.map(Me=>F.to(Me))),ye.command=j&&ue.command?j.fromInternal(ue.command):void 0,ye}we.to=Ce})(k=e.CompletionItem||(e.CompletionItem={}));var z;(function(we){function Ce(j){return{label:j.label,documentation:R.fromStrict(j.documentation)}}we.from=Ce;function ue(j){return{label:j.label,documentation:p.isMarkdownString(j.documentation)?R.to(j.documentation):j.documentation}}we.to=ue})(z=e.ParameterInformation||(e.ParameterInformation={}));var H;(function(we){function Ce(j){return{label:j.label,documentation:R.fromStrict(j.documentation),parameters:Array.isArray(j.parameters)?j.parameters.map(z.from):[],activeParameter:j.activeParameter}}we.from=Ce;function ue(j){return{label:j.label,documentation:p.isMarkdownString(j.documentation)?R.to(j.documentation):j.documentation,parameters:Array.isArray(j.parameters)?j.parameters.map(z.to):[],activeParameter:j.activeParameter}}we.to=ue})(H=e.SignatureInformation||(e.SignatureInformation={}));var V;(function(we){function Ce(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(H.from):[]}}we.from=Ce;function ue(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(H.to):[]}}we.to=ue})(V=e.SignatureHelp||(e.SignatureHelp={}));var re;(function(we){function Ce(ue,j){const ye=new a.InlayHint(o.to(j.position),typeof j.label=="string"?j.label:j.label.map(de.to.bind(void 0,ue)),j.kind&&Q.to(j.kind));return ye.textEdits=j.textEdits&&j.textEdits.map(F.to),ye.tooltip=p.isMarkdownString(j.tooltip)?R.to(j.tooltip):j.tooltip,ye.paddingLeft=j.paddingLeft,ye.paddingRight=j.paddingRight,ye}we.to=Ce})(re=e.InlayHint||(e.InlayHint={}));var de;(function(we){function Ce(ue,j){const ye=new a.InlayHintLabelPart(j.label);return ye.tooltip=p.isMarkdownString(j.tooltip)?R.to(j.tooltip):j.tooltip,g.Command.is(j.command)&&(ye.command=ue.fromInternal(j.command)),j.location&&(ye.location=Re.to(j.location)),ye}we.to=Ce})(de=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Q;(function(we){function Ce(j){return j}we.from=Ce;function ue(j){return j}we.to=ue})(Q=e.InlayHintKind||(e.InlayHintKind={}));var pe;(function(we){function Ce(j){return{range:d.from(j.range),url:j.target,tooltip:j.tooltip}}we.from=Ce;function ue(j){let ye;if(j.url)try{ye=typeof j.url=="string"?O.URI.parse(j.url,!0):O.URI.revive(j.url)}catch{}return new a.DocumentLink(d.to(j.range),ye)}we.to=ue})(pe=e.DocumentLink||(e.DocumentLink={}));var ge;(function(we){function Ce(j){const ye=new a.ColorPresentation(j.label);return j.textEdit&&(ye.textEdit=F.to(j.textEdit)),j.additionalTextEdits&&(ye.additionalTextEdits=j.additionalTextEdits.map(Me=>F.to(Me))),ye}we.to=Ce;function ue(j){return{label:j.label,textEdit:j.textEdit?F.from(j.textEdit):void 0,additionalTextEdits:j.additionalTextEdits?j.additionalTextEdits.map(ye=>F.from(ye)):void 0}}we.from=ue})(ge=e.ColorPresentation||(e.ColorPresentation={}));var Ne;(function(we){function Ce(j){return new a.Color(j[0],j[1],j[2],j[3])}we.to=Ce;function ue(j){return[j.red,j.green,j.blue,j.alpha]}we.from=ue})(Ne=e.Color||(e.Color={}));var Be;(function(we){function Ce(j){return{range:d.from(j.range)}}we.from=Ce;function ue(j){return new a.SelectionRange(d.to(j.range))}we.to=ue})(Be=e.SelectionRange||(e.SelectionRange={}));var Pe;(function(we){function Ce(ue){switch(ue){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}we.to=Ce})(Pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ke;(function(we){function Ce(j){switch(j){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}we.from=Ce;function ue(j){switch(j){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}we.to=ue})(Ke=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var q;(function(we){function Ce(j){if(j===a.EndOfLine.CRLF)return 1;if(j===a.EndOfLine.LF)return 0}we.from=Ce;function ue(j){if(j===1)return a.EndOfLine.CRLF;if(j===0)return a.EndOfLine.LF}we.to=ue})(q=e.EndOfLine||(e.EndOfLine={}));var Y;(function(we){function Ce(ue){if(typeof ue=="object")return ue.viewId;switch(ue){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}we.from=Ce})(Y=e.ProgressLocation||(e.ProgressLocation={}));var me;(function(we){function Ce(ue){const j={start:ue.start+1,end:ue.end+1};return ue.kind&&(j.kind=Le.from(ue.kind)),j}we.from=Ce})(me=e.FoldingRange||(e.FoldingRange={}));var Le;(function(we){function Ce(ue){if(ue)switch(ue){case a.FoldingRangeKind.Comment:return g.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports:return g.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region:return g.FoldingRangeKind.Region}}we.from=Ce})(Le=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ze;(function(we){function Ce(ue){if(ue)return{pinned:typeof ue.preview=="boolean"?!ue.preview:void 0,inactive:ue.background,preserveFocus:ue.preserveFocus,selection:typeof ue.selection=="object"?d.from(ue.selection):void 0,override:typeof ue.override=="boolean"?S.EditorResolution.DISABLED:void 0}}we.from=Ce})(ze=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ge;(function(we){function Ce(Me){return Me instanceof a.RelativePattern?Me.toJSON():typeof Me=="string"?Me:ue(Me)||j(Me)?new a.RelativePattern(Me.baseUri??Me.base,Me.pattern).toJSON():Me}we.from=Ce;function ue(Me){const Je=Me;return Je?O.URI.isUri(Je.baseUri)&&typeof Je.pattern=="string":!1}function j(Me){const Je=Me;return Je?typeof Je.base=="string"&&typeof Je.pattern=="string":!1}function ye(Me){return typeof Me=="string"?Me:new a.RelativePattern(O.URI.revive(Me.baseUri),Me.pattern)}we.to=ye})(Ge=e.GlobPattern||(e.GlobPattern={}));var Ze;(function(we){function Ce(ue){if(ue){if(Array.isArray(ue))return ue.map(Ce);if(typeof ue=="string")return ue;{const j=ue;return{language:j.language,scheme:j.scheme,pattern:Ge.from(j.pattern),exclusive:j.exclusive,notebookType:j.notebookType}}}else return}we.from=Ce})(Ze=e.LanguageSelector||(e.LanguageSelector={}));var ot;(function(we){function Ce(j){return{start:j.start,end:j.end}}we.from=Ce;function ue(j){return new a.NotebookRange(j.start,j.end)}we.to=ue})(ot=e.NotebookRange||(e.NotebookRange={}));var Qe;(function(we){function Ce(j){return{timing:typeof j.runStartTime=="number"&&typeof j.runEndTime=="number"?{startTime:j.runStartTime,endTime:j.runEndTime}:void 0,executionOrder:j.executionOrder,success:j.lastRunSuccess}}we.to=Ce;function ue(j){return{lastRunSuccess:j.success,runStartTime:j.timing?.startTime,runEndTime:j.timing?.endTime,executionOrder:j.executionOrder}}we.from=ue})(Qe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var et;(function(we){function Ce(ue){if(ue===h.NotebookCellExecutionState.Executing)return a.NotebookCellExecutionState.Executing;if(ue===h.NotebookCellExecutionState.Pending)return a.NotebookCellExecutionState.Pending;if(ue===h.NotebookCellExecutionState.Unconfirmed)return a.NotebookCellExecutionState.Pending;throw new Error(`Unknown state: ${ue}`)}we.to=Ce})(et=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var qe;(function(we){function Ce(j){switch(j){case a.NotebookCellKind.Markup:return h.CellKind.Markup;case a.NotebookCellKind.Code:default:return h.CellKind.Code}}we.from=Ce;function ue(j){switch(j){case h.CellKind.Markup:return a.NotebookCellKind.Markup;case h.CellKind.Code:default:return a.NotebookCellKind.Code}}we.to=ue})(qe=e.NotebookCellKind||(e.NotebookCellKind={}));var st;(function(we){function Ce(j){const ye={metadata:j.metadata??Object.create(null),cells:[]};for(let Me of j.cells)a.NotebookCellData.validate(Me),ye.cells.push(it.from(Me));return ye}we.from=Ce;function ue(j){const ye=new a.NotebookData(j.cells.map(it.to));return(0,A.isEmptyObject)(j.metadata)||(ye.metadata=j.metadata),ye}we.to=ue})(st=e.NotebookData||(e.NotebookData={}));var it;(function(we){function Ce(j){return{cellKind:qe.from(j.kind),language:j.languageId,mime:j.mime,source:j.value,metadata:j.metadata,internalMetadata:Qe.from(j.executionSummary??{}),outputs:j.outputs?j.outputs.map(ct.from):[]}}we.from=Ce;function ue(j){return new a.NotebookCellData(qe.to(j.cellKind),j.source,j.language,j.mime,j.outputs?j.outputs.map(ct.to):void 0,j.metadata,j.internalMetadata?Qe.to(j.internalMetadata):void 0)}we.to=ue})(it=e.NotebookCellData||(e.NotebookCellData={}));var lt;(function(we){function Ce(j){return{mime:j.mime,valueBytes:C.VSBuffer.wrap(j.data)}}we.from=Ce;function ue(j){return new a.NotebookCellOutputItem(j.valueBytes.buffer,j.mime)}we.to=ue})(lt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ct;(function(we){function Ce(j){return{outputId:j.id,items:j.items.map(lt.from),metadata:j.metadata}}we.from=Ce;function ue(j){const ye=j.items.map(lt.to);return new a.NotebookCellOutput(ye,j.outputId,j.metadata)}we.to=ue})(ct=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Pt;(function(we){function Ce(ye){return j(ye)?{include:(0,A.withNullAsUndefined)(Ge.from(ye.include)),exclude:(0,A.withNullAsUndefined)(Ge.from(ye.exclude))}:(0,A.withNullAsUndefined)(Ge.from(ye))}we.from=Ce;function ue(ye){return j(ye)?{include:Ge.to(ye.include),exclude:Ge.to(ye.exclude)}:Ge.to(ye)}we.to=ue;function j(ye){const Me=ye;return Me?!(0,A.isUndefinedOrNull)(Me.include)&&!(0,A.isUndefinedOrNull)(Me.exclude):!1}})(Pt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var zt;(function(we){function Ce(ue){return{backgroundColor:ue.backgroundColor,borderColor:ue.borderColor,top:ue.top?N.from(ue.top):void 0}}we.from=Ce})(zt=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var It;(function(we){function Ce(ue,j,ye){const Me=typeof ue.command=="string"?{title:"",command:ue.command}:ue.command;return{alignment:ue.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:j.toInternal(Me,ye),text:ue.text,tooltip:ue.tooltip,accessibilityInformation:ue.accessibilityInformation,priority:ue.priority}}we.from=Ce})(It=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var mt;(function(we){function Ce(ue){return{transientOutputs:ue?.transientOutputs??!1,transientCellMetadata:ue?.transientCellMetadata??{},transientDocumentMetadata:ue?.transientDocumentMetadata??{}}}we.from=Ce})(mt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ft;(function(we){function Ce(j){return{uri:j.uri,provides:j.provides}}we.from=Ce;function ue(j){return new a.NotebookRendererScript(O.URI.revive(j.uri),j.provides)}we.to=ue})(Ft=e.NotebookRendererScript||(e.NotebookRendererScript={}));var $t;(function(we){function Ce(j){return{message:R.fromStrict(j.message)||"",type:0,expected:j.expectedOutput,actual:j.actualOutput,location:j.location&&{range:d.from(j.location.range),uri:j.location.uri}}}we.from=Ce;function ue(j){const ye=new a.TestMessage(typeof j.message=="string"?j.message:R.to(j.message));return ye.actualOutput=j.actual,ye.expectedOutput=j.expected,ye.location=j.location?Re.to(j.location):void 0,ye}we.to=ue})($t=e.TestMessage||(e.TestMessage={}));var Dt;(function(we){we.namespace=D.namespaceTestTag,we.denamespace=D.denamespaceTestTag})(Dt=e.TestTag||(e.TestTag={}));var He;(function(we){function Ce(j){const ye=(0,c.getPrivateApiFor)(j).controllerId;return{extId:u.TestId.fromExtHostTestItem(j,ye).toString(),label:j.label,uri:O.URI.revive(j.uri),busy:!1,tags:j.tags.map(Me=>Dt.namespace(ye,Me.id)),range:w.Range.lift(d.from(j.range)),description:j.description||null,sortText:j.sortText||null,error:j.error&&R.fromStrict(j.error)||null}}we.from=Ce;function ue(j){return{parent:void 0,error:void 0,id:u.TestId.fromString(j.extId).localId,label:j.label,uri:O.URI.revive(j.uri),tags:(j.tags||[]).map(ye=>{const{tagId:Me}=Dt.denamespace(ye);return new a.TestTag(Me)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},get:()=>{},replace:()=>{},size:0},range:d.to(j.range||void 0),canResolveChildren:!1,busy:!1,description:j.description||void 0,sortText:j.sortText||void 0}}we.toPlain=ue})(He=e.TestItem||(e.TestItem={})),function(we){function Ce(j){return{id:j.id}}we.from=Ce;function ue(j){return new a.TestTag(j.id)}we.to=ue}(Dt=e.TestTag||(e.TestTag={}));var At;(function(we){const Ce=(j,ye)=>{const Me={...He.toPlain(j.item),parent:void 0,taskStates:j.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(Ve=>Ve.type===0).map($t.to)})),children:j.children.map(Je=>ye.get(Je)).filter(A.isDefined).map(Je=>Ce(Je,ye))};for(const Je of Me.children)Je.parent=Me;return Me};function ue(j){const ye=[],Me=new Map;for(const Je of j.items)Me.set(Je.item.extId,Je),j.request.targets.some(Ve=>Ve.controllerId===Je.controllerId&&Ve.testIds.includes(Je.item.extId))&&ye.push(Je);return{completedAt:j.completedAt,results:ye.map(Je=>Ce(Je,Me))}}we.to=ue})(At=e.TestResults||(e.TestResults={}));var Lt;(function(we){function Ce(Me){return{covered:Me.covered,total:Me.covered}}function ue(Me){return"line"in Me?o.from(Me):d.from(Me)}function j(Me){return"branches"in Me?{count:Me.executionCount,location:ue(Me.location),type:1,branches:Me.branches.length?Me.branches.map(Je=>({count:Je.executionCount,location:Je.location&&ue(Je.location)})):void 0}:{type:0,count:Me.executionCount,location:ue(Me.location)}}we.fromDetailed=j;function ye(Me){return{uri:Me.uri,statement:Ce(Me.statementCoverage),branch:Me.branchCoverage&&Ce(Me.branchCoverage),function:Me.functionCoverage&&Ce(Me.functionCoverage),details:Me.detailedCoverage?.map(j)}}we.fromFile=ye})(Lt=e.TestCoverage||(e.TestCoverage={}));var Nt;(function(we){function Ce(ue){switch(ue){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}we.to=Ce})(Nt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var pt;(function(we){function Ce(j){const ye=new a.TypeHierarchyItem(ae.to(j.kind),j.name,j.detail||"",O.URI.revive(j.uri),d.to(j.range),d.to(j.selectionRange));return ye._sessionId=j._sessionId,ye._itemId=j._itemId,ye}we.to=Ce;function ue(j,ye,Me){if(ye=ye??j._sessionId,Me=Me??j._itemId,ye===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:ye,_itemId:Me,kind:ae.from(j.kind),name:j.name,detail:j.detail??"",uri:j.uri,range:d.from(j.range),selectionRange:d.from(j.selectionRange),tags:j.tags?.map(fe.from)}}we.from=ue})(pt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var yt;(function(we){function Ce(ue){if(!!ue)return{value:ue.value,tooltip:ue.tooltip}}we.from=Ce})(yt=e.ViewBadge||(e.ViewBadge={}));var Tt;(function(we){function Ce(ue,j){const ye=ue.fileData;return ye?new class extends a.DataTransferItem{asFile(){return{name:ye.name,uri:O.URI.revive(ye.uri),data:(0,_.once)(()=>j())}}}(""):new a.DataTransferItem(ue.asString)}we.toDataTransferItem=Ce})(Tt=e.DataTransferItem||(e.DataTransferItem={}));var wt;(function(we){function Ce(j,ye){const Me=j.items.map(([Je,Ve],ut)=>[Je,Tt.toDataTransferItem(Ve,()=>ye(ut))]);return new a.DataTransfer(Me)}we.toDataTransfer=Ce;async function ue(j){const ye={items:[]},Me=[];return j.forEach((Je,Ve)=>{Me.push((async()=>{const ut=await Je.asString(),ht=Je.asFile();ye.items.push([Ve,{asString:ut,fileData:ht?{name:ht.name,uri:ht.uri}:void 0}])})())}),await Promise.all(Me),ye}we.toDataTransferDTO=ue})(wt=e.DataTransfer||(e.DataTransfer={}))}),define(De[173],Ie([1,0,2,11,6,8,238]),function(J,e,s,C,p,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(A,O,w,g={timeout:1500,errors:3}){this._logService=A,this._documents=O,this._mainThreadBulkEdits=w,this._thresholds=g,this._callbacks=new T.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(A){return(O,w,g)=>{const f={dispose:this._callbacks.push([O,w,A])};return Array.isArray(g)&&g.push(f),f}}async $participateInSave(A,O){const w=s.URI.revive(A);let g=!1;const S=setTimeout(()=>g=!0,this._thresholds.timeout),f=[];try{for(let c of[...this._callbacks]){if(g)break;const h=this._documents.getDocument(w),u=await this._deliverEventAsyncAndBlameBadListeners(c,{document:h,reason:U.TextDocumentSaveReason.to(O)});f.push(u)}}finally{clearTimeout(S)}return f}_deliverEventAsyncAndBlameBadListeners([A,O,w],g){const S=this._badListeners.get(A);return typeof S=="number"&&S>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(w,A,O,g).then(()=>!0,f=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' threw ERROR`),this._logService.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const c=this._badListeners.get(A);this._badListeners.set(A,c?c+1:1),typeof c=="number"&&c>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(A,O,w,g){const S=[],f=Date.now(),{document:c,reason:h}=g,{version:u}=c,D=Object.freeze({document:c,reason:h,waitUntil(y){if(Object.isFrozen(S))throw(0,C.illegalState)("waitUntil can not be called async");S.push(Promise.resolve(y))}});try{O.apply(w,[D])}catch(y){return Promise.reject(y)}return Object.freeze(S),new Promise((y,a)=>{const _=setTimeout(()=>a(new Error("timeout")),this._thresholds.timeout);return Promise.all(S).then(r=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(_),y(r)}).catch(r=>{clearTimeout(_),a(r)})}).then(y=>{const a={edits:[]};for(const _ of y)if(Array.isArray(_)&&_.every(r=>r instanceof p.TextEdit))for(const{newText:r,newEol:d,range:i}of _)a.edits.push({_type:2,resource:c.uri,edit:{range:i&&U.Range.from(i),text:r,eol:d&&U.EndOfLine.from(d)}});if(a.edits.length!==0)return u===c.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(De[174],Ie([1,0,12,2,8,6,88]),function(J,e,s,C,p,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class P{constructor(w,g,S,f){this.start=w,this.deletedCount=g,this.deletedItems=S,this.items=f}asApiEvent(){return{range:new U.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(w=>w.apiCell),removedCells:this.deletedItems}}}class b{constructor(w,g,S){this.notebook=w,this._extHostDocument=g,this._cellData=S,this.handle=S.handle,this.uri=C.URI.revive(S.uri),this.cellKind=S.cellKind,this._outputs=S.outputs.map(p.NotebookCellOutput.to),this._internalMetadata=S.internalMetadata??{},this._metadata=Object.freeze(S.metadata??{}),this._previousResult=Object.freeze(p.NotebookCellExecutionSummary.to(S.internalMetadata??{}))}static asModelAddData(w,g){return{EOL:g.eol,lines:g.source,languageId:g.language,uri:g.uri,isDirty:!1,versionId:1,notebook:w}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const w=this,g=this._extHostDocument.getDocument(this.uri);if(!g)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const S={get index(){return w.notebook.getCellIndex(w)},notebook:w.notebook.apiNotebook,kind:p.NotebookCellKind.to(this._cellData.cellKind),document:g.document,get mime(){return w._mime},set mime(f){w._mime=f},get outputs(){return w._outputs.slice(0)},get metadata(){return w._metadata},get executionSummary(){return w._previousResult}};this._apiCell=Object.freeze(S)}return this._apiCell}setOutputs(w){this._outputs=w.map(p.NotebookCellOutput.to)}setOutputItems(w,g,S){const f=S.map(p.NotebookCellOutputItem.to),c=this._outputs.find(h=>h.id===w);c&&(g||(c.items.length=0),c.items.push(...f))}setMetadata(w){this._metadata=Object.freeze(w)}setInternalMetadata(w){this._internalMetadata=w,this._previousResult=Object.freeze(p.NotebookCellExecutionSummary.to(w))}setMime(w){}}e.ExtHostCell=b;class A{constructor(w,g,S,f,c){this._proxy=w,this._textDocumentsAndEditors=g,this._textDocuments=S,this.uri=f,this.handle=A._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=c.viewType,this._metadata=Object.freeze(c.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,c.cells]],!0,void 0),this._versionId=c.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const w=this,g={get uri(){return w.uri},get version(){return w._versionId},get notebookType(){return w._notebookType},get isDirty(){return w._isDirty},get isUntitled(){return w.uri.scheme===s.Schemas.untitled},get isClosed(){return w._disposed},get metadata(){return w._metadata},get cellCount(){return w._cells.length},cellAt(S){return S=w._validateIndex(S),w._cells[S].apiCell},getCells(S){return(S?w._getCells(S):w._cells).map(c=>c.apiCell)},save(){return w._save()}};this._notebook=Object.freeze(g)}return this._notebook}updateBackup(w){this._backup?.delete(),this._backup=w}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(w){w.metadata&&(this._metadata=Object.freeze({...this._metadata,...w.metadata}))}acceptDirty(w){this._isDirty=w}acceptModelChanged(w,g,S){this._versionId=w.versionId,this._isDirty=g,this.acceptDocumentPropertiesChanged({metadata:S});const f={notebook:this.apiNotebook,metadata:S,cellChanges:[],contentChanges:[]},c=[];for(const u of w.rawEvents)u.kind===T.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(u.changes,!1,f.contentChanges):u.kind===T.NotebookCellsChangeType.Move?this._moveCell(u.index,u.newIdx,f.contentChanges):u.kind===T.NotebookCellsChangeType.Output?(this._setCellOutputs(u.index,u.outputs),c.push({cell:this._cells[u.index].apiCell,outputs:this._cells[u.index].apiCell.outputs})):u.kind===T.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(u.index,u.outputId,u.append,u.outputItems),c.push({cell:this._cells[u.index].apiCell,outputs:this._cells[u.index].apiCell.outputs})):u.kind===T.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(u.index,u.language),c.push({cell:this._cells[u.index].apiCell,document:this._cells[u.index].apiCell.document})):u.kind===T.NotebookCellsChangeType.ChangeCellContent?c.push({cell:this._cells[u.index].apiCell,document:this._cells[u.index].apiCell.document}):u.kind===T.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(u.index,u.mime):u.kind===T.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(u.index,u.metadata),c.push({cell:this._cells[u.index].apiCell,metadata:this._cells[u.index].apiCell.metadata})):u.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(u.index,u.internalMetadata),c.push({cell:this._cells[u.index].apiCell,executionSummary:this._cells[u.index].apiCell.executionSummary}));const h=new Map;for(let u=0;u<c.length;u++){const D=c[u],y=h.get(D.cell);if(y===void 0){const a=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...D});h.set(D.cell,a-1)}else f.cellChanges[y]={...f.cellChanges[y],...D}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}_validateIndex(w){return w=w|0,w<0?0:w>=this._cells.length?this._cells.length-1:w}_validateRange(w){let g=w.start|0,S=w.end|0;return g<0&&(g=0),S>this._cells.length&&(S=this._cells.length),w.with({start:g,end:S})}_getCells(w){w=this._validateRange(w);const g=[];for(let S=w.start;S<w.end;S++)g.push(this._cells[S]);return g}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(w,g,S){if(this._disposed)return;const f=[],c=[],h=[];if(w.reverse().forEach(u=>{const y=u[2].map(r=>{const d=new b(this,this._textDocumentsAndEditors,r);return g||c.push(b.asModelAddData(this.apiNotebook,r)),d}),a=new P(u[0],u[1],[],y),_=this._cells.splice(u[0],u[1],...y);for(const r of _)h.push(r.uri),a.deletedItems.push(r.apiCell);f.push(a)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:c,removedDocuments:h}),S)for(let u of f)S.push(u.asApiEvent())}_moveCell(w,g,S){const f=this._cells.splice(w,1);this._cells.splice(g,0,...f);const c=[new P(w,1,f.map(h=>h.apiCell),[]),new P(g,0,[],f)];for(const h of c)S.push(h.asApiEvent())}_setCellOutputs(w,g){this._cells[w].setOutputs(g)}_setCellOutputItems(w,g,S,f){this._cells[w].setOutputItems(g,S,f)}_changeCellLanguage(w,g){const S=this._cells[w];S.apiCell.document.languageId!==g&&this._textDocuments.$acceptModelLanguageChanged(S.uri,g)}_changeCellMime(w,g){const S=this._cells[w];S.apiCell.mime=g}_changeCellMetadata(w,g){this._cells[w].setMetadata(g)}_changeCellInternalMetadata(w,g){this._cells[w].setInternalMetadata(g)}getCellFromApiCell(w){return this._cells.find(g=>g.apiCell===w)}getCellFromIndex(w){return this._cells[w]}getCell(w){return this._cells.find(g=>g.handle===w)}getCellIndex(w){return this._cells.indexOf(w)}}e.ExtHostNotebookDocument=A,A._handlePool=0}),define(De[91],Ie([1,0,6,8,11]),function(J,e,s,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class U{constructor(b){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=b}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(b){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:b})}replaceCellMetadata(b,A){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:b,metadata:A})}replaceCells(b,A,O){this._throwIfFinalized(),!(b===A&&O.length===0)&&this._collectedEdits.push({editType:1,index:b,count:A-b,cells:O.map(C.NotebookCellData.from)})}}class T{constructor(b,A,O,w,g,S){this.id=b,this._proxy=A,this.notebookData=O,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=g,this._visibleRanges=w,this._viewColumn=S}get apiEditor(){if(!this._editor){const b=this;this._editor={get document(){return b.notebookData.apiNotebook},get notebook(){return b.notebookData.apiNotebook},get selection(){return b._selections[0]},set selection(A){this.selections=[A]},get selections(){return b._selections},set selections(A){if(!Array.isArray(A)||!A.every(s.NotebookRange.isNotebookRange))throw(0,p.illegalArgument)("selections");b._selections=A,b._trySetSelections(A)},get visibleRanges(){return b._visibleRanges},revealRange(A,O){b._proxy.$tryRevealRange(b.id,C.NotebookRange.from(A),O??s.NotebookEditorRevealType.Default)},get viewColumn(){return b._viewColumn},edit(A){const O=new U(this.document.version);return A(O),b._applyEdit(O.finalize())},setDecorations(A,O){return b.setDecorations(A,O)}},T.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(b){this._visible=b}_acceptVisibleRanges(b){this._visibleRanges=b}_acceptSelections(b){this._selections=b}_trySetSelections(b){this._proxy.$trySetSelections(this.id,b.map(C.NotebookRange.from))}_acceptViewColumn(b){this._viewColumn=b}_applyEdit(b){if(b.cellEdits.length===0)return Promise.resolve(!0);const A=[];let O=-1;for(let w=0;w<b.cellEdits.length;w++){if(O<0){A.push(b.cellEdits[w]),O++;continue}const S=A[O],f=b.cellEdits[w];if(S.editType===1&&f.editType===1&&S.index===f.index){S.cells.push(...b.cellEdits[w].cells),S.count+=b.cellEdits[w].count;continue}A.push(b.cellEdits[w]),O++}return this._proxy.$tryApplyEdits(this.id,b.documentVersionId,A)}setDecorations(b,A){if(!(A.isEmpty&&!this._hasDecorationsForKey.has(b.key)))return A.isEmpty?this._hasDecorationsForKey.delete(b.key):this._hasDecorationsForKey.add(b.key),this._proxy.$trySetDecorations(this.id,C.NotebookRange.from(A),b.key)}}e.ExtHostNotebookEditor=T,T.apiEditorsToExtHost=new WeakMap}),define(De[175],Ie([1,0,8,150,130,20,55,11]),function(J,e,s,C,p,U,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class b{constructor(g){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=g}async withProgress(g,S,f){const c=this._handles++,{title:h,location:u,cancellable:D}=S,y={label:(0,p.localize)(0,null,g.displayName||g.name),id:g.identifier.value};return this._proxy.$startProgress(c,{location:s.ProgressLocation.from(u),title:h,source:y,cancellable:D},g.isUnderDevelopment?void 0:g.identifier.value).catch(P.onUnexpectedExternalError),this._withProgress(c,f,!!D)}_withProgress(g,S,f){let c;f&&(c=new U.CancellationTokenSource,this._mapHandleToCancellationSource.set(g,c));const h=D=>{this._proxy.$progressEnd(D),this._mapHandleToCancellationSource.delete(D),c&&c.dispose()};let u;try{u=S(new O(this._proxy,g),f&&c?c.token:U.CancellationToken.None)}catch(D){throw h(g),D}return u.then(D=>h(g),D=>h(g)),u}$acceptProgressCanceled(g){const S=this._mapHandleToCancellationSource.get(g);S&&(S.cancel(),this._mapHandleToCancellationSource.delete(g))}}e.ExtHostProgress=b;function A(w,g){return w.message=g.message,typeof g.increment=="number"&&(typeof w.increment=="number"?w.increment+=g.increment:w.increment=g.increment),w}class O extends C.Progress{constructor(g,S){super(f=>this.throttledReport(f));this._proxy=g,this._handle=S}throttledReport(g){this._proxy.$progressReport(this._handle,g)}}$e([(0,T.throttle)(100,(w,g)=>A(w,g),()=>Object.create(null))],O.prototype,"throttledReport",null)}),define(De[92],Ie([1,0,49,89,47,67,48,8,2]),function(J,e,s,C,p,U,T,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const A=(y,a,_,r)=>{let d=a;return{enumerable:!0,configurable:!1,get(){return d},set(i){if(!_(d,i)){const o=d;d=i,y.listener?.(r(i,o))}}}},O=(y,a)=>y===a,w={range:(y,a)=>y===a?!0:!y||!a?!1:y.isEqual(a),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(y,a)=>!(y.length!==a.length||y.some(_=>!a.find(r=>_.id===r.id)))},g=y=>a=>({op:4,update:y(a)}),S=(y,a)=>({range:A(y,void 0,w.range,g(_=>({range:s.Range.lift(P.Range.from(_))}))),label:A(y,a,w.label,g(_=>({label:_}))),description:A(y,void 0,w.description,g(_=>({description:_}))),sortText:A(y,void 0,w.sortText,g(_=>({sortText:_}))),canResolveChildren:A(y,!1,w.canResolveChildren,_=>({op:2,state:_})),busy:A(y,!1,w.busy,g(_=>({busy:_}))),error:A(y,void 0,w.error,g(_=>({error:P.MarkdownString.fromStrict(_)||null}))),tags:A(y,[],w.tags,(_,r)=>({op:1,new:_.map(P.TestTag.from),old:r.map(P.TestTag.from)}))}),f=y=>{const a=p.TestId.fromString(y.extId),_=new h(a.controllerId,a.localId,y.label,b.URI.revive(y.uri)||void 0);return _.range=P.Range.to(y.range||void 0),_.description=y.description||void 0,_.sortText=y.sortText||void 0,_.tags=y.tags.map(r=>P.TestTag.to({id:(0,T.denamespaceTestTag)(r).tagId})),_},c=y=>{let a;for(const _ of y.tests){const r=f(_.item);(0,C.getPrivateApiFor)(r).parent=a,a=r}return a};e.toItemFromContext=c;class h{constructor(a,_,r,d){if(_.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(_)} symbol`);const i=(0,C.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:_,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return i.parent instanceof u?void 0:i.parent}},children:{value:(0,U.createTestItemChildren)(i,C.getPrivateApiFor,h),enumerable:!0,writable:!1},...S(i,r)})}}e.TestItemImpl=h;class u extends h{constructor(a,_){super(a,a,_,void 0)}}e.TestItemRootImpl=u;class D extends U.TestItemCollection{constructor(a,_){super({controllerId:a,getApiFor:C.getPrivateApiFor,getChildren:r=>r.children,root:new u(a,_),toITestItem:P.TestItem.from})}}e.ExtHostTestItemCollection=D}),define(De[93],Ie([1,0,42,11,56,8,6]),function(J,e,s,C,p,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(g,S,f){const c=P._Keys.nextId();g.$registerTextEditorDecorationType(S.identifier,c,U.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:c,dispose(){g.$removeTextEditorDecorationType(c)}})}}e.TextEditorDecorationType=P,P._Keys=new p.IdGenerator("TextEditorDecorationType");class b{constructor(g,S){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=g,this._documentVersionId=g.version,this._undoStopBefore=S.undoStopBefore,this._undoStopAfter=S.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(g,S){this._throwIfFinalized();let f=null;if(g instanceof T.Position)f=new T.Range(g,g);else if(g instanceof T.Range)f=g;else throw new Error("Unrecognized location");this._pushEdit(f,S,!1)}insert(g,S){this._throwIfFinalized(),this._pushEdit(new T.Range(g,g),S,!0)}delete(g){this._throwIfFinalized();let S=null;if(g instanceof T.Range)S=g;else throw new Error("Unrecognized location");this._pushEdit(S,null,!0)}_pushEdit(g,S,f){const c=this._document.validateRange(g);this._collectedEdits.push({range:c,text:S,forceMoveMarkers:f})}setEndOfLine(g){if(this._throwIfFinalized(),g!==T.EndOfLine.LF&&g!==T.EndOfLine.CRLF)throw(0,C.illegalArgument)("endOfLine");this._setEndOfLine=g}}e.TextEditorEdit=b;class A{constructor(g,S,f,c){this._proxy=g,this._id=S,this._accept(f),this._logService=c;const h=this;this.value={get tabSize(){return h._tabSize},set tabSize(u){h._setTabSize(u)},get insertSpaces(){return h._insertSpaces},set insertSpaces(u){h._setInsertSpaces(u)},get cursorStyle(){return h._cursorStyle},set cursorStyle(u){h._setCursorStyle(u)},get lineNumbers(){return h._lineNumbers},set lineNumbers(u){h._setLineNumbers(u)}}}_accept(g){this._tabSize=g.tabSize,this._insertSpaces=g.insertSpaces,this._cursorStyle=g.cursorStyle,this._lineNumbers=U.TextEditorLineNumbersStyle.to(g.lineNumbers)}_validateTabSize(g){if(g==="auto")return"auto";if(typeof g=="number"){const S=Math.floor(g);return S>0?S:null}if(typeof g=="string"){const S=parseInt(g,10);return isNaN(S)?null:S>0?S:null}return null}_setTabSize(g){const S=this._validateTabSize(g);if(S!==null){if(typeof S=="number"){if(this._tabSize===S)return;this._tabSize=S}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:S}))}}_validateInsertSpaces(g){return g==="auto"?"auto":g==="false"?!1:Boolean(g)}_setInsertSpaces(g){const S=this._validateInsertSpaces(g);if(typeof S=="boolean"){if(this._insertSpaces===S)return;this._insertSpaces=S}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:S}))}_setCursorStyle(g){this._cursorStyle!==g&&(this._cursorStyle=g,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:g})))}_setLineNumbers(g){this._lineNumbers!==g&&(this._lineNumbers=g,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:U.TextEditorLineNumbersStyle.from(g)})))}assign(g){const S={};let f=!1;if(typeof g.tabSize!="undefined"){const c=this._validateTabSize(g.tabSize);c==="auto"?(f=!0,S.tabSize=c):typeof c=="number"&&this._tabSize!==c&&(this._tabSize=c,f=!0,S.tabSize=c)}if(typeof g.insertSpaces!="undefined"){const c=this._validateInsertSpaces(g.insertSpaces);c==="auto"?(f=!0,S.insertSpaces=c):this._insertSpaces!==c&&(this._insertSpaces=c,f=!0,S.insertSpaces=c)}typeof g.cursorStyle!="undefined"&&this._cursorStyle!==g.cursorStyle&&(this._cursorStyle=g.cursorStyle,f=!0,S.cursorStyle=g.cursorStyle),typeof g.lineNumbers!="undefined"&&this._lineNumbers!==g.lineNumbers&&(this._lineNumbers=g.lineNumbers,f=!0,S.lineNumbers=U.TextEditorLineNumbersStyle.from(g.lineNumbers)),f&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,S))}_warnOnError(g,S){S.catch(f=>{this._logService.warn(`ExtHostTextEditorOptions '${g}' failed:'`),this._logService.warn(f)})}}e.ExtHostTextEditorOptions=A;class O{constructor(g,S,f,c,h,u,D,y){this.id=g,this._proxy=S,this._logService=f,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=h,this._options=new A(this._proxy,this.id,u,f),this._visibleRanges=D,this._viewColumn=y;const a=this;this.value=Object.freeze({get document(){return c.getValue()},set document(_){throw(0,C.readonly)("document")},get selection(){return a._selections&&a._selections[0]},set selection(_){if(!(_ instanceof T.Selection))throw(0,C.illegalArgument)("selection");a._selections=[_],a._trySetSelection()},get selections(){return a._selections},set selections(_){if(!Array.isArray(_)||_.some(r=>!(r instanceof T.Selection)))throw(0,C.illegalArgument)("selections");a._selections=_,a._trySetSelection()},get visibleRanges(){return a._visibleRanges},set visibleRanges(_){throw(0,C.readonly)("visibleRanges")},get options(){return a._options.value},set options(_){a._disposed||a._options.assign(_)},get viewColumn(){return a._viewColumn},set viewColumn(_){throw(0,C.readonly)("viewColumn")},edit(_,r={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new b(c.getValue(),r);return _(d),a._applyEdit(d)},insertSnippet(_,r,d={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let i;if(!r||Array.isArray(r)&&r.length===0)i=a._selections.map(o=>U.Range.from(o));else if(r instanceof T.Position){const{lineNumber:o,column:n}=U.Position.from(r);i=[{startLineNumber:o,startColumn:n,endLineNumber:o,endColumn:n}]}else if(r instanceof T.Range)i=[U.Range.from(r)];else{i=[];for(const o of r)if(o instanceof T.Range)i.push(U.Range.from(o));else{const{lineNumber:n,column:t}=U.Position.from(o);i.push({startLineNumber:n,startColumn:t,endLineNumber:n,endColumn:t})}}return S.$tryInsertSnippet(g,c.getValue().version,_.value,i,d)},setDecorations(_,r){const d=r.length===0;d&&!a._hasDecorationsForKey.has(_.key)||(d?a._hasDecorationsForKey.delete(_.key):a._hasDecorationsForKey.add(_.key),a._runOnProxy(()=>{if(U.isDecorationOptionsArr(r))return S.$trySetDecorations(g,_.key,U.fromRangeOrRangeWithMessage(r));{const i=new Array(4*r.length);for(let o=0,n=r.length;o<n;o++){const t=r[o];i[4*o]=t.start.line+1,i[4*o+1]=t.start.character+1,i[4*o+2]=t.end.line+1,i[4*o+3]=t.end.character+1}return S.$trySetDecorationsFast(g,_.key,i)}}))},revealRange(_,r){a._runOnProxy(()=>S.$tryRevealRange(g,U.Range.from(_),r||T.TextEditorRevealType.Default))},show(_){S.$tryShowEditor(g,U.ViewColumn.from(_))},hide(){S.$tryHideEditor(g)}})}dispose(){(0,s.ok)(!this._disposed),this._disposed=!0}_acceptOptions(g){(0,s.ok)(!this._disposed),this._options._accept(g)}_acceptVisibleRanges(g){(0,s.ok)(!this._disposed),this._visibleRanges=g}_acceptViewColumn(g){(0,s.ok)(!this._disposed),this._viewColumn=g}_acceptSelections(g){(0,s.ok)(!this._disposed),this._selections=g}async _trySetSelection(){const g=this._selections.map(U.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,g)),this.value}_applyEdit(g){const S=g.finalize();if(S.edits.length===0&&!S.setEndOfLine)return Promise.resolve(!0);const f=S.edits.map(h=>h.range);f.sort((h,u)=>h.end.line===u.end.line?h.end.character===u.end.character?h.start.line===u.start.line?h.start.character-u.start.character:h.start.line-u.start.line:h.end.character-u.end.character:h.end.line-u.end.line);for(let h=0,u=f.length-1;h<u;h++){const D=f[h].end;if(f[h+1].start.isBefore(D))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const c=S.edits.map(h=>({range:U.Range.from(h.range),text:h.text,forceMoveMarkers:h.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,c,{setEndOfLine:typeof S.setEndOfLine=="number"?U.EndOfLine.from(S.setEndOfLine):void 0,undoStopBefore:S.undoStopBefore,undoStopAfter:S.undoStopAfter})}_runOnProxy(g){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):g().then(()=>this,S=>(S instanceof Error&&S.name==="DISPOSED"||this._logService.warn(S),null))}}e.ExtHostTextEditor=O}),define(De[176],Ie([1,0,3,146]),function(J,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,s.refineServiceDecorator)(C.IEnvironmentService)}),define(De[177],Ie([1,0,25,5,19]),function(J,e,s,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class U{constructor(O){this.removedDueToLooping=O}}e.DeltaExtensionsResult=U;class T{constructor(O){this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=O,this._initialize()}_initialize(){this._extensionDescriptions.sort(b),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const O of this._extensionDescriptions){if(this._extensionsMap.has(s.ExtensionIdentifier.toKey(O.identifier))){console.error("Extension `"+O.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(s.ExtensionIdentifier.toKey(O.identifier),O),this._extensionsArr.push(O),Array.isArray(O.activationEvents))for(let w of O.activationEvents)w==="onUri"&&(w=`onUri:${s.ExtensionIdentifier.toKey(O.identifier)}`),this._activationMap.has(w)||this._activationMap.set(w,[]),this._activationMap.get(w).push(O)}}set(O){this._extensionDescriptions=O,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(O,w){O.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(O));const g=T._findLoopingExtensions(this._extensionDescriptions);if(w=w.concat(g.map(S=>S.identifier)),w.length>0){const S=new Set;w.forEach(f=>S.add(s.ExtensionIdentifier.toKey(f))),this._extensionDescriptions=this._extensionDescriptions.filter(f=>!S.has(s.ExtensionIdentifier.toKey(f.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new U(g)}static _findLoopingExtensions(O){const w=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(h){this._nodesSet.has(h)||(this._nodesSet.add(h),this._nodesArr.push(h))}addArc(h,u){this.addNode(h),this.addNode(u),this._arcs.has(h)?this._arcs.get(h).push(u):this._arcs.set(h,[u])}getArcs(h){return this._arcs.has(h)?this._arcs.get(h):[]}hasOnlyGoodArcs(h,u){const D=w.getArcs(h);for(let y=0;y<D.length;y++)if(!u.has(D[y]))return!1;return!0}getNodes(){return this._nodesArr}};let g=new Map;for(let h of O){const u=s.ExtensionIdentifier.toKey(h.identifier);if(g.set(u,h),h.extensionDependencies)for(let D of h.extensionDependencies){const y=s.ExtensionIdentifier.toKey(D);w.addArc(u,y)}}let S=new Set;w.getNodes().filter(h=>w.getArcs(h).length===0).forEach(h=>S.add(h));let f=w.getNodes().filter(h=>!S.has(h)),c;do{c=!1;for(let h=0;h<f.length;h++){const u=f[h];w.hasOnlyGoodArcs(u,S)&&(f.splice(h,1),h--,S.add(u),c=!0)}}while(c);return f.map(h=>g.get(h))}containsActivationEvent(O){return this._activationMap.has(O)}containsExtension(O){return this._extensionsMap.has(s.ExtensionIdentifier.toKey(O))}getExtensionDescriptionsForActivationEvent(O){const w=this._activationMap.get(O);return w?w.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(O){const w=this._extensionsMap.get(s.ExtensionIdentifier.toKey(O));return w||void 0}}e.ExtensionDescriptionRegistry=T;var P;(function(A){A[A.Builtin=0]="Builtin",A[A.User=1]="User",A[A.Dev=2]="Dev"})(P||(P={}));function b(A,O){const w=A.isBuiltin?0:A.isUnderDevelopment?2:1,g=O.isBuiltin?0:O.isUnderDevelopment?2:1;if(w!==g)return w-g;const S=p.posix.basename(A.extensionLocation.path),f=p.posix.basename(O.extensionLocation.path);return S<f?-1:S>f?1:0}}),define(De[94],Ie([1,0,23]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var C;(function(b){b[b.Desktop=1]="Desktop",b[b.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var p;(function(b){b[b.VersionMismatch=55]="VersionMismatch",b[b.UnexpectedError=81]="UnexpectedError"})(p=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var U;(function(b){b[b.Initialized=0]="Initialized",b[b.Ready=1]="Ready",b[b.Terminate=2]="Terminate"})(U=e.MessageType||(e.MessageType={}));function T(b){const A=s.VSBuffer.alloc(1);switch(b){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.createMessageOfType=T;function P(b,A){if(b.byteLength!==1)return!1;switch(b.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.isMessageOfType=P}),define(De[26],Ie([1,0,5,2,3,25,152]),function(J,e,s,C,p,U,T){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new U.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:C.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,p.createDecorator)("extensionService");class b{constructor(t){this.affinity=t,this.kind=1}equals(t){return this.kind===t.kind&&this.affinity===t.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=b;class A{constructor(){this.kind=2,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=A;class O{constructor(){this.kind=3,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"Remote"}}e.RemoteRunningLocation=O;class w{constructor(t){this.dependency=t}}e.MissingExtensionDependency=w;var g;(function(n){n[n.LocalProcess=1]="LocalProcess",n[n.LocalWebWorker=2]="LocalWebWorker",n[n.Remote=3]="Remote"})(g=e.ExtensionHostKind||(e.ExtensionHostKind={}));function S(n){if(n===null)return"None";switch(n){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=S;class f{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(t,l){const v=[],m=[],I=[],B=[],x=u(this._allExtensions),R=u(t),E=(Z,K)=>Z.extensionLocation.toString()===K.extensionLocation.toString()||Z.isBuiltin===K.isBuiltin||Z.isUserBuiltin===K.isUserBuiltin||Z.isUnderDevelopment===K.isUnderDevelopment;for(const Z of this._allExtensions){const K=R.get(U.ExtensionIdentifier.toKey(Z.identifier));if(!K){v.push(Z.identifier),x.delete(U.ExtensionIdentifier.toKey(Z.identifier));continue}if(!E(Z,K)){v.push(Z.identifier),x.delete(U.ExtensionIdentifier.toKey(Z.identifier));continue}}for(const Z of t){const K=x.get(U.ExtensionIdentifier.toKey(Z.identifier));if(!K){m.push(Z);continue}if(!E(K,Z)){v.push(K.identifier),x.delete(U.ExtensionIdentifier.toKey(K.identifier));continue}}const M=h(this._myExtensions),N=h(l);for(const Z of this._myExtensions)N.has(U.ExtensionIdentifier.toKey(Z))||I.push(Z);for(const Z of l)M.has(U.ExtensionIdentifier.toKey(Z))||B.push(Z);const W={toRemove:v,toAdd:m,myToRemove:I,myToAdd:B};return this.delta(W),W}delta(t){const{toRemove:l,toAdd:v,myToRemove:m,myToAdd:I}=t,B=h(l),x=h(m);for(let R=0;R<this._allExtensions.length;R++)B.has(U.ExtensionIdentifier.toKey(this._allExtensions[R].identifier))&&(this._allExtensions.splice(R,1),R--);for(let R=0;R<this._myExtensions.length;R++)x.has(U.ExtensionIdentifier.toKey(this._myExtensions[R]))&&(this._myExtensions.splice(R,1),R--);for(const R of v)this._allExtensions.push(R);for(const R of I)this._myExtensions.push(R)}containsExtension(t){for(const l of this._myExtensions)if(U.ExtensionIdentifier.equals(l,t))return!0;return!1}}e.ExtensionHostExtensions=f;class c{constructor(t){if(this[P]="ExtensionIdentifierSet",this._map=new Map,this._toKey=U.ExtensionIdentifier.toKey,t)for(const l of t)this.add(l)}get size(){return this._map.size}add(t){return this._map.set(this._toKey(t),t),this}clear(){this._map.clear()}delete(t){return this._map.delete(this._toKey(t))}has(t){return this._map.has(this._toKey(t))}forEach(t,l){this._map.forEach(v=>t.call(l,v,v,this))}*entries(){for(let[t,l]of this._map)yield[l,l]}keys(){return this._map.values()}values(){return this._map.values()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=c;function h(n){const t=new Set;for(const l of n)t.add(U.ExtensionIdentifier.toKey(l));return t}e.extensionIdentifiersArrayToSet=h;function u(n){const t=new Map;for(const l of n)t.set(U.ExtensionIdentifier.toKey(l.identifier),l);return t}function D(n,t){return n.enabledApiProposals?n.enabledApiProposals.includes(t):!1}e.isProposedApiEnabled=D;function y(n,t){if(!D(n,t))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}e.checkProposedApiEnabled=y;class a{constructor(t,l,v,m){this.codeLoadingTime=t,this.activateCallTime=l,this.activateResolvedTime=v,this.activationReason=m}}e.ActivationTimes=a;class _{constructor(t,l){this.description=t,this.value=l}}e.ExtensionPointContribution=_,e.ExtensionHostLogFileName="exthost";var r;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(r=e.ActivationKind||(e.ActivationKind={}));function d(n){return{type:n.isBuiltin?0:1,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,T.getGalleryExtensionId)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}e.toExtension=d;function i(n,t){return{identifier:new U.ExtensionIdentifier((0,T.getExtensionId)(n.manifest.publisher,n.manifest.name)),isBuiltin:n.type===0,isUserBuiltin:n.type===1&&n.isBuiltin,isUnderDevelopment:!!t,extensionLocation:n.location,...n.manifest,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform}}e.toExtensionDescription=i;class o{constructor(){this.onDidRegisterExtensions=s.Event.None,this.onDidChangeExtensionsStatus=s.Event.None,this.onDidChangeExtensions=s.Event.None,this.onWillActivateByEvent=s.Event.None,this.onDidChangeResponsiveChange=s.Event.None}activateByEvent(t){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(t,l){return Promise.resolve(0)}getInspectPorts(t,l){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(t,l){return Promise.resolve()}}e.NullExtensionService=o}),define(De[178],Ie([1,0,11,25,26,14,13]),function(J,e,s,C,p,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class P{constructor(h,u,D,y){this.startup=h,this.codeLoadingTime=u,this.activateCallTime=D,this.activateResolvedTime=y}}e.ExtensionActivationTimes=P,P.NONE=new P(!1,-1,-1,-1);class b{constructor(h){this._startup=h,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(h,u){return h===-1||u===-1?-1:u-h}build(){return new P(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=b;class A{constructor(h,u,D,y,a,_){this.activationFailed=h,this.activationFailedError=u,this.activationTimes=D,this.module=y,this.exports=a,this.subscriptions=_}}e.ActivatedExtension=A;class O extends A{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=O;class w extends A{constructor(){super(!1,null,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=w;class g extends A{constructor(h){super(!0,h,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=g;let S=class{constructor(h,u,D,y,a){this._logService=a,this._registry=h,this._resolvedExtensionsSet=new Set,u.forEach(_=>this._resolvedExtensionsSet.add(C.ExtensionIdentifier.toKey(_))),this._externalExtensionsMap=new Map,D.forEach(_=>this._externalExtensionsMap.set(C.ExtensionIdentifier.toKey(_),_)),this._host=y,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[h,u]of this._operations)u.dispose()}isActivated(h){const u=this._operations.get(C.ExtensionIdentifier.toKey(h));return Boolean(u&&u.value)}getActivatedExtension(h){const u=this._operations.get(C.ExtensionIdentifier.toKey(h));if(!u||!u.value)throw new Error(`Extension '${h.value}' is not known or not activated`);return u.value}async activateByEvent(h,u){if(this._alreadyActivatedEvents[h])return;const D=this._registry.getExtensionDescriptionsForActivationEvent(h);await this._activateExtensions(D.map(y=>({id:y.identifier,reason:{startup:u,extensionId:y.identifier,activationEvent:h}}))),this._alreadyActivatedEvents[h]=!0}activateById(h,u){const D=this._registry.getExtensionDescription(h);if(!D)throw new Error(`Extension '${h}' is not known`);return this._activateExtensions([{id:D.identifier,reason:u}])}async _activateExtensions(h){const u=h.filter(D=>!this.isActivated(D.id)).map(D=>this._handleActivationRequest(D));await Promise.all(u.map(D=>D.wait()))}_handleActivationRequest(h){if(this._operations.has(C.ExtensionIdentifier.toKey(h.id)))return this._operations.get(C.ExtensionIdentifier.toKey(h.id));if(this._externalExtensionsMap.has(C.ExtensionIdentifier.toKey(h.id)))return this._createAndSaveOperation(h,null,[],null);const u=this._registry.getExtensionDescription(h.id);if(!u){const a=new Error(`Cannot activate unknown extension '${h.id.value}'`),_=this._createAndSaveOperation(h,null,[],new g(a));return this._host.onExtensionActivationError(h.id,a,new p.MissingExtensionDependency(h.id.value)),_}const D=[],y=typeof u.extensionDependencies=="undefined"?[]:u.extensionDependencies;for(const a of y){if(this._resolvedExtensionsSet.has(C.ExtensionIdentifier.toKey(a)))continue;const _=this._operations.get(C.ExtensionIdentifier.toKey(a));if(_){D.push(_);continue}if(this._externalExtensionsMap.has(C.ExtensionIdentifier.toKey(a))){D.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(C.ExtensionIdentifier.toKey(a)),reason:h.reason}));continue}const r=this._registry.getExtensionDescription(a);if(r){if(!r.main&&!r.browser)continue;D.push(this._handleActivationRequest({id:r.identifier,reason:h.reason}));continue}const d=u.displayName||u.identifier.value,i=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${a}'`),o=this._createAndSaveOperation(h,u.displayName,[],new g(i));return this._host.onExtensionActivationError(u.identifier,i,new p.MissingExtensionDependency(a)),o}return this._createAndSaveOperation(h,u.displayName,D,null)}_createAndSaveOperation(h,u,D,y){const a=new f(h.id,u,h.reason,D,y,this._host,this._logService);return this._operations.set(C.ExtensionIdentifier.toKey(h.id),a),a}};S=$e([xe(4,U.ILogService)],S),e.ExtensionsActivator=S;let f=class{constructor(h,u,D,y,a,_,r){this._id=h,this._displayName=u,this._reason=D,this._deps=y,this._value=a,this._host=_,this._logService=r,this._barrier=new T.Barrier,this._isDisposed=!1,this._initialize()}get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let h=0;h<this._deps.length;h++){const u=this._deps[h];if(u.value&&!u.value.activationFailed){this._deps.splice(h,1),h--;continue}if(u.value&&u.value.activationFailed){const D=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${u.friendlyName}' failed to activate`);D.detail=u.value.activationFailedError,this._value=new g(D),this._host.onExtensionActivationError(this._id,D,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(h=>h.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(h){const u=new Error;if(h&&h.name&&(u.name=h.name),h&&h.message?u.message=`Activating extension '${this._id.value}' failed: ${h.message}.`:u.message=`Activating extension '${this._id.value}' failed: ${h}.`,h&&h.stack&&(u.stack=h.stack),this._value=new g(u),this._isDisposed&&s.isCancellationError(h))return;this._host.onExtensionActivationError(this._id,u,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(h)}}};f=$e([xe(6,U.ILogService)],f)}),define(De[179],Ie([1,0,14,28,26]),function(J,e,s,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let U=class extends s.LogService{constructor(P,b){super(P.createLogger(b.logFile,{name:p.ExtensionHostLogFileName}))}};U=$e([xe(0,s.ILoggerService),xe(1,C.IExtHostInitDataService)],U),e.ExtHostLogService=U}),define(De[180],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",badges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.badges.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorToolbar:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorToolbar.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",dataTransferFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dataTransferFiles.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDebugOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDebugOptions.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookEditorDecorationType:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditorDecorationType.d.ts",notebookEditorEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditorEdit.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookWorkspaceEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookWorkspaceEdit.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmInput:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInput.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalNameChangeEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalNameChangeEvent.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textEditorDrop:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textEditorDrop.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[181],Ie([1,0,141,11,29,79,82,30,25,180,43,149]),function(J,e,s,C,p,U,T,P,b,A,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const g=P.Registry.as(T.Extensions.JSONContribution);class S{constructor(_,r,d){this._messageHandler=_,this._extension=r,this._extensionPointId=d}_msg(_,r){this._messageHandler({type:_,message:r,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(_){this._msg(p.default.Error,_)}warn(_){this._msg(p.default.Warning,_)}info(_){this._msg(p.default.Info,_)}}e.ExtensionMessageCollector=S;class f{constructor(_,r){this.added=_,this.removed=r}static _toSet(_){const r=new Set;for(let d=0,i=_.length;d<i;d++)r.add(b.ExtensionIdentifier.toKey(_[d].description.identifier));return r}static compute(_,r){if(!_||!_.length)return new f(r,[]);if(!r||!r.length)return new f([],_);const d=this._toSet(_),i=this._toSet(r);let o=r.filter(t=>!d.has(b.ExtensionIdentifier.toKey(t.description.identifier))),n=_.filter(t=>!i.has(b.ExtensionIdentifier.toKey(t.description.identifier)));return new f(o,n)}}e.ExtensionPointUserDelta=f;class c{constructor(_,r){this.name=_,this.defaultExtensionKind=r,this._handler=null,this._users=null,this._delta=null}setHandler(_){if(this._handler!==null)throw new Error("Handler already set!");this._handler=_,this._handle()}acceptUsers(_){this._delta=f.compute(this._users,_),this._users=_,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(_){(0,C.onUnexpectedError)(_)}}}e.ExtensionPoint=c;const h={type:"string",enum:["ui","workspace"],enumDescriptions:[s.localize(0,null),s.localize(1,null)]},u="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:s.localize(2,null),properties:{vscode:{type:"string",description:s.localize(3,null),default:"^1.22.0"}}},publisher:{description:s.localize(4,null),type:"string"},displayName:{description:s.localize(5,null),type:"string"},categories:{description:s.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:b.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:s.localize(7,null)}]}},galleryBanner:{type:"object",description:s.localize(8,null),properties:{color:{description:s.localize(9,null),type:"string"},theme:{description:s.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:s.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:s.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:s.localize(13,null)},enabledApiProposals:{markdownDescription:s.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(A.allApiProposals),markdownEnumDescriptions:(0,O.values)(A.allApiProposals)}},activationEvents:{description:s.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:s.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:s.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:s.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:s.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:s.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:s.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:s.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:s.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:s.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:s.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:s.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:s.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onSearch",description:s.localize(28,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:s.localize(29,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:s.localize(30,null)},{label:"onUri",body:"onUri",description:s.localize(31,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:s.localize(32,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:s.localize(33,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:s.localize(34,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:s.localize(35,null)},{label:"onRenderer",description:s.localize(36,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:s.localize(37,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:s.localize(38,null)},{label:"*",description:s.localize(39,null),body:"*"}]}},badges:{type:"array",description:s.localize(40,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:s.localize(41,null)},href:{type:"string",description:s.localize(42,null)},description:{type:"string",description:s.localize(43,null)}}}},markdown:{type:"string",description:s.localize(44,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:s.localize(45,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:s.localize(46,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:U.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:s.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:U.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:s.localize(48,null),type:"array",items:h,default:["workspace"],defaultSnippets:[{body:["ui"],description:s.localize(49,null)},{body:["workspace"],description:s.localize(50,null)},{body:["ui","workspace"],description:s.localize(51,null)},{body:["workspace","ui"],description:s.localize(52,null)},{body:[],description:s.localize(53,null)}]},capabilities:{description:s.localize(54,null),type:"object",properties:{virtualWorkspaces:{description:s.localize(55,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:s.localize(56,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[s.localize(57,null),s.localize(58,null),s.localize(59,null)]},description:{type:"string",markdownDescription:s.localize(60,null)}}},untrustedWorkspaces:{description:s.localize(61,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:s.localize(62,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[s.localize(63,null),s.localize(64,null),s.localize(65,null)]},restrictedConfigurations:{description:s.localize(66,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:s.localize(67,null)}}}}},sponsor:{description:s.localize(68,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:s.localize(69,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:s.localize(70,null),type:"string"},"vscode:uninstall":{description:s.localize(71,null),type:"string"}}},icon:{type:"string",description:s.localize(72,null)}}};class D{constructor(){this._extensionPoints=new Map}registerExtensionPoint(_){if(this._extensionPoints.has(_.extensionPoint))throw new Error("Duplicate extension point: "+_.extensionPoint);const r=new c(_.extensionPoint,_.defaultExtensionKind);return this._extensionPoints.set(_.extensionPoint,r),e.schema.properties.contributes.properties[_.extensionPoint]=_.jsonSchema,g.registerSchema(u,e.schema),r}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=D;const y={ExtensionsRegistry:"ExtensionsRegistry"};P.Registry.add(y.ExtensionsRegistry,new D),e.ExtensionsRegistry=P.Registry.as(y.ExtensionsRegistry),g.registerSchema(u,e.schema),g.registerSchema(w.productSchemaId,{properties:{extensionEnabledApiProposals:{description:s.localize(73,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(A.allApiProposals),markdownEnumDescriptions:(0,O.values)(A.allApiProposals)}}]}}}})}),define(De[182],Ie([1,0,138,9,27,181,38,5]),function(J,e,s,C,p,U,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const b={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:s.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:s.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:s.localize(2,null),default:""}}};var A;(function(g){function S(f,c,h){if(!f)return;let u=C.isString(f.type)?f.type:void 0;if(!u||u.length===0){h.error(s.localize(3,null));return}let D=[];if(Array.isArray(f.required))for(let y of f.required)C.isString(y)&&D.push(y);return{extensionId:c.value,taskType:u,required:D,properties:f.properties?p.deepClone(f.properties):{},when:f.when?T.ContextKeyExpr.deserialize(f.when):void 0}}g.from=S})(A||(A={}));const O=U.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:s.localize(4,null),type:"array",items:b}});class w{constructor(){this._onDefinitionsChanged=new P.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((S,f)=>{O.setHandler((c,h)=>{try{for(let u of h.removed){let D=u.value;for(let y of D)this.taskTypes&&y.type&&this.taskTypes[y.type]&&delete this.taskTypes[y.type]}for(let u of h.added){let D=u.value;for(let y of D){let a=A.from(y,u.description.identifier,u.collector);a&&(this.taskTypes[a.taskType]=a)}}(h.removed.length>0||h.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}S(void 0)})})}onReady(){return this.readyPromise}get(S){return this.taskTypes[S]}all(){return Object.keys(this.taskTypes).map(S=>this.taskTypes[S])}getJsonSchema(){if(this._schema===void 0){let S=[];for(let f of this.all()){let c={type:"object",additionalProperties:!1};f.required.length>0&&(c.required=f.required.slice(0)),f.properties!==void 0?c.properties=p.deepClone(f.properties):c.properties=Object.create(null),c.properties.type={type:"string",enum:[f.taskType]},S.push(c)}this._schema={oneOf:S}}return this._schema}}e.TaskDefinitionRegistryImpl=w,e.TaskDefinitionRegistry=new w}),define(De[183],Ie([1,0,139,9,21,27,38,182]),function(J,e,s,C,p,U,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new T.RawContextKey("taskRunning",!1,s.localize(0,null)),e.TASKS_CATEGORY={value:s.localize(1,null),original:"Tasks"};var b;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(b=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(M){function N(W){if(!W)return M.Strong;switch(W.toLowerCase()){case"escape":return M.Escape;case"strong":return M.Strong;case"weak":return M.Weak;default:return M.Strong}}M.from=N}(b=e.ShellQuoting||(e.ShellQuoting={}));var A;(function(M){M.defaults={cwd:"${workspaceFolder}"}})(A=e.CommandOptions||(e.CommandOptions={}));var O;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(O=e.RevealKind||(e.RevealKind={})),function(M){function N(W){switch(W.toLowerCase()){case"always":return M.Always;case"silent":return M.Silent;case"never":return M.Never;default:return M.Always}}M.fromString=N}(O=e.RevealKind||(e.RevealKind={}));var w;(function(M){M[M.Never=1]="Never",M[M.OnProblem=2]="OnProblem",M[M.Always=3]="Always"})(w=e.RevealProblemKind||(e.RevealProblemKind={})),function(M){function N(W){switch(W.toLowerCase()){case"always":return M.Always;case"never":return M.Never;case"onproblem":return M.OnProblem;default:return M.OnProblem}}M.fromString=N}(w=e.RevealProblemKind||(e.RevealProblemKind={}));var g;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(g=e.PanelKind||(e.PanelKind={})),function(M){function N(W){switch(W.toLowerCase()){case"shared":return M.Shared;case"dedicated":return M.Dedicated;case"new":return M.New;default:return M.Shared}}M.fromString=N}(g=e.PanelKind||(e.PanelKind={}));var S;(function(M){M.defaults={echo:!0,reveal:O.Always,revealProblems:w.Never,focus:!1,panel:g.Shared,showReuseMessage:!0,clear:!1}})(S=e.PresentationOptions||(e.PresentationOptions={}));var f;(function(M){M[M.Shell=1]="Shell",M[M.Process=2]="Process",M[M.CustomExecution=3]="CustomExecution"})(f=e.RuntimeType||(e.RuntimeType={})),function(M){function N(Z){switch(Z.toLowerCase()){case"shell":return M.Shell;case"process":return M.Process;case"customExecution":return M.CustomExecution;default:return M.Process}}M.fromString=N;function W(Z){switch(Z){case M.Shell:return"shell";case M.Process:return"process";case M.CustomExecution:return"customExecution";default:return"process"}}M.toString=W}(f=e.RuntimeType||(e.RuntimeType={}));var c;(function(M){function N(W){return C.isString(W)?W:W.value}M.value=N})(c=e.CommandString||(e.CommandString={}));var h;(function(M){M.Clean={_id:"clean",isDefault:!1},M.Build={_id:"build",isDefault:!1},M.Rebuild={_id:"rebuild",isDefault:!1},M.Test={_id:"test",isDefault:!1};function N(Z){return Z===M.Clean._id||Z===M.Build._id||Z===M.Rebuild._id||Z===M.Test._id}M.is=N;function W(Z){if(Z!==void 0)return C.isString(Z)?N(Z)?{_id:Z,isDefault:!1}:void 0:Z}M.from=W})(h=e.TaskGroup||(e.TaskGroup={}));var u;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.Folder=3]="Folder"})(u=e.TaskScope||(e.TaskScope={}));var D;(function(M){M.Workspace="workspace",M.Extension="extension",M.InMemory="inMemory",M.WorkspaceFile="workspaceFile",M.User="user";function N(W){switch(W){case M.User:return 1;case M.WorkspaceFile:return 4;default:return 5}}M.toConfigurationTarget=N})(D=e.TaskSourceKind||(e.TaskSourceKind={}));var y;(function(M){M.parallel="parallel",M.sequence="sequence"})(y=e.DependsOrder||(e.DependsOrder={}));var a;(function(M){M[M.default=1]="default",M[M.folderOpen=2]="folderOpen"})(a=e.RunOnOptions||(e.RunOnOptions={}));var _;(function(M){M.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(_=e.RunOptions||(e.RunOptions={}));class r{constructor(N,W,Z,K,F,oe){this._label="",this._id=N,W&&(this._label=W),Z&&(this.type=Z),this.runOptions=K,this.configurationProperties=F,this._source=oe}getDefinition(N){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const N={folder:this.getFolderId(),id:this._id};return JSON.stringify(N)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(N,W=!1){if(N===void 0)return!1;if(C.isString(N))return N===this._label||N===this.configurationProperties.identifier||W&&N===this._id;let Z=this.getDefinition(!0);return Z!==void 0&&Z._key===N._key}getQualifiedLabel(){let N=this.getWorkspaceFolder();return N?`${this._label} (${N.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(N){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),N&&(this._taskLoadMessages=this._taskLoadMessages.concat(N))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=r;class d extends r{constructor(N,W,Z,K,F,oe,ce,ae){super(N,Z,void 0,ce,ae,W);this.command={},this._source=W,this.hasDefinedMatchers=oe,F&&(this.command=F)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(N=!1){if(N&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case f.Shell:W="shell";break;case f.Process:W="process";break;case f.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(N){return N instanceof d}getMapKey(){let N=this._source.config.workspaceFolder;return N?`${N.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===D.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){let N=this.getFolderId();if(!N)return;let W=this.configurationProperties.identifier;this._source.kind!==D.Workspace&&(W+=this._source.kind);let Z={type:e.CUSTOMIZED_TASK_TYPE,folder:N,id:W};return JSON.stringify(Z)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?p.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(N){return new d(N._id,N._source,N._label,N.type,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.CustomTask=d;class i extends r{constructor(N,W,Z,K,F,oe,ce){super(N,Z,K,oe,ce,W);this._source=W,this.configures=F}static is(N){return N instanceof i}fromObject(N){return N}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?p.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===D.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){let N=this.getFolderId();if(!N)return;let W=this.configurationProperties.identifier;this._source.kind!==D.Workspace&&(W+=this._source.kind);let Z={type:e.CUSTOMIZED_TASK_TYPE,folder:N,id:W};return JSON.stringify(Z)}}e.ConfiguringTask=i;class o extends r{constructor(N,W,Z,K,F,oe,ce,ae,fe){super(N,Z,K,ae,fe,W);this.defines=F,this.hasDefinedMatchers=ce,this.command=oe}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(N){return N instanceof o}getMapKey(){let N=this._source.workspaceFolder;return N?`${this._source.scope.toString()}|${N.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){let N={type:"contributed",scope:this._source.scope,id:this._id};return N.folder=this.getFolderId(),JSON.stringify(N)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(N){return new o(N._id,N._source,N._label,N.type,N.defines,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.ContributedTask=o;class n extends r{constructor(N,W,Z,K,F,oe){super(N,Z,K,F,oe,W);this._source=W}clone(){return new n(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(N){return N instanceof n}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(N){return new n(N._id,N._source,N._label,N.type,N.runOptions,N.configurationProperties)}}e.InMemoryTask=n;var t;(function(M){M[M.Process=1]="Process",M[M.Terminal=2]="Terminal"})(t=e.ExecutionEngine||(e.ExecutionEngine={})),function(M){M._default=M.Terminal}(t=e.ExecutionEngine||(e.ExecutionEngine={}));var l;(function(M){M[M.V0_1_0=1]="V0_1_0",M[M.V2_0_0=2]="V2_0_0"})(l=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class v{constructor(N){this._order=new Map;for(let W=0;W<N.length;W++)this._order.set(N[W].uri.toString(),W)}compare(N,W){let Z=N.getWorkspaceFolder(),K=W.getWorkspaceFolder();if(Z&&K){let F=this._order.get(Z.uri.toString());F=F===void 0?0:F+1;let oe=this._order.get(K.uri.toString());return oe=oe===void 0?0:oe+1,F===oe?N._label.localeCompare(W._label):F-oe}else return!Z&&K?-1:Z&&!K?1:0}}e.TaskSorter=v;var m;(function(M){M.DependsOnStarted="dependsOnStarted",M.AcquiredInput="acquiredInput",M.Start="start",M.ProcessStarted="processStarted",M.Active="active",M.Inactive="inactive",M.Changed="changed",M.Terminated="terminated",M.ProcessEnded="processEnded",M.End="end"})(m=e.TaskEventKind||(e.TaskEventKind={}));var I;(function(M){M.SingleRun="singleRun",M.Background="background"})(I=e.TaskRunType||(e.TaskRunType={}));var B;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.FolderOpen=2]="FolderOpen",M[M.ConfigurationChange=3]="ConfigurationChange"})(B=e.TaskRunSource||(e.TaskRunSource={}));var x;(function(M){function N(W,Z,K,F){if(Z){let oe={kind:W,taskId:Z._id,taskName:Z.configurationProperties.name,runType:Z.configurationProperties.isBackground?"background":"singleRun",group:Z.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:Z};return W==="start"?(oe.terminalId=K,oe.resolvedVariables=F):W==="processStarted"?oe.processId=K:W==="processEnded"&&(oe.exitCode=K),Object.freeze(oe)}else return Object.freeze({kind:"changed"})}M.create=N})(x=e.TaskEvent||(e.TaskEvent={}));var R;(function(M){function N(Z){const K=Object.keys(Z).sort();let F="";for(const oe of K){let ce=Z[oe];ce instanceof Object?ce=N(ce):typeof ce=="string"&&(ce=ce.replace(/,/g,",,")),F+=oe+","+ce+","}return F}function W(Z){let F={_key:N(Z),type:Z.taskType};return Object.assign(F,Z),F}M.create=W})(R=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var E;(function(M){function N(W,Z){let K=P.TaskDefinitionRegistry.get(W.type);if(K===void 0){let ae=U.deepClone(W);return delete ae._key,R.create(ae)}let F=Object.create(null);F.type=K.taskType;let oe=new Set;K.required.forEach(ae=>oe.add(ae));let ce=K.properties;for(let ae of Object.keys(ce)){let fe=W[ae];if(fe!=null)F[ae]=fe;else if(oe.has(ae)){let ie=ce[ae];if(ie.default!==void 0)F[ae]=U.deepClone(ie.default);else switch(ie.type){case"boolean":F[ae]=!1;break;case"number":case"integer":F[ae]=0;break;case"string":F[ae]="";break;default:Z.error(s.localize(2,null,JSON.stringify(W,void 0,0),ae));return}}}return R.create(F)}M.createTaskIdentifier=N})(E=e.TaskDefinition||(e.TaskDefinition={}))}),define(De[184],Ie([1,0,11]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class C{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((U,T)=>{this._actualOk=U,this._actualErr=T,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(U){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=U,this._actual&&this._actualOk(U))}resolveErr(U){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=U,this._actual?this._actualErr(U):(0,s.onUnexpectedError)(U))}then(U,T){return this._ensureActual().then(U,T)}catch(U){return this._ensureActual().then(void 0,U)}finally(U){return this._ensureActual().finally(U)}}e.LazyPromise=C}),define(De[40],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class s{constructor(b){this._proxyIdentifierBrand=void 0,this.sid=b,this.nid=++s.count}}e.ProxyIdentifier=s,s.count=0;const C=[];function p(P){const b=new s(P);return C[b.nid]=b,b}e.createProxyIdentifier=p;function U(P){return C[P].sid}e.getStringIdentifierForProxy=U;class T{constructor(b){this.value=b}}e.SerializableObjectWithBuffers=T}),define(De[4],Ie([1,0,57,2,40]),function(J,e,s,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var U;(function(y){y[y.Default=0]="Default",y[y.InCenter=1]="InCenter",y[y.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",y[y.AtTop=3]="AtTop"})(U=e.TextEditorRevealType||(e.TextEditorRevealType={}));var T;(function(y){y[y.UnknownInput=0]="UnknownInput",y[y.TextInput=1]="TextInput",y[y.TextDiffInput=2]="TextDiffInput",y[y.NotebookInput=3]="NotebookInput",y[y.NotebookDiffInput=4]="NotebookDiffInput",y[y.CustomEditorInput=5]="CustomEditorInput",y[y.WebviewEditorInput=6]="WebviewEditorInput",y[y.TerminalEditorInput=7]="TerminalEditorInput"})(T=e.TabInputKind||(e.TabInputKind={}));var P;(function(y){y[y.TAB_OPEN=0]="TAB_OPEN",y[y.TAB_CLOSE=1]="TAB_CLOSE",y[y.TAB_UPDATE=2]="TAB_UPDATE",y[y.TAB_MOVE=3]="TAB_MOVE"})(P=e.TabModelOperationKind||(e.TabModelOperationKind={}));var b;(function(y){y[y.Editable=0]="Editable",y[y.SupportsHotExit=1]="SupportsHotExit"})(b=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(y){y[y.Int8Array=1]="Int8Array",y[y.Uint8Array=2]="Uint8Array",y[y.Uint8ClampedArray=3]="Uint8ClampedArray",y[y.Int16Array=4]="Int16Array",y[y.Uint16Array=5]="Uint16Array",y[y.Int32Array=6]="Int32Array",y[y.Uint32Array=7]="Uint32Array",y[y.Float32Array=8]="Float32Array",y[y.Float64Array=9]="Float64Array",y[y.BigInt64Array=10]="BigInt64Array",y[y.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var O;(function(y){y[y.Text=1]="Text",y[y.Error=2]="Error",y[y.Rich=3]="Rich"})(O=e.CellOutputKind||(e.CellOutputKind={}));var w;(function(y){y[y.Default=0]="Default",y[y.InCenter=1]="InCenter",y[y.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",y[y.AtTop=3]="AtTop"})(w=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var g;(function(y){y[y.None=0]="None",y[y.Process=1]="Process",y[y.Output=2]="Output"})(g=e.CandidatePortSource||(e.CandidatePortSource={}));class S{static mixin(a){return a._id=S._n++,a}}e.IdObject=S,S._n=0;var f;(function(y){y.label="a",y.kind="b",y.detail="c",y.documentation="d",y.sortText="e",y.filterText="f",y.preselect="g",y.insertText="h",y.insertTextRules="i",y.range="j",y.commitCharacters="k",y.additionalTextEdits="l",y.command="m",y.kindModifier="n"})(f=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var c;(function(y){y.defaultRanges="a",y.completions="b",y.isIncomplete="c",y.duration="d"})(c=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var h;(function(y){y[y.File=1]="File",y[y.Text=2]="Text",y[y.Cell=3]="Cell"})(h=e.WorkspaceEditType||(e.WorkspaceEditType={}));function u(y){if(y&&y.edits)for(const a of y.edits)typeof a.resource=="object"?a.resource=C.URI.revive(a.resource):(a.newUri=C.URI.revive(a.newUri),a.oldUri=C.URI.revive(a.oldUri)),a.metadata&&a.metadata.iconPath&&(a.metadata=(0,s.revive)(a.metadata));return y}e.reviveWorkspaceEditDto=u;var D;(function(y){y[y.Workspace=0]="Workspace",y[y.TextDocument=1]="TextDocument"})(D=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,p.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,p.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,p.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,p.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,p.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,p.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,p.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,p.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,p.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,p.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,p.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,p.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,p.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,p.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,p.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,p.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,p.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,p.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,p.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,p.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,p.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,p.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,p.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,p.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,p.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,p.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,p.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,p.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,p.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,p.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,p.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,p.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,p.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,p.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,p.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,p.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,p.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,p.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,p.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,p.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,p.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,p.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,p.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,p.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,p.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,p.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,p.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,p.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,p.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,p.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,p.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,p.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,p.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,p.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,p.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,p.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,p.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,p.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,p.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,p.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,p.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,p.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,p.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,p.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,p.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,p.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,p.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,p.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,p.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,p.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,p.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,p.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,p.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,p.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,p.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,p.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,p.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,p.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,p.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,p.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,p.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,p.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,p.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,p.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,p.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,p.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,p.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,p.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,p.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,p.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,p.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,p.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,p.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,p.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,p.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,p.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,p.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,p.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,p.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,p.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,p.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,p.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,p.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,p.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,p.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,p.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,p.createProxyIdentifier)("ExtHostTelemetry")}}),define(De[69],Ie([1,0,4,5,3]),function(J,e,s,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class U{constructor(P){this._onDidChangePassword=new C.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(s.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,b){return this._proxy.$getPassword(P,b)}store(P,b,A){return this._proxy.$setPassword(P,b,A)}delete(P,b){return this._proxy.$deletePassword(P,b)}}e.ExtHostSecretState=U,e.IExtHostSecretState=(0,p.createDecorator)("IExtHostSecretState")}),define(De[70],Ie([1,0,3,14,4,16]),function(J,e,s,C,p,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,s.createDecorator)("IExtHostApiDeprecationService");let T=class{constructor(b,A){this._extHostLogService=A,this._reportedUsages=new Set,this._telemetryShape=b.getProxy(p.MainContext.MainThreadTelemetry)}report(b,A,O){const w=this.getUsageKey(b,A);this._reportedUsages.has(w)||(this._reportedUsages.add(w),A.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${b}' is deprecated. ${O}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:A.identifier.value,apiId:b}))}getUsageKey(b,A){return`${b}-${A.identifier.value}`}};T=$e([xe(0,U.IExtHostRpcService),xe(1,C.ILogService)],T),e.ExtHostApiDeprecationService=T,e.NullApiDeprecationService=Object.freeze(new class{report(P,b,A){}})}),define(De[185],Ie([1,0,5,4,6,25]),function(J,e,s,C,p,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class T{constructor(b){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new s.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=b.getProxy(C.MainContext.MainThreadAuthentication)}$setProviders(b){return this._providers=b,Promise.resolve()}async getSession(b,A,O,w={}){const g=U.ExtensionIdentifier.toKey(b.identifier),S=this._inFlightRequests.get(g)||[],f=[...O].sort().join(" ");let c=S.find(h=>h.providerId===A&&h.scopes===f);if(c)return c.result;{const h=this._getSession(b,g,A,O,w);c={providerId:A,scopes:f,result:h},S.push(c),this._inFlightRequests.set(g,S);try{await h}finally{const u=S.findIndex(D=>D.providerId===A&&D.scopes===f);u>-1&&(S.splice(u),this._inFlightRequests.set(g,S))}return h}}async _getSession(b,A,O,w,g={}){await this._proxy.$ensureProvider(O);const S=b.displayName||b.name;return this._proxy.$getSession(O,w,A,S,g)}async removeSession(b,A){const O=this._authenticationProviders.get(b);return O?O.provider.removeSession(A):this._proxy.$removeSession(b,A)}registerAuthenticationProvider(b,A,O,w){if(this._authenticationProviders.get(b))throw new Error(`An authentication provider with id '${b}' is already registered.`);this._authenticationProviders.set(b,{label:A,provider:O,options:w??{supportsMultipleAccounts:!1}}),this._providers.find(S=>S.id===b)||this._providers.push({id:b,label:A});const g=O.onDidChangeSessions(S=>{this._proxy.$sendDidChangeSessions(b,{added:S.added??[],changed:S.changed??[],removed:S.removed??[]})});return this._proxy.$registerAuthenticationProvider(b,A,w?.supportsMultipleAccounts??!1),new p.Disposable(()=>{g.dispose(),this._authenticationProviders.delete(b);const S=this._providers.findIndex(f=>f.id===b);S>-1&&this._providers.splice(S),this._proxy.$unregisterAuthenticationProvider(b)})}$createSession(b,A){const O=this._authenticationProviders.get(b);if(O)return Promise.resolve(O.provider.createSession(A));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$removeSession(b,A){const O=this._authenticationProviders.get(b);if(O)return Promise.resolve(O.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$getSessions(b,A){const O=this._authenticationProviders.get(b);if(O)return Promise.resolve(O.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$onDidChangeAuthenticationSessions(b,A){return this._onDidChangeSessions.fire({provider:{id:b,label:A}}),Promise.resolve()}}e.ExtHostAuthentication=T}),define(De[186],Ie([1,0,4,16,8]),function(J,e,s,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let U=class{constructor(P,b){this._proxy=P.getProxy(s.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:A=>b.getDocument(A)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(P){const b=p.WorkspaceEdit.from(P,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(b)}};U=$e([xe(0,C.IExtHostRpcService)],U),e.ExtHostBulkEdits=U}),define(De[187],Ie([1,0,4]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class C{constructor(U){const T=U.getProxy(s.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(P){return T.$writeText(P)}})}}e.ExtHostClipboard=C});var Ye=this&&this.__classPrivateFieldSet||function(J,e,s,C,p){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?p.call(J,s):p?p.value=s:e.set(J,s),s},Ae=this&&this.__classPrivateFieldGet||function(J,e,s,C){if(s==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?C:s==="a"?C.call(J):C?C.value:e.get(J)};define(De[36],Ie([1,0,9,6,8,27,4,15,14,57,49,239,2,7,3,16,92,23,40,45]),function(J,e,s,C,p,U,T,P,b,A,O,w,g,S,f,c,h,u,D,y){"use strict";var a,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let r=class{constructor(l,v){a.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,_.set(this,void 0),Ye(this,a,l.getProxy(T.MainContext.MainThreadCommands),"f"),this._logService=v,Ye(this,_,l.getProxy(T.MainContext.MainThreadTelemetry),"f"),this.converter=new d(this,m=>{const I=this._apiCommands.get(m);return I?.result===o.Void?I:void 0},v),this._argumentProcessors=[{processArgument(m){return(0,A.revive)(m)}},{processArgument(m){return(0,U.cloneAndChange)(m,function(I){if(O.Range.isIRange(I))return p.Range.to(I);if(w.Position.isIPosition(I))return p.Position.to(I);if(O.Range.isIRange(I.range)&&g.URI.isUri(I.uri))return p.location.to(I);if(I instanceof u.VSBuffer)return I.buffer.buffer;if(!Array.isArray(I))return I})}}]}registerArgumentProcessor(l){this._argumentProcessors.push(l)}registerApiCommand(l){const v=this.registerCommand(!1,l.id,async(...m)=>{const I=l.args.map((x,R)=>{if(!x.validate(m[R]))throw new Error(`Invalid argument '${x.name}' when running '${l.id}', received: ${m[R]}`);return x.convert(m[R])}),B=await this.executeCommand(l.internalId,...I);return l.result.convert(B,m,this.converter)},void 0,{description:l.description,args:l.args,returns:l.result.description});return this._apiCommands.set(l.id,l),new C.Disposable(()=>{v.dispose(),this._apiCommands.delete(l.id)})}registerCommand(l,v,m,I,B,x){if(this._logService.trace("ExtHostCommands#registerCommand",v),!v.trim().length)throw new Error("invalid id");if(this._commands.has(v))throw new Error(`command '${v}' already exists`);return this._commands.set(v,{callback:m,thisArg:I,description:B,extension:x}),l&&Ae(this,a,"f").$registerCommand(v),new C.Disposable(()=>{this._commands.delete(v)&&l&&Ae(this,a,"f").$unregisterCommand(v)})}executeCommand(l,...v){return this._logService.trace("ExtHostCommands#executeCommand",l),this._doExecuteCommand(l,v,!0)}async _doExecuteCommand(l,v,m){if(this._commands.has(l))return this._executeContributedCommand(l,v,!1);{let I=!1;const B=(0,U.cloneAndChange)(v,function(x){if(x instanceof C.Position)return p.Position.from(x);if(x instanceof C.Range)return p.Range.from(x);if(x instanceof C.Location)return p.location.from(x);if(C.NotebookRange.isNotebookRange(x))return p.NotebookRange.from(x);if(x instanceof ArrayBuffer)return I=!0,u.VSBuffer.wrap(new Uint8Array(x));if(x instanceof Uint8Array)return I=!0,u.VSBuffer.wrap(x);if(x instanceof u.VSBuffer)return I=!0,x;if(!Array.isArray(x))return x});try{const x=await Ae(this,a,"f").$executeCommand(l,I?new D.SerializableObjectWithBuffers(B):B,m);return(0,A.revive)(x)}catch(x){if(x instanceof Error&&x.message==="$executeCommand:retry")return this._doExecuteCommand(l,v,!1);throw x}}}async _executeContributedCommand(l,v,m){const I=this._commands.get(l);if(!I)throw new Error("Unknown command");this._reportTelemetry(I,l);let{callback:B,thisArg:x,description:R}=I;if(R)for(let E=0;E<R.args.length;E++)try{(0,s.validateConstraint)(v[E],R.args[E].constraint)}catch{throw new Error(`Running the contributed command: '${l}' failed. Illegal argument '${R.args[E].name}' - ${R.args[E].description}`)}try{return await B.apply(x,v)}catch(E){if(l===this.converter.delegatingCommandId){const M=this.converter.getActualCommand(...v);M&&(l=M.command)}throw this._logService.error(E,l,I.extension?.identifier),m?new class extends Error{constructor(){super((0,y.toErrorMessage)(E));this.id=l,this.source=I.extension?.displayName??I.extension?.name}}:E}}_reportTelemetry(l,v){!l.extension||l.extension.isBuiltin||Ae(this,_,"f").$publicLog2("Extension:ActionExecuted",{extensionId:l.extension.identifier.value,id:v})}$executeContributedCommand(l,...v){return this._logService.trace("ExtHostCommands#$executeContributedCommand",l),this._commands.has(l)?(v=v.map(m=>this._argumentProcessors.reduce((I,B)=>B.processArgument(I),m)),this._executeContributedCommand(l,v,!0)):Promise.reject(new Error(`Contributed command '${l}' does not exist.`))}getCommands(l=!1){return this._logService.trace("ExtHostCommands#getCommands",l),Ae(this,a,"f").$getCommands().then(v=>(l&&(v=v.filter(m=>m[0]!=="_")),v))}$getContributedCommandHandlerDescriptions(){const l=Object.create(null);for(let[v,m]of this._commands){let{description:I}=m;I&&(l[v]=I)}return Promise.resolve(l)}};a=new WeakMap,_=new WeakMap,r=$e([xe(0,c.IExtHostRpcService),xe(1,b.ILogService)],r),e.ExtHostCommands=r,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class d{constructor(l,v,m){this._commands=l,this._lookupApiCommand=v,this._logService=m,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(l,v){if(!l)return;const m={$ident:void 0,id:l.command,title:l.title,tooltip:l.tooltip};if(!l.command)return m;const I=this._lookupApiCommand(l.command);if(I)m.id=I.internalId,m.arguments=I.args.map((B,x)=>B.convert(l.arguments&&l.arguments[x]));else if((0,P.isNonEmptyArray)(l.arguments)){const B=++this._cachIdPool;this._cache.set(B,l),v.add((0,S.toDisposable)(()=>{this._cache.delete(B),this._logService.trace("CommandsConverter#DISPOSE",B)})),m.$ident=B,m.id=this.delegatingCommandId,m.arguments=[B],this._logService.trace("CommandsConverter#CREATE",l.command,B)}return m}fromInternal(l){return typeof l.$ident=="number"?this._cache.get(l.$ident):{command:l.id,title:l.title,arguments:l.arguments}}getActualCommand(...l){return this._cache.get(l[0])}_executeConvertedCommand(...l){const v=this.getActualCommand(...l);return this._logService.trace("CommandsConverter#EXECUTE",l[0],v?v.command:"MISSING"),v?this._commands.executeCommand(v.command,...v.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=d;class i{constructor(l,v,m,I){this.name=l,this.description=v,this.validate=m,this.convert=I}optional(){return new i(this.name,`(optional) ${this.description}`,l=>l==null||this.validate(l),l=>l===void 0?void 0:l===null?null:this.convert(l))}with(l,v){return new i(l??this.name,v??this.description,this.validate,this.convert)}}e.ApiCommandArgument=i,i.Uri=new i("uri","Uri of a text document",t=>g.URI.isUri(t),t=>t),i.Position=new i("position","A position in a text document",t=>C.Position.isPosition(t),p.Position.from),i.Range=new i("range","A range in a text document",t=>C.Range.isRange(t),p.Range.from),i.Selection=new i("selection","A selection in a text document",t=>C.Selection.isSelection(t),p.Selection.from),i.Number=new i("number","",t=>typeof t=="number",t=>t),i.String=new i("string","",t=>typeof t=="string",t=>t),i.CallHierarchyItem=new i("item","A call hierarchy item",t=>t instanceof C.CallHierarchyItem,p.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",t=>t instanceof C.TypeHierarchyItem,p.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",t=>t instanceof h.TestItemImpl,p.TestItem.from);class o{constructor(l,v){this.description=l,this.convert=v}}e.ApiCommandResult=o,o.Void=new o("no result",t=>t);class n{constructor(l,v,m,I,B){this.id=l,this.internalId=v,this.description=m,this.args=I,this.result=B}}e.ApiCommand=n}),define(De[188],Ie([1,0,2,8,6,68,36,15,77,81,12]),function(J,e,s,C,p,U,T,P,b,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const w=[new T.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",S(C.DocumentHighlight.to))),new T.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,h)=>{if((0,P.isFalsyOrEmpty)(c))return;class u extends p.SymbolInformation{static to(y){const a=new u(y.name,C.SymbolKind.to(y.kind),y.containerName||"",new p.Location(h[0],C.Range.to(y.range)));return a.detail=y.detail,a.range=a.location.range,a.selectionRange=C.Range.to(y.selectionRange),a.children=y.children?y.children.map(u.to):[],a}}return c.map(u.to)})),new T.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",S(C.TextEdit.to))),new T.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range,new T.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",S(C.TextEdit.to))),new T.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,new T.ApiCommandArgument("ch","Trigger character",c=>typeof c=="string",c=>c),new T.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",S(C.TextEdit.to))),new T.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new T.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new T.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new T.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new T.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location-instances.",S(C.location.to))),new T.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Hover-instances.",S(C.Hover.to))),new T.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("position","A position in a text document",c=>Array.isArray(c)&&c.every(h=>p.Position.isPosition(h)),c=>c.map(C.Position.from))],new T.ApiCommandResult("A promise that resolves to an array of ranges.",c=>c.map(h=>{let u;for(const D of h.reverse())u=new p.SelectionRange(C.Range.to(D),u);return u}))),new T.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[T.ApiCommandArgument.String.with("query","Search string")],new T.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",c=>c.map(C.WorkspaceSymbol.to))),new T.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(C.CallHierarchyItem.to))),new T.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[T.ApiCommandArgument.CallHierarchyItem],new T.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(C.CallHierarchyIncomingCall.to))),new T.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[T.ApiCommandArgument.CallHierarchyItem],new T.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(C.CallHierarchyOutgoingCall.to))),new T.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to a range and placeholder text.",c=>{if(!!c)return{range:C.Range.to(c.range),placeholder:c.text}})),new T.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("newName","The new symbol name")],new T.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",c=>{if(!!c){if(c.rejectReason)throw new Error(c.rejectReason);return C.WorkspaceEdit.to(c)}})),new T.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new T.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(C.DocumentLink.to))),new T.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new p.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new T.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const h=(0,b.decodeSemanticTokensDto)(c);if(h.type==="full")return new p.SemanticTokens(h.data,void 0)})),new T.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range.optional()],new T.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new p.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new T.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const h=(0,b.decodeSemanticTokensDto)(c);if(h.type==="full")return new p.SemanticTokens(h.data,void 0)})),new T.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),T.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new T.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(c,h,u)=>{if(!c)return new p.CompletionList([]);const D=c.suggestions.map(y=>C.CompletionItem.to(y,u));return new p.CompletionList(D,c.incomplete)})),new T.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new T.ApiCommandResult("A promise that resolves to SignatureHelp.",c=>{if(c)return C.SignatureHelp.to(c)})),new T.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new T.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(c,h,u)=>S(D=>new p.CodeLens(C.Range.to(D.range),D.command&&u.fromInternal(D.command)))(c))),new T.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>p.Range.isRange(c),c=>p.Selection.isSelection(c)?C.Selection.from(c):C.Range.from(c)),T.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),T.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new T.ApiCommandResult("A promise that resolves to an array of Command-instances.",(c,h,u)=>S(D=>{if(D._isSynthetic){if(!D.command)throw new Error("Synthetic code actions must have a command");return u.fromInternal(D.command)}else{const y=new p.CodeAction(D.title,D.kind?new p.CodeActionKind(D.kind):void 0);return D.edit&&(y.edit=C.WorkspaceEdit.to(D.edit)),D.command&&(y.command=u.fromInternal(D.command)),y.isPreferred=D.isPreferred,y}})(c))),new T.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(h=>new p.ColorInformation(C.Range.to(h.range),C.Color.to(h.color))):[])),new T.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new T.ApiCommandArgument("color","The color to show and insert",c=>c instanceof p.Color,C.Color.from),new T.ApiCommandArgument("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:C.Range.from(c.range)}))],new T.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(C.ColorPresentation.to):[])),new T.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to an array of Inlay objects",(c,h,u)=>c.map(C.InlayHint.to.bind(void 0,u)))),new T.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new T.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",S(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(h=>C.NotebookExclusiveDocumentPattern.to(h))})))),new T.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to an array of InlineValue objects",c=>c.map(C.InlineValue.to))),new T.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new T.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",c=>s.URI.isUri(c)||typeof c=="string"&&(0,A.matchesSomeScheme)(c,O.Schemas.http,O.Schemas.https),c=>c),new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[C.ViewColumn.from(c),void 0]:[C.ViewColumn.from(c.viewColumn),C.TextEditorOpenOptions.from(c)])).optional(),T.ApiCommandArgument.String.with("label","").optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[T.ApiCommandArgument.Uri.with("resource","Resource to open"),T.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[C.ViewColumn.from(c),void 0]:[C.ViewColumn.from(c.viewColumn),C.TextEditorOpenOptions.from(c)])).optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[T.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),T.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),T.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[C.ViewColumn.from(c.viewColumn),C.TextEditorOpenOptions.from(c)]).optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(C.TypeHierarchyItem.to))),new T.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[T.ApiCommandArgument.TypeHierarchyItem],new T.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(C.TypeHierarchyItem.to))),new T.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[T.ApiCommandArgument.TypeHierarchyItem],new T.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(C.TypeHierarchyItem.to))),new T.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[T.ApiCommandArgument.TestItem],T.ApiCommandResult.Void)];class g{static register(h){w.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=g;function S(c){return h=>{if(Array.isArray(h))return h.map(c)}}function f(c){if(!Array.isArray(c))return;const h=[];for(const u of c)U.isLocationLink(u)?h.push(C.DefinitionLink.to(u)):h.push(C.location.to(u));return h}}),define(De[189],Ie([1,0,13,55,5,7,2,68,25,8,6,26,4]),function(J,e,s,C,p,U,T,P,b,A,O,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function S(f,c,h){const u=f.getProxy(g.MainContext.MainThreadComments);class D{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,c.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const l=this._commentControllers.get(t.handle);return l?l.value:t}else if(t&&t.$mid===7){const l=this._commentControllers.get(t.commentControlHandle);if(!l)return t;const v=l.getCommentThread(t.commentThreadHandle);return v?v.value:t}else if(t&&t.$mid===8){const l=this._commentControllers.get(t.thread.commentControlHandle);if(!l)return t;const v=l.getCommentThread(t.thread.commentThreadHandle);return v?{thread:v.value,text:t.text}:t}else if(t&&t.$mid===9){const l=this._commentControllers.get(t.thread.commentControlHandle);if(!l)return t;const v=l.getCommentThread(t.thread.commentThreadHandle);if(!v)return t;let m=t.commentUniqueId,I=v.getCommentByUniqueId(m);return I||t}else if(t&&t.$mid===10){const l=this._commentControllers.get(t.thread.commentControlHandle);if(!l)return t;const v=l.getCommentThread(t.thread.commentThreadHandle);if(!v)return t;let m=t.text,I=t.commentUniqueId,B=v.getCommentByUniqueId(I);return B?(B.body=m,B):t}return t}})}createCommentController(t,l,v){const m=D.handlePool++,I=new a(t,m,l,v);this._commentControllers.set(I.handle,I);const B=this._commentControllersByExtension.get(b.ExtensionIdentifier.toKey(t.identifier))||[];return B.push(I),this._commentControllersByExtension.set(b.ExtensionIdentifier.toKey(t.identifier),B),I.value}$createCommentThreadTemplate(t,l,v){const m=this._commentControllers.get(t);!m||m.$createCommentThreadTemplate(l,v)}async $updateCommentThreadTemplate(t,l,v){const m=this._commentControllers.get(t);!m||m.$updateCommentThreadTemplate(l,v)}$deleteCommentThread(t,l){const v=this._commentControllers.get(t);v&&v.$deleteCommentThread(l)}$provideCommentingRanges(t,l,v){const m=this._commentControllers.get(t);if(!m||!m.commentingRangeProvider)return Promise.resolve(void 0);const I=h.getDocument(T.URI.revive(l));return(0,s.asPromise)(()=>m.commentingRangeProvider.provideCommentingRanges(I,v)).then(B=>B?B.map(x=>A.Range.from(x)):void 0)}$toggleReaction(t,l,v,m,I){const B=this._commentControllers.get(t);return!B||!B.reactionHandler?Promise.resolve(void 0):(0,s.asPromise)(()=>{const x=B.getCommentThread(l);if(x){const R=x.getCommentByUniqueId(m.uniqueIdInThread);if(B!==void 0&&R&&B.reactionHandler)return B.reactionHandler(R,d(I))}return Promise.resolve(void 0)})}dispose(){}}D.handlePool=0;class y{constructor(t,l,v,m,I,B,x,R){this._commentControllerHandle=l,this._id=v,this._uri=m,this._range=I,this._comments=B,this.extensionDescription=x,this._isTemplate=R,this.handle=y._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new p.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new U.MutableDisposable,this._acceptInputDisposables.value=new U.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),u.$createCommentThread(l,this.handle,this._id,this._uri,A.Range.from(this._range),x.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=B,this._localDisposables.push({dispose:()=>{u.$deleteCommentThread(l,this.handle)}});const E=this;this.value={get uri(){return E.uri},get range(){return E.range},set range(M){E.range=M},get comments(){return E.comments},set comments(M){E.comments=M},get collapsibleState(){return E.collapsibleState},set collapsibleState(M){E.collapsibleState=M},get canReply(){return E.canReply},set canReply(M){E.canReply=M},get contextValue(){return E.contextValue},set contextValue(M){E.contextValue=M},get label(){return E.label},set label(M){E.label=M},get state(){return E.state},set state(M){E.state=M},dispose:()=>{E.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get state(){return(0,w.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(t){(0,w.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=t,this.modifications.state=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new U.DisposableStore);const t=v=>Object.prototype.hasOwnProperty.call(this.modifications,v),l={};t("range")&&(l.range=A.Range.from(this._range)),t("label")&&(l.label=this.label),t("contextValue")&&(l.contextValue=this.contextValue??null),t("comments")&&(l.comments=this._comments.map(v=>_(this,v,this._commentsMap))),t("collapsibleState")&&(l.collapseState=i(this._collapseState)),t("canReply")&&(l.canReply=this.canReply),t("state")&&(l.state=o(this._state)),t("isTemplate")&&(l.isTemplate=this._isTemplate),this.modifications={},u.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,l)}getCommentByUniqueId(t){for(let l of this._commentsMap){let v=l[0],m=l[1];if(t===m)return v}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}y._handlePool=0,$e([(0,C.debounce)(100)],y.prototype,"eventuallyUpdateCommentThread",null);class a{constructor(t,l,v,m){this._extension=t,this._handle=l,this._id=v,this._label=m,this._threads=new Map,u.$registerCommentController(this.handle,v,m);const I=this;this.value=Object.freeze({id:I.id,label:I.label,get options(){return I.options},set options(B){I.options=B},get commentingRangeProvider(){return I.commentingRangeProvider},set commentingRangeProvider(B){I.commentingRangeProvider=B},get reactionHandler(){return I.reactionHandler},set reactionHandler(B){I.reactionHandler=B},createCommentThread(B,x,R){return I.createCommentThread(B,x,R).value},dispose:()=>{I.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{u.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,u.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,u.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,u.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,l,v,m){if(typeof t=="string"){const I=new y(this.id,this.handle,t,l,v,m,this._extension,!1);return this._threads.set(I.handle,I),I}else{const I=new y(this.id,this.handle,void 0,t,l,v,this._extension,!1);return this._threads.set(I.handle,I),I}}$createCommentThreadTemplate(t,l){const v=new y(this.id,this.handle,void 0,T.URI.revive(t),A.Range.to(l),[],this._extension,!0);return v.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(v.handle,v),v}$updateCommentThreadTemplate(t,l){let v=this._threads.get(t);v&&(v.range=A.Range.to(l))}$deleteCommentThread(t){let l=this._threads.get(t);l&&l.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function _(n,t,l){let v=l.get(t);v||(v=++n.commentHandle,l.set(t,v));const m=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:v,body:typeof t.body=="string"?t.body:A.MarkdownString.from(t.body),userName:t.author.name,userIconPath:m,label:t.label,commentReactions:t.reactions?t.reactions.map(I=>r(I)):void 0,timestamp:t.timestamp?.toJSON()}}function r(n){return{label:n.label,iconPath:n.iconPath?A.pathOrURIToURI(n.iconPath):void 0,count:n.count,hasReacted:n.authorHasReacted}}function d(n){return{label:n.label||"",count:n.count||0,iconPath:n.iconPath?T.URI.revive(n.iconPath):"",authorHasReacted:n.hasReacted||!1}}function i(n){if(n!==void 0)switch(n){case O.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}function o(n){if(n!==void 0)switch(n){case O.CommentThreadState.Unresolved:return P.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return P.CommentThreadState.Resolved}return P.CommentThreadState.Unresolved}return new D}e.createExtHostComments=S}),define(De[95],Ie([1,0,2,4,6,3,16,14,15,10,19]),function(J,e,s,C,p,U,T,P,b,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let w=class Si{constructor(S,f){this._logService=f,this._provider=new Map,this._proxy=S.getProxy(C.MainContext.MainThreadDecorations)}registerFileDecorationProvider(S,f){const c=Si._handlePool++;this._provider.set(c,{provider:S,extensionId:f}),this._proxy.$registerDecorationProvider(c,f.value);const h=S.onDidChangeFileDecorations&&S.onDidChangeFileDecorations(u=>{if(!u){this._proxy.$onDidChange(c,null);return}let D=(0,b.asArray)(u);if(D.length<=Si._maxEventSize){this._proxy.$onDidChange(c,D);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",f.value,D.length);const y=D.map(r=>({uri:r,rank:(0,A.count)(r.path,"/")})),a=(0,b.groupBy)(y,(r,d)=>r.rank-d.rank||(0,A.compare)(r.uri.path,d.uri.path));let _=[];e:for(let r of a){let d;for(let i of r){let o=(0,O.dirname)(i.uri.path);if(d!==o&&(d=o,_.push(i.uri)>=Si._maxEventSize))break e}}this._proxy.$onDidChange(c,_)});return new p.Disposable(()=>{h?.dispose(),this._proxy.$unregisterDecorationProvider(c),this._provider.delete(c)})}async $provideDecorations(S,f,c){if(!this._provider.has(S))return Object.create(null);const h=Object.create(null),{provider:u,extensionId:D}=this._provider.get(S);return await Promise.all(f.map(async y=>{try{const{uri:a,id:_}=y,r=await Promise.resolve(u.provideFileDecoration(s.URI.revive(a),c));if(!r)return;try{p.FileDecoration.validate(r),h[_]=[r.propagate,r.tooltip,r.badge,r.color]}catch(d){this._logService.warn(`INVALID decoration from extension '${D.value}': ${d}`)}}catch(a){this._logService.error(a)}})),h}};w._handlePool=0,w._maxEventSize=250,w=$e([xe(0,T.IExtHostRpcService),xe(1,P.ILogService)],w),e.ExtHostDecorations=w,e.IExtHostDecorations=(0,U.createDecorator)("IExtHostDecorations")});var Ye=this&&this.__classPrivateFieldSet||function(J,e,s,C,p){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?p.call(J,s):p?p.value=s:e.set(J,s),s},Ae=this&&this.__classPrivateFieldGet||function(J,e,s,C){if(s==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?C:s==="a"?C.call(J):C?C.value:e.get(J)};define(De[190],Ie([1,0,128,80,2,4,6,8,5,14,24,35]),function(J,e,s,C,p,U,T,P,b,A,O,w){"use strict";var g,S,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class c{constructor(D,y,a,_,r,d){this._name=D,this._owner=y,this._maxDiagnosticsPerFile=a,g.set(this,void 0),S.set(this,void 0),f.set(this,void 0),this._isDisposed=!1,Ye(this,f,new O.ResourceMap(i=>_.getComparisonKey(i)),"f"),Ye(this,g,r,"f"),Ye(this,S,d,"f")}dispose(){this._isDisposed||(Ae(this,S,"f").fire([...Ae(this,f,"f").keys()]),Ae(this,g,"f")&&Ae(this,g,"f").$clear(this._owner),Ae(this,f,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(D,y){if(!D){this.clear();return}this._checkDisposed();let a=[];if(p.URI.isUri(D)){if(!y){this.delete(D);return}Ae(this,f,"f").set(D,y.slice()),a=[D]}else if(Array.isArray(D)){a=[];let r;D=[...D].sort(c._compareIndexedTuplesByUri);for(const d of D){const[i,o]=d;if((!r||i.toString()!==r.toString())&&(r&&Ae(this,f,"f").get(r).length===0&&Ae(this,f,"f").delete(r),r=i,a.push(i),Ae(this,f,"f").set(i,[])),o){const n=Ae(this,f,"f").get(i);n&&n.push(...o)}else{const n=Ae(this,f,"f").get(i);n&&(n.length=0)}}}if(Ae(this,S,"f").fire(a),!Ae(this,g,"f"))return;const _=[];for(let r of a){let d=[];const i=Ae(this,f,"f").get(r);if(i)if(i.length>this._maxDiagnosticsPerFile){d=[];const o=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let n=0;n<4;n++)for(let t of i)if(t.severity===o[n]&&d.push(P.Diagnostic.from(t))===this._maxDiagnosticsPerFile)break e;d.push({severity:C.MarkerSeverity.Info,message:(0,s.localize)(0,null,i.length-this._maxDiagnosticsPerFile),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=i.map(o=>P.Diagnostic.from(o));_.push([r,d])}Ae(this,g,"f").$changeMany(this._owner,_)}delete(D){this._checkDisposed(),Ae(this,S,"f").fire([D]),Ae(this,f,"f").delete(D),Ae(this,g,"f")&&Ae(this,g,"f").$changeMany(this._owner,[[D,void 0]])}clear(){this._checkDisposed(),Ae(this,S,"f").fire([...Ae(this,f,"f").keys()]),Ae(this,f,"f").clear(),Ae(this,g,"f")&&Ae(this,g,"f").$clear(this._owner)}forEach(D,y){this._checkDisposed();for(let a of Ae(this,f,"f").keys())D.apply(y,[a,this.get(a),this])}get(D){this._checkDisposed();const y=Ae(this,f,"f").get(D);return Array.isArray(y)?Object.freeze(y.slice(0)):[]}has(D){return this._checkDisposed(),Array.isArray(Ae(this,f,"f").get(D))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(D,y){return D[0].toString()<y[0].toString()?-1:D[0].toString()>y[0].toString()?1:0}}e.DiagnosticCollection=c,g=new WeakMap,S=new WeakMap,f=new WeakMap;let h=class ci{constructor(D,y,a){this._logService=y,this._fileSystemInfoService=a,this._collections=new Map,this._onDidChangeDiagnostics=new b.DebounceEmitter({merge:_=>_.flat(),delay:50}),this.onDidChangeDiagnostics=b.Event.map(this._onDidChangeDiagnostics.event,ci._mapper),this._proxy=D.getProxy(U.MainContext.MainThreadDiagnostics)}static _mapper(D){const y=new O.ResourceMap;for(const a of D)y.set(a,a);return{uris:Object.freeze(Array.from(y.values()))}}createDiagnosticCollection(D,y){const{_collections:a,_proxy:_,_onDidChangeDiagnostics:r,_logService:d,_fileSystemInfoService:i}=this,o=new class{$changeMany(l,v){_.$changeMany(l,v),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",D.value,l,v.length===0?"CLEARING":v)}$clear(l){_.$clear(l),d.trace("[DiagnosticCollection] remove all (extension, owner)",D.value,l)}dispose(){_.dispose()}};let n;if(!y)y="_generated_diagnostic_collection_name_#"+ci._idPool++,n=y;else if(!a.has(y))n=y;else{this._logService.warn(`DiagnosticCollection with name '${y}' does already exist.`);do n=y+ci._idPool++;while(a.has(n))}return new class extends c{constructor(){super(y,n,ci._maxDiagnosticsPerFile,i.extUri,o,r);a.set(n,this)}dispose(){super.dispose(),a.delete(n)}}}getDiagnostics(D){if(D)return this._getDiagnostics(D);{const y=new Map,a=[];for(const _ of this._collections.values())_.forEach((r,d)=>{let i=y.get(r.toString());typeof i=="undefined"&&(i=a.length,y.set(r.toString(),i),a.push([r,[]])),a[i][1]=a[i][1].concat(...d)});return a}}_getDiagnostics(D){let y=[];for(let a of this._collections.values())a.has(D)&&(y=y.concat(a.get(D)));return y}$acceptMarkersChange(D){if(!this._mirrorCollection){const y="_generated_mirror",a=new c(y,y,ci._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(y,a),this._mirrorCollection=a}for(const[y,a]of D)this._mirrorCollection.set(p.URI.revive(y),a.map(P.Diagnostic.to))}};h._idPool=0,h._maxDiagnosticsPerFile=1e3,h=$e([xe(1,A.ILogService),xe(2,w.IExtHostFileSystemInfo)],h),e.ExtHostDiagnostics=h}),define(De[191],Ie([1,0,2,4]),function(J,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class p{constructor(T){this._proxy=T.getProxy(C.MainContext.MainThreadDialogs)}showOpenDialog(T){return this._proxy.$showOpenDialog(T).then(P=>P?P.map(b=>s.URI.revive(b)):void 0)}showSaveDialog(T){return this._proxy.$showSaveDialog(T).then(P=>P?s.URI.revive(P):void 0)}}e.ExtHostDialogs=p}),define(De[192],Ie([1,0,11,2,6,4,12,20,10]),function(J,e,s,C,p,U,T,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class A{constructor(w,g,S){this._documentsAndEditors=g,this._logService=S,this._documentContentProviders=new Map,this._proxy=w.getProxy(U.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(w,g){if(Object.keys(T.Schemas).indexOf(w)>=0)throw new Error(`scheme '${w}' already registered`);const S=A._handlePool++;this._documentContentProviders.set(S,g),this._proxy.$registerTextContentProvider(S,w);let f;return typeof g.onDidChange=="function"&&(f=g.onDidChange(c=>{if(c.scheme!==w){this._logService.warn(`Provider for scheme '${w}' is firing event for schema '${c.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(c)&&this.$provideTextDocumentContent(S,c).then(h=>{if(!h&&typeof h!="string")return;const u=this._documentsAndEditors.getDocument(c);if(!u)return;const D=(0,b.splitLines)(h);if(!u.equalLines(D))return this._proxy.$onVirtualDocumentChange(c,h)},s.onUnexpectedError)})),new p.Disposable(()=>{this._documentContentProviders.delete(S)&&this._proxy.$unregisterTextContentProvider(S),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(w,g){const S=this._documentContentProviders.get(w);return S?Promise.resolve(S.provideTextDocumentContent(C.URI.revive(g),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${g.scheme}`))}}e.ExtHostDocumentContentProvider=A,A._handlePool=0}),define(De[193],Ie([1,0,5,7,2,4,87,8,9,27,6]),function(J,e,s,C,p,U,T,P,b,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class w{constructor(S,f){this._onDidAddDocument=new s.Emitter,this._onDidRemoveDocument=new s.Emitter,this._onDidChangeDocument=new s.Emitter,this._onDidSaveDocument=new s.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new C.DisposableStore,this._documentLoader=new Map,this._proxy=S.getProxy(U.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(c=>{for(const h of c)this._onDidRemoveDocument.fire(h.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(c=>{for(const h of c)this._onDidAddDocument.fire(h.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(S){if(!S)return;const f=this._documentsAndEditors.getDocument(S);if(f)return f}getDocument(S){const f=this.getDocumentData(S);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${S}'`);return f.document}ensureDocumentData(S){const f=this._documentsAndEditors.getDocument(S);if(f)return Promise.resolve(f);let c=this._documentLoader.get(S.toString());return c||(c=this._proxy.$tryOpenDocument(S).then(h=>{this._documentLoader.delete(S.toString());const u=p.URI.revive(h);return(0,b.assertIsDefined)(this._documentsAndEditors.getDocument(u))},h=>(this._documentLoader.delete(S.toString()),Promise.reject(h))),this._documentLoader.set(S.toString(),c)),c}createDocumentData(S){return this._proxy.$tryCreateDocument(S).then(f=>p.URI.revive(f))}$acceptModelLanguageChanged(S,f){const c=p.URI.revive(S),h=this._documentsAndEditors.getDocument(c);if(!h)throw new Error("unknown document");this._onDidRemoveDocument.fire(h.document),h._acceptLanguageId(f),this._onDidAddDocument.fire(h.document)}$acceptModelSaved(S){const f=p.URI.revive(S),c=this._documentsAndEditors.getDocument(f);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(S,!1),this._onDidSaveDocument.fire(c.document)}$acceptDirtyStateChanged(S,f){const c=p.URI.revive(S),h=this._documentsAndEditors.getDocument(c);if(!h)throw new Error("unknown document");h._acceptIsDirty(f),this._onDidChangeDocument.fire({document:h.document,contentChanges:[],reason:void 0})}$acceptModelChanged(S,f,c){const h=p.URI.revive(S),u=this._documentsAndEditors.getDocument(h);if(!u)throw new Error("unknown document");u._acceptIsDirty(c),u.onEvents(f);let D;f.isUndoing?D=O.TextDocumentChangeReason.Undo:f.isRedoing&&(D=O.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,A.deepFreeze)({document:u.document,contentChanges:f.changes.map(y=>({range:P.Range.to(y.range),rangeOffset:y.rangeOffset,rangeLength:y.rangeLength,text:y.text})),reason:D}))}setWordDefinitionFor(S,f){(0,T.setWordDefinitionFor)(S,f)}}e.ExtHostDocuments=w}),define(De[50],Ie([1,0,42,5,7,2,3,4,87,16,93,8,14,24,12,167,194]),function(J,e,s,C,p,U,T,P,b,A,O,w,g,S,f,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class u{constructor(a){this.value=a,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let D=class{constructor(a,_){this._extHostRpc=a,this._logService=_,this._activeEditorId=null,this._editors=new Map,this._documents=new S.ResourceMap,this._onDidAddDocuments=new C.Emitter,this._onDidRemoveDocuments=new C.Emitter,this._onDidChangeVisibleTextEditors=new C.Emitter,this._onDidChangeActiveTextEditor=new C.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const _=[],r=[],d=[];if(a.removedDocuments)for(const i of a.removedDocuments){const o=U.URI.revive(i),n=this._documents.get(o);n?.unref()&&(this._documents.delete(o),_.push(n.value))}if(a.addedDocuments)for(const i of a.addedDocuments){const o=U.URI.revive(i.uri);let n=this._documents.get(o);if(n&&o.scheme!==f.Schemas.vscodeNotebookCell&&o.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);n||(n=new u(new b.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),o,i.lines,i.EOL,i.versionId,i.languageId,i.isDirty,i.notebook)),this._documents.set(o,n),r.push(n.value)),n.ref()}if(a.removedEditors)for(const i of a.removedEditors){const o=this._editors.get(i);this._editors.delete(i),o&&d.push(o)}if(a.addedEditors)for(const i of a.addedEditors){const o=U.URI.revive(i.documentUri);s.ok(this._documents.has(o),`document '${o}' does not exist`),s.ok(!this._editors.has(i.id),`editor '${i.id}' already exists!`);const n=this._documents.get(o).value,t=new O.ExtHostTextEditor(i.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new h.Lazy(()=>n.document),i.selections.map(w.Selection.to),i.options,i.visibleRanges.map(l=>w.Range.to(l)),typeof i.editorPosition=="number"?w.ViewColumn.to(i.editorPosition):void 0);this._editors.set(i.id,t)}a.newActiveEditor!==void 0&&(s.ok(a.newActiveEditor===null||this._editors.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this._activeEditorId=a.newActiveEditor),(0,p.dispose)(_),(0,p.dispose)(d),a.removedDocuments&&this._onDidRemoveDocuments.fire(_),a.addedDocuments&&this._onDidAddDocuments.fire(r),(a.removedEditors||a.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(i=>i.value)),a.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(a){return this._documents.get(a)?.value}allDocuments(){return c.Iterable.map(this._documents.values(),a=>a.value)}getEditor(a){return this._editors.get(a)}activeEditor(a){if(!this._activeEditorId)return;const _=this._editors.get(this._activeEditorId);return a?_:_?.value}allEditors(){return[...this._editors.values()]}};D=$e([xe(0,A.IExtHostRpcService),xe(1,g.ILogService)],D),e.ExtHostDocumentsAndEditors=D,e.IExtHostDocumentsAndEditors=(0,T.createDecorator)("IExtHostDocumentsAndEditors")}),define(De[51],Ie([1,0,8,4,2,5,3,6,16,9,43]),function(J,e,s,C,p,U,T,P,b,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,T.createDecorator)("IExtHostEditorTabs");class w{constructor(h,u,D){this._activeTabIdGetter=D,this._parentGroup=u,this.acceptDtoUpdate(h)}get apiObject(){if(!this._apiObject){const h=this,u={get isActive(){return h._dto.id===h._activeTabIdGetter()},get label(){return h._dto.label},get input(){return h._input},get isDirty(){return h._dto.isDirty},get isPinned(){return h._dto.isPinned},get isPreview(){return h._dto.isPreview},get group(){return h._parentGroup.apiObject}};this._apiObject=Object.freeze(u)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(h){this._dto=h,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new P.TextTabInput(p.URI.revive(this._dto.input.uri));case 2:return new P.TextDiffTabInput(p.URI.revive(this._dto.input.original),p.URI.revive(this._dto.input.modified));case 5:return new P.CustomEditorTabInput(p.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 6:return new P.WebviewEditorTabInput(this._dto.input.viewType);case 3:return new P.NotebookEditorTabInput(p.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 4:return new P.NotebookDiffEditorTabInput(p.URI.revive(this._dto.input.original),p.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 7:return new P.TerminalEditorTabInput;default:return}}}class g{constructor(h,u,D){this._tabs=[],this._activeTabId="",this._dto=h,this._activeGroupIdGetter=D;for(const y of h.tabs)y.isActive&&(this._activeTabId=y.id),this._tabs.push(new w(y,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const h=this,u={get isActive(){return h._dto.groupId===h._activeGroupIdGetter()},get viewColumn(){return s.ViewColumn.to(h._dto.viewColumn)},get activeTab(){return h._tabs.find(D=>D.tabId===h._activeTabId)?.apiObject},get tabs(){return Object.freeze(h._tabs.map(D=>D.apiObject))}};this._apiObject=Object.freeze(u)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(h){this._dto=h}acceptTabOperation(h){if(h.kind===0){const D=new w(h.tabDto,this,()=>this.activeTabId());return this._tabs.splice(h.index,0,D),h.tabDto.isActive&&(this._activeTabId=D.tabId),D}else if(h.kind===1){const D=this._tabs.splice(h.index,1)[0];if(!D)throw new Error(`Tab close updated received for index ${h.index} which does not exist`);return D.tabId===this._activeTabId&&(this._activeTabId=""),D}else if(h.kind===3){if(h.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const D=this._tabs.splice(h.oldIndex,1)[0];if(!D)throw new Error(`Tab move updated received for index ${h.oldIndex} which does not exist`);return this._tabs.splice(h.index,0,D),D}const u=this._tabs.find(D=>D.tabId===h.tabDto.id);if(!u)throw new Error("INVALID tab");return h.tabDto.isActive?this._activeTabId=h.tabDto.id:this._activeTabId===h.tabDto.id&&!h.tabDto.isActive&&(this._activeTabId=""),u.acceptDtoUpdate(h.tabDto),u}activeTabId(){return this._activeTabId}}let S=class{constructor(h){this._onDidChangeTabs=new U.Emitter,this._onDidChangeTabGroups=new U.Emitter,this._extHostTabGroups=[],this._proxy=h.getProxy(C.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const h=this,u={onDidChangeTabGroups:h._onDidChangeTabGroups.event,onDidChangeTabs:h._onDidChangeTabs.event,get all(){return Object.freeze(h._extHostTabGroups.map(D=>D.apiObject))},get activeTabGroup(){const D=h._activeGroupId;return(0,A.assertIsDefined)(h._extHostTabGroups.find(a=>a.groupId===D)?.apiObject)},close:async(D,y)=>{const a=Array.isArray(D)?D:[D];return a.length?f(a[0])?this._closeGroups(a,y):this._closeTabs(a,y):!0}};this._apiObject=Object.freeze(u)}return this._apiObject}$acceptEditorTabModel(h){const u=new Set(this._extHostTabGroups.map(i=>i.groupId)),D=new Set(h.map(i=>i.groupId)),y=(0,O.diffSets)(u,D),a=this._extHostTabGroups.filter(i=>y.removed.includes(i.groupId)).map(i=>i.apiObject),_=[],r=[];this._extHostTabGroups=h.map(i=>{const o=new g(i,this._proxy,()=>this._activeGroupId);return y.added.includes(o.groupId)?_.push(o.apiObject):r.push(o.apiObject),o});const d=(0,A.assertIsDefined)(h.find(i=>i.isActive===!0)?.groupId);d!==void 0&&this._activeGroupId!==d&&(this._activeGroupId=d),this._onDidChangeTabGroups.fire(Object.freeze({opened:_,closed:a,changed:r}))}$acceptTabGroupUpdate(h){const u=this._extHostTabGroups.find(D=>D.groupId===h.groupId);if(!u)throw new Error("Update Group IPC call received before group creation.");u.acceptGroupDtoUpdate(h),h.isActive&&(this._activeGroupId=h.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[u.apiObject],opened:[],closed:[]}))}$acceptTabOperation(h){const u=this._extHostTabGroups.find(y=>y.groupId===h.groupId);if(!u)throw new Error("Update Tabs IPC call received before group creation.");const D=u.acceptTabOperation(h);switch(h.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[D.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[D.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[D.apiObject]}));return}}_findExtHostTabFromApi(h){for(const u of this._extHostTabGroups)for(const D of u.tabs)if(D.apiObject===h)return D}_findExtHostTabGroupFromApi(h){return this._extHostTabGroups.find(u=>u.apiObject===h)}async _closeTabs(h,u){const D=[];for(const y of h){const a=this._findExtHostTabFromApi(y);if(!a)throw new Error("Tab close: Invalid tab not found!");D.push(a.tabId)}return this._proxy.$closeTab(D,u)}async _closeGroups(h,u){const D=[];for(const y of h){const a=this._findExtHostTabGroupFromApi(y);if(!a)throw new Error("Group close: Invalid group not found!");D.push(a.groupId)}return this._proxy.$closeGroup(D,u)}};S=$e([xe(0,b.IExtHostRpcService)],S),e.ExtHostEditorTabs=S;function f(c){return c.tabs!==void 0}}),define(De[195],Ie([1,0,2,4,7,6,8,240,10,23,26]),function(J,e,s,C,p,U,T,P,b,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class w{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const c=this._schemes.indexOf(f);c>=0&&(this._schemes.splice(c,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),c=[];let h,u,D=14,y=14;for(const a of f){let _=h?(0,b.commonPrefixLength)(h,a):0;for(_===0?u=1:u=y;_<a.length;_++)_+1===a.length?(D=y,y=9):y+=1,c.push([u,a.toUpperCase().charCodeAt(_),y]),c.push([u,a.toLowerCase().charCodeAt(_),y]),u=y;h=a,y=D}c.push([9,58,10]),c.push([10,47,12]),this._stateMachine=new P.StateMachine(c)}}provideDocumentLinks(f){this._initStateMachine();const c=[],h=P.LinkComputer.computeLinks({getLineContent(u){return f.lineAt(u-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const u of h){const D=T.DocumentLink.to(u);D.target&&c.push(D)}return c}}class g{constructor(f,c){this._extHostLanguageFeatures=c,this._linkProvider=new w,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(C.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(f,c,h,u={}){if(this._registeredSchemes.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(f,"*",this._linkProvider));const D=this._handlePool++;this._linkProvider.add(c),this._registeredSchemes.add(c),this._fsProvider.set(D,h);let y=2;u.isCaseSensitive&&(y+=1024),u.isReadonly&&(y+=2048),typeof h.copy=="function"&&(y+=8),typeof h.open=="function"&&typeof h.close=="function"&&typeof h.read=="function"&&typeof h.write=="function"&&((0,O.checkProposedApiEnabled)(f,"fsChunks"),y+=4),this._proxy.$registerFileSystemProvider(D,c,y).catch(_=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${c}`),console.error(_)});const a=h.onDidChangeFile(_=>{const r=[];for(const d of _){let{uri:i,type:o}=d;if(i.scheme!==c)continue;let n;switch(o){case U.FileChangeType.Changed:n=0;break;case U.FileChangeType.Created:n=1;break;case U.FileChangeType.Deleted:n=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:i,type:n})}this._proxy.$onFileSystemChange(D,r)});return(0,p.toDisposable)(()=>{a.dispose(),this._linkProvider.delete(c),this._registeredSchemes.delete(c),this._fsProvider.delete(D),this._proxy.$unregisterProvider(D)})}static _asIStat(f){const{type:c,ctime:h,mtime:u,size:D,permissions:y}=f;return{type:c,ctime:h,mtime:u,size:D,permissions:y}}$stat(f,c){return Promise.resolve(this._getFsProvider(f).stat(s.URI.revive(c))).then(h=>g._asIStat(h))}$readdir(f,c){return Promise.resolve(this._getFsProvider(f).readDirectory(s.URI.revive(c)))}$readFile(f,c){return Promise.resolve(this._getFsProvider(f).readFile(s.URI.revive(c))).then(h=>A.VSBuffer.wrap(h))}$writeFile(f,c,h,u){return Promise.resolve(this._getFsProvider(f).writeFile(s.URI.revive(c),h.buffer,u))}$delete(f,c,h){return Promise.resolve(this._getFsProvider(f).delete(s.URI.revive(c),h))}$rename(f,c,h,u){return Promise.resolve(this._getFsProvider(f).rename(s.URI.revive(c),s.URI.revive(h),u))}$copy(f,c,h,u){const D=this._getFsProvider(f);if(!D.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(D.copy(s.URI.revive(c),s.URI.revive(h),u))}$mkdir(f,c){return Promise.resolve(this._getFsProvider(f).createDirectory(s.URI.revive(c)))}$watch(f,c,h,u){const D=this._getFsProvider(f).watch(s.URI.revive(h),u);this._watches.set(c,D)}$unwatch(f,c){const h=this._watches.get(c);h&&(h.dispose(),this._watches.delete(c))}$open(f,c,h){const u=this._getFsProvider(f);if(!u.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(u.open(s.URI.revive(c),h))}$close(f,c){const h=this._getFsProvider(f);if(!h.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(h.close(c))}$read(f,c,h,u){const D=this._getFsProvider(f);if(!D.read)throw new Error('FileSystemProvider does not implement "read"');const y=A.VSBuffer.alloc(u);return Promise.resolve(D.read(c,h,y.buffer,0,u)).then(a=>y.slice(0,a))}$write(f,c,h,u){const D=this._getFsProvider(f);if(!D.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(D.write(c,h,u.buffer,0,u.byteLength))}_getFsProvider(f){const c=this._fsProvider.get(f);if(!c){const h=new Error;throw h.name="ENOPRO",h.message="no provider",h}return c}}e.ExtHostFileSystem=g}),define(De[52],Ie([1,0,4,39,6,23,3,16,35,7]),function(J,e,s,C,p,U,T,P,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let O=class Gt{constructor(g,S){this._fileSystemProvider=new Map,this._proxy=g.getProxy(s.MainContext.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(c){try{const h=f._fileSystemProvider.get(c.scheme);if(!h)return await f._proxy.$stat(c);await f._proxy.$ensureActivation(c.scheme);const u=await h.stat(c);return{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions}}catch(h){Gt._handleError(h)}},async readDirectory(c){try{const h=f._fileSystemProvider.get(c.scheme);return h?(await f._proxy.$ensureActivation(c.scheme),(await h.readDirectory(c)).slice()):await f._proxy.$readdir(c)}catch(h){return Gt._handleError(h)}},async createDirectory(c){try{return await f._proxy.$mkdir(c)}catch(h){return Gt._handleError(h)}},async readFile(c){try{const h=f._fileSystemProvider.get(c.scheme);return h?(await f._proxy.$ensureActivation(c.scheme),(await h.readFile(c)).slice()):(await f._proxy.$readFile(c)).buffer}catch(h){return Gt._handleError(h)}},async writeFile(c,h){try{return await f._proxy.$writeFile(c,U.VSBuffer.wrap(h))}catch(u){return Gt._handleError(u)}},async delete(c,h){try{const u=f._fileSystemProvider.get(c.scheme);return u?(await f._proxy.$ensureActivation(c.scheme),await u.delete(c,{recursive:!1,...h})):await f._proxy.$delete(c,{recursive:!1,useTrash:!1,...h})}catch(u){return Gt._handleError(u)}},async rename(c,h,u){try{return await f._proxy.$rename(c,h,{overwrite:!1,...u})}catch(D){return Gt._handleError(D)}},async copy(c,h,u){try{return await f._proxy.$copy(c,h,{overwrite:!1,...u})}catch(D){return Gt._handleError(D)}},isWritableFileSystem(c){const h=S.getCapabilities(c);if(typeof h=="number")return!(h&2048)}})}static _handleError(g){if(g instanceof p.FileSystemError)throw g;if(!(g instanceof Error))throw new p.FileSystemError(String(g));if(g.name==="ENOPRO")throw p.FileSystemError.Unavailable(g.message);switch(g.name){case C.FileSystemProviderErrorCode.FileExists:throw p.FileSystemError.FileExists(g.message);case C.FileSystemProviderErrorCode.FileNotFound:throw p.FileSystemError.FileNotFound(g.message);case C.FileSystemProviderErrorCode.FileNotADirectory:throw p.FileSystemError.FileNotADirectory(g.message);case C.FileSystemProviderErrorCode.FileIsADirectory:throw p.FileSystemError.FileIsADirectory(g.message);case C.FileSystemProviderErrorCode.NoPermissions:throw p.FileSystemError.NoPermissions(g.message);case C.FileSystemProviderErrorCode.Unavailable:throw p.FileSystemError.Unavailable(g.message);default:throw new p.FileSystemError(g.message,g.name)}}addFileSystemProvider(g,S){return this._fileSystemProvider.set(g,S),(0,A.toDisposable)(()=>this._fileSystemProvider.delete(g))}};O=$e([xe(0,P.IExtHostRpcService),xe(1,b.IExtHostFileSystemInfo)],O),e.ExtHostConsumerFileSystem=O,e.IExtHostConsumerFileSystem=(0,T.createDecorator)("IExtHostConsumerFileSystem")}),define(De[196],Ie([1,0,5,34,2,4,8,6]),function(J,e,s,C,p,U,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class b{constructor(w,g,S,f,c,h,u,D){this._onDidCreate=new s.Emitter,this._onDidChange=new s.Emitter,this._onDidDelete=new s.Emitter;const y=this.ensureWatching(w,S,c);this._config=0,h&&(this._config+=1),u&&(this._config+=2),D&&(this._config+=4);const a=(0,C.parse)(c),_=typeof c=="string",r=f(d=>{if(!h)for(let i of d.created){const o=p.URI.revive(i);a(o.fsPath)&&(!_||g.getWorkspaceFolder(o))&&this._onDidCreate.fire(o)}if(!u)for(let i of d.changed){const o=p.URI.revive(i);a(o.fsPath)&&(!_||g.getWorkspaceFolder(o))&&this._onDidChange.fire(o)}if(!D)for(let i of d.deleted){const o=p.URI.revive(i);a(o.fsPath)&&(!_||g.getWorkspaceFolder(o))&&this._onDidDelete.fire(o)}});this._disposable=P.Disposable.from(y,this._onDidCreate,this._onDidChange,this._onDidDelete,r)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(w,g,S){let f=P.Disposable.from();if(typeof S=="string")return f;const c=w.getProxy(U.MainContext.MainThreadFileSystem);let h=!1;(S.pattern.includes(C.GLOBSTAR)||S.pattern.includes(C.GLOB_SPLIT))&&(h=!0);const u=Math.random();return c.$watch(g.identifier.value,u,S.baseUri,{recursive:h,excludes:[]}),P.Disposable.from({dispose:()=>c.$unwatch(u)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class A{constructor(w,g,S){this._mainContext=w,this._logService=g,this._extHostDocumentsAndEditors=S,this._onFileSystemEvent=new s.Emitter,this._onDidRenameFile=new s.Emitter,this._onDidCreateFile=new s.Emitter,this._onDidDeleteFile=new s.Emitter,this._onWillRenameFile=new s.AsyncEmitter,this._onWillCreateFile=new s.AsyncEmitter,this._onWillDeleteFile=new s.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(w,g,S,f,c,h){return new b(this._mainContext,w,g,this._onFileSystemEvent.event,T.GlobPattern.from(S),f,c,h)}$onFileEvent(w){this._onFileSystemEvent.fire(w)}$onDidRunFileOperation(w,g){switch(w){case 2:this._onDidRenameFile.fire(Object.freeze({files:g.map(S=>({oldUri:p.URI.revive(S.source),newUri:p.URI.revive(S.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:g.map(S=>p.URI.revive(S.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:g.map(S=>p.URI.revive(S.target))}));break;default:}}getOnWillRenameFileEvent(w){return this._createWillExecuteEvent(w,this._onWillRenameFile)}getOnWillCreateFileEvent(w){return this._createWillExecuteEvent(w,this._onWillCreateFile)}getOnWillDeleteFileEvent(w){return this._createWillExecuteEvent(w,this._onWillDeleteFile)}_createWillExecuteEvent(w,g){return(S,f,c)=>{const h=function(D){S.call(f,D)};return h.extension=w,g.event(h,void 0,c)}}async $onWillRunFileOperation(w,g,S,f){switch(w){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:g.map(c=>({oldUri:p.URI.revive(c.source),newUri:p.URI.revive(c.target)}))},S,f);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:g.map(c=>p.URI.revive(c.target))},S,f);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:g.map(c=>p.URI.revive(c.target))},S,f)}}async _fireWillEvent(w,g,S,f){const c=new Set,h=[];if(await w.fireAsync(g,f,async(D,y)=>{const a=Date.now(),_=await Promise.resolve(D);_ instanceof P.WorkspaceEdit&&(h.push(_),c.add(y.extension.displayName??y.extension.identifier.value)),Date.now()-a>S&&this._logService.warn("SLOW file-participant",y.extension.identifier)}),f.isCancellationRequested||h.length===0)return;const u={edits:[]};for(let D of h){let{edits:y}=T.WorkspaceEdit.from(D,{getTextDocumentVersion:a=>this._extHostDocumentsAndEditors.getDocument(a)?.version,getNotebookDocumentVersion:()=>{}});u.edits=u.edits.concat(y)}return{edit:u,extensionNames:Array.from(c)}}}e.ExtHostFileSystemEventService=A}),define(De[197],Ie([1,0,2,36]),function(J,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class p{constructor(T,P,b,A){this._extHostNotebooks=P,this._textDocumentsAndEditors=b,this._commands=A;const O=new C.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new C.ApiCommandArgument("showOptions","Show Options",w=>!0,w=>w),new C.ApiCommandArgument("resource","Interactive resource Uri",w=>!0,w=>w),new C.ApiCommandArgument("controllerId","Notebook controller Id",w=>!0,w=>w),new C.ApiCommandArgument("title","Interactive editor title",w=>!0,w=>w)],new C.ApiCommandResult("Notebook and input URI",w=>{if(w.notebookEditorId!==void 0){const g=this._extHostNotebooks.getEditorById(w.notebookEditorId);return{notebookUri:s.URI.revive(w.notebookUri),inputUri:s.URI.revive(w.inputUri),notebookEditor:g.apiEditor}}return{notebookUri:s.URI.revive(w.notebookUri),inputUri:s.URI.revive(w.inputUri)}}));this._commands.registerApiCommand(O)}$willAddInteractiveDocument(T,P,b,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:P,lines:[""],languageId:b,uri:T,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(s.URI.revive(A))?.apiNotebook}]})}$willRemoveInteractiveDocument(T,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.ExtHostInteractive=p}),define(De[198],Ie([1,0,7,4]),function(J,e,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class p{constructor(T){this._handlePool=0,this._proxy=T.getProxy(C.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(T){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,T),(0,s.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=p}),define(De[199],Ie([1,0,2,27,8,6,68,4,10,49,15,9,241,20,7,77,56,63,200,11,13,26]),function(J,e,s,C,p,U,T,P,b,A,O,w,g,S,f,c,h,u,D,y,a,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class r{constructor(k,z){this._documents=k,this._provider=z}async provideDocumentSymbols(k,z){const H=this._documents.getDocument(k),V=await this._provider.provideDocumentSymbols(H,z);if(!(0,O.isFalsyOrEmpty)(V))return V[0]instanceof U.DocumentSymbol?V.map(p.DocumentSymbol.from):r._asDocumentSymbolTree(V)}static _asDocumentSymbolTree(k){k=k.slice(0).sort((V,re)=>{let de=V.location.range.start.compareTo(re.location.range.start);return de===0&&(de=re.location.range.end.compareTo(V.location.range.end)),de});const z=[],H=[];for(const V of k){const re={name:V.name||"!!MISSING: name!!",kind:p.SymbolKind.from(V.kind),tags:V.tags?.map(p.SymbolTag.from)||[],detail:"",containerName:V.containerName,range:p.Range.from(V.location.range),selectionRange:p.Range.from(V.location.range),children:[]};for(;;){if(H.length===0){H.push(re),z.push(re);break}const de=H[H.length-1];if(A.Range.containsRange(de.range,re.range)&&!A.Range.equalsRange(de.range,re.range)){de.children&&de.children.push(re),H.push(re);break}H.pop()}}return z}}class d{constructor(k,z,H){this._documents=k,this._commands=z,this._provider=H,this._cache=new u.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(k,z){const H=this._documents.getDocument(k),V=await this._provider.provideCodeLenses(H,z);if(!V||z.isCancellationRequested)return;const re=this._cache.add(V),de=new f.DisposableStore;this._disposables.set(re,de);const Q={cacheId:re,lenses:[]};for(let pe=0;pe<V.length;pe++)Q.lenses.push({cacheId:[re,pe],range:p.Range.from(V[pe].range),command:this._commands.toInternal(V[pe].command,de)});return Q}async resolveCodeLens(k,z){const H=k.cacheId&&this._cache.get(...k.cacheId);if(!H)return;let V;if(typeof this._provider.resolveCodeLens!="function"||H.isResolved?V=H:V=await this._provider.resolveCodeLens(H,z),V||(V=H),z.isCancellationRequested)return;const re=k.cacheId&&this._disposables.get(k.cacheId[0]);if(!!re)return k.command=this._commands.toInternal(V.command??d._badCmd,re),k}releaseCodeLenses(k){this._disposables.get(k)?.dispose(),this._disposables.delete(k),this._cache.delete(k)}}d._badCmd={command:"missing",title:"!!MISSING: command!!"};function i(X){return Array.isArray(X)?X.map(p.DefinitionLink.from):X?[p.DefinitionLink.from(X)]:[]}class o{constructor(k,z){this._documents=k,this._provider=z}async provideDefinition(k,z,H){const V=this._documents.getDocument(k),re=p.Position.to(z),de=await this._provider.provideDefinition(V,re,H);return i(de)}}class n{constructor(k,z){this._documents=k,this._provider=z}async provideDeclaration(k,z,H){const V=this._documents.getDocument(k),re=p.Position.to(z),de=await this._provider.provideDeclaration(V,re,H);return i(de)}}class t{constructor(k,z){this._documents=k,this._provider=z}async provideImplementation(k,z,H){const V=this._documents.getDocument(k),re=p.Position.to(z),de=await this._provider.provideImplementation(V,re,H);return i(de)}}class l{constructor(k,z){this._documents=k,this._provider=z}async provideTypeDefinition(k,z,H){const V=this._documents.getDocument(k),re=p.Position.to(z),de=await this._provider.provideTypeDefinition(V,re,H);return i(de)}}class v{constructor(k,z){this._documents=k,this._provider=z}async provideHover(k,z,H){const V=this._documents.getDocument(k),re=p.Position.to(z),de=await this._provider.provideHover(V,re,H);if(!(!de||(0,O.isFalsyOrEmpty)(de.contents)))return de.range||(de.range=V.getWordRangeAtPosition(re)),de.range||(de.range=new U.Range(re,re)),p.Hover.from(de)}}class m{constructor(k,z){this._documents=k,this._provider=z}async provideEvaluatableExpression(k,z,H){const V=this._documents.getDocument(k),re=p.Position.to(z),de=await this._provider.provideEvaluatableExpression(V,re,H);if(de)return p.EvaluatableExpression.from(de)}}class I{constructor(k,z){this._documents=k,this._provider=z}async provideInlineValues(k,z,H,V){const re=this._documents.getDocument(k),de=await this._provider.provideInlineValues(re,p.Range.to(z),p.InlineValueContext.to(H),V);if(Array.isArray(de))return de.map(Q=>p.InlineValue.from(Q))}}class B{constructor(k,z){this._documents=k,this._provider=z}async provideDocumentHighlights(k,z,H){const V=this._documents.getDocument(k),re=p.Position.to(z),de=await this._provider.provideDocumentHighlights(V,re,H);if(Array.isArray(de))return de.map(p.DocumentHighlight.from)}}class x{constructor(k,z){this._documents=k,this._provider=z}async provideLinkedEditingRanges(k,z,H){const V=this._documents.getDocument(k),re=p.Position.to(z),de=await this._provider.provideLinkedEditingRanges(V,re,H);if(de&&Array.isArray(de.ranges))return{ranges:(0,O.coalesce)(de.ranges.map(p.Range.from)),wordPattern:de.wordPattern}}}class R{constructor(k,z){this._documents=k,this._provider=z}async provideReferences(k,z,H,V){const re=this._documents.getDocument(k),de=p.Position.to(z),Q=await this._provider.provideReferences(re,de,H,V);if(Array.isArray(Q))return Q.map(p.location.from)}}class E{constructor(k,z,H,V,re,de,Q){this._documents=k,this._commands=z,this._diagnostics=H,this._provider=V,this._logService=re,this._extension=de,this._apiDeprecation=Q,this._cache=new u.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(k,z,H,V){const re=this._documents.getDocument(k),de=g.Selection.isISelection(z)?p.Selection.to(z):p.Range.to(z),Q=[];for(const Ke of this._diagnostics.getDiagnostics(k))if(de.intersection(Ke.range)&&Q.push(Ke)>E._maxCodeActionsPerFile)break;const pe={diagnostics:Q,only:H.only?new U.CodeActionKind(H.only):void 0,triggerKind:p.CodeActionTriggerKind.to(H.trigger)},ge=await this._provider.provideCodeActions(re,de,pe,V);if(!(0,O.isNonEmptyArray)(ge)||V.isCancellationRequested)return;const Ne=this._cache.add(ge),Be=new f.DisposableStore;this._disposables.set(Ne,Be);const Pe=[];for(let Ke=0;Ke<ge.length;Ke++){const q=ge[Ke];!q||(E._isCommand(q)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Pe.push({_isSynthetic:!0,title:q.title,command:this._commands.toInternal(q,Be)})):(pe.only&&(q.kind?pe.only.contains(q.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action is of kind '${q.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Pe.push({cacheId:[Ne,Ke],title:q.title,command:q.command&&this._commands.toInternal(q.command,Be),diagnostics:q.diagnostics&&q.diagnostics.map(p.Diagnostic.from),edit:q.edit&&p.WorkspaceEdit.from(q.edit),kind:q.kind&&q.kind.value,isPreferred:q.isPreferred,disabled:q.disabled?.reason})))}return{cacheId:Ne,actions:Pe}}async resolveCodeAction(k,z){const[H,V]=k,re=this._cache.get(H,V);if(!re||E._isCommand(re)||!this._provider.resolveCodeAction)return;const de=await this._provider.resolveCodeAction(re,z)??re;return de?.edit?p.WorkspaceEdit.from(de.edit):void 0}releaseCodeActions(k){this._disposables.get(k)?.dispose(),this._disposables.delete(k),this._cache.delete(k)}static _isCommand(k){return typeof k.command=="string"&&typeof k.title=="string"}}E._maxCodeActionsPerFile=1e3;class M{constructor(k,z,H,V){this._proxy=k,this._documents=z,this._provider=H,this._handle=V}async prepareDocumentPaste(k,z,H,V){if(!this._provider.prepareDocumentPaste)return;const re=this._documents.getDocument(k),de=p.Range.to(z),Q=p.DataTransfer.toDataTransfer(H,()=>{throw new y.NotImplementedError});return await this._provider.prepareDocumentPaste(re,de,Q,V),p.DataTransfer.toDataTransferDTO(Q)}async providePasteEdits(k,z,H,V,re){const de=this._documents.getDocument(z),Q=p.Range.to(H),pe=p.DataTransfer.toDataTransfer(V,async Ne=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,k,Ne)).buffer),ge=await this._provider.provideDocumentPasteEdits(de,Q,pe,re);if(!!ge)return ge instanceof U.WorkspaceEdit?p.WorkspaceEdit.from(ge):p.SnippetTextEdit.from(ge)}}class N{constructor(k,z){this._documents=k,this._provider=z}async provideDocumentFormattingEdits(k,z,H){const V=this._documents.getDocument(k),re=await this._provider.provideDocumentFormattingEdits(V,z,H);if(Array.isArray(re))return re.map(p.TextEdit.from)}}class W{constructor(k,z){this._documents=k,this._provider=z}async provideDocumentRangeFormattingEdits(k,z,H,V){const re=this._documents.getDocument(k),de=p.Range.to(z),Q=await this._provider.provideDocumentRangeFormattingEdits(re,de,H,V);if(Array.isArray(Q))return Q.map(p.TextEdit.from)}}class Z{constructor(k,z){this._documents=k,this._provider=z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(k,z,H,V,re){const de=this._documents.getDocument(k),Q=p.Position.to(z),pe=await this._provider.provideOnTypeFormattingEdits(de,Q,H,V,re);if(Array.isArray(pe))return pe.map(p.TextEdit.from)}}class K{constructor(k,z){this._provider=k,this._logService=z,this._cache=new u.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(k,z){const H=await this._provider.provideWorkspaceSymbols(k,z);if(!(0,O.isNonEmptyArray)(H))return{symbols:[]};const V=this._cache.add(H),re={cacheId:V,symbols:[]};for(let de=0;de<H.length;de++){const Q=H[de];if(!Q||!Q.name){this._logService.warn("INVALID SymbolInformation",Q);continue}re.symbols.push({...p.WorkspaceSymbol.from(Q),cacheId:[V,de]})}return re}async resolveWorkspaceSymbol(k,z){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!k.cacheId)return k;const H=this._cache.get(...k.cacheId);if(H){const V=await this._provider.resolveWorkspaceSymbol(H,z);return V&&(0,C.mixin)(k,p.WorkspaceSymbol.from(V),!0)}}releaseWorkspaceSymbols(k){this._cache.delete(k)}}class F{constructor(k,z,H){this._documents=k,this._provider=z,this._logService=H}static supportsResolving(k){return typeof k.prepareRename=="function"}async provideRenameEdits(k,z,H,V){const re=this._documents.getDocument(k),de=p.Position.to(z);try{const Q=await this._provider.provideRenameEdits(re,de,H,V);return Q?p.WorkspaceEdit.from(Q):void 0}catch(Q){const pe=F._asMessage(Q);return pe?{rejectReason:pe,edits:void 0}:Promise.reject(Q)}}async resolveRenameLocation(k,z,H){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const V=this._documents.getDocument(k),re=p.Position.to(z);try{const de=await this._provider.prepareRename(V,re,H);let Q,pe;if(U.Range.isRange(de)?(Q=de,pe=V.getText(de)):(0,w.isObject)(de)&&(Q=de.range,pe=de.placeholder),!Q||!pe)return;if(Q.start.line>re.line||Q.end.line<re.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:p.Range.from(Q),text:pe}}catch(de){const Q=F._asMessage(de);return Q?{rejectReason:Q,range:void 0,text:void 0}:Promise.reject(de)}}static _asMessage(k){return typeof k=="string"?k:k instanceof Error&&typeof k.message=="string"?k.message:void 0}}class oe{constructor(k,z){this.resultId=k,this.tokens=z}}class ce{constructor(k,z){this._documents=k,this._provider=z,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(k,z,H){const V=this._documents.getDocument(k),re=z!==0?this._previousResults.get(z):null;let de=typeof re?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(V,re.resultId,H):await this._provider.provideDocumentSemanticTokens(V,H);return re&&this._previousResults.delete(z),de?(de=ce._fixProvidedSemanticTokens(de),this._send(ce._convertToEdits(re,de),de)):null}async releaseDocumentSemanticColoring(k){this._previousResults.delete(k)}static _fixProvidedSemanticTokens(k){return ce._isSemanticTokens(k)?ce._isCorrectSemanticTokens(k)?k:new U.SemanticTokens(new Uint32Array(k.data),k.resultId):ce._isSemanticTokensEdits(k)?ce._isCorrectSemanticTokensEdits(k)?k:new U.SemanticTokensEdits(k.edits.map(z=>new U.SemanticTokensEdit(z.start,z.deleteCount,z.data?new Uint32Array(z.data):z.data)),k.resultId):k}static _isSemanticTokens(k){return k&&!!k.data}static _isCorrectSemanticTokens(k){return k.data instanceof Uint32Array}static _isSemanticTokensEdits(k){return k&&Array.isArray(k.edits)}static _isCorrectSemanticTokensEdits(k){for(const z of k.edits)if(!(z.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(k,z){if(!ce._isSemanticTokens(z)||!k||!k.tokens)return z;const H=k.tokens,V=H.length,re=z.data,de=re.length;let Q=0;const pe=Math.min(V,de);for(;Q<pe&&H[Q]===re[Q];)Q++;if(Q===V&&Q===de)return new U.SemanticTokensEdits([],z.resultId);let ge=0;const Ne=pe-Q;for(;ge<Ne&&H[V-ge-1]===re[de-ge-1];)ge++;return new U.SemanticTokensEdits([{start:Q,deleteCount:V-Q-ge,data:re.subarray(Q,de-ge)}],z.resultId)}_send(k,z){if(ce._isSemanticTokens(k)){const H=this._nextResultId++;return this._previousResults.set(H,new oe(k.resultId,k.data)),(0,c.encodeSemanticTokensDto)({id:H,type:"full",data:k.data})}if(ce._isSemanticTokensEdits(k)){const H=this._nextResultId++;return ce._isSemanticTokens(z)?this._previousResults.set(H,new oe(z.resultId,z.data)):this._previousResults.set(H,new oe(k.resultId)),(0,c.encodeSemanticTokensDto)({id:H,type:"delta",deltas:(k.edits||[]).map(V=>({start:V.start,deleteCount:V.deleteCount,data:V.data}))})}return null}}e.DocumentSemanticTokensAdapter=ce;class ae{constructor(k,z){this._documents=k,this._provider=z}async provideDocumentRangeSemanticTokens(k,z,H){const V=this._documents.getDocument(k),re=await this._provider.provideDocumentRangeSemanticTokens(V,p.Range.to(z),H);return re?this._send(re):null}_send(k){return(0,c.encodeSemanticTokensDto)({id:0,type:"full",data:k.data})}}e.DocumentRangeSemanticTokensAdapter=ae;class fe{constructor(k,z,H,V,re){this._documents=k,this._commands=z,this._provider=H,this._apiDeprecation=V,this._extension=re,this._cache=new u.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(k){return typeof k.resolveCompletionItem=="function"}async provideCompletionItems(k,z,H,V){const re=this._documents.getDocument(k),de=p.Position.to(z),Q=re.getWordRangeAtPosition(de)||new U.Range(de,de),pe=Q.with({end:de}),ge=new D.StopWatch(!0),Ne=await this._provider.provideCompletionItems(re,de,V,p.CompletionContext.to(H));if(!Ne||V.isCancellationRequested)return;const Be=Array.isArray(Ne)?new U.CompletionList(Ne):Ne,Pe=fe.supportsResolving(this._provider)?this._cache.add(Be.items):this._cache.add([]),Ke=new f.DisposableStore;this._disposables.set(Pe,Ke);const q=[],Y={x:Pe,b:q,a:{replace:p.Range.from(Q),insert:p.Range.from(pe)},c:Be.isIncomplete||void 0,d:ge.elapsed()};for(let me=0;me<Be.items.length;me++){const Le=Be.items[me],ze=this._convertCompletionItem(Le,[Pe,me],pe,Q);q.push(ze)}return Y}async resolveCompletionItem(k,z){if(typeof this._provider.resolveCompletionItem!="function")return;const H=this._cache.get(...k);if(!H)return;const V=await this._provider.resolveCompletionItem(H,z);if(!!V)return this._convertCompletionItem(V,k)}releaseCompletionItems(k){this._disposables.get(k)?.dispose(),this._disposables.delete(k),this._cache.delete(k)}_convertCompletionItem(k,z,H,V){const re=this._disposables.get(z[0]);if(!re)throw Error("DisposableStore is missing...");const de={x:z,a:k.label,b:k.kind!==void 0?p.CompletionItemKind.from(k.kind):void 0,n:k.tags&&k.tags.map(p.CompletionItemTag.from),c:k.detail,d:typeof k.documentation=="undefined"?void 0:p.MarkdownString.fromStrict(k.documentation),e:k.sortText!==k.label?k.sortText:void 0,f:k.filterText!==k.label?k.filterText:void 0,g:k.preselect||void 0,i:k.keepWhitespace?1:0,k:k.commitCharacters,l:k.additionalTextEdits&&k.additionalTextEdits.map(p.TextEdit.from),m:this._commands.toInternal(k.command,re)};k.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),de.h=k.textEdit.newText):typeof k.insertText=="string"?de.h=k.insertText:k.insertText instanceof U.SnippetString&&(de.h=k.insertText.value,de.i|=4);let Q;return k.textEdit?Q=k.textEdit.range:k.range&&(Q=k.range),U.Range.isRange(Q)?de.j=p.Range.from(Q):Q&&(!H?.isEqual(Q.inserting)||!V?.isEqual(Q.replacing))&&(de.j={insert:p.Range.from(Q.inserting),replace:p.Range.from(Q.replacing)}),de}}class ie{async provideInlineCompletions(k,z,H,V){}disposeCompletions(k){}handleDidShowCompletionItem(k,z){}}class Ee extends ie{constructor(k,z,H,V){super();this._extension=k,this._documents=z,this._provider=H,this._commands=V,this._references=new ee,this._isAdditionsProposedApiEnabled=(0,_.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[T.InlineCompletionTriggerKind.Automatic]:U.InlineCompletionTriggerKind.Automatic,[T.InlineCompletionTriggerKind.Explicit]:U.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,_.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(k,z,H,V){const re=this._documents.getDocument(k),de=p.Position.to(z),Q=await this._provider.provideInlineCompletionItems(re,de,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:p.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind]},V);if(!Q||V.isCancellationRequested)return;const pe=(0,w.isArray)(Q)?Q:Q.items,ge=this._isAdditionsProposedApiEnabled?(0,w.isArray)(Q)?[]:Q.commands||[]:[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne&&Ne.dispose()},items:pe}),items:pe.map((Pe,Ke)=>{let q;Pe.command&&(Ne||(Ne=new f.DisposableStore),q=this._commands.toInternal(Pe.command,Ne));const Y=Pe.insertText;return{insertText:typeof Y=="string"?Y:{snippet:Y.value},filterText:Pe.filterText,range:Pe.range?p.Range.from(Pe.range):void 0,command:q,idx:Ke,completeBracketPairs:this._isAdditionsProposedApiEnabled?Pe.completeBracketPairs:!1}}),commands:ge.map(Pe=>(Ne||(Ne=new f.DisposableStore),this._commands.toInternal(Pe,Ne)))}}disposeCompletions(k){this._references.disposeReferenceId(k)?.dispose()}handleDidShowCompletionItem(k,z){const H=this._references.get(k)?.items[z];H&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(H)}}class be extends ie{constructor(k,z,H,V){super();this.extension=k,this._documents=z,this._provider=H,this._commands=V,this._references=new ee,this.isAdditionProposedApiEnabled=(0,_.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[T.InlineCompletionTriggerKind.Automatic]:U.InlineCompletionTriggerKindNew.Automatic,[T.InlineCompletionTriggerKind.Explicit]:U.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(k,z,H,V){const re=this._documents.getDocument(k),de=p.Position.to(z),Q=await this._provider.provideInlineCompletionItems(re,de,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:p.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind]},V);if(!Q||V.isCancellationRequested)return;const pe=(0,w.isArray)(Q)?Q:Q.items,ge=(0,w.isArray)(Q)?[]:Q.commands||[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne&&Ne.dispose()},items:pe}),items:pe.map((Pe,Ke)=>{let q;Pe.command&&(Ne||(Ne=new f.DisposableStore),q=this._commands.toInternal(Pe.command,Ne));const Y=Pe.insertText;return{insertText:typeof Y=="string"?Y:{snippet:Y.value},filterText:Pe.filterText,range:Pe.range?p.Range.from(Pe.range):void 0,command:q,idx:Ke,completeBracketPairs:this.isAdditionProposedApiEnabled?Pe.completeBracketPairs:!1}}),commands:ge.map(Pe=>(Ne||(Ne=new f.DisposableStore),this._commands.toInternal(Pe,Ne)))}}disposeCompletions(k){this._references.disposeReferenceId(k)?.dispose()}handleDidShowCompletionItem(k,z){const H=this._references.get(k)?.items[z];H&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(H)}}class ee{constructor(){this._references=new Map,this._idPool=1}createReferenceId(k){const z=this._idPool++;return this._references.set(z,k),z}disposeReferenceId(k){const z=this._references.get(k);return this._references.delete(k),z}get(k){return this._references.get(k)}}class ve{constructor(k,z){this._documents=k,this._provider=z,this._cache=new u.Cache("SignatureHelp")}async provideSignatureHelp(k,z,H,V){const re=this._documents.getDocument(k),de=p.Position.to(z),Q=this.reviveContext(H),pe=await this._provider.provideSignatureHelp(re,de,V,Q);if(pe){const ge=this._cache.add([pe]);return{...p.SignatureHelp.from(pe),id:ge}}}reviveContext(k){let z;if(k.activeSignatureHelp){const H=p.SignatureHelp.to(k.activeSignatureHelp),V=this._cache.get(k.activeSignatureHelp.id,0);V?(z=V,z.activeSignature=H.activeSignature,z.activeParameter=H.activeParameter):z=H}return{...k,activeSignatureHelp:z}}releaseSignatureHelp(k){this._cache.delete(k)}}class Re{constructor(k,z,H,V,re){this._documents=k,this._commands=z,this._provider=H,this._logService=V,this._extension=re,this._cache=new u.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(k,z,H){const V=this._documents.getDocument(k),re=p.Range.to(z),de=await this._provider.provideInlayHints(V,re,H);if(!Array.isArray(de)||de.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${z}`);return}if(H.isCancellationRequested)return;const Q=this._cache.add(de);this._disposables.set(Q,new f.DisposableStore);const pe={hints:[],cacheId:Q};for(let ge=0;ge<de.length;ge++)this._isValidInlayHint(de[ge],re)&&pe.hints.push(this._convertInlayHint(de[ge],[Q,ge]));return this._logService.trace(`[InlayHints] ${pe.hints.length} inlay hints from '${this._extension.identifier.value}' for ${z}`),pe}async resolveInlayHint(k,z){if(typeof this._provider.resolveInlayHint!="function")return;const H=this._cache.get(...k);if(!H)return;const V=await this._provider.resolveInlayHint(H,z);if(!!V&&!!this._isValidInlayHint(V))return this._convertInlayHint(V,k)}releaseHints(k){this._disposables.get(k)?.dispose(),this._disposables.delete(k),this._cache.delete(k)}_isValidInlayHint(k,z){return k.label.length===0||Array.isArray(k.label)&&k.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",k),!1):!(z&&!z.contains(k.position))}_convertInlayHint(k,z){const H=this._disposables.get(z[0]);if(!H)throw Error("DisposableStore is missing...");const V={label:"",cacheId:z,tooltip:p.MarkdownString.fromStrict(k.tooltip),position:p.Position.from(k.position),textEdits:k.textEdits&&k.textEdits.map(p.TextEdit.from),kind:k.kind&&p.InlayHintKind.from(k.kind),paddingLeft:k.paddingLeft,paddingRight:k.paddingRight};return typeof k.label=="string"?V.label=k.label:V.label=k.label.map(re=>{let de={label:re.value};return de.tooltip=p.MarkdownString.fromStrict(re.tooltip),U.Location.isLocation(re.location)&&(de.location=p.location.from(re.location)),re.command&&(de.command=this._commands.toInternal(re.command,H)),de}),V}}class Fe{constructor(k,z){this._documents=k,this._provider=z,this._cache=new u.Cache("DocumentLink")}async provideLinks(k,z){const H=this._documents.getDocument(k),V=await this._provider.provideDocumentLinks(H,z);if(!(!Array.isArray(V)||V.length===0)&&!z.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:V.filter(Fe._validateLink).map(p.DocumentLink.from)};{const re=this._cache.add(V),de={links:[],cacheId:re};for(let Q=0;Q<V.length;Q++){if(!Fe._validateLink(V[Q]))continue;const pe=p.DocumentLink.from(V[Q]);pe.cacheId=[re,Q],de.links.push(pe)}return de}}}static _validateLink(k){return k.target&&k.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(k,z){if(typeof this._provider.resolveDocumentLink!="function")return;const H=this._cache.get(...k);if(!H)return;const V=await this._provider.resolveDocumentLink(H,z);if(!(!V||!Fe._validateLink(V)))return p.DocumentLink.from(V)}releaseLinks(k){this._cache.delete(k)}}class We{constructor(k,z){this._documents=k,this._provider=z}async provideColors(k,z){const H=this._documents.getDocument(k),V=await this._provider.provideDocumentColors(H,z);return Array.isArray(V)?V.map(de=>({color:p.Color.from(de.color),range:p.Range.from(de.range)})):[]}async provideColorPresentations(k,z,H){const V=this._documents.getDocument(k),re=p.Range.to(z.range),de=p.Color.to(z.color),Q=await this._provider.provideColorPresentations(de,{document:V,range:re},H);if(!!Array.isArray(Q))return Q.map(p.ColorPresentation.from)}}class Xe{constructor(k,z){this._documents=k,this._provider=z}async provideFoldingRanges(k,z,H){const V=this._documents.getDocument(k),re=await this._provider.provideFoldingRanges(V,z,H);if(!!Array.isArray(re))return re.map(p.FoldingRange.from)}}class Te{constructor(k,z,H){this._documents=k,this._provider=z,this._logService=H}async provideSelectionRanges(k,z,H){const V=this._documents.getDocument(k),re=z.map(p.Position.to),de=await this._provider.provideSelectionRanges(V,re,H);if(!(0,O.isNonEmptyArray)(de))return[];if(de.length!==re.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Q=[];for(let pe=0;pe<re.length;pe++){const ge=[];Q.push(ge);let Ne=re[pe],Be=de[pe];for(;;){if(!Be.range.contains(Ne))throw new Error("INVALID selection range, must contain the previous range");if(ge.push(p.SelectionRange.from(Be)),!Be.parent)break;Ne=Be.range,Be=Be.parent}}return Q}}class Se{constructor(k,z){this._documents=k,this._provider=z,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(k,z,H){const V=this._documents.getDocument(k),re=p.Position.to(z),de=await this._provider.prepareCallHierarchy(V,re,H);if(!de)return;const Q=this._idPool.nextId();return this._cache.set(Q,new Map),Array.isArray(de)?de.map(pe=>this._cacheAndConvertItem(Q,pe)):[this._cacheAndConvertItem(Q,de)]}async provideCallsTo(k,z,H){const V=this._itemFromCache(k,z);if(!V)throw new Error("missing call hierarchy item");const re=await this._provider.provideCallHierarchyIncomingCalls(V,H);if(!!re)return re.map(de=>({from:this._cacheAndConvertItem(k,de.from),fromRanges:de.fromRanges.map(Q=>p.Range.from(Q))}))}async provideCallsFrom(k,z,H){const V=this._itemFromCache(k,z);if(!V)throw new Error("missing call hierarchy item");const re=await this._provider.provideCallHierarchyOutgoingCalls(V,H);if(!!re)return re.map(de=>({to:this._cacheAndConvertItem(k,de.to),fromRanges:de.fromRanges.map(Q=>p.Range.from(Q))}))}releaseSession(k){this._cache.delete(k)}_cacheAndConvertItem(k,z){const H=this._cache.get(k),V=p.CallHierarchyItem.from(z,k,H.size.toString(36));return H.set(V._itemId,z),V}_itemFromCache(k,z){return this._cache.get(k)?.get(z)}}class ke{constructor(k,z){this._documents=k,this._provider=z,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(k,z,H){const V=this._documents.getDocument(k),re=p.Position.to(z),de=await this._provider.prepareTypeHierarchy(V,re,H);if(!de)return;const Q=this._idPool.nextId();return this._cache.set(Q,new Map),Array.isArray(de)?de.map(pe=>this._cacheAndConvertItem(Q,pe)):[this._cacheAndConvertItem(Q,de)]}async provideSupertypes(k,z,H){const V=this._itemFromCache(k,z);if(!V)throw new Error("missing type hierarchy item");const re=await this._provider.provideTypeHierarchySupertypes(V,H);if(!!re)return re.map(de=>this._cacheAndConvertItem(k,de))}async provideSubtypes(k,z,H){const V=this._itemFromCache(k,z);if(!V)throw new Error("missing type hierarchy item");const re=await this._provider.provideTypeHierarchySubtypes(V,H);if(!!re)return re.map(de=>this._cacheAndConvertItem(k,de))}releaseSession(k){this._cache.delete(k)}_cacheAndConvertItem(k,z){const H=this._cache.get(k),V=p.TypeHierarchyItem.from(z,k,H.size.toString(36));return H.set(V._itemId,z),V}_itemFromCache(k,z){return this._cache.get(k)?.get(z)}}class se{constructor(k,z,H,V){this._proxy=k,this._documents=z,this._provider=H,this._handle=V}async provideDocumentOnDropEdits(k,z,H,V,re){const de=this._documents.getDocument(z),Q=p.Position.to(H),pe=p.DataTransfer.toDataTransfer(V,async Ne=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,k,Ne)).buffer),ge=await this._provider.provideDocumentOnDropEdits(de,Q,pe,re);if(!!ge)return p.SnippetTextEdit.from(ge)}}class le{constructor(k,z){this.adapter=k,this.extension=z}}class G{constructor(k,z,H,V,re,de,Q){this._adapter=new Map,this._uriTransformer=z,this._proxy=k.getProxy(P.MainContext.MainThreadLanguageFeatures),this._documents=H,this._commands=V,this._diagnostics=re,this._logService=de,this._apiDeprecation=Q}_transformDocumentSelector(k){return p.DocumentSelector.from(k,this._uriTransformer)}_createDisposable(k){return new U.Disposable(()=>{this._adapter.delete(k),this._proxy.$unregister(k)})}_nextHandle(){return G._handlePool++}async _withAdapter(k,z,H,V,re,de=!1){const Q=this._adapter.get(k);if(!Q||!(Q.adapter instanceof z))return V;const pe=Date.now();de||this._logService.trace(`[${Q.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const ge=H(Q.adapter,Q.extension);return Promise.resolve(ge).catch(Ne=>{(0,y.isCancellationError)(Ne)||(this._logService.error(`[${Q.extension.identifier.value}] provider FAILED`),this._logService.error(Ne))}).finally(()=>{de||this._logService.trace(`[${Q.extension.identifier.value}] provider DONE after ${Date.now()-pe}ms`)}),S.CancellationToken.isCancellationToken(re)?(0,a.raceCancellationError)(ge,re):ge}_addNewAdapter(k,z){const H=this._nextHandle();return this._adapter.set(H,new le(k,z)),H}static _extLabel(k){return k.displayName||k.name}registerDocumentSymbolProvider(k,z,H,V){const re=this._addNewAdapter(new r(this._documents,H),k),de=V&&V.label||G._extLabel(k);return this._proxy.$registerDocumentSymbolProvider(re,this._transformDocumentSelector(z),de),this._createDisposable(re)}$provideDocumentSymbols(k,z,H){return this._withAdapter(k,r,V=>V.provideDocumentSymbols(s.URI.revive(z),H),void 0,H)}registerCodeLensProvider(k,z,H){const V=this._nextHandle(),re=typeof H.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(V,new le(new d(this._documents,this._commands.converter,H),k)),this._proxy.$registerCodeLensSupport(V,this._transformDocumentSelector(z),re);let de=this._createDisposable(V);if(re!==void 0){const Q=H.onDidChangeCodeLenses(pe=>this._proxy.$emitCodeLensEvent(re));de=U.Disposable.from(de,Q)}return de}$provideCodeLenses(k,z,H){return this._withAdapter(k,d,V=>V.provideCodeLenses(s.URI.revive(z),H),void 0,H)}$resolveCodeLens(k,z,H){return this._withAdapter(k,d,V=>V.resolveCodeLens(z,H),void 0,void 0)}$releaseCodeLenses(k,z){this._withAdapter(k,d,H=>Promise.resolve(H.releaseCodeLenses(z)),void 0,void 0)}registerDefinitionProvider(k,z,H){const V=this._addNewAdapter(new o(this._documents,H),k);return this._proxy.$registerDefinitionSupport(V,this._transformDocumentSelector(z)),this._createDisposable(V)}$provideDefinition(k,z,H,V){return this._withAdapter(k,o,re=>re.provideDefinition(s.URI.revive(z),H,V),[],V)}registerDeclarationProvider(k,z,H){const V=this._addNewAdapter(new n(this._documents,H),k);return this._proxy.$registerDeclarationSupport(V,this._transformDocumentSelector(z)),this._createDisposable(V)}$provideDeclaration(k,z,H,V){return this._withAdapter(k,n,re=>re.provideDeclaration(s.URI.revive(z),H,V),[],V)}registerImplementationProvider(k,z,H){const V=this._addNewAdapter(new t(this._documents,H),k);return this._proxy.$registerImplementationSupport(V,this._transformDocumentSelector(z)),this._createDisposable(V)}$provideImplementation(k,z,H,V){return this._withAdapter(k,t,re=>re.provideImplementation(s.URI.revive(z),H,V),[],V)}registerTypeDefinitionProvider(k,z,H){const V=this._addNewAdapter(new l(this._documents,H),k);return this._proxy.$registerTypeDefinitionSupport(V,this._transformDocumentSelector(z)),this._createDisposable(V)}$provideTypeDefinition(k,z,H,V){return this._withAdapter(k,l,re=>re.provideTypeDefinition(s.URI.revive(z),H,V),[],V)}registerHoverProvider(k,z,H,V){const re=this._addNewAdapter(new v(this._documents,H),k);return this._proxy.$registerHoverProvider(re,this._transformDocumentSelector(z)),this._createDisposable(re)}$provideHover(k,z,H,V){return this._withAdapter(k,v,re=>re.provideHover(s.URI.revive(z),H,V),void 0,V)}registerEvaluatableExpressionProvider(k,z,H,V){const re=this._addNewAdapter(new m(this._documents,H),k);return this._proxy.$registerEvaluatableExpressionProvider(re,this._transformDocumentSelector(z)),this._createDisposable(re)}$provideEvaluatableExpression(k,z,H,V){return this._withAdapter(k,m,re=>re.provideEvaluatableExpression(s.URI.revive(z),H,V),void 0,V)}registerInlineValuesProvider(k,z,H,V){const re=typeof H.onDidChangeInlineValues=="function"?this._nextHandle():void 0,de=this._addNewAdapter(new I(this._documents,H),k);this._proxy.$registerInlineValuesProvider(de,this._transformDocumentSelector(z),re);let Q=this._createDisposable(de);if(re!==void 0){const pe=H.onDidChangeInlineValues(ge=>this._proxy.$emitInlineValuesEvent(re));Q=U.Disposable.from(Q,pe)}return Q}$provideInlineValues(k,z,H,V,re){return this._withAdapter(k,I,de=>de.provideInlineValues(s.URI.revive(z),H,V,re),void 0,re)}registerDocumentHighlightProvider(k,z,H){const V=this._addNewAdapter(new B(this._documents,H),k);return this._proxy.$registerDocumentHighlightProvider(V,this._transformDocumentSelector(z)),this._createDisposable(V)}$provideDocumentHighlights(k,z,H,V){return this._withAdapter(k,B,re=>re.provideDocumentHighlights(s.URI.revive(z),H,V),void 0,V)}registerLinkedEditingRangeProvider(k,z,H){const V=this._addNewAdapter(new x(this._documents,H),k);return this._proxy.$registerLinkedEditingRangeProvider(V,this._transformDocumentSelector(z)),this._createDisposable(V)}$provideLinkedEditingRanges(k,z,H,V){return this._withAdapter(k,x,async re=>{const de=await re.provideLinkedEditingRanges(s.URI.revive(z),H,V);if(de)return{ranges:de.ranges,wordPattern:de.wordPattern?G._serializeRegExp(de.wordPattern):void 0}},void 0,V)}registerReferenceProvider(k,z,H){const V=this._addNewAdapter(new R(this._documents,H),k);return this._proxy.$registerReferenceSupport(V,this._transformDocumentSelector(z)),this._createDisposable(V)}$provideReferences(k,z,H,V,re){return this._withAdapter(k,R,de=>de.provideReferences(s.URI.revive(z),H,V,re),void 0,re)}registerCodeActionProvider(k,z,H,V){const re=new f.DisposableStore,de=this._addNewAdapter(new E(this._documents,this._commands.converter,this._diagnostics,H,this._logService,k,this._apiDeprecation),k);return this._proxy.$registerQuickFixSupport(de,this._transformDocumentSelector(z),{providedKinds:V?.providedCodeActionKinds?.map(Q=>Q.value),documentation:V?.documentation?.map(Q=>({kind:Q.kind.value,command:this._commands.converter.toInternal(Q.command,re)}))},G._extLabel(k),Boolean(H.resolveCodeAction)),re.add(this._createDisposable(de)),re}$provideCodeActions(k,z,H,V,re){return this._withAdapter(k,E,de=>de.provideCodeActions(s.URI.revive(z),H,V,re),void 0,re)}$resolveCodeAction(k,z,H){return this._withAdapter(k,E,V=>V.resolveCodeAction(z,H),void 0,void 0)}$releaseCodeActions(k,z){this._withAdapter(k,E,H=>Promise.resolve(H.releaseCodeActions(z)),void 0,void 0)}registerDocumentFormattingEditProvider(k,z,H){const V=this._addNewAdapter(new N(this._documents,H),k);return this._proxy.$registerDocumentFormattingSupport(V,this._transformDocumentSelector(z),k.identifier,k.displayName||k.name),this._createDisposable(V)}$provideDocumentFormattingEdits(k,z,H,V){return this._withAdapter(k,N,re=>re.provideDocumentFormattingEdits(s.URI.revive(z),H,V),void 0,V)}registerDocumentRangeFormattingEditProvider(k,z,H){const V=this._addNewAdapter(new W(this._documents,H),k);return this._proxy.$registerRangeFormattingSupport(V,this._transformDocumentSelector(z),k.identifier,k.displayName||k.name),this._createDisposable(V)}$provideDocumentRangeFormattingEdits(k,z,H,V,re){return this._withAdapter(k,W,de=>de.provideDocumentRangeFormattingEdits(s.URI.revive(z),H,V,re),void 0,re)}registerOnTypeFormattingEditProvider(k,z,H,V){const re=this._addNewAdapter(new Z(this._documents,H),k);return this._proxy.$registerOnTypeFormattingSupport(re,this._transformDocumentSelector(z),V,k.identifier),this._createDisposable(re)}$provideOnTypeFormattingEdits(k,z,H,V,re,de){return this._withAdapter(k,Z,Q=>Q.provideOnTypeFormattingEdits(s.URI.revive(z),H,V,re,de),void 0,de)}registerWorkspaceSymbolProvider(k,z){const H=this._addNewAdapter(new K(z,this._logService),k);return this._proxy.$registerNavigateTypeSupport(H,typeof z.resolveWorkspaceSymbol=="function"),this._createDisposable(H)}$provideWorkspaceSymbols(k,z,H){return this._withAdapter(k,K,V=>V.provideWorkspaceSymbols(z,H),{symbols:[]},H)}$resolveWorkspaceSymbol(k,z,H){return this._withAdapter(k,K,V=>V.resolveWorkspaceSymbol(z,H),void 0,void 0)}$releaseWorkspaceSymbols(k,z){this._withAdapter(k,K,H=>H.releaseWorkspaceSymbols(z),void 0,void 0)}registerRenameProvider(k,z,H){const V=this._addNewAdapter(new F(this._documents,H,this._logService),k);return this._proxy.$registerRenameSupport(V,this._transformDocumentSelector(z),F.supportsResolving(H)),this._createDisposable(V)}$provideRenameEdits(k,z,H,V,re){return this._withAdapter(k,F,de=>de.provideRenameEdits(s.URI.revive(z),H,V,re),void 0,re)}$resolveRenameLocation(k,z,H,V){return this._withAdapter(k,F,re=>re.resolveRenameLocation(s.URI.revive(z),H,V),void 0,V)}registerDocumentSemanticTokensProvider(k,z,H,V){const re=this._addNewAdapter(new ce(this._documents,H),k),de=typeof H.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(re,this._transformDocumentSelector(z),V,de);let Q=this._createDisposable(re);if(de){const pe=H.onDidChangeSemanticTokens(ge=>this._proxy.$emitDocumentSemanticTokensEvent(de));Q=U.Disposable.from(Q,pe)}return Q}$provideDocumentSemanticTokens(k,z,H,V){return this._withAdapter(k,ce,re=>re.provideDocumentSemanticTokens(s.URI.revive(z),H,V),null,V)}$releaseDocumentSemanticTokens(k,z){this._withAdapter(k,ce,H=>H.releaseDocumentSemanticColoring(z),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(k,z,H,V){const re=this._addNewAdapter(new ae(this._documents,H),k);return this._proxy.$registerDocumentRangeSemanticTokensProvider(re,this._transformDocumentSelector(z),V),this._createDisposable(re)}$provideDocumentRangeSemanticTokens(k,z,H,V){return this._withAdapter(k,ae,re=>re.provideDocumentRangeSemanticTokens(s.URI.revive(z),H,V),null,V)}registerCompletionItemProvider(k,z,H,V){const re=this._addNewAdapter(new fe(this._documents,this._commands.converter,H,this._apiDeprecation,k),k);return this._proxy.$registerCompletionsProvider(re,this._transformDocumentSelector(z),V,fe.supportsResolving(H),`${k.identifier.value}(${V.join("")})`),this._createDisposable(re)}$provideCompletionItems(k,z,H,V,re){return this._withAdapter(k,fe,de=>de.provideCompletionItems(s.URI.revive(z),H,V,re),void 0,re)}$resolveCompletionItem(k,z,H){return this._withAdapter(k,fe,V=>V.resolveCompletionItem(z,H),void 0,H)}$releaseCompletionItems(k,z){this._withAdapter(k,fe,H=>H.releaseCompletionItems(z),void 0,void 0)}registerInlineCompletionsProvider(k,z,H){const V=new Ee(k,this._documents,H,this._commands.converter),re=this._addNewAdapter(V,k);return this._proxy.$registerInlineCompletionsSupport(re,this._transformDocumentSelector(z),V.supportsHandleDidShowCompletionItem),this._createDisposable(re)}registerInlineCompletionsProviderNew(k,z,H){const V=this._addNewAdapter(new be(k,this._documents,H,this._commands.converter),k);return this._proxy.$registerInlineCompletionsSupport(V,this._transformDocumentSelector(z),!0),this._createDisposable(V)}$provideInlineCompletions(k,z,H,V,re){return this._withAdapter(k,ie,de=>de.provideInlineCompletions(s.URI.revive(z),H,V,re),void 0,re)}$handleInlineCompletionDidShow(k,z,H){this._withAdapter(k,ie,async V=>{V.handleDidShowCompletionItem(z,H)},void 0,void 0)}$freeInlineCompletionsList(k,z){this._withAdapter(k,ie,async H=>{H.disposeCompletions(z)},void 0,void 0)}registerSignatureHelpProvider(k,z,H,V){const re=Array.isArray(V)?{triggerCharacters:V,retriggerCharacters:[]}:V,de=this._addNewAdapter(new ve(this._documents,H),k);return this._proxy.$registerSignatureHelpProvider(de,this._transformDocumentSelector(z),re),this._createDisposable(de)}$provideSignatureHelp(k,z,H,V,re){return this._withAdapter(k,ve,de=>de.provideSignatureHelp(s.URI.revive(z),H,V,re),void 0,re)}$releaseSignatureHelp(k,z){this._withAdapter(k,ve,H=>H.releaseSignatureHelp(z),void 0,void 0)}registerInlayHintsProvider(k,z,H){const V=typeof H.onDidChangeInlayHints=="function"?this._nextHandle():void 0,re=this._addNewAdapter(new Re(this._documents,this._commands.converter,H,this._logService,k),k);this._proxy.$registerInlayHintsProvider(re,this._transformDocumentSelector(z),typeof H.resolveInlayHint=="function",V,G._extLabel(k));let de=this._createDisposable(re);if(V!==void 0){const Q=H.onDidChangeInlayHints(pe=>this._proxy.$emitInlayHintsEvent(V));de=U.Disposable.from(de,Q)}return de}$provideInlayHints(k,z,H,V){return this._withAdapter(k,Re,re=>re.provideInlayHints(s.URI.revive(z),H,V),void 0,V)}$resolveInlayHint(k,z,H){return this._withAdapter(k,Re,V=>V.resolveInlayHint(z,H),void 0,H)}$releaseInlayHints(k,z){this._withAdapter(k,Re,H=>H.releaseHints(z),void 0,void 0)}registerDocumentLinkProvider(k,z,H){const V=this._addNewAdapter(new Fe(this._documents,H),k);return this._proxy.$registerDocumentLinkProvider(V,this._transformDocumentSelector(z),typeof H.resolveDocumentLink=="function"),this._createDisposable(V)}$provideDocumentLinks(k,z,H){return this._withAdapter(k,Fe,V=>V.provideLinks(s.URI.revive(z),H),void 0,H,z.scheme==="output")}$resolveDocumentLink(k,z,H){return this._withAdapter(k,Fe,V=>V.resolveLink(z,H),void 0,void 0,!0)}$releaseDocumentLinks(k,z){this._withAdapter(k,Fe,H=>H.releaseLinks(z),void 0,void 0,!0)}registerColorProvider(k,z,H){const V=this._addNewAdapter(new We(this._documents,H),k);return this._proxy.$registerDocumentColorProvider(V,this._transformDocumentSelector(z)),this._createDisposable(V)}$provideDocumentColors(k,z,H){return this._withAdapter(k,We,V=>V.provideColors(s.URI.revive(z),H),[],H)}$provideColorPresentations(k,z,H,V){return this._withAdapter(k,We,re=>re.provideColorPresentations(s.URI.revive(z),H,V),void 0,V)}registerFoldingRangeProvider(k,z,H){const V=this._nextHandle(),re=typeof H.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(V,new le(new Xe(this._documents,H),k)),this._proxy.$registerFoldingRangeProvider(V,this._transformDocumentSelector(z),re);let de=this._createDisposable(V);if(re!==void 0){const Q=H.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(re));de=U.Disposable.from(de,Q)}return de}$provideFoldingRanges(k,z,H,V){return this._withAdapter(k,Xe,re=>re.provideFoldingRanges(s.URI.revive(z),H,V),void 0,V)}registerSelectionRangeProvider(k,z,H){const V=this._addNewAdapter(new Te(this._documents,H,this._logService),k);return this._proxy.$registerSelectionRangeProvider(V,this._transformDocumentSelector(z)),this._createDisposable(V)}$provideSelectionRanges(k,z,H,V){return this._withAdapter(k,Te,re=>re.provideSelectionRanges(s.URI.revive(z),H,V),[],V)}registerCallHierarchyProvider(k,z,H){const V=this._addNewAdapter(new Se(this._documents,H),k);return this._proxy.$registerCallHierarchyProvider(V,this._transformDocumentSelector(z)),this._createDisposable(V)}$prepareCallHierarchy(k,z,H,V){return this._withAdapter(k,Se,re=>Promise.resolve(re.prepareSession(s.URI.revive(z),H,V)),void 0,V)}$provideCallHierarchyIncomingCalls(k,z,H,V){return this._withAdapter(k,Se,re=>re.provideCallsTo(z,H,V),void 0,V)}$provideCallHierarchyOutgoingCalls(k,z,H,V){return this._withAdapter(k,Se,re=>re.provideCallsFrom(z,H,V),void 0,V)}$releaseCallHierarchy(k,z){this._withAdapter(k,Se,H=>Promise.resolve(H.releaseSession(z)),void 0,void 0)}registerTypeHierarchyProvider(k,z,H){const V=this._addNewAdapter(new ke(this._documents,H),k);return this._proxy.$registerTypeHierarchyProvider(V,this._transformDocumentSelector(z)),this._createDisposable(V)}$prepareTypeHierarchy(k,z,H,V){return this._withAdapter(k,ke,re=>Promise.resolve(re.prepareSession(s.URI.revive(z),H,V)),void 0,V)}$provideTypeHierarchySupertypes(k,z,H,V){return this._withAdapter(k,ke,re=>re.provideSupertypes(z,H,V),void 0,V)}$provideTypeHierarchySubtypes(k,z,H,V){return this._withAdapter(k,ke,re=>re.provideSubtypes(z,H,V),void 0,V)}$releaseTypeHierarchy(k,z){this._withAdapter(k,ke,H=>Promise.resolve(H.releaseSession(z)),void 0,void 0)}registerDocumentOnDropEditProvider(k,z,H){const V=this._nextHandle();return this._adapter.set(V,new le(new se(this._proxy,this._documents,H,V),k)),this._proxy.$registerDocumentOnDropEditProvider(V,this._transformDocumentSelector(z)),this._createDisposable(V)}$provideDocumentOnDropEdits(k,z,H,V,re,de){return this._withAdapter(k,se,Q=>Promise.resolve(Q.provideDocumentOnDropEdits(z,s.URI.revive(H),V,re,de)),void 0,void 0)}registerDocumentPasteEditProvider(k,z,H){const V=this._nextHandle();return this._adapter.set(V,new le(new M(this._proxy,this._documents,H,V),k)),this._proxy.$registerPasteEditProvider(V,this._transformDocumentSelector(z),!!H.prepareDocumentPaste),this._createDisposable(V)}$prepareDocumentPaste(k,z,H,V,re){return this._withAdapter(k,M,de=>de.prepareDocumentPaste(s.URI.revive(z),H,V,re),void 0,re)}$providePasteEdits(k,z,H,V,re){return this._withAdapter(k,M,de=>de.providePasteEdits(0,s.URI.revive(z),H,V,re),void 0,re)}static _serializeRegExp(k){return{pattern:k.source,flags:(0,b.regExpFlags)(k)}}static _serializeIndentationRule(k){return{decreaseIndentPattern:G._serializeRegExp(k.decreaseIndentPattern),increaseIndentPattern:G._serializeRegExp(k.increaseIndentPattern),indentNextLinePattern:k.indentNextLinePattern?G._serializeRegExp(k.indentNextLinePattern):void 0,unIndentedLinePattern:k.unIndentedLinePattern?G._serializeRegExp(k.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(k){return{beforeText:G._serializeRegExp(k.beforeText),afterText:k.afterText?G._serializeRegExp(k.afterText):void 0,previousLineText:k.previousLineText?G._serializeRegExp(k.previousLineText):void 0,action:k.action}}static _serializeOnEnterRules(k){return k.map(G._serializeOnEnterRule)}setLanguageConfiguration(k,z,H){let{wordPattern:V}=H;if(V&&(0,b.regExpLeadsToEndlessLoop)(V))throw new Error(`Invalid language configuration: wordPattern '${V}' is not allowed to match the empty string.`);V?this._documents.setWordDefinitionFor(z,V):this._documents.setWordDefinitionFor(z,void 0),H.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",k,"Do not use."),H.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",k,"Do not use.");const re=this._nextHandle(),de={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?G._serializeRegExp(H.wordPattern):void 0,indentationRules:H.indentationRules?G._serializeIndentationRule(H.indentationRules):void 0,onEnterRules:H.onEnterRules?G._serializeOnEnterRules(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport};return this._proxy.$setLanguageConfiguration(re,z,de),this._createDisposable(re)}$setWordDefinitions(k){for(const z of k)this._documents.setWordDefinitionFor(z.languageId,new RegExp(z.regexSource,z.regexFlags))}}e.ExtHostLanguageFeatures=G,G._handlePool=0}),define(De[201],Ie([1,0,4,8,6,29,13,7]),function(J,e,s,C,p,U,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class b{constructor(O,w,g,S){this._documents=w,this._commands=g,this._uriTransformer=S,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=O.getProxy(s.MainContext.MainThreadLanguages)}$acceptLanguageIds(O){this._languageIds=O}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(O,w){await this._proxy.$changeLanguage(O,w);const g=this._documents.getDocumentData(O);if(!g)throw new Error(`document '${O.toString()}' NOT found`);return g.document}async tokenAtPosition(O,w){const g=O.version,S=C.Position.from(w),f=await this._proxy.$tokensAtPosition(O.uri,S),c={type:p.StandardTokenType.Other,range:O.getWordRangeAtPosition(w)??new p.Range(w.line,w.character,w.line,w.character)};if(!f)return c;const h={range:C.Range.to(f.range),type:C.TokenType.to(f.type)};return!h.range.contains(w)||g!==O.version?c:h}createLanguageStatusItem(O,w,g){const S=this._handlePool++,f=this._proxy,c=this._ids,h=`${O.identifier.value}/${w}`;if(c.has(h))throw new Error(`LanguageStatusItem with id '${w}' ALREADY exists`);c.add(h);const u={selector:g,id:w,name:O.displayName??O.name,severity:p.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let D,y=new P.DisposableStore;const a=()=>{D?.dispose(),D=(0,T.disposableTimeout)(()=>{y.clear(),this._proxy.$setLanguageStatus(S,{id:h,name:u.name??O.displayName??O.name,source:O.displayName??O.name,selector:C.DocumentSelector.from(u.selector,this._uriTransformer),label:u.text,detail:u.detail??"",severity:u.severity===p.LanguageStatusSeverity.Error?U.default.Error:u.severity===p.LanguageStatusSeverity.Warning?U.default.Warning:U.default.Info,command:u.command&&this._commands.toInternal(u.command,y),accessibilityInfo:u.accessibilityInformation,busy:u.busy})},0)},_={dispose(){y.dispose(),D?.dispose(),f.$removeLanguageStatus(S),c.delete(h)},get id(){return u.id},get name(){return u.name},set name(r){u.name=r,a()},get selector(){return u.selector},set selector(r){u.selector=r,a()},get text(){return u.text},set text(r){u.text=r,a()},get detail(){return u.detail},set detail(r){u.detail=r,a()},get severity(){return u.severity},set severity(r){u.severity=r,a()},get accessibilityInformation(){return u.accessibilityInformation},set accessibilityInformation(r){u.accessibilityInformation=r,a()},get command(){return u.command},set command(r){u.command=r,a()},get busy(){return u.busy},set busy(r){u.busy=r,a()}};return a(),_}}e.ExtHostLanguages=b}),define(De[202],Ie([1,0,14,4,28,16,5]),function(J,e,s,C,p,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let P=class extends s.AbstractLoggerService{constructor(O,w){const g=new T.Emitter;super(w.logLevel,g.event);this._proxy=O.getProxy(C.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(g)}$setLevel(O){this._onDidChangeLogLevel.fire(O)}doCreateLogger(O,w,g){return new b(this._proxy,O,w,g)}};P=$e([xe(0,U.IExtHostRpcService),xe(1,p.IExtHostInitDataService)],P),e.ExtHostLoggerService=P;class b extends s.AbstractMessageLogger{constructor(O,w,g,S){super(S?.always);this.proxy=O,this.file=w,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(g),this.proxy.$createLogger(w,S).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(O,w){const g=[[O,w]];this.isLoggerCreated?this.doLog(g):this.buffer.push(...g)}doLog(O){this.proxy.$log(this.file,O)}}}),define(De[203],Ie([1,0,4,14,26]),function(J,e,s,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function U(P){return P&&P.title}let T=class{constructor(b,A){this._logService=A,this._proxy=b.getProxy(s.MainContext.MainThreadMessageService)}showMessage(b,A,O,w,g){const S={source:{identifier:b.identifier,label:b.displayName||b.name}};let f;typeof w=="string"||U(w)?f=[w,...g]:(S.modal=w?.modal,S.useCustom=w?.useCustom,S.detail=w?.detail,f=g),S.useCustom&&(0,p.checkProposedApiEnabled)(b,"resolvers");const c=[];for(let h=0;h<f.length;h++){const u=f[h];if(typeof u=="string")c.push({title:u,handle:h,isCloseAffordance:!1});else if(typeof u=="object"){let{title:D,isCloseAffordance:y}=u;c.push({title:D,isCloseAffordance:!!y,handle:h})}else this._logService.warn("Invalid message item:",u)}return this._proxy.$showMessage(A,O,S,c).then(h=>{if(typeof h=="number")return f[h]})}};T=$e([xe(1,C.ILogService)],T),e.ExtHostMessageService=T}),define(De[204],Ie([1,0,23,5,96,7,24,10,9,2,63,4,36,8,6,40,174,91]),function(J,e,s,C,p,U,T,P,b,A,O,w,g,S,f,c,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class D{constructor(a,_,r,d,i){this._textDocumentsAndEditors=r,this._textDocuments=d,this._extensionStoragePaths=i,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new T.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new C.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new C.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new C.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new C.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new O.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=a.getProxy(w.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=a.getProxy(w.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=a.getProxy(w.MainContext.MainThreadNotebookEditors),this._commandsConverter=_.converter,_.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===12){const n=o.notebookEditor?.notebookUri,t=o.cell.handle,v=this._documents.get(n)?.getCell(t);if(v)return v.apiCell}return o}}),D._registerApiCommands(_)}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(a=>a.apiEditor)}getEditorById(a){const _=this._editors.get(a);if(!_)throw new Error(`unknown text editor: ${a}. known editors: ${[...this._editors.keys()]} `);return _}getIdByEditor(a){for(const[_,r]of this._editors)if(r.apiEditor===a)return _}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(a,_){const r=this._documents.get(a);if(!r&&!_)throw new Error(`NO notebook document for '${a}'`);return r}_getProviderData(a){const _=this._notebookContentProviders.get(a);if(!_)throw new Error(`NO provider for '${a}'`);return _}registerNotebookContentProvider(a,_,r,d,i){if((0,P.isFalsyOrWhitespace)(_))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(_))throw new Error(`Notebook provider for '${_}' already registered`);this._notebookContentProviders.set(_,{extension:a,provider:r});let o;return r.onDidChangeNotebookContentOptions&&(o=r.onDidChangeNotebookContentOptions(()=>{const n=S.NotebookDocumentContentOptions.from(r.options);this._notebookProxy.$updateNotebookProviderOptions(_,n)})),this._notebookProxy.$registerNotebookProvider({id:a.identifier,location:a.extensionLocation},_,S.NotebookDocumentContentOptions.from(d),D._convertNotebookRegistrationData(a,i)),new f.Disposable(()=>{o?.dispose(),this._notebookContentProviders.delete(_),this._notebookProxy.$unregisterNotebookProvider(_)})}static _convertNotebookRegistrationData(a,_){if(!_)return;const r=_.filenamePattern.map(d=>S.NotebookExclusiveDocumentPattern.from(d)).filter(d=>d!==void 0);if(_.filenamePattern&&!r){console.warn(`Notebook content provider view options file name pattern is invalid ${_.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:_.displayName,filenamePattern:r,exclusive:_.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,_,r){const d=D._notebookStatusBarItemProviderHandlePool++,i=typeof r.onDidChangeCellStatusBarItems=="function"?D._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(d,r),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(d,i,_);let o;return i!==void 0&&(o=r.onDidChangeCellStatusBarItems(n=>this._notebookProxy.$emitCellStatusBarEvent(i))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(d),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(d,i),o&&o.dispose()})}async createNotebookDocument(a){const _=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:a.viewType,content:a.content&&S.NotebookData.from(a.content)});return A.URI.revive(_)}async openNotebookDocument(a){const _=this._documents.get(a);if(_)return _.apiNotebook;const r=await this._notebookDocumentsProxy.$tryOpenNotebook(a),d=this._documents.get(A.URI.revive(r));return(0,b.assertIsDefined)(d?.apiNotebook)}async showNotebookDocument(a,_){A.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let r;typeof _=="object"?r={position:S.ViewColumn.from(_.viewColumn),preserveFocus:_.preserveFocus,selections:_.selections&&_.selections.map(S.NotebookRange.from),pinned:typeof _.preview=="boolean"?!_.preview:void 0}:r={preserveFocus:!1};const d=await this._notebookEditorsProxy.$tryShowNotebookDocument(a.uri,a.notebookType,r),i=d&&this._editors.get(d)?.apiEditor;if(i)return i;throw d?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,_,r,d){const i=this._notebookStatusBarItemProviders.get(a),o=A.URI.revive(_),n=this._documents.get(o);if(!n||!i)return;const t=n.getCellFromIndex(r);if(!t)return;const l=await i.provideCellStatusBarItems(t.apiCell,d);if(!l)return;const v=new U.DisposableStore,m=this._statusBarCache.add([v]),B=(Array.isArray(l)?l:[l]).map(x=>S.NotebookStatusBarItem.from(x,this._commandsConverter,v));return{cacheId:m,items:B}}$releaseNotebookCellStatusBarItems(a){this._statusBarCache.delete(a)}registerNotebookSerializer(a,_,r,d,i){if((0,P.isFalsyOrWhitespace)(_))throw new Error("viewType cannot be empty or just whitespace");const o=this._handlePool++;return this._notebookSerializer.set(o,r),this._notebookProxy.$registerNotebookSerializer(o,{id:a.identifier,location:a.extensionLocation},_,S.NotebookDocumentContentOptions.from(d),D._convertNotebookRegistrationData(a,i)),(0,U.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(o)})}async $dataToNotebook(a,_,r){const d=this._notebookSerializer.get(a);if(!d)throw new Error("NO serializer found");const i=await d.deserializeNotebook(_.buffer,r);return new c.SerializableObjectWithBuffers(S.NotebookData.from(i))}async $notebookToData(a,_,r){const d=this._notebookSerializer.get(a);if(!d)throw new Error("NO serializer found");const i=await d.serializeNotebook(S.NotebookData.to(_.value),r);return s.VSBuffer.wrap(i)}async $openNotebook(a,_,r,d,i){const{provider:o}=this._getProviderData(a),n=await o.openNotebook(A.URI.revive(_),{backupId:r,untitledDocumentData:d?.buffer},i);return new c.SerializableObjectWithBuffers({metadata:n.metadata??Object.create(null),cells:n.cells.map(S.NotebookCellData.from)})}async $saveNotebook(a,_,r){const d=this.getNotebookDocument(A.URI.revive(_)),{provider:i}=this._getProviderData(a);return await i.saveNotebook(d.apiNotebook,r),!0}async $saveNotebookAs(a,_,r,d){const i=this.getNotebookDocument(A.URI.revive(_)),{provider:o}=this._getProviderData(a);return await o.saveNotebookAs(A.URI.revive(r),i.apiNotebook,d),!0}async $backupNotebook(a,_,r){const d=this.getNotebookDocument(A.URI.revive(_)),i=this._getProviderData(a),o=this._extensionStoragePaths.workspaceValue(i.extension)??this._extensionStoragePaths.globalValue(i.extension),n=String((0,p.hash)([d.uri.toString(),this._backupIdPool++])),t=A.URI.joinPath(o,n),l=await i.provider.backupNotebook(d.apiNotebook,{destination:t},r);return d.updateBackup(l),l.id}_createExtHostEditor(a,_,r){if(this._editors.has(_))throw new Error(`editor with id ALREADY EXSIST: ${_}`);const d=new u.ExtHostNotebookEditor(_,this._notebookEditorsProxy,a,r.visibleRanges.map(S.NotebookRange.to),r.selections.map(S.NotebookRange.to),typeof r.viewColumn=="number"?S.ViewColumn.to(r.viewColumn):void 0);this._editors.set(_,d)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const r of a.value.removedDocuments){const d=A.URI.revive(r),i=this._documents.get(d);i&&(i.dispose(),this._documents.delete(d),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:i.apiNotebook.getCells().map(o=>o.document.uri)}),this._onDidCloseNotebookDocument.fire(i.apiNotebook));for(const o of this._editors.values())o.notebookData.uri.toString()===d.toString()&&this._editors.delete(o.id)}if(a.value.addedDocuments){const r=[];for(const d of a.value.addedDocuments){const i=A.URI.revive(d.uri);if(this._documents.has(i))throw new Error(`adding EXISTING notebook ${i} `);const o=new h.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,i,d);r.push(...d.cells.map(n=>h.ExtHostCell.asModelAddData(o.apiNotebook,n))),this._documents.get(i)?.dispose(),this._documents.set(i,o),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:r}),this._onDidOpenNotebookDocument.fire(o.apiNotebook)}}if(a.value.addedEditors)for(const r of a.value.addedEditors){if(this._editors.has(r.id))return;const d=A.URI.revive(r.documentUri),i=this._documents.get(d);i&&this._createExtHostEditor(i,r.id,r)}const _=[];if(a.value.removedEditors)for(const r of a.value.removedEditors){const d=this._editors.get(r);d&&(this._editors.delete(r),this._activeNotebookEditor?.id===d.id&&(this._activeNotebookEditor=void 0),_.push(d))}if(a.value.visibleEditors){this._visibleNotebookEditors=a.value.visibleEditors.map(d=>this._editors.get(d)).filter(d=>!!d);const r=new Set;this._visibleNotebookEditors.forEach(d=>r.add(d.id));for(const d of this._editors.values()){const i=r.has(d.id);d._acceptVisibility(i)}this._visibleNotebookEditors=[...this._editors.values()].map(d=>d).filter(d=>d.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this._activeNotebookEditor=void 0:a.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(a){const _=g.ApiCommandArgument.String.with("notebookType","A notebook type"),r=new g.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[_,new g.ApiCommandArgument("data","Bytes to convert to data",i=>i instanceof Uint8Array,i=>s.VSBuffer.wrap(i))],new g.ApiCommandResult("Notebook Data",i=>S.NotebookData.to(i.value))),d=new g.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[_,new g.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",i=>!0,i=>new c.SerializableObjectWithBuffers(S.NotebookData.from(i)))],new g.ApiCommandResult("Bytes",i=>i.buffer));a.registerApiCommand(r),a.registerApiCommand(d)}}e.ExtHostNotebookController=D,D._notebookStatusBarItemProviderHandlePool=0}),define(De[205],Ie([1,0,5,56,14,4,16,8]),function(J,e,s,C,p,U,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class b{constructor(w,g){const S=b._Keys.nextId();w.$registerNotebookEditorDecorationType(S,P.NotebookDecorationRenderOptions.from(g)),this.value={key:S,dispose(){w.$removeNotebookEditorDecorationType(S)}}}}b._Keys=new C.IdGenerator("NotebookEditorDecorationType");let A=class{constructor(w,g,S){this._logService=w,this._extHostRpc=g,this._notebooksAndEditors=S,this._onDidChangeNotebookEditorSelection=new s.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new s.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(w){return new b(this._extHostRpc.getProxy(U.MainContext.MainThreadNotebookEditors),w).value}$acceptEditorPropertiesChanged(w,g){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",w,g);const S=this._notebooksAndEditors.getEditorById(w);g.visibleRanges&&S._acceptVisibleRanges(g.visibleRanges.ranges.map(P.NotebookRange.to)),g.selections&&S._acceptSelections(g.selections.selections.map(P.NotebookRange.to)),g.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:S.apiEditor,visibleRanges:S.apiEditor.visibleRanges}),g.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:S.apiEditor,selections:S.apiEditor.selections}))}$acceptEditorViewColumns(w){for(const g in w)this._notebooksAndEditors.getEditorById(g)._acceptViewColumn(P.ViewColumn.to(w[g]))}};A=$e([xe(0,p.ILogService),xe(1,T.IExtHostRpcService)],A),e.ExtHostNotebookEditors=A}),define(De[206],Ie([1,0,15,13,20,5,7,24,2,25,14,4,36,8,6,66,168,26,40]),function(J,e,s,C,p,U,T,P,b,A,O,w,g,S,f,c,h,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let y=class{constructor(o,n,t,l,v){this._initData=n,this._extHostNotebook=t,this._commands=l,this._logService=v,this._activeExecutions=new P.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new U.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=o.getProxy(w.MainContext.MainThreadNotebookKernels);const m=new g.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new g.ApiCommandArgument("options","Select kernel options",I=>!0,I=>{if(I&&"notebookEditor"in I&&"id"in I){const B=this._extHostNotebook.getIdByEditor(I.notebookEditor);return{id:I.id,extension:I.extension,notebookEditorId:B}}else if(I&&"notebookEditor"in I){const B=this._extHostNotebook.getIdByEditor(I.notebookEditor);if(B===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${I.notebookEditor.document.uri.toString()}`);return{notebookEditorId:B}}return I})],g.ApiCommandResult.Void);this._commands.registerApiCommand(m)}createNotebookController(o,n,t,l,v,m){for(const fe of this._kernelData.values())if(fe.controller.id===n&&A.ExtensionIdentifier.equals(o.identifier,fe.extensionId))throw new Error(`notebook controller with id '${n}' ALREADY exist`);const I=this._handlePool++,B=this;this._logService.trace(`NotebookController[${I}], CREATED by ${o.identifier.value}, ${n}`);const x=()=>console.warn(`NO execute handler from notebook controller '${W.id}' of extension: '${o.identifier}'`);let R=!1;const E=new T.DisposableStore,M=new U.Emitter,N=new U.Emitter,W={id:d(o.identifier,n),notebookType:t,extensionId:o.identifier,extensionLocation:o.extensionLocation,label:l||o.identifier.value,preloads:m?m.map(S.NotebookRendererScript.from):[]};let Z=v??x,K;this._proxy.$addKernel(I,W).catch(fe=>{console.log(fe),R=!0});let F=0;const oe=()=>{if(R)return;const fe=++F;Promise.resolve().then(()=>{fe===F&&this._proxy.$updateKernel(I,W)})},ce=new P.ResourceMap,ae={get id(){return n},get notebookType(){return W.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return W.label},set label(fe){W.label=fe??o.displayName??o.name,oe()},get detail(){return W.detail??""},set detail(fe){W.detail=fe,oe()},get description(){return W.description??""},set description(fe){W.description=fe,oe()},get kind(){return(0,u.checkProposedApiEnabled)(o,"notebookControllerKind"),W.kind??""},set kind(fe){(0,u.checkProposedApiEnabled)(o,"notebookControllerKind"),W.kind=fe,oe()},get supportedLanguages(){return W.supportedLanguages},set supportedLanguages(fe){W.supportedLanguages=fe,oe()},get supportsExecutionOrder(){return W.supportsExecutionOrder??!1},set supportsExecutionOrder(fe){W.supportsExecutionOrder=fe,oe()},get rendererScripts(){return W.preloads?W.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return Z},set executeHandler(fe){Z=fe??x},get interruptHandler(){return K},set interruptHandler(fe){K=fe,W.supportsInterrupt=Boolean(fe),oe()},createNotebookCellExecution(fe){if(R)throw new Error("notebook controller is DISPOSED");if(!ce.has(fe.notebook.uri))throw B._logService.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(ie=>ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${fe.notebook.uri.toString()}`);return B._createNotebookCellExecution(fe,d(o.identifier,this.id))},dispose:()=>{R||(this._logService.trace(`NotebookController[${I}], DISPOSED`),R=!0,this._kernelData.delete(I),E.dispose(),M.dispose(),N.dispose(),this._proxy.$removeKernel(I))},updateNotebookAffinity(fe,ie){B._proxy.$updateNotebookPriority(I,fe.uri,ie)},onDidReceiveMessage:N.event,postMessage(fe,ie){return(0,u.checkProposedApiEnabled)(o,"notebookMessaging"),B._proxy.$postMessage(I,ie&&B._extHostNotebook.getIdByEditor(ie),fe)},asWebviewUri(fe){return(0,u.checkProposedApiEnabled)(o,"notebookMessaging"),(0,c.asWebviewUri)(fe,B._initData.remote)}};return this._kernelData.set(I,{extensionId:o.identifier,controller:ae,onDidReceiveMessage:N,onDidChangeSelection:M,associatedNotebooks:ce}),ae}getIdByController(o){for(const[n,t]of this._kernelData)if(t.controller===o)return d(t.extensionId,o.id);return null}$acceptNotebookAssociation(o,n,t){const l=this._kernelData.get(o);if(l){const v=this._extHostNotebook.getNotebookDocument(b.URI.revive(n));t?l.associatedNotebooks.set(v.uri,!0):l.associatedNotebooks.delete(v.uri),this._logService.trace(`NotebookController[${o}] ASSOCIATE notebook`,v.uri.toString(),t),l.onDidChangeSelection.fire({selected:t,notebook:v.apiNotebook})}}async $executeCells(o,n,t){const l=this._kernelData.get(o);if(!l)return;const v=this._extHostNotebook.getNotebookDocument(b.URI.revive(n)),m=[];for(const I of t){const B=v.getCell(I);B&&m.push(B.apiCell)}try{this._logService.trace(`NotebookController[${o}] EXECUTE cells`,v.uri.toString(),m.length),await l.controller.executeHandler.call(l.controller,m,v.apiNotebook,l.controller)}catch(I){this._logService.error(`NotebookController[${o}] execute cells FAILED`,I),console.error(I)}}async $cancelCells(o,n,t){const l=this._kernelData.get(o);if(!l)return;const v=this._extHostNotebook.getNotebookDocument(b.URI.revive(n));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,v.apiNotebook);else for(const m of t){const I=v.getCell(m);I&&this._activeExecutions.get(I.uri)?.cancel()}}$acceptKernelMessageFromRenderer(o,n,t){const l=this._kernelData.get(o);if(!l)return;const v=this._extHostNotebook.getEditorById(n);l.onDidReceiveMessage.fire(Object.freeze({editor:v.apiEditor,message:t}))}$cellExecutionChanged(o,n,t){const v=this._extHostNotebook.getNotebookDocument(b.URI.revive(o)).getCell(n);v&&this._onDidChangeCellExecutionState.fire({cell:v.apiCell,state:t?S.NotebookCellExecutionState.to(t):f.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(o,n){if(o.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const l=this._extHostNotebook.getNotebookDocument(o.notebook.uri).getCellFromApiCell(o);if(!l)throw new Error("invalid cell");if(this._activeExecutions.has(l.uri))throw new Error(`duplicate execution for ${l.uri}`);const v=new _(n,l,this._proxy);this._activeExecutions.set(l.uri,v);const m=v.onDidChangeState(()=>{v.state===a.Resolved&&(v.dispose(),m.dispose(),this._activeExecutions.delete(l.uri))});return v.asApiObject()}};y=$e([xe(4,O.ILogService)],y),e.ExtHostNotebookKernels=y;var a;(function(i){i[i.Init=0]="Init",i[i.Started=1]="Started",i[i.Resolved=2]="Resolved"})(a||(a={}));class _ extends T.Disposable{constructor(o,n,t){super();this._cell=n,this._proxy=t,this._handle=_.HANDLE++,this._onDidChangeState=new U.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=a.Init,this._tokenSource=this._register(new p.CancellationTokenSource),this._collector=new r(10,l=>this.update(l)),this._executionOrder=n.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,o,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(o){await this._collector.addItem(o)}async update(o){const n=Array.isArray(o)?o:[o];return this._proxy.$updateExecution(this._handle,new D.SerializableObjectWithBuffers(n))}verifyStateForOutput(){if(this._state===a.Init)throw new Error("Must call start before modifying cell output");if(this._state===a.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(o){return o.map(n=>{const t=f.NotebookCellOutput.ensureUniqueMimeTypes(n.items,!0);return t===n.items?S.NotebookCellOutput.from(n):S.NotebookCellOutput.from({items:t,id:n.id,metadata:n.metadata})})}async updateOutputs(o,n,t){const l=this.validateAndConvertOutputs((0,s.asArray)(o));return this.updateSoon({editType:h.CellExecutionUpdateType.Output,append:t,outputs:l})}async updateOutputItems(o,n,t){return o=f.NotebookCellOutput.ensureUniqueMimeTypes((0,s.asArray)(o),!0),this.updateSoon({editType:h.CellExecutionUpdateType.OutputItems,items:o.map(S.NotebookCellOutputItem.from),outputId:n.id,append:t})}asApiObject(){const o=this;return Object.freeze({get token(){return o._tokenSource.token},get cell(){return o._cell.apiCell},get executionOrder(){return o._executionOrder},set executionOrder(t){o._executionOrder=t,o.update([{editType:h.CellExecutionUpdateType.ExecutionState,executionOrder:o._executionOrder}])},start(t){if(o._state===a.Resolved||o._state===a.Started)throw new Error("Cannot call start again");o._state=a.Started,o._onDidChangeState.fire(),o.update({editType:h.CellExecutionUpdateType.ExecutionState,runStartTime:t})},end(t,l){if(o._state===a.Resolved)throw new Error("Cannot call resolve twice");o._state=a.Resolved,o._onDidChangeState.fire(),o._collector.flush(),o._proxy.$completeExecution(o._handle,new D.SerializableObjectWithBuffers({runEndTime:l,lastRunSuccess:t}))},clearOutput(t){return o.verifyStateForOutput(),o.updateOutputs([],t,!1)},appendOutput(t,l){return o.verifyStateForOutput(),o.updateOutputs(t,l,!0)},replaceOutput(t,l){return o.verifyStateForOutput(),o.updateOutputs(t,l,!1)},appendOutputItems(t,l){return o.verifyStateForOutput(),o.updateOutputItems(t,l,!0)},replaceOutputItems(t,l){return o.verifyStateForOutput(),o.updateOutputItems(t,l,!1)}})}}_.HANDLE=0;class r{constructor(o,n){this.delay=o,this.callback=n,this.batch=[],this.startedTimer=Date.now()}addItem(o){return this.batch.push(o),this.currentDeferred||(this.currentDeferred=new C.DeferredPromise,this.startedTimer=Date.now(),(0,C.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const o=this.currentDeferred;this.currentDeferred=void 0;const n=this.batch;return this.batch=[],this.callback(n).finally(()=>o.complete())}}function d(i,o){return`${i.value}/${o}`}e.createKernelId=d}),define(De[207],Ie([1,0,5,4,91]),function(J,e,s,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class U{constructor(P,b){this._extHostNotebook=b,this._rendererMessageEmitters=new Map,this.proxy=P.getProxy(C.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(P,b,A){const O=this._extHostNotebook.getEditorById(P);this._rendererMessageEmitters.get(b)?.fire({editor:O.apiEditor,message:A})}createRendererMessaging(P,b){if(!P.contributes?.notebookRenderer?.some(O=>O.id===b))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${b})`);return{onDidReceiveMessage:(O,w,g)=>this.getOrCreateEmitterFor(b).event(O,w,g),postMessage:(O,w)=>{p.ExtHostNotebookEditor.apiEditorsToExtHost.has(O)&&([O,w]=[w,O]);const g=w&&p.ExtHostNotebookEditor.apiEditorsToExtHost.get(w);return this.proxy.$postMessage(g?.id,b,O)}}}getOrCreateEmitterFor(P){let b=this._rendererMessageEmitters.get(P);return b||(b=new s.Emitter({onLastListenerRemove:()=>{b?.dispose(),this._rendererMessageEmitters.delete(P)}}),this._rendererMessageEmitters.set(P,b),b)}}e.ExtHostNotebookRenderers=U}),define(De[208],Ie([1,0,20,5,7,4,2,6,11,15,29,62]),function(J,e,s,C,p,U,T,P,b,A,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function g(S,f,c){const h=S.getProxy(U.MainContext.MainThreadQuickOpen);class u{constructor(n,t){this._sessions=new Map,this._instances=0,this._workspace=n,this._commands=t}showQuickPick(n,t,l=s.CancellationToken.None){this._onDidSelectItem=void 0;const v=Promise.resolve(n),m=++this._instances,I=h.$show(m,{title:t?.title,placeHolder:t?.placeHolder,matchOnDescription:t?.matchOnDescription,matchOnDetail:t?.matchOnDetail,ignoreFocusLost:t?.ignoreFocusOut,canPickMany:t?.canPickMany},l),B={},x=I.then(()=>B);return Promise.race([x,v]).then(R=>{if(R!==B)return v.then(E=>{const M=[];for(let N=0;N<E.length;N++){const W=E[N];typeof W=="string"?M.push({label:W,handle:N}):W.kind===P.QuickPickItemKind.Separator?M.push({type:"separator",label:W.label}):M.push({label:W.label,description:W.description,detail:W.detail,picked:W.picked,alwaysShow:W.alwaysShow,handle:N})}return t&&typeof t.onDidSelectItem=="function"&&(this._onDidSelectItem=N=>{t.onDidSelectItem(E[N])}),h.$setItems(m,M),I.then(N=>{if(typeof N=="number")return E[N];if(Array.isArray(N))return N.map(W=>E[W])})})}).then(void 0,R=>{if(!(0,b.isCancellationError)(R))return h.$setError(m,R),Promise.reject(R)})}$onItemSelected(n){this._onDidSelectItem&&this._onDidSelectItem(n)}showInput(n,t=s.CancellationToken.None){return this._validateInput=n?.validateInput,h.$input(n,typeof this._validateInput=="function",t).then(void 0,l=>{if(!(0,b.isCancellationError)(l))return Promise.reject(l)})}async $validateInput(n){if(!this._validateInput)return;const t=await this._validateInput(n);if(!t||typeof t=="string")return t;let l;switch(t.severity){case P.InputBoxValidationSeverity.Info:l=O.default.Info;break;case P.InputBoxValidationSeverity.Warning:l=O.default.Warning;break;case P.InputBoxValidationSeverity.Error:l=O.default.Error;break;default:l=t.message?O.default.Error:O.default.Ignore;break}return{content:t.message,severity:l}}async showWorkspaceFolderPick(n,t=s.CancellationToken.None){const l=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[n]);if(!l)return;const v=await this._workspace.getWorkspaceFolders2();if(!!v)return v.find(m=>m.uri.toString()===l.uri.toString())}createQuickPick(n){const t=new d(n,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}createInputBox(n){const t=new i(n,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}$onDidChangeValue(n,t){const l=this._sessions.get(n);l&&l._fireDidChangeValue(t)}$onDidAccept(n){const t=this._sessions.get(n);t&&t._fireDidAccept()}$onDidChangeActive(n,t){const l=this._sessions.get(n);l instanceof d&&l._fireDidChangeActive(t)}$onDidChangeSelection(n,t){const l=this._sessions.get(n);l instanceof d&&l._fireDidChangeSelection(t)}$onDidTriggerButton(n,t){const l=this._sessions.get(n);l&&l._fireDidTriggerButton(t)}$onDidTriggerItemButton(n,t,l){const v=this._sessions.get(n);v instanceof d&&v._fireDidTriggerItemButton(t,l)}$onDidHide(n){const t=this._sessions.get(n);t&&t._fireDidHide()}}class D{constructor(n,t){this._extensionId=n,this._onDidDispose=t,this._id=d._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new C.Emitter,this._onDidChangeValueEmitter=new C.Emitter,this._onDidTriggerButtonEmitter=new C.Emitter,this._onDidHideEmitter=new C.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(n){this._title=n,this.update({title:n})}get step(){return this._steps}set step(n){this._steps=n,this.update({step:n})}get totalSteps(){return this._totalSteps}set totalSteps(n){this._totalSteps=n,this.update({totalSteps:n})}get enabled(){return this._enabled}set enabled(n){this._enabled=n,this.update({enabled:n})}get busy(){return this._busy}set busy(n){this._busy=n,this.update({busy:n})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(n){this._ignoreFocusOut=n,this.update({ignoreFocusOut:n})}get value(){return this._value}set value(n){this._value=n,this.update({value:n})}get placeholder(){return this._placeholder}set placeholder(n){this._placeholder=n,this.update({placeholder:n})}get buttons(){return this._buttons}set buttons(n){this._buttons=n.slice(),this._handlesToButtons.clear(),n.forEach((t,l)=>{const v=t===P.QuickInputButtons.Back?-1:l;this._handlesToButtons.set(v,t)}),this.update({buttons:n.map((t,l)=>({...r(t),tooltip:t.tooltip,handle:t===P.QuickInputButtons.Back?-1:l}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(n){this._value=n,this._onDidChangeValueEmitter.fire(n)}_fireDidTriggerButton(n){const t=this._handlesToButtons.get(n);t&&this._onDidTriggerButtonEmitter.fire(t)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,p.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),h.$dispose(this._id))}update(n){if(!this._disposed){for(const t of Object.keys(n)){const l=n[t];this._pendingUpdate[t]=l===void 0?null:l}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){h.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}D._nextId=1;function y(o){if(o instanceof P.ThemeIcon)return{id:o.id};const n=_(o),t=a(o);return{dark:typeof n=="string"?T.URI.file(n):n,light:typeof t=="string"?T.URI.file(t):t}}function a(o){return typeof o=="object"&&"light"in o?o.light:o}function _(o){return typeof o=="object"&&"dark"in o?o.dark:o}function r(o){const n=y(o.iconPath);let t,l;return"id"in n?l=w.ThemeIcon.asClassName(n):t=n,{iconPath:t,iconClass:l}}class d extends D{constructor(n,t){super(n.identifier,t);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new C.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new C.Emitter,this._onDidTriggerItemButtonEmitter=new C.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(n){this._items=n.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),n.forEach((l,v)=>{this._handlesToItems.set(v,l),this._itemsToHandles.set(l,v)});const t=[];for(let l=0;l<n.length;l++){const v=n[l];v.kind===P.QuickPickItemKind.Separator?t.push({type:"separator",label:v.label}):t.push({handle:l,label:v.label,description:v.description,detail:v.detail,picked:v.picked,alwaysShow:v.alwaysShow,buttons:v.buttons?.map((m,I)=>({...r(m),tooltip:m.tooltip,handle:I}))})}this.update({items:t})}get canSelectMany(){return this._canSelectMany}set canSelectMany(n){this._canSelectMany=n,this.update({canSelectMany:n})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(n){this._matchOnDescription=n,this.update({matchOnDescription:n})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(n){this._matchOnDetail=n,this.update({matchOnDetail:n})}get sortByLabel(){return this._sortByLabel}set sortByLabel(n){this._sortByLabel=n,this.update({sortByLabel:n})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(n){this._keepScrollPosition=n,this.update({keepScrollPosition:n})}get activeItems(){return this._activeItems}set activeItems(n){this._activeItems=n.filter(t=>this._itemsToHandles.has(t)),this.update({activeItems:this._activeItems.map(t=>this._itemsToHandles.get(t))})}get selectedItems(){return this._selectedItems}set selectedItems(n){this._selectedItems=n.filter(t=>this._itemsToHandles.has(t)),this.update({selectedItems:this._selectedItems.map(t=>this._itemsToHandles.get(t))})}_fireDidChangeActive(n){const t=(0,A.coalesce)(n.map(l=>this._handlesToItems.get(l)));this._activeItems=t,this._onDidChangeActiveEmitter.fire(t)}_fireDidChangeSelection(n){const t=(0,A.coalesce)(n.map(l=>this._handlesToItems.get(l)));this._selectedItems=t,this._onDidChangeSelectionEmitter.fire(t)}_fireDidTriggerItemButton(n,t){const l=this._handlesToItems.get(n);if(!l||!l.buttons||!l.buttons.length)return;const v=l.buttons[t];v&&this._onDidTriggerItemButtonEmitter.fire({button:v,item:l})}}class i extends D{constructor(n,t){super(n.identifier,t);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(n){this._password=n,this.update({password:n})}get prompt(){return this._prompt}set prompt(n){this._prompt=n,this.update({prompt:n})}get validationMessage(){return this._validationMessage}set validationMessage(n){this._validationMessage=n,n?typeof n=="string"?this.update({validationMessage:n,severity:O.default.Error}):this.update({validationMessage:n.message,severity:n.severity??O.default.Error}):this.update({validationMessage:void 0,severity:O.default.Ignore})}}return new u(f,c)}e.createExtHostQuickOpen=g});var Ye=this&&this.__classPrivateFieldSet||function(J,e,s,C,p){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?p.call(J,s):p?p.value=s:e.set(J,s),s},Ae=this&&this.__classPrivateFieldGet||function(J,e,s,C){if(s==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?C:s==="a"?C.call(J):C?C.value:e.get(J)};define(De[209],Ie([1,0,2,5,55,7,13,4,15,111,14,25,62,8,26]),function(J,e,s,C,p,U,T,P,b,A,O,w,g,S,f){"use strict";var c,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function u(v){if(v)return typeof v.iconPath=="string"?s.URI.file(v.iconPath):s.URI.isUri(v.iconPath)||g.ThemeIcon.isThemeIcon(v.iconPath)?v.iconPath:void 0}function D(v,m){if(!v.iconPath&&!m.iconPath)return 0;if(v.iconPath){if(!m.iconPath)return 1}else return-1;const I=typeof v.iconPath=="string"?v.iconPath:s.URI.isUri(v.iconPath)?v.iconPath.fsPath:v.iconPath.id,B=typeof m.iconPath=="string"?m.iconPath:s.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id;return(0,A.comparePaths)(I,B)}function y(v,m){let I=0;if(v.strikeThrough!==m.strikeThrough)return v.strikeThrough?1:-1;if(v.faded!==m.faded)return v.faded?1:-1;if(v.tooltip!==m.tooltip)return(v.tooltip||"").localeCompare(m.tooltip||"");if(I=D(v,m),I!==0)return I;if(v.light&&m.light)I=D(v.light,m.light);else{if(v.light)return 1;if(m.light)return-1}if(I!==0)return I;if(v.dark&&m.dark)I=D(v.dark,m.dark);else{if(v.dark)return 1;if(m.dark)return-1}return I}function a(v,m){if(v.command!==m.command)return v.command<m.command?-1:1;if(v.title!==m.title)return v.title<m.title?-1:1;if(v.tooltip!==m.tooltip){if(v.tooltip!==void 0&&m.tooltip!==void 0)return v.tooltip<m.tooltip?-1:1;if(v.tooltip!==void 0)return 1;if(m.tooltip!==void 0)return-1}if(v.arguments===m.arguments)return 0;if(v.arguments)if(m.arguments){if(v.arguments.length!==m.arguments.length)return v.arguments.length-m.arguments.length}else return 1;else return-1;for(let I=0;I<v.arguments.length;I++){const B=v.arguments[I],x=m.arguments[I];if(B!==x)return B<x?-1:1}return 0}function _(v,m){let I=(0,A.comparePaths)(v.resourceUri.fsPath,m.resourceUri.fsPath,!0);if(I!==0)return I;if(v.command&&m.command)I=a(v.command,m.command);else{if(v.command)return 1;if(m.command)return-1}if(I!==0)return I;if(v.decorations&&m.decorations)I=y(v.decorations,m.decorations);else{if(v.decorations)return 1;if(m.decorations)return-1}return I}function r(v,m){for(let I=0;I<v.length;I++)if(v[I]!==m[I])return!1;return!0}function d(v,m){return v.command===m.command&&v.title===m.title&&v.tooltip===m.tooltip&&(v.arguments&&m.arguments?r(v.arguments,m.arguments):v.arguments===m.arguments)}function i(v,m){return(0,b.equals)(v,m,d)}class o{constructor(m,I,B){this._extension=m,this._sourceControlHandle=B,c.set(this,void 0),this._value="",this._onDidChange=new C.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Ye(this,c,I,"f")}get value(){return this._value}set value(m){m=m??"",Ae(this,c,"f").$setInputBoxValue(this._sourceControlHandle,m),this.updateValue(m)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(m){Ae(this,c,"f").$setInputBoxPlaceholder(this._sourceControlHandle,m),this._placeholder=m}get validateInput(){return(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(m){if((0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),m&&typeof m!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=m,Ae(this,c,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!m)}get enabled(){return(0,f.checkProposedApiEnabled)(this._extension,"scmInput"),this._enabled}set enabled(m){(0,f.checkProposedApiEnabled)(this._extension,"scmInput"),m=!!m,this._enabled!==m&&(this._enabled=m,Ae(this,c,"f").$setInputBoxEnablement(this._sourceControlHandle,m))}get visible(){return this._visible}set visible(m){m=!!m,this._visible!==m&&(this._visible=m,Ae(this,c,"f").$setInputBoxVisibility(this._sourceControlHandle,m))}showValidationMessage(m,I){(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),Ae(this,c,"f").$showValidationMessage(this._sourceControlHandle,m,I)}$onInputBoxValueChange(m){this.updateValue(m)}updateValue(m){this._value=m,this._onDidChange.fire(m)}}e.ExtHostSCMInputBox=o,c=new WeakMap;class n{constructor(m,I,B,x,R){this._proxy=m,this._commands=I,this._sourceControlHandle=B,this._id=x,this._label=R,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new C.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new C.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=n._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(m){this._label=m,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,m)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(m){this._hideWhenEmpty=m,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(m){this._resourceStates=[...m],this._onDidUpdateResourceStates.fire()}getResourceState(m){return this._resourceStatesMap.get(m)}$executeResourceCommand(m,I){const B=this._resourceStatesCommandsMap.get(m);return B?(0,T.asPromise)(()=>this._commands.executeCommand(B.command,...B.arguments||[],I)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const m=[...this._resourceStates].sort(_),B=(0,b.sortedDiff)(this._resourceSnapshot,m,_).map(E=>{const M=E.toInsert.map(N=>{const W=this._resourceHandlePool++;this._resourceStatesMap.set(W,N);const Z=N.resourceUri;let K;if(N.command)if(N.command.command==="vscode.open"||N.command.command==="vscode.diff"){const ve=new U.DisposableStore;K=this._commands.converter.toInternal(N.command,ve),this._resourceStatesDisposablesMap.set(W,ve)}else this._resourceStatesCommandsMap.set(W,N.command);const F=u(N.decorations),oe=N.decorations&&u(N.decorations.light)||F,ce=N.decorations&&u(N.decorations.dark)||F,ae=[oe,ce],fe=N.decorations&&N.decorations.tooltip||"",ie=N.decorations&&!!N.decorations.strikeThrough,Ee=N.decorations&&!!N.decorations.faded,be=N.contextValue||"";return{rawResource:[W,Z,ae,fe,ie,Ee,be,K],handle:W}});return{start:E.start,deleteCount:E.deleteCount,toInsert:M}}),x=B.map(({start:E,deleteCount:M,toInsert:N})=>[E,M,N.map(W=>W.rawResource)]),R=B.reverse();for(const{start:E,deleteCount:M,toInsert:N}of R){const W=N.map(K=>K.handle),Z=this._handlesSnapshot.splice(E,M,...W);for(const K of Z)this._resourceStatesMap.delete(K),this._resourceStatesCommandsMap.delete(K),this._resourceStatesDisposablesMap.get(K)?.dispose(),this._resourceStatesDisposablesMap.delete(K)}return this._resourceSnapshot=m,x}dispose(){this._disposed=!0,this._onDidDispose.fire()}}n._handlePool=0;class t{constructor(m,I,B,x,R,E){this._extension=m,this._commands=B,this._id=x,this._label=R,this._rootUri=E,h.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new U.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new U.MutableDisposable,this._statusBarDisposables=new U.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new C.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Ye(this,h,I,"f"),this._inputBox=new o(m,Ae(this,h,"f"),this.handle),Ae(this,h,"f").$registerSourceControl(this.handle,x,R,E)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(m){this._count!==m&&(this._count=m,Ae(this,h,"f").$updateSourceControl(this.handle,{count:m}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(m){this._quickDiffProvider=m,Ae(this,h,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!m})}get commitTemplate(){return this._commitTemplate}set commitTemplate(m){m!==this._commitTemplate&&(this._commitTemplate=m,Ae(this,h,"f").$updateSourceControl(this.handle,{commitTemplate:m}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(m){this._acceptInputDisposables.value=new U.DisposableStore,this._acceptInputCommand=m;const I=this._commands.converter.toInternal(m,this._acceptInputDisposables.value);Ae(this,h,"f").$updateSourceControl(this.handle,{acceptInputCommand:I})}get actionButton(){return(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(m){(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new U.DisposableStore,this._actionButton=m;const I=m!==void 0?{command:this._commands.converter.toInternal(m.command,this._actionButtonDisposables.value),description:m.description}:void 0;Ae(this,h,"f").$updateSourceControl(this.handle,{actionButton:I??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(m){if(this._statusBarCommands&&m&&i(this._statusBarCommands,m))return;this._statusBarDisposables.value=new U.DisposableStore,this._statusBarCommands=m;const I=(m||[]).map(B=>this._commands.converter.toInternal(B,this._statusBarDisposables.value));Ae(this,h,"f").$updateSourceControl(this.handle,{statusBarCommands:I})}get selected(){return this._selected}createResourceGroup(m,I){const B=new n(Ae(this,h,"f"),this._commands,this.handle,m,I),x=C.Event.once(B.onDidDispose)(()=>this.createdResourceGroups.delete(B));return this.createdResourceGroups.set(B,x),this.eventuallyAddResourceGroups(),B}eventuallyAddResourceGroups(){const m=[],I=[];for(const[B,x]of this.createdResourceGroups){x.dispose();const R=B.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(B),this.eventuallyUpdateResourceStates()});C.Event.once(B.onDidDispose)(()=>{this.updatedResourceGroups.delete(B),R.dispose(),this._groups.delete(B.handle),Ae(this,h,"f").$unregisterGroup(this.handle,B.handle)}),m.push([B.handle,B.id,B.label,B.features]);const E=B._takeResourceStateSnapshot();E.length>0&&I.push([B.handle,E]),this._groups.set(B.handle,B)}Ae(this,h,"f").$registerGroups(this.handle,m,I),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const m=[];this.updatedResourceGroups.forEach(I=>{const B=I._takeResourceStateSnapshot();B.length!==0&&m.push([I.handle,B])}),m.length>0&&Ae(this,h,"f").$spliceResourceStates(this.handle,m),this.updatedResourceGroups.clear()}getResourceGroup(m){return this._groups.get(m)}setSelectionState(m){this._selected=m,this._onDidChangeSelection.fire(m)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(m=>m.dispose()),Ae(this,h,"f").$unregisterSourceControl(this.handle)}}h=new WeakMap,t._handlePool=0,$e([(0,p.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),$e([(0,p.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let l=class Xi{constructor(m,I,B){this._commands=I,this.logService=B,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new C.Emitter,this._proxy=m.getProxy(P.MainContext.MainThreadSCM),this._telemetry=m.getProxy(P.MainContext.MainThreadTelemetry),I.registerArgumentProcessor({processArgument:x=>{if(x&&x.$mid===3){const R=this._sourceControls.get(x.sourceControlHandle);if(!R)return x;const E=R.getResourceGroup(x.groupHandle);return E?E.getResourceState(x.handle):x}else if(x&&x.$mid===4){const R=this._sourceControls.get(x.sourceControlHandle);return R?R.getResourceGroup(x.groupHandle):x}else if(x&&x.$mid===5){const R=this._sourceControls.get(x.handle);return R||x}return x}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(m,I,B,x){this.logService.trace("ExtHostSCM#createSourceControl",m.identifier.value,I,B,x),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:m.identifier.value});const R=Xi._handlePool++,E=new t(m,this._proxy,this._commands,I,B,x);this._sourceControls.set(R,E);const M=this._sourceControlsByExtension.get(w.ExtensionIdentifier.toKey(m.identifier))||[];return M.push(E),this._sourceControlsByExtension.set(w.ExtensionIdentifier.toKey(m.identifier),M),E}getLastInputBox(m){this.logService.trace("ExtHostSCM#getLastInputBox",m.identifier.value);const I=this._sourceControlsByExtension.get(w.ExtensionIdentifier.toKey(m.identifier)),B=I&&I[I.length-1];return B&&B.inputBox}$provideOriginalResource(m,I,B){const x=s.URI.revive(I);this.logService.trace("ExtHostSCM#$provideOriginalResource",m,x.toString());const R=this._sourceControls.get(m);return!R||!R.quickDiffProvider||!R.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.asPromise)(()=>R.quickDiffProvider.provideOriginalResource(x,B)).then(E=>E||null)}$onInputBoxValueChange(m,I){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",m);const B=this._sourceControls.get(m);return B&&B.inputBox.$onInputBoxValueChange(I),Promise.resolve(void 0)}$executeResourceCommand(m,I,B,x){this.logService.trace("ExtHostSCM#$executeResourceCommand",m,I,B);const R=this._sourceControls.get(m);if(!R)return Promise.resolve(void 0);const E=R.getResourceGroup(I);return E?E.$executeResourceCommand(B,x):Promise.resolve(void 0)}$validateInput(m,I,B){this.logService.trace("ExtHostSCM#$validateInput",m);const x=this._sourceControls.get(m);return!x||!x.inputBox.validateInput?Promise.resolve(void 0):(0,T.asPromise)(()=>x.inputBox.validateInput(I,B)).then(R=>{if(!R)return Promise.resolve(void 0);const E=S.MarkdownString.fromStrict(R.message);return E?Promise.resolve([E,R.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(m){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",m),m!==void 0&&this._sourceControls.get(m)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=m,Promise.resolve(void 0)}};l._handlePool=0,l=$e([xe(2,O.ILogService)],l),e.ExtHostSCM=l});var Ye=this&&this.__classPrivateFieldSet||function(J,e,s,C,p){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?p.call(J,s):p?p.value=s:e.set(J,s),s},Ae=this&&this.__classPrivateFieldGet||function(J,e,s,C){if(s==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?C:s==="a"?C.call(J):C?C.value:e.get(J)};define(De[210],Ie([1,0,6,4,131,7,8,9]),function(J,e,s,C,p,U,T,P){"use strict";var b,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class O{constructor(f,c,h,u,D=s.StatusBarAlignment.Left,y){b.set(this,void 0),A.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new U.DisposableStore,Ye(this,b,f,"f"),Ye(this,A,c,"f"),this._entryId=O.ID_GEN++,this._extension=h,this._id=u,this._alignment=D,this._priority=this.validatePriority(y)}validatePriority(f){if(!!(0,P.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!O.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){this._command?.fromApi!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Ae(this,A,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Ae(this,A,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ae(this,b,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let f;this._extension?this._id?f=`${this._extension.identifier.value}.${this._id}`:f=this._extension.identifier.value:f=this._id;let c;this._name?c=this._name:c=(0,p.localize)(0,null,this._extension.displayName||this._extension.name);let h=this._color;this._backgroundColor&&(h=O.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const u=T.MarkdownString.fromStrict(this._tooltip);Ae(this,b,"f").$setEntry(this._entryId,f,c,this._text,u,this._command?.internal,h,this._backgroundColor,this._alignment===s.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=O,b=new WeakMap,A=new WeakMap,O.ID_GEN=0,O.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new s.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new s.ThemeColor("statusBarItem.warningForeground")]]);class w{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",s.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,p.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const c={message:f};return this._messages.unshift(c),this._update(),new s.Disposable(()=>{const h=this._messages.indexOf(c);h>=0&&(this._messages.splice(h,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class g{constructor(f,c){this._proxy=f.getProxy(C.MainContext.MainThreadStatusBar),this._commands=c,this._statusMessage=new w(this)}createStatusBarEntry(f,c,h,u){return new O(this._proxy,this._commands,f,c,h,u)}setStatusBarMessage(f,c){const h=this._statusMessage.setMessage(f);let u;return typeof c=="number"?u=setTimeout(()=>h.dispose(),c):typeof c!="undefined"&&c.then(()=>h.dispose(),()=>h.dispose()),new s.Disposable(()=>{h.dispose(),clearTimeout(u)})}}e.ExtHostStatusBar=g}),define(De[71],Ie([1,0,4,5,3]),function(J,e,s,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class U{constructor(P){this._onDidChangeStorage=new C.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(s.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,b){this._proxy.$registerExtensionStorageKeysToSync(P,b)}initializeExtensionStorage(P,b,A){return this._proxy.$initializeExtensionStorage(P,b).then(O=>O||A)}setValue(P,b,A){return this._proxy.$setValue(P,b,A)}$acceptValue(P,b,A){this._onDidChangeStorage.fire({shared:P,key:b,value:A})}}e.ExtHostStorage=U,e.IExtHostStorage=(0,p.createDecorator)("IExtHostStorage")}),define(De[72],Ie([1,0,3,28,14,52,2]),function(J,e,s,C,p,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,s.createDecorator)("IExtensionStoragePaths");let P=class{constructor(A,O,w){this._logService=O,this._extHostFileSystem=w,this._workspace=A.workspace??void 0,this._environment=A.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(g=>this._value=g)}async _getWorkspaceStorageURI(A){return T.URI.joinPath(this._environment.workspaceStorageHome,A)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const A=this._workspace.id,O=await this._getWorkspaceStorageURI(A);try{return await this._extHostFileSystem.value.stat(O),this._logService.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",O),await this._extHostFileSystem.value.createDirectory(O),await this._extHostFileSystem.value.writeFile(T.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:T.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),O}catch(w){this._logService.error("[ExtHostStorage]",w);return}}workspaceValue(A){if(this._value)return T.URI.joinPath(this._value,A.identifier.value)}globalValue(A){return T.URI.joinPath(this._environment.globalStorageHome,A.identifier.value.toLowerCase())}onWillDeactivateAll(){}};P=$e([xe(0,C.IExtHostInitDataService),xe(1,p.ILogService),xe(2,U.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(De[53],Ie([1,0,5,4,3,2,16,7,6,132,11,169,20,44,153,62,9,13]),function(J,e,s,C,p,U,T,P,b,A,O,w,g,S,f,c,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,p.createDecorator)("IExtHostTerminalService");class D{constructor(t,l,v,m){this._proxy=t,this._id=l,this._creationOptions=v,this._name=m,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(B=>this._pidPromiseComplete=B);const I=this;this.value={get name(){return I._name||""},get processId(){return I._pidPromise},get creationOptions(){return I._creationOptions},get exitStatus(){return I._exitStatus},get state(){return I._state},sendText(B,x=!0){I._checkDisposed(),I._proxy.$sendText(I._id,B,x)},show(B){I._checkDisposed(),I._proxy.$show(I._id,B)},hide(){I._checkDisposed(),I._proxy.$hide(I._id)},dispose(){I._disposed||(I._disposed=!0,I._proxy.$dispose(I._id))},get dimensions(){if(!(I._cols===void 0||I._rows===void 0))return{columns:I._cols,rows:I._rows}}}}async create(t,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:t.name,shellPath:(0,h.withNullAsUndefined)(t.shellPath),shellArgs:(0,h.withNullAsUndefined)(t.shellArgs),cwd:(0,h.withNullAsUndefined)(t.cwd),env:(0,h.withNullAsUndefined)(t.env),icon:(0,h.withNullAsUndefined)(i(t.iconPath)),color:c.ThemeColor.isThemeColor(t.color)?t.color.id:void 0,initialText:(0,h.withNullAsUndefined)(t.message),strictEnv:(0,h.withNullAsUndefined)(t.strictEnv),hideFromUser:(0,h.withNullAsUndefined)(t.hideFromUser),isFeatureTerminal:(0,h.withNullAsUndefined)(l?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,h.withNullAsUndefined)(l?.useShellEnvironment),location:l?.location||this._serializeParentTerminal(t.location,l?.resolvedExtHostIdentifier),isTransient:(0,h.withNullAsUndefined)(t.isTransient)})}async createExtensionTerminal(t,l,v,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:v,color:c.ThemeColor.isThemeColor(m)?m.id:void 0,location:this._serializeParentTerminal(t,l),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(t,l){return typeof t=="object"?"parentTerminal"in t&&t.parentTerminal&&l?{parentTerminal:l}:"viewColumn"in t?{viewColumn:t.viewColumn,preserveFocus:t.preserveFocus}:void 0:t}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,l){return t===this._cols&&l===this._rows||t===0||l===0?!1:(this._cols=t,this._rows=l,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(l=>{l!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=D;class y{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new s.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new s.Emitter,this._onDidChangeProperty=new s.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new s.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(t){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${t}`)}updateProperty(t,l){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${t}, value: ${l}`)}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput?.(t)}resize(t,l){this._pty.setDimensions?.({columns:t,rows:l})}async processBinary(t){}acknowledgeDataEvent(t){}async setUnicodeVersion(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(l=>this._onProcessData.fire(l)),this._pty.onDidClose?.((l=void 0)=>{this._onProcessExit.fire(l===void 0?void 0:l)}),this._pty.onDidOverrideDimensions?.(l=>{l&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:l.columns,rows:l.rows}})}),this._pty.onDidChangeName?.(l=>{this._onDidChangeProperty.fire({type:"title",value:l})}),this._pty.open(t||void 0),t&&this._pty.setDimensions?.(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=y;let a=1,_=class extends P.Disposable{constructor(t,l){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new s.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new s.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new s.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new s.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new s.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=l.getProxy(C.MainContext.MainThreadTerminalService),this._bufferer=new f.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new s.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[v,m]of this._terminalProcesses)m.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(t,l){const v=new D(this._proxy,(0,S.generateUuid)(),t,t.name),m=new y(t.pty);return v.createExtensionTerminal(t.location,this._serializeParentTerminal(t,l).resolvedExtHostIdentifier,i(t.iconPath),o(t.color)).then(I=>{const B=this._setupExtHostProcessListeners(I,m);this._terminalProcessDisposables[I]=B}),this._terminals.push(v),v.value}_serializeParentTerminal(t,l){if(l=l||{},t.location&&typeof t.location=="object"&&"parentTerminal"in t.location){const v=t.location.parentTerminal;if(v){const m=this._terminals.find(I=>I.value===v);m&&(l.resolvedExtHostIdentifier=m._id)}}else t.location&&typeof t.location!="object"?l.location=t.location:l.location&&typeof l.location=="object"&&"splitActiveTerminal"in l.location&&(l.location={splitActiveTerminal:!0});return l}attachPtyToTerminal(t,l){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const m=new y(l),I=this._setupExtHostProcessListeners(t,m);this._terminalProcessDisposables[t]=I}async $acceptActiveTerminalChanged(t){const l=this._activeTerminal;if(t===null){this._activeTerminal=void 0,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const v=this._getTerminalById(t);v&&(this._activeTerminal=v,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,l){const v=this._getTerminalById(t);v&&this._onDidWriteTerminalData.fire({terminal:v.value,data:l})}async $acceptTerminalDimensions(t,l,v){const m=this._getTerminalById(t);m&&m.setDimensions(l,v)&&this._onDidChangeTerminalDimensions.fire({terminal:m.value,dimensions:m.value.dimensions})}async $acceptTerminalMaximumDimensions(t,l,v){this._terminalProcesses.get(t)?.resize(l,v)}async $acceptTerminalTitleChange(t,l){const v=this._getTerminalById(t);v&&(v.name=l)}async $acceptTerminalClosed(t,l){const v=this._getTerminalObjectIndexById(this._terminals,t);if(v!==null){const m=this._terminals.splice(v,1)[0];m.setExitCode(l),this._onDidCloseTerminal.fire(m.value)}}$acceptTerminalOpened(t,l,v,m){if(l){const x=this._getTerminalObjectIndexById(this._terminals,l);if(x!==null){this._terminals[x]._id=t,this._onDidOpenTerminal.fire(this.terminals[x]),this._terminals[x].isOpen=!0;return}}const I={name:m.name,shellPath:m.executable,shellArgs:m.args,cwd:typeof m.cwd=="string"?m.cwd:U.URI.revive(m.cwd),env:m.env,hideFromUser:m.hideFromUser},B=new D(this._proxy,t,I,v);this._terminals.push(B),this._onDidOpenTerminal.fire(B.value),B.isOpen=!0}async $acceptTerminalProcessId(t,l){const v=this._getTerminalById(t);v&&v._setProcessId(l)}async $startExtensionTerminal(t,l){const v=this._getTerminalById(t);if(!v)return{message:(0,A.localize)(0,null,t)};v.isOpen||await new Promise(I=>{const B=this.onDidOpenTerminal(async x=>{x===v.value&&(B.dispose(),I())})});const m=this._terminalProcesses.get(t);m?m.startSendingEvents(l):this._extensionTerminalAwaitingStart[t]={initialDimensions:l}}_setupExtHostProcessListeners(t,l){const v=new P.DisposableStore;v.add(l.onProcessReady(I=>this._proxy.$sendProcessReady(t,I.pid,I.cwd))),v.add(l.onDidChangeProperty(I=>this._proxy.$sendProcessProperty(t,I))),this._bufferer.startBuffering(t,l.onProcessData),v.add(l.onProcessExit(I=>this._onProcessExit(t,I))),this._terminalProcesses.set(t,l);const m=this._extensionTerminalAwaitingStart[t];return m&&l instanceof y&&(l.startSendingEvents(m.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),v}$acceptProcessAckDataEvent(t,l){this._terminalProcesses.get(t)?.acknowledgeDataEvent(l)}$acceptProcessInput(t,l){this._terminalProcesses.get(t)?.input(l)}$acceptTerminalInteraction(t){const l=this._getTerminalById(t);l?.setInteractedWith()&&this._onDidChangeTerminalState.fire(l.value)}$acceptProcessResize(t,l,v){try{this._terminalProcesses.get(t)?.resize(l,v)}catch(m){if(m.code!=="EPIPE"&&m.code!=="ERR_IPC_CHANNEL_CLOSED")throw m}}$acceptProcessShutdown(t,l){this._terminalProcesses.get(t)?.shutdown(l)}$acceptProcessRequestInitialCwd(t){this._terminalProcesses.get(t)?.getInitialCwd().then(l=>this._proxy.$sendProcessProperty(t,{type:"initialCwd",value:l}))}$acceptProcessRequestCwd(t){this._terminalProcesses.get(t)?.getCwd().then(l=>this._proxy.$sendProcessProperty(t,{type:"cwd",value:l}))}$acceptProcessRequestLatency(t){return Promise.resolve(t)}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new b.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(t,l,v){if(this._profileProviders.has(l))throw new Error(`Terminal profile provider "${l}" already registered`);return this._profileProviders.set(l,v),this._proxy.$registerProfileProvider(l,t.identifier.value),new b.Disposable(()=>{this._profileProviders.delete(l),this._proxy.$unregisterProfileProvider(l)})}async $createContributedProfileTerminal(t,l){const v=new g.CancellationTokenSource().token;let m=await this._profileProviders.get(t)?.provideTerminalProfile(v);if(!v.isCancellationRequested){if(m&&!("options"in m)&&(m={options:m}),!m||!("options"in m))throw new Error(`No terminal profile options provided for id "${t}"`);if("pty"in m.options){this.createExtensionTerminal(m.options,l);return}this.createTerminalFromOptions(m.options,l)}}async $provideLinks(t,l){const v=this._getTerminalById(t);if(!v)return[];this._terminalLinkCache.delete(t);const m=this._terminalLinkCancellationSource.get(t);m&&m.dispose(!0);const I=new g.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,I);const B=[],x={terminal:v.value,line:l},R=[];for(const N of this._linkProviders)R.push(u.Promises.withAsyncBody(async W=>{I.token.onCancellationRequested(()=>W({provider:N,links:[]}));const Z=await N.provideTerminalLinks(x,I.token)||[];I.token.isCancellationRequested||W({provider:N,links:Z})}));const E=await Promise.all(R);if(I.token.isCancellationRequested)return[];const M=new Map;for(const N of E)N&&N.links.length>0&&B.push(...N.links.map(W=>{const Z={id:a++,startIndex:W.startIndex,length:W.length,label:W.tooltip};return M.set(Z.id,{provider:N.provider,link:W}),Z}));return this._terminalLinkCache.set(t,M),B}$activateLink(t,l){const v=this._terminalLinkCache.get(t)?.get(l);!v||v.provider.handleTerminalLink(v.link)}_onProcessExit(t,l){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const v=this._terminalProcessDisposables[t];v&&(v.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,l)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,l){const v=this._getTerminalObjectIndexById(t,l);return v!==null?t[v]:null}_getTerminalObjectIndexById(t,l){let v=null;return t.some((m,I)=>m._id===l?(v=I,!0):!1),v}getEnvironmentVariableCollection(t){let l=this._environmentVariableCollections.get(t.identifier.value);return l||(l=new r,this._setEnvironmentVariableCollection(t.identifier.value,l)),l}_syncEnvironmentVariableCollection(t,l){const v=(0,w.serializeEnvironmentVariableCollection)(l.map);this._proxy.$setEnvironmentVariableCollection(t,l.persistent,v.length===0?void 0:v)}$initEnvironmentVariableCollections(t){t.forEach(l=>{const v=l[0],m=new r(l[1]);this._setEnvironmentVariableCollection(v,m)})}$acceptDefaultProfile(t,l){this._defaultProfile=t,this._defaultAutomationProfile=l}_setEnvironmentVariableCollection(t,l){this._environmentVariableCollections.set(t,l),l.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,l)})}};_=$e([xe(1,T.IExtHostRpcService)],_),e.BaseExtHostTerminalService=_;class r{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new s.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,l){this._setIfDiffers(t,{value:l,type:b.EnvironmentVariableMutatorType.Replace})}append(t,l){this._setIfDiffers(t,{value:l,type:b.EnvironmentVariableMutatorType.Append})}prepend(t,l){this._setIfDiffers(t,{value:l,type:b.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,l){const v=this.map.get(t);(!v||v.value!==l.value||v.type!==l.type)&&(this.map.set(t,l),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,l){this.map.forEach((v,m)=>t.call(l,m,v,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=r;let d=class extends _{constructor(t){super(!1,t)}createTerminal(t,l,v){throw new O.NotSupportedError}createTerminalFromOptions(t,l){throw new O.NotSupportedError}};d=$e([xe(0,T.IExtHostRpcService)],d),e.WorkerExtHostTerminalService=d;function i(n){if(!(!n||typeof n=="string"))return"id"in n?{id:n.id,color:n.color}:n}function o(n){return c.ThemeColor.isThemeColor(n)?n:void 0}});var Ye=this&&this.__classPrivateFieldSet||function(J,e,s,C,p){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?p.call(J,s):p?p.value=s:e.set(J,s),s},Ae=this&&this.__classPrivateFieldGet||function(J,e,s,C){if(s==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?C:s==="a"?C.call(J):C?C.value:e.get(J)};define(De[211],Ie([1,0,15,23,20,5,172,96,7,27,9,44,4,16,92,8,6,47,67,48]),function(J,e,s,C,p,U,T,P,b,A,O,w,g,S,f,c,h,u,D,y){"use strict";var a,_;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=class{constructor(R,E){this.resultsChangedEmitter=new U.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(g.MainContext.MainThreadTesting),this.observer=new m(this.proxy),this.runTracker=new i(this.proxy),E.registerArgumentProcessor({processArgument:M=>M?.$mid===13?(0,f.toItemFromContext)(M):M})}createTestController(R,E,M){if(this.controllers.has(R))throw new Error(`Attempt to insert a duplicate controller with ID "${R}"`);const N=new b.DisposableStore,W=N.add(new f.ExtHostTestItemCollection(R,E));W.root.label=E;const Z=new Map,K=this.proxy,F={items:W.root.children,get label(){return E},set label(ce){E=ce,W.root.label=ce,K.$updateController(R,{label:E})},get refreshHandler(){return M},set refreshHandler(ce){M=ce,K.$updateController(R,{canRefresh:!!ce})},get id(){return R},createRunProfile:(ce,ae,fe,ie,Ee)=>{let be=(0,P.hash)(ce);for(;Z.has(be);)be++;return new I(this.proxy,Z,R,be,ce,ae,fe,ie,Ee)},createTestItem(ce,ae,fe){return new f.TestItemImpl(R,ce,ae,fe)},createTestRun:(ce,ae,fe=!0)=>this.runTracker.createTestRun(R,W,ce,ae,fe),set resolveHandler(ce){W.resolveHandler=ce},get resolveHandler(){return W.resolveHandler},dispose:()=>{N.dispose()}};K.$registerTestController(R,E,!!M),N.add((0,b.toDisposable)(()=>K.$unregisterTestController(R)));const oe={controller:F,collection:W,profiles:Z};return this.controllers.set(R,oe),N.add((0,b.toDisposable)(()=>this.controllers.delete(R))),N.add(W.onDidGenerateDiff(ce=>K.$publishDiff(R,ce.map(y.TestsDiffOp.serialize)))),F}createTestObserver(){return this.observer.checkout()}async runTests(R,E=p.CancellationToken.None){const M=o(R);if(!M)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const N=this.controllers.get(M.controllerId);if(!N)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:R.include?.map(W=>u.TestId.fromExtHostTestItem(W,N.collection.root.id).toString())??[N.collection.root.id],profileGroup:B[M.kind],profileId:M.profileId,controllerId:M.controllerId}],exclude:R.exclude?.map(W=>W.id)},E)}$provideFileCoverage(R,E,M){return(0,s.mapFind)(this.runTracker.trackers,W=>W.id===R?W.getCoverage(E):void 0)?.provideFileCoverage(M)??Promise.resolve([])}$resolveFileCoverage(R,E,M,N){return(0,s.mapFind)(this.runTracker.trackers,Z=>Z.id===R?Z.getCoverage(E):void 0)?.resolveFileCoverage(M,N)??Promise.resolve([])}$configureRunProfile(R,E){this.controllers.get(R)?.profiles.get(E)?.configureHandler?.()}async $refreshTests(R,E){await this.controllers.get(R)?.controller.refreshHandler?.(E)}$publishTestResults(R){this.results=Object.freeze(R.map(E=>(0,A.deepFreeze)(c.TestResults.to(E))).concat(this.results).sort((E,M)=>M.completedAt-E.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(R,E){const M=this.controllers.get(u.TestId.fromString(R).controllerId)?.collection;M&&(await M.expand(R,E<0?1/0:E),M.flushDiff())}$acceptDiff(R){this.observer.applyDiff(R.map(y.TestsDiffOp.deserialize))}async $runControllerTests(R,E){const M=this.controllers.get(R.controllerId);if(!M)return;const{collection:N,profiles:W}=M,Z=W.get(R.profileId);if(!Z)return;const K=R.testIds.map(ae=>N.tree.get(ae)).filter(O.isDefined),F=R.excludeExtIds.map(ae=>M.collection.tree.get(ae)).filter(O.isDefined).filter(ae=>K.some(fe=>fe.fullId.compare(ae.fullId)===2));if(!K.length)return;const oe=new h.TestRunRequest(K.some(ae=>ae.actual instanceof f.TestItemRootImpl)?void 0:K.map(ae=>ae.actual),F.map(ae=>ae.actual),Z),ce=this.runTracker.prepareForMainThreadTestRun(oe,n.fromInternal(R,M.collection),E);try{await Z.runHandler(oe,E)}finally{ce.isRunning&&!E.isCancellationRequested&&await U.Event.toPromise(ce.onEnd),ce.dispose()}}$cancelExtensionTestRun(R){R===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(R)}};r=$e([xe(0,S.IExtHostRpcService)],r),e.ExtHostTesting=r;class d extends b.Disposable{constructor(R,E,M){super();this.dto=R,this.proxy=E,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new U.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new p.CancellationTokenSource(M)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:N}of this.tasks.values())N.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(R){return this.tasks.get(R)?.coverage}createRun(R){const E=this.dto.id,M=this.dto.controllerId,N=(0,w.generateUuid)(),W=new t(this.proxy,E,N),Z=ce=>(ae,...fe)=>{if(F){console.warn(`Setting the state of test "${ae.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(ae)||(this.ensureTestIsKnown(ae),ce(ae,...fe))},K=(ce,ae)=>{const fe=ae instanceof Array?ae.map(c.TestMessage.from):[c.TestMessage.from(ae)];if(ce.uri&&ce.range){const ie={range:c.Range.from(ce.range),uri:ce.uri};for(const Ee of fe)Ee.location=Ee.location||ie}this.proxy.$appendTestMessagesInRun(E,N,u.TestId.fromExtHostTestItem(ce,M).toString(),fe)};let F=!1;const oe={isPersisted:this.dto.isPersisted,token:this.cts.token,name:R,get coverageProvider(){return W.coverageProvider},set coverageProvider(ce){W.coverageProvider=ce},enqueued:Z(ce=>{this.proxy.$updateTestStateInRun(E,N,u.TestId.fromExtHostTestItem(ce,M).toString(),1)}),skipped:Z(ce=>{this.proxy.$updateTestStateInRun(E,N,u.TestId.fromExtHostTestItem(ce,M).toString(),5)}),started:Z(ce=>{this.proxy.$updateTestStateInRun(E,N,u.TestId.fromExtHostTestItem(ce,M).toString(),2)}),errored:Z((ce,ae,fe)=>{K(ce,ae),this.proxy.$updateTestStateInRun(E,N,u.TestId.fromExtHostTestItem(ce,M).toString(),6,fe)}),failed:Z((ce,ae,fe)=>{K(ce,ae),this.proxy.$updateTestStateInRun(E,N,u.TestId.fromExtHostTestItem(ce,M).toString(),4,fe)}),passed:Z((ce,ae)=>{this.proxy.$updateTestStateInRun(E,N,u.TestId.fromExtHostTestItem(ce,this.dto.controllerId).toString(),3,ae)}),appendOutput:(ce,ae,fe)=>{F||(fe&&(this.dto.isIncluded(fe)?this.ensureTestIsKnown(fe):fe=void 0),this.proxy.$appendOutputToRun(E,N,C.VSBuffer.fromString(ce),ae&&c.location.from(ae),fe&&u.TestId.fromExtHostTestItem(fe,M).toString()))},end:()=>{F||(F=!0,this.proxy.$finishedTestRunTask(E,N),this.tasks.delete(N),this.isRunning||this.dispose())}};return this.tasks.set(N,{run:oe,coverage:W}),this.proxy.$startedTestRunTask(E,{id:N,name:R,running:!0}),oe}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(R){if(!(R instanceof f.TestItemImpl))throw new D.InvalidTestItemError(R.id);if(this.sharedTestIds.has(u.TestId.fromExtHostTestItem(R,this.dto.controllerId).toString()))return;const E=[],M=this.dto.colllection.root;for(;;){const N=c.TestItem.from(R);if(E.unshift(N),this.sharedTestIds.has(N.extId)||(this.sharedTestIds.add(N.extId),R===M))break;R=R.parent||M}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,E)}}class i{constructor(R){this.proxy=R,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(R,E,M){return this.getTracker(R,E,M)}cancelRunById(R){for(const E of this.tracked.values())if(E.id===R){E.dispose();return}}cancelAllRuns(){for(const R of this.tracked.values())R.dispose()}createTestRun(R,E,M,N,W){const Z=this.tracked.get(M);if(Z)return Z.createRun(N);const K=n.fromPublic(R,E,M,W),F=o(M);this.proxy.$startedExtensionTestRun({controllerId:R,profile:F&&{group:B[F.kind],id:F.profileId},exclude:M.exclude?.map(ce=>u.TestId.fromExtHostTestItem(ce,E.root.id).toString())??[],id:K.id,include:M.include?.map(ce=>u.TestId.fromExtHostTestItem(ce,E.root.id).toString())??[E.root.id],persist:W});const oe=this.getTracker(M,K);return oe.onEnd(()=>this.proxy.$finishedExtensionTestRun(K.id)),oe.createRun(N)}getTracker(R,E,M){const N=new d(E,this.proxy,M);return this.tracked.set(R,N),N.onEnd(()=>this.tracked.delete(R)),N}}e.TestRunCoordinator=i;const o=x=>{if(!!x.profile){if(!(x.profile instanceof I))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return x.profile}};class n{constructor(R,E,M,N,W,Z){this.controllerId=R,this.id=E,this.isPersisted=W,this.colllection=Z,this.includePrefix=M.map(K=>K+"\0"),this.excludePrefix=N.map(K=>K+"\0")}static fromPublic(R,E,M,N){return new n(R,(0,w.generateUuid)(),M.include?.map(W=>u.TestId.fromExtHostTestItem(W,R).toString())??[R],M.exclude?.map(W=>u.TestId.fromExtHostTestItem(W,R).toString())??[],N,E)}static fromInternal(R,E){return new n(R.controllerId,R.runId,R.testIds,R.excludeExtIds,!0,E)}isIncluded(R){const E=u.TestId.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const M of this.excludePrefix)if(E===M||E.startsWith(M))return!1;for(const M of this.includePrefix)if(E===M||E.startsWith(M))return!0;return!1}}e.TestRunDto=n;class t{constructor(R,E,M){this.proxy=R,this.runId=E,this.taskId=M}set coverageProvider(R){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this._coverageProvider=R,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(R){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(R))());try{return(await this.fileCoverage)?.map(c.TestCoverage.fromFile)??[]}catch(E){throw this.fileCoverage=void 0,E}}async resolveFileCoverage(R,E){const M=await this.fileCoverage;let N=M?.[R];return!this._coverageProvider||!M||!N?[]:(N.detailedCoverage||(N=M[R]=await this._coverageProvider.resolveFileCoverage?.(N,E)??N),N.detailedCoverage?.map(c.TestCoverage.fromDetailed)??[])}}class l extends y.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,c.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:E,removed:M}=this;return{get added(){return[...R].map(N=>N.revived)},get updated(){return[...E].map(N=>N.revived)},get removed(){return[...M].map(N=>N.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class v extends y.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new U.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,E){return{...R,revived:c.TestItem.toPlain(R.item),depth:E?E.depth+1:0,children:new Set}}createChangeCollector(){return new l(this.changeEmitter)}}e.MirroredTestCollection=v;class m{constructor(R){this.proxy=R}checkout(){this.current||(this.current=this.createObserverData());const R=this.current;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(E=>E.revived)},dispose:(0,T.once)(()=>{--R.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(R){return this.current?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.current?.tests.apply(R)}createObserverData(){const R=new v;return this.proxy.$subscribeToDiffs(),{observers:0,tests:R}}}class I{constructor(R,E,M,N,W,Z,K,F=!1,oe=void 0){this.controllerId=M,this.profileId=N,this._label=W,this.kind=Z,this.runHandler=K,this._isDefault=F,this._tag=oe,a.set(this,void 0),_.set(this,void 0),Ye(this,a,R,"f"),Ye(this,_,E,"f"),E.set(N,this);const ce=B[Z];if(typeof ce!="number")throw new Error(`Unknown TestRunProfile.group ${Z}`);Ae(this,a,"f").$publishTestRunProfile({profileId:N,controllerId:M,tag:oe?c.TestTag.namespace(this.controllerId,oe.id):null,label:W,group:ce,isDefault:F,hasConfigurationHandler:!1})}get label(){return this._label}set label(R){R!==this._label&&(this._label=R,Ae(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get isDefault(){return this._isDefault}set isDefault(R){R!==this._isDefault&&(this._isDefault=R,Ae(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get tag(){return this._tag}set tag(R){R?.id!==this._tag?.id&&(this._tag=R,Ae(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:R?c.TestTag.namespace(this.controllerId,R.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(R){R!==this._configureHandler&&(this._configureHandler=R,Ae(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}dispose(){Ae(this,_,"f")?.delete(this.profileId)&&(Ye(this,_,void 0,"f"),Ae(this,a,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=I,a=new WeakMap,_=new WeakMap;const B={[h.TestRunProfileKind.Coverage]:8,[h.TestRunProfileKind.Debug]:4,[h.TestRunProfileKind.Run]:2}}),define(De[212],Ie([1,0,15,5,4,93,8,6]),function(J,e,s,C,p,U,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class b{constructor(O,w){this._extHostDocumentsAndEditors=w,this._onDidChangeTextEditorSelection=new C.Emitter,this._onDidChangeTextEditorOptions=new C.Emitter,this._onDidChangeTextEditorVisibleRanges=new C.Emitter,this._onDidChangeTextEditorViewColumn=new C.Emitter,this._onDidChangeActiveTextEditor=new C.Emitter,this._onDidChangeVisibleTextEditors=new C.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=O.getProxy(p.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(g=>this._onDidChangeVisibleTextEditors.fire(g)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(g=>this._onDidChangeActiveTextEditor.fire(g))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(O){const w=this._extHostDocumentsAndEditors.allEditors();return O?w:w.map(g=>g.value)}async showTextDocument(O,w,g){let S;typeof w=="number"?S={position:T.ViewColumn.from(w),preserveFocus:g}:typeof w=="object"?S={position:T.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selection:typeof w.selection=="object"?T.Range.from(w.selection):void 0,pinned:typeof w.preview=="boolean"?!w.preview:void 0}:S={preserveFocus:!1};const f=await this._proxy.$tryShowTextDocument(O.uri,S),c=f&&this._extHostDocumentsAndEditors.getEditor(f);if(c)return c.value;throw f?new Error(`Could NOT open editor for "${O.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${O.uri.toString()}".`)}createTextEditorDecorationType(O,w){return new U.TextEditorDecorationType(this._proxy,O,w).value}$acceptEditorPropertiesChanged(O,w){const g=this._extHostDocumentsAndEditors.getEditor(O);if(!g)throw new Error("unknown text editor");if(w.options&&g._acceptOptions(w.options),w.selections){const S=w.selections.selections.map(T.Selection.to);g._acceptSelections(S)}if(w.visibleRanges){const S=s.coalesce(w.visibleRanges.map(T.Range.to));g._acceptVisibleRanges(S)}if(w.options&&this._onDidChangeTextEditorOptions.fire({textEditor:g.value,options:{...w.options,lineNumbers:T.TextEditorLineNumbersStyle.to(w.options.lineNumbers)}}),w.selections){const S=P.TextEditorSelectionChangeKind.fromValue(w.selections.source),f=w.selections.selections.map(T.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:g.value,selections:f,kind:S})}if(w.visibleRanges){const S=s.coalesce(w.visibleRanges.map(T.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:g.value,visibleRanges:S})}}$acceptEditorPositionData(O){for(const w in O){const g=this._extHostDocumentsAndEditors.getEditor(w);if(!g)throw new Error("Unknown text editor");const S=T.ViewColumn.to(O[w]);g.value.viewColumn!==S&&(g._acceptViewColumn(S),this._onDidChangeTextEditorViewColumn.fire({textEditor:g.value,viewColumn:S}))}}getDiffInformation(O){return Promise.resolve(this._proxy.$getDiffInformation(O))}}e.ExtHostEditors=b}),define(De[213],Ie([1,0,2,3,4,7,6,8,9]),function(J,e,s,C,p,U,T,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,C.createDecorator)("IExtHostTimeline");class A{constructor(g,S){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=g.getProxy(p.MainContext.MainThreadTimeline),S.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===11){const c=f.uri===void 0?void 0:s.URI.revive(f.uri);return this._itemsBySourceAndUriMap.get(f.source)?.get(O(c))?.get(f.handle)}return f}})}async $getTimeline(g,S,f,c){return this._providers.get(g)?.provideTimeline(s.URI.revive(S),f,c)}registerTimelineProvider(g,S,f,c){const h=new U.DisposableStore,u=this.convertTimelineItem(S.id,c,h).bind(this);let D;S.onDidChange&&(D=S.onDidChange(a=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:S.id}),this));const y=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...S,scheme:g,onDidChange:void 0,async provideTimeline(a,_,r){_?.resetCache&&(h.clear(),y.get(S.id)?.clear());const d=await S.provideTimeline(a,_,r);if(d==null)return;const i=u(a,_);return{...d,source:S.id,items:d.items.map(i)}},dispose(){for(const a of y.values())a.get(S.id)?.clear();D?.dispose(),h.dispose()}})}convertTimelineItem(g,S,f){return(c,h)=>{let u;if(h?.cacheResults){let D=this._itemsBySourceAndUriMap.get(g);D===void 0&&(D=new Map,this._itemsBySourceAndUriMap.set(g,D));const y=O(c);u=D.get(y),u===void 0&&(u=new Map,D.set(y,u))}return D=>{const{iconPath:y,...a}=D,_=`${g}|${D.id??D.timestamp}`;u?.set(_,D);let r,d,i;D.iconPath&&(y instanceof T.ThemeIcon?i={id:y.id,color:y.color}:s.URI.isUri(y)?(r=y,d=y):{light:r,dark:d}=y);let o;return T.MarkdownString.isMarkdownString(a.tooltip)?o=P.MarkdownString.from(a.tooltip):(0,b.isString)(a.tooltip)?o=a.tooltip:T.MarkdownString.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),o=P.MarkdownString.from(a.detail)):(0,b.isString)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),o=a.detail),{...a,id:a.id??void 0,handle:_,source:g,command:D.command?S.toInternal(D.command,f):void 0,icon:r,iconDark:d,themeIcon:i,tooltip:o,accessibilityInformation:D.accessibilityInformation}}}}registerTimelineProviderCore(g){if(this._providers.get(g.id))throw new Error(`Timeline Provider ${g.id} already exists.`);return this._proxy.$registerTimelineProvider({id:g.id,label:g.label,scheme:g.scheme}),this._providers.set(g.id,g),(0,U.toDisposable)(()=>{for(const f of this._itemsBySourceAndUriMap.values())f.get(g.id)?.clear();this._providers.delete(g.id),this._proxy.$unregisterTimelineProvider(g.id),g.dispose()})}}e.ExtHostTimeline=A;function O(w){return w?.toString()}}),define(De[214],Ie([1,0,7,12,2,4]),function(J,e,s,C,p,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class T{constructor(b){this._openers=new Map,this._proxy=b.getProxy(U.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(b,A,O,w){if(this._openers.has(A))throw new Error(`Opener with id '${A}' already registered`);const g=w.schemes.find(S=>!T.supportedSchemes.has(S));if(g)throw new Error(`Scheme '${g}' is not supported. Only http and https are currently supported.`);return this._openers.set(A,O),this._proxy.$registerUriOpener(A,w.schemes,b,w.label),(0,s.toDisposable)(()=>{this._openers.delete(A),this._proxy.$unregisterUriOpener(A)})}async $canOpenUri(b,A,O){const w=this._openers.get(b);if(!w)throw new Error(`Unknown opener with id: ${b}`);const g=p.URI.revive(A);return w.canOpenExternalUri(g,O)}async $openUri(b,A,O){const w=this._openers.get(b);if(!w)throw new Error(`Unknown opener id: '${b}'`);return w.openExternalUri(p.URI.revive(A.resolvedUri),{sourceUri:p.URI.revive(A.sourceUri)},O)}}e.ExtHostUriOpeners=T,T.supportedSchemes=new Set([C.Schemas.http,C.Schemas.https])}),define(De[215],Ie([1,0,4,2,7,11,25]),function(J,e,s,C,p,U,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(A){this.handles=new Set,this.handlers=new Map,this._proxy=A.getProxy(s.MainContext.MainThreadUrls)}registerUriHandler(A,O){if(this.handles.has(T.ExtensionIdentifier.toKey(A)))throw new Error(`Protocol handler already registered for extension ${A}`);const w=P.HandlePool++;return this.handles.add(T.ExtensionIdentifier.toKey(A)),this.handlers.set(w,O),this._proxy.$registerUriHandler(w,A),(0,p.toDisposable)(()=>{this.handles.delete(T.ExtensionIdentifier.toKey(A)),this.handlers.delete(w),this._proxy.$unregisterUriHandler(w)})}$handleExternalUri(A,O){const w=this.handlers.get(A);if(!w)return Promise.resolve(void 0);try{w.handleUri(C.URI.revive(O))}catch(g){(0,U.onUnexpectedError)(g)}return Promise.resolve(void 0)}async createAppUri(A){return C.URI.revive(await this._proxy.$createAppUri(A))}}e.ExtHostUrls=P,P.HandlePool=0});var Ye=this&&this.__classPrivateFieldSet||function(J,e,s,C,p){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?p.call(J,s):p?p.value=s:e.set(J,s),s},Ae=this&&this.__classPrivateFieldGet||function(J,e,s,C){if(s==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?C:s==="a"?C.call(J):C?C.value:e.get(J)};define(De[54],Ie([1,0,5,12,2,144,161,66,4]),function(J,e,s,C,p,U,T,P,b){"use strict";var A,O,w,g,S,f,c,h,u,D,y,a;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class _{constructor(v,m,I,B,x,R,E){A.set(this,void 0),O.set(this,void 0),w.set(this,void 0),g.set(this,void 0),S.set(this,void 0),f.set(this,void 0),c.set(this,""),h.set(this,void 0),u.set(this,!1),D.set(this,!1),y.set(this,!1),this._onMessageEmitter=new s.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,a.set(this,new s.Emitter),this._onDidDispose=Ae(this,a,"f").event,Ye(this,A,v,"f"),Ye(this,O,m,"f"),Ye(this,h,I,"f"),Ye(this,g,B,"f"),Ye(this,S,x,"f"),Ye(this,f,R,"f"),Ye(this,y,r(R),"f"),Ye(this,w,E,"f")}dispose(){Ye(this,u,!0,"f"),Ae(this,a,"f").fire(),Ae(this,a,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(v){return Ye(this,D,!0,"f"),(0,P.asWebviewUri)(v,Ae(this,g,"f"))}get cspSource(){const v=Ae(this,f,"f").extensionLocation;if(v.scheme===C.Schemas.https||v.scheme===C.Schemas.http){let m=v.toString();return m.endsWith("/")||(m+="/"),m+" "+P.webviewGenericCspSource}return P.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ae(this,c,"f")}set html(v){this.assertNotDisposed(),Ae(this,c,"f")!==v&&(Ye(this,c,v,"f"),!Ae(this,D,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(v)&&(Ye(this,D,!0,"f"),Ae(this,w,"f").report("Webview vscode-resource: uris",Ae(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ae(this,O,"f").$setHtml(Ae(this,A,"f"),v))}get options(){return this.assertNotDisposed(),Ae(this,h,"f")}set options(v){this.assertNotDisposed(),Ae(this,O,"f").$setOptions(Ae(this,A,"f"),o(Ae(this,f,"f"),Ae(this,S,"f"),v)),Ye(this,h,v,"f")}async postMessage(v){if(Ae(this,u,"f"))return!1;const m=(0,T.serializeWebviewMessage)(v,{serializeBuffersForPostMessage:Ae(this,y,"f")});return Ae(this,O,"f").$postMessage(Ae(this,A,"f"),m.message,...m.buffers)}assertNotDisposed(){if(Ae(this,u,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=_,A=new WeakMap,O=new WeakMap,w=new WeakMap,g=new WeakMap,S=new WeakMap,f=new WeakMap,c=new WeakMap,h=new WeakMap,u=new WeakMap,D=new WeakMap,y=new WeakMap,a=new WeakMap;function r(l){try{const v=(0,U.normalizeVersion)((0,U.parseVersion)(l.engines.vscode));return!!v&&v.majorBase>=1&&v.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;class d{constructor(v,m,I,B,x){this.remoteInfo=m,this.workspace=I,this._logService=B,this._deprecationService=x,this._webviews=new Map,this._webviewProxy=v.getProxy(b.MainContext.MainThreadWebviews)}$onMessage(v,m,I){const B=this.getWebview(v);if(B){const{message:x}=(0,T.deserializeWebviewMessage)(m,I.value);B._onMessageEmitter.fire(x)}}$onMissingCsp(v,m){this._logService.warn(`${m} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(v,m,I){const B=new _(v,this._webviewProxy,n(m),this.remoteInfo,this.workspace,I,this._deprecationService);return this._webviews.set(v,B),B._onDidDispose(()=>{this._webviews.delete(v)}),B}deleteWebview(v){this._webviews.delete(v)}getWebview(v){return this._webviews.get(v)}}e.ExtHostWebviews=d;function i(l){return{id:l.identifier,location:l.extensionLocation}}e.toExtensionData=i;function o(l,v,m){return{enableCommandUris:m.enableCommandUris,enableScripts:m.enableScripts,enableForms:m.enableForms,portMapping:m.portMapping,localResourceRoots:m.localResourceRoots||t(l,v)}}e.serializeWebviewOptions=o;function n(l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots?.map(v=>p.URI.from(v))}}e.reviveOptions=n;function t(l,v){return[...(v?.getWorkspaceFolders()||[]).map(m=>m.uri),l.extensionLocation]}}),define(De[216],Ie([1,0,20,96,7,12,21,2,8,54,63,4,6]),function(J,e,s,C,p,U,T,P,b,A,O,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class S{constructor(r,d){this.document=r,this._storagePath=d,this._backupCounter=1,this._edits=new O.Cache("custom documents")}addEdit(r){return this._edits.add([r])}async undo(r,d){await this.getEdit(r).undo(),d||this.disposeBackup()}async redo(r,d){await this.getEdit(r).redo(),d||this.disposeBackup()}disposeEdits(r){for(const d of r)this._edits.delete(d)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const r=a(this.document.uri)+this._backupCounter++;return(0,T.joinPath)(this._storagePath,r)}updateBackup(r){this._backup?.delete(),this._backup=r}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(r){const d=this._edits.get(r,0);if(!d)throw new Error("No edit found");return d}}class f{constructor(){this._documents=new Map}get(r,d){return this._documents.get(this.key(r,d))}add(r,d,i){const o=this.key(r,d.uri);if(this._documents.has(o))throw new Error(`Document already exists for viewType:${r} resource:${d.uri}`);const n=new S(d,i);return this._documents.set(o,n),n}delete(r,d){const i=this.key(r,d.uri);this._documents.delete(i)}key(r,d){return`${r}@@@${d}`}}var c;(function(_){_[_.Text=0]="Text",_[_.Custom=1]="Custom"})(c||(c={}));class h{constructor(){this._providers=new Map}addTextProvider(r,d,i){return this.add(0,r,d,i)}addCustomProvider(r,d,i){return this.add(1,r,d,i)}get(r){return this._providers.get(r)}add(r,d,i,o){if(this._providers.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this._providers.set(d,{type:r,extension:i,provider:o}),new g.Disposable(()=>this._providers.delete(d))}}class u{constructor(r,d,i,o,n){this._extHostDocuments=d,this._extensionStoragePaths=i,this._extHostWebview=o,this._extHostWebviewPanels=n,this._editorProviders=new h,this._documents=new f,this._proxy=r.getProxy(w.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(r,d,i,o){const n=new p.DisposableStore;return D(i)?(n.add(this._editorProviders.addTextProvider(d,r,i)),this._proxy.$registerTextEditorProvider((0,A.toExtensionData)(r),d,o.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},(0,A.shouldSerializeBuffersForPostMessage)(r))):(n.add(this._editorProviders.addCustomProvider(d,r,i)),this.supportEditing(i)&&n.add(i.onDidChangeCustomDocument(t=>{const l=this.getCustomDocumentEntry(d,t.document.uri);if(y(t)){const v=l.addEdit(t);this._proxy.$onDidEdit(t.document.uri,d,v,t.label)}else this._proxy.$onContentChange(t.document.uri,d)})),this._proxy.$registerCustomEditorProvider((0,A.toExtensionData)(r),d,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,A.shouldSerializeBuffersForPostMessage)(r))),g.Disposable.from(n,new g.Disposable(()=>{this._proxy.$unregisterEditorProvider(d)}))}async $createCustomDocument(r,d,i,o,n){const t=this._editorProviders.get(d);if(!t)throw new Error(`No provider found for '${d}'`);if(t.type!==1)throw new Error(`Invalid provide type for '${d}'`);const l=P.URI.revive(r),v=await t.provider.openCustomDocument(l,{backupId:i,untitledDocumentData:o?.buffer},n);let m;return this.supportEditing(t.provider)&&this._extensionStoragePaths&&(m=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension)),this._documents.add(d,v,m),{editable:this.supportEditing(t.provider)}}async $disposeCustomDocument(r,d){const i=this._editorProviders.get(d);if(!i)throw new Error(`No provider found for '${d}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${d}'`);const o=P.URI.revive(r),{document:n}=this.getCustomDocumentEntry(d,o);this._documents.delete(d,n),n.dispose()}async $resolveWebviewEditor(r,d,i,o,n,t){const l=this._editorProviders.get(i);if(!l)throw new Error(`No provider found for '${i}'`);const v=b.ViewColumn.to(n),m=this._extHostWebview.createNewWebview(d,o.webviewOptions,l.extension),I=this._extHostWebviewPanels.createNewWebviewPanel(d,i,o.title,v,o.panelOptions,m,!0),B=P.URI.revive(r);switch(l.type){case 1:{const{document:x}=this.getCustomDocumentEntry(i,B);return l.provider.resolveCustomEditor(x,I,t)}case 0:{const x=this._extHostDocuments.getDocument(B);return l.provider.resolveCustomTextEditor(x,I,t)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,d,i){this.getCustomDocumentEntry(d,r).disposeEdits(i)}async $onMoveCustomEditor(r,d,i){const o=this._editorProviders.get(i);if(!o)throw new Error(`No provider found for '${i}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const n=this._extHostWebviewPanels.getWebviewPanel(r);if(!n)throw new Error("No webview found");const t=P.URI.revive(d),l=this._extHostDocuments.getDocument(t);await o.provider.moveCustomTextEditor(l,n,s.CancellationToken.None)}async $undo(r,d,i,o){return this.getCustomDocumentEntry(d,r).undo(i,o)}async $redo(r,d,i,o){return this.getCustomDocumentEntry(d,r).redo(i,o)}async $revert(r,d,i){const o=this.getCustomDocumentEntry(d,r);await this.getCustomEditorProvider(d).revertCustomDocument(o.document,i),o.disposeBackup()}async $onSave(r,d,i){const o=this.getCustomDocumentEntry(d,r);await this.getCustomEditorProvider(d).saveCustomDocument(o.document,i),o.disposeBackup()}async $onSaveAs(r,d,i,o){const n=this.getCustomDocumentEntry(d,r);return this.getCustomEditorProvider(d).saveCustomDocumentAs(n.document,P.URI.revive(i),o)}async $backup(r,d,i){const o=this.getCustomDocumentEntry(d,r),t=await this.getCustomEditorProvider(d).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},i);return o.updateBackup(t),t.id}getCustomDocumentEntry(r,d){const i=this._documents.get(r,P.URI.revive(d));if(!i)throw new Error("No custom document found");return i}getCustomEditorProvider(r){const i=this._editorProviders.get(r)?.provider;if(!i||!this.supportEditing(i))throw new Error("Custom document is not editable");return i}supportEditing(r){return!!r.onDidChangeCustomDocument}}e.ExtHostCustomEditors=u;function D(_){return typeof _.resolveCustomTextEditor=="function"}function y(_){return typeof _.undo=="function"&&typeof _.redo=="function"}function a(_){const r=_.scheme===U.Schemas.file||_.scheme===U.Schemas.untitled?_.fsPath:_.toString();return(0,C.hash)(r)+""}});var Ye=this&&this.__classPrivateFieldSet||function(J,e,s,C,p){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?p.call(J,s):p?p.value=s:e.set(J,s),s},Ae=this&&this.__classPrivateFieldGet||function(J,e,s,C){if(s==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?C:s==="a"?C.call(J):C?C.value:e.get(J)};define(De[217],Ie([1,0,5,7,2,44,8,54,4,6]),function(J,e,s,C,p,U,T,P,b,A){"use strict";var O,w,g,S,f,c,h,u,D,y,a,_,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class d extends C.Disposable{constructor(t,l,v,m){super();O.set(this,void 0),w.set(this,void 0),g.set(this,void 0),S.set(this,void 0),f.set(this,void 0),c.set(this,void 0),h.set(this,void 0),u.set(this,void 0),D.set(this,!0),y.set(this,void 0),a.set(this,!1),_.set(this,this._register(new s.Emitter)),this.onDidDispose=Ae(this,_,"f").event,r.set(this,this._register(new s.Emitter)),this.onDidChangeViewState=Ae(this,r,"f").event,Ye(this,O,t,"f"),Ye(this,w,l,"f"),Ye(this,S,v,"f"),Ye(this,g,m.viewType,"f"),Ye(this,f,m.panelOptions,"f"),Ye(this,u,m.viewColumn,"f"),Ye(this,c,m.title,"f"),Ye(this,y,m.active,"f")}dispose(){Ae(this,a,"f")||(Ye(this,a,!0,"f"),Ae(this,_,"f").fire(),Ae(this,w,"f").$disposeWebview(Ae(this,O,"f")),Ae(this,S,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ae(this,S,"f")}get viewType(){return this.assertNotDisposed(),Ae(this,g,"f")}get title(){return this.assertNotDisposed(),Ae(this,c,"f")}set title(t){this.assertNotDisposed(),Ae(this,c,"f")!==t&&(Ye(this,c,t,"f"),Ae(this,w,"f").$setTitle(Ae(this,O,"f"),t))}get iconPath(){return this.assertNotDisposed(),Ae(this,h,"f")}set iconPath(t){this.assertNotDisposed(),Ae(this,h,"f")!==t&&(Ye(this,h,t,"f"),Ae(this,w,"f").$setIconPath(Ae(this,O,"f"),p.URI.isUri(t)?{light:t,dark:t}:t))}get options(){return Ae(this,f,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ae(this,u,"f")=="number"&&Ae(this,u,"f")<0))return Ae(this,u,"f")}get active(){return this.assertNotDisposed(),Ae(this,y,"f")}get visible(){return this.assertNotDisposed(),Ae(this,D,"f")}_updateViewState(t){Ae(this,a,"f")||(this.active!==t.active||this.visible!==t.visible||this.viewColumn!==t.viewColumn)&&(Ye(this,y,t.active,"f"),Ye(this,D,t.visible,"f"),Ye(this,u,t.viewColumn,"f"),Ae(this,r,"f").fire({webviewPanel:this}))}reveal(t,l){this.assertNotDisposed(),Ae(this,w,"f").$reveal(Ae(this,O,"f"),{viewColumn:typeof t=="undefined"?void 0:T.ViewColumn.from(t),preserveFocus:!!l})}assertNotDisposed(){if(Ae(this,a,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,w=new WeakMap,g=new WeakMap,S=new WeakMap,f=new WeakMap,c=new WeakMap,h=new WeakMap,u=new WeakMap,D=new WeakMap,y=new WeakMap,a=new WeakMap,_=new WeakMap,r=new WeakMap;class i{constructor(t,l,v){this.webviews=l,this.workspace=v,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=t.getProxy(b.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,U.generateUuid)()}createWebviewPanel(t,l,v,m,I={}){const B=typeof m=="object"?m.viewColumn:m,x={viewColumn:T.ViewColumn.from(B),preserveFocus:typeof m=="object"&&!!m.preserveFocus},R=(0,P.shouldSerializeBuffersForPostMessage)(t),E=i.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(t),E,l,{title:v,panelOptions:o(I),webviewOptions:(0,P.serializeWebviewOptions)(t,this.workspace,I),serializeBuffersForPostMessage:R},x);const M=this.webviews.createNewWebview(E,I,t);return this.createNewWebviewPanel(E,l,v,B,I,M,!0)}$onDidChangeWebviewPanelViewStates(t){const l=Object.keys(t);l.sort((v,m)=>{const I=t[v],B=t[m];return I.active?1:B.active?-1:+I.visible-+B.visible});for(const v of l){const m=this.getWebviewPanel(v);if(!m)continue;const I=t[v];m._updateViewState({active:I.active,visible:I.visible,viewColumn:T.ViewColumn.to(I.position)})}}async $onDidDisposeWebviewPanel(t){this.getWebviewPanel(t)?.dispose(),this._webviewPanels.delete(t),this.webviews.deleteWebview(t)}registerWebviewPanelSerializer(t,l,v){if(this._serializers.has(l))throw new Error(`Serializer for '${l}' already registered`);return this._serializers.set(l,{serializer:v,extension:t}),this._proxy.$registerSerializer(l,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(t)}),new A.Disposable(()=>{this._serializers.delete(l),this._proxy.$unregisterSerializer(l)})}async $deserializeWebviewPanel(t,l,v,m){const I=this._serializers.get(l);if(!I)throw new Error(`No serializer found for '${l}'`);const{serializer:B,extension:x}=I,R=this.webviews.createNewWebview(t,v.webviewOptions,x),E=this.createNewWebviewPanel(t,l,v.title,m,v.panelOptions,R,v.active);await B.deserializeWebviewPanel(E,v.state)}createNewWebviewPanel(t,l,v,m,I,B,x){const R=new d(t,this._proxy,B,{viewType:l,title:v,viewColumn:m,panelOptions:I,active:x});return this._webviewPanels.set(t,R),R}getWebviewPanel(t){return this._webviewPanels.get(t)}}e.ExtHostWebviewPanels=i;function o(n){return{enableFindWidget:n.enableFindWidget,retainContextWhenHidden:n.retainContextWhenHidden}}});var Ye=this&&this.__classPrivateFieldSet||function(J,e,s,C,p){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?p.call(J,s):p?p.value=s:e.set(J,s),s},Ae=this&&this.__classPrivateFieldGet||function(J,e,s,C){if(s==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?C:s==="a"?C.call(J):C?C.value:e.get(J)};define(De[218],Ie([1,0,5,7,54,26,8,4,6]),function(J,e,s,C,p,U,T,P,b){"use strict";var A,O,w,g,S,f,c,h,u,D,y,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class _ extends C.Disposable{constructor(i,o,n,t,l,v,m){super();A.set(this,void 0),O.set(this,void 0),w.set(this,void 0),g.set(this,void 0),S.set(this,void 0),f.set(this,!1),c.set(this,void 0),h.set(this,void 0),u.set(this,void 0),D.set(this,void 0),y.set(this,this._register(new s.Emitter)),this.onDidChangeVisibility=Ae(this,y,"f").event,a.set(this,this._register(new s.Emitter)),this.onDidDispose=Ae(this,a,"f").event,Ye(this,w,n,"f"),Ye(this,h,t,"f"),Ye(this,A,i,"f"),Ye(this,O,o,"f"),Ye(this,g,l,"f"),Ye(this,S,v,"f"),Ye(this,c,m,"f")}dispose(){Ae(this,f,"f")||(Ye(this,f,!0,"f"),Ae(this,a,"f").fire(),Ae(this,g,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ae(this,h,"f")}set title(i){this.assertNotDisposed(),Ae(this,h,"f")!==i&&(Ye(this,h,i,"f"),Ae(this,O,"f").$setWebviewViewTitle(Ae(this,A,"f"),i))}get description(){return this.assertNotDisposed(),Ae(this,u,"f")}set description(i){this.assertNotDisposed(),Ae(this,u,"f")!==i&&(Ye(this,u,i,"f"),Ae(this,O,"f").$setWebviewViewDescription(Ae(this,A,"f"),i))}get visible(){return Ae(this,c,"f")}get webview(){return Ae(this,g,"f")}get viewType(){return Ae(this,w,"f")}_setVisible(i){i===Ae(this,c,"f")||Ae(this,f,"f")||(Ye(this,c,i,"f"),Ae(this,y,"f").fire())}get badge(){return this.assertNotDisposed(),(0,U.checkProposedApiEnabled)(Ae(this,S,"f"),"badges"),Ae(this,D,"f")}set badge(i){this.assertNotDisposed(),(0,U.checkProposedApiEnabled)(Ae(this,S,"f"),"badges"),!(i?.value===Ae(this,D,"f")?.value&&i?.tooltip===Ae(this,D,"f")?.tooltip)&&(Ye(this,D,T.ViewBadge.from(i),"f"),Ae(this,O,"f").$setWebviewViewBadge(Ae(this,A,"f"),i))}show(i){this.assertNotDisposed(),Ae(this,O,"f").$show(Ae(this,A,"f"),!!i)}assertNotDisposed(){if(Ae(this,f,"f"))throw new Error("Webview is disposed")}}A=new WeakMap,O=new WeakMap,w=new WeakMap,g=new WeakMap,S=new WeakMap,f=new WeakMap,c=new WeakMap,h=new WeakMap,u=new WeakMap,D=new WeakMap,y=new WeakMap,a=new WeakMap;class r{constructor(i,o){this._extHostWebview=o,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=i.getProxy(P.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,o,n,t){if(this._viewProviders.has(o))throw new Error(`View provider for '${o}' already registered`);return this._viewProviders.set(o,{provider:n,extension:i}),this._proxy.$registerWebviewViewProvider((0,p.toExtensionData)(i),o,{retainContextWhenHidden:t?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,p.shouldSerializeBuffersForPostMessage)(i)}),new b.Disposable(()=>{this._viewProviders.delete(o),this._proxy.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(i,o,n,t,l){const v=this._viewProviders.get(o);if(!v)throw new Error(`No view provider found for '${o}'`);const{provider:m,extension:I}=v,B=this._extHostWebview.createNewWebview(i,{},I),x=new _(i,this._proxy,o,n,B,I,!0);this._webviewViews.set(i,x),await m.resolveWebviewView(x,{state:t},l)}async $onDidChangeWebviewViewVisibility(i,o){this.getWebviewView(i)._setVisible(o)}async $disposeWebviewView(i){const o=this.getWebviewView(i);this._webviewViews.delete(i),o.dispose(),this._extHostWebview.deleteWebview(i)}getWebviewView(i){const o=this._webviewViews.get(i);if(!o)throw new Error("No webview found");return o}}e.ExtHostWebviewViews=r}),define(De[97],Ie([1,0,5,4,2,12,10,3,16]),function(J,e,s,C,p,U,T,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let A=class Qi{constructor(w){this._onDidChangeWindowState=new s.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Qi.InitialState,this._proxy=w.getProxy(C.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(g=>this.$onDidChangeWindowFocus(g))}get state(){return this._state}$onDidChangeWindowFocus(w){w!==this._state.focused&&(this._state={...this._state,focused:w},this._onDidChangeWindowState.fire(this._state))}openUri(w,g){let S;if(typeof w=="string"){S=w;try{w=p.URI.parse(w)}catch{return Promise.reject(`Invalid uri - '${w}'`)}}return(0,T.isFalsyOrWhitespace)(w.scheme)?Promise.reject("Invalid scheme - cannot be empty"):w.scheme===U.Schemas.command?Promise.reject(`Invalid scheme '${w.scheme}'`):this._proxy.$openUri(w,S,g)}async asExternalUri(w,g){if((0,T.isFalsyOrWhitespace)(w.scheme))return Promise.reject("Invalid scheme - cannot be empty");const S=await this._proxy.$asExternalUri(w,g);return p.URI.from(S)}};A.InitialState={focused:!0},A=$e([xe(0,b.IExtHostRpcService)],A),e.ExtHostWindow=A,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(De[219],Ie([1,0,13,23,20,11,5,7,112,184,40]),function(J,e,s,C,p,U,T,P,b,A,O){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function g(I,B){try{return JSON.stringify(I,B)}catch{return"null"}}const S="$$ref$$",f={[S]:-1};class c{constructor(B,x){this.jsonString=B,this.referencedBuffers=x}}function h(I,B=null,x=!1){const R=[];return{jsonString:(x?g:JSON.stringify)(I,(M,N)=>{if(typeof N=="undefined")return f;if(typeof N=="object"){if(N instanceof C.VSBuffer){const W=R.push(N)-1;return{[S]:W}}if(B)return B(M,N)}return N}),referencedBuffers:R}}e.stringifyJsonWithBufferRefs=h;function u(I,B,x){return JSON.parse(I,(R,E)=>{if(E){const M=E[S];if(typeof M=="number")return B[M];if(x&&E.$mid===1)return x.transformIncoming(E)}return E})}e.parseJsonAndRestoreBufferRefs=u;function D(I,B){return JSON.stringify(I,B)}function y(I){return I?(B,x)=>x&&x.$mid===1?I.transformOutgoing(x):x:null}var a;(function(I){I[I.LocalSide=0]="LocalSide",I[I.OtherSide=1]="OtherSide"})(a=e.RequestInitiator||(e.RequestInitiator={}));var _;(function(I){I[I.Responsive=0]="Responsive",I[I.Unresponsive=1]="Unresponsive"})(_=e.ResponsiveState||(e.ResponsiveState={}));const r=()=>{},d=Symbol.for("rpcProtocol"),i=Symbol.for("rpcProxy");class o extends P.Disposable{constructor(B,x=null,R=null){super();this[w]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=B,this._logger=x,this._uriTransformer=R,this._uriReplacer=y(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let E=0,M=O.ProxyIdentifier.count;E<M;E++)this._locals[E]=null,this._proxies[E]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new s.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(E=>this._receiveOneMessage(E))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(B=>{this._pendingRPCReplies[B].resolveErr(U.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(B){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(B){this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(B){this._responsiveState!==B&&(this._responsiveState=B,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(B){return this._uriTransformer?(0,b.transformIncomingURIs)(B,this._uriTransformer):B}getProxy(B){const{nid:x,sid:R}=B;return this._proxies[x]||(this._proxies[x]=this._createProxy(x,R)),this._proxies[x]}_createProxy(B,x){let R={get:(E,M)=>(typeof M=="string"&&!E[M]&&M.charCodeAt(0)===36&&(E[M]=(...N)=>this._remoteCall(B,M,N)),M===i?x:E[M])};return new Proxy(Object.create(null),R)}set(B,x){return this._locals[B.nid]=x,x}assertRegistered(B){for(let x=0,R=B.length;x<R;x++){const E=B[x];if(!this._locals[E.nid])throw new Error(`Missing proxy instance ${E.sid}`)}}_receiveOneMessage(B){if(this._isDisposed)return;const x=B.byteLength,R=n.read(B,0),E=R.readUInt8(),M=R.readUInt32();switch(E){case 1:case 2:{let{rpcId:N,method:W,args:Z}=l.deserializeRequestJSONArgs(R);this._uriTransformer&&(Z=(0,b.transformIncomingURIs)(Z,this._uriTransformer)),this._receiveRequest(x,M,N,W,Z,E===2);break}case 3:case 4:{let{rpcId:N,method:W,args:Z}=l.deserializeRequestMixedArgs(R);this._uriTransformer&&(Z=(0,b.transformIncomingURIs)(Z,this._uriTransformer)),this._receiveRequest(x,M,N,W,Z,E===4);break}case 5:{this._logger&&this._logger.logIncoming(x,M,0,"ack"),this._onDidReceiveAcknowledge(M);break}case 6:{this._receiveCancel(x,M);break}case 7:{this._receiveReply(x,M,void 0);break}case 9:{let N=l.deserializeReplyOKJSON(R);this._uriTransformer&&(N=(0,b.transformIncomingURIs)(N,this._uriTransformer)),this._receiveReply(x,M,N);break}case 10:{const N=l.deserializeReplyOKJSONWithBuffers(R,this._uriTransformer);this._receiveReply(x,M,N);break}case 8:{let N=l.deserializeReplyOKVSBuffer(R);this._receiveReply(x,M,N);break}case 11:{let N=l.deserializeReplyErrError(R);this._uriTransformer&&(N=(0,b.transformIncomingURIs)(N,this._uriTransformer)),this._receiveReplyErr(x,M,N);break}case 12:{this._receiveReplyErr(x,M,void 0);break}default:console.error("received unexpected message"),console.error(B)}}_receiveRequest(B,x,R,E,M,N){this._logger&&this._logger.logIncoming(B,x,1,`receiveRequest ${(0,O.getStringIdentifierForProxy)(R)}.${E}(`,M);const W=String(x);let Z,K;if(N){const oe=new p.CancellationTokenSource;M.push(oe.token),Z=this._invokeHandler(R,E,M),K=()=>oe.cancel()}else Z=this._invokeHandler(R,E,M),K=r;this._cancelInvokedHandlers[W]=K;const F=l.serializeAcknowledged(x);this._logger&&this._logger.logOutgoing(F.byteLength,x,1,"ack"),this._protocol.send(F),Z.then(oe=>{delete this._cancelInvokedHandlers[W];const ce=l.serializeReplyOK(x,oe,this._uriReplacer);this._logger&&this._logger.logOutgoing(ce.byteLength,x,1,"reply:",oe),this._protocol.send(ce)},oe=>{delete this._cancelInvokedHandlers[W];const ce=l.serializeReplyErr(x,oe);this._logger&&this._logger.logOutgoing(ce.byteLength,x,1,"replyErr:",oe),this._protocol.send(ce)})}_receiveCancel(B,x){this._logger&&this._logger.logIncoming(B,x,1,"receiveCancel");const R=String(x);this._cancelInvokedHandlers[R]&&this._cancelInvokedHandlers[R]()}_receiveReply(B,x,R){this._logger&&this._logger.logIncoming(B,x,0,"receiveReply:",R);const E=String(x);if(!this._pendingRPCReplies.hasOwnProperty(E))return;const M=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E],M.resolveOk(R)}_receiveReplyErr(B,x,R){this._logger&&this._logger.logIncoming(B,x,0,"receiveReplyErr:",R);const E=String(x);if(!this._pendingRPCReplies.hasOwnProperty(E))return;const M=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E];let N;R&&(R.$isError?(N=new Error,N.name=R.name,N.message=R.message,N.stack=R.stack):N=R),M.resolveErr(N)}_invokeHandler(B,x,R){try{return Promise.resolve(this._doInvokeHandler(B,x,R))}catch(E){return Promise.reject(E)}}_doInvokeHandler(B,x,R){const E=this._locals[B];if(!E)throw new Error("Unknown actor "+(0,O.getStringIdentifierForProxy)(B));let M=E[x];if(typeof M!="function")throw new Error("Unknown method "+x+" on actor "+(0,O.getStringIdentifierForProxy)(B));return M.apply(E,R)}_remoteCall(B,x,R){if(this._isDisposed)return Promise.reject(U.canceled());let E=null;if(R.length>0&&p.CancellationToken.isCancellationToken(R[R.length-1])&&(E=R.pop()),E&&E.isCancellationRequested)return Promise.reject(U.canceled());const M=l.serializeRequestArguments(R,this._uriReplacer),N=++this._lastMessageId,W=String(N),Z=new A.LazyPromise;E&&E.onCancellationRequested(()=>{const F=l.serializeCancel(N);this._logger&&this._logger.logOutgoing(F.byteLength,N,0,"cancel"),this._protocol.send(l.serializeCancel(N))}),this._pendingRPCReplies[W]=Z,this._onWillSendRequest(N);const K=l.serializeRequest(N,B,x,M,!!E);return this._logger&&this._logger.logOutgoing(K.byteLength,N,0,`request: ${(0,O.getStringIdentifierForProxy)(B)}.${x}(`,R),this._protocol.send(K),Z}}e.RPCProtocol=o,w=d,o.UNRESPONSIVE_TIME=3*1e3;class n{constructor(B,x){this._buff=B,this._offset=x}static alloc(B,x,R){let E=new n(C.VSBuffer.alloc(R+1+4),0);return E.writeUInt8(B),E.writeUInt32(x),E}static read(B,x){return new n(B,x)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(B){this._buff.writeUInt8(B,this._offset),this._offset+=1}readUInt8(){const B=this._buff.readUInt8(this._offset);return this._offset+=1,B}writeUInt32(B){this._buff.writeUInt32BE(B,this._offset),this._offset+=4}readUInt32(){const B=this._buff.readUInt32BE(this._offset);return this._offset+=4,B}static sizeShortString(B){return 1+B.byteLength}writeShortString(B){this._buff.writeUInt8(B.byteLength,this._offset),this._offset+=1,this._buff.set(B,this._offset),this._offset+=B.byteLength}readShortString(){const B=this._buff.readUInt8(this._offset);this._offset+=1;const R=this._buff.slice(this._offset,this._offset+B).toString();return this._offset+=B,R}static sizeLongString(B){return 4+B.byteLength}writeLongString(B){this._buff.writeUInt32BE(B.byteLength,this._offset),this._offset+=4,this._buff.set(B,this._offset),this._offset+=B.byteLength}readLongString(){const B=this._buff.readUInt32BE(this._offset);this._offset+=4;const R=this._buff.slice(this._offset,this._offset+B).toString();return this._offset+=B,R}writeBuffer(B){this._buff.writeUInt32BE(B.byteLength,this._offset),this._offset+=4,this._buff.set(B,this._offset),this._offset+=B.byteLength}static sizeVSBuffer(B){return 4+B.byteLength}writeVSBuffer(B){this._buff.writeUInt32BE(B.byteLength,this._offset),this._offset+=4,this._buff.set(B,this._offset),this._offset+=B.byteLength}readVSBuffer(){const B=this._buff.readUInt32BE(this._offset);this._offset+=4;const x=this._buff.slice(this._offset,this._offset+B);return this._offset+=B,x}static sizeMixedArray(B){let x=0;x+=1;for(let R=0,E=B.length;R<E;R++){const M=B[R];switch(x+=1,M.type){case 1:x+=this.sizeLongString(M.value);break;case 2:x+=this.sizeVSBuffer(M.value);break;case 3:x+=this.sizeUInt32,x+=this.sizeLongString(M.value);for(let N=0;N<M.buffers.length;++N)x+=this.sizeVSBuffer(M.buffers[N]);break;case 4:break}}return x}writeMixedArray(B){this._buff.writeUInt8(B.length,this._offset),this._offset+=1;for(let x=0,R=B.length;x<R;x++){const E=B[x];switch(E.type){case 1:this.writeUInt8(1),this.writeLongString(E.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(E.value);break;case 3:this.writeUInt8(3),this.writeUInt32(E.buffers.length),this.writeLongString(E.value);for(let M=0;M<E.buffers.length;++M)this.writeBuffer(E.buffers[M]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const B=this._buff.readUInt8(this._offset);this._offset+=1;let x=new Array(B);for(let R=0;R<B;R++)switch(this.readUInt8()){case 1:x[R]=this.readLongString();break;case 2:x[R]=this.readVSBuffer();break;case 3:{const M=this.readUInt32(),N=this.readLongString(),W=[];for(let Z=0;Z<M;++Z)W.push(this.readVSBuffer());x[R]=new O.SerializableObjectWithBuffers(u(N,W,null));break}case 4:x[R]=void 0;break}return x}}n.sizeUInt32=4;var t;(function(I){I[I.Simple=0]="Simple",I[I.Mixed=1]="Mixed"})(t||(t={}));class l{static _useMixedArgSerialization(B){for(let x=0,R=B.length;x<R;x++)if(B[x]instanceof C.VSBuffer||B[x]instanceof O.SerializableObjectWithBuffers||typeof B[x]=="undefined")return!0;return!1}static serializeRequestArguments(B,x){if(this._useMixedArgSerialization(B)){const R=[];for(let E=0,M=B.length;E<M;E++){const N=B[E];if(N instanceof C.VSBuffer)R[E]={type:2,value:N};else if(typeof N=="undefined")R[E]={type:4};else if(N instanceof O.SerializableObjectWithBuffers){const{jsonString:W,referencedBuffers:Z}=h(N.value,x);R[E]={type:3,value:C.VSBuffer.fromString(W),buffers:Z}}else R[E]={type:1,value:C.VSBuffer.fromString(D(N,x))}}return{type:1,args:R}}return{type:0,args:D(B,x)}}static serializeRequest(B,x,R,E,M){switch(E.type){case 0:return this._requestJSONArgs(B,x,R,E.args,M);case 1:return this._requestMixedArgs(B,x,R,E.args,M)}}static _requestJSONArgs(B,x,R,E,M){const N=C.VSBuffer.fromString(R),W=C.VSBuffer.fromString(E);let Z=0;Z+=n.sizeUInt8(),Z+=n.sizeShortString(N),Z+=n.sizeLongString(W);let K=n.alloc(M?2:1,B,Z);return K.writeUInt8(x),K.writeShortString(N),K.writeLongString(W),K.buffer}static deserializeRequestJSONArgs(B){const x=B.readUInt8(),R=B.readShortString(),E=B.readLongString();return{rpcId:x,method:R,args:JSON.parse(E)}}static _requestMixedArgs(B,x,R,E,M){const N=C.VSBuffer.fromString(R);let W=0;W+=n.sizeUInt8(),W+=n.sizeShortString(N),W+=n.sizeMixedArray(E);let Z=n.alloc(M?4:3,B,W);return Z.writeUInt8(x),Z.writeShortString(N),Z.writeMixedArray(E),Z.buffer}static deserializeRequestMixedArgs(B){const x=B.readUInt8(),R=B.readShortString(),E=B.readMixedArray(),M=new Array(E.length);for(let N=0,W=E.length;N<W;N++){const Z=E[N];typeof Z=="string"?M[N]=JSON.parse(Z):M[N]=Z}return{rpcId:x,method:R,args:M}}static serializeAcknowledged(B){return n.alloc(5,B,0).buffer}static serializeCancel(B){return n.alloc(6,B,0).buffer}static serializeReplyOK(B,x,R){if(typeof x=="undefined")return this._serializeReplyOKEmpty(B);if(x instanceof C.VSBuffer)return this._serializeReplyOKVSBuffer(B,x);if(x instanceof O.SerializableObjectWithBuffers){const{jsonString:E,referencedBuffers:M}=h(x.value,R,!0);return this._serializeReplyOKJSONWithBuffers(B,E,M)}else return this._serializeReplyOKJSON(B,g(x,R))}static _serializeReplyOKEmpty(B){return n.alloc(7,B,0).buffer}static _serializeReplyOKVSBuffer(B,x){let R=0;R+=n.sizeVSBuffer(x);let E=n.alloc(8,B,R);return E.writeVSBuffer(x),E.buffer}static deserializeReplyOKVSBuffer(B){return B.readVSBuffer()}static _serializeReplyOKJSON(B,x){const R=C.VSBuffer.fromString(x);let E=0;E+=n.sizeLongString(R);let M=n.alloc(9,B,E);return M.writeLongString(R),M.buffer}static _serializeReplyOKJSONWithBuffers(B,x,R){const E=C.VSBuffer.fromString(x);let M=0;M+=n.sizeUInt32,M+=n.sizeLongString(E);for(const W of R)M+=n.sizeVSBuffer(W);let N=n.alloc(10,B,M);N.writeUInt32(R.length),N.writeLongString(E);for(const W of R)N.writeBuffer(W);return N.buffer}static deserializeReplyOKJSON(B){const x=B.readLongString();return JSON.parse(x)}static deserializeReplyOKJSONWithBuffers(B,x){const R=B.readUInt32(),E=B.readLongString(),M=[];for(let N=0;N<R;++N)M.push(B.readVSBuffer());return new O.SerializableObjectWithBuffers(u(E,M,x))}static serializeReplyErr(B,x){const R=x?g(U.transformErrorForSerialization(x),null):void 0;if(typeof R!="string")return this._serializeReplyErrEmpty(B);const E=C.VSBuffer.fromString(R);let M=0;M+=n.sizeLongString(E);let N=n.alloc(11,B,M);return N.writeLongString(E),N.buffer}static deserializeReplyErrError(B){const x=B.readLongString();return JSON.parse(x)}static _serializeReplyErrEmpty(B){return n.alloc(12,B,0).buffer}}var v;(function(I){I[I.RequestJSONArgs=1]="RequestJSONArgs",I[I.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",I[I.RequestMixedArgs=3]="RequestMixedArgs",I[I.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",I[I.Acknowledged=5]="Acknowledged",I[I.Cancel=6]="Cancel",I[I.ReplyOKEmpty=7]="ReplyOKEmpty",I[I.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",I[I.ReplyOKJSON=9]="ReplyOKJSON",I[I.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",I[I.ReplyErrError=11]="ReplyErrError",I[I.ReplyErrEmpty=12]="ReplyErrEmpty"})(v||(v={}));var m;(function(I){I[I.String=1]="String",I[I.VSBuffer=2]="VSBuffer",I[I.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",I[I.Undefined=4]="Undefined"})(m||(m={}))}),define(De[220],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const s=function(U){const T=P=>{self.removeEventListener("message",T);const b=P.data;Object.defineProperties(self,{postMessage:{value(A,O){b.postMessage(A,O)}},onmessage:{get(){return b.onmessage},set(A){b.onmessage=A}}}),b.addEventListener("message",A=>{self.dispatchEvent(new MessageEvent("message",{data:A.data}))}),b.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(U)};self.addEventListener("message",T)}.toString();class C extends EventTarget{constructor(U,T,P){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const b=`((${s})('${T}'))`,A=new Blob([b],{type:"application/javascript"}),O=URL.createObjectURL(A),w=new MessageChannel,g=O,S={type:"_newWorker",id:g,port:w.port2,url:O,options:P};U(S,[w.port2]),this.postMessage=w.port1.postMessage.bind(w.port1),this.terminate=()=>{U({type:"_terminateWorker",id:g}),URL.revokeObjectURL(O),w.port1.close(),w.port2.close()},Object.defineProperties(this,{onmessage:{get(){return w.port1.onmessage},set(f){w.port1.onmessage=f}},onmessageerror:{get(){return w.port1.onmessageerror},set(f){w.port1.onmessageerror=f}}}),w.port1.addEventListener("messageerror",f=>{const c=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(c)}),w.port1.addEventListener("message",f=>{const c=new MessageEvent("message",{data:f.data});this.dispatchEvent(c)}),w.port1.start()}}e.NestedWorker=C}),define(De[221],Ie([1,0,5,30,38,3,39,11,13]),function(J,e,s,C,p,U,T,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new p.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new p.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new p.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,U.createDecorator)(e.OUTPUT_SERVICE_ID);var A;(function(S){S[S.Append=1]="Append",S[S.Replace=2]="Replace",S[S.Clear=3]="Clear"})(A=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class O{constructor(){this.channels=new Map,this._onDidRegisterChannel=new s.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new s.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(f){this.channels.has(f.id)||(this.channels.set(f.id,f),this._onDidRegisterChannel.fire(f.id))}getChannels(){const f=[];return this.channels.forEach(c=>f.push(c)),f}getChannel(f){return this.channels.get(f)}removeChannel(f){this.channels.delete(f),this._onDidRemoveChannel.fire(f)}}C.Registry.add(e.Extensions.OutputChannels,new O);function w(S,f,c,h,u){return(0,b.createCancelablePromise)(async D=>{await(0,T.whenProviderRegistered)(c,h);const y=C.Registry.as(e.Extensions.OutputChannels);try{await g(c,1,h,u,D),y.registerChannel({id:S,label:f,file:c,log:!0})}catch(a){(0,P.isCancellationError)(a)||u.error("Error while registering log channel",c.toString(),(0,P.getErrorMessage)(a))}})}e.registerLogChannel=w;async function g(S,f,c,h,u){if(!await c.exists(S)){if(u.isCancellationRequested)throw new P.CancellationError;if(f>10)throw new Error("Timed out while waiting for file to be created");h.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",S.toString()),await(0,b.timeout)(1e3,u),await g(S,f+1,c,h,u)}}}),define(De[98],Ie([1,0,4,7,3,16,14,221,52,28,35,117,23,9]),function(J,e,s,C,p,U,T,P,b,A,O,w,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class f extends C.Disposable{constructor(u,D,y,a){super();this.id=u,this.name=D,this.logger=y,this.proxy=a,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(u){this.append(u+`
`)}append(u){this.write(u),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Append))}clear(){const u=this.offset;this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Clear,u)}replace(u){const D=this.offset;this.write(u),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Replace,D),this.visible&&this.logger.flush()}show(u,D){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof u=="boolean"?u:D))}hide(){this.proxy.$close(this.id)}write(u){this.offset+=g.VSBuffer.fromString(u).byteLength,this.logger.info(u)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=f;let c=class{constructor(u,D,y,a,_){this.extHostFileSystem=y,this.extHostFileSystemInfo=a,this.loggerService=_,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=u.getProxy(s.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(D.logsLocation,`output_logging_${(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(u){this.visibleChannelId=u;for(const[D,y]of this.channels)y.visible=D===this.visibleChannelId}createOutputChannel(u,D,y){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");if((0,S.isString)(D)&&!D.trim())throw new Error("illegal argument `languageId`. must not be empty");const a=this.doCreateOutputChannel(u,D,y);return a.then(_=>{this.channels.set(_.id,_),_.visible=_.id===this.visibleChannelId}),this.createExtHostOutputChannel(u,a)}async doCreateOutputChannel(u,D,y){const a=await this.createOutputDirectory(),_=this.extHostFileSystemInfo.extUri.joinPath(a,`${this.namePool++}-${u.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=this.loggerService.createLogger(_,{always:!0,donotRotate:!0,donotUseFormatters:!0}),d=await this.proxy.$register(u,!1,_,D,y.identifier.value);return new f(d,u,r,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(u,D){let y=!1;const a=()=>{if(y)throw new Error("Channel has been closed")};return{get name(){return u},append(_){a(),D.then(r=>r.append(_))},appendLine(_){a(),D.then(r=>r.appendLine(_))},clear(){a(),D.then(_=>_.clear())},replace(_){a(),D.then(r=>r.replace(_))},show(_,r){a(),D.then(d=>d.show(_,r))},hide(){a(),D.then(_=>_.hide())},dispose(){y=!0,D.then(_=>_.dispose())}}}};c=$e([xe(0,U.IExtHostRpcService),xe(1,A.IExtHostInitDataService),xe(2,b.IExtHostConsumerFileSystem),xe(3,O.IExtHostFileSystemInfo),xe(4,T.ILoggerService)],c),e.ExtHostOutputService=c,e.IExtHostOutputService=(0,p.createDecorator)("IExtHostOutputService")}),define(De[222],Ie([1,0,3]),function(J,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,s.createDecorator)("remoteAgentService")}),define(De[223],Ie([1,0,37,12,19,22,21,2,3,156,46,176,222]),function(J,e,s,C,p,U,T,P,b,A,O,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,b.createDecorator)("pathService");let S=class Yi{constructor(c,h,u,D){this.localUserHome=c,this.remoteAgentService=h,this.environmentService=u,this.contextService=D,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||U.OS)(),this.resolveUserHome=(async()=>{const y=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=y?.userHome??c})()}hasValidBasename(c,h,u){return typeof h=="string"||typeof h=="undefined"?this.resolveOS.then(D=>this.doHasValidBasename(c,D,h)):this.doHasValidBasename(c,h,u)}doHasValidBasename(c,h,u){return c.scheme===C.Schemas.file||c.scheme===C.Schemas.vscodeRemote?(0,s.isValidBasename)(u??(0,T.basename)(c),h===1):!0}get defaultUriScheme(){return Yi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(c,h){if(c.remoteAuthority)return C.Schemas.vscodeRemote;const u=(0,A.getVirtualWorkspaceScheme)(h.getWorkspace());if(u)return u;const D=h.getWorkspace().folders[0];if(D)return D.uri.scheme;const y=h.getWorkspace().configuration;return y?y.scheme:C.Schemas.file}userHome(c){return c?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(c=>c===1?p.win32:p.posix)}async fileURI(c){let h="";if(await this.resolveOS===1&&(c=c.replace(/\\/g,"/")),c[0]==="/"&&c[1]==="/"){const D=c.indexOf("/",2);D===-1?(h=c.substring(2),c="/"):(h=c.substring(2,D),c=c.substring(D)||"/")}return P.URI.from({scheme:C.Schemas.file,authority:h,path:c,query:"",fragment:""})}};S=$e([xe(1,g.IRemoteAgentService),xe(2,w.IWorkbenchEnvironmentService),xe(3,O.IWorkspaceContextService)],S),e.AbstractPathService=S}),define(De[99],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class s{constructor(T,P){this.line=T,this.character=P}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,P){return new s(0,0)}with(T){return new s(0,0)}}e.Position=s;class C{constructor(T,P,b,A){this.isEmpty=!1,this.isSingleLine=!1,this.start=new s(T,P),this.end=new s(b,A)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new C(0,0,0,0)}with(T){return new C(0,0,0,0)}}e.Range=C;var p;(function(U){U[U.Information=1]="Information",U[U.Warning=2]="Warning"})(p=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(De[41],Ie([1,0,15,34,27,37,10,3,19,11,99,13]),function(J,e,s,C,p,U,T,P,b,A,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const g="\u27EA ",S=" characters skipped \u27EB",f=(g.length+S.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var c;(function(ae){ae[ae.file=0]="file",ae[ae.text=1]="text"})(c=e.SearchProviderType||(e.SearchProviderType={}));var h;(function(ae){ae[ae.File=1]="File",ae[ae.Text=2]="Text"})(h=e.QueryType||(e.QueryType={}));function u(ae){return!!ae.preview}e.resultIsMatch=u;function D(ae){return!!ae.resource}e.isFileMatch=D;function y(ae){return!!ae.message}e.isProgressMessage=y;var a;(function(ae){ae[ae.Normal=0]="Normal",ae[ae.NewSearchStarted=1]="NewSearchStarted"})(a=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class _{constructor(fe){this.resource=fe,this.results=[]}}e.FileMatch=_;class r{constructor(fe,ie,Ee){this.ranges=ie;const be=Array.isArray(ie)?ie:[ie];if(Ee&&Ee.matchLines===1&&d(be)){fe=(0,T.getNLines)(fe,Ee.matchLines);let ee="",ve=0,Re=0;const Fe=Math.floor(Ee.charsPerLine/5),We=[];for(const Xe of be){const Te=Math.max(Xe.startColumn-Fe,0),Se=Xe.startColumn+Ee.charsPerLine;if(Te>Re+Fe+f){const ke=g+(Te-Re)+S;ee+=ke+fe.slice(Te,Se),ve+=Te-(Re+ke.length)}else ee+=fe.slice(Re,Se);We.push(new o(0,Xe.startColumn-ve,Xe.endColumn-ve)),Re=Se}this.preview={text:ee,matches:Array.isArray(this.ranges)?We:We[0]}}else{const ee=Array.isArray(ie)?ie[0].startLineNumber:ie.startLineNumber;this.preview={text:fe,matches:(0,s.mapArrayOrNot)(ie,ve=>new i(ve.startLineNumber-ee,ve.startColumn,ve.endLineNumber-ee,ve.endColumn))}}}}e.TextSearchMatch=r;function d(ae){const fe=ae[0].startLineNumber;for(const ie of ae)if(ie.startLineNumber!==fe||ie.endLineNumber!==fe)return!1;return!0}class i{constructor(fe,ie,Ee,be){this.startLineNumber=fe,this.startColumn=ie,this.endLineNumber=Ee,this.endColumn=be}}e.SearchRange=i;class o extends i{constructor(fe,ie,Ee){super(fe,ie,fe,Ee)}}e.OneLineRange=o;var n;(function(ae){ae.Default="default",ae.FileNames="fileNames",ae.Type="type",ae.Modified="modified",ae.CountDescending="countDescending",ae.CountAscending="countAscending"})(n=e.SearchSortOrder||(e.SearchSortOrder={}));function t(ae,fe=!0){const ie=ae&&ae.files&&ae.files.exclude,Ee=fe&&ae&&ae.search&&ae.search.exclude;if(!ie&&!Ee)return;if(!ie||!Ee)return ie||Ee;let be=Object.create(null);return be=p.mixin(be,p.deepClone(ie)),be=p.mixin(be,p.deepClone(Ee),!0),be}e.getExcludes=t;function l(ae,fe){return ae.excludePattern&&C.match(ae.excludePattern,fe)?!1:ae.includePattern||ae.usingSearchPaths?ae.includePattern&&C.match(ae.includePattern,fe)?!0:ae.usingSearchPaths?!!ae.folderQueries&&ae.folderQueries.some(ie=>{const Ee=ie.folder.fsPath;if(U.isEqualOrParent(fe,Ee)){const be=b.relative(Ee,fe);return!ie.includePattern||!!C.match(ie.includePattern,be)}else return!1}):!1:!0}e.pathIncludedInQuery=l;var v;(function(ae){ae[ae.unknownEncoding=1]="unknownEncoding",ae[ae.regexParseError=2]="regexParseError",ae[ae.globParseError=3]="globParseError",ae[ae.invalidLiteral=4]="invalidLiteral",ae[ae.rgProcessError=5]="rgProcessError",ae[ae.other=6]="other",ae[ae.canceled=7]="canceled"})(v=e.SearchErrorCode||(e.SearchErrorCode={}));class m extends Error{constructor(fe,ie){super(fe);this.code=ie}}e.SearchError=m;function I(ae){const fe=ae.message;if((0,A.isCancellationError)(ae))return new m(fe,v.canceled);try{const ie=JSON.parse(fe);return new m(ie.message,ie.code)}catch{return new m(fe,v.other)}}e.deserializeSearchError=I;function B(ae){const fe={message:ae.message,code:ae.code};return new Error(JSON.stringify(fe))}e.serializeSearchError=B;function x(ae){return ae.type==="error"?!0:ae.type==="success"}e.isSerializedSearchComplete=x;function R(ae){return ae.type==="success"}e.isSerializedSearchSuccess=R;function E(ae){return!!ae.path}e.isSerializedFileMatch=E;function M(ae,fe){const ie=ae.searchPath?ae.searchPath:ae.relativePath;return(0,T.fuzzyContains)(ie,fe)}e.isFilePatternMatch=M;class N{constructor(fe){this.path=fe,this.results=[]}addMatch(fe){this.results.push(fe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=N;function W(ae,fe){const ie={...ae||{},...fe||{}};return Object.keys(ie).filter(Ee=>{const be=ie[Ee];return typeof be=="boolean"&&be})}e.resolvePatternsForProvider=W;class Z{constructor(fe,ie){this._parsedIncludeExpression=null,this._excludeExpression={...fe.excludePattern||{},...ie.excludePattern||{}},this._parsedExcludeExpression=C.parse(this._excludeExpression);let Ee=fe.includePattern;ie.includePattern&&(Ee?Ee={...Ee,...ie.includePattern}:Ee=ie.includePattern),Ee&&(this._parsedIncludeExpression=C.parse(Ee))}matchesExcludesSync(fe,ie,Ee){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(fe,ie,Ee))}includedInQuerySync(fe,ie,Ee){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(fe,ie,Ee)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(fe,ie,Ee))}includedInQuery(fe,ie,Ee){const be=this._parsedExcludeExpression(fe,ie,Ee),ee=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(fe,ie,Ee):!0;return(0,w.isThenable)(be)?be.then(ve=>ve?!1:ee()):ee()}hasSiblingExcludeClauses(){return K(this._excludeExpression)}}e.QueryGlobTester=Z;function K(ae){for(const fe in ae)if(typeof ae[fe]!="boolean")return!0;return!1}function F(ae){if(!ae)return;let fe;return ie=>(fe||(fe=(ae()||Promise.resolve([])).then(Ee=>Ee?ce(Ee):{})),fe.then(Ee=>!!Ee[ie]))}e.hasSiblingPromiseFn=F;function oe(ae){if(!ae)return;let fe;return ie=>{if(!fe){const Ee=ae();fe=Ee?ce(Ee):{}}return!!fe[ie]}}e.hasSiblingFn=oe;function ce(ae){const fe={};for(const ie of ae)fe[ie]=!0;return fe}}),define(De[31],Ie([1,0,15,13,20,5,24,12,106,21,10,9,2,134,3,14,148,46,35,28,16,8,6,41,4]),function(J,e,s,C,p,U,T,P,b,A,O,w,g,S,f,c,h,u,D,y,a,_,r,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function o(x,R,E){return new A.ExtUri(M=>v(M,E)).isEqual(x,R)}function n(x,R,E){return o(x.uri,R.uri,E)?0:(0,O.compare)(x.uri.toString(),R.uri.toString())}function t(x,R,E){return x.index!==R.index?x.index<R.index?-1:1:o(x.uri,R.uri,E)?(0,O.compare)(x.name,R.name):(0,O.compare)(x.uri.toString(),R.uri.toString())}function l(x,R,E,M){const N=x.slice(0).sort((Z,K)=>E(Z,K,M)),W=R.slice(0).sort((Z,K)=>E(Z,K,M));return(0,s.delta)(N,W,(Z,K)=>E(Z,K,M))}function v(x,R){const E=R.getCapabilities(x.scheme);return!(E&&E&1024)}class m extends u.Workspace{constructor(R,E,M,N,W,Z,K){super(R,M.map(F=>new u.WorkspaceFolder(F)),N,W,K);this._name=E,this._isUntitled=Z,this._workspaceFolders=[],this._structure=T.TernarySearchTree.forUris(K),M.forEach(F=>{this._workspaceFolders.push(F),this._structure.set(F.uri,F)})}static toExtHostWorkspace(R,E,M,N){if(!R)return{workspace:null,added:[],removed:[]};const{id:W,name:Z,folders:K,configuration:F,transient:oe,isUntitled:ce}=R,ae=[],fe=E;E?K.forEach((ee,ve)=>{const Re=g.URI.revive(ee.uri),Fe=m._findFolder(M||E,Re,N);Fe?(Fe.name=ee.name,Fe.index=ee.index,ae.push(Fe)):ae.push({uri:Re,name:ee.name,index:ve})}):ae.push(...K.map(({uri:ee,name:ve,index:Re})=>({uri:g.URI.revive(ee),name:ve,index:Re}))),ae.sort((ee,ve)=>ee.index<ve.index?-1:1);const ie=new m(W,Z,ae,!!oe,F?g.URI.revive(F):null,!!ce,ee=>v(ee,N)),{added:Ee,removed:be}=l(fe?fe.workspaceFolders:[],ie.workspaceFolders,n,N);return{workspace:ie,added:Ee,removed:be}}static _findFolder(R,E,M){for(let N=0;N<R.folders.length;N++){const W=R.workspaceFolders[N];if(o(W.uri,E,M))return W}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(R,E){return E&&this._structure.get(R)&&(R=(0,A.dirname)(R)),this._structure.findSubstr(R)}resolveWorkspaceFolder(R){return this._structure.get(R)}}let I=class{constructor(R,E,M,N){this._onDidChangeWorkspace=new U.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new U.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=N,this._extHostFileSystemInfo=M,this._requestIdProvider=new b.Counter,this._barrier=new C.Barrier,this._proxy=R.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=R.getProxy(i.MainContext.MainThreadMessageService);const W=E.workspace;this._confirmedWorkspace=W?new m(W.id,W.name,[],!!W.transient,W.configuration?g.URI.revive(W.configuration):null,!!W.isUntitled,Z=>v(Z,M)):void 0}$initializeWorkspace(R,E){this._trusted=E,this.$acceptWorkspaceData(R),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?g.URI.from({scheme:P.Schemas.untitled,path:(0,A.basename)((0,A.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(R,E,M,...N){const W=[];if(Array.isArray(N)&&N.forEach(ce=>{g.URI.isUri(ce.uri)&&!W.some(ae=>o(ae.uri,ce.uri,this._extHostFileSystemInfo))&&W.push({uri:ce.uri,name:ce.name||(0,A.basenameOrAuthority)(ce.uri)})}),this._unconfirmedWorkspace||[E,M].some(ce=>typeof ce!="number"||ce<0)||M===0&&W.length===0)return!1;const Z=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(E+M>Z.length)return!1;const K=Z.slice(0);K.splice(E,M,...W.map(ce=>({uri:ce.uri,name:ce.name||(0,A.basenameOrAuthority)(ce.uri),index:void 0})));for(let ce=0;ce<K.length;ce++){const ae=K[ce];if(K.some((fe,ie)=>ie!==ce&&o(ae.uri,fe.uri,this._extHostFileSystemInfo)))return!1}K.forEach((ce,ae)=>ce.index=ae);const{added:F,removed:oe}=l(Z,K,t,this._extHostFileSystemInfo);if(F.length===0&&oe.length===0)return!1;if(this._proxy){const ce=R.displayName||R.name;this._proxy.$updateWorkspaceFolders(ce,E,M,W).then(void 0,ae=>{this._unconfirmedWorkspace=void 0;const fe={source:{identifier:R.identifier,label:R.displayName||R.name}};this._messageService.$showMessage(h.Severity.Error,(0,S.localize)(0,null,ce,ae.toString()),fe,[])})}return this.trySetWorkspaceFolders(K),!0}getWorkspaceFolder(R,E){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,E)}async getWorkspaceFolder2(R,E){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,E)}async resolveWorkspaceFolder(R){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(R)}getPath(){if(!this._actualWorkspace)return;const{folders:R}=this._actualWorkspace;if(R.length!==0)return R[0].uri.fsPath}getRelativePath(R,E){let M,N="";if(typeof R=="string"?(M=g.URI.file(R),N=R):typeof R!="undefined"&&(M=R,N=R.fsPath),!M)return N;const W=this.getWorkspaceFolder(M,!0);if(!W)return N;typeof E=="undefined"&&this._actualWorkspace&&(E=this._actualWorkspace.folders.length>1);let Z=(0,A.relativePath)(W.uri,M);return E&&W.name&&(Z=`${W.name}/${Z}`),Z}trySetWorkspaceFolders(R){this._actualWorkspace&&(this._unconfirmedWorkspace=m.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:R,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(R){const{workspace:E,added:M,removed:N}=m.toExtHostWorkspace(R,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=E||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:M,removed:N}))}findFiles(R,E,M,N,W=p.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${N.value}, entryPoint: findFiles`);let Z;if(E===null?Z=!1:E&&(typeof E=="string"?Z=E:Z=E.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:K,folder:F}=B(_.GlobPattern.from(R));return this._proxy.$startFileSearch((0,w.withUndefinedAsNull)(K),(0,w.withUndefinedAsNull)(F),(0,w.withUndefinedAsNull)(Z),(0,w.withUndefinedAsNull)(M),W).then(oe=>Array.isArray(oe)?oe.map(ce=>g.URI.revive(ce)):[])}async findTextInFiles(R,E,M,N,W=p.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${N.value}, entryPoint: findTextInFiles`);const Z=this._requestIdProvider.getNext(),K=typeof E.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:E.previewOptions,{includePattern:F,folder:oe}=B(_.GlobPattern.from(E.include)),ce=typeof E.exclude=="string"?E.exclude:E.exclude?E.exclude.pattern:void 0,ae={ignoreSymlinks:typeof E.followSymlinks=="boolean"?!E.followSymlinks:void 0,disregardIgnoreFiles:typeof E.useIgnoreFiles=="boolean"?!E.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof E.useGlobalIgnoreFiles=="boolean"?!E.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof E.useParentIgnoreFiles=="boolean"?!E.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof E.useDefaultExcludes=="boolean"?!E.useDefaultExcludes:!0,fileEncoding:E.encoding,maxResults:E.maxResults,previewOptions:K,afterContext:E.afterContext,beforeContext:E.beforeContext,includePattern:F,excludePattern:ce},fe=!1;if(this._activeSearchCallbacks[Z]=ie=>{if(fe)return;const Ee=g.URI.revive(ie.resource);ie.results.forEach(be=>{(0,d.resultIsMatch)(be)?M({uri:Ee,preview:{text:be.preview.text,matches:(0,s.mapArrayOrNot)(be.preview.matches,ee=>new r.Range(ee.startLineNumber,ee.startColumn,ee.endLineNumber,ee.endColumn))},ranges:(0,s.mapArrayOrNot)(be.ranges,ee=>new r.Range(ee.startLineNumber,ee.startColumn,ee.endLineNumber,ee.endColumn))}):M({uri:Ee,text:be.text,lineNumber:be.lineNumber})})},W.isCancellationRequested)return{};try{const ie=await this._proxy.$startTextSearch(R,(0,w.withUndefinedAsNull)(oe),ae,Z,W);return delete this._activeSearchCallbacks[Z],ie||{}}catch(ie){throw delete this._activeSearchCallbacks[Z],ie}}$handleTextSearchResult(R,E){this._activeSearchCallbacks[E]&&this._activeSearchCallbacks[E](R)}saveAll(R){return this._proxy.$saveAll(R)}resolveProxy(R){return this._proxy.$resolveProxy(R)}get trusted(){return this._trusted}requestWorkspaceTrust(R){return this._proxy.$requestWorkspaceTrust(R)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};I=$e([xe(0,a.IExtHostRpcService),xe(1,y.IExtHostInitDataService),xe(2,D.IExtHostFileSystemInfo),xe(3,c.ILogService)],I),e.ExtHostWorkspace=I,e.IExtHostWorkspace=(0,f.createDecorator)("IExtHostWorkspace");function B(x){let R,E;return x&&(typeof x=="string"?R=x:(R=x.pattern,E=g.URI.revive(x.baseUri))),{includePattern:R,folder:E}}}),define(De[32],Ie([1,0,27,5,31,4,6,151,83,9,13,3,16,14,2]),function(J,e,s,C,p,U,T,P,b,A,O,w,g,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function c(d,i){if(i){const o=i.split(".");let n=d;for(let t=0;n&&t<o.length;t++)n=n[o[t]];return n}}function h(d){return d instanceof f.URI}function u(d){return d&&d.uri instanceof f.URI&&d.languageId&&typeof d.languageId=="string"}function D(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function y(d){return d&&d.uri instanceof f.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function a(d){if(h(d))return{resource:d};if(u(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(D(d))return{overrideIdentifier:d.languageId};if(y(d))return{resource:d.uri};if(d===null)return{resource:null}}let _=class{constructor(i,o,n){this._proxy=i.getProxy(U.MainContext.MainThreadConfiguration),this._extHostWorkspace=o,this._logService=n,this._barrier=new O.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(i=>this._actual)}$initializeConfiguration(i){this._actual=new r(this._proxy,this._extHostWorkspace,i,this._logService),this._barrier.open()}$acceptConfigurationChanged(i,o){this.getConfigProvider().then(n=>n.$acceptConfigurationChanged(i,o))}};_=$e([xe(0,g.IExtHostRpcService),xe(1,p.IExtHostWorkspace),xe(2,S.ILogService)],_),e.ExtHostConfiguration=_;class r{constructor(i,o,n,t){this._onDidChangeConfiguration=new C.Emitter,this._proxy=i,this._logService=t,this._extHostWorkspace=o,this._configuration=P.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(i,o){const n={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(i),this._configurationScopes=this._toMap(i.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(o,n))}getConfiguration(i,o,n){const t=a(o)||{},l=this._toReadonlyValue(i?c(this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace),i):this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace));i&&this._validateConfigurationAccess(i,t,n?.identifier);function v(I){if(I==null)return null;if(typeof I=="boolean")return I?1:4;switch(I){case T.ConfigurationTarget.Global:return 1;case T.ConfigurationTarget.Workspace:return 4;case T.ConfigurationTarget.WorkspaceFolder:return 5}}const m={has(I){return typeof c(l,I)!="undefined"},get:(I,B)=>{this._validateConfigurationAccess(i?`${i}.${I}`:I,t,n?.identifier);let x=c(l,I);if(typeof x=="undefined")x=B;else{let R;const E=(M,N)=>{let W;const Z=()=>{R=R||(0,s.deepClone)(l),W=W||c(R,N)};return(0,A.isObject)(M)?new Proxy(M,{get:(K,F)=>{if(typeof F=="string"&&F.toLowerCase()==="tojson")return Z(),()=>W;if(R)return W=W||c(R,N),W[F];const oe=K[F];return typeof F=="string"?E(oe,`${N}.${F}`):oe},set:(K,F,oe)=>(Z(),W&&(W[F]=oe),!0),deleteProperty:(K,F)=>(Z(),W&&delete W[F],!0),defineProperty:(K,F,oe)=>(Z(),W&&Object.defineProperty(W,F,oe),!0)}):M};x=E(x,I)}return x},update:(I,B,x,R)=>{I=i?`${i}.${I}`:I;const E=v(x);return B!==void 0?this._proxy.$updateConfigurationOption(E,I,B,t,R):this._proxy.$removeConfigurationOption(E,I,t,R)},inspect:I=>{I=i?`${i}.${I}`:I;const B=(0,s.deepClone)(this._configuration.inspect(I,t,this._extHostWorkspace.workspace));if(B)return{key:I,defaultValue:B.policy?.value??B.default?.value,globalValue:B.user?.value,workspaceValue:B.workspace?.value,workspaceFolderValue:B.workspaceFolder?.value,defaultLanguageValue:B.default?.override,globalLanguageValue:B.user?.override,workspaceLanguageValue:B.workspace?.override,workspaceFolderLanguageValue:B.workspaceFolder?.override,languageIds:B.overrideIdentifiers}}};return typeof l=="object"&&(0,s.mixin)(m,l,!1),Object.freeze(m)}_toReadonlyValue(i){const o=n=>(0,A.isObject)(n)?new Proxy(n,{get:(t,l)=>o(t[l]),set:(t,l,v)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(l)}' of object`)},deleteProperty:(t,l)=>{throw new Error(`TypeError: Cannot delete read only property '${String(l)}' of object`)},defineProperty:(t,l)=>{throw new Error(`TypeError: Cannot define property '${String(l)}' for a readonly object`)},setPrototypeOf:t=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):n;return o(i)}_validateConfigurationAccess(i,o,n){const t=b.OVERRIDE_PROPERTY_REGEX.test(i)?4:this._configurationScopes.get(i),l=n?`[${n.value}] `:"";if(t===4){typeof o?.resource=="undefined"&&this._logService.warn(`${l}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${i}', provide the URI of a resource or 'null' for any resource.`);return}if(t===3){o?.resource&&this._logService.warn(`${l}Accessing a window scoped configuration for a resource is not expected. To associate '${i}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(i,o){const n=new P.ConfigurationChangeEvent(i,o,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(t,l)=>n.affectsConfiguration(t,a(l))})}_toMap(i){return i.reduce((o,n)=>(o.set(n[0],n[1]),o),new Map)}}e.ExtHostConfigProvider=r,e.IExtHostConfiguration=(0,w.createDecorator)("IExtHostConfiguration")});var Ye=this&&this.__classPrivateFieldSet||function(J,e,s,C,p){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?p.call(J,s):p?p.value=s:e.set(J,s),s},Ae=this&&this.__classPrivateFieldGet||function(J,e,s,C){if(s==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?C:s==="a"?C.call(J):C?C.value:e.get(J)};define(De[100],Ie([1,0,2,13,5,4,6,31,50,32,20,53,16,28,3,12,22,14,70,183,11]),function(J,e,s,C,p,U,T,P,b,A,O,w,g,S,f,c,h,u,D,y,a){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var r;(function(N){function W(K){if(K!=null)return K}N.from=W;function Z(K){if(K!=null)return K}N.to=Z})(r=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var d;(function(N){function W(K){if(K!=null)return K}N.from=W;function Z(K){if(K!=null)return K}N.to=Z})(d=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var i;(function(N){function W(K){if(K!=null)return K}N.from=W;function Z(K){if(K!=null)return K}N.to=Z})(i=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var o;(function(N){function W(F){if(F){const oe=F;return oe&&!!oe.process}else return!1}N.is=W;function Z(F){if(F==null)return;const oe={process:F.process,args:F.args};return F.options&&(oe.options=i.from(F.options)),oe}N.from=Z;function K(F){if(F!=null)return new T.ProcessExecution(F.process,F.args,F.options)}N.to=K})(o=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var n;(function(N){function W(K){if(K!=null)return K}N.from=W;function Z(K){if(K!=null)return K}N.to=Z})(n=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var t;(function(N){function W(F){if(F){const oe=F;return oe&&(!!oe.commandLine||!!oe.command)}else return!1}N.is=W;function Z(F){if(F==null)return;const oe={};return F.commandLine!==void 0?oe.commandLine=F.commandLine:(oe.command=F.command,oe.args=F.args),F.options&&(oe.options=n.from(F.options)),oe}N.from=Z;function K(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new T.ShellExecution(F.commandLine,F.options):new T.ShellExecution(F.command,F.args?F.args:[],F.options)}N.to=K})(t=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var l;(function(N){function W(F){if(F){let oe=F;return oe&&oe.customExecution==="customExecution"}else return!1}N.is=W;function Z(F){return{customExecution:"customExecution"}}N.from=Z;function K(F,oe){return oe.get(F)}N.to=K})(l=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var v;(function(N){function W(Z,K){let F;return Z.scope!==void 0&&typeof Z.scope!="number"?F=Z.scope.uri:Z.scope!==void 0&&typeof Z.scope=="number"&&(Z.scope===T.TaskScope.Workspace&&K&&K.workspaceFile?F=K.workspaceFile:F=y.USER_TASKS_GROUP_KEY),{id:Z._id,workspaceFolder:F}}N.from=W})(v=e.TaskHandleDTO||(e.TaskHandleDTO={}));var m;(function(N){function W(Z){if(Z!=null)return{_id:Z.id,isDefault:Z.isDefault}}N.from=W})(m=e.TaskGroupDTO||(e.TaskGroupDTO={}));var I;(function(N){function W(F,oe){if(F==null)return[];const ce=[];for(let ae of F){const fe=Z(ae,oe);fe&&ce.push(fe)}return ce}N.fromMany=W;function Z(F,oe){if(F==null)return;let ce;F.execution instanceof T.ProcessExecution?ce=o.from(F.execution):F.execution instanceof T.ShellExecution?ce=t.from(F.execution):F.execution&&F.execution instanceof T.CustomExecution&&(ce=l.from(F.execution));const ae=r.from(F.definition);let fe;return F.scope?typeof F.scope=="number"?fe=F.scope:fe=F.scope.uri:fe=T.TaskScope.Workspace,!ae||!fe?void 0:{_id:F._id,definition:ae,name:F.name,source:{extensionId:oe.identifier.value,label:F.source,scope:fe},execution:ce,isBackground:F.isBackground,group:m.from(F.group),presentationOptions:d.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}N.from=Z;async function K(F,oe,ce){if(F==null)return;let ae;o.is(F.execution)?ae=o.to(F.execution):t.is(F.execution)?ae=t.to(F.execution):l.is(F.execution)&&(ae=l.to(F._id,ce));const fe=r.to(F.definition);let ie;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?ie=F.source.scope:ie=await oe.resolveWorkspaceFolder(s.URI.revive(F.source.scope)):ie=T.TaskScope.Workspace),!fe||!ie)return;const Ee=new T.Task(fe,ie,F.name,F.source.label,ae,F.problemMatchers);return F.isBackground!==void 0&&(Ee.isBackground=F.isBackground),F.group!==void 0&&(Ee.group=T.TaskGroup.from(F.group._id),Ee.group&&F.group.isDefault&&(Ee.group=new T.TaskGroup(Ee.group.id,Ee.group.label),F.group.isDefault===!0&&(Ee.group.isDefault=F.group.isDefault))),F.presentationOptions&&(Ee.presentationOptions=d.to(F.presentationOptions)),F._id&&(Ee._id=F._id),F.detail&&(Ee.detail=F.detail),Ee}N.to=K})(I=e.TaskDTO||(e.TaskDTO={}));var B;(function(N){function W(K){return K}N.from=W;function Z(K){if(!!K)return Object.assign(Object.create(null),K)}N.to=Z})(B=e.TaskFilterDTO||(e.TaskFilterDTO={}));class x{constructor(W,Z,K){this._id=Z,this._task=K,_.set(this,void 0),Ye(this,_,W,"f")}get task(){return this._task}terminate(){Ae(this,_,"f").terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}_=new WeakMap;var R;(function(N){function W(Z){return{id:Z._id,task:void 0}}N.from=W})(R=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let E=class{constructor(W,Z,K,F,oe,ce,ae,fe){this._onDidExecuteTask=new p.Emitter,this._onDidTerminateTask=new p.Emitter,this._onDidTaskProcessStarted=new p.Emitter,this._onDidTaskProcessEnded=new p.Emitter,this._proxy=W.getProxy(U.MainContext.MainThreadTask),this._workspaceProvider=K,this._editorService=F,this._configurationService=oe,this._terminalService=ce,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ae,this._deprecationService=fe,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(W,Z,K){if(!K)return new T.Disposable(()=>{});const F=this.nextHandle();return this._handlers.set(F,{type:Z,provider:K,extension:W}),this._proxy.$registerTaskProvider(F,Z),new T.Disposable(()=>{this._handlers.delete(F),this._proxy.$unregisterTaskProvider(F)})}registerTaskSystem(W,Z){this._proxy.$registerTaskSystem(W,Z)}fetchTasks(W){return this._proxy.$fetchTasks(B.from(W)).then(async Z=>{const K=[];for(let F of Z){const oe=await I.to(F,this._workspaceProvider,this._providedCustomExecutions2);oe&&K.push(oe)}return K})}get taskExecutions(){const W=[];return this._taskExecutions.forEach(Z=>W.push(Z)),W}terminateTask(W){if(!(W instanceof x))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(W._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(W,Z,K){const F=this._providedCustomExecutions2.get(W.id);F&&(this._activeCustomExecutions2.set(W.id,F),this._terminalService.attachPtyToTerminal(Z,await F.callback(K))),this._lastStartedTask=W.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(W)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(W){const Z=await this.getTaskExecution(W);this._taskExecutionPromises.delete(W.id),this._taskExecutions.delete(W.id),this.customExecutionComplete(W),this._onDidTerminateTask.fire({execution:Z})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(W){const Z=await this.getTaskExecution(W.id);this._onDidTaskProcessStarted.fire({execution:Z,processId:W.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(W){const Z=await this.getTaskExecution(W.id);this._onDidTaskProcessEnded.fire({execution:Z,exitCode:W.exitCode})}$provideTasks(W,Z){const K=this._handlers.get(W);if(!K)return Promise.reject(new Error("no handler found"));const F=[],oe=(0,C.asPromise)(()=>K.provider.provideTasks(O.CancellationToken.None)).then(ce=>this.provideTasksInternal(Z,F,K,ce));return new Promise(ce=>{oe.then(ae=>{Promise.all(F).then(()=>{ce(ae)})})})}async $resolveTask(W,Z){const K=this._handlers.get(W);if(!K)return Promise.reject(new Error("no handler found"));if(Z.definition.type!==K.type)throw new Error(`Unexpected: Task of type [${Z.definition.type}] cannot be resolved by provider of type [${K.type}].`);const F=await I.to(Z,this._workspaceProvider,this._providedCustomExecutions2);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const oe=await K.provider.resolveTask(F,O.CancellationToken.None);if(!oe)return;this.checkDeprecation(oe,K);const ce=I.from(oe,K.extension);if(!ce)throw new Error("Unexpected: Task cannot be resolved.");if(oe.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return l.is(ce.execution)&&await this.addCustomExecution(ce,oe,!0),await this.resolveTaskInternal(ce)}nextHandle(){return this._handleCounter++}async addCustomExecution(W,Z,K){const F=await this._proxy.$createTaskId(W);!K&&!this._providedCustomExecutions2.has(F)&&(this._notProvidedCustomExecutions.add(F),this._activeCustomExecutions2.set(F,Z.execution)),this._providedCustomExecutions2.set(F,Z.execution)}async getTaskExecution(W,Z){if(typeof W=="string"){const oe=this._taskExecutionPromises.get(W);if(!oe)throw new Error("Unexpected: The specified task is missing an execution");return oe}let K=this._taskExecutionPromises.get(W.id);if(K)return K;const F=new Promise((oe,ce)=>{function ae(fe,ie,Ee){Ee?oe(new x(fe,ie.id,Ee)):ce("Unexpected: Task does not exist.")}Z?ae(this,W,Z):I.to(W.task,this._workspaceProvider,this._providedCustomExecutions2).then(fe=>ae(this,W,fe))});return this._taskExecutionPromises.set(W.id,F),F.then(oe=>(this._taskExecutions.set(W.id,oe),oe),oe=>Promise.reject(oe))}checkDeprecation(W,Z){W._deprecated&&this._deprecationService.report("Task.constructor",Z.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(W){this._activeCustomExecutions2.get(W.id)&&this._activeCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.has(W.id)&&this._lastStartedTask!==W.id&&(this._providedCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.delete(W.id));let K=this._notProvidedCustomExecutions.values(),F=K.next();for(;!F.done;)!this._activeCustomExecutions2.has(F.value)&&this._lastStartedTask!==F.value&&(this._providedCustomExecutions2.delete(F.value),this._notProvidedCustomExecutions.delete(F.value)),F=K.next()}};E=$e([xe(0,g.IExtHostRpcService),xe(1,S.IExtHostInitDataService),xe(2,P.IExtHostWorkspace),xe(3,b.IExtHostDocumentsAndEditors),xe(4,A.IExtHostConfiguration),xe(5,w.IExtHostTerminalService),xe(6,u.ILogService),xe(7,D.IExtHostApiDeprecationService)],E),e.ExtHostTaskBase=E;let M=class extends E{constructor(W,Z,K,F,oe,ce,ae,fe){super(W,Z,K,F,oe,ce,ae,fe);this.registerTaskSystem(c.Schemas.vscodeRemote,{scheme:c.Schemas.vscodeRemote,authority:"",platform:h.PlatformToString(0)})}async executeTask(W,Z){if(!Z.execution)throw new Error("Tasks to execute must include an execution");const K=I.from(Z,W);if(K===void 0)throw new Error("Task is not valid");if(l.is(K.execution))await this.addCustomExecution(K,Z,!1);else throw new a.NotSupportedError;const F=await this.getTaskExecution(await this._proxy.$getTaskExecution(K),Z);return this._proxy.$executeTask(K).catch(oe=>{throw new Error(oe)}),F}provideTasksInternal(W,Z,K,F){const oe=[];if(F)for(let ce of F){this.checkDeprecation(ce,K),(!ce.definition||!W[ce.definition.type])&&this._logService.warn(`The task [${ce.source}, ${ce.name}] uses an undefined task type. The task will be ignored in the future.`);const ae=I.from(ce,K.extension);ae&&l.is(ae.execution)?(oe.push(ae),Z.push(this.addCustomExecution(ae,ce,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:oe,extension:K.extension}}async resolveTaskInternal(W){if(l.is(W.execution))return W;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(W,Z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,Z,K){}};M=$e([xe(0,g.IExtHostRpcService),xe(1,S.IExtHostInitDataService),xe(2,P.IExtHostWorkspace),xe(3,b.IExtHostDocumentsAndEditors),xe(4,A.IExtHostConfiguration),xe(5,w.IExtHostTerminalService),xe(6,u.ILogService),xe(7,D.IExtHostApiDeprecationService)],M),e.WorkerExtHostTask=M,e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(De[224],Ie([1,0,19,20,45,34,21,200,41]),function(J,e,s,C,p,U,T,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class A{constructor(g,S,f){this.config=g,this.provider=S,this.sessionToken=f,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=g.filePattern,this.includePattern=g.includePattern&&U.parse(g.includePattern),this.maxResults=g.maxResults||void 0,this.exists=g.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=g.excludePattern&&U.parse(g.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(g=>g.cancel()),this.activeCancellationTokens=new Set}search(g){const S=this.config.folderQueries||[];return new Promise((f,c)=>{const h=u=>{this.resultCount++,g(u)};if(this.isCanceled)return f({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(u=>{const D=u.toString(),y=s.basename(D);this.globalExcludePattern&&this.globalExcludePattern(D,y)||this.matchFile(h,{base:u,basename:y})}),Promise.all(S.map(u=>this.searchInFolder(u,h))).then(u=>{f({limitHit:this.isLimitHit,stats:u[0]||void 0})},u=>{c(new Error((0,p.toErrorMessage)(u)))})})}async searchInFolder(g,S){const f=new C.CancellationTokenSource,c=this.getSearchOptionsForFolder(g),h=this.initDirectoryTree(),u=new b.QueryGlobTester(this.config,g),D=!u.hasSiblingExcludeClauses();let y;try{this.activeCancellationTokens.add(f),y=P.StopWatch.create();const a=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},c,f.token),_=y.elapsed(),r=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(a&&a.forEach(d=>{const i=s.posix.relative(g.folder.path,d.path);if(D){const o=s.basename(d.path);this.matchFile(S,{base:g.folder,relativePath:i,basename:o});return}this.addDirectoryEntries(h,g.folder,i,S)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(h,u,S),{providerTime:_,postProcessTime:r.elapsed()})}finally{f.dispose(),this.activeCancellationTokens.delete(f)}}getSearchOptionsForFolder(g){const S=(0,b.resolvePatternsForProvider)(this.config.includePattern,g.includePattern),f=(0,b.resolvePatternsForProvider)(this.config.excludePattern,g.excludePattern);return{folder:g.folder,excludes:f,includes:S,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const g={rootEntries:[],pathToEntries:Object.create(null)};return g.pathToEntries["."]=g.rootEntries,g}addDirectoryEntries({pathToEntries:g},S,f,c){if(f===this.filePattern){const u=s.basename(this.filePattern);this.matchFile(c,{base:S,relativePath:this.filePattern,basename:u})}function h(u){const D=s.basename(u),y=s.dirname(u);let a=g[y];a||(a=g[y]=[],h(y)),a.push({base:S,relativePath:u,basename:D})}h(f)}matchDirectoryTree({rootEntries:g,pathToEntries:S},f,c){const h=this,u=this.filePattern;function D(y){const a=(0,b.hasSiblingFn)(()=>y.map(_=>_.basename));for(let _=0,r=y.length;_<r;_++){const d=y[_],{relativePath:i,basename:o}=d;if(f.matchesExcludesSync(i,o,u!==o?a:void 0))continue;const n=S[i];if(n)D(n);else{if(i===u)continue;h.matchFile(c,d)}if(h.isLimitHit)break}}D(g)}matchFile(g,S){(!this.includePattern||S.relativePath&&this.includePattern(S.relativePath,S.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||g(S))}}class O{constructor(){this.sessions=new Map}fileSearch(g,S,f,c){const h=this.getSessionTokenSource(g.cacheKey),u=new A(g,S,h&&h.token);let D=0;const y=a=>{D+=a.length,f(a.map(_=>this.rawMatchToSearchItem(_)))};return this.doSearch(u,O.BATCH_SIZE,y,c).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:D,detailStats:a.stats}}))}clearCache(g){const S=this.getSessionTokenSource(g);S&&S.cancel()}getSessionTokenSource(g){if(!!g)return this.sessions.has(g)||this.sessions.set(g,new C.CancellationTokenSource),this.sessions.get(g)}rawMatchToSearchItem(g){return g.relativePath?{resource:T.joinPath(g.base,g.relativePath)}:{resource:g.base}}doSearch(g,S,f,c){c.onCancellationRequested(()=>{g.cancel()});const h=D=>{D&&(u.push(D),S>0&&u.length>=S&&(f(u),u=[]))};let u=[];return g.search(h).then(D=>(u.length&&f(u),D),D=>(u.length&&f(u),Promise.reject(D)))}}e.FileSearchManager=O,O.BATCH_SIZE=512}),define(De[225],Ie([1,0,15,43,34,76,24,12,19,21,10,9,2,242,142,59,14,46,90,223,41]),function(J,e,s,C,p,U,T,P,b,A,O,w,g,S,f,c,h,u,D,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let _=class{constructor(m,I,B,x,R){this.configurationService=m,this.workspaceContextService=I,this.editorGroupsService=B,this.logService=x,this.pathService=R}text(m,I,B={}){m=this.getContentPattern(m,B);const x=this.configurationService.getValue(),R=I&&I.some(M=>!this.configurationService.getValue({resource:M}).search.useRipgrep);return{...this.commonQuery(I?.map(u.toWorkspaceFolder),B),type:2,contentPattern:m,previewOptions:B.previewOptions,maxFileSize:B.maxFileSize,usePCRE2:x.search.usePCRE2||R||!1,beforeContext:B.beforeContext,afterContext:B.afterContext,userDisabledExcludesAndIgnoreFiles:B.disregardExcludeSettings&&B.disregardIgnoreFiles}}getContentPattern(m,I){const B=this.configurationService.getValue();m.isRegExp&&(m.pattern=m.pattern.replace(/\r?\n/g,"\\n"));const x={...m,wordSeparators:B.editor.wordSeparators};return this.isCaseSensitive(m,I)&&(x.isCaseSensitive=!0),this.isMultiline(m)&&(x.isMultiline=!0),x}file(m,I={}){return{...this.commonQuery(m,I),type:1,filePattern:I.filePattern?I.filePattern.trim():I.filePattern,exists:I.exists,sortByScore:I.sortByScore,cacheKey:I.cacheKey}}handleIncludeExclude(m,I){return m?(m=Array.isArray(m)?m.map(n):n(m),I?this.parseSearchPaths(m):{pattern:d(...Array.isArray(m)?m:[m])}):{}}commonQuery(m=[],I={}){const B=this.handleIncludeExclude(I.includePattern,I.expandPatterns),x=this.handleIncludeExclude(I.excludePattern,I.expandPatterns),R=m.length>1,E=(B.searchPaths&&B.searchPaths.length?B.searchPaths.map(W=>this.getFolderQueryForSearchPath(W,I,x)):m.map(W=>this.getFolderQueryForRoot(W,I,x,R))).filter(W=>!!W),M={_reason:I._reason,folderQueries:E,usingSearchPaths:!!(B.searchPaths&&B.searchPaths.length),extraFileResources:I.extraFileResources,excludePattern:x.pattern,includePattern:B.pattern,onlyOpenEditors:I.onlyOpenEditors,maxResults:I.maxResults};if(I.onlyOpenEditors){const W=s.coalesce(s.flatten(this.editorGroupsService.groups.map(F=>F.editors.map(oe=>oe.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(W));const Z=W.filter(F=>(0,a.pathIncludedInQuery)(M,F.fsPath)),K=this.commonQueryFromFileList(Z);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(K)),{...M,...K}}const N=I.extraFileResources&&I.extraFileResources.filter(W=>(0,a.pathIncludedInQuery)(M,W.fsPath));return M.extraFileResources=N&&N.length?N:void 0,M}commonQueryFromFileList(m){const I=[],B=new T.ResourceMap,x={};let R=!1;return m.forEach(E=>{if(E.scheme===P.Schemas.walkThrough)return;if((0,A.isAbsolutePath)(E)){const N=this.workspaceContextService.getWorkspaceFolder(E)?.uri??E.with({path:b.dirname(E.fsPath)});let W=B.get(N);W||(R=!0,W={folder:N,includePattern:{}},I.push(W),B.set(N,W));const Z=b.relative(N.fsPath,E.fsPath);(0,w.assertIsDefined)(W.includePattern)[Z.replace(/\\/g,"/")]=!0}else E.fsPath&&(R=!0,x[E.fsPath]=!0)}),{folderQueries:I,includePattern:x,usingSearchPaths:!0,excludePattern:R?void 0:{"**/*":!0}}}isCaseSensitive(m,I){if(I.isSmartCase){if(m.isRegExp){if(O.containsUppercaseCharacter(m.pattern,!0))return!0}else if(O.containsUppercaseCharacter(m.pattern))return!0}return!!m.isCaseSensitive}isMultiline(m){return m.isMultiline||m.isRegExp&&(0,S.isMultilineRegexSource)(m.pattern)||m.pattern.indexOf(`
`)>=0?!0:!!m.isMultiline}parseSearchPaths(m){const I=K=>b.isAbsolute(K)||/^\.\.?([\/\\]|$)/.test(K),x=(Array.isArray(m)?m:i(m)).map(K=>{const F=this.pathService.resolvedUserHome;return F?(0,U.untildify)(K,F.scheme===P.Schemas.file?F.fsPath:F.path):K}),R=C.groupBy(x,K=>I(K)?"searchPaths":"exprSegments"),E=(R.exprSegments||[]).map(K=>O.rtrim(K,"/")).map(K=>O.rtrim(K,"\\")).map(K=>(K[0]==="."&&(K="*"+K),o(K))),M={},N=this.expandSearchPathPatterns(R.searchPaths||[]);N&&N.length&&(M.searchPaths=N);const W=s.flatten(E),Z=d(...W);return Z&&(M.pattern=Z),M}getExcludesForFolder(m,I){return I.disregardExcludeSettings?void 0:(0,a.getExcludes)(m,!I.disregardSearchExcludeSettings)}expandSearchPathPatterns(m){if(!m||!m.length)return[];const I=s.flatten(m.map(x=>{let{pathPortion:R,globPortion:E}=r(x);E&&(E=t(E));const M=this.expandOneSearchPath(R);return s.flatten(M.map(N=>this.resolveOneSearchPathPattern(N,E)))})),B=new Map;return I.forEach(x=>{const R=x.searchPath.toString(),E=B.get(R);E?x.pattern&&(E.pattern=E.pattern||{},E.pattern[x.pattern]=!0):B.set(R,{searchPath:x.searchPath,pattern:x.pattern?d(x.pattern):void 0})}),Array.from(B.values())}expandOneSearchPath(m){if(b.isAbsolute(m)){const I=this.workspaceContextService.getWorkspace().folders;return I[0]&&I[0].uri.scheme!==P.Schemas.file?[{searchPath:I[0].uri.with({path:m})}]:[{searchPath:g.URI.file(b.normalize(m))}]}if(this.workspaceContextService.getWorkbenchState()===2){const I=this.workspaceContextService.getWorkspace().folders[0].uri;if(m=n(m),m.startsWith("../")||m===".."){const x=b.posix.resolve(I.path,m);return[{searchPath:I.with({path:x})}]}const B=t(m);return[{searchPath:I,pattern:B}]}else{if(m==="./"||m===".\\")return[];{const I=m.replace(/^\.[\/\\]/,""),x=this.workspaceContextService.getWorkspace().folders.map(R=>{const E=I.match(new RegExp(`^${O.escapeRegExpCharacters(R.name)}(?:/(.*)|$)`));return E?{match:E,folder:R}:null}).filter(w.isDefined);if(x.length)return x.map(R=>{const E=R.match[1];return{searchPath:R.folder.uri,pattern:E&&t(E)}});{const R=m.match(/\.[\/\\](.+)[\/\\]?/),E=R?R[1]:m,M=f.localize(0,null,E);throw new Error(M)}}}}resolveOneSearchPathPattern(m,I){const B=m.pattern&&I?`${m.pattern}/${I}`:m.pattern||I,x=[{searchPath:m.searchPath,pattern:B}];return B&&!B.endsWith("**")&&x.push({searchPath:m.searchPath,pattern:B+"/**"}),x}getFolderQueryForSearchPath(m,I,B){const x=this.getFolderQueryForRoot((0,u.toWorkspaceFolder)(m.searchPath),I,B,!1);return x?{...x,includePattern:m.pattern}:null}getFolderQueryForRoot(m,I,B,x){let R;const E=g.URI.isUri(m)?m:m.uri;if(B.searchPaths){const K=B.searchPaths.filter(F=>(0,A.isEqual)(F.searchPath,E))[0];if(K&&!K.pattern)return null;K&&(R=K.pattern)}const M=this.configurationService.getValue({resource:E}),W={...this.getExcludesForFolder(M,I)||{},...R||{}},Z=g.URI.isUri(m)?(0,A.basename)(m):m.name;return{folder:E,folderName:x?Z:void 0,excludePattern:Object.keys(W).length>0?W:void 0,fileEncoding:M.files&&M.files.encoding,disregardIgnoreFiles:typeof I.disregardIgnoreFiles=="boolean"?I.disregardIgnoreFiles:!M.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof I.disregardGlobalIgnoreFiles=="boolean"?I.disregardGlobalIgnoreFiles:!M.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof I.disregardParentIgnoreFiles=="boolean"?I.disregardParentIgnoreFiles:!M.search.useParentIgnoreFiles,ignoreSymlinks:typeof I.ignoreSymlinks=="boolean"?I.ignoreSymlinks:!M.search.followSymlinks}}};_=$e([xe(0,c.IConfigurationService),xe(1,u.IWorkspaceContextService),xe(2,D.IEditorGroupsService),xe(3,h.ILogService),xe(4,y.IPathService)],_),e.QueryBuilder=_;function r(v){const m=v.match(/[\*\{\}\(\)\[\]\?]/);if(m){const I=m.index,B=v.substr(0,I).match(/[/|\\][^/\\]*$/);if(B){let x=v.substr(0,B.index);return x.match(/[/\\]/)||(x+="/"),{pathPortion:x,globPortion:v.substr((B.index||0)+1)}}}return{pathPortion:v}}function d(...v){return v.length?v.reduce((m,I)=>(m[I]=!0,m),Object.create(null)):void 0}function i(v){return p.splitGlobAware(v,",").map(m=>m.trim()).filter(m=>!!m.length)}function o(v){return[`**/${v}/**`,`**/${v}`].map(I=>I.replace(/\*\*\/\*\*/g,"**"))}function n(v){return v.replace(/\\/g,"/")}function t(v){return n(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(v,m){v=s.distinct(v,x=>x.toString());const I=[],B=m.getWorkspace();return v&&v.forEach(x=>{let R;if(m.getWorkbenchState()===2)R=(0,A.relativePath)(B.folders[0].uri,x),R&&R!=="."&&(R="./"+R);else{const E=m.getWorkspaceFolder(x);if(E){const M=E.name;if(B.folders.filter(W=>W.name===M).length===1){const W=(0,A.relativePath)(E.uri,x);W===""?R=`./${E.name}`:R=`./${E.name}/${W}`}else R=x.fsPath}}R&&I.push(R)}),I}e.resolveResourcesForSearchIncludes=l}),define(De[226],Ie([1,0,21,2,20,11,3,225,41,46]),function(J,e,s,C,p,U,T,P,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const O=7e3;function w(c,h){const u=h.activationEvents;if(!u)return Promise.resolve(void 0);const D=[],y=[];for(const o of u)if(/^workspaceContains:/.test(o)){const n=o.substr("workspaceContains:".length);n.indexOf("*")>=0||n.indexOf("?")>=0||c.forceUsingSearch?y.push(n):D.push(n)}if(D.length===0&&y.length===0)return Promise.resolve(void 0);let a;const _=new Promise((o,n)=>{a=o}),r=o=>a({activationEvent:o}),d=Promise.all(D.map(o=>g(c,o,r))).then(()=>{}),i=S(c,h.identifier,y,r);return Promise.all([d,i]).then(()=>{a(void 0)}),_}e.checkActivateWorkspaceContainsExtension=w;async function g(c,h,u){for(const D of c.folders)if(await c.exists(s.joinPath(C.URI.revive(D),h))){u(`workspaceContains:${h}`);return}}async function S(c,h,u,D){if(u.length===0)return Promise.resolve(void 0);const y=new p.CancellationTokenSource,a=c.checkExists(c.folders,u,y.token),_=setTimeout(async()=>{y.cancel(),c.logService.info(`Not activating extension '${h.value}': Timed out while searching for 'workspaceContains' pattern ${u.join(",")}`)},O);let r=!1;try{r=await a}catch(d){U.isCancellationError(d)||U.onUnexpectedError(d)}y.dispose(),clearTimeout(_),r&&D(`workspaceContains:${u.join(",")}`)}function f(c,h,u,D){const y=c.get(T.IInstantiationService),a=c.get(b.ISearchService),r=y.createInstance(P.QueryBuilder).file(h.map(d=>(0,A.toWorkspaceFolder)(C.URI.revive(d))),{_reason:"checkExists",includePattern:u,exists:!0});return a.fileSearch(r,D).then(d=>!!d.limitHit,d=>U.isCancellationError(d)?!1:Promise.reject(d))}e.checkGlobFileExists=f});var Ye=this&&this.__classPrivateFieldSet||function(J,e,s,C,p){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!p:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?p.call(J,s):p?p.value=s:e.set(J,s),s},Ae=this&&this.__classPrivateFieldGet||function(J,e,s,C){if(s==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return s==="m"?C:s==="a"?C.call(J):C?C.value:e.get(J)};define(De[33],Ie([1,0,129,19,73,21,13,7,24,2,14,4,32,178,71,31,26,177,11,25,23,157,6,84,3,28,72,16,60,64,53,5,226,69,159,12]),function(J,e,s,C,p,U,T,P,b,A,O,w,g,S,f,c,h,u,D,y,a,_,r,d,i,o,n,t,l,v,m,I,B,x,R,E){"use strict";var M,N,W;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,i.createDecorator)("IHostUtils");let Z=class yi extends P.Disposable{constructor(ie,Ee,be,ee,ve,Re,Fe,We,Xe,Te){super();this._onDidChangeRemoteConnectionData=this._register(new I.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=Ee,this._extHostContext=be,this._initData=Fe,this._extHostWorkspace=ee,this._extHostConfiguration=ve,this._logService=Re,this._extHostTunnelService=Xe,this._extHostTerminalService=Te,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(w.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(w.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(w.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new T.Barrier,this._readyToStartExtensionHost=new T.Barrier,this._readyToRunExtensions=new T.Barrier,this._eagerExtensionsActivated=new T.Barrier,this._globalRegistry=new u.ExtensionDescriptionRegistry(this._initData.allExtensions);const Se=(0,h.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new u.ExtensionDescriptionRegistry(oe(this._globalRegistry,Se)),this._storage=new f.ExtHostStorage(this._extHostContext),this._secretState=new x.ExtHostSecretState(this._extHostContext),this._storagePath=We,this._instaService=ie.createChild(new l.ServiceCollection([f.IExtHostStorage,this._storage],[x.IExtHostSecretState,this._secretState]));let ke=[],se=[];this._initData.remote.isRemote&&(ke=this._initData.allExtensions.filter(G=>!G.main&&!G.browser).map(G=>G.identifier),se=this._initData.allExtensions.filter(G=>!Se.has(y.ExtensionIdentifier.toKey(G.identifier.value))).filter(G=>(G.main||G.browser)&&G.api==="none").map(G=>G.identifier));const le=(0,h.extensionIdentifiersArrayToSet)(se);this._activator=this._register(new S.ExtensionsActivator(this._myRegistry,ke,se,{onExtensionActivationError:(G,X,k)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(G,D.transformErrorForSerialization(X),k)},actualActivateExtension:async(G,X)=>{if(le.has(y.ExtensionIdentifier.toKey(G)))return await this._mainThreadExtensionsProxy.$activateExtension(G,X),new S.HostExtension;const k=this._myRegistry.getExtensionDescription(G);return this._activateExtension(k,X)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),p.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(ie){D.onUnexpectedError(ie)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let ie=[];try{ie=this._myRegistry.getAllExtensionDescriptions().map(ve=>ve.identifier).filter(ve=>this.isActivated(ve)).map(ve=>this._deactivate(ve))}catch{}await Promise.all(ie)}terminate(ie,Ee=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${ie}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),D.setUnexpectedErrorHandler(ee=>{this._logService.error(ee)}),this._extHostContext.dispose();const be=this._deactivateAll();Promise.race([(0,T.timeout)(5e3),be]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${Ee}`):this._logService.info(`Extension host exiting with code ${Ee}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(Ee)})}isActivated(ie){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(ie):!1}async getExtension(ie){const Ee=await this._mainThreadExtensionsProxy.$getExtension(ie);return Ee&&{...Ee,identifier:new y.ExtensionIdentifier(Ee.identifier.value),extensionLocation:A.URI.revive(Ee.extensionLocation)}}_activateByEvent(ie,Ee){return this._activator.activateByEvent(ie,Ee)}_activateById(ie,Ee){return this._activator.activateById(ie,Ee)}activateByIdWithErrors(ie,Ee){return this._activateById(ie,Ee).then(()=>{const be=this._activator.getActivatedExtension(ie);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(ie=>this._myRegistry)}getExtensionExports(ie){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(ie).exports:null}async _realPathExtensionUri(ie){if(ie.scheme!==E.Schemas.file)return ie;const Ee=await this._hostUtils.realpath(ie.fsPath);return A.URI.file(Ee)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(ie=>new ae(ie))),this._extensionPathIndex}async _createExtensionPathIndex(ie){const Ee=b.TernarySearchTree.forUris(be=>U.extUriBiasedIgnorePathCase.ignorePathCasing(be));return await Promise.all(ie.map(async be=>{if(this._getEntryPoint(be)){const ee=await this._realPathExtensionUri(be.extensionLocation);Ee.set(ee,be)}})),Ee}_deactivate(ie){let Ee=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(ie))return Ee;const be=this._activator.getActivatedExtension(ie);if(!be)return Ee;try{typeof be.module.deactivate=="function"&&(Ee=Promise.resolve(be.module.deactivate()).then(void 0,ee=>(this._logService.error(ee),Promise.resolve(void 0))))}catch(ee){this._logService.error(`An error occurred when deactivating the extension '${ie.value}':`),this._logService.error(ee)}try{(0,P.dispose)(be.subscriptions)}catch(ee){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${ie.value}':`),this._logService.error(ee)}return Ee}async _activateExtension(ie,Ee){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(ie.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(ie.identifier),this._doActivateExtension(ie,Ee).then(be=>{const ee=be.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(ie.identifier,ee.codeLoadingTime,ee.activateCallTime,ee.activateResolvedTime,Ee),this._logExtensionActivationTimes(ie,Ee,"success",ee),be},be=>{throw this._logExtensionActivationTimes(ie,Ee,"failure"),be})}_logExtensionActivationTimes(ie,Ee,be,ee){const ve=K(ie,Ee);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ve,...ee||{},outcome:be})}_doActivateExtension(ie,Ee){const be=K(ie,Ee);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",be);const ee=this._getEntryPoint(ie);if(!ee)return Promise.resolve(new S.EmptyExtension(S.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${ie.identifier.value}, startup: ${Ee.startup}, activationEvent: '${Ee.activationEvent}'${ie.identifier.value!==Ee.extensionId.value?`, root cause: ${Ee.extensionId.value}`:""}`),this._logService.flush();const ve=new S.ExtensionActivationTimesBuilder(Ee.startup);return Promise.all([this._loadCommonJSModule(ie.identifier,(0,U.joinPath)(ie.extensionLocation,ee),ve),this._loadExtensionContext(ie)]).then(Re=>(p.mark(`code/extHost/willActivateExtension/${ie.identifier.value}`),yi._callActivate(this._logService,ie.identifier,Re[0],Re[1],ve))).then(Re=>(p.mark(`code/extHost/didActivateExtension/${ie.identifier.value}`),Re))}_loadExtensionContext(ie){const Ee=new _.ExtensionGlobalMemento(ie,this._storage),be=new _.ExtensionMemento(ie.identifier.value,!1,this._storage),ee=new R.ExtensionSecrets(ie,this._secretState),ve=ie.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,Re=this._initData.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${ie.identifier.value}`),Promise.all([Ee.whenReady,be.whenReady,this._storagePath.whenReady]).then(()=>{const Fe=this;let We,Xe;const Te=(0,h.isProposedApiEnabled)(ie,"ipc")?this._initData.messagePorts?.get(y.ExtensionIdentifier.toKey(ie.identifier)):void 0;return Object.freeze({globalState:Ee,workspaceState:be,secrets:ee,subscriptions:[],get extensionUri(){return ie.extensionLocation},get extensionPath(){return ie.extensionLocation.fsPath},asAbsolutePath(Se){return C.join(ie.extensionLocation.fsPath,Se)},get storagePath(){return Fe._storagePath.workspaceValue(ie)?.fsPath},get globalStoragePath(){return Fe._storagePath.globalValue(ie).fsPath},get logPath(){return C.join(Fe._initData.logsLocation.fsPath,ie.identifier.value)},get logUri(){return A.URI.joinPath(Fe._initData.logsLocation,ie.identifier.value)},get storageUri(){return Fe._storagePath.workspaceValue(ie)},get globalStorageUri(){return Fe._storagePath.globalValue(ie)},get extensionMode(){return ve},get extension(){return We===void 0&&(We=new F(Fe,ie.identifier,ie,Re,!1)),We},get extensionRuntime(){return(0,h.checkProposedApiEnabled)(ie,"extensionRuntime"),Fe.extensionRuntime},get environmentVariableCollection(){return Fe._extHostTerminalService.getEnvironmentVariableCollection(ie)},get messagePassingProtocol(){if(!Xe){if(!Te)return;const Se=I.Event.buffer(I.Event.fromDOMEventEmitter(Te,"message",ke=>ke.data));Te.start(),Xe={onDidReceiveMessage:Se,postMessage:Te.postMessage.bind(Te)}}return Xe}})})}static _callActivate(ie,Ee,be,ee,ve){return be=be||{activate:void 0,deactivate:void 0},this._callActivateOptional(ie,Ee,be,ee,ve).then(Re=>new S.ActivatedExtension(!1,null,ve.build(),be,Re,ee.subscriptions))}static _callActivateOptional(ie,Ee,be,ee,ve){if(typeof be.activate=="function")try{ve.activateCallStart(),ie.trace(`ExtensionService#_callActivateOptional ${Ee.value}`);const Re=typeof global=="object"?global:self,Fe=be.activate.apply(Re,[ee]);return ve.activateCallStop(),ve.activateResolveStart(),Promise.resolve(Fe).then(We=>(ve.activateResolveStop(),We))}catch(Re){return Promise.reject(Re)}else return Promise.resolve(be)}_activateOneStartupFinished(ie,Ee){this._activateById(ie.identifier,{startup:!1,extensionId:ie.identifier,activationEvent:Ee}).then(void 0,be=>{this._logService.error(be)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(p.getMarks());for(const ie of this._myRegistry.getAllExtensionDescriptions())if(ie.activationEvents)for(const Ee of ie.activationEvents)Ee==="onStartupFinished"&&this._activateOneStartupFinished(ie,Ee)}_handleEagerExtensions(){const ie=this._activateByEvent("*",!0).then(void 0,ve=>{this._logService.error(ve)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ve=>this._handleWorkspaceContainsEagerExtensions(ve.added)));const Ee=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],be=this._handleWorkspaceContainsEagerExtensions(Ee),ee=Promise.all([ie,be]).then(()=>{});return Promise.race([ee,(0,T.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ee}_handleWorkspaceContainsEagerExtensions(ie){return ie.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(Ee=>this._handleWorkspaceContainsEagerExtension(ie,Ee))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(ie,Ee){if(this.isActivated(Ee.identifier))return;const be=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ee={logService:this._logService,folders:ie.map(Re=>Re.uri),forceUsingSearch:be,exists:Re=>this._hostUtils.exists(Re.fsPath),checkExists:(Re,Fe,We)=>this._mainThreadWorkspaceProxy.$checkExists(Re,Fe,We)},ve=await(0,B.checkActivateWorkspaceContainsExtension)(ee,Ee);if(!!ve)return this._activateById(Ee.identifier,{startup:!0,extensionId:Ee.identifier,activationEvent:ve.activationEvent}).then(void 0,Re=>this._logService.error(Re))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(ie){throw console.error(ie),ie}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:ie,extensionTestsLocationURI:Ee}=this._initData.environment;if(!ie||!Ee)throw new Error(s.localize(0,null));const be=await this._loadCommonJSModule(null,Ee,new S.ExtensionActivationTimesBuilder(!1));if(!be||typeof be.run!="function")throw new Error(s.localize(1,null,Ee.toString()));return new Promise((ee,ve)=>{const Re=(Xe,Te)=>{Xe?ve(Xe):ee(typeof Te=="number"&&Te>0?1:0)},Fe=(0,U.originalFSPath)(Ee),We=be.run(Fe,Re);We&&We.then&&We.then(()=>{ee(0)}).catch(Xe=>{ve(Xe instanceof Error&&Xe.stack?Xe.stack:String(Xe))})})}async $extensionTestsExit(ie){this.terminate(`test runner requested exit with code ${ie}`,ie)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ie,Ee){return this._resolvers[ie]=Ee,(0,P.toDisposable)(()=>{delete this._resolvers[ie]})}async _activateAndGetResolver(ie){const Ee=ie.indexOf("+");if(Ee===-1)throw new Error("Not an authority that can be resolved!");const be=ie.substr(0,Ee);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this._resolvers[be]}}async $resolveAuthority(ie,Ee){this._logService.info(`$resolveAuthority invoked for authority (${ce(ie)})`);const{authorityPrefix:be,resolver:ee}=await this._activateAndGetResolver(ie);if(!ee)return{type:"error",error:{code:d.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${be}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(ee)),p.mark(`code/extHost/willResolveAuthority/${be}`);const ve=await ee.resolve(ie,{resolveAttempt:Ee});p.mark(`code/extHost/didResolveAuthorityOK/${be}`);const Re={authority:ie,host:ve.host,port:ve.port,connectionToken:ve.connectionToken},Fe={extensionHostEnv:ve.extensionHostEnv,isTrusted:ve.isTrusted,authenticationSession:ve.authenticationSessionForInitializingExtensions?{id:ve.authenticationSessionForInitializingExtensions.id,providerId:ve.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Re,options:Fe,tunnelInformation:{environmentTunnels:ve.environmentTunnels,features:ve.tunnelFeatures}}}}catch(ve){if(p.mark(`code/extHost/didResolveAuthorityError/${be}`),ve instanceof r.RemoteAuthorityResolverError)return{type:"error",error:{code:ve._code,message:ve._message,detail:ve._detail}};throw ve}}async $getCanonicalURI(ie,Ee){this._logService.info(`$getCanonicalURI invoked for authority (${ce(ie)})`);const{resolver:be}=await this._activateAndGetResolver(ie);if(!be)return null;const ee=A.URI.revive(Ee);if(typeof be.getCanonicalURI=="undefined")return ee;const ve=await(0,T.asPromise)(()=>be.getCanonicalURI(ee));return ve||ee}static _applyExtensionsDelta(ie,Ee,be){const ee=new u.ExtensionDescriptionRegistry(ie.getAllExtensionDescriptions());ee.deltaExtensions(be.toAdd,be.toRemove);const ve=(0,h.extensionIdentifiersArrayToSet)(Ee.getAllExtensionDescriptions().map(Fe=>Fe.identifier));for(const Fe of be.myToRemove)ve.delete(y.ExtensionIdentifier.toKey(Fe));for(const Fe of be.myToAdd)ve.add(y.ExtensionIdentifier.toKey(Fe));const Re=oe(ee,ve);return{globalRegistry:ee,myExtensions:Re}}$startExtensionHost(ie){ie.toAdd.forEach(ee=>ee.extensionLocation=A.URI.revive(ee.extensionLocation));const{globalRegistry:Ee,myExtensions:be}=yi._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ie);return this._globalRegistry.set(Ee.getAllExtensionDescriptions()),this._myRegistry.set(be),this._startExtensionHost()}$activateByEvent(ie,Ee){return Ee===1?this._activateByEvent(ie,!1):this._readyToRunExtensions.wait().then(be=>this._activateByEvent(ie,!1))}async $activate(ie,Ee){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(ie)?(await this._activateById(ie,Ee),!0):!1}async $deltaExtensions(ie){ie.toAdd.forEach(Re=>Re.extensionLocation=A.URI.revive(Re.extensionLocation));const{globalRegistry:Ee,myExtensions:be}=yi._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ie),ee=await this._createExtensionPathIndex(be);return(await this.getExtensionPathIndex()).setSearchTree(ee),this._globalRegistry.set(Ee.getAllExtensionDescriptions()),this._myRegistry.set(be),Promise.resolve(void 0)}async $test_latency(ie){return ie}async $test_up(ie){return ie.byteLength}async $test_down(ie){let Ee=a.VSBuffer.alloc(ie),be=Math.random()%256;for(let ee=0;ee<ie;ee++)Ee.writeUInt8(be,ee);return Ee}async $updateRemoteConnectionData(ie){this._remoteConnectionData=ie,this._onDidChangeRemoteConnectionData.fire()}};Z=$e([xe(0,i.IInstantiationService),xe(1,e.IHostUtils),xe(2,t.IExtHostRpcService),xe(3,c.IExtHostWorkspace),xe(4,g.IExtHostConfiguration),xe(5,O.ILogService),xe(6,o.IExtHostInitDataService),xe(7,n.IExtensionStoragePaths),xe(8,v.IExtHostTunnelService),xe(9,m.IExtHostTerminalService)],Z),e.AbstractExtHostExtensionService=Z;function K(fe,ie){return{id:fe.identifier.value,name:fe.name,extensionVersion:fe.version,publisherDisplayName:fe.publisher,activationEvents:fe.activationEvents?fe.activationEvents.join(","):null,isBuiltin:fe.isBuiltin,reason:ie.activationEvent,reasonId:ie.extensionId.value}}e.IExtHostExtensionService=(0,i.createDecorator)("IExtHostExtensionService");class F{constructor(ie,Ee,be,ee,ve){M.set(this,void 0),N.set(this,void 0),W.set(this,void 0),Ye(this,M,ie,"f"),Ye(this,N,Ee,"f"),Ye(this,W,be.identifier,"f"),this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=C.normalize((0,U.originalFSPath)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=ee,this.isFromDifferentExtensionHost=ve}get isActive(){return Ae(this,M,"f").isActivated(Ae(this,W,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ae(this,M,"f").getExtensionExports(Ae(this,W,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ae(this,M,"f").activateByIdWithErrors(Ae(this,W,"f"),{startup:!1,extensionId:Ae(this,N,"f"),activationEvent:"api"}),this.exports}}e.Extension=F,M=new WeakMap,N=new WeakMap,W=new WeakMap;function oe(fe,ie){return fe.getAllExtensionDescriptions().filter(Ee=>ie.has(y.ExtensionIdentifier.toKey(Ee.identifier)))}function ce(fe){const ie=fe.indexOf("+");return ie===-1?fe:fe.substring(0,ie)}class ae{constructor(ie){this._searchTree=ie}setSearchTree(ie){this._searchTree=ie}findSubstr(ie){return this._searchTree.findSubstr(ie)}forEach(ie){return this._searchTree.forEach(ie)}}e.ExtensionPaths=ae}),define(De[227],Ie([1,0,73,2,4,32,26,25,16,28,3,33,61,14,10]),function(J,e,s,C,p,U,T,P,b,A,O,w,g,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let c=class{constructor(_,r,d,i,o,n,t){this._apiFactory=_,this._extensionRegistry=r,this._instaService=d,this._extHostConfiguration=i,this._extHostExtensionService=o,this._initData=n,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),s.mark("code/extHost/willWaitForConfig");const _=await this._extHostConfiguration.getConfigProvider();s.mark("code/extHost/didWaitForConfig");const r=await this._extHostExtensionService.getExtensionPathIndex();this.register(new u(this._apiFactory,r,this._extensionRegistry,_,this._logService)),this.register(this._instaService.createInstance(D,r)),this.register(this._instaService.createInstance(h)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(y,r,this._initData.environment.appUriScheme))}register(_){if("nodeModuleName"in _)if(Array.isArray(_.nodeModuleName))for(let r of _.nodeModuleName)this._factories.set(r,_);else this._factories.set(_.nodeModuleName,_);typeof _.alternativeModuleName=="function"&&this._alternatives.push(r=>_.alternativeModuleName(r))}};c=$e([xe(2,O.IInstantiationService),xe(3,U.IExtHostConfiguration),xe(4,w.IExtHostExtensionService),xe(5,A.IExtHostInitDataService),xe(6,S.ILogService)],c),e.RequireInterceptor=c;let h=class Ki{constructor(_){if(_.environment.appRoot&&Ki.aliased.size){const r=(0,f.escapeRegExpCharacters)(this.forceForwardSlashes(_.environment.appRoot.fsPath)),d="[a-z0-9_.-]",i=`@${d}+\\/${d}+|${d}+`,o="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${r}/${o}\\/)(${i})(.*)$`,"i")}}alternativeModuleName(_){if(!this.re)return;const r=this.re.exec(this.forceForwardSlashes(_));if(!r)return;const[,d,i,o]=r,n=Ki.aliased.get(i);if(n!==void 0)return console.warn(`${i} as been renamed to ${n}, please update your imports`),d+n+o}forceForwardSlashes(_){return _.replace(/\\/g,"/")}};h.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),h=$e([xe(0,A.IExtHostInitDataService)],h);class u{constructor(_,r,d,i,o){this._apiFactory=_,this._extensionPaths=r,this._extensionRegistry=d,this._configProvider=i,this._logService=o,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(_,r){const d=this._extensionPaths.findSubstr(r);if(d){let i=this._extApiImpl.get(P.ExtensionIdentifier.toKey(d.identifier));return i||(i=this._apiFactory(d,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(d.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((o,n)=>i+=`	${n} -> ${o.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(T.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let D=class{constructor(_,r,d){this._extensionPaths=_,this.nodeModuleName="keytar",this._mainThreadTelemetry=r.getProxy(p.MainContext.MainThreadTelemetry);const{environment:i}=d,o=r.getProxy(p.MainContext.MainThreadKeytar);if(i.appRoot){let n=i.appRoot.fsPath;g.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,t)=>o.$getPassword(n,t),setPassword:(n,t,l)=>o.$setPassword(n,t,l),deletePassword:(n,t)=>o.$deletePassword(n,t),findPassword:n=>o.$findPassword(n),findCredentials(n){return o.$findCredentials(n)}}}load(_,r){const d=this._extensionPaths.findSubstr(r);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:d?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(_){const r=_.length;if(r<=7||!this.alternativeNames)return;const d=r-7;if((_.charAt(d)==="/"||_.charAt(d)==="\\")&&_.endsWith("keytar")&&(_=_.replace(/\\/g,"/"),this.alternativeNames.has(_)))return"keytar"}};D=$e([xe(1,b.IExtHostRpcService),xe(2,A.IExtHostInitDataService)],D);let y=class{constructor(_,r,d){this._extensionPaths=_,this._appUriScheme=r,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=d.getProxy(p.MainContext.MainThreadTelemetry);const i=d.getProxy(p.MainContext.MainThreadWindow);this._impl=(o,n)=>{const t=C.URI.parse(o);return n?this.callOriginal(o,n):t.scheme==="http"||t.scheme==="https"?i.$openUri(t,o,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?i.$openUri(t,o,{}):this.callOriginal(o,n)}}load(_,r,d){const i=this._extensionPaths.findSubstr(r);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=d(_),this._impl}callOriginal(_,r){return this.sendNoForwardTelemetry(),this._original(_,r)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};y=$e([xe(2,b.IExtHostRpcService)],y)}),define(De[101],Ie([1,0,194,7,19,61,3,50,51,33,6,31,170,32]),function(J,e,s,C,p,U,T,P,b,A,O,w,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,T.createDecorator)("IExtHostVariableResolverProvider");class f extends g.AbstractVariableResolverService{constructor(u,D,y,a,_,r,d){function i(){if(y){const o=y.activeEditor();if(o)return o.document.uri;const n=a.tabGroups.all.find(t=>t.isActive)?.activeTab;if(n!==void 0){if(n.input instanceof O.TextDiffTabInput||n.input instanceof O.NotebookDiffEditorTabInput)return n.input.modified;if(n.input instanceof O.TextTabInput||n.input instanceof O.NotebookEditorTabInput||n.input instanceof O.CustomEditorTabInput)return n.input.uri}}}super({getFolderUri:o=>{const n=r.folders.filter(t=>t.name===o);if(n&&n.length>0)return n[0].uri},getWorkspaceFolderCount:()=>r.folders.length,getConfigurationValue:(o,n)=>_.getConfiguration(void 0,o).get(n),getAppRoot:()=>U.cwd(),getExecPath:()=>U.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=i();if(o)return p.normalize(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(D){const o=i();if(o){const n=D.getWorkspaceFolder(o);if(n)return p.normalize(n.uri.fsPath)}}},getSelectedText:()=>{if(y){const o=y.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(y){const o=y.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>u.getExtension(o)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(U.env))}}let c=class extends C.Disposable{constructor(u,D,y,a,_){super();this.extensionService=u,this.workspaceService=D,this.editorService=y,this.configurationService=a,this.editorTabs=_,this._resolver=new s.Lazy(async()=>{const r=await this.configurationService.getConfigProvider(),i={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async o=>{i.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new f(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,r,i,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};c=$e([xe(0,A.IExtHostExtensionService),xe(1,w.IExtHostWorkspace),xe(2,P.IExtHostDocumentsAndEditors),xe(3,S.IExtHostConfiguration),xe(4,b.IExtHostEditorTabs)],c),e.ExtHostVariableResolverProviderService=c}),define(De[102],Ie([1,0,13,5,9,2,3,4,51,33,16,6,31,164,166,32,101]),function(J,e,s,C,p,U,T,P,b,A,O,w,g,S,f,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,T.createDecorator)("IExtHostDebugService");let u=class{constructor(i,o,n,t,l,v){this._workspaceService=o,this._extensionService=n,this._configurationService=t,this._editorTabs=l,this._variableResolver=v,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new C.Emitter,this._onDidTerminateDebugSession=new C.Emitter,this._onDidChangeActiveDebugSession=new C.Emitter,this._onDidReceiveDebugSessionCustomEvent=new C.Emitter,this._debugServiceProxy=i.getProxy(P.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new C.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new y(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(m=>{m.onDidChange(I=>{this.registerAllDebugTypes(m)}),this.registerAllDebugTypes(m)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(i,o){const n=i;if(typeof n.sourceReference=="number"&&n.sourceReference>0){let t=`debug:${encodeURIComponent(n.path||"")}`,l="?";return o&&(t+=`${l}session=${encodeURIComponent(o.id)}`,l="&"),t+=`${l}ref=${n.sourceReference}`,U.URI.parse(t)}else{if(n.path)return U.URI.file(n.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(i){const o=[];for(const n of i.getAllExtensionDescriptions())if(n.contributes){const t=n.contributes.debuggers;if(t&&t.length>0)for(const l of t)(0,f.isDebuggerMainContribution)(l)&&o.push(l.type)}this._debugServiceProxy.$registerDebugTypes(o)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const i=[];return this._breakpoints.forEach(o=>i.push(o)),i}addBreakpoints(i){this.startBreakpoints();const o=i.filter(l=>{const v=l.id;return this._breakpoints.has(v)?!1:(this._breakpoints.set(v,l),!0)});this.fireBreakpointChanges(o,[],[]);const n=[],t=new Map;for(const l of o)if(l instanceof w.SourceBreakpoint){let v=t.get(l.location.uri.toString());v||(v={type:"sourceMulti",uri:l.location.uri,lines:[]},t.set(l.location.uri.toString(),v),n.push(v)),v.lines.push({id:l.id,enabled:l.enabled,condition:l.condition,hitCondition:l.hitCondition,logMessage:l.logMessage,line:l.location.range.start.line,character:l.location.range.start.character})}else l instanceof w.FunctionBreakpoint&&n.push({type:"function",id:l.id,enabled:l.enabled,hitCondition:l.hitCondition,logMessage:l.logMessage,condition:l.condition,functionName:l.functionName});return this._debugServiceProxy.$registerBreakpoints(n)}removeBreakpoints(i){this.startBreakpoints();const o=i.filter(v=>this._breakpoints.delete(v.id));this.fireBreakpointChanges([],o,[]);const n=o.filter(v=>v instanceof w.SourceBreakpoint).map(v=>v.id),t=o.filter(v=>v instanceof w.FunctionBreakpoint).map(v=>v.id),l=o.filter(v=>v instanceof w.DataBreakpoint).map(v=>v.id);return this._debugServiceProxy.$unregisterBreakpoints(n,t,l)}startDebugging(i,o,n){return this._debugServiceProxy.$startDebugging(i?i.uri:void 0,o,{parentSessionID:n.parentSession?n.parentSession.id:void 0,lifecycleManagedByParent:n.lifecycleManagedByParent,repl:n.consoleMode===w.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:n.noDebug,compact:n.compact,debugUI:n.debugUI,suppressSaveBeforeStart:n.suppressSaveBeforeStart})}stopDebugging(i){return this._debugServiceProxy.$stopDebugging(i?i.id:void 0)}registerDebugConfigurationProvider(i,o,n){if(!o)return new w.Disposable(()=>{});const t=this._configProviderHandleCounter++;return this._configProviders.push({type:i,handle:t,provider:o}),this._debugServiceProxy.$registerDebugConfigurationProvider(i,n,!!o.provideDebugConfigurations,!!o.resolveDebugConfiguration,!!o.resolveDebugConfigurationWithSubstitutedVariables,t),new w.Disposable(()=>{this._configProviders=this._configProviders.filter(l=>l.provider!==o),this._debugServiceProxy.$unregisterDebugConfigurationProvider(t)})}registerDebugAdapterDescriptorFactory(i,o,n){if(!n)return new w.Disposable(()=>{});if(!this.definesDebugType(i,o))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${o}' debugger.`);if(this.getAdapterDescriptorFactoryByType(o))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const t=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:o,handle:t,factory:n}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(o,t),new w.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(l=>l.factory!==n),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(t)})}registerDebugAdapterTrackerFactory(i,o){if(!o)return new w.Disposable(()=>{});const n=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:i,handle:n,factory:o}),new w.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(t=>t.factory!==o)})}async $runInTerminal(i,o){return Promise.resolve(void 0)}async $substituteVariables(i,o){let n;const t=await this.getFolder(i);return t&&(n={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(n,o)}createDebugAdapter(i,o){if(i.type==="implementation")return new _(i.implementation)}createSignService(){}async $startDASession(i,o){const n=this,t=await this.getSession(o);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(t.type),t).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}' (extension might have failed to activate)`);const v=this.convertToDto(l),m=this.createDebugAdapter(v,t);if(!m)throw new Error(`Couldn't create a debug adapter for type '${t.type}'.`);const I=m;return this._debugAdapters.set(i,I),this.getDebugAdapterTrackers(t).then(B=>(B&&this._debugAdaptersTrackers.set(i,B),I.onMessage(async x=>{if(x.type==="request"&&x.command==="handshake"){const R=x,E={type:"response",seq:0,command:R.command,request_seq:R.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const M=await this._signService.sign(R.arguments.value);E.body={signature:M},I.sendResponse(E)}else throw new Error("no signer")}catch(M){E.success=!1,E.message=M.message,I.sendResponse(E)}}else B&&B.onDidSendMessage&&B.onDidSendMessage(x),x=(0,f.convertToVSCPaths)(x,!0),n._debugServiceProxy.$acceptDAMessage(i,x)}),I.onError(x=>{B&&B.onError&&B.onError(x),this._debugServiceProxy.$acceptDAError(i,x.name,x.message,x.stack)}),I.onExit(x=>{B&&B.onExit&&B.onExit((0,p.withNullAsUndefined)(x),void 0),this._debugServiceProxy.$acceptDAExit(i,(0,p.withNullAsUndefined)(x),void 0)}),B&&B.onWillStartSession&&B.onWillStartSession(),I.startSession()))})}$sendDAMessage(i,o){o=(0,f.convertToDAPaths)(o,!1);const n=this._debugAdaptersTrackers.get(i);n&&n.onWillReceiveMessage&&n.onWillReceiveMessage(o);const t=this._debugAdapters.get(i);t&&t.sendMessage(o)}$stopDASession(i){const o=this._debugAdaptersTrackers.get(i);this._debugAdaptersTrackers.delete(i),o&&o.onWillStopSession&&o.onWillStopSession();const n=this._debugAdapters.get(i);return this._debugAdapters.delete(i),n?n.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(i){const o=[],n=[],t=[];if(i.added)for(const l of i.added){const v=l.id;if(v&&!this._breakpoints.has(v)){let m;if(l.type==="function")m=new w.FunctionBreakpoint(l.functionName,l.enabled,l.condition,l.hitCondition,l.logMessage);else if(l.type==="data")m=new w.DataBreakpoint(l.label,l.dataId,l.canPersist,l.enabled,l.hitCondition,l.condition,l.logMessage);else{const I=U.URI.revive(l.uri);m=new w.SourceBreakpoint(new w.Location(I,new w.Position(l.line,l.character)),l.enabled,l.condition,l.hitCondition,l.logMessage)}m._id=v,this._breakpoints.set(v,m),o.push(m)}}if(i.removed)for(const l of i.removed){const v=this._breakpoints.get(l);v&&(this._breakpoints.delete(l),n.push(v))}if(i.changed){for(const l of i.changed)if(l.id){const v=this._breakpoints.get(l.id);if(v){if(v instanceof w.FunctionBreakpoint&&l.type==="function"){const m=v;m.enabled=l.enabled,m.condition=l.condition,m.hitCondition=l.hitCondition,m.logMessage=l.logMessage,m.functionName=l.functionName}else if(v instanceof w.SourceBreakpoint&&l.type==="source"){const m=v;m.enabled=l.enabled,m.condition=l.condition,m.hitCondition=l.hitCondition,m.logMessage=l.logMessage,m.location=new w.Location(U.URI.revive(l.uri),new w.Position(l.line,l.character))}t.push(v)}}}this.fireBreakpointChanges(o,n,t)}$provideDebugConfigurations(i,o,n){return(0,s.asPromise)(async()=>{const t=this.getConfigProviderByHandle(i);if(!t)throw new Error("no DebugConfigurationProvider found");if(!t.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const l=await this.getFolder(o);return t.provideDebugConfigurations(l,n)}).then(t=>{if(!t)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return t})}$resolveDebugConfiguration(i,o,n,t){return(0,s.asPromise)(async()=>{const l=this.getConfigProviderByHandle(i);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const v=await this.getFolder(o);return l.resolveDebugConfiguration(v,n,t)})}$resolveDebugConfigurationWithSubstitutedVariables(i,o,n,t){return(0,s.asPromise)(async()=>{const l=this.getConfigProviderByHandle(i);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const v=await this.getFolder(o);return l.resolveDebugConfigurationWithSubstitutedVariables(v,n,t)})}async $provideDebugAdapter(i,o){const n=this.getAdapterDescriptorFactoryByHandle(i);if(!n)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const t=await this.getSession(o);return this.getAdapterDescriptor(n,t).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}'`);return this.convertToDto(l)})}async $acceptDebugSessionStarted(i){const o=await this.getSession(i);this._onDidStartDebugSession.fire(o)}async $acceptDebugSessionTerminated(i){const o=await this.getSession(i);o&&(this._onDidTerminateDebugSession.fire(o),this._debugSessions.delete(o.id))}async $acceptDebugSessionActiveChanged(i){this._activeDebugSession=i?await this.getSession(i):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(i,o){const n=await this.getSession(i);n&&n._acceptNameChanged(o)}async $acceptDebugSessionCustomEvent(i,o){const t={session:await this.getSession(i),event:o.event,body:o.body};this._onDidReceiveDebugSessionCustomEvent.fire(t)}convertToDto(i){if(i instanceof w.DebugAdapterExecutable)return{type:"executable",command:i.command,args:i.args,options:i.options};if(i instanceof w.DebugAdapterServer)return{type:"server",port:i.port,host:i.host};if(i instanceof w.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:i.path};if(i instanceof w.DebugAdapterInlineImplementation)return{type:"implementation",implementation:i.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(i){const o=this._adapterFactories.filter(n=>n.type===i);if(o.length>0)return o[0].factory}getAdapterDescriptorFactoryByHandle(i){const o=this._adapterFactories.filter(n=>n.handle===i);if(o.length>0)return o[0].factory}getConfigProviderByHandle(i){const o=this._configProviders.filter(n=>n.handle===i);if(o.length>0)return o[0].provider}definesDebugType(i,o){if(i.contributes){const n=i.contributes.debuggers;if(n&&n.length>0){for(const t of n)if(t.label&&t.type&&t.type===o)return!0}}return!1}getDebugAdapterTrackers(i){const n=i.configuration.type,t=this._trackerFactories.filter(l=>l.type===n||l.type==="*").map(l=>(0,s.asPromise)(()=>l.factory.createDebugAdapterTracker(i)).then(v=>v,v=>null));return Promise.race([Promise.all(t).then(l=>{const v=l.filter(m=>!!m);if(v.length>0)return new a(v)}),new Promise((l,v)=>{const m=setTimeout(()=>{clearTimeout(m),v(new Error("timeout"))},1e3)})]).catch(l=>{})}async getAdapterDescriptor(i,o){const n=o.configuration.debugServer;if(typeof n=="number")return Promise.resolve(new w.DebugAdapterServer(n));if(i){const l=await this._extensionService.getExtensionRegistry();return(0,s.asPromise)(()=>i.createDebugAdapterDescriptor(o,this.daExecutableFromPackage(o,l))).then(v=>{if(v)return v})}const t=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(o,t))}daExecutableFromPackage(i,o){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(i,o,n){(i.length>0||o.length>0||n.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:i,removed:o,changed:n}))}async getSession(i){if(i)if(typeof i=="string"){const o=this._debugSessions.get(i);if(o)return o}else{let o=this._debugSessions.get(i.id);if(!o){const n=await this.getFolder(i.folderUri),t=i.parent?this._debugSessions.get(i.parent):void 0;o=new D(this._debugServiceProxy,i.id,i.type,i.name,n,i.configuration,t),this._debugSessions.set(o.id,o),this._debugServiceProxy.$sessionCached(o.id)}return o}throw new Error("cannot find session")}getFolder(i){if(i){const o=U.URI.revive(i);return this._workspaceService.resolveWorkspaceFolder(o)}return Promise.resolve(void 0)}};u=$e([xe(0,O.IExtHostRpcService),xe(1,g.IExtHostWorkspace),xe(2,A.IExtHostExtensionService),xe(3,c.IExtHostConfiguration),xe(4,b.IExtHostEditorTabs),xe(5,h.IExtHostVariableResolverProvider)],u),e.ExtHostDebugServiceBase=u;class D{constructor(i,o,n,t,l,v,m){this._debugServiceProxy=i,this._id=o,this._type=n,this._name=t,this._workspaceFolder=l,this._configuration=v,this._parentSession=m}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(i){this._name=i,this._debugServiceProxy.$setDebugSessionName(this._id,i)}get parentSession(){return this._parentSession}_acceptNameChanged(i){this._name=i}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(i,o){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,i,o)}getDebugProtocolBreakpoint(i){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,i.id)}}e.ExtHostDebugSession=D;class y{constructor(i){this.value=Object.freeze({append(o){i.$appendDebugConsole(o)},appendLine(o){this.append(o+`
`)}})}}e.ExtHostDebugConsole=y;class a{constructor(i){this.trackers=i}onWillStartSession(){this.trackers.forEach(i=>i.onWillStartSession?i.onWillStartSession():void 0)}onWillReceiveMessage(i){this.trackers.forEach(o=>o.onWillReceiveMessage?o.onWillReceiveMessage(i):void 0)}onDidSendMessage(i){this.trackers.forEach(o=>o.onDidSendMessage?o.onDidSendMessage(i):void 0)}onWillStopSession(){this.trackers.forEach(i=>i.onWillStopSession?i.onWillStopSession():void 0)}onError(i){this.trackers.forEach(o=>o.onError?o.onError(i):void 0)}onExit(i,o){this.trackers.forEach(n=>n.onExit?n.onExit(i,o):void 0)}}class _ extends S.AbstractDebugAdapter{constructor(i){super();this.implementation=i,i.onDidSendMessage(o=>{this.acceptMessage(o)})}startSession(){return Promise.resolve(void 0)}sendMessage(i){this.implementation.handleMessage(i)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends u{constructor(i,o,n,t,l,v){super(i,o,n,t,l,v)}};r=$e([xe(0,O.IExtHostRpcService),xe(1,g.IExtHostWorkspace),xe(2,A.IExtHostExtensionService),xe(3,c.IExtHostConfiguration),xe(4,b.IExtHostEditorTabs),xe(5,h.IExtHostVariableResolverProvider)],r),e.WorkerExtHostDebugService=r}),define(De[228],Ie([1,0,11,73,2,4,219,14,58,60,28,147,16,65,33]),function(J,e,s,C,p,U,T,P,b,A,O,w,g,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class c{constructor(u,D,y,a,_){this._hostUtils=y,this._rpcProtocol=new T.RPCProtocol(u,null,a),D=c._transform(D,this._rpcProtocol);const r=new A.ServiceCollection(...(0,b.getSingletonServiceDescriptors)());r.set(O.IExtHostInitDataService,{_serviceBrand:void 0,...D,messagePorts:_}),r.set(g.IExtHostRpcService,new g.ExtHostRpcService(this._rpcProtocol)),r.set(S.IURITransformerService,new S.URITransformerService(a)),r.set(f.IHostUtils,y);const d=new w.InstantiationService(r,!0);this._logService=d.invokeFunction(t=>t.get(P.ILogService)),C.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",D),this._extensionService=d.invokeFunction(t=>t.get(f.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const i=new WeakMap;this._extensionService.getExtensionPathIndex().then(t=>{Error.prepareStackTrace=(l,v)=>{let m="",I,B;for(const x of v)m+=`
	at ${x.toString()}`,B=x.getFileName(),!I&&B&&(I=t.findSubstr(p.URI.file(B)));return i.set(l,I),`${l.name||"Error"}: ${l.message||""}${m}`}});const o=this._rpcProtocol.getProxy(U.MainContext.MainThreadExtensionService),n=this._rpcProtocol.getProxy(U.MainContext.MainThreadErrors);s.setUnexpectedErrorHandler(t=>{const l=s.transformErrorForSerialization(t),v=i.get(t);v?o.$onExtensionRuntimeError(v.identifier,l):n.$onUnexpectedError(l)})}async asBrowserUri(u){const D=this._rpcProtocol.getProxy(U.MainContext.MainThreadExtensionService);return p.URI.revive(await D.$asBrowserUri(u))}terminate(u){this._extensionService.terminate(u)}static _transform(u,D){u.allExtensions.forEach(a=>a.extensionLocation=p.URI.revive(D.transformIncomingURIs(a.extensionLocation))),u.environment.appRoot=p.URI.revive(D.transformIncomingURIs(u.environment.appRoot));const y=u.environment.extensionDevelopmentLocationURI;return y&&(u.environment.extensionDevelopmentLocationURI=y.map(a=>p.URI.revive(D.transformIncomingURIs(a)))),u.environment.extensionTestsLocationURI=p.URI.revive(D.transformIncomingURIs(u.environment.extensionTestsLocationURI)),u.environment.globalStorageHome=p.URI.revive(D.transformIncomingURIs(u.environment.globalStorageHome)),u.environment.workspaceStorageHome=p.URI.revive(D.transformIncomingURIs(u.environment.workspaceStorageHome)),u.logsLocation=p.URI.revive(D.transformIncomingURIs(u.logsLocation)),u.logFile=p.URI.revive(D.transformIncomingURIs(u.logFile)),u.workspace=D.transformIncomingURIs(u.workspace),u}}e.ExtensionHostMain=c}),define(De[229],Ie([1,0,15,13,20,45,12,19,21,9,2,41]),function(J,e,s,C,p,U,T,P,b,A,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class g{constructor(y,a,_,r){this.query=y,this.provider=a,this.fileUtils=_,this.processType=r,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(y,a){const _=this.query.folderQueries||[],r=new p.CancellationTokenSource;return a.onCancellationRequested(()=>r.cancel()),new Promise((d,i)=>{this.collector=new f(y);let o=!1;const n=(t,l)=>{if(!o&&!this.isLimitHit){const v=this.resultSize(t);h(t)&&typeof this.query.maxResults=="number"&&this.resultCount+v>this.query.maxResults&&(this.isLimitHit=!0,o=!0,r.cancel(),t=this.trimResultToSize(t,this.query.maxResults-this.resultCount));const m=this.resultSize(t);this.resultCount+=m,(m>0||!h(t))&&this.collector.add(t,l)}};Promise.all(_.map((t,l)=>this.searchInFolder(t,v=>n(v,l),r.token))).then(t=>{r.dispose(),this.collector.flush();const l=t.some(v=>!!v&&!!v.limitHit);d({limitHit:this.isLimitHit||l,messages:(0,s.flatten)(t.map(v=>v?.message?(0,A.isArray)(v.message)?v.message:[v.message]:[])),stats:{type:this.processType}})},t=>{r.dispose();const l=(0,U.toErrorMessage)(t);i(new Error(l))})})}resultSize(y){return h(y)?Array.isArray(y.ranges)?y.ranges.length:1:0}trimResultToSize(y,a){const _=Array.isArray(y.ranges)?y.ranges:[y.ranges],r=Array.isArray(y.preview.matches)?y.preview.matches:[y.preview.matches];return{ranges:_.slice(0,a),preview:{matches:r.slice(0,a),text:y.preview.text},uri:y.uri}}async searchInFolder(y,a,_){const r=new w.QueryGlobTester(this.query,y),d=[],i={report:t=>{if(!this.validateProviderResult(t))return;const l=y.folder.scheme===T.Schemas.file?(0,w.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(b.dirname(t.uri))):void 0,v=b.relativePath(y.folder,t.uri);if(v){const m=r.includedInQuery(v,P.basename(v),l);(0,C.isThenable)(m)?d.push(m.then(I=>{I&&a(t)})):m&&a(t)}}},o=this.getSearchOptionsForFolder(y),n=await this.provider.provideTextSearchResults(S(this.query.contentPattern),o,i,_);return d.length&&await Promise.all(d),n}validateProviderResult(y){if(h(y)){if(Array.isArray(y.ranges)){if(!Array.isArray(y.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(y.preview.matches.length!==y.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(y.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(y){const a=(0,w.resolvePatternsForProvider)(this.query.includePattern,y.includePattern),_=(0,w.resolvePatternsForProvider)(this.query.excludePattern,y.excludePattern),r={folder:O.URI.from(y.folder),excludes:_,includes:a,useIgnoreFiles:!y.disregardIgnoreFiles,useGlobalIgnoreFiles:!y.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!y.disregardParentIgnoreFiles,followSymlinks:!y.ignoreSymlinks,encoding:y.fileEncoding&&this.fileUtils.toCanonicalName(y.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return r.usePCRE2=this.query.usePCRE2,r}}e.TextSearchManager=g;function S(D){return{isCaseSensitive:D.isCaseSensitive||!1,isRegExp:D.isRegExp||!1,isWordMatch:D.isWordMatch||!1,isMultiline:D.isMultiline||!1,pattern:D.pattern}}class f{constructor(y){this._onResult=y,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new u(512,a=>this.sendItems(a))}add(y,a){this._currentFileMatch&&(this._currentFolderIdx!==a||!b.isEqual(this._currentUri,y.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=a,this._currentFileMatch={resource:y.uri,results:[]}),this._currentFileMatch.results.push(c(y))}pushToCollector(){const y=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,y)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(y){this._onResult(y)}}e.TextSearchResultsCollector=f;function c(D){return h(D)?{preview:{matches:(0,s.mapArrayOrNot)(D.preview.matches,y=>({startLineNumber:y.start.line,startColumn:y.start.character,endLineNumber:y.end.line,endColumn:y.end.character})),text:D.preview.text},ranges:(0,s.mapArrayOrNot)(D.ranges,y=>({startLineNumber:y.start.line,startColumn:y.start.character,endLineNumber:y.end.line,endColumn:y.end.character}))}:{text:D.text,lineNumber:D.lineNumber}}function h(D){return!!D.preview}e.extensionResultIsMatch=h;class u{constructor(y,a){this.maxBatchSize=y,this.cb=a,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(y,a){!y||this.addItemToBatch(y,a)}addItems(y,a){!y||this.addItemsToBatch(y,a)}addItemToBatch(y,a){this.batch.push(y),this.batchSize+=a,this.onUpdate()}addItemsToBatch(y,a){this.batch=this.batch.concat(y),this.batchSize+=a,this.onUpdate()}onUpdate(){this.totalNumberCompleted<u.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},u.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=u,u.TIMEOUT=4e3,u.START_BATCH_AFTER_COUNT=50}),define(De[103],Ie([1,0,7,4,3,224,16,65,14,2,229]),function(J,e,s,C,p,U,T,P,b,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,p.createDecorator)("IExtHostSearch");let w=class{constructor(c,h,u){this.extHostRpc=c,this._uriTransformer=h,this._logService=u,this._proxy=this.extHostRpc.getProxy(C.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new U.FileSearchManager}_transformScheme(c){return this._uriTransformer.transformOutgoingScheme(c)}registerTextSearchProvider(c,h){if(this._textSearchUsedSchemes.has(c))throw new Error(`a text search provider for the scheme '${c}' is already registered`);this._textSearchUsedSchemes.add(c);const u=this._handlePool++;return this._textSearchProvider.set(u,h),this._proxy.$registerTextSearchProvider(u,this._transformScheme(c)),(0,s.toDisposable)(()=>{this._textSearchUsedSchemes.delete(c),this._textSearchProvider.delete(u),this._proxy.$unregisterProvider(u)})}registerFileSearchProvider(c,h){if(this._fileSearchUsedSchemes.has(c))throw new Error(`a file search provider for the scheme '${c}' is already registered`);this._fileSearchUsedSchemes.add(c);const u=this._handlePool++;return this._fileSearchProvider.set(u,h),this._proxy.$registerFileSearchProvider(u,this._transformScheme(c)),(0,s.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(c),this._fileSearchProvider.delete(u),this._proxy.$unregisterProvider(u)})}$provideFileSearchResults(c,h,u,D){const y=g(u),a=this._fileSearchProvider.get(c);if(a)return this._fileSearchManager.fileSearch(y,a,_=>{this._proxy.$handleFileMatch(c,h,_.map(r=>r.resource))},D);throw new Error("unknown provider: "+c)}$clearCache(c){return this._fileSearchManager.clearCache(c),Promise.resolve(void 0)}$provideTextSearchResults(c,h,u,D){const y=this._textSearchProvider.get(c);if(!y||!y.provideTextSearchResults)throw new Error(`Unknown provider ${c}`);const a=g(u);return this.createTextSearchManager(a,y).search(r=>this._proxy.$handleTextMatch(c,h,r),D)}$enableExtensionHostSearch(){}createTextSearchManager(c,h){return new O.TextSearchManager(c,h,{readdir:u=>Promise.resolve([]),toCanonicalName:u=>u},"textSearchProvider")}};w=$e([xe(0,T.IExtHostRpcService),xe(1,P.IURITransformerService),xe(2,b.ILogService)],w),e.ExtHostSearch=w;function g(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(S),extraFileResources:f.extraFileResources&&f.extraFileResources.map(c=>A.URI.revive(c))}}e.reviveQuery=g;function S(f){return{...f,folder:A.URI.revive(f.folder)}}}),define(De[230],Ie([1,0,58,98,31,95,32,36,50,53,100,102,103,71,64,70,97,52,35,69,86,51,202,14,179,101]),function(J,e,s,C,p,U,T,P,b,A,O,w,g,S,f,c,h,u,D,y,a,_,r,d,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,s.registerSingleton)(d.ILoggerService,r.ExtHostLoggerService),(0,s.registerSingleton)(d.ILogService,i.ExtHostLogService),(0,s.registerSingleton)(c.IExtHostApiDeprecationService,c.ExtHostApiDeprecationService),(0,s.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands),(0,s.registerSingleton)(T.IExtHostConfiguration,T.ExtHostConfiguration),(0,s.registerSingleton)(u.IExtHostConsumerFileSystem,u.ExtHostConsumerFileSystem),(0,s.registerSingleton)(w.IExtHostDebugService,w.WorkerExtHostDebugService),(0,s.registerSingleton)(U.IExtHostDecorations,U.ExtHostDecorations),(0,s.registerSingleton)(b.IExtHostDocumentsAndEditors,b.ExtHostDocumentsAndEditors),(0,s.registerSingleton)(D.IExtHostFileSystemInfo,D.ExtHostFileSystemInfo),(0,s.registerSingleton)(C.IExtHostOutputService,C.ExtHostOutputService),(0,s.registerSingleton)(g.IExtHostSearch,g.ExtHostSearch),(0,s.registerSingleton)(S.IExtHostStorage,S.ExtHostStorage),(0,s.registerSingleton)(O.IExtHostTask,O.WorkerExtHostTask),(0,s.registerSingleton)(A.IExtHostTerminalService,A.WorkerExtHostTerminalService),(0,s.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService),(0,s.registerSingleton)(h.IExtHostWindow,h.ExtHostWindow),(0,s.registerSingleton)(p.IExtHostWorkspace,p.ExtHostWorkspace),(0,s.registerSingleton)(y.IExtHostSecretState,y.ExtHostSecretState),(0,s.registerSingleton)(a.IExtHostTelemetry,a.ExtHostTelemetry),(0,s.registerSingleton)(_.IExtHostEditorTabs,_.ExtHostEditorTabs),(0,s.registerSingleton)(o.IExtHostVariableResolverProvider,o.ExtHostVariableResolverProviderService)}),define(De[231],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class s{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(p){if(p&&this._dragOperations.has(p)){const U=this._dragOperations.get(p);return this._dragOperations.delete(p),U}}addDragOperationTransfer(p,U){this._dragOperations.set(p,U)}getRenderedTreeElement(p){if(this._renderedElements.has(p))return this._renderedElements.get(p)}addRenderedTreeItemElement(p,U){this._renderedElements.set(p,U)}removeRenderedTreeItemElement(p){this._renderedElements.has(p)&&this._renderedElements.delete(p)}}e.TreeviewsService=s}),define(De[232],Ie([1,0,133,6,21,2,5,7,13,6,9,15,8,20,231,26]),function(J,e,s,C,p,U,T,P,b,A,O,w,g,S,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(y,a){if((0,O.isString)(y))return{label:y};if(y&&typeof y=="object"&&typeof y.label=="string"){let _;return Array.isArray(y.highlights)&&(_=y.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),_=_.length?_:void 0),{label:y.label,highlights:_}}}class u{constructor(a,_,r){this._proxy=a,this.commands=_,this.logService=r,this.treeViews=new Map,this.treeDragAndDropService=new f.TreeviewsService;function d(i){return i&&i.$treeViewId&&i.$treeItemHandle}_.registerArgumentProcessor({processArgument:i=>d(i)?this.convertArgument(i):Array.isArray(i)&&i.length>0?i.map(o=>d(o)?this.convertArgument(o):o):i})}registerTreeDataProvider(a,_,r){const d=this.createTreeView(a,{treeDataProvider:_},r);return{dispose:()=>d.dispose()}}createTreeView(a,_,r){if(!_||!_.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=_.dragAndDropController?.dropMimeTypes??[],i=_.dragAndDropController?.dragMimeTypes??[],o=!!_.dragAndDropController?.handleDrag,n=!!_.dragAndDropController?.handleDrop,t=(0,c.isProposedApiEnabled)(r,"dataTransferFiles"),l=this._proxy.$registerTreeViewDataProvider(a,{showCollapseAll:!!_.showCollapseAll,canSelectMany:!!_.canSelectMany,dropMimeTypes:d,dragMimeTypes:i,hasHandleDrag:o,hasHandleDrop:n,supportsFileDataTransfers:t}),v=this.createExtHostTreeView(a,_,r);return{get onDidCollapseElement(){return v.onDidCollapseElement},get onDidExpandElement(){return v.onDidExpandElement},get selection(){return v.selectedElements},get onDidChangeSelection(){return v.onDidChangeSelection},get visible(){return v.visible},get onDidChangeVisibility(){return v.onDidChangeVisibility},get message(){return v.message},set message(m){v.message=m},get title(){return v.title},set title(m){v.title=m},get description(){return v.description},set description(m){v.description=m},get badge(){return(0,c.checkProposedApiEnabled)(r,"badges"),v.badge},set badge(m){(0,c.checkProposedApiEnabled)(r,"badges"),v.badge=m},reveal:(m,I)=>v.reveal(m,I),dispose:async()=>{await l,this.treeViews.delete(a),v.dispose()}}}$getChildren(a,_){const r=this.treeViews.get(a);return r?r.getChildren(_):Promise.reject(new Error((0,s.localize)(0,null,a)))}async $handleDrop(a,_,r,d,i,o,n,t){const l=this.treeViews.get(a);if(!l)return Promise.reject(new Error((0,s.localize)(1,null,a)));const v=g.DataTransfer.toDataTransfer(r,async m=>(await this._proxy.$resolveDropFileData(a,_,m)).buffer);return n===a&&t&&await this.addAdditionalTransferItems(v,l,t,i,o),l.onDrop(v,d,i)}async addAdditionalTransferItems(a,_,r,d,i){const o=this.treeDragAndDropService.removeDragOperationTransfer(i);if(o)(await o)?.forEach((n,t)=>{n&&a.set(t,n)});else if(i&&_.handleDrag){const n=_.handleDrag(r,a,d);this.treeDragAndDropService.addDragOperationTransfer(i,n),await n}return a}async $handleDrag(a,_,r,d){const i=this.treeViews.get(a);if(!i)return Promise.reject(new Error((0,s.localize)(2,null,a)));const o=await this.addAdditionalTransferItems(new C.DataTransfer,i,_,d,r);if(!!o)return g.DataTransfer.toDataTransferDTO(o)}async $hasResolve(a){const _=this.treeViews.get(a);if(!_)throw new Error((0,s.localize)(3,null,a));return _.hasResolve}$resolve(a,_,r){const d=this.treeViews.get(a);if(!d)throw new Error((0,s.localize)(4,null,a));return d.resolveTreeItem(_,r)}$setExpanded(a,_,r){const d=this.treeViews.get(a);if(!d)throw new Error((0,s.localize)(5,null,a));d.setExpanded(_,r)}$setSelection(a,_){const r=this.treeViews.get(a);if(!r)throw new Error((0,s.localize)(6,null,a));r.setSelection(_)}$setVisible(a,_){const r=this.treeViews.get(a);if(!r)throw new Error((0,s.localize)(7,null,a));r.setVisible(_)}createExtHostTreeView(a,_,r){const d=new D(a,_,this._proxy,this.commands.converter,this.logService,r);return this.treeViews.set(a,d),d}convertArgument(a){const _=this.treeViews.get(a.$treeViewId);return _?_.getExtensionElement(a.$treeItemHandle):null}}e.ExtHostTreeViews=u;class D extends P.Disposable{constructor(a,_,r,d,i,o){super();if(this.viewId=a,this.proxy=r,this.commands=d,this.logService=i,this.extension=o,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new S.CancellationTokenSource,o.contributes&&o.contributes.views)for(const l in o.contributes.views)for(const v of o.contributes.views[l])v.id===a&&(this._title=v.name);this.dataProvider=_.treeDataProvider,this.dndController=_.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(l=>this._onDidChangeData.fire({message:!1,element:l})));let n,t;this._register(T.Event.debounce(this._onDidChangeData.event,(l,v)=>(l||(l={message:!1,elements:[]}),v.element!==!1&&(n||(n=new Promise(m=>t=m),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(v.element)?l.elements.push(...v.element):l.elements.push(v.element)),v.message&&(l.message=!0),l),200,!0)(({message:l,elements:v})=>{v.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const m=t;return n=null,this.refresh(v).then(()=>m())})),l&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,O.isUndefinedOrNull)(a))}async getChildren(a){const _=a?this.getExtensionElement(a):void 0;if(a&&!_)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let r=this.getChildrenNodes(a);return r||(r=await this.fetchChildrenNodes(_)),r?r.map(d=>d.item):void 0}getExtensionElement(a){return this.elements.get(a)}reveal(a,_){_=_||{select:!0,focus:!1};const r=(0,O.isUndefinedOrNull)(_.select)?!0:_.select,d=(0,O.isUndefinedOrNull)(_.focus)?!1:_.focus,i=(0,O.isUndefinedOrNull)(_.expand)?!1:_.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(o=>this.resolveTreeNode(a,o[o.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:o.map(t=>t.item)},{select:r,focus:d,expand:i})),o=>this.logService.error(o)):this.proxy.$reveal(this.viewId,void 0,{select:r,focus:d,expand:i})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}get badge(){return this._badge}set badge(a){this._badge?.value===a?.value&&this._badge?.tooltip===a?.tooltip||(this._badge=g.ViewBadge.from(a),this.proxy.$setBadge(this.viewId,a))}setExpanded(a,_){const r=this.getExtensionElement(a);r&&(_?this._onDidExpandElement.fire(Object.freeze({element:r})):this._onDidCollapseElement.fire(Object.freeze({element:r})))}setSelection(a){(0,w.equals)(this._selectedHandles,a)||(this._selectedHandles=a,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(a,_,r){const d=[];for(const i of a){const o=this.getExtensionElement(i);o&&d.push(o)}if(!(!this.dndController?.handleDrag||d.length===0))return await this.dndController.handleDrag(d,_,r),_}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(a,_,r){const d=_?this.getExtensionElement(_):void 0;if(!(!d&&_||!this.dndController?.handleDrop))return(0,b.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(d,a,r):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,_){if(!this.dataProvider.resolveTreeItem)return;const r=this.elements.get(a);if(r){const d=this.nodes.get(r);if(d){const i=await this.dataProvider.resolveTreeItem(d.extensionItem,r,_)??d.extensionItem;return d.item.tooltip=this.getTooltip(i.tooltip),d.item.command=this.getCommand(d.disposableStore,i.command),d.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(_=>_?this.resolveUnknownParentChain(_).then(r=>this.resolveTreeNode(_,r[r.length-1]).then(d=>(r.push(d),r))):Promise.resolve([]))}resolveParent(a){const _=this.nodes.get(a);return _?Promise.resolve(_.parent?this.elements.get(_.parent.item.handle):void 0):(0,b.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,_){const r=this.nodes.get(a);return r?Promise.resolve(r):(0,b.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(d=>this.createHandle(a,d,_,!0)).then(d=>this.getChildren(_?_.item.handle:void 0).then(()=>{const i=this.getExtensionElement(d);if(i){const o=this.nodes.get(i);if(o)return Promise.resolve(o)}throw new Error(`Cannot resolve tree item for element ${d}`)}))}getChildrenNodes(a){if(a){let _;if(typeof a=="string"){const r=this.getExtensionElement(a);_=r?this.nodes.get(r):void 0}else _=a;return _&&_.children||void 0}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const _=new S.CancellationTokenSource(this._refreshCancellationSource.token);try{const r=a?this.nodes.get(a):void 0,d=await this.dataProvider.getChildren(a);if(_.token.isCancellationRequested)return;const i=await Promise.all((0,w.coalesce)(d||[]).map(async o=>{const n=await this.dataProvider.getTreeItem(o);return n&&!_.token.isCancellationRequested?this.createAndRegisterTreeNode(o,n,r):null}));return _.token.isCancellationRequested?void 0:(0,w.coalesce)(i)}finally{_.dispose()}}refresh(a){if(a.some(r=>!r))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new S.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const r=this.getHandlesToRefresh(a);if(r.length)return this.refreshHandles(r)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const _=new Set,r=a.map(i=>this.nodes.get(i));for(const i of r)if(i&&!_.has(i.item.handle)){let o=i;for(;o&&o.parent&&r.findIndex(n=>o&&o.parent&&n&&n.item.handle===o.parent.item.handle)===-1;){const n=this.elements.get(o.parent.item.handle);o=n?this.nodes.get(n):void 0}o&&!o.parent&&_.add(i.item.handle)}const d=[];return _.forEach(i=>{const o=this.elements.get(i);if(o){const n=this.nodes.get(o);n&&(!n.parent||!_.has(n.parent.item.handle))&&d.push(i)}}),d}refreshHandles(a){const _={};return Promise.all(a.map(r=>this.refreshNode(r).then(d=>{d&&(_[r]=d.item)}))).then(()=>Object.keys(_).length?this.proxy.$refresh(this.viewId,_):void 0)}refreshNode(a){const _=this.getExtensionElement(a);if(_){const r=this.nodes.get(_);if(r)return this.clearChildren(_),(0,b.asPromise)(()=>this.dataProvider.getTreeItem(_)).then(d=>{if(d){const i=this.createTreeNode(_,d,r.parent);return this.updateNodeCache(_,i,r,r.parent),r.dispose(),i}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,_,r){const d=this.createTreeNode(a,_,r);if(_.id&&this.elements.has(d.item.handle))throw new Error((0,s.localize)(8,null,_.id));return this.addNodeToCache(a,d),this.addNodeToParentCache(d,r),d}getTooltip(a){return A.MarkdownString.isMarkdownString(a)?g.MarkdownString.from(a):a}getCommand(a,_){return _?this.commands.toInternal(_,a):void 0}createTreeNode(a,_,r){const d=new P.DisposableStore,i=this.createHandle(a,_,r),o=this.getLightIconPath(_);return{item:{handle:i,parentHandle:r?r.item.handle:void 0,label:h(_.label,this.extension),description:_.description,resourceUri:_.resourceUri,tooltip:this.getTooltip(_.tooltip),command:this.getCommand(d,_.command),contextValue:_.contextValue,icon:o,iconDark:this.getDarkIconPath(_)||o,themeIcon:this.getThemeIcon(_),collapsibleState:(0,O.isUndefinedOrNull)(_.collapsibleState)?A.TreeItemCollapsibleState.None:_.collapsibleState,accessibilityInformation:_.accessibilityInformation},extensionItem:_,parent:r,children:void 0,disposableStore:d,dispose(){d.dispose()}}}getThemeIcon(a){return a.iconPath instanceof A.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:_,label:r,resourceUri:d},i,o){if(_)return`${D.ID_HANDLE_PREFIX}/${_}`;const n=h(r,this.extension),t=i?i.item.handle:D.LABEL_HANDLE_PREFIX;let l=n?n.label:d?(0,p.basename)(d):"";l=l.indexOf("/")!==-1?l.replace("/","//"):l;const v=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,m=this.getChildrenNodes(i)||[];let I,B=0;do{if(I=`${t}/${B}:${l}`,o||!this.elements.has(I)||v===I)break;B++}while(B<=m.length);return I}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof A.ThemeIcon))return typeof a.iconPath=="string"||U.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof A.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return U.URI.isUri(a)?a:U.URI.file(a)}addNodeToCache(a,_){this.elements.set(_.item.handle,a),this.nodes.set(a,_)}updateNodeCache(a,_,r,d){this.elements.delete(_.item.handle),this.nodes.delete(a),_.item.handle!==r.item.handle&&this.elements.delete(r.item.handle),this.addNodeToCache(a,_);const i=this.getChildrenNodes(d)||[],o=i.filter(n=>n.item.handle===r.item.handle)[0];o&&i.splice(i.indexOf(o),1,_)}addNodeToParentCache(a,_){_?(_.children||(_.children=[]),_.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const _=this.nodes.get(a);if(_){if(_.children)for(const r of _.children){const d=this.elements.get(r.item.handle);d&&this.clear(d)}_.children=void 0}}else this.clearAll()}clear(a){const _=this.nodes.get(a);if(_){if(_.children)for(const r of _.children){const d=this.elements.get(r.item.handle);d&&this.clear(d)}this.nodes.delete(a),this.elements.delete(_.item.handle),_.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}D.LABEL_HANDLE_PREFIX="0",D.ID_HANDLE_PREFIX="1"}),define(De[233],Ie([1,0,20,11,5,29,2,120,243,115,114,39,4,94,188,187,36,189,32,190,191,192,173,193,50,33,195,196,199,201,203,98,175,208,209,210,71,53,212,232,8,6,215,54,97,31,43,163,198,85,95,100,102,103,14,65,16,28,204,160,64,70,185,213,72,52,218,216,217,186,35,211,214,69,51,86,206,99,207,12,81,205,158,197,7,26,165]),function(J,e,s,C,p,U,T,P,b,A,O,w,g,S,f,c,h,u,D,y,a,_,r,d,i,o,n,t,l,v,m,I,B,x,R,E,M,N,W,Z,K,F,oe,ce,ae,fe,ie,Ee,be,ee,ve,Re,Fe,We,Xe,Te,Se,ke,se,le,G,X,k,z,H,V,re,de,Q,pe,ge,Ne,Be,Pe,Ke,q,Y,me,Le,ze,Ge,Ze,ot,Qe,et,qe,st){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function it(lt){const ct=lt.get(ke.IExtHostInitDataService),Pt=lt.get(ge.IExtHostFileSystemInfo),zt=lt.get(V.IExtHostConsumerFileSystem),It=lt.get(o.IExtHostExtensionService),mt=lt.get(fe.IExtHostWorkspace),Ft=lt.get(q.IExtHostTelemetry),$t=lt.get(D.IExtHostConfiguration),Dt=lt.get(Te.IURITransformerService),He=lt.get(Se.IExtHostRpcService),At=lt.get(M.IExtHostStorage),Lt=lt.get(H.IExtensionStoragePaths),Nt=lt.get(Xe.ILoggerService),pt=lt.get(Xe.ILogService),yt=lt.get(G.IExtHostTunnelService),Tt=lt.get(X.IExtHostApiDeprecationService),wt=lt.get(ae.IExtHostWindow),we=lt.get(Pe.IExtHostSecretState),Ce=lt.get(Ke.IExtHostEditorTabs);He.set(g.ExtHostContext.ExtHostFileSystemInfo,Pt),He.set(g.ExtHostContext.ExtHostLogLevelServiceShape,Nt),He.set(g.ExtHostContext.ExtHostWorkspace,mt),He.set(g.ExtHostContext.ExtHostConfiguration,$t),He.set(g.ExtHostContext.ExtHostExtensionService,It),He.set(g.ExtHostContext.ExtHostStorage,At),He.set(g.ExtHostContext.ExtHostTunnelService,yt),He.set(g.ExtHostContext.ExtHostWindow,wt),He.set(g.ExtHostContext.ExtHostSecretState,we),He.set(g.ExtHostContext.ExtHostTelemetry,Ft),He.set(g.ExtHostContext.ExtHostEditorTabs,Ce);const ue=He.set(g.ExtHostContext.ExtHostDecorations,lt.get(ve.IExtHostDecorations)),j=He.set(g.ExtHostContext.ExtHostDocumentsAndEditors,lt.get(i.IExtHostDocumentsAndEditors)),ye=He.set(g.ExtHostContext.ExtHostCommands,lt.get(h.IExtHostCommands)),Me=He.set(g.ExtHostContext.ExtHostTerminalService,lt.get(N.IExtHostTerminalService)),Je=He.set(g.ExtHostContext.ExtHostDebugService,lt.get(Fe.IExtHostDebugService)),Ve=He.set(g.ExtHostContext.ExtHostSearch,lt.get(We.IExtHostSearch)),ut=He.set(g.ExtHostContext.ExtHostTask,lt.get(Re.IExtHostTask)),ht=He.set(g.ExtHostContext.ExtHostOutputService,lt.get(I.IExtHostOutputService)),Et=He.set(g.ExtHostContext.ExtHostUrls,new oe.ExtHostUrls(He)),ft=He.set(g.ExtHostContext.ExtHostDocuments,new d.ExtHostDocuments(He,j)),Ct=He.set(g.ExtHostContext.ExtHostDocumentContentProviders,new _.ExtHostDocumentContentProvider(He,j,pt)),Rt=He.set(g.ExtHostContext.ExtHostDocumentSaveParticipant,new r.ExtHostDocumentSaveParticipant(pt,ft,He.getProxy(g.MainContext.MainThreadBulkEdits))),vt=He.set(g.ExtHostContext.ExtHostNotebook,new se.ExtHostNotebookController(He,ye,j,ft,Lt)),Wt=He.set(g.ExtHostContext.ExtHostNotebookDocuments,new ot.ExtHostNotebookDocuments(vt)),Jt=He.set(g.ExtHostContext.ExtHostNotebookEditors,new Ze.ExtHostNotebookEditors(pt,He,vt)),vi=He.set(g.ExtHostContext.ExtHostNotebookKernels,new Y.ExtHostNotebookKernels(He,ct,vt,ye,pt)),ui=He.set(g.ExtHostContext.ExtHostNotebookRenderers,new Le.ExtHostNotebookRenderers(He,vt)),_t=He.set(g.ExtHostContext.ExtHostEditors,new W.ExtHostEditors(He,j)),ri=He.set(g.ExtHostContext.ExtHostTreeViews,new Z.ExtHostTreeViews(He.getProxy(g.MainContext.MainThreadTreeViews),ye,pt)),di=He.set(g.ExtHostContext.ExtHostEditorInsets,new Ee.ExtHostEditorInsets(He.getProxy(g.MainContext.MainThreadEditorInsets),_t,ct.remote)),Xt=He.set(g.ExtHostContext.ExtHostDiagnostics,new y.ExtHostDiagnostics(He,pt,Pt)),Qt=He.set(g.ExtHostContext.ExtHostLanguages,new v.ExtHostLanguages(He,ft,ye.converter,Dt)),dt=He.set(g.ExtHostContext.ExtHostLanguageFeatures,new l.ExtHostLanguageFeatures(He,Dt,ft,ye,Xt,pt,Tt)),hi=He.set(g.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(He,dt)),xt=He.set(g.ExtHostContext.ExtHostFileSystemEventService,new t.ExtHostFileSystemEventService(He,pt,j)),jt=He.set(g.ExtHostContext.ExtHostQuickOpen,(0,x.createExtHostQuickOpen)(He,mt,ye)),Ei=He.set(g.ExtHostContext.ExtHostSCM,new R.ExtHostSCM(He,ye,pt)),Di=He.set(g.ExtHostContext.ExtHostComments,(0,u.createExtHostComments)(He,ye,ft)),si=He.set(g.ExtHostContext.ExtHostProgress,new B.ExtHostProgress(He.getProxy(g.MainContext.MainThreadProgress))),fi=He.set(g.ExtHostContext.ExtHosLabelService,new be.ExtHostLabelService(He)),oi=He.set(g.ExtHostContext.ExtHostTheming,new le.ExtHostTheming(He)),Yt=He.set(g.ExtHostContext.ExtHostAuthentication,new k.ExtHostAuthentication(He)),Ci=He.set(g.ExtHostContext.ExtHostTimeline,new z.ExtHostTimeline(He,ye)),Zt=He.set(g.ExtHostContext.ExtHostWebviews,new ce.ExtHostWebviews(He,ct.remote,mt,pt,Tt)),ei=He.set(g.ExtHostContext.ExtHostWebviewPanels,new Q.ExtHostWebviewPanels(He,Zt,mt)),Ii=He.set(g.ExtHostContext.ExtHostCustomEditors,new de.ExtHostCustomEditors(He,ft,Lt,Zt,ei)),Ti=He.set(g.ExtHostContext.ExtHostWebviewViews,new re.ExtHostWebviewViews(He,Zt)),ti=He.set(g.ExtHostContext.ExtHostTesting,new Ne.ExtHostTesting(He,ye)),ki=He.set(g.ExtHostContext.ExtHostUriOpeners,new Be.ExtHostUriOpeners(He));He.set(g.ExtHostContext.ExtHostInteractive,new Qe.ExtHostInteractive(He,vt,j,ye));const Pi=(0,ie.values)(g.ExtHostContext);He.assertRegistered(Pi);const Ai=new pe.ExtHostBulkEdits(He,j),mi=new c.ExtHostClipboard(He),ii=new m.ExtHostMessageService(He,pt),bi=new a.ExtHostDialogs(He),wi=new E.ExtHostStatusBar(He,ye.converter);return f.ExtHostApiCommands.register(ye),function(Ue,Ut,_i){const gt=function(){let ne=!Ue.isUnderDevelopment;function he(){ne||(pt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Oe(nt){if(Array.isArray(nt))nt.forEach(Oe);else if(typeof nt=="string")he();else{const bt=nt;typeof bt.scheme=="undefined"&&he(),typeof bt.exclusive=="boolean"&&(0,qe.checkProposedApiEnabled)(Ue,"documentFiltersExclusive")}return nt}}(),Ri={getSession(ne,he,Oe){return Yt.getSession(Ue,ne,he,Oe)},async hasSession(ne,he){return(0,qe.checkProposedApiEnabled)(Ue,"authSession"),!!await Yt.getSession(Ue,ne,he,{silent:!0})},get onDidChangeSessions(){return Yt.onDidChangeSessions},registerAuthenticationProvider(ne,he,Oe,nt){return Yt.registerAuthenticationProvider(ne,he,Oe,nt)}},Oi={registerCommand(ne,he,Oe){return ye.registerCommand(!0,ne,he,Oe,void 0,Ue)},registerTextEditorCommand(ne,he,Oe){return ye.registerCommand(!0,ne,(...nt)=>{const bt=_t.getActiveTextEditor();if(!bt){pt.warn("Cannot execute "+ne+" because there is no active text editor.");return}return bt.edit(kt=>{he.apply(Oe,[bt,kt,...nt])}).then(kt=>{kt||pt.warn("Edits from command "+ne+" were not applied.")},kt=>{pt.warn("An error occurred while running command "+ne,kt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(ne,he,Oe)=>((0,qe.checkProposedApiEnabled)(Ue,"diffCommand"),ye.registerCommand(!0,ne,async(...nt)=>{const bt=j.activeEditor(!0);if(!bt){pt.warn("Cannot execute "+ne+" because there is no active text editor.");return}const kt=await _t.getDiffInformation(bt.id);he.apply(Oe,[kt,...nt])},void 0,void 0,Ue)),executeCommand(ne,...he){return ye.executeCommand(ne,...he)},getCommands(ne=!1){return ye.getCommands(ne)}},ai={get machineId(){return ct.telemetryInfo.machineId},get sessionId(){return ct.telemetryInfo.sessionId},get language(){return ct.environment.appLanguage},get appName(){return ct.environment.appName},get appRoot(){return ct.environment.appRoot?.fsPath??""},get appHost(){return ct.environment.appHost},get uriScheme(){return ct.environment.appUriScheme},get clipboard(){return mi.value},get shell(){return Me.getDefaultShell(!1)},get isTelemetryEnabled(){return Ft.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Ft.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,qe.checkProposedApiEnabled)(Ue,"telemetry"),Ft.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,qe.checkProposedApiEnabled)(Ue,"telemetry"),Ft.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const ne=Date.now()-new Date(ct.telemetryInfo.firstSessionDate).getTime();return isNaN(ne)?!1:ne<1e3*60*60*24},openExternal(ne,he){return wt.openUri(ne,{allowTunneling:!!ct.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===ct.environment.appUriScheme)return Et.createAppUri(ne);try{return await wt.asExternalUri(ne,{allowTunneling:!!ct.remote.authority})}catch(he){if((0,Ge.matchesScheme)(ne,ze.Schemas.http)||(0,Ge.matchesScheme)(ne,ze.Schemas.https))return ne;throw he}},get remoteName(){return(0,ee.getRemoteName)(ct.remote.authority)},get remoteAuthority(){return(0,qe.checkProposedApiEnabled)(Ue,"resolvers"),ct.remote.authority},get uiKind(){return ct.uiKind}};ct.environment.extensionTestsLocationURI||Object.freeze(ai);const Fi={createTestController(ne,he,Oe){return ti.createTestController(ne,he,Oe)},createTestObserver(){return(0,qe.checkProposedApiEnabled)(Ue,"testObserver"),ti.createTestObserver()},runTests(ne){return(0,qe.checkProposedApiEnabled)(Ue,"testObserver"),ti.runTests(ne)},get onDidChangeTestResults(){return(0,qe.checkProposedApiEnabled)(Ue,"testObserver"),ti.onResultsChanged},get testResults(){return(0,qe.checkProposedApiEnabled)(Ue,"testObserver"),ti.results}},Mt=ct.remote.isRemote?F.ExtensionKind.Workspace:F.ExtensionKind.UI,qt={getExtension(ne,he){(0,qe.isProposedApiEnabled)(Ue,"extensionsAny")||(he=!1);const Oe=Ut.mine.getExtensionDescription(ne);if(Oe)return new o.Extension(It,Ue.identifier,Oe,Mt,!1);if(he){const nt=Ut.all.getExtensionDescription(ne);if(nt)return new o.Extension(It,Ue.identifier,nt,Mt,!0)}},get all(){const ne=[];for(const he of Ut.mine.getAllExtensionDescriptions())ne.push(new o.Extension(It,Ue.identifier,he,Mt,!1));return ne},get allAcrossExtensionHosts(){(0,qe.checkProposedApiEnabled)(Ue,"extensionsAny");const ne=new qe.ExtensionIdentifierSet(Ut.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),he=[];for(const Oe of Ut.all.getAllExtensionDescriptions()){const nt=!ne.has(Oe.identifier);he.push(new o.Extension(It,Ue.identifier,Oe,Mt,nt))}return he},get onDidChange(){return(0,qe.isProposedApiEnabled)(Ue,"extensionsAny")?p.Event.any(Ut.mine.onDidChange,Ut.all.onDidChange):Ut.mine.onDidChange}},Ni={createDiagnosticCollection(ne){return Xt.createDiagnosticCollection(Ue.identifier,ne)},get onDidChangeDiagnostics(){return Xt.onDidChangeDiagnostics},getDiagnostics:ne=>Xt.getDiagnostics(ne),getLanguages(){return Qt.getLanguages()},setTextDocumentLanguage(ne,he){return Qt.changeLanguage(ne.uri,he)},match(ne,he){const Oe=ft.getDocumentData(he.uri)?.notebook;return(0,O.score)(K.LanguageSelector.from(ne),he.uri,he.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(ne,he,Oe){return dt.registerCodeActionProvider(Ue,gt(ne),he,Oe)},registerDocumentPasteEditProvider(ne,he){return(0,qe.checkProposedApiEnabled)(Ue,"documentPaste"),dt.registerDocumentPasteEditProvider(Ue,gt(ne),he)},registerCodeLensProvider(ne,he){return dt.registerCodeLensProvider(Ue,gt(ne),he)},registerDefinitionProvider(ne,he){return dt.registerDefinitionProvider(Ue,gt(ne),he)},registerDeclarationProvider(ne,he){return dt.registerDeclarationProvider(Ue,gt(ne),he)},registerImplementationProvider(ne,he){return dt.registerImplementationProvider(Ue,gt(ne),he)},registerTypeDefinitionProvider(ne,he){return dt.registerTypeDefinitionProvider(Ue,gt(ne),he)},registerHoverProvider(ne,he){return dt.registerHoverProvider(Ue,gt(ne),he,Ue.identifier)},registerEvaluatableExpressionProvider(ne,he){return dt.registerEvaluatableExpressionProvider(Ue,gt(ne),he,Ue.identifier)},registerInlineValuesProvider(ne,he){return dt.registerInlineValuesProvider(Ue,gt(ne),he,Ue.identifier)},registerDocumentHighlightProvider(ne,he){return dt.registerDocumentHighlightProvider(Ue,gt(ne),he)},registerLinkedEditingRangeProvider(ne,he){return dt.registerLinkedEditingRangeProvider(Ue,gt(ne),he)},registerReferenceProvider(ne,he){return dt.registerReferenceProvider(Ue,gt(ne),he)},registerRenameProvider(ne,he){return dt.registerRenameProvider(Ue,gt(ne),he)},registerDocumentSymbolProvider(ne,he,Oe){return dt.registerDocumentSymbolProvider(Ue,gt(ne),he,Oe)},registerWorkspaceSymbolProvider(ne){return dt.registerWorkspaceSymbolProvider(Ue,ne)},registerDocumentFormattingEditProvider(ne,he){return dt.registerDocumentFormattingEditProvider(Ue,gt(ne),he)},registerDocumentRangeFormattingEditProvider(ne,he){return dt.registerDocumentRangeFormattingEditProvider(Ue,gt(ne),he)},registerOnTypeFormattingEditProvider(ne,he,Oe,...nt){return dt.registerOnTypeFormattingEditProvider(Ue,gt(ne),he,[Oe].concat(nt))},registerDocumentSemanticTokensProvider(ne,he,Oe){return dt.registerDocumentSemanticTokensProvider(Ue,gt(ne),he,Oe)},registerDocumentRangeSemanticTokensProvider(ne,he,Oe){return dt.registerDocumentRangeSemanticTokensProvider(Ue,gt(ne),he,Oe)},registerSignatureHelpProvider(ne,he,Oe,...nt){return typeof Oe=="object"?dt.registerSignatureHelpProvider(Ue,gt(ne),he,Oe):dt.registerSignatureHelpProvider(Ue,gt(ne),he,typeof Oe=="undefined"?[]:[Oe,...nt])},registerCompletionItemProvider(ne,he,...Oe){return dt.registerCompletionItemProvider(Ue,gt(ne),he,Oe)},registerInlineCompletionItemProvider(ne,he){return he.handleDidShowCompletionItem&&(0,qe.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(Ue,gt(ne),he)},registerInlineCompletionItemProviderNew(ne,he){if((0,qe.checkProposedApiEnabled)(Ue,"inlineCompletionsNew"),he.handleDidShowCompletionItem&&!(0,qe.isProposedApiEnabled)(Ue,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return dt.registerInlineCompletionsProviderNew(Ue,gt(ne),he)},registerDocumentLinkProvider(ne,he){return dt.registerDocumentLinkProvider(Ue,gt(ne),he)},registerColorProvider(ne,he){return dt.registerColorProvider(Ue,gt(ne),he)},registerFoldingRangeProvider(ne,he){return dt.registerFoldingRangeProvider(Ue,gt(ne),he)},registerSelectionRangeProvider(ne,he){return dt.registerSelectionRangeProvider(Ue,ne,he)},registerCallHierarchyProvider(ne,he){return dt.registerCallHierarchyProvider(Ue,ne,he)},registerTypeHierarchyProvider(ne,he){return dt.registerTypeHierarchyProvider(Ue,ne,he)},setLanguageConfiguration:(ne,he)=>dt.setLanguageConfiguration(Ue,ne,he),getTokenInformationAtPosition(ne,he){return(0,qe.checkProposedApiEnabled)(Ue,"tokenInformation"),Qt.tokenAtPosition(ne,he)},registerInlayHintsProvider(ne,he){return dt.registerInlayHintsProvider(Ue,ne,he)},createLanguageStatusItem(ne,he){return Qt.createLanguageStatusItem(Ue,ne,he)},registerDocumentOnDropEditProvider(ne,he){return(0,qe.checkProposedApiEnabled)(Ue,"textEditorDrop"),dt.registerDocumentOnDropEditProvider(Ue,ne,he)}},Bt={get activeTextEditor(){return _t.getActiveTextEditor()},get visibleTextEditors(){return _t.getVisibleTextEditors()},get activeTerminal(){return Me.activeTerminal},get terminals(){return Me.terminals},async showTextDocument(ne,he,Oe){const nt=await(T.URI.isUri(ne)?Promise.resolve(ni.openTextDocument(ne)):Promise.resolve(ne));return _t.showTextDocument(nt,he,Oe)},createTextEditorDecorationType(ne){return _t.createTextEditorDecorationType(Ue,ne)},onDidChangeActiveTextEditor(ne,he,Oe){return _t.onDidChangeActiveTextEditor(ne,he,Oe)},onDidChangeVisibleTextEditors(ne,he,Oe){return _t.onDidChangeVisibleTextEditors(ne,he,Oe)},onDidChangeTextEditorSelection(ne,he,Oe){return _t.onDidChangeTextEditorSelection(ne,he,Oe)},onDidChangeTextEditorOptions(ne,he,Oe){return _t.onDidChangeTextEditorOptions(ne,he,Oe)},onDidChangeTextEditorVisibleRanges(ne,he,Oe){return _t.onDidChangeTextEditorVisibleRanges(ne,he,Oe)},onDidChangeTextEditorViewColumn(ne,he,Oe){return _t.onDidChangeTextEditorViewColumn(ne,he,Oe)},onDidCloseTerminal(ne,he,Oe){return Me.onDidCloseTerminal(ne,he,Oe)},onDidOpenTerminal(ne,he,Oe){return Me.onDidOpenTerminal(ne,he,Oe)},onDidChangeActiveTerminal(ne,he,Oe){return Me.onDidChangeActiveTerminal(ne,he,Oe)},onDidChangeTerminalDimensions(ne,he,Oe){return(0,qe.checkProposedApiEnabled)(Ue,"terminalDimensions"),Me.onDidChangeTerminalDimensions(ne,he,Oe)},onDidChangeTerminalState(ne,he,Oe){return Me.onDidChangeTerminalState(ne,he,Oe)},onDidWriteTerminalData(ne,he,Oe){return(0,qe.checkProposedApiEnabled)(Ue,"terminalDataWriteEvent"),Me.onDidWriteTerminalData(ne,he,Oe)},get state(){return wt.state},onDidChangeWindowState(ne,he,Oe){return wt.onDidChangeWindowState(ne,he,Oe)},showInformationMessage(ne,...he){return ii.showMessage(Ue,U.default.Info,ne,he[0],he.slice(1))},showWarningMessage(ne,...he){return ii.showMessage(Ue,U.default.Warning,ne,he[0],he.slice(1))},showErrorMessage(ne,...he){return ii.showMessage(Ue,U.default.Error,ne,he[0],he.slice(1))},showQuickPick(ne,he,Oe){return jt.showQuickPick(ne,he,Oe)},showWorkspaceFolderPick(ne){return jt.showWorkspaceFolderPick(ne)},showInputBox(ne,he){return jt.showInput(ne,he)},showOpenDialog(ne){return bi.showOpenDialog(ne)},showSaveDialog(ne){return bi.showSaveDialog(ne)},createStatusBarItem(ne,he,Oe){let nt,bt,kt;return typeof ne=="string"?(nt=ne,bt=he,kt=Oe):(bt=ne,kt=he),wi.createStatusBarEntry(Ue,nt,bt,kt)},setStatusBarMessage(ne,he){return wi.setStatusBarMessage(ne,he)},withScmProgress(ne){return Tt.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),si.withProgress(Ue,{location:F.ProgressLocation.SourceControl},(he,Oe)=>ne({report(nt){}}))},withProgress(ne,he){return si.withProgress(Ue,ne,he)},createOutputChannel(ne,he){return ht.createOutputChannel(ne,he,Ue)},createWebviewPanel(ne,he,Oe,nt){return ei.createWebviewPanel(Ue,ne,he,Oe,nt)},createWebviewTextEditorInset(ne,he,Oe,nt){return(0,qe.checkProposedApiEnabled)(Ue,"editorInsets"),di.createWebviewEditorInset(ne,he,Oe,nt,Ue)},createTerminal(ne,he,Oe){return typeof ne=="object"?"pty"in ne?Me.createExtensionTerminal(ne):Me.createTerminalFromOptions(ne):Me.createTerminal(ne,he,Oe)},registerTerminalLinkProvider(ne){return Me.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,he){return Me.registerProfileProvider(Ue,ne,he)},registerTreeDataProvider(ne,he){return ri.registerTreeDataProvider(ne,he,Ue)},createTreeView(ne,he){return ri.createTreeView(ne,he,Ue)},registerWebviewPanelSerializer:(ne,he)=>ei.registerWebviewPanelSerializer(Ue,ne,he),registerCustomEditorProvider:(ne,he,Oe={})=>Ii.registerCustomEditorProvider(Ue,ne,he,Oe),registerFileDecorationProvider(ne){return ue.registerFileDecorationProvider(ne,Ue.identifier)},registerUriHandler(ne){return Et.registerUriHandler(Ue.identifier,ne)},createQuickPick(){return jt.createQuickPick(Ue)},createInputBox(){return jt.createInputBox(Ue)},get activeColorTheme(){return oi.activeColorTheme},onDidChangeActiveColorTheme(ne,he,Oe){return oi.onDidChangeActiveColorTheme(ne,he,Oe)},registerWebviewViewProvider(ne,he,Oe){return Ti.registerWebviewViewProvider(Ue,ne,he,Oe?.webviewOptions)},get activeNotebookEditor(){return vt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,he,Oe){return vt.onDidChangeActiveNotebookEditor(ne,he,Oe)},get visibleNotebookEditors(){return vt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return vt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,he,Oe){return Jt.onDidChangeNotebookEditorSelection(ne,he,Oe)},onDidChangeNotebookEditorVisibleRanges(ne,he,Oe){return Jt.onDidChangeNotebookEditorVisibleRanges(ne,he,Oe)},showNotebookDocument(ne,he){return T.URI.isUri(ne)&&Tt.report("window.showNotebookDocument(uri)",Ue,"Please use 'window.openNotebookDocument' and 'window.showTextDocument'"),vt.showNotebookDocument(ne,he)},registerExternalUriOpener(ne,he,Oe){return(0,qe.checkProposedApiEnabled)(Ue,"externalUriOpener"),ki.registerExternalUriOpener(Ue.identifier,ne,he,Oe)},get tabGroups(){return Ce.tabGroups}},ni={get rootPath(){return Tt.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(ne){throw C.readonly()},getWorkspaceFolder(ne){return mt.getWorkspaceFolder(ne)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(ne){throw C.readonly()},get workspaceFile(){return mt.workspaceFile},set workspaceFile(ne){throw C.readonly()},updateWorkspaceFolders:(ne,he,...Oe)=>mt.updateWorkspaceFolders(Ue,ne,he||0,...Oe),onDidChangeWorkspaceFolders:function(ne,he,Oe){return mt.onDidChangeWorkspace(ne,he,Oe)},asRelativePath:(ne,he)=>mt.getRelativePath(ne,he),findFiles:(ne,he,Oe,nt)=>mt.findFiles(ne,he,Oe,Ue.identifier,nt),findTextInFiles:(ne,he,Oe,nt)=>{(0,qe.checkProposedApiEnabled)(Ue,"findTextInFiles");let bt,kt;return typeof he=="object"?(bt=he,kt=Oe):(bt={},kt=he,nt=Oe),mt.findTextInFiles(ne,bt||{},kt,Ue.identifier,nt)},saveAll:ne=>mt.saveAll(ne),applyEdit(ne){return Ai.applyWorkspaceEdit(ne)},createFileSystemWatcher:(ne,he,Oe,nt)=>xt.createFileSystemWatcher(mt,Ue,ne,he,Oe,nt),get textDocuments(){return ft.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw C.readonly()},openTextDocument(ne){let he;const Oe=ne;if(typeof ne=="string")he=Promise.resolve(T.URI.file(ne));else if(T.URI.isUri(ne))he=Promise.resolve(ne);else if(!Oe||typeof Oe=="object")he=ft.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(nt=>ft.ensureDocumentData(nt).then(bt=>bt.document))},onDidOpenTextDocument:(ne,he,Oe)=>ft.onDidAddDocument(ne,he,Oe),onDidCloseTextDocument:(ne,he,Oe)=>ft.onDidRemoveDocument(ne,he,Oe),onDidChangeTextDocument:(ne,he,Oe)=>ft.onDidChangeDocument(ne,he,Oe),onDidSaveTextDocument:(ne,he,Oe)=>ft.onDidSaveDocument(ne,he,Oe),onWillSaveTextDocument:(ne,he,Oe)=>Rt.getOnWillSaveTextDocumentEvent(Ue)(ne,he,Oe),get notebookDocuments(){return vt.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,he){let Oe;if(T.URI.isUri(ne))Oe=ne,await vt.openNotebookDocument(ne);else if(typeof ne=="string")Oe=T.URI.revive(await vt.createNotebookDocument({viewType:ne,content:he}));else throw new Error("Invalid arguments");return vt.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(ne,he,Oe){return Wt.onDidSaveNotebookDocument(ne,he,Oe)},onDidChangeNotebookDocument(ne,he,Oe){return Wt.onDidChangeNotebookDocument(ne,he,Oe)},get onDidOpenNotebookDocument(){return vt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return vt.onDidCloseNotebookDocument},registerNotebookSerializer(ne,he,Oe,nt){return vt.registerNotebookSerializer(Ue,ne,he,Oe,(0,qe.isProposedApiEnabled)(Ue,"notebookLiveShare")?nt:void 0)},registerNotebookContentProvider:(ne,he,Oe,nt)=>((0,qe.checkProposedApiEnabled)(Ue,"notebookContentProvider"),Tt.report("workspace.registerNotebookContentProvider",Ue,"The notebookContentProvider API is not on track for finalization and will be removed."),vt.registerNotebookContentProvider(Ue,ne,he,Oe,(0,qe.isProposedApiEnabled)(Ue,"notebookLiveShare")?nt:void 0)),onDidChangeConfiguration:(ne,he,Oe)=>_i.onDidChangeConfiguration(ne,he,Oe),getConfiguration(ne,he){return he=arguments.length===1?void 0:he,_i.getConfiguration(ne,he,Ue)},registerTextDocumentContentProvider(ne,he){return Ct.registerTextDocumentContentProvider(ne,he)},registerTaskProvider:(ne,he)=>(Tt.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),ut.registerTaskProvider(Ue,ne,he)),registerFileSystemProvider(ne,he,Oe){return(0,et.combinedDisposable)(hi.registerFileSystemProvider(Ue,ne,he,Oe),zt.addFileSystemProvider(ne,he))},get fs(){return zt.value},registerFileSearchProvider:(ne,he)=>((0,qe.checkProposedApiEnabled)(Ue,"fileSearchProvider"),Ve.registerFileSearchProvider(ne,he)),registerTextSearchProvider:(ne,he)=>((0,qe.checkProposedApiEnabled)(Ue,"textSearchProvider"),Ve.registerTextSearchProvider(ne,he)),registerRemoteAuthorityResolver:(ne,he)=>((0,qe.checkProposedApiEnabled)(Ue,"resolvers"),It.registerRemoteAuthorityResolver(ne,he)),registerResourceLabelFormatter:ne=>((0,qe.checkProposedApiEnabled)(Ue,"resolvers"),fi.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,he,Oe)=>xt.onDidCreateFile(ne,he,Oe),onDidDeleteFiles:(ne,he,Oe)=>xt.onDidDeleteFile(ne,he,Oe),onDidRenameFiles:(ne,he,Oe)=>xt.onDidRenameFile(ne,he,Oe),onWillCreateFiles:(ne,he,Oe)=>xt.getOnWillCreateFileEvent(Ue)(ne,he,Oe),onWillDeleteFiles:(ne,he,Oe)=>xt.getOnWillDeleteFileEvent(Ue)(ne,he,Oe),onWillRenameFiles:(ne,he,Oe)=>xt.getOnWillRenameFileEvent(Ue)(ne,he,Oe),openTunnel:ne=>((0,qe.checkProposedApiEnabled)(Ue,"resolvers"),yt.openTunnel(Ue,ne).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,qe.checkProposedApiEnabled)(Ue,"resolvers"),yt.getTunnels()},onDidChangeTunnels:(ne,he,Oe)=>((0,qe.checkProposedApiEnabled)(Ue,"resolvers"),yt.onDidChangeTunnels(ne,he,Oe)),registerPortAttributesProvider:(ne,he)=>((0,qe.checkProposedApiEnabled)(Ue,"portsAttributes"),yt.registerPortsAttributesProvider(ne,he)),registerTimelineProvider:(ne,he)=>((0,qe.checkProposedApiEnabled)(Ue,"timeline"),Ci.registerTimelineProvider(ne,he,Ue.identifier,ye.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:ne=>((0,qe.checkProposedApiEnabled)(Ue,"workspaceTrust"),mt.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,he,Oe)=>mt.onDidGrantWorkspaceTrust(ne,he,Oe)},Mi={get inputBox(){return Tt.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),Ei.getLastInputBox(Ue)},createSourceControl(ne,he,Oe){return Ei.createSourceControl(Ue,ne,he,Oe)}},Li={createCommentController(ne,he){return Di.createCommentController(Ue,ne,he)}},Ui={get activeDebugSession(){return Je.activeDebugSession},get activeDebugConsole(){return Je.activeDebugConsole},get breakpoints(){return Je.breakpoints},onDidStartDebugSession(ne,he,Oe){return Je.onDidStartDebugSession(ne,he,Oe)},onDidTerminateDebugSession(ne,he,Oe){return Je.onDidTerminateDebugSession(ne,he,Oe)},onDidChangeActiveDebugSession(ne,he,Oe){return Je.onDidChangeActiveDebugSession(ne,he,Oe)},onDidReceiveDebugSessionCustomEvent(ne,he,Oe){return Je.onDidReceiveDebugSessionCustomEvent(ne,he,Oe)},onDidChangeBreakpoints(ne,he,Oe){return Je.onDidChangeBreakpoints(ne,he,Oe)},registerDebugConfigurationProvider(ne,he,Oe){return Je.registerDebugConfigurationProvider(ne,he,Oe||st.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,he){return Je.registerDebugAdapterDescriptorFactory(Ue,ne,he)},registerDebugAdapterTrackerFactory(ne,he){return Je.registerDebugAdapterTrackerFactory(ne,he)},startDebugging(ne,he,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?Je.startDebugging(ne,he,{parentSession:Oe}):Je.startDebugging(ne,he,Oe||{})},stopDebugging(ne){return Je.stopDebugging(ne)},addBreakpoints(ne){return Je.addBreakpoints(ne)},removeBreakpoints(ne){return Je.removeBreakpoints(ne)},asDebugSourceUri(ne,he){return Je.asDebugSourceUri(ne,he)}},Bi={registerTaskProvider:(ne,he)=>ut.registerTaskProvider(Ue,ne,he),fetchTasks:ne=>ut.fetchTasks(ne),executeTask:ne=>ut.executeTask(Ue,ne),get taskExecutions(){return ut.taskExecutions},onDidStartTask:(ne,he,Oe)=>ut.onDidStartTask(ne,he,Oe),onDidEndTask:(ne,he,Oe)=>ut.onDidEndTask(ne,he,Oe),onDidStartTaskProcess:(ne,he,Oe)=>ut.onDidStartTaskProcess(ne,he,Oe),onDidEndTaskProcess:(ne,he,Oe)=>ut.onDidEndTaskProcess(ne,he,Oe)},zi={createNotebookController(ne,he,Oe,nt,bt){return vi.createNotebookController(Ue,ne,he,Oe,nt,(0,qe.isProposedApiEnabled)(Ue,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(ne,he)=>vt.registerNotebookCellStatusBarItemProvider(Ue,ne,he),createNotebookEditorDecorationType(ne){return(0,qe.checkProposedApiEnabled)(Ue,"notebookEditorDecorationType"),Jt.createNotebookEditorDecorationType(ne)},createRendererMessaging(ne){return ui.createRendererMessaging(Ue,ne)},onDidChangeNotebookCellExecutionState(ne,he,Oe){return(0,qe.checkProposedApiEnabled)(Ue,"notebookCellExecutionState"),vi.onDidChangeNotebookCellExecutionState(ne,he,Oe)}};return{version:ct.version,authentication:Ri,commands:Oi,comments:Li,debug:Ui,env:ai,extensions:qt,languages:Ni,notebooks:zi,scm:Mi,tasks:Bi,tests:Fi,window:Bt,workspace:ni,Breakpoint:F.Breakpoint,CallHierarchyIncomingCall:F.CallHierarchyIncomingCall,CallHierarchyItem:F.CallHierarchyItem,CallHierarchyOutgoingCall:F.CallHierarchyOutgoingCall,CancellationError:C.CancellationError,CancellationTokenSource:s.CancellationTokenSource,CandidatePortSource:g.CandidatePortSource,CodeAction:F.CodeAction,CodeActionKind:F.CodeActionKind,CodeActionTriggerKind:F.CodeActionTriggerKind,CodeLens:F.CodeLens,Color:F.Color,ColorInformation:F.ColorInformation,ColorPresentation:F.ColorPresentation,ColorThemeKind:F.ColorThemeKind,CommentMode:F.CommentMode,CommentThreadCollapsibleState:F.CommentThreadCollapsibleState,CommentThreadState:F.CommentThreadState,CompletionItem:F.CompletionItem,CompletionItemKind:F.CompletionItemKind,CompletionItemTag:F.CompletionItemTag,CompletionList:F.CompletionList,CompletionTriggerKind:F.CompletionTriggerKind,ConfigurationTarget:F.ConfigurationTarget,CustomExecution:F.CustomExecution,DebugAdapterExecutable:F.DebugAdapterExecutable,DebugAdapterInlineImplementation:F.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:F.DebugAdapterNamedPipeServer,DebugAdapterServer:F.DebugAdapterServer,DebugConfigurationProviderTriggerKind:st.DebugConfigurationProviderTriggerKind,DebugConsoleMode:F.DebugConsoleMode,DecorationRangeBehavior:F.DecorationRangeBehavior,Diagnostic:F.Diagnostic,DiagnosticRelatedInformation:F.DiagnosticRelatedInformation,DiagnosticSeverity:F.DiagnosticSeverity,DiagnosticTag:F.DiagnosticTag,Disposable:F.Disposable,DocumentHighlight:F.DocumentHighlight,DocumentHighlightKind:F.DocumentHighlightKind,DocumentLink:F.DocumentLink,DocumentSymbol:F.DocumentSymbol,EndOfLine:F.EndOfLine,EnvironmentVariableMutatorType:F.EnvironmentVariableMutatorType,EvaluatableExpression:F.EvaluatableExpression,InlineValueText:F.InlineValueText,InlineValueVariableLookup:F.InlineValueVariableLookup,InlineValueEvaluatableExpression:F.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:F.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:F.InlineCompletionTriggerKindNew,EventEmitter:p.Emitter,ExtensionKind:F.ExtensionKind,ExtensionMode:F.ExtensionMode,ExternalUriOpenerPriority:F.ExternalUriOpenerPriority,FileChangeType:F.FileChangeType,FileDecoration:F.FileDecoration,FileSystemError:F.FileSystemError,FileType:w.FileType,FilePermission:w.FilePermission,FoldingRange:F.FoldingRange,FoldingRangeKind:F.FoldingRangeKind,FunctionBreakpoint:F.FunctionBreakpoint,InlineCompletionItem:F.InlineSuggestion,InlineCompletionItemNew:F.InlineSuggestionNew,InlineCompletionList:F.InlineSuggestionList,InlineCompletionListNew:F.InlineSuggestionsNew,Hover:F.Hover,IndentAction:A.IndentAction,Location:F.Location,MarkdownString:F.MarkdownString,OverviewRulerLane:b.OverviewRulerLane,ParameterInformation:F.ParameterInformation,PortAutoForwardAction:F.PortAutoForwardAction,Position:F.Position,ProcessExecution:F.ProcessExecution,ProgressLocation:F.ProgressLocation,QuickInputButtons:F.QuickInputButtons,Range:F.Range,RelativePattern:F.RelativePattern,Selection:F.Selection,SelectionRange:F.SelectionRange,SemanticTokens:F.SemanticTokens,SemanticTokensBuilder:F.SemanticTokensBuilder,SemanticTokensEdit:F.SemanticTokensEdit,SemanticTokensEdits:F.SemanticTokensEdits,SemanticTokensLegend:F.SemanticTokensLegend,ShellExecution:F.ShellExecution,ShellQuoting:F.ShellQuoting,SignatureHelp:F.SignatureHelp,SignatureHelpTriggerKind:F.SignatureHelpTriggerKind,SignatureInformation:F.SignatureInformation,SnippetString:F.SnippetString,SnippetTextEdit:F.SnippetTextEdit,SourceBreakpoint:F.SourceBreakpoint,StandardTokenType:F.StandardTokenType,StatusBarAlignment:F.StatusBarAlignment,SymbolInformation:F.SymbolInformation,SymbolKind:F.SymbolKind,SymbolTag:F.SymbolTag,Task:F.Task,TaskGroup:F.TaskGroup,TaskPanelKind:F.TaskPanelKind,TaskRevealKind:F.TaskRevealKind,TaskScope:F.TaskScope,TerminalLink:F.TerminalLink,TerminalLocation:F.TerminalLocation,TerminalProfile:F.TerminalProfile,TextDocumentSaveReason:F.TextDocumentSaveReason,TextEdit:F.TextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:F.TextEditorLineNumbersStyle,TextEditorRevealType:F.TextEditorRevealType,TextEditorSelectionChangeKind:F.TextEditorSelectionChangeKind,TextDocumentChangeReason:F.TextDocumentChangeReason,ThemeColor:F.ThemeColor,ThemeIcon:F.ThemeIcon,TreeItem:F.TreeItem,TreeItemCollapsibleState:F.TreeItemCollapsibleState,TypeHierarchyItem:F.TypeHierarchyItem,UIKind:S.UIKind,Uri:T.URI,ViewColumn:F.ViewColumn,WorkspaceEdit:F.WorkspaceEdit,InlayHint:F.InlayHint,InlayHintLabelPart:F.InlayHintLabelPart,InlayHintKind:F.InlayHintKind,RemoteAuthorityResolverError:F.RemoteAuthorityResolverError,ResolvedAuthority:F.ResolvedAuthority,SourceControlInputBoxValidationType:F.SourceControlInputBoxValidationType,ExtensionRuntime:F.ExtensionRuntime,TimelineItem:F.TimelineItem,NotebookRange:F.NotebookRange,NotebookCellKind:F.NotebookCellKind,NotebookCellExecutionState:F.NotebookCellExecutionState,NotebookCellData:F.NotebookCellData,NotebookData:F.NotebookData,NotebookRendererScript:F.NotebookRendererScript,NotebookCellStatusBarAlignment:F.NotebookCellStatusBarAlignment,NotebookEditorRevealType:F.NotebookEditorRevealType,NotebookCellOutput:F.NotebookCellOutput,NotebookCellOutputItem:F.NotebookCellOutputItem,NotebookCellStatusBarItem:F.NotebookCellStatusBarItem,NotebookControllerAffinity:F.NotebookControllerAffinity,NotebookEdit:F.NotebookEdit,PortAttributes:F.PortAttributes,LinkedEditingRanges:F.LinkedEditingRanges,TestResultState:F.TestResultState,TestRunRequest:F.TestRunRequest,TestMessage:F.TestMessage,TestTag:F.TestTag,TestRunProfileKind:F.TestRunProfileKind,TextSearchCompleteMessageType:me.TextSearchCompleteMessageType,DataTransfer:F.DataTransfer,DataTransferItem:F.DataTransferItem,CoveredCount:F.CoveredCount,FileCoverage:F.FileCoverage,StatementCoverage:F.StatementCoverage,BranchCoverage:F.BranchCoverage,FunctionCoverage:F.FunctionCoverage,WorkspaceTrustState:F.WorkspaceTrustState,LanguageStatusSeverity:F.LanguageStatusSeverity,QuickPickItemKind:F.QuickPickItemKind,InputBoxValidationSeverity:F.InputBoxValidationSeverity,TabInputText:F.TextTabInput,TabInputTextDiff:F.TextDiffTabInput,TabInputCustom:F.CustomEditorTabInput,TabInputNotebook:F.NotebookEditorTabInput,TabInputNotebookDiff:F.NotebookDiffEditorTabInput,TabInputWebview:F.WebviewEditorTabInput,TabInputTerminal:F.TerminalEditorTabInput}}}e.createApiFactoryAndRegisterActors=it}),define(De[234],Ie([1,0,233,33,2,227,6,13,4]),function(J,e,s,C,p,U,T,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class A extends U.RequireInterceptor{_installInterceptor(){}getModule(f,c){for(let h of this._alternatives){let u=h(f);if(u){f=u;break}}if(this._factories.has(f))return this._factories.get(f).load(f,c,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class O extends C.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const f=this._extHostContext.getProxy(b.MainContext.MainThreadConsole);g(f,this._initData.environment.isExtensionDevelopmentDebug);const c=this._instaService.invokeFunction(s.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(A,c,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(f){return f.browser}async _loadCommonJSModule(f,c,h){c=c.with({path:w(c.path,".js")}),f&&performance.mark(`code/extHost/willFetchExtensionCode/${f.value}`);const u=p.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(c)),D=await fetch(u.toString(!0));if(f&&performance.mark(`code/extHost/didFetchExtensionCode/${f.value}`),D.status!==200)throw new Error(D.statusText);const y=await D.text(),a=`${c.toString(!0)}#vscode-extension`,_=`${y}
//# sourceURL=${a}`;let r;try{r=new Function("module","exports","require",_)}catch(n){throw console.error(f?`Loading code for extension ${f.value} failed: ${n.message}`:`Loading code failed: ${n.message}`),console.error(`${c.toString(!0)}${typeof n.line=="number"?` line ${n.line}`:""}${typeof n.column=="number"?` column ${n.column}`:""}`),console.error(n),n}const d={},i={exports:d},o=n=>{const t=this._fakeModules.getModule(n,c);if(t===void 0)throw new Error(`Cannot load module '${n}'`);return t};try{return h.codeLoadingStart(),f&&performance.mark(`code/extHost/willLoadExtensionCode/${f.value}`),r(i,d,o),i.exports!==d?i.exports:d}finally{f&&performance.mark(`code/extHost/didLoadExtensionCode/${f.value}`),h.codeLoadingStop()}}async $setRemoteEnvironment(f){}async _waitForDebuggerAttachment(f=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const c=Date.now()+f;for(;Date.now()<c&&!("__jsDebugIsReady"in globalThis);)await(0,P.timeout)(10)}}e.ExtHostExtensionService=O;function w(S,f){return S.endsWith(f)?S:S+f}function g(S,f){c("info","log"),c("log","log"),c("warn","warn"),c("error","error");function c(D,y){const a=console[D];console[D]=function(){S.$logExtensionHostMessage({type:"__$console",severity:y,arguments:u(arguments)}),f&&a.apply(console,arguments)}}const h=1e5;function u(D){const y=[],a=[];if(D.length)for(let _=0;_<D.length;_++){if(typeof D[_]=="undefined")D[_]="undefined";else if(D[_]instanceof Error){const r=D[_];r.stack?D[_]=r.stack:D[_]=r.toString()}a.push(D[_])}try{const _=JSON.stringify(a,function(r,d){if(d&&typeof d=="object"){if(y.indexOf(d)!==-1)return"[Circular]";y.push(d)}return d});return _.length>h?"Output omitted for a large object that exceeds the limits":_}catch(_){return`Output omitted for an object that cannot be inspected ('${_.toString()}')`}}}}),define(De[235],Ie([1,0,58,33,72,234]),function(J,e,s,C,p,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,s.registerSingleton)(C.IExtHostExtensionService,U.ExtHostExtensionService),(0,s.registerSingleton)(p.IExtensionStoragePaths,p.ExtensionStoragePaths)}),define(De[244],Ie([1,0,23,5,94,228,220,19,73,12,2,230,235]),function(J,e,s,C,p,U,T,P,b,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const w=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const g=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function S(r){return/^(file|vscode-remote):/i.test(r)}const f=fetch.bind(self);function c(r){self.fetch=async function(d,i){return d instanceof Request||S(String(d))&&(d=(await r(O.URI.parse(String(d)))).toString(!0)),f(d,i)},self.XMLHttpRequest=class extends XMLHttpRequest{open(d,i,o,n,t){(async()=>{S(i.toString())&&(i=(await r(O.URI.parse(i.toString()))).toString(!0)),super.open(d,i,o??!0,n,t)})()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const r=self.Worker;Worker=function(d,i){if(/^file:/i.test(d.toString()))d=A.FileAccess.asBrowserUri(O.URI.parse(d.toString())).toString(!0);else if(/^vscode-remote:/i.test(d.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const n=`(${function(m){function I(R){return typeof R=="string"||R instanceof URL?String(R).replace(/^file:\/\//i,"vscode-file://vscode-app"):R}const B=fetch.bind(self);self.fetch=function(R,E){return R instanceof Request?B(R,E):B(I(R),E)},self.XMLHttpRequest=class extends XMLHttpRequest{open(R,E,M,N,W){return super.open(R,I(E),M??!0,N,W)}};const x=importScripts.bind(self);self.importScripts=(...R)=>{x(...R.map(I))},x(m)}.toString()}('${d}'))`;i=i||{},i.name=i.name||P.basename(d.toString());const t=new Blob([n],{type:"application/javascript"}),l=URL.createObjectURL(t);return new r(l,i)}}else self.Worker=class extends T.NestedWorker{constructor(r,d){super(g,r,{name:P.basename(r.toString()),...d})}};const h=new class{constructor(){this.pid=void 0}exit(r){w()}async exists(r){return!0}async realpath(r){return r}};class u{constructor(){const d=new MessageChannel,i=new C.Emitter;let o=!1;g(d.port2,[d.port2]),d.port1.onmessage=n=>{const{data:t}=n;if(!(t instanceof ArrayBuffer)){console.warn("UNKNOWN data received",t);return}const l=s.VSBuffer.wrap(new Uint8Array(t,0,t.byteLength));if((0,p.isMessageOfType)(l,2)){o=!0,y("received terminate message from renderer");return}i.fire(l)},this.protocol={onMessage:i.event,send:n=>{if(!o){const t=n.buffer.buffer.slice(n.buffer.byteOffset,n.buffer.byteOffset+n.buffer.byteLength);d.port1.postMessage(t,[t])}}}}}function D(r){return new Promise(d=>{const i=r.onMessage(o=>{i.dispose();const n=JSON.parse(o.toString());r.send((0,p.createMessageOfType)(0)),d({protocol:r,initData:n})});r.send((0,p.createMessageOfType)(1))})}let y=r=>w();function a(r){return!!r&&typeof r=="object"&&r.type==="vscode.init"&&r.data instanceof Map}function _(){b.mark("code/extHost/willConnectToRenderer");const r=new u;return{onmessage(d){!a(d)||D(r.protocol).then(i=>{b.mark("code/extHost/didWaitForInitData");const o=new U.ExtensionHostMain(i.protocol,i.initData,h,null,d.data);c(n=>o.asBrowserUri(n)),y=n=>o.terminate(n)})}}}e.create=_})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/30d9c6cd9483b2cc586687151bcbcd635f373630/core/vs/workbench/api/worker/extensionHostWorker.js.map
